namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *combined_reduction_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2021-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if defined(IS_MAX) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MIN) )==""\n"
R"==(#elif defined(IS_MIN) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MAX) )==""\n"
R"==(#elif defined(IS_MUL) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ONE) )==""\n"
R"==(#else )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ZERO) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8) || defined(SRC_DT_S32) )==""\n"
R"==(#define MAX_FUNC max )==""\n"
R"==(#define MIN_FUNC min )==""\n"
R"==(#else )==""\n"
R"==(#define MAX_FUNC fmax )==""\n"
R"==(#define MIN_FUNC fmin )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(IS_MAX) )==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) MAX_FUNC(x, y) )==""\n"
R"==(#elif defined(IS_MIN) )==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) MIN_FUNC(x, y) )==""\n"
R"==(#elif defined(IS_MEAN) || defined(IS_SUM) )==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x + y) )==""\n"
R"==(#elif defined(IS_MUL) )==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x * y) )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE_INITIAL(x, y) (x + pow(fabs(y), POWER)) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(IS_MAX) || defined(IS_MIN) || defined(IS_MEAN) || defined(IS_MUL) )==""\n"
R"==(#define ACCUMULATE_FURTHER ACCUMULATE_INITIAL )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE_FURTHER(x, y) (x + y) )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_FIRST )==""\n"
R"==(#define ACCUMULATE ACCUMULATE_INITIAL )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE ACCUMULATE_FURTHER )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(IS_MEAN) )==""\n"
R"==(#define FINALIZE(x) (x / DIV) )==""\n"
R"==(#elif defined(IS_LP_MAX) )==""\n"
R"==(#define FINALIZE(x) rootn(fmax(x, EPS), POWER) )==""\n"
R"==(#elif defined(IS_LP_SUM) )==""\n"
R"==(#define FINALIZE(x) rootn(x + EPS, POWER) )==""\n"
R"==(#elif defined(IS_P_MAX) )==""\n"
R"==(#define FINALIZE(x) fmax(x, EPS) )==""\n"
R"==(#elif defined(IS_P_SUM) )==""\n"
R"==(#define FINALIZE(x) (x + EPS) )==""\n"
R"==(#else )==""\n"
R"==(#define FINALIZE(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#define _SRC_OFF(outer, reduction, inner) \ )==""\n"
R"==((outer) * REDUCTION_SIZE *INNER_DIM_SIZE + (reduction)*INNER_DIM_SIZE \ )==""\n"
R"==(+ (inner) )==""\n"
R"==(#define _DST_OFF(outer, reduction_chunk, inner) \ )==""\n"
R"==((outer) * INNER_DIM_SIZE *REDUCTION_END_SIZE \ )==""\n"
R"==(+ (reduction_chunk)*INNER_DIM_SIZE + inner )==""\n"
R"==(KERNEL_ATTR )==""\n"
R"==(__kernel void combined_reduce( )==""\n"
R"==(__global SRC_DATA_T *src, __global DST_DATA_T *dst) { )==""\n"
R"==(const int outer_idx = (get_global_id(0) / OUTER_DIM_STRIDE); )==""\n"
R"==(const int reduction_chunk )==""\n"
R"==(= (get_global_id(0) / PADDED_INNER_DIM_SIZE) % REDUCTION_CHUNK_SIZE; )==""\n"
R"==(const int inner = (get_global_id(0) % PADDED_INNER_DIM_SIZE); )==""\n"
R"==(if (outer_idx >= OUTER_DIM_SIZE) return; )==""\n"
R"==(const int inner_idx = inner % INNER_DIM_SIZE; )==""\n"
R"==(const int red_off = inner / INNER_DIM_SIZE; )==""\n"
R"==(const int reduction_idx )==""\n"
R"==(= reduction_chunk * REDUCTIONS_PER_WI * INNER_DIMS_PER_WI + red_off; )==""\n"
R"==(const int reduction_idx_start = reduction_idx - red_off; )==""\n"
R"==(const int inner_idx_start = inner - get_sub_group_local_id(); )==""\n"
R"==(if (inner / INNER_DIMS_PER_WI >= INNER_DIM_SIZE) { return; } )==""\n"
R"==(const int dst_off )==""\n"
R"==(= _DST_OFF(outer_idx, reduction_chunk + red_off, inner_idx); )==""\n"
R"==(DEF_ACC_DATA_T acc = INIT_ACC; )==""\n"
R"==(for (int off = 0; off < REDUCTIONS_PER_WI )==""\n"
R"==(&& off * INNER_DIMS_PER_WI + reduction_idx < REDUCTION_SIZE; )==""\n"
R"==(off++) { )==""\n"
R"==(#if WITH_BLOCK_READ )==""\n"
R"==(const int src_off = _SRC_OFF(outer_idx, )==""\n"
R"==(off * INNER_DIMS_PER_WI + reduction_idx_start, inner_idx_start); )==""\n"
R"==(const SRC_DATA_T src_val = AS_DATA_T( )==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off])); )==""\n"
R"==(#else )==""\n"
R"==(const int src_off = _SRC_OFF( )==""\n"
R"==(outer_idx, off * INNER_DIMS_PER_WI + reduction_idx, inner_idx); )==""\n"
R"==(const SRC_DATA_T src_val = src[src_off]; )==""\n"
R"==(#endif )==""\n"
R"==(const DEF_ACC_DATA_T prev = acc; )==""\n"
R"==(acc = ACCUMULATE(acc, TO_DEF_ACC_DATA_T(src_val)); )==""\n"
R"==(} )==""\n"
R"==(for (int i = 1; i < INNER_DIMS_PER_WI; i++) { )==""\n"
R"==(const DEF_ACC_DATA_T other )==""\n"
R"==(= intel_sub_group_shuffle_down(acc, INIT_ACC, INNER_DIM_SIZE); )==""\n"
R"==(if (get_sub_group_local_id() < INNER_DIM_SIZE) { )==""\n"
R"==(acc = ACCUMULATE_FURTHER(acc, other); )==""\n"
R"==(} else { )==""\n"
R"==(acc = other;  )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(if (get_sub_group_local_id() < INNER_DIM_SIZE) { )==""\n"
R"==(#if IS_FINAL )==""\n"
R"==(float res = convert_float(acc); )==""\n"
R"==(res = FINALIZE(res); )==""\n"
R"==(dst[dst_off] = TO_DST(res); )==""\n"
R"==(#else )==""\n"
R"==(dst[dst_off] = acc; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}