namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_bnorm_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#define VECT_DT_N VECT_SIZE )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define IS_IC_EQ_8 (IC == 8) )==""\n"
R"==(#define HAS_IC_TAIL (IC != IC16) )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(#error IC tail processing not supported )==""\n"
R"==(#endif )==""\n"
R"==(#else  )==""\n"
R"==(#if HAS_IC_TAIL && !USE_NHWC )==""\n"
R"==(#error IC tail processing not supported )==""\n"
R"==(#endif )==""\n"
R"==(#define HAS_STAT_SP_TAIL (STAT_SP_TAIL != STAT_SP_NBLOCKS) )==""\n"
R"==(#define HAS_SP_TAIL (SP != SP_TAIL) )==""\n"
R"==(#endif  )==""\n"
R"==(#define IC_BLOCK_SGROUPS (IC_BLOCK / 16) )==""\n"
R"==(#define IC_TAIL_SGROUPS (IC_BLOCK_SGROUPS % VECT_SIZE) )==""\n"
R"==(#define IC_VECT_SGROUPS (IC_BLOCK_SGROUPS - IC_TAIL_SGROUPS) )==""\n"
R"==(#define HAS_IC_VECT_TAIL (IC_TAIL_SGROUPS > 0) )==""\n"
R"==(#define LOAD_FLOAT_1x16(ptr) \ )==""\n"
R"==(as_float(intel_sub_group_block_read((const __global uint *)(ptr))) )==""\n"
R"==(#define LOAD_UINT_1x16(ptr) \ )==""\n"
R"==(as_uint(intel_sub_group_block_read((const __global uint *)(ptr))) )==""\n"
R"==(#define LOAD_UINT_8x16(ptr) \ )==""\n"
R"==(convert_uint8(as_uint8( \ )==""\n"
R"==(intel_sub_group_block_read8((const __global uint *)(ptr)))) )==""\n"
R"==(#define LOAD_CHAR_1x16(ptr) \ )==""\n"
R"==(as_char(intel_sub_group_block_read_uc((const __global uchar *)(ptr))) )==""\n"
R"==(#define LOAD_CHAR_8x16(ptr) \ )==""\n"
R"==(convert_char8(as_char8( \ )==""\n"
R"==(intel_sub_group_block_read_uc8((const __global uchar *)(ptr)))) )==""\n"
R"==(#define LOAD_DATA_1x16(ptr) \ )==""\n"
R"==(CONVERT_FLOAT_T(AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)(ptr)))) )==""\n"
R"==(#define LOAD_DATA_8x16(ptr) \ )==""\n"
R"==(CONVERT_FLOAT8_T( \ )==""\n"
R"==(AS_DATA8_T(BLOCK_READ8((const __global BLOCK_DATA_T *)(ptr)))) )==""\n"
R"==(#define LOAD_VECT_DATA(ptr) \ )==""\n"
R"==(CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( \ )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)(ptr)))) )==""\n"
R"==(#define LOAD_VECT_CHAR(ptr) \ )==""\n"
R"==(CONVERT_VECT_CHAR_T( \ )==""\n"
R"==(AS_VECT_CHAR_T(VECT_UCHAR_READ((const __global uchar *)(ptr)))) )==""\n"
R"==(#define LOAD_VECT_FLOAT(ptr) \ )==""\n"
R"==(AS_VECT_FLOAT_T(VECT_UINT_READ((const __global uint *)(ptr))) )==""\n"
R"==(#define STORE_DATA_1x16(ptr, val) \ )==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), \ )==""\n"
R"==(AS_BLOCK_DATA_T(CONVERT_DATA_T(val))) )==""\n"
R"==(#define STORE_DATA_8x16(ptr, val) \ )==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)ptr, \ )==""\n"
R"==(AS_BLOCK_DATA8_T(CONVERT_DATA8_T(val))) )==""\n"
R"==(#define STORE_VECT_DATA(ptr, val) \ )==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), \ )==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(val))) )==""\n"
R"==(#define STORE_FLOAT_1x16(ptr, val) \ )==""\n"
R"==(intel_sub_group_block_write((__global uint *)(ptr), as_uint(val)) )==""\n"
R"==(#define STORE_FLOAT_8x16(ptr, val) \ )==""\n"
R"==(intel_sub_group_block_write8((__global uint *)(ptr), as_uint8(val)) )==""\n"
R"==(#define STORE_CHAR_1x16(ptr, val) \ )==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)(ptr), as_uchar(val)) )==""\n"
R"==(#define STORE_CHAR_8x16(ptr, val) \ )==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)(ptr), as_uchar8(val)) )==""\n"
R"==(#define STORE_VECT_CHAR(ptr, val) \ )==""\n"
R"==(VECT_UCHAR_WRITE((__global uchar *)(ptr), \ )==""\n"
R"==(AS_VECT_UCHAR_T(CONVERT_VECT_CHAR_T(val))) )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(#define MAYBE_LAST_IC_LOAD_FLOAT_1x16(ptr, idx) \ )==""\n"
R"==((is_last_ic_block ? (simd_id < 8 ? ptr[(idx) + simd_id] : 0.0f) \ )==""\n"
R"==(: as_float(intel_sub_group_block_read( \ )==""\n"
R"==((const __global uint *)(&ptr[(idx)])))) )==""\n"
R"==(#else )==""\n"
R"==(#define MAYBE_LAST_IC_LOAD_FLOAT_1x16(ptr, idx) LOAD_FLOAT_1x16(&ptr[(idx)]) )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(#define IC_BLOCK_STRIDE IC )==""\n"
R"==(#else )==""\n"
R"==(#define IC_BLOCK_STRIDE 16 )==""\n"
R"==(#endif )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(#define REDUCE_NUM_SGROUPS IC_BLOCK_SGROUPS )==""\n"
R"==(#else )==""\n"
R"==(#define REDUCE_NUM_SGROUPS 1 )==""\n"
R"==(#endif )==""\n"
R"==(#define CALC_SLM_LINE_SIZE (REDUCE_NUM_SGROUPS * GWS_LWS0_CALC) )==""\n"
R"==(#define CALC_SLM_SIZE (CALC_SLM_LINE_SIZE * GWS_LWS1_CALC * GWS_LWS2_CALC) )==""\n"
R"==(NAMED_KERNEL_ATTR(AUX) )==""\n"
R"==(__kernel void gen9_fused_reduce_init( )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(__global float *mean, __global float *variance )==""\n"
R"==(#else )==""\n"
R"==(__global float *diff_scale, __global float *diff_shift )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(const int c = GWS_GET_IC_AUX(); )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(mean[c] = 0.0f; )==""\n"
R"==(variance[c] = 0.0f; )==""\n"
R"==(#else )==""\n"
R"==(diff_scale[c] = 0.0f; )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(diff_shift[c] = 0.0f; )==""\n"
R"==(#else )==""\n"
R"==(diff_shift[IC + IC * REDUCE_STAT_NBLOCKS + c] = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(#define LOAD_DATA_Nx16_USING_LOOP_IDX(n, dest, src, idx) \ )==""\n"
R"==({ \ )==""\n"
R"==(for (int k = 0; k < n; ++k) { \ )==""\n"
R"==(dest[k] = LOAD_DATA_1x16(&src[(k + idx) * IC]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(n, dest, src, idx) \ )==""\n"
R"==({ \ )==""\n"
R"==(for (int k = 0; k < n; k += 2) { \ )==""\n"
R"==(dest[k] = LOAD_DATA_1x16(&src[(k + idx) * IC]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#if USE_STATS_ONE_PASS )==""\n"
R"==(#define ACCUM_DATA_T float )==""\n"
R"==(#define ACCUM_DATA8_T float8 )==""\n"
R"==(#define ACCUM_DATA2_T float2 )==""\n"
R"==(#define SUM_DATA_T ACCUM_DATA2_T )==""\n"
R"==(SUM_DATA_T summation(ACCUM_DATA_T input, SUM_DATA_T state) { )==""\n"
R"==(ACCUM_DATA2_T ret; )==""\n"
R"==(ACCUM_DATA_T y = input - state.s1; )==""\n"
R"==(ACCUM_DATA_T t = state.s0 + y; )==""\n"
R"==(ret.s1 = (t - state.s0) - y; )==""\n"
R"==(ret.s0 = t; )==""\n"
R"==(return ret; )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(void gen9_mean_var_calc_fused_reduction(volatile __global atomic_float *mean, )==""\n"
R"==(volatile __global atomic_float *variance, int dst_offset, )==""\n"
R"==(SUM_DATA_T *sum, SUM_DATA_T *sum_sq, __local SUM_DATA_T *local_sum, )==""\n"
R"==(__local SUM_DATA_T *local_sum_sq) { )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const int group_size = GWS_LWS1_CALC * GWS_LWS2_CALC; )==""\n"
R"==(const int sg_group_id = get_local_id(0) / 16; )==""\n"
R"==(const int local_id = get_local_id(1); )==""\n"
R"==(if (local_id > 0) { )==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) { )==""\n"
R"==(const int slm_offset = CALC_SLM_LINE_SIZE * local_id )==""\n"
R"==(+ REDUCE_NUM_SGROUPS * 16 * sg_group_id + sg * 16 + simd_id; )==""\n"
R"==(local_sum[slm_offset] = sum[sg]; )==""\n"
R"==(local_sum_sq[slm_offset] = sum_sq[sg]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(if (local_id == 0) { )==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) { )==""\n"
R"==(for (int gr_id = 1; gr_id < group_size; ++gr_id) { )==""\n"
R"==(const int off_local = CALC_SLM_LINE_SIZE * gr_id )==""\n"
R"==(+ REDUCE_NUM_SGROUPS * 16 * sg_group_id + sg * 16 )==""\n"
R"==(+ simd_id; )==""\n"
R"==(SUM_DATA_T tmp = local_sum[off_local]; )==""\n"
R"==(SUM_DATA_T tmp_sq = local_sum_sq[off_local]; )==""\n"
R"==(sum[sg] = summation(tmp.s1, sum[sg]); )==""\n"
R"==(sum_sq[sg] = summation(tmp_sq.s1, sum_sq[sg]); )==""\n"
R"==(sum[sg] = summation(tmp.s0, sum[sg]); )==""\n"
R"==(sum_sq[sg] = summation(tmp_sq.s0, sum_sq[sg]); )==""\n"
R"==(} )==""\n"
R"==(const int offset = dst_offset + sg * 16 + simd_id; )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(if (offset < IC) { )==""\n"
R"==(#endif )==""\n"
R"==(atomic_add_global(&mean[offset], sum[sg].s0); )==""\n"
R"==(atomic_add_global(&variance[offset], sum_sq[sg].s0); )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(void gen9_calc_fused_reduction(volatile __global atomic_float *dst, )==""\n"
R"==(int dst_offset, float *sum, __local float *local_sum) { )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const int group_size = GWS_LWS1_CALC * GWS_LWS2_CALC; )==""\n"
R"==(const int sg_group_id = get_local_id(0) / 16; )==""\n"
R"==(const int local_id = get_local_id(1); )==""\n"
R"==(if (local_id > 0) { )==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) { )==""\n"
R"==(const int slm_offset = CALC_SLM_LINE_SIZE * local_id )==""\n"
R"==(+ REDUCE_NUM_SGROUPS * 16 * sg_group_id + sg * 16 + simd_id; )==""\n"
R"==(local_sum[slm_offset] = sum[sg]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(if (local_id == 0) { )==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) { )==""\n"
R"==(for (int gr_id = 1; gr_id < group_size; ++gr_id) { )==""\n"
R"==(const int off_local = CALC_SLM_LINE_SIZE * gr_id )==""\n"
R"==(+ REDUCE_NUM_SGROUPS * 16 * sg_group_id + sg * 16 )==""\n"
R"==(+ simd_id; )==""\n"
R"==(sum[sg] += local_sum[off_local]; )==""\n"
R"==(} )==""\n"
R"==(const int offset = dst_offset + sg * 16 + simd_id; )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(if (offset < IC) )==""\n"
R"==(#endif )==""\n"
R"==(atomic_add_global(&dst[offset], sum[sg]); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(void gen9_reduce_common(__global float *reduce_temp, __local float *local_sum, )==""\n"
R"==(__global float *dst) { )==""\n"
R"==(const int ic_sub_group = get_global_id(0) / 16; )==""\n"
R"==(const int group_c = get_global_id(1); )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const int c = group_c * 16 + simd_id; )==""\n"
R"==(const bool is_last_ic_block = (IC - group_c * 16) < 16; )==""\n"
R"==(float sum = 0.0f; )==""\n"
R"==(reduce_temp )==""\n"
R"==(+= REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS * 16 * ic_sub_group )==""\n"
R"==(+ REDUCE_STAT_NBLOCKS * 16 * group_c + simd_id; )==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) { )==""\n"
R"==(sum += reduce_temp[i * 16]; )==""\n"
R"==(} )==""\n"
R"==(if (ic_sub_group > 0) { local_sum[ic_sub_group * 16 + simd_id] = sum; } )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(if (ic_sub_group == 0) { )==""\n"
R"==(for (int i = 1; i < REDUCE_IC_SUB_GROUPS; i++) { )==""\n"
R"==(sum += local_sum[i * 16 + simd_id]; )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(if (!is_last_ic_block || (is_last_ic_block && simd_id < 8)) )==""\n"
R"==(#endif )==""\n"
R"==(dst[c] = sum / (MB * ID * IH * IW); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if USE_STATS_ONE_PASS )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void gen9_calc_mean_var(__global DATA_T *src, )==""\n"
R"==(__global ACCUM_DATA_T *reduce_temp, )==""\n"
R"==(volatile __global atomic_float *mean, )==""\n"
R"==(volatile __global atomic_float *variance) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP(); )==""\n"
R"==(const int ic_block_offset = (c / 16) * IC_BLOCK; )==""\n"
R"==(const int group_c_offset )==""\n"
R"==(= REDUCE_STAT_NBLOCKS * ic_block_offset + sp_block_idx * 16; )==""\n"
R"==(const int ver_offs = REDUCE_STAT_NBLOCKS * IC; )==""\n"
R"==(const int src_off = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(src += src_off; )==""\n"
R"==(SUM_DATA_T sum[IC_BLOCK_SGROUPS] = {0.0f}; )==""\n"
R"==(SUM_DATA_T sum_sq[IC_BLOCK_SGROUPS] = {0.0f}; )==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) { )==""\n"
R"==(if (sp_block_idx * STAT_SP_BLOCK + sp >= SP) break; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) { )==""\n"
R"==(VECT_FLOAT_T s_vect = LOAD_VECT_DATA(&src[sg * 16 * VECT_SIZE]); )==""\n"
R"==(for (int vect = 0; vect < VECT_SIZE; ++vect) { )==""\n"
R"==(const int sum_idx = sg * VECT_SIZE + vect; )==""\n"
R"==(#if VECT_SIZE > 1 )==""\n"
R"==(sum[sum_idx] = summation(s_vect[vect], sum[sum_idx]); )==""\n"
R"==(sum_sq[sum_idx] = summation( )==""\n"
R"==(s_vect[vect] * s_vect[vect], sum_sq[sum_idx]); )==""\n"
R"==(#else )==""\n"
R"==(sum[sum_idx] = summation(s_vect, sum[sum_idx]); )==""\n"
R"==(sum_sq[sum_idx] = summation(s_vect * s_vect, sum_sq[sum_idx]); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) { )==""\n"
R"==(const int sg_idx = IC_VECT_SGROUPS + sg; )==""\n"
R"==(float s_tail = LOAD_DATA_1x16(&src[(IC_VECT_SGROUPS + sg) * 16]); )==""\n"
R"==(sum[sg_idx] = summation(s_tail, sum[sg_idx]); )==""\n"
R"==(sum_sq[sg_idx] = summation(s_tail * s_tail, sum_sq[sg_idx]); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(src += IC; )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(__local SUM_DATA_T local_sum[2 * CALC_SLM_SIZE]; )==""\n"
R"==(__local SUM_DATA_T *local_sum_sq = local_sum + CALC_SLM_SIZE; )==""\n"
R"==(gen9_mean_var_calc_fused_reduction(mean, variance, ic_block_offset, sum, )==""\n"
R"==(sum_sq, local_sum, local_sum_sq); )==""\n"
R"==(#else )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) { )==""\n"
R"==(const int reduce_off = group_c_offset + sg * 16 * REDUCE_STAT_NBLOCKS; )==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[reduce_off], sum[sg].s0); )==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[ver_offs + reduce_off], sum_sq[sg].s0); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void gen9_calc_mean_var(__global DATA_T *src, )==""\n"
R"==(__global ACCUM_DATA_T *reduce_temp, )==""\n"
R"==(volatile __global atomic_float *mean, )==""\n"
R"==(volatile __global atomic_float *variance) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP(); )==""\n"
R"==(const int mb_sp_idx = mb * STAT_SP_NBLOCKS + sp_block_idx; )==""\n"
R"==(const int group_c_offset = REDUCE_STAT_NBLOCKS * 16 * (int)(c / 16); )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const int ver_offs = REDUCE_STAT_NBLOCKS * IC; )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(src += c + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(#else )==""\n"
R"==(src += (c & 15) + sp_block_idx * STAT_SP_BLOCK * 16 + (c & ~15) * SP )==""\n"
R"==(+ mb * SP * IC; )==""\n"
R"==(#endif )==""\n"
R"==(SUM_DATA_T sum; )==""\n"
R"==(SUM_DATA_T sum_sq; )==""\n"
R"==(sum.s0 = 0; )==""\n"
R"==(sum.s1 = 0; )==""\n"
R"==(sum_sq.s0 = 0; )==""\n"
R"==(sum_sq.s1 = 0; )==""\n"
R"==(#if HAS_STAT_SP_TAIL )==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) { )==""\n"
R"==(int sp = SP - STAT_SP_TAIL * STAT_SP_BLOCK; )==""\n"
R"==(while (sp >= 16) { )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(float8 s0, s1; )==""\n"
R"==(for (int k = 0; k < 8; ++k) )==""\n"
R"==(s0[k] = LOAD_DATA_1x16(&src[k * IC]); )==""\n"
R"==(for (int k = 0; k < 8; ++k) )==""\n"
R"==(s1[k] = LOAD_DATA_1x16(&src[(k + 8) * IC]); )==""\n"
R"==(#else )==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]); )==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]); )==""\n"
R"==(#endif )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(sum = summation(s0[i], sum); )==""\n"
R"==(sum = summation(s1[i], sum); )==""\n"
R"==(sum_sq = summation(s0[i] * s0[i], sum_sq); )==""\n"
R"==(sum_sq = summation(s1[i] * s1[i], sum_sq); )==""\n"
R"==(} )==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE; )==""\n"
R"==(sp -= 16; )==""\n"
R"==(} )==""\n"
R"==(while (sp >= 1) { )==""\n"
R"==(float s0 = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(sum = summation(s0, sum); )==""\n"
R"==(sum_sq = summation(s0 * s0, sum_sq); )==""\n"
R"==(src += IC_BLOCK_STRIDE; )==""\n"
R"==(--sp; )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif )==""\n"
R"==({ )==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK / 16; ++sp) { )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(float8 s0, s1; )==""\n"
R"==(for (int k = 0; k < 8; ++k) )==""\n"
R"==(s0[k] = LOAD_DATA_1x16(&src[k * IC]); )==""\n"
R"==(for (int k = 0; k < 8; ++k) )==""\n"
R"==(s1[k] = LOAD_DATA_1x16(&src[(k + 8) * IC]); )==""\n"
R"==(#else )==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]); )==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]); )==""\n"
R"==(#endif )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(sum = summation(s0[i], sum); )==""\n"
R"==(sum = summation(s1[i], sum); )==""\n"
R"==(sum_sq = summation(s0[i] * s0[i], sum_sq); )==""\n"
R"==(sum_sq = summation(s1[i] * s1[i], sum_sq); )==""\n"
R"==(} )==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(__local SUM_DATA_T local_sum[2 * CALC_SLM_SIZE]; )==""\n"
R"==(__local SUM_DATA_T *local_sum_sq = local_sum + CALC_SLM_SIZE; )==""\n"
R"==(gen9_mean_var_calc_fused_reduction( )==""\n"
R"==(mean, variance, c, &sum, &sum_sq, local_sum, local_sum_sq); )==""\n"
R"==(#else )==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[group_c_offset + mb_sp_idx * 16], sum.s0); )==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[ver_offs + group_c_offset + mb_sp_idx * 16], )==""\n"
R"==(sum_sq.s0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE) )==""\n"
R"==(__kernel void gen9_reduce_mean_var(__global ACCUM_DATA_T *reduce_temp, )==""\n"
R"==(__global float *mean, __global float *variance) { )==""\n"
R"==(__local SUM_DATA_T local_sum[16 * REDUCE_IC_SUB_GROUPS]; )==""\n"
R"==(__local SUM_DATA_T local_sum_sq[16 * REDUCE_IC_SUB_GROUPS]; )==""\n"
R"==(const int ic_sub_group = get_global_id(0) / 16; )==""\n"
R"==(const int group_c = get_global_id(1); )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const int c = group_c * 16 + simd_id; )==""\n"
R"==(SUM_DATA_T sum; )==""\n"
R"==(SUM_DATA_T sum_sq; )==""\n"
R"==(sum.s0 = 0; )==""\n"
R"==(sum.s1 = 0; )==""\n"
R"==(sum_sq.s0 = 0; )==""\n"
R"==(sum_sq.s1 = 0; )==""\n"
R"==(int offs_sq = REDUCE_STAT_NBLOCKS * IC; )==""\n"
R"==(int offs = REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS * 16 * ic_sub_group )==""\n"
R"==(+ REDUCE_STAT_NBLOCKS * 16 * group_c + simd_id; )==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) { )==""\n"
R"==(float tmp = reduce_temp[offs + i * 16]; )==""\n"
R"==(sum = summation(tmp, sum); )==""\n"
R"==(} )==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) { )==""\n"
R"==(float tmp = reduce_temp[offs_sq + offs + i * 16]; )==""\n"
R"==(sum_sq = summation(tmp, sum_sq); )==""\n"
R"==(} )==""\n"
R"==(if (ic_sub_group > 0) { )==""\n"
R"==(local_sum[ic_sub_group * 16 + simd_id] = sum; )==""\n"
R"==(local_sum_sq[ic_sub_group * 16 + simd_id] = sum_sq; )==""\n"
R"==(} )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(if (ic_sub_group == 0) { )==""\n"
R"==(for (int i = 1; i < REDUCE_IC_SUB_GROUPS; i++) { )==""\n"
R"==(SUM_DATA_T tmp = local_sum[i * 16 + simd_id]; )==""\n"
R"==(SUM_DATA_T tmp_sq = local_sum_sq[i * 16 + simd_id]; )==""\n"
R"==(sum = summation(tmp.s1, sum); )==""\n"
R"==(sum_sq = summation(tmp_sq.s1, sum_sq); )==""\n"
R"==(sum = summation(tmp.s0, sum); )==""\n"
R"==(sum_sq = summation(tmp_sq.s0, sum_sq); )==""\n"
R"==(} )==""\n"
R"==(float tmp_mean = sum.s0 / (MB * ID * IH * IW); )==""\n"
R"==(mean[c] = tmp_mean; )==""\n"
R"==(float tmp_var = max(0.0f, )==""\n"
R"==((sum_sq.s0 / (MB * ID * IH * IW)) - (tmp_mean * tmp_mean)); )==""\n"
R"==(variance[c] = tmp_var; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(NAMED_KERNEL_ATTR(AUX) )==""\n"
R"==(__kernel void gen9_fused_reduce_final( )==""\n"
R"==(#if USE_STATS_ONE_PASS )==""\n"
R"==(__global float *mean, __global float *variance )==""\n"
R"==(#else )==""\n"
R"==(__global float *data_reduce )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(const int c = GWS_GET_IC_AUX(); )==""\n"
R"==(#if USE_STATS_ONE_PASS )==""\n"
R"==(mean[c] = mean[c] / (MB * ID * IH * IW); )==""\n"
R"==(float tmp_var = max( )==""\n"
R"==(0.0f, (variance[c] / (MB * ID * IH * IW)) - (mean[c] * mean[c])); )==""\n"
R"==(variance[c] = tmp_var; )==""\n"
R"==(#else )==""\n"
R"==(data_reduce[c] = data_reduce[c] / (MB * ID * IH * IW); )==""\n"
R"==(#endif )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void gen9_calc_mean(__global DATA_T *src, __global float *reduce_temp, )==""\n"
R"==(volatile __global atomic_float *mean) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP(); )==""\n"
R"==(const int ic_block_offset = (c / 16) * IC_BLOCK; )==""\n"
R"==(const int group_c_offset )==""\n"
R"==(= REDUCE_STAT_NBLOCKS * ic_block_offset + sp_block_idx * 16; )==""\n"
R"==(const int src_off = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(src += src_off; )==""\n"
R"==(float v_mean[IC_BLOCK_SGROUPS] = {0.0f}; )==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) { )==""\n"
R"==(if (sp_block_idx * STAT_SP_BLOCK + sp >= SP) break; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) { )==""\n"
R"==(VECT_FLOAT_T s_vect = LOAD_VECT_DATA(&src[sg * 16 * VECT_SIZE]); )==""\n"
R"==(for (int vect = 0; vect < VECT_SIZE; ++vect) { )==""\n"
R"==(v_mean[sg * VECT_SIZE + vect] )==""\n"
R"==(#if VECT_SIZE > 1 )==""\n"
R"==(+= s_vect[vect]; )==""\n"
R"==(#else )==""\n"
R"==(+= s_vect; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) { )==""\n"
R"==(float s_tail = LOAD_DATA_1x16(&src[(IC_VECT_SGROUPS + sg) * 16]); )==""\n"
R"==(v_mean[IC_VECT_SGROUPS + sg] += s_tail; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(src += IC; )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(__local float local_sum[CALC_SLM_SIZE]; )==""\n"
R"==(gen9_calc_fused_reduction(mean, ic_block_offset, v_mean, local_sum); )==""\n"
R"==(#else )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) { )==""\n"
R"==(const int reduce_off = group_c_offset + sg * 16 * REDUCE_STAT_NBLOCKS; )==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[reduce_off], v_mean[sg]); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void gen9_calc_mean(__global DATA_T *src, __global float *reduce_temp, )==""\n"
R"==(__global float *mean) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP(); )==""\n"
R"==(const int mb_sp_idx = mb * STAT_SP_NBLOCKS + sp_block_idx; )==""\n"
R"==(const int group_c_offset = REDUCE_STAT_NBLOCKS * 16 * (int)(c / 16); )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC; )==""\n"
R"==(const bool is_last_sp_block = (sp_block_idx == STAT_SP_NBLOCKS - 1); )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(src += c + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(#else )==""\n"
R"==(src += (c & 15) + sp_block_idx * STAT_SP_BLOCK * 16 + (c & ~15) * SP )==""\n"
R"==(+ mb * SP * IC; )==""\n"
R"==(#endif )==""\n"
R"==(float8 res0 = 0.0f, res1 = 0.0f; )==""\n"
R"==(float v_mean = 0.0f; )==""\n"
R"==(#if HAS_STAT_SP_TAIL )==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) { )==""\n"
R"==(int sp = SP - STAT_SP_TAIL * STAT_SP_BLOCK; )==""\n"
R"==(while (sp >= 16) { )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(float8 s0, s1; )==""\n"
R"==(#if IS_IC_EQ_8 )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s1, src, 8); )==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(s0, s0, 8); )==""\n"
R"==(float8 t1 = intel_sub_group_shuffle_down(s1, s1, 8); )==""\n"
R"==(for (int k = 0; k < 7; k += 2) { )==""\n"
R"==(s0[k + 1] = t0[k]; )==""\n"
R"==(s1[k + 1] = t1[k]; )==""\n"
R"==(} )==""\n"
R"==(#elif HAS_IC_TAIL )==""\n"
R"==(const bool is_last_sp = sp == 16; )==""\n"
R"==(if (is_last_sp && is_last_ic_block) { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s0, src, 0); )==""\n"
R"==(s0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s1, src, 8); )==""\n"
R"==(s1[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[15 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8); )==""\n"
R"==(#endif  )==""\n"
R"==(#else )==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]); )==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]); )==""\n"
R"==(#endif  )==""\n"
R"==(res0 += s0; )==""\n"
R"==(res1 += s1; )==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE; )==""\n"
R"==(sp -= 16; )==""\n"
R"==(} )==""\n"
R"==(while (sp >= 1) { )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(float s0; )==""\n"
R"==(if (sp == 1 && is_last_ic_block) )==""\n"
R"==(s0 = simd_id < 8 ? CONVERT_FLOAT_T(src[simd_id]) : 0.0f; )==""\n"
R"==(else )==""\n"
R"==(s0 = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(#else )==""\n"
R"==(float s0 = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(#endif )==""\n"
R"==(v_mean += s0; )==""\n"
R"==(src += IC_BLOCK_STRIDE; )==""\n"
R"==(--sp; )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK / 16; ++sp) { )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(float8 s0, s1; )==""\n"
R"==(#if IS_IC_EQ_8 )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s1, src, 8); )==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(s0, s0, 8); )==""\n"
R"==(float8 t1 = intel_sub_group_shuffle_down(s1, s1, 8); )==""\n"
R"==(for (int k = 0; k < 7; k += 2) { )==""\n"
R"==(s0[k + 1] = t0[k]; )==""\n"
R"==(s1[k + 1] = t1[k]; )==""\n"
R"==(} )==""\n"
R"==(#elif HAS_IC_TAIL )==""\n"
R"==(const bool is_last_sp = sp == STAT_SP_BLOCK / 16 - 1; )==""\n"
R"==(if (is_last_sp && is_last_ic_block && is_last_sp_block) { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s0, src, 0); )==""\n"
R"==(s0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s1, src, 8); )==""\n"
R"==(s1[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[15 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8); )==""\n"
R"==(#endif  )==""\n"
R"==(#else )==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]); )==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]); )==""\n"
R"==(#endif  )==""\n"
R"==(res0 += s0; )==""\n"
R"==(res1 += s1; )==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(v_mean += res0[i] + res1[i]; )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(__local float local_sum[CALC_SLM_SIZE]; )==""\n"
R"==(gen9_calc_fused_reduction(mean, c, &v_mean, local_sum); )==""\n"
R"==(#else )==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[group_c_offset + mb_sp_idx * 16], v_mean); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE) )==""\n"
R"==(__kernel void gen9_reduce_mean( )==""\n"
R"==(__global float *reduce_temp, __global float *mean) { )==""\n"
R"==(__local float local_sum[16 * REDUCE_IC_SUB_GROUPS]; )==""\n"
R"==(gen9_reduce_common(reduce_temp, local_sum, mean); )==""\n"
R"==(} )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void gen9_calc_variance(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global float *reduce_temp, volatile __global atomic_float *variance) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP(); )==""\n"
R"==(const int ic_block_offset = (c / 16) * IC_BLOCK; )==""\n"
R"==(const int group_c_offset )==""\n"
R"==(= REDUCE_STAT_NBLOCKS * ic_block_offset + sp_block_idx * 16; )==""\n"
R"==(reduce_temp += REDUCE_STAT_NBLOCKS * IC16; )==""\n"
R"==(mean += ic_block_offset; )==""\n"
R"==(const int src_off = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(src += src_off; )==""\n"
R"==(float v_mean[IC_BLOCK_SGROUPS]; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) { )==""\n"
R"==(v_mean[sg] = as_float(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(&mean[(sg * 16)]))); )==""\n"
R"==(} )==""\n"
R"==(float v_var[IC_BLOCK_SGROUPS] = {0.0f}; )==""\n"
R"==(float v0[IC_BLOCK_SGROUPS] = {0.0f}; )==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) { )==""\n"
R"==(if (sp_block_idx * STAT_SP_BLOCK + sp >= SP) break; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) { )==""\n"
R"==(VECT_FLOAT_T s_vect = LOAD_VECT_DATA(&src[sg * 16 * VECT_SIZE]); )==""\n"
R"==(for (int vect = 0; vect < VECT_SIZE; ++vect) { )==""\n"
R"==(int sg_idx = sg * VECT_SIZE + vect; )==""\n"
R"==(#if VECT_SIZE > 1 )==""\n"
R"==(v0[sg_idx] = s_vect[vect] - v_mean[sg_idx]; )==""\n"
R"==(#else )==""\n"
R"==(v0[sg_idx] = s_vect - v_mean[sg_idx]; )==""\n"
R"==(#endif )==""\n"
R"==(v_var[sg_idx] = fma(v0[sg_idx], v0[sg_idx], v_var[sg_idx]); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) { )==""\n"
R"==(const int sg_idx = IC_VECT_SGROUPS + sg; )==""\n"
R"==(float s_tail = LOAD_DATA_1x16(&src[(IC_VECT_SGROUPS + sg) * 16]); )==""\n"
R"==(v0[sg_idx] = s_tail - v_mean[sg_idx]; )==""\n"
R"==(v_var[sg_idx] = fma(v0[sg_idx], v0[sg_idx], v_var[sg_idx]); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(src += IC; )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(__local float local_sum[CALC_SLM_SIZE]; )==""\n"
R"==(gen9_calc_fused_reduction(variance, ic_block_offset, v_var, local_sum); )==""\n"
R"==(#else )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) { )==""\n"
R"==(const int reduce_off = group_c_offset + sg * 16 * REDUCE_STAT_NBLOCKS; )==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[reduce_off], v_var[sg]); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void gen9_calc_variance(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global float *reduce_temp, __global float *variance) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP(); )==""\n"
R"==(const int mb_sp_idx = mb * STAT_SP_NBLOCKS + sp_block_idx; )==""\n"
R"==(const int group_c_offset = REDUCE_STAT_NBLOCKS * 16 * (int)(c / 16); )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC; )==""\n"
R"==(const bool is_last_sp_block = (sp_block_idx == STAT_SP_NBLOCKS - 1); )==""\n"
R"==(#endif )==""\n"
R"==(reduce_temp += REDUCE_STAT_NBLOCKS * IC16; )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(src += c + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(#else )==""\n"
R"==(src += (c & 15) + sp_block_idx * STAT_SP_BLOCK * 16 + (c & ~15) * SP )==""\n"
R"==(+ mb * SP * IC; )==""\n"
R"==(#endif )==""\n"
R"==(float8 res0 = 0.0f, res1 = 0.0f; )==""\n"
R"==(float v_var = 0.0f; )==""\n"
R"==(float v_mean = MAYBE_LAST_IC_LOAD_FLOAT_1x16(mean, c); )==""\n"
R"==(#if HAS_STAT_SP_TAIL )==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) { )==""\n"
R"==(int sp = SP - STAT_SP_TAIL * STAT_SP_BLOCK; )==""\n"
R"==(while (sp >= 16) { )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(float8 s0, s1; )==""\n"
R"==(#if IS_IC_EQ_8 )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s1, src, 8); )==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(s0, s0, 8); )==""\n"
R"==(float8 t1 = intel_sub_group_shuffle_down(s1, s1, 8); )==""\n"
R"==(for (int k = 0; k < 7; k += 2) { )==""\n"
R"==(s0[k + 1] = t0[k]; )==""\n"
R"==(s1[k + 1] = t1[k]; )==""\n"
R"==(} )==""\n"
R"==(#elif HAS_IC_TAIL )==""\n"
R"==(const bool is_last_sp = sp == 16; )==""\n"
R"==(if (is_last_sp && is_last_ic_block) { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s0, src, 0); )==""\n"
R"==(s0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s1, src, 8); )==""\n"
R"==(s1[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[15 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8); )==""\n"
R"==(#endif )==""\n"
R"==(#else  )==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]); )==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]); )==""\n"
R"==(#endif )==""\n"
R"==(float8 v0 = s0 - v_mean; )==""\n"
R"==(float8 v1 = s1 - v_mean; )==""\n"
R"==(res0 = fma(v0, v0, res0); )==""\n"
R"==(res1 = fma(v1, v1, res1); )==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE; )==""\n"
R"==(sp -= 16; )==""\n"
R"==(} )==""\n"
R"==(while (sp >= 1) { )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(float s0; )==""\n"
R"==(if (sp == 1 && is_last_ic_block) )==""\n"
R"==(s0 = simd_id < 8 ? CONVERT_FLOAT_T(src[simd_id]) : 0.0f; )==""\n"
R"==(else )==""\n"
R"==(s0 = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(#else )==""\n"
R"==(float s0 = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(#endif )==""\n"
R"==(float v0 = s0 - v_mean; )==""\n"
R"==(v_var = fma(v0, v0, v_var); )==""\n"
R"==(src += IC_BLOCK_STRIDE; )==""\n"
R"==(--sp; )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK / 16; ++sp) { )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(float8 s0, s1; )==""\n"
R"==(#if IS_IC_EQ_8 )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, s1, src, 8); )==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(s0, s0, 8); )==""\n"
R"==(float8 t1 = intel_sub_group_shuffle_down(s1, s1, 8); )==""\n"
R"==(for (int k = 0; k < 7; k += 2) { )==""\n"
R"==(s0[k + 1] = t0[k]; )==""\n"
R"==(s1[k + 1] = t1[k]; )==""\n"
R"==(} )==""\n"
R"==(#elif HAS_IC_TAIL )==""\n"
R"==(const bool is_last_sp = sp == STAT_SP_BLOCK / 16 - 1; )==""\n"
R"==(if (is_last_sp && is_last_ic_block && is_last_sp_block) { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s0, src, 0); )==""\n"
R"==(s0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, s1, src, 8); )==""\n"
R"==(s1[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[15 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s0, src, 0); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, s1, src, 8); )==""\n"
R"==(#endif  )==""\n"
R"==(#else )==""\n"
R"==(float8 s0 = LOAD_DATA_8x16(&src[0]); )==""\n"
R"==(float8 s1 = LOAD_DATA_8x16(&src[8 * 16]); )==""\n"
R"==(#endif  )==""\n"
R"==(float8 v0 = s0 - v_mean; )==""\n"
R"==(float8 v1 = s1 - v_mean; )==""\n"
R"==(res0 = fma(v0, v0, res0); )==""\n"
R"==(res1 = fma(v1, v1, res1); )==""\n"
R"==(src += 16 * IC_BLOCK_STRIDE; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(v_var += res0[i] + res1[i]; )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(__local float local_sum[CALC_SLM_SIZE]; )==""\n"
R"==(gen9_calc_fused_reduction(variance, c, &v_var, local_sum); )==""\n"
R"==(#else )==""\n"
R"==(STORE_FLOAT_1x16(&reduce_temp[group_c_offset + mb_sp_idx * 16], v_var); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE) )==""\n"
R"==(__kernel void gen9_reduce_variance( )==""\n"
R"==(__global float *reduce_temp, __global float *variance) { )==""\n"
R"==(__local float local_sum[16 * REDUCE_IC_SUB_GROUPS]; )==""\n"
R"==(gen9_reduce_common( )==""\n"
R"==(reduce_temp + REDUCE_STAT_NBLOCKS * IC16, local_sum, variance); )==""\n"
R"==(} )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(KERNEL_ATTR )==""\n"
R"==(__kernel void gen9_bnorm_fwd(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global float *variance, __global DATA_T *dst, )==""\n"
R"==(__global float *scaleshift, __global float *shift, __global char *ws, )==""\n"
R"==(float eps, __global DATA_T *src_add) { )==""\n"
R"==(const int n = GWS_GET_MB(); )==""\n"
R"==(const int c = GWS_GET_IC(); )==""\n"
R"==(const int sp = GWS_GET_SP() * STAT_SP_BLOCK; )==""\n"
R"==(const int ic_block_offset = (c / 16) * IC_BLOCK; )==""\n"
R"==(mean += ic_block_offset; )==""\n"
R"==(variance += ic_block_offset; )==""\n"
R"==(shift += ic_block_offset; )==""\n"
R"==(scaleshift += ic_block_offset; )==""\n"
R"==(const uint d_off = sp * IC + ic_block_offset; )==""\n"
R"==(src += d_off; )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(src_add += d_off; )==""\n"
R"==(#endif )==""\n"
R"==(dst += d_off; )==""\n"
R"==(#if FUSE_BN_RELU && IS_TRAINING )==""\n"
R"==(ws += d_off; )==""\n"
R"==(#endif )==""\n"
R"==(VECT_FLOAT_T sm[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(sv[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(v_mean[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(v_variance[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(sqrt_variance[IC_BLOCK_SGROUPS / VECT_SIZE]; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) { )==""\n"
R"==(const int sg_idx = sg * 16 * VECT_SIZE; )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(sm[sg] = LOAD_VECT_FLOAT(&scaleshift[sg_idx]); )==""\n"
R"==(#else )==""\n"
R"==(sm[sg] = (VECT_FLOAT_T)1.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_SHIFT == 1 )==""\n"
R"==(sv[sg] = LOAD_VECT_FLOAT(&shift[sg_idx]); )==""\n"
R"==(#else )==""\n"
R"==(sv[sg] = (VECT_FLOAT_T)0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(v_mean[sg] = LOAD_VECT_FLOAT(&mean[sg_idx]); )==""\n"
R"==(v_variance[sg] = LOAD_VECT_FLOAT(&variance[sg_idx]); )==""\n"
R"==(sqrt_variance[sg] = sm[sg] / sqrt(v_variance[sg] + (VECT_FLOAT_T)eps); )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(float sm_tail[IC_TAIL_SGROUPS], sv_tail[IC_TAIL_SGROUPS], )==""\n"
R"==(v_mean_tail[IC_TAIL_SGROUPS], v_variance_tail[IC_TAIL_SGROUPS], )==""\n"
R"==(sqrt_variance_tail[IC_TAIL_SGROUPS]; )==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) { )==""\n"
R"==(const int sg_idx = (IC_VECT_SGROUPS + sg) * 16; )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(sm_tail[sg] = LOAD_FLOAT_1x16(&scaleshift[sg_idx]); )==""\n"
R"==(#else )==""\n"
R"==(sm_tail[sg] = 1.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_SHIFT == 1 )==""\n"
R"==(sv_tail[sg] = LOAD_FLOAT_1x16(&shift[sg_idx]); )==""\n"
R"==(#else )==""\n"
R"==(sv_tail[sg] = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(v_mean_tail[sg] = LOAD_FLOAT_1x16(&mean[sg_idx]); )==""\n"
R"==(v_variance_tail[sg] = LOAD_FLOAT_1x16(&variance[sg_idx]); )==""\n"
R"==(sqrt_variance_tail[sg] = sm_tail[sg] / sqrt(v_variance_tail[sg] + eps); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(for (int sp_idx = 0; sp_idx < STAT_SP_BLOCK; sp_idx++) { )==""\n"
R"==(if (sp_idx + sp >= SP) break; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) { )==""\n"
R"==(const int sg_idx = sg * 16 * VECT_SIZE; )==""\n"
R"==(VECT_FLOAT_T s_vect = LOAD_VECT_DATA(&src[sg_idx]); )==""\n"
R"==(VECT_FLOAT_T d_vect )==""\n"
R"==(= fma(s_vect - v_mean[sg], sqrt_variance[sg], sv[sg]); )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(VECT_FLOAT_T s_add_vect = LOAD_VECT_DATA(&src_add[sg_idx]); )==""\n"
R"==(d_vect += s_add_vect; )==""\n"
R"==(#endif )==""\n"
R"==(VECT_INT_T ws_vect = isgreater(d_vect, (VECT_FLOAT_T)0.0f); )==""\n"
R"==(d_vect = select((VECT_FLOAT_T)0.0f, d_vect, ws_vect); )==""\n"
R"==(#if IS_TRAINING )==""\n"
R"==(STORE_VECT_CHAR(&ws[sg_idx], ws_vect); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_RELU )==""\n"
R"==(d_vect = max(d_vect, (VECT_FLOAT_T)0.0f); )==""\n"
R"==(#endif )==""\n"
R"==(STORE_VECT_DATA(&dst[sg_idx], d_vect); )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) { )==""\n"
R"==(const int sg_idx = (IC_VECT_SGROUPS + sg) * 16; )==""\n"
R"==(float s_tail = LOAD_DATA_1x16(&src[sg_idx]); )==""\n"
R"==(float d_tail = fma(s_tail - v_mean_tail[sg], sqrt_variance_tail[sg], )==""\n"
R"==(sv_tail[sg]); )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(float s_add_tail = LOAD_DATA_1x16(&src_add[sg_idx]); )==""\n"
R"==(d_tail += s_add_tail; )==""\n"
R"==(#endif )==""\n"
R"==(int ws_tail = isgreater(d_tail, 0.0f); )==""\n"
R"==(d_tail = select(0.0f, d_tail, ws_tail); )==""\n"
R"==(#if IS_TRAINING )==""\n"
R"==(STORE_CHAR_1x16(&ws[sg_idx], convert_char(ws_tail)); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_RELU )==""\n"
R"==(d_tail = max(d_tail, 0.0f); )==""\n"
R"==(#endif )==""\n"
R"==(STORE_DATA_1x16(&dst[sg_idx], d_tail); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(src += IC; )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(src_add += IC; )==""\n"
R"==(#endif )==""\n"
R"==(dst += IC; )==""\n"
R"==(#if FUSE_BN_RELU && IS_TRAINING )==""\n"
R"==(ws += IC; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(inline float8 read_src_block(__global DATA_T *src, int c, int sp) { )==""\n"
R"==(float8 blockS0 = 0.0f; )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC; )==""\n"
R"==(const bool is_last_sp_block = sp >= SP - VECT_SIZE; )==""\n"
R"==(#endif )==""\n"
R"==(#if HAS_SP_TAIL )==""\n"
R"==(if (sp == SP_TAIL) { )==""\n"
R"==(for (int k = 0; k < SP - SP_TAIL; ++k) )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(if (k == SP - SP_TAIL - 1 && is_last_ic_block) )==""\n"
R"==(blockS0[k] = simd_id < 8 )==""\n"
R"==(? CONVERT_FLOAT_T(src[k * IC_BLOCK_STRIDE + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(else )==""\n"
R"==(#endif )==""\n"
R"==(blockS0[k] = LOAD_DATA_1x16(&src[k * IC_BLOCK_STRIDE]); )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(#if IS_IC_EQ_8 )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX_HALF(8, blockS0, src, 0); )==""\n"
R"==(float8 t0 = intel_sub_group_shuffle_down(blockS0, blockS0, 8); )==""\n"
R"==(for (int k = 0; k < 7; k += 2) )==""\n"
R"==(blockS0[k + 1] = t0[k]; )==""\n"
R"==(#elif HAS_IC_TAIL )==""\n"
R"==(if (is_last_ic_block && is_last_sp_block) { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(7, blockS0, src, 0); )==""\n"
R"==(blockS0[7] = simd_id < 8 ? CONVERT_FLOAT_T(src[7 * IC + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, blockS0, src, 0); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_IDX(8, blockS0, src, 0); )==""\n"
R"==(#endif  )==""\n"
R"==(#else )==""\n"
R"==(blockS0 = LOAD_DATA_8x16(&src[0]); )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(return blockS0; )==""\n"
R"==(} )==""\n"
R"==(KERNEL_ATTR )==""\n"
R"==(__kernel void gen9_bnorm_fwd(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global float *variance, __global DATA_T *dst, )==""\n"
R"==(__global float *scaleshift, __global float *shift, __global char *ws, )==""\n"
R"==(float eps, __global DATA_T *src_add) { )==""\n"
R"==(const int n = GWS_GET_MB(); )==""\n"
R"==(const int c = GWS_GET_IC(); )==""\n"
R"==(const int sp = GWS_GET_SP() * VECT_SIZE; )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC; )==""\n"
R"==(const bool is_last_sp_block = sp >= SP - VECT_SIZE; )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(const uint d_off = sp * IC + c; )==""\n"
R"==(#else )==""\n"
R"==(const uint d_off = (c & 15) + sp * 16 + (c & ~15) * SP + n * SP * IC; )==""\n"
R"==(#endif )==""\n"
R"==(src += d_off; )==""\n"
R"==(dst += d_off; )==""\n"
R"==(float8 blockS0 = read_src_block(src, c, sp); )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(src_add += d_off; )==""\n"
R"==(float8 block_S0_Add = read_src_block(src_add, c, sp); )==""\n"
R"==(#endif )==""\n"
R"==(float8 blockD0; )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(float sm = MAYBE_LAST_IC_LOAD_FLOAT_1x16(scaleshift, c); )==""\n"
R"==(#else )==""\n"
R"==(float sm = 1.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_SHIFT == 1 )==""\n"
R"==(float sv = MAYBE_LAST_IC_LOAD_FLOAT_1x16(shift, c); )==""\n"
R"==(#else )==""\n"
R"==(float sv = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(float v_mean, v_variance; )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(if (is_last_ic_block) { )==""\n"
R"==(v_mean = simd_id < 8 ? mean[c + simd_id] : 0.0f; )==""\n"
R"==(v_variance = simd_id < 8 ? variance[c + simd_id] : 0.0f; )==""\n"
R"==(} else )==""\n"
R"==(#endif )==""\n"
R"==({ )==""\n"
R"==(v_mean = LOAD_FLOAT_1x16(&mean[c]); )==""\n"
R"==(v_variance = LOAD_FLOAT_1x16(&variance[c]); )==""\n"
R"==(} )==""\n"
R"==(float sqrt_variance = sm / sqrt(v_variance + eps); )==""\n"
R"==(blockD0 = fma(blockS0 - (float8)v_mean, (float8)sqrt_variance, (float8)sv); )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(blockD0 += block_S0_Add; )==""\n"
R"==(#endif )==""\n"
R"==(int8 blockWS0 = isgreater(blockD0, (float8)0.0f); )==""\n"
R"==(blockD0 = select((float8)0.0f, blockD0, blockWS0); )==""\n"
R"==(#if IS_TRAINING )==""\n"
R"==(ws += d_off; )==""\n"
R"==(#if HAS_SP_TAIL )==""\n"
R"==(if (sp == SP_TAIL) { )==""\n"
R"==(for (int k = 0; k < SP - SP_TAIL; ++k) { )==""\n"
R"==(STORE_CHAR_1x16( )==""\n"
R"==(&ws[k * IC_BLOCK_STRIDE], convert_char(blockWS0[k])); )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(for (int k = 0; k < 8; ++k) )==""\n"
R"==(STORE_CHAR_1x16( )==""\n"
R"==(&ws[k * IC_BLOCK_STRIDE], convert_char(blockWS0[k])); )==""\n"
R"==(#else )==""\n"
R"==(STORE_CHAR_8x16(&ws[0], convert_char8(blockWS0)); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_RELU )==""\n"
R"==(blockD0 = max(blockD0, (VECT_FLOAT_T)0.0f); )==""\n"
R"==(#endif )==""\n"
R"==(#if HAS_SP_TAIL )==""\n"
R"==(if (sp == SP_TAIL) { )==""\n"
R"==(for (int k = 0; k < SP - SP_TAIL; ++k) { )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(if (is_last_ic_block) { )==""\n"
R"==(if (simd_id < 8) )==""\n"
R"==(dst[k * IC_BLOCK_STRIDE + simd_id] )==""\n"
R"==(= CONVERT_DATA_T(blockD0[k]); )==""\n"
R"==(} else )==""\n"
R"==(#endif )==""\n"
R"==(STORE_DATA_1x16(&dst[k * IC_BLOCK_STRIDE], blockD0[k]); )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(for (int k = 0; k < 8; ++k) )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(if (is_last_ic_block) { )==""\n"
R"==(if (simd_id < 8) )==""\n"
R"==(dst[k * IC_BLOCK_STRIDE + simd_id] )==""\n"
R"==(= CONVERT_DATA_T(blockD0[k]); )==""\n"
R"==(} else )==""\n"
R"==(#endif )==""\n"
R"==(STORE_DATA_1x16(&dst[k * IC_BLOCK_STRIDE], blockD0[k]); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DATA_8x16(&dst[0], blockD0); )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if IS_BWD == 1 )==""\n"
R"==(#define LOAD_DATA_Nx16_USING_LOOP(n, dest, src) \ )==""\n"
R"==({ \ )==""\n"
R"==(for (int k = 0; k < n; ++k) { \ )==""\n"
R"==(dest[k] = LOAD_DATA_1x16(&src[k * IC_BLOCK_STRIDE]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define LOAD_UINT_Nx16_USING_LOOP(n, dest, src) \ )==""\n"
R"==({ \ )==""\n"
R"==(for (int k = 0; k < n; ++k) { \ )==""\n"
R"==(dest[k] = LOAD_UINT_1x16(&src[k * IC_BLOCK_STRIDE]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define LOAD_CHAR_Nx16_USING_LOOP(n, dest, src) \ )==""\n"
R"==({ \ )==""\n"
R"==(for (int k = 0; k < n; ++k) { \ )==""\n"
R"==(dest[k] = LOAD_CHAR_1x16(&src[k * IC_BLOCK_STRIDE]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define LOAD_DATA_8x16_USING_LAYOUT(dest, src) \ )==""\n"
R"==({ \ )==""\n"
R"==(if (USE_NHWC) { \ )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, dest, src); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(dest = LOAD_DATA_8x16(src); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define LOAD_UINT_8x16_USING_LAYOUT(dest, src) \ )==""\n"
R"==({ \ )==""\n"
R"==(if (USE_NHWC) { \ )==""\n"
R"==(LOAD_UINT_Nx16_USING_LOOP(8, dest, src); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(dest = LOAD_UINT_8x16(src); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define LOAD_CHAR_8x16_USING_LAYOUT(dest, src) \ )==""\n"
R"==({ \ )==""\n"
R"==(if (USE_NHWC) { \ )==""\n"
R"==(LOAD_CHAR_Nx16_USING_LOOP(8, dest, src); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(dest = LOAD_CHAR_8x16(src); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define LOAD_DATA_Nx16_USING_LOOP_HALF(n, dest, src) \ )==""\n"
R"==({ \ )==""\n"
R"==(for (int k = 0; k < n; k += 2) { \ )==""\n"
R"==(dest[k] = LOAD_DATA_1x16(&src[k * IC_BLOCK_STRIDE]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(#if VECT_SIZE > 1 )==""\n"
R"==(#define GET_SCALAR_VAL(v, idx) v[idx / VECT_SIZE][idx % VECT_SIZE] )==""\n"
R"==(#else )==""\n"
R"==(#define GET_SCALAR_VAL(v, idx) v[idx] )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(#define GET_SCALAR_VAL(v, idx) v[idx] )==""\n"
R"==(#endif )==""\n"
R"==(void gen9_calc_fused_reduction(volatile __global atomic_float *diff_scale, )==""\n"
R"==(volatile __global atomic_float *diff_shift, int dst_offset, )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(VECT_FLOAT_T *diff_gamma, VECT_FLOAT_T *diff_beta, )==""\n"
R"==(#else )==""\n"
R"==(float *diff_gamma, float *diff_beta, )==""\n"
R"==(#endif )==""\n"
R"==(float *diff_gamma_tail, float *diff_beta_tail, )==""\n"
R"==(__local float *local_gamma, __local float *local_beta) { )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const int group_size = GWS_LWS1_CALC * GWS_LWS2_CALC; )==""\n"
R"==(const int sg_group_id = get_local_id(0) / 16; )==""\n"
R"==(const int local_id = get_local_id(1); )==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) { )==""\n"
R"==(const int slm_offset = CALC_SLM_LINE_SIZE * local_id )==""\n"
R"==(+ REDUCE_NUM_SGROUPS * 16 * sg_group_id + sg * 16 + simd_id; )==""\n"
R"==(#if HAS_IC_VECT_TAIL && NHWC_OPTIMIZED )==""\n"
R"==(if (sg >= IC_VECT_SGROUPS) { )==""\n"
R"==(local_gamma[slm_offset] = diff_gamma_tail[sg - IC_VECT_SGROUPS]; )==""\n"
R"==(local_beta[slm_offset] = diff_beta_tail[sg - IC_VECT_SGROUPS]; )==""\n"
R"==(} else )==""\n"
R"==(#endif )==""\n"
R"==({ )==""\n"
R"==(local_gamma[slm_offset] = GET_SCALAR_VAL(diff_gamma, sg); )==""\n"
R"==(local_beta[slm_offset] = GET_SCALAR_VAL(diff_beta, sg); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(if (local_id == 0) { )==""\n"
R"==(for (int sg = 0; sg < REDUCE_NUM_SGROUPS; ++sg) { )==""\n"
R"==(float d_gamma = 0.f; )==""\n"
R"==(float d_beta = 0.f; )==""\n"
R"==(for (int gr_id = 0; gr_id < group_size; ++gr_id) { )==""\n"
R"==(const int off_local = CALC_SLM_LINE_SIZE * gr_id )==""\n"
R"==(+ REDUCE_NUM_SGROUPS * 16 * sg_group_id + sg * 16 )==""\n"
R"==(+ simd_id; )==""\n"
R"==(d_gamma += local_gamma[off_local]; )==""\n"
R"==(d_beta += local_beta[off_local]; )==""\n"
R"==(} )==""\n"
R"==(const int offset = dst_offset + sg * 16 + simd_id; )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(if (offset < IC) )==""\n"
R"==(#endif )==""\n"
R"==({ )==""\n"
R"==(atomic_add_global(&diff_scale[offset], d_gamma); )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(atomic_add_global(&diff_shift[offset], d_beta); )==""\n"
R"==(#else )==""\n"
R"==(atomic_add_global( )==""\n"
R"==(&diff_shift[IC + IC * REDUCE_STAT_NBLOCKS + offset], )==""\n"
R"==(d_beta); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void gen9_calculate_stats(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global DATA_T *diff_dst, __global char *ws, )==""\n"
R"==(__global float *temp_reduce, volatile __global atomic_float *diff_scale, )==""\n"
R"==(volatile __global atomic_float *diff_shift) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP(); )==""\n"
R"==(const int ic_block_offset = (c / 16) * IC_BLOCK; )==""\n"
R"==(const int offset = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(mean += ic_block_offset; )==""\n"
R"==(src += offset; )==""\n"
R"==(diff_dst += offset; )==""\n"
R"==(ws += offset; )==""\n"
R"==(float v_mean[IC_BLOCK_SGROUPS]; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) { )==""\n"
R"==(v_mean[sg] = as_float(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(&mean[(sg * 16)]))); )==""\n"
R"==(} )==""\n"
R"==(VECT_FLOAT_T diff_gamma[IC_BLOCK_SGROUPS / VECT_SIZE] = {0.0f}; )==""\n"
R"==(VECT_FLOAT_T diff_beta[IC_BLOCK_SGROUPS / VECT_SIZE] = {0.0f}; )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(float diff_gamma_tail[IC_TAIL_SGROUPS] = {0.0f}; )==""\n"
R"==(float diff_beta_tail[IC_TAIL_SGROUPS] = {0.0f}; )==""\n"
R"==(#else )==""\n"
R"==(float *diff_gamma_tail = NULL; )==""\n"
R"==(float *diff_beta_tail = NULL; )==""\n"
R"==(#endif )==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; ++sp) { )==""\n"
R"==(if (sp_block_idx * STAT_SP_BLOCK + sp >= SP) break; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) { )==""\n"
R"==(const int sg_idx = sg * 16 * VECT_SIZE; )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(VECT_CHAR_T ws_vect = LOAD_VECT_CHAR(&ws[sg_idx]); )==""\n"
R"==(#endif )==""\n"
R"==(VECT_FLOAT_T src_vect = LOAD_VECT_DATA(&src[sg_idx]); )==""\n"
R"==(VECT_FLOAT_T dd_vect = LOAD_VECT_DATA(&diff_dst[sg_idx]); )==""\n"
R"==(VECT_FLOAT_T v0; )==""\n"
R"==(for (int vect = 0; vect < VECT_SIZE; ++vect) { )==""\n"
R"==(int sg_idx = sg * VECT_SIZE + vect; )==""\n"
R"==(#if VECT_SIZE > 1 )==""\n"
R"==(v0[vect] = src_vect[vect] - v_mean[sg_idx]; )==""\n"
R"==(#else )==""\n"
R"==(v0 = src_vect - v_mean[sg_idx]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(dd_vect = select( )==""\n"
R"==((VECT_FLOAT_T)0.0f, dd_vect, CONVERT_VECT_INT_T(ws_vect)); )==""\n"
R"==(#endif )==""\n"
R"==(diff_gamma[sg] = fma(v0, dd_vect, diff_gamma[sg]); )==""\n"
R"==(diff_beta[sg] += dd_vect; )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) { )==""\n"
R"==(const int sg_idx = IC_VECT_SGROUPS + sg; )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(char ws_tail = LOAD_CHAR_1x16(&ws[sg_idx * 16]); )==""\n"
R"==(#endif )==""\n"
R"==(float src_tail = LOAD_DATA_1x16(&src[sg_idx * 16]); )==""\n"
R"==(float dd_tail = LOAD_DATA_1x16(&diff_dst[sg_idx * 16]); )==""\n"
R"==(float v0 = src_tail - v_mean[sg_idx]; )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(dd_tail = select(0.0f, dd_tail, convert_int(ws_tail)); )==""\n"
R"==(#endif )==""\n"
R"==(diff_gamma_tail[sg] = fma(v0, dd_tail, diff_gamma_tail[sg]); )==""\n"
R"==(diff_beta_tail[sg] += dd_tail; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(src += IC; )==""\n"
R"==(diff_dst += IC; )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(ws += IC; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(__local float local_gamma[2 * CALC_SLM_SIZE]; )==""\n"
R"==(__local float *local_beta = local_gamma + CALC_SLM_SIZE; )==""\n"
R"==(gen9_calc_fused_reduction(diff_scale, diff_shift, ic_block_offset, )==""\n"
R"==(diff_gamma, diff_beta, diff_gamma_tail, diff_beta_tail, local_gamma, )==""\n"
R"==(local_beta); )==""\n"
R"==(#else )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS; ++sg) { )==""\n"
R"==(const int reduce_off = sp_block_idx * 16 )==""\n"
R"==(+ REDUCE_STAT_NBLOCKS * 16 )==""\n"
R"==(* (sg + (int)(c / 16) * (IC_BLOCK / 16)); )==""\n"
R"==(const int diff_gamma_offset = IC16 + reduce_off; )==""\n"
R"==(const int diff_beta_offset )==""\n"
R"==(= 2 * IC16 + REDUCE_STAT_NBLOCKS * IC16 + reduce_off; )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(if (sg >= IC_VECT_SGROUPS) { )==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_gamma_offset], )==""\n"
R"==(diff_gamma_tail[sg - IC_VECT_SGROUPS]); )==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_beta_offset], )==""\n"
R"==(diff_beta_tail[sg - IC_VECT_SGROUPS]); )==""\n"
R"==(} else )==""\n"
R"==(#endif )==""\n"
R"==({ )==""\n"
R"==(#if VECT_SIZE > 1 )==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_gamma_offset], )==""\n"
R"==(diff_gamma[sg / VECT_SIZE][sg % VECT_SIZE]); )==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_beta_offset], )==""\n"
R"==(diff_beta[sg / VECT_SIZE][sg % VECT_SIZE]); )==""\n"
R"==(#else )==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_gamma_offset], diff_gamma[sg]); )==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[diff_beta_offset], diff_beta[sg]); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void gen9_calculate_stats(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global DATA_T *diff_dst, __global char *ws, )==""\n"
R"==(__global float *temp_reduce, volatile __global atomic_float *diff_scale, )==""\n"
R"==(volatile __global atomic_float *diff_shift) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_block_idx = GWS_GET_STAT_SP(); )==""\n"
R"==(const int mb_sp_idx = mb * STAT_SP_NBLOCKS + sp_block_idx; )==""\n"
R"==(const int group_c_offset = REDUCE_STAT_NBLOCKS * 16 * (int)(c / 16); )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC; )==""\n"
R"==(const bool is_last_sp_block = (sp_block_idx == STAT_SP_NBLOCKS - 1); )==""\n"
R"==(#endif )==""\n"
R"==(temp_reduce += group_c_offset; )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(const int offset = c + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(#else )==""\n"
R"==(const int offset = (c & 15) + sp_block_idx * STAT_SP_BLOCK * 16 )==""\n"
R"==(+ (c & ~15) * SP + mb * SP * IC; )==""\n"
R"==(#endif )==""\n"
R"==(src += offset; )==""\n"
R"==(diff_dst += offset; )==""\n"
R"==(ws += offset; )==""\n"
R"==(float v_mean = MAYBE_LAST_IC_LOAD_FLOAT_1x16(mean, c); )==""\n"
R"==(float8 diff_gamma = 0.0f; )==""\n"
R"==(float8 diff_beta = 0.0f; )==""\n"
R"==(#if HAS_STAT_SP_TAIL )==""\n"
R"==(int sp; )==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) { )==""\n"
R"==(sp = SP - STAT_SP_TAIL * STAT_SP_BLOCK; )==""\n"
R"==(} else { )==""\n"
R"==(sp = STAT_SP_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(int sp = STAT_SP_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(const int C_PARALLEL_FACTOR = 8; )==""\n"
R"==(for (; sp > C_PARALLEL_FACTOR - 1; sp -= C_PARALLEL_FACTOR) { )==""\n"
R"==(float8 src_data; )==""\n"
R"==(float8 dd_data; )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(char8 ws_data; )==""\n"
R"==(LOAD_CHAR_8x16_USING_LAYOUT(ws_data, ws); )==""\n"
R"==(#endif  )==""\n"
R"==(#if IS_IC_EQ_8 )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_HALF(8, src_data, src); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_HALF(8, dd_data, diff_dst); )==""\n"
R"==(float8 t_src = intel_sub_group_shuffle_down(src_data, src_data, 8); )==""\n"
R"==(float8 t_dd = intel_sub_group_shuffle_down(dd_data, dd_data, 8); )==""\n"
R"==(for (int k = 0; k < 7; k += 2) { )==""\n"
R"==(dd_data[k + 1] = t_dd[k]; )==""\n"
R"==(src_data[k + 1] = t_src[k]; )==""\n"
R"==(} )==""\n"
R"==(#elif HAS_IC_TAIL )==""\n"
R"==(const bool is_last_sp = sp - C_PARALLEL_FACTOR <= C_PARALLEL_FACTOR - 1; )==""\n"
R"==(if (is_last_sp && is_last_ic_block && is_last_sp_block) { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(7, src_data, src); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(7, dd_data, diff_dst); )==""\n"
R"==(dd_data[7] = simd_id < 8 )==""\n"
R"==(? CONVERT_FLOAT_T(diff_dst[7 * IC_BLOCK_STRIDE + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(src_data[7] = simd_id < 8 )==""\n"
R"==(? CONVERT_FLOAT_T(src[7 * IC_BLOCK_STRIDE + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, src_data, src); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, dd_data, diff_dst); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(LOAD_DATA_8x16_USING_LAYOUT(src_data, src); )==""\n"
R"==(LOAD_DATA_8x16_USING_LAYOUT(dd_data, diff_dst); )==""\n"
R"==(#endif )==""\n"
R"==(src += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE; )==""\n"
R"==(diff_dst += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE; )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(ws += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE; )==""\n"
R"==(#endif  )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(const float8 C_ZERO = 0.0; )==""\n"
R"==(dd_data = select(C_ZERO, dd_data, convert_int8(ws_data)); )==""\n"
R"==(#endif  )==""\n"
R"==(const float8 v0 = src_data - v_mean; )==""\n"
R"==(diff_gamma = fma(v0, dd_data, diff_gamma); )==""\n"
R"==(diff_beta += dd_data; )==""\n"
R"==(} )==""\n"
R"==(#if HAS_STAT_SP_TAIL )==""\n"
R"==(if (sp_block_idx == STAT_SP_TAIL) { )==""\n"
R"==(sp = (SP - STAT_SP_TAIL * STAT_SP_BLOCK) % C_PARALLEL_FACTOR; )==""\n"
R"==(while (sp-- >= 1) { )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(const char ws_data = LOAD_CHAR_1x16(&ws[0]); )==""\n"
R"==(#else )==""\n"
R"==(const char ws_data = 1; )==""\n"
R"==(#endif  )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(float src_data, dd_data; )==""\n"
R"==(if (sp == 0 && is_last_ic_block) { )==""\n"
R"==(src_data = simd_id < 8 ? CONVERT_FLOAT_T(src[simd_id]) : 0.0f; )==""\n"
R"==(dd_data = simd_id < 8 ? CONVERT_FLOAT_T(diff_dst[simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(src_data = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(dd_data = LOAD_DATA_1x16(&diff_dst[0]); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(const float src_data = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(const float dd_data = LOAD_DATA_1x16(&diff_dst[0]); )==""\n"
R"==(#endif )==""\n"
R"==(src += IC_BLOCK_STRIDE; )==""\n"
R"==(diff_dst += IC_BLOCK_STRIDE; )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(ws += IC_BLOCK_STRIDE; )==""\n"
R"==(#endif  )==""\n"
R"==(if (ws_data != 0) { )==""\n"
R"==(const float v0 = src_data - v_mean; )==""\n"
R"==(const float diff_gamma_tmp = fma(v0, dd_data, diff_gamma[0]); )==""\n"
R"==(diff_gamma[0] = diff_gamma_tmp; )==""\n"
R"==(diff_beta[0] += dd_data; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(for (int i = 1; i < 8; i++) { )==""\n"
R"==(diff_gamma[0] += diff_gamma[i]; )==""\n"
R"==(diff_beta[0] += diff_beta[i]; )==""\n"
R"==(} )==""\n"
R"==(#if FUSED_ATOMICS_REDUCTION )==""\n"
R"==(__local float local_gamma[2 * CALC_SLM_SIZE]; )==""\n"
R"==(__local float *local_beta = local_gamma + CALC_SLM_SIZE; )==""\n"
R"==(gen9_calc_fused_reduction(diff_scale, diff_shift, c, &diff_gamma, )==""\n"
R"==(&diff_beta, NULL, NULL, local_gamma, local_beta); )==""\n"
R"==(#else )==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[IC16 + mb_sp_idx * 16], diff_gamma[0]); )==""\n"
R"==(STORE_FLOAT_1x16(&temp_reduce[2 * IC16 + REDUCE_STAT_NBLOCKS * IC16 )==""\n"
R"==(+ mb_sp_idx * 16], )==""\n"
R"==(diff_beta[0]); )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE) )==""\n"
R"==(__kernel void gen9_reduce_stats(__global float *temp_reduce, )==""\n"
R"==(__global float *diff_scale, __global float *diff_shift, )==""\n"
R"==(__global float *variance, float eps) { )==""\n"
R"==(__local float local_gamma[16 * REDUCE_IC_SUB_GROUPS]; )==""\n"
R"==(__local float local_beta[16 * REDUCE_IC_SUB_GROUPS]; )==""\n"
R"==(const int ic_sub_group = get_global_id(0) / 16; )==""\n"
R"==(const int group_c = get_global_id(1); )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const int c = group_c * 16 + simd_id; )==""\n"
R"==(float diff_gamma = 0.0f; )==""\n"
R"==(float diff_beta = 0.0f; )==""\n"
R"==(temp_reduce += IC16 + REDUCE_STAT_NBLOCKS * 16 * group_c )==""\n"
R"==(+ REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS * 16 * ic_sub_group )==""\n"
R"==(+ simd_id; )==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) { )==""\n"
R"==(diff_gamma += temp_reduce[i * 16]; )==""\n"
R"==(} )==""\n"
R"==(temp_reduce += IC16 + IC16 * REDUCE_STAT_NBLOCKS; )==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS / REDUCE_IC_SUB_GROUPS; i++) { )==""\n"
R"==(diff_beta += temp_reduce[i * 16]; )==""\n"
R"==(} )==""\n"
R"==(if (ic_sub_group > 0) { )==""\n"
R"==(local_gamma[ic_sub_group * 16 + simd_id] = diff_gamma; )==""\n"
R"==(local_beta[ic_sub_group * 16 + simd_id] = diff_beta; )==""\n"
R"==(} )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(if (ic_sub_group == 0) { )==""\n"
R"==(for (int i = 1; i < REDUCE_IC_SUB_GROUPS; i++) { )==""\n"
R"==(diff_gamma += local_gamma[i * 16 + simd_id]; )==""\n"
R"==(diff_beta += local_beta[i * 16 + simd_id]; )==""\n"
R"==(} )==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(variance[c] + eps); )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const bool is_last_ic_block = group_c * 16 + 16 > IC; )==""\n"
R"==(if (!is_last_ic_block || (is_last_ic_block && simd_id < 8)) )==""\n"
R"==(#endif )==""\n"
R"==({ )==""\n"
R"==(diff_scale[c] = diff_gamma * sqrt_variance; )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(diff_shift[c] = diff_beta; )==""\n"
R"==(#else )==""\n"
R"==(diff_shift[IC + IC * REDUCE_STAT_NBLOCKS + c] = diff_beta; )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(NAMED_KERNEL_ATTR(AUX) )==""\n"
R"==(__kernel void gen9_fused_reduce_final( )==""\n"
R"==(__global float *diff_scale, __global float *variance, float eps) { )==""\n"
R"==(const int c = GWS_GET_IC_AUX(); )==""\n"
R"==(diff_scale[c] *= 1.0f / sqrt(variance[c] + eps); )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#if NHWC_OPTIMIZED )==""\n"
R"==(KERNEL_ATTR )==""\n"
R"==(__kernel void gen9_bnorm_bwd(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst, )==""\n"
R"==(__global float *scaleshift, __global char *ws, )==""\n"
R"==(__global DATA_T *diff_src, __global float *diff_scale, )==""\n"
R"==(__global float *diff_shift, float eps, __global DATA_T *diff_src_add) { )==""\n"
R"==(const int c = GWS_GET_IC(); )==""\n"
R"==(const int ic_block_offset = (c / 16) * IC_BLOCK; )==""\n"
R"==(variance += ic_block_offset; )==""\n"
R"==(mean += ic_block_offset; )==""\n"
R"==(diff_scale += ic_block_offset; )==""\n"
R"==(diff_shift += ic_block_offset; )==""\n"
R"==(scaleshift += ic_block_offset; )==""\n"
R"==(VECT_FLOAT_T v_variance[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(v_mean[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(diff_gamma[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(diff_beta[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(sqrt_variance[IC_BLOCK_SGROUPS / VECT_SIZE], )==""\n"
R"==(gamma[IC_BLOCK_SGROUPS / VECT_SIZE]; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) { )==""\n"
R"==(const int sg_idx = sg * 16 * VECT_SIZE; )==""\n"
R"==(v_variance[sg] = LOAD_VECT_FLOAT(&variance[sg_idx]); )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(v_mean[sg] = LOAD_VECT_FLOAT(&mean[sg_idx]); )==""\n"
R"==(diff_gamma[sg] = LOAD_VECT_FLOAT(&diff_scale[sg_idx]); )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(diff_beta[sg] = LOAD_VECT_FLOAT(&diff_shift[sg_idx]); )==""\n"
R"==(#else )==""\n"
R"==(diff_beta[sg] = LOAD_VECT_FLOAT( )==""\n"
R"==(&diff_shift[IC + REDUCE_STAT_NBLOCKS * IC + sg_idx]); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(gamma[sg] = LOAD_VECT_FLOAT(&scaleshift[sg_idx]); )==""\n"
R"==(#else )==""\n"
R"==(gamma[sg] = (VECT_FLOAT_T)1.0f; )==""\n"
R"==(#endif )==""\n"
R"==(sqrt_variance[sg] )==""\n"
R"==(= (VECT_FLOAT_T)1.0f / sqrt(v_variance[sg] + (VECT_FLOAT_T)eps); )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(float v_variance_tail[IC_TAIL_SGROUPS], v_mean_tail[IC_TAIL_SGROUPS], )==""\n"
R"==(diff_gamma_tail[IC_TAIL_SGROUPS], diff_beta_tail[IC_TAIL_SGROUPS], )==""\n"
R"==(sqrt_variance_tail[IC_TAIL_SGROUPS], gamma_tail[IC_TAIL_SGROUPS]; )==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) { )==""\n"
R"==(const int sg_idx = (IC_VECT_SGROUPS + sg) * 16; )==""\n"
R"==(v_variance_tail[sg] = LOAD_FLOAT_1x16(&variance[sg_idx]); )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(v_mean_tail[sg] = LOAD_FLOAT_1x16(&mean[sg_idx]); )==""\n"
R"==(diff_gamma_tail[sg] = LOAD_FLOAT_1x16(&diff_scale[sg_idx]); )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(diff_beta_tail[sg] = LOAD_FLOAT_1x16(&diff_shift[sg_idx]); )==""\n"
R"==(#else )==""\n"
R"==(diff_beta_tail[sg] = LOAD_FLOAT_1x16( )==""\n"
R"==(&diff_shift[IC + REDUCE_STAT_NBLOCKS * IC + sg_idx]); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(gamma_tail[sg] = LOAD_FLOAT_1x16(&scaleshift[sg_idx]); )==""\n"
R"==(#else )==""\n"
R"==(gamma_tail[sg] = 1.0f; )==""\n"
R"==(#endif )==""\n"
R"==(sqrt_variance_tail[sg] = 1.0f / sqrt(v_variance_tail[sg] + eps); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(const int sp_block_idx = GWS_GET_SP(); )==""\n"
R"==(const int offset = ic_block_offset + sp_block_idx * STAT_SP_BLOCK * IC; )==""\n"
R"==(src += offset; )==""\n"
R"==(diff_dst += offset; )==""\n"
R"==(ws += offset; )==""\n"
R"==(diff_src += offset; )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(diff_src_add += offset; )==""\n"
R"==(#endif )==""\n"
R"==(for (int sp = 0; sp < STAT_SP_BLOCK; sp++) { )==""\n"
R"==(if (sp_block_idx * STAT_SP_BLOCK + sp >= SP) break; )==""\n"
R"==(for (int sg = 0; sg < IC_BLOCK_SGROUPS / VECT_SIZE; ++sg) { )==""\n"
R"==(const int sg_idx = sg * 16 * VECT_SIZE; )==""\n"
R"==(VECT_FLOAT_T src_vect = LOAD_VECT_DATA(&src[sg_idx]); )==""\n"
R"==(VECT_FLOAT_T dd_vect = LOAD_VECT_DATA(&diff_dst[sg_idx]); )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(VECT_CHAR_T ws_vect = LOAD_VECT_CHAR(&ws[sg_idx]); )==""\n"
R"==(dd_vect = select( )==""\n"
R"==((VECT_FLOAT_T)0.0f, dd_vect, CONVERT_VECT_INT_T(ws_vect)); )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(STORE_VECT_DATA(&diff_src_add[sg_idx], dd_vect); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(dd_vect -= (diff_beta[sg] )==""\n"
R"==(+ (src_vect - v_mean[sg]) * diff_gamma[sg] )==""\n"
R"==(* sqrt_variance[sg]) )==""\n"
R"==(/ (MB * ID * IH * IW); )==""\n"
R"==(#endif  )==""\n"
R"==(dd_vect *= gamma[sg] * sqrt_variance[sg]; )==""\n"
R"==(STORE_VECT_DATA(&diff_src[sg_idx], dd_vect); )==""\n"
R"==(} )==""\n"
R"==(#if HAS_IC_VECT_TAIL )==""\n"
R"==(for (int sg = 0; sg < IC_TAIL_SGROUPS; ++sg) { )==""\n"
R"==(const int sg_idx = (IC_VECT_SGROUPS + sg) * 16; )==""\n"
R"==(float src_tail = LOAD_DATA_1x16(&src[sg_idx]); )==""\n"
R"==(float dd_tail = LOAD_DATA_1x16(&diff_dst[sg_idx]); )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(char ws_tail = LOAD_CHAR_1x16(&ws[sg_idx]); )==""\n"
R"==(dd_tail = select(0.0f, dd_tail, convert_int(ws_tail)); )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(STORE_DATA_1x16(&diff_src_add[sg_idx], dd_tail); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(dd_tail -= (diff_beta_tail[sg] )==""\n"
R"==(+ (src_tail - v_mean_tail[sg]) )==""\n"
R"==(* diff_gamma_tail[sg] )==""\n"
R"==(* sqrt_variance_tail[sg]) )==""\n"
R"==(/ (MB * ID * IH * IW); )==""\n"
R"==(#endif  )==""\n"
R"==(dd_tail *= gamma_tail[sg] * sqrt_variance_tail[sg]; )==""\n"
R"==(STORE_DATA_1x16(&diff_src[sg_idx], dd_tail); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(src += IC; )==""\n"
R"==(diff_dst += IC; )==""\n"
R"==(diff_src += IC; )==""\n"
R"==(#if FUSE_BN_RELU )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(diff_src_add += IC; )==""\n"
R"==(#endif )==""\n"
R"==(ws += IC; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(inline void write_8x16_block(__global DATA_T *ptr, int c, float8 val) { )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC; )==""\n"
R"==(if (is_last_ic_block) { )==""\n"
R"==(if (simd_id < 8) { )==""\n"
R"==(for (int k = 0; k < 8; ++k) )==""\n"
R"==(ptr[k * IC_BLOCK_STRIDE + simd_id] = CONVERT_DATA_T(val[k]); )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==(for (int k = 0; k < 8; ++k) )==""\n"
R"==(STORE_DATA_1x16(&ptr[k * IC_BLOCK_STRIDE], val[k]); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DATA_8x16(&ptr[0], val); )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(inline void write_1x16_block(__global DATA_T *ptr, int c, float val) { )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC; )==""\n"
R"==(if (!is_last_ic_block) { )==""\n"
R"==(STORE_DATA_1x16(&ptr[0], val); )==""\n"
R"==(} else { )==""\n"
R"==(if (simd_id < 8) { ptr[simd_id] = CONVERT_DATA_T(val); } )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(STORE_DATA_1x16(&ptr[0], val); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(KERNEL_ATTR )==""\n"
R"==(__kernel void gen9_bnorm_bwd(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst, )==""\n"
R"==(__global float *scaleshift, __global char *ws, )==""\n"
R"==(__global DATA_T *diff_src, __global float *diff_scale, )==""\n"
R"==(__global float *diff_shift, float eps, __global DATA_T *diff_src_add) { )==""\n"
R"==(const int c = GWS_GET_IC(); )==""\n"
R"==(const int simd_id = get_sub_group_local_id(); )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const bool is_last_ic_block = c + 16 > IC; )==""\n"
R"==(#endif )==""\n"
R"==(const float v_variance = MAYBE_LAST_IC_LOAD_FLOAT_1x16(variance, c); )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(const float v_mean = MAYBE_LAST_IC_LOAD_FLOAT_1x16(mean, c); )==""\n"
R"==(const float diff_gamma = MAYBE_LAST_IC_LOAD_FLOAT_1x16(diff_scale, c); )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(const float diff_beta = MAYBE_LAST_IC_LOAD_FLOAT_1x16(diff_shift, c); )==""\n"
R"==(#else )==""\n"
R"==(const float diff_beta = MAYBE_LAST_IC_LOAD_FLOAT_1x16( )==""\n"
R"==(diff_shift, IC + REDUCE_STAT_NBLOCKS * IC + c); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(const float gamma = MAYBE_LAST_IC_LOAD_FLOAT_1x16(scaleshift, c); )==""\n"
R"==(#else )==""\n"
R"==(const float gamma = 1; )==""\n"
R"==(#endif  )==""\n"
R"==(const int sp_block_idx = GWS_GET_SP(); )==""\n"
R"==(#if USE_NHWC )==""\n"
R"==(const int offset = c + sp_block_idx * VECT_SIZE * IC; )==""\n"
R"==(#else )==""\n"
R"==(const int mb = GWS_GET_MB(); )==""\n"
R"==(const int offset = (c & 15) + sp_block_idx * VECT_SIZE * 16 + (c & ~15) * SP )==""\n"
R"==(+ mb * SP * IC; )==""\n"
R"==(#endif )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(const bool is_last_sp_block = sp_block_idx == SP / VECT_SIZE - 1; )==""\n"
R"==(#endif )==""\n"
R"==(src += offset; )==""\n"
R"==(diff_dst += offset; )==""\n"
R"==(ws += offset; )==""\n"
R"==(diff_src += offset; )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(diff_src_add += offset; )==""\n"
R"==(#endif )==""\n"
R"==(#if HAS_SP_TAIL )==""\n"
R"==(int sp; )==""\n"
R"==(if (sp_block_idx == SP_TAIL / VECT_SIZE) { )==""\n"
R"==(sp = SP - SP_TAIL; )==""\n"
R"==(} else { )==""\n"
R"==(sp = VECT_SIZE; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(int sp = VECT_SIZE; )==""\n"
R"==(#endif )==""\n"
R"==(const float sqrt_variance = 1.0f / sqrt(v_variance + eps); )==""\n"
R"==(const int C_PARALLEL_FACTOR = 8; )==""\n"
R"==(for (; sp > C_PARALLEL_FACTOR - 1; sp -= C_PARALLEL_FACTOR) { )==""\n"
R"==(float8 src_data; )==""\n"
R"==(float8 dd_data; )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(char8 ws_data; )==""\n"
R"==(LOAD_CHAR_8x16_USING_LAYOUT(ws_data, ws); )==""\n"
R"==(#endif  )==""\n"
R"==(#if IS_IC_EQ_8 )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_HALF(8, src_data, src); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP_HALF(8, dd_data, diff_dst); )==""\n"
R"==(float8 t_dd = intel_sub_group_shuffle_down(dd_data, dd_data, 8); )==""\n"
R"==(float8 t_src = intel_sub_group_shuffle_down(src_data, src_data, 8); )==""\n"
R"==(for (int k = 0; k < 7; k += 2) { )==""\n"
R"==(dd_data[k + 1] = t_dd[k]; )==""\n"
R"==(src_data[k + 1] = t_src[k]; )==""\n"
R"==(} )==""\n"
R"==(#elif HAS_IC_TAIL && !HAS_SP_TAIL )==""\n"
R"==(const bool is_last_sp = sp - C_PARALLEL_FACTOR <= C_PARALLEL_FACTOR - 1; )==""\n"
R"==(if (is_last_sp && is_last_ic_block && is_last_sp_block) { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(7, src_data, src); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(7, dd_data, diff_dst); )==""\n"
R"==(dd_data[7] = simd_id < 8 )==""\n"
R"==(? CONVERT_FLOAT_T(diff_dst[7 * IC_BLOCK_STRIDE + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(src_data[7] = simd_id < 8 )==""\n"
R"==(? CONVERT_FLOAT_T(src[7 * IC_BLOCK_STRIDE + simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, src_data, src); )==""\n"
R"==(LOAD_DATA_Nx16_USING_LOOP(8, dd_data, diff_dst); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(LOAD_DATA_8x16_USING_LAYOUT(dd_data, diff_dst); )==""\n"
R"==(LOAD_DATA_8x16_USING_LAYOUT(src_data, src); )==""\n"
R"==(#endif  )==""\n"
R"==(src += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE; )==""\n"
R"==(diff_dst += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE; )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(ws += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE; )==""\n"
R"==(#endif  )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(const float8 C_ZERO = 0.0; )==""\n"
R"==(dd_data = select(C_ZERO, dd_data, convert_int8(ws_data)); )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(write_8x16_block(diff_src_add, c, dd_data); )==""\n"
R"==(#endif )==""\n"
R"==(#endif  )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(dd_data -= (diff_beta )==""\n"
R"==(+ (src_data - v_mean) * diff_gamma * sqrt_variance) )==""\n"
R"==(/ (MB * ID * IH * IW); )==""\n"
R"==(#endif  )==""\n"
R"==(dd_data *= gamma * sqrt_variance; )==""\n"
R"==(write_8x16_block(diff_src, c, dd_data); )==""\n"
R"==(diff_src += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE; )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(diff_src_add += C_PARALLEL_FACTOR * IC_BLOCK_STRIDE; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if HAS_SP_TAIL )==""\n"
R"==(if (sp_block_idx == SP_TAIL / VECT_SIZE) { )==""\n"
R"==(sp = (SP - SP_TAIL) % C_PARALLEL_FACTOR; )==""\n"
R"==(while (sp-- >= 1) { )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(const char ws_data = LOAD_CHAR_1x16(&ws[0]); )==""\n"
R"==(#endif  )==""\n"
R"==(#if HAS_IC_TAIL )==""\n"
R"==(float dd_data; )==""\n"
R"==(if (sp == 0 && is_last_ic_block) )==""\n"
R"==(dd_data = simd_id < 8 ? CONVERT_FLOAT_T(diff_dst[simd_id]) )==""\n"
R"==(: 0.0f; )==""\n"
R"==(else )==""\n"
R"==(dd_data = LOAD_DATA_1x16(&diff_dst[0]); )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(float src_data; )==""\n"
R"==(if (sp == 0 && is_last_ic_block) )==""\n"
R"==(src_data = simd_id < 8 ? CONVERT_FLOAT_T(src[simd_id]) : 0.0f; )==""\n"
R"==(else )==""\n"
R"==(src_data = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(#endif  )==""\n"
R"==(#else )==""\n"
R"==(float dd_data = LOAD_DATA_1x16(&diff_dst[0]); )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(const float src_data = LOAD_DATA_1x16(&src[0]); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(src += IC_BLOCK_STRIDE; )==""\n"
R"==(diff_dst += IC_BLOCK_STRIDE; )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(ws += IC_BLOCK_STRIDE; )==""\n"
R"==(#endif  )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(if (ws_data == 0) dd_data = 0; )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(write_1x16_block(diff_src_add, c, dd_data); )==""\n"
R"==(#endif )==""\n"
R"==(#endif  )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(dd_data -= (diff_beta )==""\n"
R"==(+ (src_data - v_mean) * diff_gamma )==""\n"
R"==(* sqrt_variance) )==""\n"
R"==(/ (MB * ID * IH * IW); )==""\n"
R"==(#endif  )==""\n"
R"==(dd_data *= gamma * sqrt_variance; )==""\n"
R"==(write_1x16_block(diff_src, c, dd_data); )==""\n"
R"==(diff_src += IC_BLOCK_STRIDE; )==""\n"
R"==(#if FUSE_BN_ADD_RELU )==""\n"
R"==(diff_src_add += IC_BLOCK_STRIDE; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==()==";
}
}
}
}