namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_bwd_data_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if ID > 1 )==""\n"
R"==(#define CASE_3D 1 )==""\n"
R"==(#else )==""\n"
R"==(#define CASE_3D 0 )==""\n"
R"==(#endif )==""\n"
R"==(#if BWD_DATA == 1 )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))  )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE)))  )==""\n"
R"==(__kernel void )==""\n"
R"==(gen9_conv_bwd_data(__global DATA_T *diff_src, __global DATA_T *wei, )==""\n"
R"==(__global DATA_T *diff_dst, __global DATA_T *bias) { )==""\n"
R"==(MAYBE_SKIP_NON_UNIFORM_WG(); )==""\n"
R"==(#if VER_16MB16C == 1 )==""\n"
R"==(const int sp = get_group_id(1); )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(const int icb_mb = get_group_id(2); )==""\n"
R"==(const int mb = icb_mb / (G * IC / ICB) * MB_BLOCK; )==""\n"
R"==(const int icb = icb_mb % (G * IC / ICB); )==""\n"
R"==(const int ic = (icb * ICB) / IC_BLOCK )==""\n"
R"==(+ get_group_id(0) * (LWS_0 / SUB_GROUP_SIZE) + get_sub_group_id(); )==""\n"
R"==(const int g = ic / (IC / IC_BLOCK); )==""\n"
R"==(const int gic = ic % (IC / IC_BLOCK); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(const int id = sp / (IW * IH); )==""\n"
R"==(const int ihw = sp % (IW * IH); )==""\n"
R"==(#else )==""\n"
R"==(const int id = 0; )==""\n"
R"==(const int ihw = sp; )==""\n"
R"==(#endif )==""\n"
R"==(const int ih = ihw / IW; )==""\n"
R"==(const int iw = ihw % IW; )==""\n"
R"==(diff_dst += mb * OC * G * OD * OH * OW + g * OC * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(DATA8_T blockC00 = (DATA8_T)DATA_ZERO; )==""\n"
R"==(DATA8_T blockC01 = (DATA8_T)DATA_ZERO; )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(#if IS_DW )==""\n"
R"==(const int bg_off = g * IC + sglid; )==""\n"
R"==(const int bc_off = gic * IC_BLOCK; )==""\n"
R"==(DATA_T b = (G_WO_PADDING % IC_BLOCK == 0 || bg_off < G_WO_PADDING) )==""\n"
R"==(? bias[bg_off + bc_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(#else )==""\n"
R"==(const int bg_off = g * IC; )==""\n"
R"==(const int bc_off = gic * IC_BLOCK + sglid; )==""\n"
R"==(DATA_T b = (IC_WO_PADDING % IC_BLOCK == 0 || bc_off < IC_WO_PADDING) )==""\n"
R"==(? bias[bg_off + bc_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(#endif )==""\n"
R"==(unroll_for(int i = 0; i < 8; ++i) { )==""\n"
R"==(blockC00[i] = b; )==""\n"
R"==(blockC01[i] = b; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(wei += gic * KD * KH * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(+ g * IC * OC * KD * KH * KW; )==""\n"
R"==(int ocb = 0; )==""\n"
R"==(do { )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) )==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) )==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) { )==""\n"
R"==(if (iw + PW < kw * (1 + DW) || ih + PH < kh * (1 + DH)) )==""\n"
R"==(continue; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(if (id + PD < kd * (1 + DD)) continue; )==""\n"
R"==(int od = id - kd * (1 + DD) + PD; )==""\n"
R"==(if (od % SD != 0) continue; )==""\n"
R"==(od /= SD; )==""\n"
R"==(if (od >= OD) continue; )==""\n"
R"==(#endif )==""\n"
R"==(int ow = iw - kw * (1 + DW) + PW; )==""\n"
R"==(int oh = ih - kh * (1 + DH) + PH; )==""\n"
R"==(#if SW != 1 || SH != 1 )==""\n"
R"==(if (ow % SW != 0 || oh % SH != 0) continue; )==""\n"
R"==(ow /= SW; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(#endif )==""\n"
R"==(if (oh >= OH || ow >= OW) continue; )==""\n"
R"==(const __global DATA_T *diff_dst1 = diff_dst )==""\n"
R"==(+ ow * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ oh * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(diff_dst1 += od * OH * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(const __global DATA_T *wei1 = wei )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(+ kd * KH * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(#endif )==""\n"
R"==(+ kh * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(+ kw * OC_BLOCK * IC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(int ow = (iw + PW); )==""\n"
R"==(int oh = (ih + PH); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(int od = (id + PD); )==""\n"
R"==(#endif )==""\n"
R"==(bool do_ker = true; )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 )==""\n"
R"==(do_ker = ow % SW == 0 && oh % SH == 0; )==""\n"
R"==(ow /= SW; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(do_ker = do_ker && od % SD == 0; )==""\n"
R"==(od /= SD; )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(do_ker = do_ker && (oh < OH && ow < OW); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(do_ker = do_ker && (od < OD); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 || PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(if (do_ker) { )==""\n"
R"==(#endif )==""\n"
R"==(const __global DATA_T *diff_dst1 = diff_dst )==""\n"
R"==(+ ow * OC_BLOCK * MB_BLOCK + oh * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(diff_dst1 += od * OH * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(const __global DATA_T *wei1 = wei; )==""\n"
R"==(#endif )==""\n"
R"==(#define LOAD_DIFF_DST(_block, _diff_dst, mb_chunk) \ )==""\n"
R"==({ \ )==""\n"
R"==((_block) = AS_DATA8_T( \ )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)((_diff_dst) \ )==""\n"
R"==(+ (mb_chunk)*OC_BLOCK))); \ )==""\n"
R"==(} )==""\n"
R"==(#define SAVE_SRC_DIFF(_block, _diff_src, mb_chunk) \ )==""\n"
R"==({ \ )==""\n"
R"==(BLOCK_WRITE8((const __global BLOCK_DATA_T *)(&( \ )==""\n"
R"==(_diff_src)[(mb_chunk)*IC_BLOCK]), \ )==""\n"
R"==(AS_BLOCK_DATA8_T((_block))); \ )==""\n"
R"==(} )==""\n"
R"==(#if DT_F32 )==""\n"
R"==(#define TRANSPOSE_8(_block, _col) \ )==""\n"
R"==((DATA8_T)(intel_sub_group_shuffle(_block, _col)) )==""\n"
R"==(#else )==""\n"
R"==(#define TRANSPOSE_8(_block, _col) \ )==""\n"
R"==((DATA8_T)(intel_sub_group_shuffle(_block[0], _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[1], _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[2], _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[3], _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[4], _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[5], _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[6], _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[7], _col)) )==""\n"
R"==(#endif )==""\n"
R"==(#define FMA8(a, b, c) fma((DATA8_T)(a), (DATA8_T)b, (DATA8_T)c) )==""\n"
R"==(#define MULTIPLY_BLOCKS_8x8(_result, _blockA, _blockB, _blockB1) \ )==""\n"
R"==({ \ )==""\n"
R"==(_result = FMA8(_blockB.s0, TRANSPOSE_8(_blockA, 0), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s1, TRANSPOSE_8(_blockA, 1), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s2, TRANSPOSE_8(_blockA, 2), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s3, TRANSPOSE_8(_blockA, 3), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s4, TRANSPOSE_8(_blockA, 4), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s5, TRANSPOSE_8(_blockA, 5), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s6, TRANSPOSE_8(_blockA, 6), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s7, TRANSPOSE_8(_blockA, 7), _result); \ )==""\n"
R"==(_result = FMA8(_blockB1.s0, TRANSPOSE_8(_blockA, 8), _result); \ )==""\n"
R"==(_result = FMA8(_blockB1.s1, TRANSPOSE_8(_blockA, 9), _result); \ )==""\n"
R"==(_result = FMA8(_blockB1.s2, TRANSPOSE_8(_blockA, 10), _result); \ )==""\n"
R"==(_result = FMA8(_blockB1.s3, TRANSPOSE_8(_blockA, 11), _result); \ )==""\n"
R"==(_result = FMA8(_blockB1.s4, TRANSPOSE_8(_blockA, 12), _result); \ )==""\n"
R"==(_result = FMA8(_blockB1.s5, TRANSPOSE_8(_blockA, 13), _result); \ )==""\n"
R"==(_result = FMA8(_blockB1.s6, TRANSPOSE_8(_blockA, 14), _result); \ )==""\n"
R"==(_result = FMA8(_blockB1.s7, TRANSPOSE_8(_blockA, 15), _result); \ )==""\n"
R"==(} )==""\n"
R"==(DATA8_T blockA0, blockA1; )==""\n"
R"==(LOAD_DIFF_DST(blockA0, diff_dst1, 0); )==""\n"
R"==(LOAD_DIFF_DST(blockA1, diff_dst1, 8); )==""\n"
R"==(DATA8_T blockB00 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)wei1)); )==""\n"
R"==(DATA8_T blockB01 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)(wei1 )==""\n"
R"==(+ 8 * IC_BLOCK))); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC00, blockA0, blockB00, blockB01); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC01, blockA1, blockB00, blockB01); )==""\n"
R"==(#undef TRANSPOSE_BLOCK_8 )==""\n"
R"==(#undef MULTIPLY_BLOCKS_8x8 )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 || PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(diff_dst += OC_BLOCK * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(wei += IC * KD * KH * KW * OC_BLOCK; )==""\n"
R"==(ocb += OC_BLOCK; )==""\n"
R"==(} while (ocb < OC); )==""\n"
R"==(__global DATA_T *src_write0 = diff_src + mb * IC * G * ID * IH * IW )==""\n"
R"==(+ gic * ID * IH * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ g * IC * ID * IH * IW * MB_BLOCK )==""\n"
R"==(+ id * IH * IW * IC_BLOCK * MB_BLOCK + ih * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ iw * IC_BLOCK * MB_BLOCK; )==""\n"
R"==(SAVE_SRC_DIFF(blockC00, src_write0, 0); )==""\n"
R"==(SAVE_SRC_DIFF(blockC01, src_write0, 8); )==""\n"
R"==(#endif )==""\n"
R"==(#if VER_8OW16C == 1 )==""\n"
R"==(const int sp = get_group_id(1); )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(const int icb_mb = get_group_id(2); )==""\n"
R"==(const int mb = icb_mb / (G * IC / ICB); )==""\n"
R"==(const int icb = icb_mb % (G * IC / ICB); )==""\n"
R"==(const int ic = (icb * ICB) / IC_BLOCK )==""\n"
R"==(+ get_group_id(0) * (LWS_0 / SUB_GROUP_SIZE) + get_sub_group_id(); )==""\n"
R"==(const int g = ic / (IC / IC_BLOCK); )==""\n"
R"==(const int gic = ic % (IC / IC_BLOCK); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(const int id = sp / (IWB * IH); )==""\n"
R"==(const int ihw = sp % (IWB * IH); )==""\n"
R"==(#else )==""\n"
R"==(const int id = 0; )==""\n"
R"==(const int ihw = sp; )==""\n"
R"==(#endif )==""\n"
R"==(const int ih = ihw / IWB; )==""\n"
R"==(const int iw = (ihw % IWB) * IW_BLOCK; )==""\n"
R"==(diff_dst += mb * OC * G * OD * OH * OW + g * OC * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(DATA_T blockC00[IW_BLOCK] = {DATA_ZERO}; )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(#if IS_DW )==""\n"
R"==(const int bg_off = g * IC + sglid; )==""\n"
R"==(const int bc_off = gic * IC_BLOCK; )==""\n"
R"==(DATA_T b = (G_WO_PADDING % IC_BLOCK == 0 || bg_off < G_WO_PADDING) )==""\n"
R"==(? bias[bg_off + bc_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(#else )==""\n"
R"==(const int bg_off = g * IC; )==""\n"
R"==(const int bc_off = gic * IC_BLOCK + sglid; )==""\n"
R"==(DATA_T b = (IC_WO_PADDING % IC_BLOCK == 0 || bc_off < IC_WO_PADDING) )==""\n"
R"==(? bias[bg_off + bc_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(#endif )==""\n"
R"==(unroll_for(int i = 0; i < IW_BLOCK; ++i) { blockC00[i] = b; } )==""\n"
R"==(} )==""\n"
R"==(wei += gic * KD * KH * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(+ g * IC * OC * KD * KH * KW; )==""\n"
R"==(for (int ocb = 0; ocb < OC; ocb += OC_BLOCK) { )==""\n"
R"==(const __global DATA_T *diff_dst1; )==""\n"
R"==(const __global DATA_T *wei1; )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) { )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(if (id + PD < kd * (1 + DD)) continue; )==""\n"
R"==(int od = id - kd * (1 + DD) + PD; )==""\n"
R"==(if (od % SD != 0) continue; )==""\n"
R"==(od /= SD; )==""\n"
R"==(if (od >= OD) continue; )==""\n"
R"==(#endif )==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) { )==""\n"
R"==(if (ih + PH < kh * (1 + DH)) continue; )==""\n"
R"==(int oh = ih - kh * (1 + DH) + PH; )==""\n"
R"==(if (oh % SH != 0) continue; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(if (oh >= OH) continue; )==""\n"
R"==(__attribute__((opencl_unroll_hint(KW)))  )==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) { )==""\n"
R"==(diff_dst1 = diff_dst + oh * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(diff_dst1 += od * OH * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(wei1 = wei )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(+ kd * KH * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(#endif )==""\n"
R"==(+ kh * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(+ kw * OC_BLOCK * IC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(int oh = (ih + PH); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(int od = (id + PD); )==""\n"
R"==(#endif )==""\n"
R"==(bool do_ker = true; )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 )==""\n"
R"==(do_ker = oh % SH == 0; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(do_ker = do_ker && od % SD == 0; )==""\n"
R"==(od /= SD; )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(do_ker = do_ker && (oh < OH); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(do_ker = do_ker && (od < OD); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 || PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(if (do_ker) { )==""\n"
R"==(#endif )==""\n"
R"==(diff_dst1 = diff_dst + oh * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(diff_dst1 += od * OH * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(wei1 = wei; )==""\n"
R"==(#endif )==""\n"
R"==(#define TRANSPOSE_1(_block, _col) \ )==""\n"
R"==((DATA_T)(intel_sub_group_shuffle(_block, _col)) )==""\n"
R"==(#define FMA1(a, b, c) fma((DATA_T)(a), (DATA_T)b, (DATA_T)c) )==""\n"
R"==(#define HAS_PAD_W (PW > 0 || OW * SW - PW + (KW - 1) * (1 + DW) >= IW) )==""\n"
R"==(#define _BLOCK_READ8(ptr) \ )==""\n"
R"==(AS_DATA8_T(BLOCK_READ8((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ4(ptr) \ )==""\n"
R"==(AS_DATA4_T(BLOCK_READ4((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ2(ptr) \ )==""\n"
R"==(AS_DATA2_T(BLOCK_READ2((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ(ptr) \ )==""\n"
R"==(AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define unrolled_read(n, block, ptr) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if ((n)&16) { \ )==""\n"
R"==(*((DATA8_T *)(block)) = _BLOCK_READ8((ptr)); \ )==""\n"
R"==(*((DATA8_T *)((block) + 8)) = _BLOCK_READ8((ptr) + 8 * 16); \ )==""\n"
R"==(} \ )==""\n"
R"==(if ((n)&8) \ )==""\n"
R"==(*((DATA8_T *)((block) + ((n) & ~15))) \ )==""\n"
R"==(= _BLOCK_READ8((ptr) + ((n) & ~15) * 16); \ )==""\n"
R"==(if ((n)&4) \ )==""\n"
R"==(*((DATA4_T *)((block) + ((n) & ~7))) \ )==""\n"
R"==(= _BLOCK_READ4((ptr) + ((n) & ~7) * 16); \ )==""\n"
R"==(if ((n)&2) \ )==""\n"
R"==(*((DATA2_T *)((block) + ((n) & ~3))) \ )==""\n"
R"==(= _BLOCK_READ2((ptr) + ((n) & ~3) * 16); \ )==""\n"
R"==(if ((n)&1) \ )==""\n"
R"==(*((block) + ((n) & ~1)) = _BLOCK_READ((ptr) + ((n) & ~1) * 16); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define MULTIPLY_BLOCKS_8x8(_result, _blockA, _blockB, _blockB1) \ )==""\n"
R"==({ \ )==""\n"
R"==(_result = FMA1(_blockB.s0, TRANSPOSE_1(_blockA, 0), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s1, TRANSPOSE_1(_blockA, 1), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s2, TRANSPOSE_1(_blockA, 2), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s3, TRANSPOSE_1(_blockA, 3), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s4, TRANSPOSE_1(_blockA, 4), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s5, TRANSPOSE_1(_blockA, 5), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s6, TRANSPOSE_1(_blockA, 6), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s7, TRANSPOSE_1(_blockA, 7), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s0, TRANSPOSE_1(_blockA, 8), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s1, TRANSPOSE_1(_blockA, 9), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s2, TRANSPOSE_1(_blockA, 10), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s3, TRANSPOSE_1(_blockA, 11), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s4, TRANSPOSE_1(_blockA, 12), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s5, TRANSPOSE_1(_blockA, 13), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s6, TRANSPOSE_1(_blockA, 14), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s7, TRANSPOSE_1(_blockA, 15), _result); \ )==""\n"
R"==(} )==""\n"
R"==(DATA8_T blockB00 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)wei1)); )==""\n"
R"==(DATA8_T blockB01 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)(wei1 )==""\n"
R"==(+ 8 * IC_BLOCK))); )==""\n"
R"==(DATA_T blockA[IW_BLOCK] = {0}; )==""\n"
R"==(#if KW == 1 && !HAS_PAD_W && SW == 1 )==""\n"
R"==(int iw_bound = min(IW_BLOCK, IW - iw); )==""\n"
R"==(int ow = iw; )==""\n"
R"==(unrolled_read( )==""\n"
R"==(iw_bound, &blockA[0], &(diff_dst1)[ow * OC_BLOCK]); )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint(IW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(MULTIPLY_BLOCKS_8x8( )==""\n"
R"==(blockC00[i], blockA[i], blockB00, blockB01); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(__attribute__((opencl_unroll_hint(IW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(#if KW != 1 )==""\n"
R"==(if (iw + i + PW < kw * (1 + DW)) continue; )==""\n"
R"==(int ow = iw + i - kw * (1 + DW) + PW; )==""\n"
R"==(#else )==""\n"
R"==(int ow = iw + i + PW; )==""\n"
R"==(#endif )==""\n"
R"==(#if SW != 1 )==""\n"
R"==(if (ow % SW != 0) continue; )==""\n"
R"==(ow /= SW; )==""\n"
R"==(#endif )==""\n"
R"==(if (ow >= OW) continue; )==""\n"
R"==(blockA[i] = AS_DATA_T( )==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)(&( )==""\n"
R"==(diff_dst1)[ow * OC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(__attribute__((opencl_unroll_hint(IW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC00[i], blockA[i], blockB00, blockB01); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#undef TRANSPOSE_BLOCK_8 )==""\n"
R"==(#undef MULTIPLY_BLOCKS_8x8 )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 || PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(diff_dst += OC_BLOCK * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(wei += IC * KD * KH * KW * OC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(__global DATA_T *src_write0 = diff_src + mb * IC * G * ID * IH * IW )==""\n"
R"==(+ gic * ID * IH * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ g * IC * ID * IH * IW * MB_BLOCK )==""\n"
R"==(+ id * IH * IW * IC_BLOCK * MB_BLOCK + ih * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ iw * IC_BLOCK * MB_BLOCK; )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(if (iw + i >= IW) continue; )==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)(&(src_write0)[i * IC_BLOCK]), )==""\n"
R"==(AS_BLOCK_DATA_T(blockC00[i])); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}