namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_bwd_weights_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define DT_UNDEF )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if OD > 1 )==""\n"
R"==(#define CASE_3D 1 )==""\n"
R"==(#else )==""\n"
R"==(#define CASE_3D 0 )==""\n"
R"==(#endif )==""\n"
R"==(#define HAS_PAD_D (PD != 0 || PD_R != 0) )==""\n"
R"==(#define HAS_PAD_H (PH != 0 || PH_R != 0) )==""\n"
R"==(#define HAS_PAD_W (PW != 0 || PW_R != 0) )==""\n"
R"==(#if DST_DT_F32 )==""\n"
R"==(#define BLOCK_READ_DST(ptr) \ )==""\n"
R"==(as_float(intel_sub_group_block_read((__global uint *)ptr)) )==""\n"
R"==(#elif DST_DT_BF16 )==""\n"
R"==(#define BLOCK_READ_DST(ptr) \ )==""\n"
R"==(as_ushort(intel_sub_group_block_read_us((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_READ_DST8(ptr) \ )==""\n"
R"==(as_ushort8(intel_sub_group_block_read_us8((__global ushort *)ptr)) )==""\n"
R"==(#endif )==""\n"
R"==(#if BWD_WEIGHTS == 1 )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))  )==""\n"
R"==(#if VER_16MB16C == 1 || VER_8OW16C == 1 )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE)))  )==""\n"
R"==(#endif )==""\n"
R"==(__kernel void )==""\n"
R"==(gen9_conv_bwd_weights(__global SRC_DATA_T *src, )==""\n"
R"==(volatile __global atomic_float *diff_wei, )==""\n"
R"==(volatile __global atomic_float *diff_bias, )==""\n"
R"==(__global DST_DATA_T *diff_dst) { )==""\n"
R"==(MAYBE_SKIP_NON_UNIFORM_WG(); )==""\n"
R"==(#if VER_16MB16C == 1 )==""\n"
R"==(const uint ksp = get_global_id(1); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(const uint kd = ksp / (KW * KH); )==""\n"
R"==(const uint khw = ksp % (KW * KH); )==""\n"
R"==(#else )==""\n"
R"==(const uint khw = ksp; )==""\n"
R"==(const uint kd = 0; )==""\n"
R"==(#endif )==""\n"
R"==(const uint kh = khw / KW; )==""\n"
R"==(const uint kw = khw % KW; )==""\n"
R"==(const uint sglid = get_sub_group_local_id(); )==""\n"
R"==(const uint chunk = get_global_id(2) / ((IC / ICB) * (OC / OCB)); )==""\n"
R"==(const uint icb_ocb = get_global_id(2) % ((IC / ICB) * (OC / OCB)); )==""\n"
R"==(const uint icb = icb_ocb % (IC / ICB); )==""\n"
R"==(const uint ocb = icb_ocb / (IC / ICB); )==""\n"
R"==(#if IS_DW )==""\n"
R"==(const uint g = 0; )==""\n"
R"==(const uint oc )==""\n"
R"==(= get_group_id(0) * (LWS_0 / SUB_GROUP_SIZE) + get_sub_group_id(); )==""\n"
R"==(const uint ic = oc; )==""\n"
R"==(#else )==""\n"
R"==(const uint g_ic_oc = get_global_id(0); )==""\n"
R"==(const uint g = g_ic_oc / (OCB * (ICB / IC_BLOCK)); )==""\n"
R"==(const uint io = g_ic_oc % (OCB * (ICB / IC_BLOCK)); )==""\n"
R"==(const uint oc = (io % OCB) / OC_BLOCK + ocb * (OCB / OC_BLOCK); )==""\n"
R"==(const uint ic = io / OCB + icb * (ICB / IC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(const uint sp_chunk = chunk % OSP_CHUNK; )==""\n"
R"==(const uint mb_chunk = chunk / OSP_CHUNK; )==""\n"
R"==(const uint oh_nb = (OH + OHB - 1) / OHB; )==""\n"
R"==(const uint ow_nb = (OW + OWB - 1) / OWB; )==""\n"
R"==(const uint od_beg = (sp_chunk / ow_nb) / oh_nb * ODB; )==""\n"
R"==(const uint oh_beg = (sp_chunk / ow_nb) % oh_nb * OHB; )==""\n"
R"==(const uint ow_beg = (sp_chunk % ow_nb) * OWB; )==""\n"
R"==(const uint mb = mb_chunk * (MB_CHUNK_SIZE); )==""\n"
R"==(const uint mb_end = min((mb_chunk + 1) * (MB_CHUNK_SIZE), (uint)MB); )==""\n"
R"==(const bool do_bias = (ic == 0 || IS_DW) && kh == 0 && kw == 0 && kd == 0; )==""\n"
R"==(src += ic * ID * IH * IW * IC_BLOCK * MB_BLOCK + mb * IC * G * ID * IH * IW )==""\n"
R"==(+ g * IC * ID * IH * IW * MB_BLOCK; )==""\n"
R"==(diff_dst += oc * OD * OH * OW * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ g * OC * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(diff_bias += g * OC + oc * OC_BLOCK + sglid; )==""\n"
R"==(float bias_loc = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_DW )==""\n"
R"==(float blockC00 = 0.0f; )==""\n"
R"==(#else )==""\n"
R"==(float8 blockC00 = 0.0f; )==""\n"
R"==(float8 blockC01 = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#if MB != (MB_CHUNK * MB_BLOCK) )==""\n"
R"==(uint omb = mb; )==""\n"
R"==(do { )==""\n"
R"==(const __global float *diff_dst1_ )==""\n"
R"==(= diff_dst + omb * OC * G * OD * OH * OW; )==""\n"
R"==(#else )==""\n"
R"==(const __global float *diff_dst1_ = diff_dst + mb * OC * G * OD * OH * OW; )==""\n"
R"==(#endif )==""\n"
R"==(for (uint od = od_beg; od < min(od_beg + ODB, (uint)OD); od++) { )==""\n"
R"==(for (uint oh = oh_beg; oh < min(oh_beg + OHB, (uint)OH); oh++) { )==""\n"
R"==(for (uint ow = ow_beg; ow < min(ow_beg + OWB, (uint)OW); ow++) { )==""\n"
R"==(const __global float *diff_dst1 = diff_dst1_ )==""\n"
R"==(+ od * OH * OW * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ oh * OW * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ ow * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(const uint ih = oh * SH - PH + kh * (1 + DH); )==""\n"
R"==(const uint iw = ow * SW - PW + kw * (1 + DW); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(const uint id = od * SD - PD + kd * (1 + DD); )==""\n"
R"==(#endif )==""\n"
R"==(if (iw < 0 || ih < 0 || iw >= IW || ih >= IH )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(|| id < 0 || id >= ID )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(if (do_bias) { )==""\n"
R"==(float8 blockB )==""\n"
R"==(= as_float8(intel_sub_group_block_read8(( )==""\n"
R"==(const __global uint *)(diff_dst1))); )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(blockB = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(diff_dst1 )==""\n"
R"==(+ 8 * OC_BLOCK))); )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(const __global float *src1 = src )==""\n"
R"==(+ ih * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ iw * IC_BLOCK * MB_BLOCK; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(src1 += id * IH * IW * IC_BLOCK * MB_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(#define TRANSPOSE_8(_block, _row, _col) \ )==""\n"
R"==((float8)(intel_sub_group_shuffle(_block[_row], 0 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 1 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 2 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 3 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 4 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 5 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 6 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 7 + _col)) )==""\n"
R"==(#define FMA8(a, b, c) fma((float8)(a), (float8)b, (float8)c) )==""\n"
R"==(#define MULTIPLY_BLOCKS_8x8(_result, _blockA, _blockB, col) \ )==""\n"
R"==({ \ )==""\n"
R"==(_result = FMA8(_blockB.s0, TRANSPOSE_8(_blockA, 0, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s1, TRANSPOSE_8(_blockA, 1, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s2, TRANSPOSE_8(_blockA, 2, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s3, TRANSPOSE_8(_blockA, 3, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s4, TRANSPOSE_8(_blockA, 4, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s5, TRANSPOSE_8(_blockA, 5, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s6, TRANSPOSE_8(_blockA, 6, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s7, TRANSPOSE_8(_blockA, 7, col), _result); \ )==""\n"
R"==(} )==""\n"
R"==(#if IS_DW )==""\n"
R"==(float8 blockA = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(src1))); )==""\n"
R"==(float8 blockA1 = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(src1 + 8 * IC_BLOCK))); )==""\n"
R"==(float8 blockB = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(diff_dst1))); )==""\n"
R"==(float8 blockB1 = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(diff_dst1 + 8 * OC_BLOCK))); )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(blockC00 = fma(blockA[i], blockB[i], blockC00); )==""\n"
R"==(} )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(#endif )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(blockC00 = fma(blockA1[i], blockB1[i], blockC00); )==""\n"
R"==(} )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(bias_loc += blockB1[i]; )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(float8 blockA = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(src1))); )==""\n"
R"==(float8 blockB = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(diff_dst1))); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC00, blockA, blockB, 0); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC01, blockA, blockB, 8); )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(#endif )==""\n"
R"==(blockA = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(src1 + 8 * IC_BLOCK))); )==""\n"
R"==(blockB = as_float8(intel_sub_group_block_read8( )==""\n"
R"==((const __global uint *)(diff_dst1 + 8 * OC_BLOCK))); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC00, blockA, blockB, 0); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC01, blockA, blockB, 8); )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if MB != (MB_CHUNK * MB_BLOCK) )==""\n"
R"==(omb += MB_BLOCK; )==""\n"
R"==(src += IC * G * ID * IH * IW * MB_BLOCK; )==""\n"
R"==(} while (omb < mb_end); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(if (do_bias )==""\n"
R"==(&& oc * OC_BLOCK + sglid < (IS_DW ? G_WO_PADDING : OC_WO_PADDING)) )==""\n"
R"==(atomic_add_global(diff_bias, bias_loc); )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_DW )==""\n"
R"==(diff_wei += oc * KD * KH * KW * OC_BLOCK + kd * KH * KW * OC_BLOCK )==""\n"
R"==(+ kh * KW * OC_BLOCK + kw * OC_BLOCK; )==""\n"
R"==(atomic_add_global(diff_wei + sglid, blockC00); )==""\n"
R"==(#else )==""\n"
R"==(diff_wei += ic * OC * KD * KH * KW * IC_BLOCK )==""\n"
R"==(+ oc * KD * KH * KW * IC_BLOCK * OC_BLOCK )==""\n"
R"==(+ kd * KH * KW * IC_BLOCK * OC_BLOCK + kh * KW * IC_BLOCK * OC_BLOCK )==""\n"
R"==(+ kw * IC_BLOCK * OC_BLOCK + g * OC * IC * KD * KH * KW; )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(atomic_add_global(diff_wei + i * OC_BLOCK + sglid, blockC00[i]); )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(atomic_add_global(diff_wei + (8 + i) * OC_BLOCK + sglid, blockC01[i]); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if VER_8OW16C == 1 )==""\n"
R"==(#define HAS_PAD_W (PW > 0 || OW * SW - PW + (KW - 1) * (1 + DW) >= IW) )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(const int ksp = get_global_id(1) * 16 + sglid; )==""\n"
R"==(#else )==""\n"
R"==(const int ksp = get_global_id(1); )==""\n"
R"==(#endif )==""\n"
R"==(const int ICX = IC == 3 ? 3 : 1; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(const int kd = ksp / (KW * KH * ICX); )==""\n"
R"==(const int khw = ksp % (KW * KH * ICX); )==""\n"
R"==(#else )==""\n"
R"==(const int khw = ksp; )==""\n"
R"==(const int kd = 0; )==""\n"
R"==(#endif )==""\n"
R"==(const int kh = khw / (KW * ICX); )==""\n"
R"==(const int kw = (khw % (KW * ICX)) % KW; )==""\n"
R"==(const int chunk = get_global_id(2) % NCHUNK; )==""\n"
R"==(const int icb_ocb = get_global_id(2) / NCHUNK; )==""\n"
R"==(const int icb = icb_ocb % (IC / ICB); )==""\n"
R"==(const int ocb = icb_ocb / (IC / ICB); )==""\n"
R"==(#if IS_DW )==""\n"
R"==(const int g = 0; )==""\n"
R"==(const int oc )==""\n"
R"==(= get_group_id(0) * (LWS_0 / SUB_GROUP_SIZE) + get_sub_group_id(); )==""\n"
R"==(const int ic = oc; )==""\n"
R"==(#else )==""\n"
R"==(const int g_ic_oc = get_global_id(0); )==""\n"
R"==(const int g = g_ic_oc / (OC * (IC / IC_BLOCK)); )==""\n"
R"==(const int io = g_ic_oc % (OC * (IC / IC_BLOCK)); )==""\n"
R"==(const int oc = (io % OCB) / OC_BLOCK + ocb * (OCB / OC_BLOCK); )==""\n"
R"==(const int ic = (IC == 3) ? (khw % (KW * ICX)) / KW )==""\n"
R"==(: (io / OCB + icb * (ICB / IC_BLOCK)); )==""\n"
R"==(#endif )==""\n"
R"==(const int sp_chunk = chunk % OSP_CHUNK; )==""\n"
R"==(const int mb_chunk = chunk / OSP_CHUNK; )==""\n"
R"==(const int ow_nb = (OW + OWB - 1) / OWB; )==""\n"
R"==(const int oh_nb = (OH + OHB - 1) / OHB; )==""\n"
R"==(const int od_beg = ((sp_chunk / ow_nb) / oh_nb) * ODB; )==""\n"
R"==(const int oh_beg = ((sp_chunk / ow_nb) % oh_nb) * OHB; )==""\n"
R"==(const int ow_beg = (sp_chunk % ow_nb) * OWB; )==""\n"
R"==(const int mb = mb_chunk * MB_CHUNK_SIZE; )==""\n"
R"==(const int mb_end = min((mb_chunk + 1) * MB_CHUNK_SIZE, MB); )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(const bool do_bias = get_global_id(1) == 0; )==""\n"
R"==(#else )==""\n"
R"==(const bool do_bias = (ic == 0 || IS_DW) && kh == 0 && kw == 0 && kd == 0; )==""\n"
R"==(#endif )==""\n"
R"==(const int OW_LOOP_BLOCK = 8; )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(src += mb * IC * G * ID * IH * IW + g * IC * ID * IH * IW * MB_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(src += ic * ID * IH * IW * IC_BLOCK * MB_BLOCK + mb * IC * G * ID * IH * IW )==""\n"
R"==(+ g * IC * ID * IH * IW * MB_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(diff_dst += oc * OD * OH * OW * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ g * OC * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(diff_bias += g * OC + oc * OC_BLOCK + sglid; )==""\n"
R"==(float bias_loc = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(float8 blockC00 = 0.0f; )==""\n"
R"==(float8 blockC01 = 0.0f; )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(float blockC00 = 0.0f; )==""\n"
R"==(#else )==""\n"
R"==(float8 blockC00 = 0.0f; )==""\n"
R"==(float8 blockC01 = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(for (int omb = mb; omb < mb_end; omb++) { )==""\n"
R"==(const __global DST_DATA_T *diff_dst1_ )==""\n"
R"==(= diff_dst + omb * OC * G * OD * OH * OW; )==""\n"
R"==(for (int od = od_beg; od < min(od_beg + ODB, OD); od++) )==""\n"
R"==(for (int oh = oh_beg; oh < min(oh_beg + OHB, OH); oh++) { )==""\n"
R"==(const __global DST_DATA_T *diff_dst1 = diff_dst1_ )==""\n"
R"==(+ od * OH * OW * OC_BLOCK + oh * OW * OC_BLOCK; )==""\n"
R"==(bool skip = false; )==""\n"
R"==(if (oh * SH + kh * (1 + DH) < PH )==""\n"
R"==(|| oh * SH + kh * (1 + DH) >= IH + PH )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(|| od * SD + kd * (1 + DD) < PD )==""\n"
R"==(|| od * SD + kd * (1 + DD) >= ID + PD )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(skip = true; )==""\n"
R"==(} )==""\n"
R"==(const int id = od * SD - PD + kd * (1 + DD); )==""\n"
R"==(const int ih = oh * SH - PH + kh * (1 + DH); )==""\n"
R"==(__global SRC_DATA_T *src1; )==""\n"
R"==(for (int ow = ow_beg; )==""\n"
R"==(ow < min(ow_beg + OWB, (OW / OW_BLOCK) * OW_BLOCK); )==""\n"
R"==(ow += OW_BLOCK) { )==""\n"
R"==(const int iw = ow * SW - PW + kw * (1 + DW); )==""\n"
R"==(src1 = src + id * IH * IW * IC_BLOCK + ih * IW * IC_BLOCK )==""\n"
R"==(+ iw * IC_BLOCK; )==""\n"
R"==(#define TRANSPOSE_8(_block, _row, _col) \ )==""\n"
R"==({ \ )==""\n"
R"==((float8)(intel_sub_group_shuffle(_block[_row], 0 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 1 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 2 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 3 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 4 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 5 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 6 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 7 + _col)) \ )==""\n"
R"==(} )==""\n"
R"==(#define FMA8(a, b, c) fma((float8)(a), (float8)b, (float8)c) )==""\n"
R"==(#define MULTIPLY_BLOCKS_8x8(_result, _blockA, _blockB, col) \ )==""\n"
R"==({ \ )==""\n"
R"==(_result = FMA8(_blockB.s0, TRANSPOSE_8(_blockA, 0, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s1, TRANSPOSE_8(_blockA, 1, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s2, TRANSPOSE_8(_blockA, 2, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s3, TRANSPOSE_8(_blockA, 3, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s4, TRANSPOSE_8(_blockA, 4, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s5, TRANSPOSE_8(_blockA, 5, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s6, TRANSPOSE_8(_blockA, 6, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s7, TRANSPOSE_8(_blockA, 7, col), _result); \ )==""\n"
R"==(} )==""\n"
R"==(float8 blockA, blockB; )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(if (skip) { )==""\n"
R"==(blockA = 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(if (HAS_PAD_W )==""\n"
R"==(&& (iw + i * SW < 0 || iw + i * SW >= IW)) )==""\n"
R"==(blockA[i] = 0; )==""\n"
R"==(else )==""\n"
R"==(blockA[i] = SRC_TO_REF( )==""\n"
R"==(src1[ic * ID * IH * IW + i * SW]); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(if (skip) { )==""\n"
R"==(blockA = 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(if (HAS_PAD_W )==""\n"
R"==(&& (iw + i * SW < 0 || iw + i * SW >= IW)) { )==""\n"
R"==(blockA[i] = 0; )==""\n"
R"==(} else { )==""\n"
R"==(blockA[i] = as_float(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(&src1[i )==""\n"
R"==(* IC_BLOCK * SW]))); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(blockB = DST_TO_REF8( )==""\n"
R"==(BLOCK_READ_DST8(diff_dst1 + ow * OC_BLOCK)); )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC00, blockB, blockA, 0); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC01, blockB, blockA, 8); )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(for (int i = 0; i < OW_LOOP_BLOCK; i++) { )==""\n"
R"==(blockC00 = fma(blockA[i], blockB[i], blockC00); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC00, blockA, blockB, 0); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC01, blockA, blockB, 8); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(for (int i = 0; i < OW_LOOP_BLOCK; i++) { )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(for (int ow = (OW / OW_BLOCK) * OW_BLOCK; )==""\n"
R"==(ow < min(ow_beg + OWB, OW); ow += OW_LOOP_BLOCK) { )==""\n"
R"==(const int id = od * SD - PD + kd * (1 + DD); )==""\n"
R"==(const int ih = oh * SH - PH + kh * (1 + DH); )==""\n"
R"==(const int iw = ow * SW - PW + kw * (1 + DW); )==""\n"
R"==(__global SRC_DATA_T *src1; )==""\n"
R"==(float8 blockA, blockB; )==""\n"
R"==(src1 = src + id * IH * IW * IC_BLOCK + ih * IW * IC_BLOCK )==""\n"
R"==(+ iw * IC_BLOCK; )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(if (skip) { )==""\n"
R"==(blockA = 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(for (int i = 0; i < min(OW_LOOP_BLOCK, OW - ow); i++) { )==""\n"
R"==(if (HAS_PAD_W )==""\n"
R"==(&& (iw + i * SW < 0 || iw + i * SW >= IW)) )==""\n"
R"==(blockA[i] = 0; )==""\n"
R"==(else )==""\n"
R"==(blockA[i] = SRC_TO_REF( )==""\n"
R"==(src1[ic * ID * IH * IW + i * SW]); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(if (skip) { )==""\n"
R"==(blockA = 0.0f; )==""\n"
R"==(} else { )==""\n"
R"==(for (int i = 0; i < min(OW_LOOP_BLOCK, OW - ow); i++) { )==""\n"
R"==(if (HAS_PAD_W )==""\n"
R"==(&& (iw + i * SW < 0 || iw + i * SW >= IW)) { )==""\n"
R"==(blockA[i] = 0; )==""\n"
R"==(} else { )==""\n"
R"==(blockA[i] = as_float(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(&src1[i )==""\n"
R"==(* IC_BLOCK * SW]))); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(for (int i = 0; i < min(OW_LOOP_BLOCK, OW - ow); i++) { )==""\n"
R"==(blockB[i] = DST_TO_REF(BLOCK_READ_DST( )==""\n"
R"==((&diff_dst1[(ow + i) * OC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(for (int i = 0; i < min(OW_LOOP_BLOCK, OW - ow); i++) { )==""\n"
R"==(blockC00 = FMA8( )==""\n"
R"==(blockA[i], TRANSPOSE_8(blockB, i, 0), blockC00); )==""\n"
R"==(blockC01 = FMA8( )==""\n"
R"==(blockA[i], TRANSPOSE_8(blockB, i, 8), blockC01); )==""\n"
R"==(} )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(for (int i = 0; i < min(OW_LOOP_BLOCK, OW - ow); i++) { )==""\n"
R"==(blockC00 = fma(blockA[i], blockB[i], blockC00); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(for (int i = 0; i < min(OW_LOOP_BLOCK, OW - ow); i++) { )==""\n"
R"==(blockC00 = FMA8( )==""\n"
R"==(blockB[i], TRANSPOSE_8(blockA, i, 0), blockC00); )==""\n"
R"==(blockC01 = FMA8( )==""\n"
R"==(blockB[i], TRANSPOSE_8(blockA, i, 8), blockC01); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(for (int i = 0; i < min(OW_LOOP_BLOCK, OW - ow); i++) )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(src += G * IC * ID * IH * IW * MB_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(if (do_bias )==""\n"
R"==(&& oc * OC_BLOCK + sglid < (IS_DW ? G_WO_PADDING : OC_WO_PADDING)) )==""\n"
R"==(atomic_add_global(diff_bias, bias_loc); )==""\n"
R"==(#endif )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(diff_wei += ic * OC_BLOCK + oc * KD * KH * KW * IC * OC_BLOCK )==""\n"
R"==(+ g * OC * IC * KD * KH * KW + kd * KH * KW * IC * OC_BLOCK )==""\n"
R"==(+ kh * KW * IC * OC_BLOCK + kw * IC * OC_BLOCK; )==""\n"
R"==(if (ksp >= KH * KW * KD * IC) return; )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(atomic_add_global(diff_wei + i, blockC00[i]); )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(atomic_add_global(diff_wei + 8 + i, blockC01[i]); )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(diff_wei += oc * KD * KH * KW * OC_BLOCK + kd * KH * KW * OC_BLOCK )==""\n"
R"==(+ kh * KW * OC_BLOCK + kw * OC_BLOCK; )==""\n"
R"==(atomic_add_global(diff_wei + sglid, blockC00); )==""\n"
R"==(#else )==""\n"
R"==(diff_wei += ic * OC * KD * KH * KW * IC_BLOCK )==""\n"
R"==(+ oc * KD * KH * KW * IC_BLOCK * OC_BLOCK )==""\n"
R"==(+ kd * KH * KW * IC_BLOCK * OC_BLOCK + kh * KW * IC_BLOCK * OC_BLOCK )==""\n"
R"==(+ kw * IC_BLOCK * OC_BLOCK + g * OC * IC * KD * KH * KW; )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(atomic_add_global(diff_wei + i * OC_BLOCK + sglid, blockC00[i]); )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(atomic_add_global(diff_wei + (8 + i) * OC_BLOCK + sglid, blockC01[i]); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}