namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_dw_bwd_data_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if BWD_DATA == 1 )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))  )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE)))  )==""\n"
R"==(__kernel void )==""\n"
R"==(gen9_conv_dw_bwd_data(__global DATA_T *diff_src, __global DATA_T *wei, )==""\n"
R"==(__global DATA_T *diff_dst, __global DATA_T *bias) { )==""\n"
R"==(MAYBE_SKIP_NON_UNIFORM_WG(); )==""\n"
R"==(#if VER_16MB16C == 1 )==""\n"
R"==(const int mb_unroll = 16; )==""\n"
R"==(const int ic )==""\n"
R"==(= get_group_id(1) * (LWS_1 / SUB_GROUP_SIZE) + get_sub_group_id(); )==""\n"
R"==(const int sp = get_group_id(0); )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(int mb = get_group_id(2) * mb_unroll; )==""\n"
R"==(const int g = ic * IC_BLOCK; )==""\n"
R"==(const int gic = 0; )==""\n"
R"==(const int id = sp / (IW * IH); )==""\n"
R"==(const int ihw = sp % (IW * IH); )==""\n"
R"==(const int ih = ihw / IW; )==""\n"
R"==(const int iw = ihw % IW; )==""\n"
R"==(diff_dst += mb * OC * G * OD * OH * OW + g * OC * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(DATA8_T blockC00 = (DATA8_T)DATA_ZERO; )==""\n"
R"==(DATA8_T blockC01 = (DATA8_T)DATA_ZERO; )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(const int bg_off = g * IC + gic * IC_BLOCK + sglid; )==""\n"
R"==(DATA_T b = (G_WO_PADDING % IC_BLOCK == 0 || bg_off < G_WO_PADDING) )==""\n"
R"==(? bias[bg_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(unroll_for(int i = 0; i < 8; ++i) { )==""\n"
R"==(blockC00[i] = b; )==""\n"
R"==(blockC01[i] = b; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(wei += gic * KD * KH * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(+ g * IC * OC * KD * KH * KW; )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) )==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) )==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) { )==""\n"
R"==(if (id + PD < kd * (1 + DD) || iw + PW < kw * (1 + DW) )==""\n"
R"==(|| ih + PH < kh * (1 + DH)) )==""\n"
R"==(continue; )==""\n"
R"==(int od = id - kd * (1 + DD) + PD; )==""\n"
R"==(int ow = iw - kw * (1 + DW) + PW; )==""\n"
R"==(int oh = ih - kh * (1 + DH) + PH; )==""\n"
R"==(if (od % SD != 0 || ow % SW != 0 || oh % SH != 0) continue; )==""\n"
R"==(od /= SD; )==""\n"
R"==(ow /= SW; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(if (od >= OD || oh >= OH || ow >= OW) continue; )==""\n"
R"==(const __global DATA_T *diff_dst1 = diff_dst )==""\n"
R"==(+ ow * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ oh * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(diff_dst1 += od * OH * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(const __global DATA_T *wei1 = wei + kd * KH * KW * OC_BLOCK )==""\n"
R"==(+ kh * KW * OC_BLOCK + kw * OC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(const int kw = 0; )==""\n"
R"==(int ow = (iw + PW); )==""\n"
R"==(int oh = (ih + PH); )==""\n"
R"==(int od = (id + PD); )==""\n"
R"==(bool do_ker = ow % SW == 0 && oh % SH == 0 && od % SD == 0; )==""\n"
R"==(ow /= SW; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(od /= SD; )==""\n"
R"==(#if PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(do_ker = do_ker && (od < OD && oh < OH && ow < OW); )==""\n"
R"==(#endif )==""\n"
R"==(if (do_ker) { )==""\n"
R"==(const __global DATA_T *diff_dst1 = diff_dst + ow * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ oh * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(diff_dst1 += od * OH * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(const __global DATA_T *wei1 = wei; )==""\n"
R"==(#endif )==""\n"
R"==(#define LOAD_DIFF_DST(_block, _diff_dst, mb_chunk) \ )==""\n"
R"==({ \ )==""\n"
R"==((_block) = AS_DATA8_T( \ )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)((_diff_dst) \ )==""\n"
R"==(+ (mb_chunk)*OC_BLOCK))); \ )==""\n"
R"==(} )==""\n"
R"==(#define SAVE_SRC_DIFF(_block, _diff_src, mb_chunk) \ )==""\n"
R"==({ \ )==""\n"
R"==(BLOCK_WRITE8((const __global BLOCK_DATA_T *)(&( \ )==""\n"
R"==(_diff_src)[(mb_chunk)*IC_BLOCK]), \ )==""\n"
R"==(AS_BLOCK_DATA8_T((_block))); \ )==""\n"
R"==(} )==""\n"
R"==(DATA8_T blockA0, blockA1; )==""\n"
R"==(LOAD_DIFF_DST(blockA0, diff_dst1, 0); )==""\n"
R"==(LOAD_DIFF_DST(blockA1, diff_dst1, 8); )==""\n"
R"==(DATA_T blockB00 = AS_DATA_T( )==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)wei1)); )==""\n"
R"==(blockC00 = fma(blockA0, (DATA8_T)blockB00, blockC00); )==""\n"
R"==(blockC01 = fma(blockA1, (DATA8_T)blockB00, blockC01); )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(__global DATA_T *src_write0 = diff_src + mb * IC * G * ID * IH * IW )==""\n"
R"==(+ gic * ID * IH * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ g * IC * ID * IH * IW * MB_BLOCK )==""\n"
R"==(+ id * IH * IW * IC_BLOCK * MB_BLOCK + ih * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ iw * IC_BLOCK * MB_BLOCK; )==""\n"
R"==(SAVE_SRC_DIFF(blockC00, src_write0, 0); )==""\n"
R"==(SAVE_SRC_DIFF(blockC01, src_write0, 8); )==""\n"
R"==(#endif )==""\n"
R"==(#if VER_8OW16C == 1 )==""\n"
R"==(const int ic )==""\n"
R"==(= get_group_id(1) * (LWS_1 / SUB_GROUP_SIZE) + get_sub_group_id(); )==""\n"
R"==(const int sp = get_group_id(0); )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(const int mb = get_group_id(2); )==""\n"
R"==(const int g = ic * IC_BLOCK; )==""\n"
R"==(const int gic = 0; )==""\n"
R"==(const int id = sp / (IWB * IH); )==""\n"
R"==(const int ihw = sp % (IWB * IH); )==""\n"
R"==(const int ih = ihw / IWB; )==""\n"
R"==(const int iw = (ihw % IWB) * IW_BLOCK; )==""\n"
R"==(diff_dst += mb * OC * G * OD * OH * OW + g * OC * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(DATA_T blockC00[IW_BLOCK] = {DATA_ZERO}; )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(const int bg_off = g * IC + gic * IC_BLOCK + sglid; )==""\n"
R"==(DATA_T b = (G_WO_PADDING % IC_BLOCK == 0 || bg_off < G_WO_PADDING) )==""\n"
R"==(? bias[bg_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(unroll_for(int i = 0; i < IW_BLOCK; ++i) { blockC00[i] = b; } )==""\n"
R"==(} )==""\n"
R"==(wei += gic * KD * KH * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(+ g * IC * OC * KD * KH * KW; )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) )==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) )==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) { )==""\n"
R"==(if (id + PD < kd * (1 + DD)) continue; )==""\n"
R"==(if (ih + PH < kh * (1 + DH)) continue; )==""\n"
R"==(int od = id - kd * (1 + DD) + PD; )==""\n"
R"==(int oh = ih - kh * (1 + DH) + PH; )==""\n"
R"==(if (od % SD != 0 || oh % SH != 0) continue; )==""\n"
R"==(od /= SD; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(if (od >= OD || oh >= OH) continue; )==""\n"
R"==(const __global DATA_T *diff_dst1 = diff_dst )==""\n"
R"==(+ oh * OW * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ od * OH * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(const __global DATA_T *wei1 = wei + kd * KH * KW * OC_BLOCK )==""\n"
R"==(+ kh * KW * OC_BLOCK + kw * OC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(const int kw = 0; )==""\n"
R"==(int oh = (ih + PH); )==""\n"
R"==(int od = (id + PD); )==""\n"
R"==(bool do_ker = od % SD == 0 && oh % SH == 0; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(od /= SD; )==""\n"
R"==(#if PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(do_ker = do_ker && (oh < OH && od < OD); )==""\n"
R"==(#endif )==""\n"
R"==(if (do_ker) { )==""\n"
R"==(const __global DATA_T *diff_dst1 = diff_dst )==""\n"
R"==(+ oh * OW * OC_BLOCK * MB_BLOCK )==""\n"
R"==(+ od * OH * OW * OC_BLOCK * MB_BLOCK; )==""\n"
R"==(const __global DATA_T *wei1 = wei; )==""\n"
R"==(#endif )==""\n"
R"==(DATA_T blockB00 = AS_DATA_T( )==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)wei1)); )==""\n"
R"==(DATA_T blockA[IW_BLOCK]; )==""\n"
R"==(__attribute__((opencl_unroll_hint(IW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(if (iw + i + PW < kw * (1 + DW)) { )==""\n"
R"==(blockA[i] = 0.0; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(int ow = iw + i - kw * (1 + DW) + PW; )==""\n"
R"==(if (ow % SW != 0) { )==""\n"
R"==(blockA[i] = 0.0; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(ow /= SW; )==""\n"
R"==(if (ow >= OW) { )==""\n"
R"==(blockA[i] = 0.0; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(blockA[i] = AS_DATA_T( )==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)(&( )==""\n"
R"==(diff_dst1)[ow * OC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(__attribute__((opencl_unroll_hint(IW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(blockC00[i] = fma(blockA[i], (DATA_T)blockB00, blockC00[i]); )==""\n"
R"==(} )==""\n"
R"==(diff_dst1 += OC_BLOCK * OD * OH * OW * MB_BLOCK; )==""\n"
R"==(wei1 += IC * KD * KH * KW * OC_BLOCK; )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(__global DATA_T *src_write0 = diff_src + mb * IC * G * ID * IH * IW )==""\n"
R"==(+ gic * ID * IH * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ g * IC * ID * IH * IW * MB_BLOCK )==""\n"
R"==(+ id * IH * IW * IC_BLOCK * MB_BLOCK + ih * IW * IC_BLOCK * MB_BLOCK )==""\n"
R"==(+ iw * IC_BLOCK * MB_BLOCK; )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(if (iw + i >= IW) continue; )==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)(&(src_write0)[i * IC_BLOCK]), )==""\n"
R"==(AS_BLOCK_DATA_T(blockC00[i])); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}