namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_dw_fwd_data_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if IS_DW != 1 )==""\n"
R"==(#error "Kernel supports depth-wise convolutions only" )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef DST_DT_S8 )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(#define DST_MB_BLOCK MB_BLOCK )==""\n"
R"==(#else  )==""\n"
R"==(#define DST_MB_BLOCK (MB_BLOCK * 2) )==""\n"
R"==(#endif  )==""\n"
R"==(#define DST_OC_BLOCK (OC_BLOCK * 2) )==""\n"
R"==(#endif  )==""\n"
R"==(#define APPLY_POST_OPS_COMMON(nelems, accumulator, dest_data, mb_shift) \ )==""\n"
R"==({ \ )==""\n"
R"==(const int po_mb = mb_shift + mb; \ )==""\n"
R"==(const int po_oc = g; \ )==""\n"
R"==(int po_mb_count; \ )==""\n"
R"==(if (VER_16MB16C == 1) { \ )==""\n"
R"==(po_mb_count = nelems; \ )==""\n"
R"==(} else { \ )==""\n"
R"==(po_mb_count = 1; \ )==""\n"
R"==(} \ )==""\n"
R"==(APPLY_POST_OPS_TRY_BURST(accumulator, DATA_T, dest_data, DATA_T, \ )==""\n"
R"==(po_mb, po_mb_count, po_oc, SUB_GROUP_SIZE, \ )==""\n"
R"==(get_sub_group_local_id()); \ )==""\n"
R"==(} )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))  )==""\n"
R"==(#if SUB_GROUP_SIZE != 1 )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE)))  )==""\n"
R"==(#endif )==""\n"
R"==(__kernel void )==""\n"
R"==(gen9_conv_dw_fwd(const __global DATA_T *src, const __global DATA_T *wei, )==""\n"
R"==(const __global DATA_T *bias, __global DST_DATA_T *dst POST_OP_ARGS) { )==""\n"
R"==(MAYBE_SKIP_NON_UNIFORM_WG(); )==""\n"
R"==(#if VER_8OW16C )==""\n"
R"==(const int osp = get_global_id(1); )==""\n"
R"==(const int od = osp / (OWB * OH); )==""\n"
R"==(const int ohw = osp % (OWB * OH); )==""\n"
R"==(const int ow = (ohw % OWB) * OW_BLOCK; )==""\n"
R"==(const int oh = ohw / OWB; )==""\n"
R"==(const int g )==""\n"
R"==(= (get_group_id(0) * (LWS_0 / SUB_GROUP_SIZE) + get_sub_group_id()) )==""\n"
R"==(* OC_BLOCK; )==""\n"
R"==(const int mb = get_global_id(2) * MB_BLOCK; )==""\n"
R"==(const int id = od * SD - PD; )==""\n"
R"==(const int ih = oh * SH - PH; )==""\n"
R"==(const int iw = ow * SW - PW; )==""\n"
R"==(#ifdef DST_DT_S8  )==""\n"
R"==(const int G_32block = G % 32 ? (32 + G - (G % 32)) : G; )==""\n"
R"==(dst += mb * G_32block * OD * OH * OW )==""\n"
R"==(+ (g / 32 * 32) * OD * OH * OW * MB_BLOCK )==""\n"
R"==(+ (od * OH * OW + oh * OW + ow) * MB_BLOCK * (DST_OC_BLOCK) )==""\n"
R"==(+ (g % 32); )==""\n"
R"==(#else )==""\n"
R"==(dst += mb * G * OD * OH * OW + g * OD * OH * OW * MB_BLOCK )==""\n"
R"==(+ (od * OH * OW + oh * OW + ow) * MB_BLOCK * OC_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(src += mb )==""\n"
R"==(* ((G_WO_PADDING / IC_BLOCK) )==""\n"
R"==(+ (G_WO_PADDING % IC_BLOCK > 0 ? 1 : 0)) )==""\n"
R"==(* IC_BLOCK * ID * IH * IW )==""\n"
R"==(+ g * ID * IH * IW * MB_BLOCK )==""\n"
R"==(+ (id * IH * IW + ih * IW + iw) * MB_BLOCK * IC_BLOCK; )==""\n"
R"==(wei += g * KD * KH * KW; )==""\n"
R"==(DATA_T S00[OW_BLOCK] = {DATA_ZERO}; )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(const int bg_off = g + get_sub_group_local_id(); )==""\n"
R"==(DATA_T b = (G_WO_PADDING % OC_BLOCK == 0 || bg_off < G_WO_PADDING) )==""\n"
R"==(? bias[bg_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(unroll_for(int k = 0; k < OW_BLOCK; k++) { S00[k] = b; } )==""\n"
R"==(} )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(if (id + kd * (1 + DD) < 0 || id + kd * (1 + DD) >= ID) continue; )==""\n"
R"==(if (ih + kh * (1 + DH) < 0 || ih + kh * (1 + DH) >= IH) continue; )==""\n"
R"==(const __global DATA_T *src1 = src )==""\n"
R"==(+ (kd * (1 + DD) * IH + kh * (1 + DH)) * IW * MB_BLOCK )==""\n"
R"==(* IC_BLOCK; )==""\n"
R"==(DATA_T tempA[SW * OW_BLOCK + KW * (1 + DW)] = {0}; )==""\n"
R"==(__attribute__((opencl_unroll_hint( )==""\n"
R"==(SW * OW_BLOCK + KW * (1 + DW))))  )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK + KW * (1 + DW); i++) { )==""\n"
R"==(if ((i + iw) >= 0 && (i + iw) < IW) { )==""\n"
R"==(tempA[i] = AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T )==""\n"
R"==(*)(&src1[i * IC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { )==""\n"
R"==(const __global DATA_T *wei1 )==""\n"
R"==(= wei + (kd * KH * KW + kh * KW + kw) * OC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(const int kw = 0; )==""\n"
R"==(const __global DATA_T *wei1 = wei; )==""\n"
R"==(const __global DATA_T *src1 = src; )==""\n"
R"==(#endif )==""\n"
R"==(DATA_T B0 = AS_DATA_T( )==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)(wei1))); )==""\n"
R"==(DATA_T A0; )==""\n"
R"==(__attribute__((opencl_unroll_hint(OW_BLOCK)))  )==""\n"
R"==(for (int k = 0; k < OW_BLOCK; k++) { )==""\n"
R"==(if (G != G_WO_PADDING && g >= G_WO_PADDING) { )==""\n"
R"==(S00[k] = DATA_ZERO; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(A0 = tempA[k * SW + kw * (1 + DW)]; )==""\n"
R"==(#else )==""\n"
R"==(if (iw + kw * (1 + DW) + k * SW < 0 )==""\n"
R"==(|| iw + kw * (1 + DW) + k * SW >= IW) )==""\n"
R"==(A0 = DATA_ZERO; )==""\n"
R"==(else )==""\n"
R"==(A0 = AS_DATA_T(BLOCK_READ( )==""\n"
R"==((const __global BLOCK_DATA_T *)(&src1[k * SW * IC_BLOCK]))); )==""\n"
R"==(#endif )==""\n"
R"==(S00[k] = fma(A0, (DATA_T)B0, S00[k]); )==""\n"
R"==(} )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(DATA_T D00[OW_BLOCK] = {0}; )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(#ifdef DST_DT_S8 )==""\n"
R"==(__attribute__((opencl_unroll_hint(OW_BLOCK)))  )==""\n"
R"==(for (int k = 0; k < OW_BLOCK; k++) { )==""\n"
R"==(D00[k] = CONVERT_DATA_T(BLOCK_READ_DST( )==""\n"
R"==((const __global DST_DATA_T *)&dst[k * DST_OC_BLOCK])); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(__attribute__((opencl_unroll_hint(OW_BLOCK)))  )==""\n"
R"==(for (int k = 0; k < OW_BLOCK; k++) { )==""\n"
R"==(D00[k] = AS_DATA_T( )==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)&dst[k * OC_BLOCK])); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(APPLY_POST_OPS_COMMON(OW_BLOCK, S00, D00, 0); )==""\n"
R"==(if (OW % OW_BLOCK == 0 || ow + OW_BLOCK <= OW) { )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int k = 0; k < OW_BLOCK; k++) { )==""\n"
R"==(#ifdef DST_DT_S8 )==""\n"
R"==(BLOCK_WRITE_DST((__global DST_DATA_T *)&dst[k * DST_OC_BLOCK], )==""\n"
R"==(CONVERT_DST_DATA_T(S00[k])); )==""\n"
R"==(#else )==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)&dst[k * OC_BLOCK], )==""\n"
R"==(AS_UINT_T(S00[k])); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int k = 0; k < OW % OW_BLOCK; k++) { )==""\n"
R"==(#ifdef DST_DT_S8 )==""\n"
R"==(BLOCK_WRITE_DST((__global DST_DATA_T *)&dst[k * DST_OC_BLOCK], )==""\n"
R"==(CONVERT_DST_DATA_T(S00[k])); )==""\n"
R"==(#else )==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)&dst[k * OC_BLOCK], )==""\n"
R"==(AS_UINT_T(S00[k])); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if VER_16MB16C || VER_32MB16C )==""\n"
R"==(const int osp = get_global_id(1); )==""\n"
R"==(const int od = osp / (OWB * OH); )==""\n"
R"==(const int ohw = osp % (OWB * OH); )==""\n"
R"==(const int ow = (ohw % OWB) * OW_BLOCK; )==""\n"
R"==(const int oh = ohw / OWB; )==""\n"
R"==(const int g )==""\n"
R"==(= (get_group_id(0) * (LWS_0 / SUB_GROUP_SIZE) + get_sub_group_id()) )==""\n"
R"==(* OC_BLOCK; )==""\n"
R"==(const int mb = get_global_id(2) * MB_BLOCK; )==""\n"
R"==(const int id = od * SD - PD; )==""\n"
R"==(const int ih = oh * SH - PH; )==""\n"
R"==(const int iw = ow * SW - PW; )==""\n"
R"==(#ifdef DST_DT_S8  )==""\n"
R"==(const int G_32block = G % 32 ? (32 + G - (G % 32)) : G; )==""\n"
R"==(dst += (mb / DST_MB_BLOCK) * G_32block * OD * OH * OW * DST_MB_BLOCK )==""\n"
R"==(+ (mb % DST_MB_BLOCK) * DST_OC_BLOCK )==""\n"
R"==(+ (g / DST_OC_BLOCK) * OD * OH * OW * DST_MB_BLOCK * DST_OC_BLOCK )==""\n"
R"==(+ (od * OH * OW + oh * OW + ow) * DST_MB_BLOCK * DST_OC_BLOCK )==""\n"
R"==(+ (g % DST_OC_BLOCK); )==""\n"
R"==(#else )==""\n"
R"==(dst += mb * G * OD * OH * OW + g * OD * OH * OW * MB_BLOCK )==""\n"
R"==(+ (od * OH * OW + oh * OW + ow) * MB_BLOCK * OC_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(src += mb )==""\n"
R"==(* ((G_WO_PADDING / IC_BLOCK) )==""\n"
R"==(+ (G_WO_PADDING % IC_BLOCK > 0 ? 1 : 0)) )==""\n"
R"==(* IC_BLOCK * ID * IH * IW )==""\n"
R"==(+ g * ID * IH * IW * MB_BLOCK )==""\n"
R"==(+ (id * IH * IW + ih * IW + iw) * MB_BLOCK * IC_BLOCK; )==""\n"
R"==(wei += g * KD * KH * KW; )==""\n"
R"==(DATA8_T S00 = DATA_ZERO; )==""\n"
R"==(DATA8_T S01 = DATA_ZERO; )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(DATA8_T S02 = DATA_ZERO; )==""\n"
R"==(DATA8_T S03 = DATA_ZERO; )==""\n"
R"==(#endif )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(const int bg_off = g + get_sub_group_local_id(); )==""\n"
R"==(DATA_T b = (G_WO_PADDING % OC_BLOCK == 0 || bg_off < G_WO_PADDING) )==""\n"
R"==(? bias[bg_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(unroll_for(int k = 0; k < 8; k++) { )==""\n"
R"==(S00[k] = b; )==""\n"
R"==(S01[k] = b; )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(S02[k] = b; )==""\n"
R"==(S03[k] = b; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { )==""\n"
R"==(if (id + kd * (1 + DD) < 0 || id + kd * (1 + DD) >= ID) )==""\n"
R"==(continue; )==""\n"
R"==(if (ih + kh * (1 + DH) < 0 || ih + kh * (1 + DH) >= IH) )==""\n"
R"==(continue; )==""\n"
R"==(if (iw + kw * (1 + DW) < 0 || iw + kw * (1 + DW) >= IW) )==""\n"
R"==(continue; )==""\n"
R"==(const __global DATA_T *wei1 )==""\n"
R"==(= wei + (kd * KH * KW + kh * KW + kw) * OC_BLOCK; )==""\n"
R"==(const __global DATA_T *src1 = src )==""\n"
R"==(+ (kd * (1 + DD) * IH * IW + kh * (1 + DH) * IW )==""\n"
R"==(+ kw * (1 + DW)) )==""\n"
R"==(* MB_BLOCK * IC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(const __global DATA_T *wei1 = wei; )==""\n"
R"==(const __global DATA_T *src1 = src; )==""\n"
R"==(#endif )==""\n"
R"==(if (G != G_WO_PADDING && g >= G_WO_PADDING) { )==""\n"
R"==(S00 = DATA_ZERO; )==""\n"
R"==(S01 = DATA_ZERO; )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(S02 = DATA_ZERO; )==""\n"
R"==(S03 = DATA_ZERO; )==""\n"
R"==(#endif )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(DATA8_T A0 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)(src1))); )==""\n"
R"==(DATA8_T A1 = AS_DATA8_T(BLOCK_READ8( )==""\n"
R"==((const __global BLOCK_DATA_T *)&src1[8 * IC_BLOCK])); )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(DATA8_T A2 = AS_DATA8_T(BLOCK_READ8( )==""\n"
R"==((const __global BLOCK_DATA_T *)&src1[16 * IC_BLOCK])); )==""\n"
R"==(DATA8_T A3 = AS_DATA8_T(BLOCK_READ8( )==""\n"
R"==((const __global BLOCK_DATA_T *)&src1[24 * IC_BLOCK])); )==""\n"
R"==(#endif )==""\n"
R"==(DATA_T B0 = AS_DATA_T( )==""\n"
R"==(BLOCK_READ((const __global BLOCK_DATA_T *)(wei1))); )==""\n"
R"==(S00 = fma(A0, (DATA8_T)B0, S00); )==""\n"
R"==(S01 = fma(A1, (DATA8_T)B0, S01); )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(S02 = fma(A2, (DATA8_T)B0, S02); )==""\n"
R"==(S03 = fma(A3, (DATA8_T)B0, S03); )==""\n"
R"==(#endif )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(DATA8_T D00; )==""\n"
R"==(DATA8_T D01; )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(DATA8_T D02; )==""\n"
R"==(DATA8_T D03; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(#ifdef DST_DT_S8 )==""\n"
R"==(for (int i = 0; i < 8; ++i) { )==""\n"
R"==(D00[i] = CONVERT_DATA_T( )==""\n"
R"==(BLOCK_READ_DST((__global DST_DATA_T *)&dst[i * 32])); )==""\n"
R"==(D01[i] = CONVERT_DATA_T( )==""\n"
R"==(BLOCK_READ_DST((__global DST_DATA_T *)&dst[(i * 32) + 256])); )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(D02[i] = CONVERT_DATA_T( )==""\n"
R"==(BLOCK_READ_DST((__global DST_DATA_T *)&dst[i * 32] + 512)); )==""\n"
R"==(D03[i] = CONVERT_DATA_T( )==""\n"
R"==(BLOCK_READ_DST((__global DST_DATA_T *)&dst[(i * 32) + 768])); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(D00 = AS_DATA8_T(BLOCK_READ8((const __global BLOCK_DATA_T *)dst)); )==""\n"
R"==(D01 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)&dst[8 * OC_BLOCK])); )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(D02 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)&dst[16 * OC_BLOCK])); )==""\n"
R"==(D03 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)&dst[24 * OC_BLOCK])); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(APPLY_POST_OPS_COMMON(8, S00, D00, 0); )==""\n"
R"==(APPLY_POST_OPS_COMMON(8, S01, D01, 8); )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(APPLY_POST_OPS_COMMON(8, S02, D02, 16); )==""\n"
R"==(APPLY_POST_OPS_COMMON(8, S03, D03, 24); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef DST_DT_S8 )==""\n"
R"==(for (int i = 0; i < 8; ++i) { )==""\n"
R"==(BLOCK_WRITE_DST((__global DST_DATA_T *)&dst[i * DST_OC_BLOCK], )==""\n"
R"==(CONVERT_DST_DATA_T(S00[i])); )==""\n"
R"==(BLOCK_WRITE_DST((__global DST_DATA_T *)&dst[(i + 8) * DST_OC_BLOCK], )==""\n"
R"==(CONVERT_DST_DATA_T(S01[i])); )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(BLOCK_WRITE_DST((__global DST_DATA_T *)&dst[(i + 16) * DST_OC_BLOCK], )==""\n"
R"==(CONVERT_DST_DATA_T(S02[i])); )==""\n"
R"==(BLOCK_WRITE_DST((__global DST_DATA_T *)&dst[(i + 24) * DST_OC_BLOCK], )==""\n"
R"==(CONVERT_DST_DATA_T(S03[i])); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)&dst[0], AS_UINT8_T(S00)); )==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)&dst[8 * OC_BLOCK], AS_UINT8_T(S01)); )==""\n"
R"==(#if VER_32MB16C )==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)&dst[16 * OC_BLOCK], AS_UINT8_T(S02)); )==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)&dst[24 * OC_BLOCK], AS_UINT8_T(S03)); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}