namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_fwd_data_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#include "gpu/ocl/offsets.h" )==""\n"
R"==(#define BASE_OC_TAIL (SUB_GROUP_SIZE - (OC - OC_WO_PADDING)) )==""\n"
R"==(#define _BLOCK_READ_DST(v, n_c, ptr) \ )==""\n"
R"==(if (n_c == 8) \ )==""\n"
R"==((*(DATA8_T *)(v)) = CONVERT_DATA8_T( \ )==""\n"
R"==(vload8(0, (const __global DST_DATA_T *)(ptr))); \ )==""\n"
R"==(if (n_c == 4) \ )==""\n"
R"==((*(DATA4_T *)(v)) = CONVERT_DATA4_T( \ )==""\n"
R"==(vload4(0, (const __global DST_DATA_T *)(ptr))); \ )==""\n"
R"==(if (n_c == 2) \ )==""\n"
R"==((*(DATA2_T *)(v)) = CONVERT_DATA2_T( \ )==""\n"
R"==(vload2(0, (const __global DST_DATA_T *)(ptr))); \ )==""\n"
R"==(if (n_c == 1) \ )==""\n"
R"==((*(DATA_T *)(v)) = CONVERT_DATA_T(*(__global DST_DATA_T *)(ptr)); )==""\n"
R"==(#define _BLOCK_READ8(ptr) \ )==""\n"
R"==(AS_DATA8_T(BLOCK_READ8((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ4(ptr) \ )==""\n"
R"==(AS_DATA4_T(BLOCK_READ4((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ2(ptr) \ )==""\n"
R"==(AS_DATA2_T(BLOCK_READ2((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ(ptr) \ )==""\n"
R"==(AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#ifdef DST_DT_S8 )==""\n"
R"==(#if DST_NCHW )==""\n"
R"==(#define _BLOCK_WRITE8(ptr, v) \ )==""\n"
R"==(vstore8(CONVERT_DST_DATA8_T(v), 0, (__global DST_DATA_T *)(ptr)); )==""\n"
R"==(#define _BLOCK_WRITE4(ptr, v) \ )==""\n"
R"==(vstore4(CONVERT_DST_DATA4_T(v), 0, (__global DST_DATA_T *)(ptr)); )==""\n"
R"==(#define _BLOCK_WRITE2(ptr, v) \ )==""\n"
R"==(vstore2(CONVERT_DST_DATA2_T(v), 0, (__global DST_DATA_T *)(ptr)); )==""\n"
R"==(#define _BLOCK_WRITE(ptr, v) \ )==""\n"
R"==(*(__global DST_DATA_T *)(ptr) = CONVERT_DST_DATA_T(v); )==""\n"
R"==(#else )==""\n"
R"==(#define _BLOCK_WRITE8(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE_DST8((__global DST_DATA_T *)(ptr), CONVERT_DST_DATA8_T(v)); )==""\n"
R"==(#define _BLOCK_WRITE4(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE_DST4((__global DST_DATA_T *)(ptr), CONVERT_DST_DATA4_T(v)); )==""\n"
R"==(#define _BLOCK_WRITE2(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE_DST2((__global DST_DATA_T *)(ptr), CONVERT_DST_DATA2_T(v)); )==""\n"
R"==(#define _BLOCK_WRITE(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE_DST((__global DST_DATA_T *)(ptr), CONVERT_DST_DATA_T(v)); )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(#define _BLOCK_WRITE8(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA8_T(v)); )==""\n"
R"==(#define _BLOCK_WRITE4(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE4((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA4_T(v)); )==""\n"
R"==(#define _BLOCK_WRITE2(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE2((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA2_T(v)); )==""\n"
R"==(#define _BLOCK_WRITE(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA_T(v)); )==""\n"
R"==(#endif )==""\n"
R"==(#define IS_3D (OD > 1) )==""\n"
R"==(#define IS_1STCONV (IC == 3) )==""\n"
R"==(#define HAS_PAD_D (PD > 0 || OD * SD - PD + (KD - 1) * (1 + DD) >= ID) )==""\n"
R"==(#define HAS_PAD_H (PH > 0 || OH * SH - PH + (KH - 1) * (1 + DH) >= IH) )==""\n"
R"==(#define HAS_PAD_W (PW > 0 || OW * SW - PW + (KW - 1) * (1 + DW) >= IW) )==""\n"
R"==(#define ENABLE_SRC_BUF (MB_BLOCK == 1 && KW >= 3) )==""\n"
R"==(#define W_VEC (IS_1STCONV && ENABLE_SRC_BUF && KW >= 5 && SW <= 3) )==""\n"
R"==(#define C_VEC (!W_VEC) )==""\n"
R"==(#define IC_INNER (C_VEC ? (IC < 16 ? IC : 16) : 1) )==""\n"
R"==(#define IC_OUTER (IC_BLOCK / IC_INNER) )==""\n"
R"==(#define OC_OUTER (OC_BLOCK / 16) )==""\n"
R"==(#define IW_BLOCK (SW * (OW_BLOCK - 1) + (KW - 1) * (1 + DW) + 1) )==""\n"
R"==(#define OW_INNER (C_VEC ? 1 : 16) )==""\n"
R"==(#define IW_INNER OW_INNER )==""\n"
R"==(#define OW_OUTER ((OW_BLOCK + OW_INNER - 1) / OW_INNER) )==""\n"
R"==(#define IW_OUTER ((IW_BLOCK + IW_INNER - 1) / IW_INNER) )==""\n"
R"==(#define C_SIZE (MB_BLOCK * OC_OUTER * OW_BLOCK) )==""\n"
R"==(#if OW_BLOCK >= 32 )==""\n"
R"==(#error "Block is too big for unrolled_read and unrolled_write." )==""\n"
R"==(#endif )==""\n"
R"==(int src_idx_c_vec(int mb_block, int ic_outer, int ow_outer) { )==""\n"
R"==(if (SRC_16N16C) )==""\n"
R"==(return ic_outer * OW_BLOCK * MB_BLOCK + ow_outer * MB_BLOCK + mb_block; )==""\n"
R"==(return mb_block * IC_OUTER * OW_BLOCK + ic_outer * OW_BLOCK + ow_outer; )==""\n"
R"==(} )==""\n"
R"==(int src_idx_w_vec(int mb_block, int ic_outer, int ow_outer) { )==""\n"
R"==(return mb_block * IC_OUTER * OW_OUTER + ic_outer * OW_OUTER + ow_outer; )==""\n"
R"==(} )==""\n"
R"==(int src_idx(int mb_block, int ic_outer, int ow_outer) { )==""\n"
R"==(if (C_VEC) return src_idx_c_vec(mb_block, ic_outer, ow_outer); )==""\n"
R"==(return src_idx_w_vec(mb_block, ic_outer, ow_outer); )==""\n"
R"==(} )==""\n"
R"==(int src_buf_idx_c_vec(int mb_block, int ic_outer, int iw_outer) { )==""\n"
R"==(if (SRC_16N16C) )==""\n"
R"==(return mb_block * IC_OUTER * IW_OUTER + ic_outer * IW_OUTER + iw_outer; )==""\n"
R"==(return ic_outer * IW_OUTER * MB_BLOCK + iw_outer * MB_BLOCK + mb_block; )==""\n"
R"==(} )==""\n"
R"==(int src_buf_idx_w_vec(int mb_block, int ic_outer, int iw_outer) { )==""\n"
R"==(return mb_block * IC_OUTER * IW_OUTER + ic_outer * IW_OUTER + iw_outer; )==""\n"
R"==(} )==""\n"
R"==(int src_buf_idx(int mb_block, int ic_outer, int iw_outer) { )==""\n"
R"==(if (C_VEC) return src_buf_idx_c_vec(mb_block, ic_outer, iw_outer); )==""\n"
R"==(return src_buf_idx_w_vec(mb_block, ic_outer, iw_outer); )==""\n"
R"==(} )==""\n"
R"==(int wei_idx_c_vec(int oc_outer, int ic_outer) { )==""\n"
R"==(return ic_outer * OC_OUTER * IC_INNER + oc_outer * IC_INNER; )==""\n"
R"==(} )==""\n"
R"==(int wei_idx_w_vec(int oc_outer, int ic_outer) { )==""\n"
R"==(return oc_outer * IC_OUTER + ic_outer; )==""\n"
R"==(} )==""\n"
R"==(int wei_idx(int oc_outer, int ic_outer) { )==""\n"
R"==(if (C_VEC) return wei_idx_c_vec(oc_outer, ic_outer); )==""\n"
R"==(return wei_idx_w_vec(oc_outer, ic_outer); )==""\n"
R"==(} )==""\n"
R"==(int dst_idx(int mb_block, int oc_outer, int ow_block) { )==""\n"
R"==(if (DST_16N16C || DST_32N16C) )==""\n"
R"==(return oc_outer * OW_BLOCK * MB_BLOCK + ow_block * MB_BLOCK + mb_block; )==""\n"
R"==(return mb_block * OC_OUTER * OW_BLOCK + oc_outer * OW_BLOCK + ow_block; )==""\n"
R"==(} )==""\n"
R"==(#define copy(dst, src, n) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int i = 0; i < (n); i++) \ )==""\n"
R"==((dst)[i] = (src)[i]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define unrolled_read(n, block, ptr) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if ((n)&16) { \ )==""\n"
R"==(*((DATA8_T *)(block)) = _BLOCK_READ8((ptr)); \ )==""\n"
R"==(*((DATA8_T *)((block) + 8)) = _BLOCK_READ8((ptr) + 8 * 16); \ )==""\n"
R"==(} \ )==""\n"
R"==(if ((n)&8) \ )==""\n"
R"==(*((DATA8_T *)((block) + ((n) & ~15))) \ )==""\n"
R"==(= _BLOCK_READ8((ptr) + ((n) & ~15) * 16); \ )==""\n"
R"==(if ((n)&4) \ )==""\n"
R"==(*((DATA4_T *)((block) + ((n) & ~7))) \ )==""\n"
R"==(= _BLOCK_READ4((ptr) + ((n) & ~7) * 16); \ )==""\n"
R"==(if ((n)&2) \ )==""\n"
R"==(*((DATA2_T *)((block) + ((n) & ~3))) \ )==""\n"
R"==(= _BLOCK_READ2((ptr) + ((n) & ~3) * 16); \ )==""\n"
R"==(if ((n)&1) \ )==""\n"
R"==(*((block) + ((n) & ~1)) = _BLOCK_READ((ptr) + ((n) & ~1) * 16); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define strided_read(block, ptr, n, stride) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if ((n) == 16 && (stride) == 1) { \ )==""\n"
R"==((block)[0] = _BLOCK_READ((ptr)); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(int sglid = get_sub_group_local_id(); \ )==""\n"
R"==((block)[0] = (sglid < (n)) ? (ptr)[sglid * (stride)] : 0; \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#if DST_NCHW )==""\n"
R"==(#define unrolled_write(n, block, ptr) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if ((n)&16) { \ )==""\n"
R"==(_BLOCK_WRITE8((ptr), *(DATA8_T *)((block))); \ )==""\n"
R"==(_BLOCK_WRITE8((ptr) + 8 * 16, *(DATA8_T *)((block) + 8)); \ )==""\n"
R"==(} \ )==""\n"
R"==(if ((n)&8) \ )==""\n"
R"==(_BLOCK_WRITE8( \ )==""\n"
R"==((ptr) + ((n) & ~15), *(DATA8_T *)((block) + ((n) & ~15))); \ )==""\n"
R"==(if ((n)&4) \ )==""\n"
R"==(_BLOCK_WRITE4( \ )==""\n"
R"==((ptr) + ((n) & ~7), *(DATA4_T *)((block) + ((n) & ~7))); \ )==""\n"
R"==(if ((n)&2) \ )==""\n"
R"==(_BLOCK_WRITE2( \ )==""\n"
R"==((ptr) + ((n) & ~3), *(DATA2_T *)((block) + ((n) & ~3))); \ )==""\n"
R"==(if ((n)&1) _BLOCK_WRITE((ptr) + ((n) & ~1), *((block) + ((n) & ~1))); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define unrolled_write(n, block, ptr) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if ((n)&16) { \ )==""\n"
R"==(_BLOCK_WRITE8((ptr), *(DATA8_T *)((block))); \ )==""\n"
R"==(_BLOCK_WRITE8((ptr) + 8 * 16, *(DATA8_T *)((block) + 8)); \ )==""\n"
R"==(} \ )==""\n"
R"==(if ((n)&8) \ )==""\n"
R"==(_BLOCK_WRITE8((ptr) + ((n) & ~15) * 16, \ )==""\n"
R"==(*(DATA8_T *)((block) + ((n) & ~15))); \ )==""\n"
R"==(if ((n)&4) \ )==""\n"
R"==(_BLOCK_WRITE4((ptr) + ((n) & ~7) * 16, \ )==""\n"
R"==(*(DATA4_T *)((block) + ((n) & ~7))); \ )==""\n"
R"==(if ((n)&2) \ )==""\n"
R"==(_BLOCK_WRITE2((ptr) + ((n) & ~3) * 16, \ )==""\n"
R"==(*(DATA2_T *)((block) + ((n) & ~3))); \ )==""\n"
R"==(if ((n)&1) \ )==""\n"
R"==(_BLOCK_WRITE((ptr) + ((n) & ~1) * 16, *((block) + ((n) & ~1))); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#define multiply_row(C, A, B, mb_block, oc_outer, ic_outer, ow_outer) \ )==""\n"
R"==(do { \ )==""\n"
R"==(int b_off = wei_idx((oc_outer), (ic_outer)); \ )==""\n"
R"==(int c_off = dst_idx((mb_block), (oc_outer), (ow_outer)); \ )==""\n"
R"==(for (int ic_inner = 0; ic_inner < min(IC_WO_PADDING, IC_INNER); \ )==""\n"
R"==(ic_inner++) { \ )==""\n"
R"==((C)[c_off] = fma(intel_sub_group_shuffle((A), ic_inner), \ )==""\n"
R"==((B)[b_off + ic_inner], (C)[c_off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_src_and_multiply_w16c_dense(ptr, iw, kw, C, B) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) \ )==""\n"
R"==(for (int ic_outer = 0; ic_outer < IC_OUTER; ic_outer++) { \ )==""\n"
R"==(int idx = src_idx(mb_block, ic_outer, 0); \ )==""\n"
R"==(for (int ow_block = 0; ow_block < OW_BLOCK; ow_block += 8) { \ )==""\n"
R"==(int ow_bound = min(8, OW_BLOCK - ow_block); \ )==""\n"
R"==(DATA_T A[8]; \ )==""\n"
R"==(int off = src_off(mb_block, ic_outer * IC_INNER, 0, 0, \ )==""\n"
R"==(ow_block + (kw) * (1 + DW)); \ )==""\n"
R"==(unrolled_read(ow_bound, A, &(ptr)[off]); \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \ )==""\n"
R"==(for (int i = 0; i < ow_bound; i++) { \ )==""\n"
R"==(multiply_row((C), A[i], (B), mb_block, oc_outer, \ )==""\n"
R"==(ic_outer, ow_block + i); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_src_and_multiply_16n16c(ptr, iw, kw, do_w_check, C, B) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int ow_block = 0; ow_block < OW_BLOCK; ow_block++) { \ )==""\n"
R"==(int iw_off = ow_block * SW + (kw) * (1 + DW); \ )==""\n"
R"==(if ((do_w_check) && HAS_PAD_W \ )==""\n"
R"==(&& ((iw) + iw_off < 0 || (iw) + iw_off >= IW)) \ )==""\n"
R"==(continue; \ )==""\n"
R"==(for (int ic_outer = 0; ic_outer < IC_OUTER; ic_outer++) \ )==""\n"
R"==(__attribute__((opencl_unroll_hint)) /* attr:no-format */ \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; \ )==""\n"
R"==(mb_block += 8) { \ )==""\n"
R"==(int mb_bound = min(8, MB_BLOCK - mb_block); \ )==""\n"
R"==(DATA_T A[8]; \ )==""\n"
R"==(int off = src_off( \ )==""\n"
R"==(mb_block, ic_outer * IC_INNER, 0, 0, iw_off); \ )==""\n"
R"==(unrolled_read(mb_bound, A, &(ptr)[off]); \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \ )==""\n"
R"==(for (int i = 0; i < mb_bound; i++) { \ )==""\n"
R"==(multiply_row((C), A[i], (B), mb_block + i, \ )==""\n"
R"==(oc_outer, ic_outer, ow_block); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_src_and_multiply_common(ptr, iw, kw, do_w_check, C, B) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { \ )==""\n"
R"==(int iw_off = i * SW + (kw) * (1 + DW); \ )==""\n"
R"==(if ((do_w_check) && HAS_PAD_W \ )==""\n"
R"==(&& ((iw) + iw_off < 0 || (iw) + iw_off >= IW)) \ )==""\n"
R"==(continue; \ )==""\n"
R"==(for (int ic_outer = 0; ic_outer < IC_OUTER; ic_outer++) { \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \ )==""\n"
R"==(int off = src_off( \ )==""\n"
R"==(mb_block, ic_outer * IC_INNER, 0, 0, iw_off); \ )==""\n"
R"==(DATA_T A; \ )==""\n"
R"==(strided_read(&A, &(ptr)[off], IC_INNER, \ )==""\n"
R"==(src_off(0, 1, 0, 0, 0)); \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \ )==""\n"
R"==(int b_off = wei_idx(oc_outer, ic_outer); \ )==""\n"
R"==(int c_off = dst_idx(mb_block, oc_outer, i); \ )==""\n"
R"==(for (int ic_inner = 0; \ )==""\n"
R"==(ic_inner < min(IC_WO_PADDING, IC_INNER); \ )==""\n"
R"==(ic_inner++) { \ )==""\n"
R"==((C)[c_off] = fma( \ )==""\n"
R"==(intel_sub_group_shuffle(A, ic_inner), \ )==""\n"
R"==((B)[b_off + ic_inner], (C)[c_off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_src_and_multiply(ptr, iw, kw, do_w_check, C, B) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (SRC_W16C && (!(do_w_check) || (!HAS_PAD_W && SW == 1))) { \ )==""\n"
R"==(read_src_and_multiply_w16c_dense((ptr), (iw), (kw), (C), (B)); \ )==""\n"
R"==(} else if (SRC_16N16C) { \ )==""\n"
R"==(read_src_and_multiply_16n16c( \ )==""\n"
R"==((ptr), (iw), (kw), (do_w_check), (C), (B)); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(read_src_and_multiply_common( \ )==""\n"
R"==((ptr), (iw), (kw), (do_w_check), (C), (B)); \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_src_buf(buf, ptr, iw) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int iw_outer = 0; iw_outer < IW_OUTER; iw_outer++) { \ )==""\n"
R"==(int iw_inner = (C_VEC ? 0 : get_sub_group_local_id()); \ )==""\n"
R"==(int iw_block = iw_outer * IW_INNER + iw_inner; \ )==""\n"
R"==(if (HAS_PAD_W && ((iw) + iw_block < 0 || (iw) + iw_block >= IW)) \ )==""\n"
R"==(continue; \ )==""\n"
R"==(for (int ic_outer = 0; ic_outer < IC_OUTER; ic_outer++) { \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \ )==""\n"
R"==(int off = src_off( \ )==""\n"
R"==(mb_block, ic_outer * IC_INNER, 0, 0, iw_block); \ )==""\n"
R"==(int idx = src_buf_idx(mb_block, ic_outer, iw_outer); \ )==""\n"
R"==(if (C_VEC) { \ )==""\n"
R"==(strided_read(&(buf)[idx], &(ptr)[off], IC_INNER, \ )==""\n"
R"==(src_off(0, 1, 0, 0, 0)); \ )==""\n"
R"==(} else { \ )==""\n"
R"==((buf)[idx] = (ptr)[off]; \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_wei_block(block, ptr) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \ )==""\n"
R"==(int ic_bound = min(IC_WO_PADDING, IC_BLOCK); \ )==""\n"
R"==(for (int ic_block = 0; ic_block < ic_bound; ic_block += 16) { \ )==""\n"
R"==(int off = wei_off(0, oc_outer * 16, ic_block, 0, 0, 0); \ )==""\n"
R"==(int idx = wei_idx(oc_outer, ic_block); \ )==""\n"
R"==(unrolled_read(min(16, ic_bound - ic_block), &(block)[idx], \ )==""\n"
R"==(&(ptr)[off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_wei_and_multiply_c_vec(wei, kw, C, A) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \ )==""\n"
R"==(int ic_bound1 = min(IC_WO_PADDING, IC_BLOCK); \ )==""\n"
R"==(for (int ic_block = 0; ic_block < ic_bound1; ic_block += 8) { \ )==""\n"
R"==(int ic_bound2 = min(8, ic_bound1 - ic_block); \ )==""\n"
R"==(int off = wei_off(0, oc_outer * 16, ic_block, 0, 0, 0); \ )==""\n"
R"==(DATA_T B[8]; \ )==""\n"
R"==(unrolled_read(ic_bound2, B, &(wei)[off]); \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \ )==""\n"
R"==(for (int ow_block = 0; ow_block < OW_BLOCK; ow_block++) { \ )==""\n"
R"==(int iw_off = ow_block * SW + (kw) * (1 + DW); \ )==""\n"
R"==(int buf_idx = src_buf_idx(mb_block, 0, iw_off); \ )==""\n"
R"==(int c_off = dst_idx(mb_block, oc_outer, ow_block); \ )==""\n"
R"==(for (int i = 0; i < ic_bound2; i++) { \ )==""\n"
R"==((C)[c_off] \ )==""\n"
R"==(= fma(intel_sub_group_shuffle( \ )==""\n"
R"==((A)[buf_idx], ic_block + i), \ )==""\n"
R"==(B[i], (C)[c_off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(DATA_T shuffle_a_value(int mb_block, int ic_block, int ow_outer, int ow_inner, )==""\n"
R"==(int kw, const DATA_T *A) { )==""\n"
R"==(int iw_off0 = ow_outer * OW_INNER * SW + kw * (1 + DW); )==""\n"
R"==(int iw_outer0 = iw_off0 / IW_INNER; )==""\n"
R"==(int buf_idx0 = src_buf_idx(mb_block, ic_block, iw_outer0); )==""\n"
R"==(int iw_off = iw_off0 + ow_inner * SW; )==""\n"
R"==(int iw_outer = iw_off / IW_INNER; )==""\n"
R"==(DATA4_T A_shuf = 0; )==""\n"
R"==(for (int i = 0; i < SW + 1; i++) { )==""\n"
R"==(A_shuf[i] = (iw_outer0 + i < IW_OUTER) ? A[buf_idx0 + i] : 0; )==""\n"
R"==(} )==""\n"
R"==(A_shuf = AS_DATA4_T(intel_sub_group_shuffle( )==""\n"
R"==(AS_BLOCK_DATA4_T(A_shuf), iw_off % IW_INNER)); )==""\n"
R"==(return A_shuf[iw_outer - iw_outer0]; )==""\n"
R"==(} )==""\n"
R"==(#define read_wei_and_multiply_w_vec(wei, kw, C, A) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \ )==""\n"
R"==(int ic_bound1 = min(IC_WO_PADDING, IC_BLOCK); \ )==""\n"
R"==(for (int ic_block = 0; ic_block < ic_bound1; ic_block += 8) { \ )==""\n"
R"==(int ic_bound2 = min(8, ic_bound1 - ic_block); \ )==""\n"
R"==(int off = wei_off(0, oc_outer * 16, ic_block, 0, 0, 0); \ )==""\n"
R"==(DATA_T B[8]; \ )==""\n"
R"==(unrolled_read(ic_bound2, B, &(wei)[off]); \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) \ )==""\n"
R"==(/* IC_INNER is 1 with W vectorization. */ \ )==""\n"
R"==(for (int ic_inner = 0; ic_inner < ic_bound2; ic_inner++) \ )==""\n"
R"==(for (int ow_outer = 0; ow_outer < OW_OUTER; \ )==""\n"
R"==(ow_outer++) { \ )==""\n"
R"==(int ow_bound = min( \ )==""\n"
R"==(OW_INNER, OW_BLOCK - ow_outer * OW_INNER); \ )==""\n"
R"==(for (int i = 0; i < ow_bound; i++) { \ )==""\n"
R"==(DATA_T A_val = shuffle_a_value(mb_block, \ )==""\n"
R"==(ic_block + ic_inner, ow_outer, i, \ )==""\n"
R"==((kw), (A)); \ )==""\n"
R"==(int c_off = dst_idx(mb_block, oc_outer, \ )==""\n"
R"==(ow_outer * OW_INNER + i); \ )==""\n"
R"==((C)[c_off] = fma(A_val, \ )==""\n"
R"==(B[ic_block + ic_inner], (C)[c_off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_wei_and_multiply(wei, kw, C, A) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (W_VEC) \ )==""\n"
R"==(read_wei_and_multiply_w_vec((wei), (kw), (C), (A)); \ )==""\n"
R"==(else \ )==""\n"
R"==(read_wei_and_multiply_c_vec((wei), (kw), (C), (A)); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define read_dst_block(block, ptr, ow) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (DST_NCHW) { \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \ )==""\n"
R"==(int n_channels = min(min(C_SIZE, OW - ow), OW_BLOCK); \ )==""\n"
R"==(bool w_oc_tail = BASE_OC_TAIL > 0 \ )==""\n"
R"==(&& OC_WO_PADDING - (ocb ? ocb : SUB_GROUP_SIZE) \ )==""\n"
R"==(< OC_BLOCK; \ )==""\n"
R"==(int loc_oc_tail = w_oc_tail ? BASE_OC_TAIL : SUB_GROUP_SIZE; \ )==""\n"
R"==(int oc_loop = (!w_oc_tail || sglid < loc_oc_tail) \ )==""\n"
R"==(? C_SIZE \ )==""\n"
R"==(: n_channels; \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < oc_loop; oc_outer += 1) { \ )==""\n"
R"==(int oc_tail_idx = ((sglid < loc_oc_tail \ )==""\n"
R"==(&& oc_outer >= n_channels) \ )==""\n"
R"==(? (sglid + (16 * (C_SIZE / OW_BLOCK - 1))) \ )==""\n"
R"==(: sglid); \ )==""\n"
R"==(int off = dst_off( \ )==""\n"
R"==(0, oc_tail_idx, 0, 0, (oc_outer % n_channels)); \ )==""\n"
R"==(int idx = oc_outer; \ )==""\n"
R"==(_BLOCK_READ_DST(&(block)[idx], 1, &(ptr)[off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} else { \ )==""\n"
R"==(int ow_bound = (OW % OW_BLOCK == 0) ? OW_BLOCK \ )==""\n"
R"==(: min(OW_BLOCK, OW - (ow)); \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) \ )==""\n"
R"==(for (int ow_block = 0; ow_block < ow_bound; ow_block++) { \ )==""\n"
R"==(int off = dst_off( \ )==""\n"
R"==(mb_block, oc_outer * 16, 0, 0, ow_block); \ )==""\n"
R"==(int idx = dst_idx(mb_block, oc_outer, ow_block); \ )==""\n"
R"==(if (DST_W32C) { \ )==""\n"
R"==(int off = dst_off( \ )==""\n"
R"==(mb_block, oc_outer * 16, 0, 0, 0); \ )==""\n"
R"==(int idx = dst_idx(mb_block, oc_outer, 0); \ )==""\n"
R"==(for (int i = 0; i < OW_BLOCK && ow + i < OW; \ )==""\n"
R"==(++i) { \ )==""\n"
R"==(*((DATA_T *)&(block)[idx + i]) \ )==""\n"
R"==(= CONVERT_DATA_T(BLOCK_READ_DST( \ )==""\n"
R"==(&(ptr)[off + (32 * i)])); \ )==""\n"
R"==(} \ )==""\n"
R"==(} else if (DST_32N32C) { \ )==""\n"
R"==(int off = dst_off(mb_block, \ )==""\n"
R"==(oc_outer * (DST_32N32C ? 32 : 16), 0, 0, \ )==""\n"
R"==(ow_block); \ )==""\n"
R"==(int idx = dst_idx(mb_block, oc_outer, ow_block); \ )==""\n"
R"==(mb_block ? mb_block += 31 : mb_block; \ )==""\n"
R"==(for (int i = 0; i < 16; ++i) { \ )==""\n"
R"==(*((DATA_T *)&(block)[idx + i]) \ )==""\n"
R"==(= CONVERT_DATA_T(BLOCK_READ_DST( \ )==""\n"
R"==(&(ptr)[off + (32 * i)])); \ )==""\n"
R"==(} \ )==""\n"
R"==(} else { \ )==""\n"
R"==((block)[idx] = _BLOCK_READ(&(ptr)[off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define write_dst_block(block, ptr, ow) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (DST_W16C || DST_W32C) { \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { \ )==""\n"
R"==(int off = dst_off(mb_block, oc_outer * 16, 0, 0, 0); \ )==""\n"
R"==(int idx = dst_idx(mb_block, oc_outer, 0); \ )==""\n"
R"==(if (DST_W32C) { \ )==""\n"
R"==(for (int i = 0; i < OW_BLOCK && ow + i < OW; ++i) { \ )==""\n"
R"==(unrolled_write(1, &(block)[idx + i], \ )==""\n"
R"==(&(ptr)[off + (32 * i)]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} else if (OW % OW_BLOCK == 0 || (ow) + OW_BLOCK <= OW) { \ )==""\n"
R"==(unrolled_write(OW_BLOCK, &(block)[idx], &(ptr)[off]); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(unrolled_write( \ )==""\n"
R"==(OW % OW_BLOCK, &(block)[idx], &(ptr)[off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} else if (DST_16N16C || DST_32N32C) { \ )==""\n"
R"==(int ow_bound = (OW % OW_BLOCK == 0) ? OW_BLOCK \ )==""\n"
R"==(: min(OW_BLOCK, OW - (ow)); \ )==""\n"
R"==(for (int ow_block = 0; ow_block < ow_bound; ow_block++) \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; \ )==""\n"
R"==(mb_block += (DST_32N32C ? 32 : 16)) { \ )==""\n"
R"==(int off = dst_off(mb_block, \ )==""\n"
R"==(oc_outer * (DST_32N32C ? 32 : 16), 0, 0, \ )==""\n"
R"==(ow_block); \ )==""\n"
R"==(int idx = dst_idx(mb_block, oc_outer, ow_block); \ )==""\n"
R"==(if (DST_32N32C && MB > 8) { \ )==""\n"
R"==(for (int i = 0; i < C_SIZE; ++i) { \ )==""\n"
R"==(unrolled_write(1, &(block)[idx + i], \ )==""\n"
R"==(&(ptr)[off + (32 * i)]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} else { \ )==""\n"
R"==(unrolled_write(min(16, MB_BLOCK), &(block)[idx], \ )==""\n"
R"==(&(ptr)[off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} else if (DST_32N16C) { \ )==""\n"
R"==(int ow_bound = (OW % OW_BLOCK == 0) ? OW_BLOCK \ )==""\n"
R"==(: min(OW_BLOCK, OW - (ow)); \ )==""\n"
R"==(for (int ow_block = 0; ow_block < ow_bound; ow_block++) \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; \ )==""\n"
R"==(mb_block += 32) { \ )==""\n"
R"==(int off = dst_off( \ )==""\n"
R"==(mb_block, oc_outer * 16, 0, 0, ow_block); \ )==""\n"
R"==(int idx = dst_idx(mb_block, oc_outer, ow_block); \ )==""\n"
R"==(unrolled_write(min(32, MB_BLOCK), &(block)[idx], \ )==""\n"
R"==(&(ptr)[off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} else if (DST_NCHW && sglid < OC_WO_PADDING - oc) { \ )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { \ )==""\n"
R"==(int n_channels = min(min(C_SIZE, OW - ow), OW_BLOCK); \ )==""\n"
R"==(bool w_oc_tail = BASE_OC_TAIL > 0 \ )==""\n"
R"==(&& OC_WO_PADDING - (ocb ? ocb : SUB_GROUP_SIZE) \ )==""\n"
R"==(< OC_BLOCK; \ )==""\n"
R"==(int loc_oc_tail = w_oc_tail ? BASE_OC_TAIL : SUB_GROUP_SIZE; \ )==""\n"
R"==(int oc_loop = (!w_oc_tail || sglid < loc_oc_tail) \ )==""\n"
R"==(? C_SIZE \ )==""\n"
R"==(: n_channels; \ )==""\n"
R"==(for (int oc_outer = 0; oc_outer < oc_loop; oc_outer += 1) { \ )==""\n"
R"==(int oc_tail_idx = ((sglid < loc_oc_tail \ )==""\n"
R"==(&& oc_outer >= n_channels) \ )==""\n"
R"==(? (sglid + (16 * (C_SIZE / OW_BLOCK - 1))) \ )==""\n"
R"==(: sglid); \ )==""\n"
R"==(int off = dst_off( \ )==""\n"
R"==(0, oc_tail_idx, 0, 0, (oc_outer % n_channels)); \ )==""\n"
R"==(int idx = oc_outer; \ )==""\n"
R"==(unrolled_write(1, &(block)[oc_outer], &(ptr)[off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define loop_ic_outermost(src, wei, C, id, ih, iw) \ )==""\n"
R"==(do { \ )==""\n"
R"==(__attribute__((opencl_unroll_hint(1))) /* attr:no-format */ \ )==""\n"
R"==(for (int ic = 0; ic < IC; ic += IC_BLOCK) { \ )==""\n"
R"==(__attribute__((opencl_unroll_hint(1))) /* attr:no-format */ \ )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { \ )==""\n"
R"==(if (HAS_PAD_D \ )==""\n"
R"==(&& ((id) + kd * (1 + DD) < 0 \ )==""\n"
R"==(|| (id) + kd * (1 + DD) >= ID)) \ )==""\n"
R"==(continue; \ )==""\n"
R"==(__attribute__((opencl_unroll_hint(1))) /* attr:no-format */ \ )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { \ )==""\n"
R"==(if (HAS_PAD_H \ )==""\n"
R"==(&& ((ih) + kh * (1 + DH) < 0 \ )==""\n"
R"==(|| (ih) + kh * (1 + DH) >= IH)) \ )==""\n"
R"==(continue; \ )==""\n"
R"==(const __global DATA_T *src1 = (src) \ )==""\n"
R"==(+ src_off(0, 0, kd * (1 + DD), kh * (1 + DH), 0); \ )==""\n"
R"==(DATA_T A_buf[MB_BLOCK * IC_OUTER * IW_OUTER] = {0}; \ )==""\n"
R"==(if (ENABLE_SRC_BUF) read_src_buf(A_buf, src1, (iw)); \ )==""\n"
R"==(__attribute__( \ )==""\n"
R"==((opencl_unroll_hint(KW))) /* attr:no-format */ \ )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { \ )==""\n"
R"==(const __global DATA_T *wei1 \ )==""\n"
R"==(= (wei) + wei_off(0, 0, 0, kd, kh, kw); \ )==""\n"
R"==(DATA_T B[IC_OUTER * OC_OUTER * IC_INNER]; \ )==""\n"
R"==(if (ENABLE_SRC_BUF) { \ )==""\n"
R"==(read_wei_and_multiply(wei1, kw, (C), A_buf); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(read_wei_block(B, wei1); \ )==""\n"
R"==(read_src_and_multiply(src1, (iw), kw, 1, (C), B); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==((src) += src_off(0, IC_BLOCK, 0, 0, 0); \ )==""\n"
R"==((wei) += wei_off(0, 0, IC_BLOCK, 0, 0, 0); \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define loop_kdhw_outermost(src, wei, C, id, ih, iw) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { \ )==""\n"
R"==(if (HAS_PAD_D \ )==""\n"
R"==(&& ((id) + kd * (1 + DD) < 0 \ )==""\n"
R"==(|| (id) + kd * (1 + DD) >= ID)) \ )==""\n"
R"==(continue; \ )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { \ )==""\n"
R"==(if (HAS_PAD_H \ )==""\n"
R"==(&& ((ih) + kh * (1 + DH) < 0 \ )==""\n"
R"==(|| (ih) + kh * (1 + DH) >= IH)) \ )==""\n"
R"==(continue; \ )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { \ )==""\n"
R"==(if (HAS_PAD_W \ )==""\n"
R"==(&& ((iw) + kw * (1 + DW) < 0 \ )==""\n"
R"==(|| (iw) + kw * (1 + DW) >= IW)) \ )==""\n"
R"==(continue; \ )==""\n"
R"==(/* XXX: kw offset is applied in read_src_and_multiply(). */ \ )==""\n"
R"==(const __global DATA_T *src1 = (src) \ )==""\n"
R"==(+ src_off(0, 0, kd * (1 + DD), kh * (1 + DH), 0); \ )==""\n"
R"==(const __global DATA_T *wei1 \ )==""\n"
R"==(= (wei) + wei_off(0, 0, 0, kd, kh, kw); \ )==""\n"
R"==(__attribute__((opencl_unroll_hint)) /* attr:no-format */ \ )==""\n"
R"==(for (int ic = 0; ic < IC; ic += IC_BLOCK) { \ )==""\n"
R"==(DATA_T B[IC_OUTER * OC_OUTER * IC_INNER]; \ )==""\n"
R"==(read_wei_block(B, wei1); \ )==""\n"
R"==(read_src_and_multiply(src1, (iw), kw, 0, (C), B); \ )==""\n"
R"==(src1 += src_off(0, IC_BLOCK, 0, 0, 0); \ )==""\n"
R"==(wei1 += wei_off(0, 0, IC_BLOCK, 0, 0, 0); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) __kernel void )==""\n"
R"==(gen9_conv_fwd(const __global DATA_T *src, const __global DATA_T *wei, )==""\n"
R"==(const __global DATA_T *bia, __global DST_DATA_T *dst POST_OP_ARGS) { )==""\n"
R"==(MAYBE_SKIP_NON_UNIFORM_WG(); )==""\n"
R"==(int sglid = get_sub_group_local_id(); )==""\n"
R"==(int g_ocb = get_group_id(0) * (LWS_0 / SUB_GROUP_SIZE) + get_sub_group_id(); )==""\n"
R"==(int g = g_ocb / (OCB / OC_BLOCK); )==""\n"
R"==(int ocb = g_ocb % (OCB / OC_BLOCK) * OC_BLOCK; )==""\n"
R"==(int odhw = get_group_id(1) / (OMB / MB_BLOCK); )==""\n"
R"==(int omb = get_group_id(1) % (OMB / MB_BLOCK) * MB_BLOCK; )==""\n"
R"==(int ohw = IS_3D ? odhw % (OWB * OHB) : odhw; )==""\n"
R"==(int od = IS_3D ? odhw / (OWB * OHB) : 0; )==""\n"
R"==(int oh = (ohw / OWB) * OH_BLOCK; )==""\n"
R"==(int ow = (ohw % OWB) * OW_BLOCK; )==""\n"
R"==(int ocb_idx_omb_idx = get_group_id(2); )==""\n"
R"==(int ocb_idx = ocb_idx_omb_idx / (MB / OMB); )==""\n"
R"==(int omb_idx = ocb_idx_omb_idx % (MB / OMB); )==""\n"
R"==(int oc = ocb_idx * OCB + ocb; )==""\n"
R"==(int mb = omb_idx * OMB + omb; )==""\n"
R"==(int ih = oh * SH - PH; )==""\n"
R"==(int iw = ow * SW - PW; )==""\n"
R"==(int id = od * SD - PD; )==""\n"
R"==(#if DT_F16 && C_SIZE == 8 )==""\n"
R"==(DATA8_T C = 0; )==""\n"
R"==(#elif DT_F16 && C_SIZE == 16 )==""\n"
R"==(DATA16_T C = 0; )==""\n"
R"==(#else )==""\n"
R"==(DATA_T C[C_SIZE] = {0}; )==""\n"
R"==(#endif )==""\n"
R"==(src += src_off(mb, g * IC, id, ih, iw); )==""\n"
R"==(wei += wei_off(g, oc, 0, 0, 0, 0); )==""\n"
R"==(dst += dst_off(mb, g * OC + oc, od, oh, ow); )==""\n"
R"==(if ((DST_32N32C || DST_W32C) && (OC_BLOCK % 32 != 0) )==""\n"
R"==(&& oc > OC_WO_PADDING) { )==""\n"
R"==(write_dst_block((DATA_T *)(&C), dst, ow); )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(for (int mb_block = 0; mb_block < MB_BLOCK; mb_block++) { )==""\n"
R"==(for (int oc_outer = 0; oc_outer < OC_OUTER; oc_outer++) { )==""\n"
R"==(const int bg_off = g * OC; )==""\n"
R"==(const int bc_off = oc + oc_outer * 16 + sglid; )==""\n"
R"==(#if (DT_F16 || DST_DT_U8 || DST_DT_S8) )==""\n"
R"==(#if OC_WO_PADDING == SUB_GROUP_SIZE && (DST_DT_U8 || DST_DT_S8) )==""\n"
R"==(if (OC_WO_PADDING % OC_BLOCK == 0 && bc_off < OC_WO_PADDING) { )==""\n"
R"==(#else )==""\n"
R"==(if (OC_WO_PADDING % OC_BLOCK == 0 || bc_off < OC_WO_PADDING) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int ow_block = 0; ow_block < OW_BLOCK; ow_block++) { )==""\n"
R"==(const int c_off = dst_idx(mb_block, oc_outer, ow_block); )==""\n"
R"==(C[c_off] = bia[bg_off + bc_off]; )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(#else )==""\n"
R"==(for (int ow_block = 0; ow_block < OW_BLOCK; ow_block++) { )==""\n"
R"==(const int c_off = dst_idx(mb_block, oc_outer, ow_block); )==""\n"
R"==(C[c_off] = (OC_WO_PADDING % OC_BLOCK == 0 )==""\n"
R"==(|| bc_off < OC_WO_PADDING) )==""\n"
R"==(? bia[bg_off + bc_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(#if OC_WO_PADDING == SUB_GROUP_SIZE && (DST_DT_U8 || DST_DT_S8) )==""\n"
R"==(const bool DO_MUL = ((OC_BLOCK * g_ocb) < OC_WO_PADDING); )==""\n"
R"==(#else )==""\n"
R"==(const bool DO_MUL = true; )==""\n"
R"==(#endif )==""\n"
R"==(if (OW_BLOCK == 1 && DO_MUL) { )==""\n"
R"==(loop_kdhw_outermost(src, wei, C, id, ih, iw); )==""\n"
R"==(} else if (DO_MUL) { )==""\n"
R"==(loop_ic_outermost(src, wei, C, id, ih, iw); )==""\n"
R"==(} )==""\n"
R"==(DATA_T S[MB_BLOCK * OC_OUTER * OW_BLOCK]; )==""\n"
R"==(if (WITH_SUM) { read_dst_block(S, dst, ow); } )==""\n"
R"==(#if WITH_POST_OP )==""\n"
R"==(if (OW_BLOCK == 1) { )==""\n"
R"==(const int po_mb = mb; )==""\n"
R"==(const int po_oc = (g * OC + oc) % (OC * G); )==""\n"
R"==(APPLY_POST_OPS_TRY_BURST(C, DATA_T, S, DATA_T, po_mb, MB_BLOCK, po_oc, )==""\n"
R"==(OC_OUTER * SUB_GROUP_SIZE, sglid); )==""\n"
R"==(} else { )==""\n"
R"==(unroll_for(int mb_idx = 0; mb_idx < MB_BLOCK; ++mb_idx) { )==""\n"
R"==(unroll_for(int oc_idx = 0; oc_idx < OC_OUTER; ++oc_idx) { )==""\n"
R"==(const int po_mb = (mb + mb_idx) % MB; )==""\n"
R"==(const int po_oc = (g * OC + oc + (oc_idx * 16)) % (OC * G); )==""\n"
R"==(float acc_ow[OW_BLOCK]; )==""\n"
R"==(float sum_ow[OW_BLOCK]; )==""\n"
R"==(unroll_for(int ow_idx = 0; ow_idx < OW_BLOCK; ++ow_idx) { )==""\n"
R"==(acc_ow[ow_idx] )==""\n"
R"==(= CONVERT_FLOAT_T(C[mb_idx * OC_OUTER * OW_BLOCK )==""\n"
R"==(+ oc_idx * OW_BLOCK + ow_idx]); )==""\n"
R"==(sum_ow[ow_idx] )==""\n"
R"==(= CONVERT_FLOAT_T(S[mb_idx * OC_OUTER * OW_BLOCK )==""\n"
R"==(+ oc_idx * OW_BLOCK + ow_idx]); )==""\n"
R"==(} )==""\n"
R"==(APPLY_POST_OPS_TRY_BURST(acc_ow, float, sum_ow, float, po_mb, 1, )==""\n"
R"==(po_oc, SUB_GROUP_SIZE, sglid); )==""\n"
R"==(unroll_for(int ow_idx = 0; ow_idx < OW_BLOCK; ++ow_idx) { )==""\n"
R"==(C[mb_idx * OC_OUTER * OW_BLOCK + oc_idx * OW_BLOCK + ow_idx] )==""\n"
R"==(= acc_ow[ow_idx]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(write_dst_block((DATA_T *)(&C), dst, ow); )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}