namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_nhwc_bwd_data_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if ID > 1 )==""\n"
R"==(#define CASE_3D 1 )==""\n"
R"==(#else )==""\n"
R"==(#define CASE_3D 0 )==""\n"
R"==(#endif )==""\n"
R"==(#define TRANSPOSE_1(_block, _col) \ )==""\n"
R"==((DATA_T)(intel_sub_group_shuffle(_block, _col)) )==""\n"
R"==(#define FMA1(a, b, c) fma((DATA_T)(a), (DATA_T)b, (DATA_T)c) )==""\n"
R"==(#define MULTIPLY_BLOCKS_8x8(_result, _blockA, _blockB, _blockB1) \ )==""\n"
R"==({ \ )==""\n"
R"==(_result = FMA1(_blockB.s0, TRANSPOSE_1(_blockA, 0), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s1, TRANSPOSE_1(_blockA, 1), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s2, TRANSPOSE_1(_blockA, 2), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s3, TRANSPOSE_1(_blockA, 3), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s4, TRANSPOSE_1(_blockA, 4), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s5, TRANSPOSE_1(_blockA, 5), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s6, TRANSPOSE_1(_blockA, 6), _result); \ )==""\n"
R"==(_result = FMA1(_blockB.s7, TRANSPOSE_1(_blockA, 7), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s0, TRANSPOSE_1(_blockA, 8), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s1, TRANSPOSE_1(_blockA, 9), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s2, TRANSPOSE_1(_blockA, 10), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s3, TRANSPOSE_1(_blockA, 11), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s4, TRANSPOSE_1(_blockA, 12), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s5, TRANSPOSE_1(_blockA, 13), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s6, TRANSPOSE_1(_blockA, 14), _result); \ )==""\n"
R"==(_result = FMA1(_blockB1.s7, TRANSPOSE_1(_blockA, 15), _result); \ )==""\n"
R"==(} )==""\n"
R"==(inline DATA_T read_oc_block(const __global DATA_T *ptr, int off) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if OC_WO_PADDING % OC_BLOCK != 0 )==""\n"
R"==(int tail = OC_WO_PADDING - off; )==""\n"
R"==(if (tail < OC_BLOCK) { )==""\n"
R"==(return (local_id < tail) ? AS_DATA_T(ptr[local_id]) : DATA_ZERO; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(if ((OC_WO_PADDING * sizeof(DATA_T)) % 4 != 0) )==""\n"
R"==(return ptr[local_id]; )==""\n"
R"==(else )==""\n"
R"==(return AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)(ptr))); )==""\n"
R"==(} )==""\n"
R"==(inline void write_ic_block(__global DATA_T *ptr, int off, DATA_T value) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if IC_WO_PADDING % IC_BLOCK != 0 )==""\n"
R"==(int tail = IC_WO_PADDING - off; )==""\n"
R"==(if (tail < IC_BLOCK) { )==""\n"
R"==(if (local_id < tail) ptr[local_id] = value; )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(if ((IC_WO_PADDING * sizeof(DATA_T)) % 16 != 0) )==""\n"
R"==(ptr[local_id] = value; )==""\n"
R"==(else )==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)ptr, AS_BLOCK_DATA_T(value)); )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))  )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE)))  )==""\n"
R"==(__kernel void )==""\n"
R"==(gen9_conv_nhwc_bwd_data(__global DATA_T *diff_src, __global DATA_T *wei, )==""\n"
R"==(__global DATA_T *diff_dst, __global DATA_T *bias) { )==""\n"
R"==(MAYBE_SKIP_NON_UNIFORM_WG(); )==""\n"
R"==(const int sp = get_group_id(1); )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(const int icb_mb = get_group_id(2); )==""\n"
R"==(const int mb = icb_mb / (G * IC_PADDED / ICB); )==""\n"
R"==(const int icb = icb_mb % (G * IC_PADDED / ICB); )==""\n"
R"==(const int ic = (icb * ICB) / IC_BLOCK + get_group_id(0); )==""\n"
R"==(const int g = ic / (IC_PADDED / IC_BLOCK); )==""\n"
R"==(const int gic = ic % (IC_PADDED / IC_BLOCK); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(const int id = sp / (IWB * IH); )==""\n"
R"==(const int ihw = sp % (IWB * IH); )==""\n"
R"==(#else )==""\n"
R"==(const int id = 0; )==""\n"
R"==(const int ihw = sp; )==""\n"
R"==(#endif )==""\n"
R"==(const int ih = ihw / IWB; )==""\n"
R"==(const int iw = (ihw % IWB) * IW_BLOCK; )==""\n"
R"==(diff_dst += mb * OC_WO_PADDING * G * OD * OH * OW + g * OC_WO_PADDING; )==""\n"
R"==(DATA_T blockC00[IW_BLOCK] = {DATA_ZERO}; )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(const int bg_off = g * IC; )==""\n"
R"==(const int bc_off = gic * IC_BLOCK + local_id; )==""\n"
R"==(DATA_T b = (IC_WO_PADDING % IC_BLOCK == 0 || bc_off < IC_WO_PADDING) )==""\n"
R"==(? bias[bg_off + bc_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(unroll_for(int i = 0; i < IW_BLOCK; ++i) { blockC00[i] = b; } )==""\n"
R"==(} )==""\n"
R"==(wei += gic * KD * KH * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(+ g * IC_PADDED * OC_PADDED * KD * KH * KW; )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) )==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) )==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) { )==""\n"
R"==(if (ih + PH < kh * (1 + DH)) continue; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(if (id + PD < kd * (1 + DD)) continue; )==""\n"
R"==(int od = id - kd * (1 + DD) + PD; )==""\n"
R"==(if (od % SD != 0) continue; )==""\n"
R"==(od /= SD; )==""\n"
R"==(if (od >= OD) continue; )==""\n"
R"==(#endif )==""\n"
R"==(int oh = ih - kh * (1 + DH) + PH; )==""\n"
R"==(if (oh % SH != 0) continue; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(if (oh >= OH) continue; )==""\n"
R"==(const __global DATA_T *diff_dst1 )==""\n"
R"==(= diff_dst + oh * OW * G * OC_WO_PADDING; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(diff_dst1 += od * OH * OW * G * OC_WO_PADDING; )==""\n"
R"==(#endif )==""\n"
R"==(const __global DATA_T *wei1 = wei )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(+ kd * KH * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(#endif )==""\n"
R"==(+ kh * KW * OC_BLOCK * IC_BLOCK )==""\n"
R"==(+ kw * OC_BLOCK * IC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(int oh = (ih + PH); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(int od = (id + PD); )==""\n"
R"==(#endif )==""\n"
R"==(bool do_ker = true; )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 )==""\n"
R"==(do_ker = oh % SH == 0; )==""\n"
R"==(oh /= SH; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(do_ker = do_ker && od % SD == 0; )==""\n"
R"==(od /= SD; )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(do_ker = do_ker && (oh < OH); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(do_ker = do_ker && (od < OD); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 || PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(if (do_ker) { )==""\n"
R"==(#endif )==""\n"
R"==(const __global DATA_T *diff_dst1 )==""\n"
R"==(= diff_dst + oh * OW * G * OC_WO_PADDING; )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(diff_dst1 += od * OH * OW * G * OC_WO_PADDING; )==""\n"
R"==(#endif )==""\n"
R"==(const __global DATA_T *wei1 = wei; )==""\n"
R"==(#endif )==""\n"
R"==(int ocb = 0; )==""\n"
R"==(do { )==""\n"
R"==(DATA8_T blockB00 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)wei1)); )==""\n"
R"==(DATA8_T blockB01 = AS_DATA8_T( )==""\n"
R"==(BLOCK_READ8((const __global BLOCK_DATA_T *)(wei1 )==""\n"
R"==(+ 8 * IC_BLOCK))); )==""\n"
R"==(DATA_T blockA[IW_BLOCK]; )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint(IW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(#if KW != 1 )==""\n"
R"==(if (iw + i + PW < kw * (1 + DW)) { )==""\n"
R"==(blockA[i] = 0.0; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(int ow = iw + i - kw * (1 + DW) + PW; )==""\n"
R"==(#else )==""\n"
R"==(int ow = iw + i + PW; )==""\n"
R"==(#endif )==""\n"
R"==(#if SW != 1 )==""\n"
R"==(if (ow % SW != 0) { )==""\n"
R"==(blockA[i] = 0.0; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(ow /= SW; )==""\n"
R"==(#endif )==""\n"
R"==(if (ow >= OW) { )==""\n"
R"==(blockA[i] = 0.0; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(blockA[i] = read_oc_block( )==""\n"
R"==(&diff_dst1[ow * G * OC_WO_PADDING], ocb); )==""\n"
R"==(} )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint(IW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(MULTIPLY_BLOCKS_8x8( )==""\n"
R"==(blockC00[i], blockA[i], blockB00, blockB01); )==""\n"
R"==(} )==""\n"
R"==(diff_dst1 += OC_BLOCK; )==""\n"
R"==(wei1 += KD * KH * KW * OC_BLOCK * IC_PADDED; )==""\n"
R"==(ocb += OC_BLOCK; )==""\n"
R"==(} while (ocb < OC); )==""\n"
R"==(#if SW != 1 || SH != 1 || SD != 1 || PH != 0 || PW != 0 || PD != 0 )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if KH != 1 || KW != 1 || KD != 1 )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(__global DATA_T *src_write0 = diff_src )==""\n"
R"==(+ mb * IC_WO_PADDING * G * ID * IH * IW )==""\n"
R"==(+ id * IH * IW * G * IC_WO_PADDING + ih * IW * G * IC_WO_PADDING )==""\n"
R"==(+ iw * G * IC_WO_PADDING + g * IC_WO_PADDING + gic * IC_BLOCK; )==""\n"
R"==(for (int i = 0; i < min(IW_BLOCK, IW - iw); i++) { )==""\n"
R"==(write_ic_block(&src_write0[i * G * IC_WO_PADDING], gic * IC_BLOCK, )==""\n"
R"==(blockC00[i]); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#undef TRANSPOSE_BLOCK_8 )==""\n"
R"==(#undef MULTIPLY_BLOCKS_8x8 )==""\n"
R"==()==";
}
}
}
}