namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_nhwc_bwd_weights_f32_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if ID > 1 )==""\n"
R"==(#define CASE_3D 1 )==""\n"
R"==(#else )==""\n"
R"==(#define CASE_3D 0 )==""\n"
R"==(#endif )==""\n"
R"==(#define DIV_UP(a, b) (((a) + (b)-1) / (b)) )==""\n"
R"==(#define RND_UP(a, b) (DIV_UP(a, b) * (b)) )==""\n"
R"==(#if BWD_WEIGHTS == 1 )==""\n"
R"==(inline float read_ic_block(const __global float *ptr, int off) { )==""\n"
R"==(#if (IS_DW ? G : IC) % IC_BLOCK != 0 )==""\n"
R"==(int tail = (IS_DW ? G : IC) - off; )==""\n"
R"==(if (tail < IC_BLOCK) { )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(return (sglid < tail) ? ptr[sglid] : 0.0f; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(return as_float(intel_sub_group_block_read((const __global uint *)ptr)); )==""\n"
R"==(} )==""\n"
R"==(inline float read_oc_block(const __global float *ptr, int off) { )==""\n"
R"==(#if (IS_DW ? G : OC_WO_PADDING) % OC_BLOCK != 0 )==""\n"
R"==(int tail = (IS_DW ? G : OC_WO_PADDING) - off; )==""\n"
R"==(if (tail < OC_BLOCK) { )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(return (sglid < tail) ? ptr[sglid] : 0.0f; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(return as_float(intel_sub_group_block_read((const __global uint *)ptr)); )==""\n"
R"==(} )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))  )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE)))  )==""\n"
R"==(__kernel void )==""\n"
R"==(gen9_conv_nhwc_bwd_weights(__global float *src, )==""\n"
R"==(volatile __global atomic_float *diff_wei, )==""\n"
R"==(volatile __global atomic_float *diff_bias, __global float *diff_dst) { )==""\n"
R"==(MAYBE_SKIP_NON_UNIFORM_WG(); )==""\n"
R"==(const int ksp = get_global_id(1); )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(const int kd = ksp / (KW * KH); )==""\n"
R"==(const int khw = ksp % (KW * KH); )==""\n"
R"==(#else )==""\n"
R"==(const int khw = ksp; )==""\n"
R"==(const int kd = 0; )==""\n"
R"==(#endif )==""\n"
R"==(const int kh = khw / KW; )==""\n"
R"==(const int kw = khw % KW; )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(const int chunk = get_global_id(2) % NCHUNK; )==""\n"
R"==(const int icb_ocb = get_global_id(2) / NCHUNK; )==""\n"
R"==(const int icb = icb_ocb % DIV_UP(IC, ICB); )==""\n"
R"==(const int ocb = icb_ocb / DIV_UP(IC, ICB); )==""\n"
R"==(const int ic_padded = RND_UP(IC, IC_BLOCK); )==""\n"
R"==(const int oc_padded = RND_UP(OC, OC_BLOCK); )==""\n"
R"==(#if IS_DW )==""\n"
R"==(const int g = 0; )==""\n"
R"==(const int oc )==""\n"
R"==(= get_group_id(0) * (LWS_0 / SUB_GROUP_SIZE) + get_sub_group_id(); )==""\n"
R"==(const int ic = oc; )==""\n"
R"==(#else )==""\n"
R"==(const int g_ic_oc = get_global_id(0); )==""\n"
R"==(const int g = g_ic_oc / (oc_padded * DIV_UP(IC, IC_BLOCK)); )==""\n"
R"==(const int io = g_ic_oc % (oc_padded * DIV_UP(IC, IC_BLOCK)); )==""\n"
R"==(const int oc = (io % OCB) / OC_BLOCK + ocb * (OCB / OC_BLOCK); )==""\n"
R"==(const int ic = (IC == 3) ? 0 : (io / OCB + icb * (ICB / IC_BLOCK)); )==""\n"
R"==(#endif )==""\n"
R"==(const int sp_chunk = chunk % OSP_CHUNK; )==""\n"
R"==(const int mb_chunk = chunk / OSP_CHUNK; )==""\n"
R"==(const int ow_nb = (OW + OWB - 1) / OWB; )==""\n"
R"==(const int oh_nb = (OH + OHB - 1) / OHB; )==""\n"
R"==(const int od_beg = ((sp_chunk / ow_nb) / oh_nb) * ODB; )==""\n"
R"==(const int oh_beg = ((sp_chunk / ow_nb) % oh_nb) * OHB; )==""\n"
R"==(const int ow_beg = (sp_chunk % ow_nb) * OWB; )==""\n"
R"==(const int mb = mb_chunk * MB_CHUNK_SIZE; )==""\n"
R"==(const int mb_end = min((mb_chunk + 1) * MB_CHUNK_SIZE, MB); )==""\n"
R"==(const bool do_bias = (ic == 0 || IS_DW) && kh == 0 && kw == 0 && kd == 0; )==""\n"
R"==(src += mb * ID * IH * IW * G * IC; )==""\n"
R"==(src += g * IC + ic * IC_BLOCK; )==""\n"
R"==(diff_dst += g * OC_WO_PADDING + oc * OC_BLOCK; )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(diff_bias += g * OC_WO_PADDING + oc * OC_BLOCK + sglid; )==""\n"
R"==(float bias_loc = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(float8 blockC00 = 0.0f; )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(float blockC00 = 0.0f; )==""\n"
R"==(#else )==""\n"
R"==(float8 blockC00 = 0.0f; )==""\n"
R"==(float8 blockC01 = 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(for (int omb = mb; omb < mb_end; omb++) { )==""\n"
R"==(const __global float *diff_dst1_ )==""\n"
R"==(= diff_dst + omb * OD * OH * OW * G * OC_WO_PADDING; )==""\n"
R"==(for (int od = od_beg; od < min(od_beg + ODB, OD); od++) )==""\n"
R"==(for (int oh = oh_beg; oh < min(oh_beg + OHB, OH); oh++) { )==""\n"
R"==(const __global float *diff_dst1 = diff_dst1_ )==""\n"
R"==(+ (od * OH * OW + oh * OW) * G * OC_WO_PADDING; )==""\n"
R"==(if (oh * SH + kh * (1 + DH) < PH )==""\n"
R"==(|| oh * SH + kh * (1 + DH) >= IH + PH )==""\n"
R"==(#if CASE_3D )==""\n"
R"==(|| od * SD + kd * (1 + DD) < PD )==""\n"
R"==(|| od * SD + kd * (1 + DD) >= ID + PD )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(if (do_bias) { )==""\n"
R"==(for (int ow = ow_beg; ow < ow_beg + OWB; )==""\n"
R"==(ow += OW_BLOCK) { )==""\n"
R"==(float8 blockB; )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(if (ow + i >= OW) { )==""\n"
R"==(blockB[i] = 0.0; )==""\n"
R"==(} else { )==""\n"
R"==(blockB[i] = read_oc_block( )==""\n"
R"==(&diff_dst1[(ow + i) * G )==""\n"
R"==(* OC_WO_PADDING], )==""\n"
R"==(oc * OC_BLOCK); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(for (int ow = ow_beg; ow < ow_beg + OWB; ow += OW_BLOCK) { )==""\n"
R"==(const int id = od * SD - PD + kd * (1 + DD); )==""\n"
R"==(const int ih = oh * SH - PH + kh * (1 + DH); )==""\n"
R"==(const int iw = ow * SW - PW + kw * (1 + DW); )==""\n"
R"==(__global float *src1 )==""\n"
R"==(= src + (id * IH * IW + ih * IW + iw) * G * IC; )==""\n"
R"==(#define TRANSPOSE_8(_block, _row, _col) \ )==""\n"
R"==({ \ )==""\n"
R"==((float8)(intel_sub_group_shuffle(_block[_row], 0 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 1 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 2 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 3 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 4 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 5 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 6 + _col), \ )==""\n"
R"==(intel_sub_group_shuffle(_block[_row], 7 + _col)) \ )==""\n"
R"==(} )==""\n"
R"==(#define FMA8(a, b, c) fma((float8)(a), (float8)b, (float8)c) )==""\n"
R"==(#define MULTIPLY_BLOCKS_8x8(_result, _blockA, _blockB, col) \ )==""\n"
R"==({ \ )==""\n"
R"==(_result = FMA8(_blockB.s0, TRANSPOSE_8(_blockA, 0, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s1, TRANSPOSE_8(_blockA, 1, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s2, TRANSPOSE_8(_blockA, 2, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s3, TRANSPOSE_8(_blockA, 3, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s4, TRANSPOSE_8(_blockA, 4, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s5, TRANSPOSE_8(_blockA, 5, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s6, TRANSPOSE_8(_blockA, 6, col), _result); \ )==""\n"
R"==(_result = FMA8(_blockB.s7, TRANSPOSE_8(_blockA, 7, col), _result); \ )==""\n"
R"==(} )==""\n"
R"==(float8 blockA, blockB; )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(if (sglid < IC) { )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(if (iw + i * SW < 0 || iw + i * SW >= IW) { )==""\n"
R"==(blockA[i] = 0; )==""\n"
R"==(} else { )==""\n"
R"==(blockA[i] = src1[i * SW * G * IC + sglid]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(blockA = 0.0f; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(__attribute__((opencl_unroll_hint(8)))  )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(if (iw + i * SW < 0 || iw + i * SW >= IW) { )==""\n"
R"==(blockA[i] = 0; )==""\n"
R"==(} else { )==""\n"
R"==(blockA[i] = read_ic_block( )==""\n"
R"==(&src1[i * SW * G * IC], ic * IC_BLOCK); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__((opencl_unroll_hint(8)))  )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(if (ow + i >= OW) { )==""\n"
R"==(blockB[i] = 0.0; )==""\n"
R"==(} else { )==""\n"
R"==(blockB[i] = read_oc_block( )==""\n"
R"==(&diff_dst1[(ow + i) * G * OC_WO_PADDING], )==""\n"
R"==(oc * OC_BLOCK); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC00, blockA, blockB, 0); )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(blockC00 = fma(blockA[i], blockB[i], blockC00); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC00, blockA, blockB, 0); )==""\n"
R"==(MULTIPLY_BLOCKS_8x8(blockC01, blockA, blockB, 8); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(bias_loc += blockB[i]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(src += ID * IH * IW * G * IC; )==""\n"
R"==(} )==""\n"
R"==(#if WITH_BIAS == 1 )==""\n"
R"==(if (do_bias && oc * OC_BLOCK + sglid < (IS_DW ? G : OC_WO_PADDING)) )==""\n"
R"==(atomic_add_global(diff_bias, bias_loc); )==""\n"
R"==(#endif )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(diff_wei += g * oc_padded * ic_padded * KD * KH * KW; )==""\n"
R"==(diff_wei += oc * KD * KH * KW * ic_padded * OC_BLOCK; )==""\n"
R"==(diff_wei += (kd * KH * KW + kh * KW + kw) * ic_padded * OC_BLOCK; )==""\n"
R"==(for (int i = 0; i < 3; i++) )==""\n"
R"==(atomic_add_global(diff_wei + i * OC_BLOCK + sglid, blockC00[i]); )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(diff_wei += oc * KD * KH * KW * OC_BLOCK; )==""\n"
R"==(diff_wei += (kd * KH * KW + kh * KW + kw) * OC_BLOCK; )==""\n"
R"==(atomic_add_global(diff_wei + sglid, blockC00); )==""\n"
R"==(#else )==""\n"
R"==(diff_wei += g * ic_padded * oc_padded * KD * KH * KW; )==""\n"
R"==(diff_wei += ic * oc_padded * KD * KH * KW * IC_BLOCK; )==""\n"
R"==(diff_wei += oc * KD * KH * KW * IC_BLOCK * OC_BLOCK; )==""\n"
R"==(diff_wei += (kd * KH * KW + kh * KW + kw) * IC_BLOCK * OC_BLOCK; )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(atomic_add_global(diff_wei + i * OC_BLOCK + sglid, blockC00[i]); )==""\n"
R"==(for (int i = 0; i < 8; i++) )==""\n"
R"==(atomic_add_global(diff_wei + (8 + i) * OC_BLOCK + sglid, blockC01[i]); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}