namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_conv_nhwc_fwd_data_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define _BLOCK_READ8(ptr) \ )==""\n"
R"==(AS_DATA8_T(BLOCK_READ8((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ4(ptr) \ )==""\n"
R"==(AS_DATA4_T(BLOCK_READ4((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ2(ptr) \ )==""\n"
R"==(AS_DATA2_T(BLOCK_READ2((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_READ(ptr) \ )==""\n"
R"==(AS_DATA_T(BLOCK_READ((const __global BLOCK_DATA_T *)(ptr))) )==""\n"
R"==(#define _BLOCK_WRITE8(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE8((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA8_T(v)) )==""\n"
R"==(#define _BLOCK_WRITE4(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE4((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA4_T(v)) )==""\n"
R"==(#define _BLOCK_WRITE2(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE2((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA2_T(v)) )==""\n"
R"==(#define _BLOCK_WRITE(ptr, v) \ )==""\n"
R"==(BLOCK_WRITE((__global BLOCK_DATA_T *)(ptr), AS_BLOCK_DATA_T(v)) )==""\n"
R"==(#define ENABLE_KW_BUF (KW >= 5) )==""\n"
R"==(#define IS_3D (OD > 1) )==""\n"
R"==(#define KDHW_SIZE (KD * KH * KW) )==""\n"
R"==(#define HAS_PAD_D (PD > 0 || OD * SD - PD + (KD - 1) * (1 + DD) >= ID) )==""\n"
R"==(#define HAS_PAD_H (PH > 0 || OH * SH - PH + (KH - 1) * (1 + DH) >= IH) )==""\n"
R"==(#define HAS_PAD_W (PW > 0 || OW * SW - PW + (KW - 1) * (1 + DW) >= IW) )==""\n"
R"==(#define OC_PAD_BLOCK (OC % OC_BLOCK ? (OC / OC_BLOCK + 1) * OC_BLOCK : OC) )==""\n"
R"==(#if DT_F32 )==""\n"
R"==(#define BLOCK_READ_BOUND 1 )==""\n"
R"==(#define BLOCK_WRITE_BOUND 4 )==""\n"
R"==(#elif DT_F16 )==""\n"
R"==(#define BLOCK_READ_BOUND 2 )==""\n"
R"==(#define BLOCK_WRITE_BOUND 8 )==""\n"
R"==(#else )==""\n"
R"==(#error "Wrong Data Type" )==""\n"
R"==(#endif )==""\n"
R"==(inline DATA_T read_ic_block(const __global DATA_T *ptr, int off) { )==""\n"
R"==(const int local_id = get_local_id(0); )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(return (local_id < IC) ? *ptr : 0; )==""\n"
R"==(#else )==""\n"
R"==(#if (IS_DW ? G_WO_PADDING : IC_WO_PADDING) % IC_BLOCK != 0 )==""\n"
R"==(int tail = (IS_DW ? G_WO_PADDING : IC_WO_PADDING) - off; )==""\n"
R"==(if (tail < IC_BLOCK) { return (local_id < tail) ? ptr[local_id] : 0; } )==""\n"
R"==(#endif )==""\n"
R"==(#if (IS_DW ? G_WO_PADDING : IC_WO_PADDING) % BLOCK_READ_BOUND != 0 )==""\n"
R"==(return ptr[local_id]; )==""\n"
R"==(#else )==""\n"
R"==(return _BLOCK_READ(ptr); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(inline DATA_T read_oc_block(const __global DATA_T *ptr, int off) { )==""\n"
R"==(const int local_id = get_local_id(0); )==""\n"
R"==(#if (IS_DW ? G_WO_PADDING : OC_WO_PADDING) % OC_BLOCK != 0 )==""\n"
R"==(int tail = (IS_DW ? G_WO_PADDING : OC_WO_PADDING) - off; )==""\n"
R"==(if (tail < OC_BLOCK) { return (local_id < tail) ? ptr[local_id] : 0; } )==""\n"
R"==(#endif )==""\n"
R"==(#if (IS_DW ? G_WO_PADDING : OC_WO_PADDING) % BLOCK_READ_BOUND != 0 )==""\n"
R"==(return ptr[local_id]; )==""\n"
R"==(#else )==""\n"
R"==(return _BLOCK_READ(ptr); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(inline void write_oc_block(__global DATA_T *ptr, int off, DATA_T value) { )==""\n"
R"==(const int local_id = get_local_id(0); )==""\n"
R"==(#if (IS_DW ? G_WO_PADDING : OC_WO_PADDING) % OC_BLOCK != 0 )==""\n"
R"==(int tail = (IS_DW ? G_WO_PADDING : OC_WO_PADDING) - off; )==""\n"
R"==(if (tail < OC_BLOCK) { )==""\n"
R"==(if (local_id < tail) ptr[local_id] = value; )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if (IS_DW ? G_WO_PADDING : OC_WO_PADDING) % BLOCK_WRITE_BOUND != 0 )==""\n"
R"==(ptr[local_id] = value; )==""\n"
R"==(return; )==""\n"
R"==(#else )==""\n"
R"==(return _BLOCK_WRITE(ptr, value); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(void multiply_blocks_8x8_ic3(DATA_T *res, DATA_T blockA, const DATA_T *blockB) { )==""\n"
R"==(*res = fma(blockB[0], intel_sub_group_shuffle(blockA, 0), *res); )==""\n"
R"==(*res = fma(blockB[1], intel_sub_group_shuffle(blockA, 1), *res); )==""\n"
R"==(*res = fma(blockB[2], intel_sub_group_shuffle(blockA, 2), *res); )==""\n"
R"==(} )==""\n"
R"==(void multiply_blocks_8x8( )==""\n"
R"==(DATA_T *res, DATA_T blockA, DATA8_T blockB0, DATA8_T blockB1) { )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(*res = fma(blockB0[i], intel_sub_group_shuffle(blockA, i), *res); )==""\n"
R"==(} )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(*res = fma(blockB1[i], intel_sub_group_shuffle(blockA, 8 + i), *res); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) __kernel void )==""\n"
R"==(gen9_conv_nhwc_fwd(const __global DATA_T *src, const __global DATA_T *wei, )==""\n"
R"==(const __global DATA_T *bias, __global DATA_T *dst POST_OP_ARGS) { )==""\n"
R"==(MAYBE_SKIP_NON_UNIFORM_WG(); )==""\n"
R"==(const int sp = get_group_id(1); )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(const int ocb_mb = get_group_id(2); )==""\n"
R"==(const int ocb = ocb_mb / (MB); )==""\n"
R"==(const int mb = ocb_mb % (MB); )==""\n"
R"==(#if IS_DW )==""\n"
R"==(const int oc = get_group_id(0); )==""\n"
R"==(const int g = 0; )==""\n"
R"==(const int goc = oc; )==""\n"
R"==(#else )==""\n"
R"==(const int oc = (ocb * OCB) / OC_BLOCK + get_group_id(0); )==""\n"
R"==(const int g = oc / (OC_PAD_BLOCK / OC_BLOCK); )==""\n"
R"==(const int goc = oc % (OC_PAD_BLOCK / OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(const int od = IS_3D ? sp / (OWB * OHB) : 0; )==""\n"
R"==(const int ohw = IS_3D ? sp % (OWB * OHB) : sp; )==""\n"
R"==(const int id = IS_3D ? od * SD - PD : 0; )==""\n"
R"==(const int oh = (ohw / OWB) * OH_BLOCK; )==""\n"
R"==(const int ow = (ohw % OWB) * OW_BLOCK; )==""\n"
R"==(DATA_T blockC00[OW_BLOCK] = {0}; )==""\n"
R"==(if (WITH_BIAS) { )==""\n"
R"==(const int bc_off = oc * OC_BLOCK + local_id; )==""\n"
R"==(#if IS_DW )==""\n"
R"==(DATA_T b = (G_WO_PADDING % OC_BLOCK == 0 || bc_off < G_WO_PADDING) )==""\n"
R"==(#else )==""\n"
R"==(DATA_T b = (OC_WO_PADDING % OC_BLOCK == 0 || bc_off < OC_WO_PADDING) )==""\n"
R"==(#endif )==""\n"
R"==(? bias[bc_off] )==""\n"
R"==(: DATA_ZERO; )==""\n"
R"==(unroll_for(int i = 0; i < OW_BLOCK; i++) { blockC00[i] = b; } )==""\n"
R"==(} )==""\n"
R"==(int ih = oh * SH - PH; )==""\n"
R"==(int iw = ow * SW - PW; )==""\n"
R"==(src += mb * ID * IH * IW * G * IC_WO_PADDING; )==""\n"
R"==(src += (id * IH * IW + ih * IW + iw) * G * IC_WO_PADDING; )==""\n"
R"==(src += g * IC_WO_PADDING; )==""\n"
R"==(src += (IS_DW ? oc * OC_BLOCK : 0); )==""\n"
R"==(wei += goc * KDHW_SIZE * OC_BLOCK * IC + g * IC * OC_PAD_BLOCK * KDHW_SIZE; )==""\n"
R"==(#if (KD == 1 && KH == 1) && (HAS_PAD_D || HAS_PAD_H) )==""\n"
R"==(const bool dh_out_of_range = (id < 0 || id >= ID || ih < 0 || ih >= IH); )==""\n"
R"==(#else )==""\n"
R"==(const bool dh_out_of_range = false; )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_DW )==""\n"
R"==(const int icb_min = goc * OC_BLOCK; )==""\n"
R"==(const int icb_max = icb_min + OC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(const int icb_min = 0; )==""\n"
R"==(const int icb_max = dh_out_of_range ? 0 : (IC == 3 ? 1 : IC); )==""\n"
R"==(#endif )==""\n"
R"==(for (int icb = icb_min; icb < icb_max; icb += IC_BLOCK) { )==""\n"
R"==(__attribute__((opencl_unroll_hint(1)))  )==""\n"
R"==(for (int kd = 0; kd < KD; ++kd) { )==""\n"
R"==(#if HAS_PAD_D )==""\n"
R"==(if (id + kd * (1 + DD) < 0 || id + kd * (1 + DD) >= ID) continue; )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__((opencl_unroll_hint(1)))  )==""\n"
R"==(for (int kh = 0; kh < KH; ++kh) { )==""\n"
R"==(#if HAS_PAD_H )==""\n"
R"==(if (ih + kh * (1 + DH) < 0 || ih + kh * (1 + DH) >= IH) )==""\n"
R"==(continue; )==""\n"
R"==(#endif )==""\n"
R"==(const __global DATA_T *src1 = src )==""\n"
R"==(+ kd * (1 + DD) * IH * IW * G * IC_WO_PADDING )==""\n"
R"==(+ kh * (1 + DH) * IW * G * IC_WO_PADDING; )==""\n"
R"==(if (IC == 3) src1 += local_id; )==""\n"
R"==(#if ENABLE_KW_BUF )==""\n"
R"==(DATA_T tempA[SW * OW_BLOCK + KW * (1 + DW)] = {0}; )==""\n"
R"==(__attribute__((opencl_unroll_hint( )==""\n"
R"==(SW * OW_BLOCK + KW * (1 + DW))))  )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK + KW * (1 + DW); i++) { )==""\n"
R"==(if ((i + iw) >= 0 && (i + iw) < IW) { )==""\n"
R"==(tempA[i] = read_ic_block( )==""\n"
R"==(&src1[i * G * IC_WO_PADDING], icb); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__((opencl_unroll_hint(KW)))  )==""\n"
R"==(for (int kw = 0; kw < KW; ++kw) { )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(const __global DATA_T *wei1 = wei )==""\n"
R"==(+ (kd * KH * KW + kh * KW + kw) * IC * OC_BLOCK; )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(const __global DATA_T *wei1 )==""\n"
R"==(= wei + (kd * KH * KW + kh * KW + kw) * OC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(const __global DATA_T *wei1 = wei )==""\n"
R"==(+ (kd * KH * KW + kh * KW + kw) * IC_BLOCK )==""\n"
R"==(* OC_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(DATA_T blockA[OW_BLOCK] = {0}; )==""\n"
R"==(#if ENABLE_KW_BUF )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint(OW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(blockA[i] = tempA[i * SW + kw * (1 + DW)]; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint(OW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(int iw_off = i * SW + kw * (1 + DW); )==""\n"
R"==(if (iw + iw_off >= 0 && iw + iw_off < IW) { )==""\n"
R"==(blockA[i] = read_ic_block( )==""\n"
R"==(&src1[iw_off * G * IC_WO_PADDING], icb); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(DATA_T blockB[IC]; )==""\n"
R"==(__attribute__((opencl_unroll_hint(IC)))  )==""\n"
R"==(for (int i = 0; i < IC; i++) { )==""\n"
R"==(blockB[i] = _BLOCK_READ(wei1 + i * OC_BLOCK); )==""\n"
R"==(} )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint(OW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(multiply_blocks_8x8_ic3( )==""\n"
R"==(&blockC00[i], blockA[i], blockB); )==""\n"
R"==(} )==""\n"
R"==(#elif IS_DW )==""\n"
R"==(DATA_T blockB = _BLOCK_READ(wei1); )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(blockC00[i] = fma(blockA[i], blockB, blockC00[i]); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(DATA8_T blockB00 = _BLOCK_READ8(wei1); )==""\n"
R"==(DATA8_T blockB01 = _BLOCK_READ8(wei1 + 8 * OC_BLOCK); )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint(OW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(multiply_blocks_8x8( )==""\n"
R"==(&blockC00[i], blockA[i], blockB00, blockB01); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(src += IC_BLOCK; )==""\n"
R"==(wei += KDHW_SIZE * IC_BLOCK * OC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(__global DATA_T *dst_write0 = dst + mb * OD * OH * OW * G * OC_WO_PADDING; )==""\n"
R"==(dst_write0 += (od * OH * OW + oh * OW + ow) * G * OC_WO_PADDING; )==""\n"
R"==(dst_write0 += g * OC_WO_PADDING + goc * OC_BLOCK; )==""\n"
R"==(DATA_T blockS00[OW_BLOCK]; )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(for (int i = 0; i < min(OW_BLOCK, OW - ow); i++) { )==""\n"
R"==(blockS00[i] = read_oc_block( )==""\n"
R"==(&dst_write0[i * G * OC_WO_PADDING], goc * OC_BLOCK); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(const int po_mb = (mb) % MB; )==""\n"
R"==(const int po_oc = (oc * OC_BLOCK + local_id) % (OC * G); )==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D( )==""\n"
R"==(blockC00, DATA_T, blockS00, DATA_T, po_mb, 1, po_oc, 1); )==""\n"
R"==(for (int i = 0; i < min(OW_BLOCK, OW - ow); i++) { )==""\n"
R"==(write_oc_block(&dst_write0[i * G * OC_WO_PADDING], goc * OC_BLOCK, )==""\n"
R"==(blockC00[i]); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}