namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_gemm_compute_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define GRX 8 )==""\n"
R"==(#if DT_F32 == 1 )==""\n"
R"==(#if UNROLL_M <= 1 * GRX )==""\n"
R"==(#define FLOATX float )==""\n"
R"==(#define SIZEX 1 )==""\n"
R"==(#elif UNROLL_M <= 2 * GRX )==""\n"
R"==(#define FLOATX float2 )==""\n"
R"==(#define SIZEX 2 )==""\n"
R"==(#elif UNROLL_M <= 3 * GRX )==""\n"
R"==(#define FLOATX float3 )==""\n"
R"==(#define SIZEX 3 )==""\n"
R"==(#else )==""\n"
R"==(#define FLOATX float4 )==""\n"
R"==(#define SIZEX 4 )==""\n"
R"==(#endif )==""\n"
R"==(#if UNROLL_N <= 1 * GRX )==""\n"
R"==(#define FLOATY float )==""\n"
R"==(#define SIZEY 1 )==""\n"
R"==(#elif UNROLL_N <= 2 * GRX )==""\n"
R"==(#define FLOATY float2 )==""\n"
R"==(#define SIZEY 2 )==""\n"
R"==(#elif UNROLL_N <= 3 * GRX )==""\n"
R"==(#define FLOATY float3 )==""\n"
R"==(#define SIZEY 3 )==""\n"
R"==(#else )==""\n"
R"==(#define FLOATY float4 )==""\n"
R"==(#define SIZEY 4 )==""\n"
R"==(#endif )==""\n"
R"==(#define SHUFFLE(X, Y) intel_sub_group_shuffle(X, Y) )==""\n"
R"==(#define SHUFFLE_DOWN(X, Y) intel_sub_group_shuffle_down(X, X, Y) )==""\n"
R"==(#define SHUFFLE_UP(X, Y) intel_sub_group_shuffle_up(X, X, Y) )==""\n"
R"==(#elif DT_F16 == 1 )==""\n"
R"==(#if UNROLL_M <= 1 * GRX )==""\n"
R"==(#define FLOATX half )==""\n"
R"==(#define SIZEX 1 )==""\n"
R"==(#elif UNROLL_M <= 2 * GRX )==""\n"
R"==(#define FLOATX half2 )==""\n"
R"==(#define SIZEX 2 )==""\n"
R"==(#elif UNROLL_M <= 3 * GRX )==""\n"
R"==(#define FLOATX half3 )==""\n"
R"==(#define SIZEX 3 )==""\n"
R"==(#elif UNROLL_M <= 4 * GRX )==""\n"
R"==(#define FLOATX half4 )==""\n"
R"==(#define SIZEX 4 )==""\n"
R"==(#else )==""\n"
R"==(#define FLOATX half8 )==""\n"
R"==(#define SIZEX 8 )==""\n"
R"==(#endif )==""\n"
R"==(#if UNROLL_N <= 1 * GRX )==""\n"
R"==(#define FLOATY half )==""\n"
R"==(#define SIZEY 1 )==""\n"
R"==(#elif UNROLL_N <= 2 * GRX )==""\n"
R"==(#define FLOATY half2 )==""\n"
R"==(#define SIZEY 2 )==""\n"
R"==(#elif UNROLL_N <= 3 * GRX )==""\n"
R"==(#define FLOATY half3 )==""\n"
R"==(#define SIZEY 3 )==""\n"
R"==(#elif UNROLL_N <= 4 * GRX )==""\n"
R"==(#define FLOATY half4 )==""\n"
R"==(#define SIZEY 4 )==""\n"
R"==(#else )==""\n"
R"==(#define FLOATY half8 )==""\n"
R"==(#define SIZEY 8 )==""\n"
R"==(#endif )==""\n"
R"==(#if SIZEY == 2 )==""\n"
R"==(#define SHUFFLE(X, Y) as_half2(intel_sub_group_shuffle(as_float(X), Y)) )==""\n"
R"==(#elif SIZEY == 4 )==""\n"
R"==(#define SHUFFLE(X, Y) as_half4(intel_sub_group_shuffle(as_float2(X), Y)) )==""\n"
R"==(#else )==""\n"
R"==(#define SHUFFLE(X, Y) as_half8(intel_sub_group_shuffle(as_float4(X), Y)) )==""\n"
R"==(#endif )==""\n"
R"==(#if SIZEX == 2 )==""\n"
R"==(#define SHUFFLE_UP(X, Y) \ )==""\n"
R"==(as_half2(intel_sub_group_shuffle_up(as_float(X), as_float(X), Y)) )==""\n"
R"==(#define SHUFFLE_DOWN(X, Y) \ )==""\n"
R"==(as_half2(intel_sub_group_shuffle_down(as_float(X), as_float(X), Y)) )==""\n"
R"==(#elif SIZEX == 4 )==""\n"
R"==(#define SHUFFLE_UP(X, Y) \ )==""\n"
R"==(as_half4(intel_sub_group_shuffle_up(as_float2(X), as_float2(X), Y)) )==""\n"
R"==(#define SHUFFLE_DOWN(X, Y) \ )==""\n"
R"==(as_half4(intel_sub_group_shuffle_down(as_float2(X), as_float2(X), Y)) )==""\n"
R"==(#else )==""\n"
R"==(#define SHUFFLE_UP(X, Y) \ )==""\n"
R"==(as_half8(intel_sub_group_shuffle_up(as_float4(X), as_float4(X), Y)) )==""\n"
R"==(#define SHUFFLE_DOWN(X, Y) \ )==""\n"
R"==(as_half8(intel_sub_group_shuffle_down(as_float4(X), as_float4(X), Y)) )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#define AS_FLOATX(X, Y) *((__global FLOATX *)(X + Y)) )==""\n"
R"==(#define AS_FLOATY(X, Y) *((__global FLOATY *)(X + Y)) )==""\n"
R"==(#if UNROLL_M <= 1 * GRX )==""\n"
R"==(#define CALC_X(x, a, b, R0, R1, R2, R3) \ )==""\n"
R"==(bb = SHUFFLE(b, x); \ )==""\n"
R"==(R0##x = mad(a, bb, R0##x); )==""\n"
R"==(#elif UNROLL_M <= 2 * GRX )==""\n"
R"==(#define CALC_X(x, a, b, R0, R1, R2, R3) \ )==""\n"
R"==(bb = SHUFFLE(b, x); \ )==""\n"
R"==(R0##x = mad(a.s0, bb, R0##x); \ )==""\n"
R"==(R1##x = mad(a.s1, bb, R1##x); )==""\n"
R"==(#elif UNROLL_M <= 3 * GRX )==""\n"
R"==(#define CALC_X(x, a, b, R0, R1, R2, R3) \ )==""\n"
R"==(bb = SHUFFLE(b, x); \ )==""\n"
R"==(R0##x = mad(a.s0, bb, R0##x); \ )==""\n"
R"==(R1##x = mad(a.s1, bb, R1##x); \ )==""\n"
R"==(R2##x = mad(a.s2, bb, R2##x); )==""\n"
R"==(#else )==""\n"
R"==(#define CALC_X(x, a, b, R0, R1, R2, R3) \ )==""\n"
R"==(bb = SHUFFLE(b, x); \ )==""\n"
R"==(R0##x = mad(a.s0, bb, R0##x); \ )==""\n"
R"==(R1##x = mad(a.s1, bb, R1##x); \ )==""\n"
R"==(R2##x = mad(a.s2, bb, R2##x); \ )==""\n"
R"==(R3##x = mad(a.s3, bb, R3##x); )==""\n"
R"==(#endif )==""\n"
R"==(#define CALC(a, b, R0, R1, R2, R3) \ )==""\n"
R"==(CALC_X(0, a, b, R0, R1, R2, R3); \ )==""\n"
R"==(CALC_X(1, a, b, R0, R1, R2, R3); \ )==""\n"
R"==(CALC_X(2, a, b, R0, R1, R2, R3); \ )==""\n"
R"==(CALC_X(3, a, b, R0, R1, R2, R3); \ )==""\n"
R"==(CALC_X(4, a, b, R0, R1, R2, R3); \ )==""\n"
R"==(CALC_X(5, a, b, R0, R1, R2, R3); \ )==""\n"
R"==(CALC_X(6, a, b, R0, R1, R2, R3); \ )==""\n"
R"==(CALC_X(7, a, b, R0, R1, R2, R3); )==""\n"
R"==(#define INIT_C(n) \ )==""\n"
R"==(FLOATY cc##n##0 = DATA_ZERO, cc##n##1 = DATA_ZERO; \ )==""\n"
R"==(FLOATY cc##n##2 = DATA_ZERO, cc##n##3 = DATA_ZERO; \ )==""\n"
R"==(FLOATY cc##n##4 = DATA_ZERO, cc##n##5 = DATA_ZERO; \ )==""\n"
R"==(FLOATY cc##n##6 = DATA_ZERO, cc##n##7 = DATA_ZERO; )==""\n"
R"==(#if WITH_ELTWISE == 1 )==""\n"
R"==(#define POST_OP(val) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (last_k_block) \ )==""\n"
R"==(val = fwd_eltwise( \ )==""\n"
R"==(val, eltwise_alpha, eltwise_beta, eltwise_scale); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define POST_OP(val) )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef BETA_ZERO )==""\n"
R"==(#define UPDATE(c, acc) \ )==""\n"
R"==(do { \ )==""\n"
R"==(DATA_T val = acc; \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(c = REF_TO_DST(val); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define UPDATE(c, acc) \ )==""\n"
R"==(do { \ )==""\n"
R"==(DATA_T val = DST_TO_REF(c) + acc; \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(c = REF_TO_DST(val); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#if SIZEX == 1 )==""\n"
R"==(#define UPDATE_YY(X, Y, R0, R1, R2, R3) \ )==""\n"
R"==(if (n > (Y)) { \ )==""\n"
R"==(if ((m > 0)) { UPDATE(c[offsetC + 0], R0); } \ )==""\n"
R"==(offsetC += ldc; \ )==""\n"
R"==(} )==""\n"
R"==(#elif SIZEX == 2 )==""\n"
R"==(#define UPDATE_YY(X, Y, R0, R1, R2, R3) \ )==""\n"
R"==(if (n > (Y)) { \ )==""\n"
R"==(if ((m > 0)) { UPDATE(c[offsetC + 0], R0); } \ )==""\n"
R"==(if ((m > 1)) { UPDATE(c[offsetC + 1], R1); } \ )==""\n"
R"==(offsetC += ldc; \ )==""\n"
R"==(} )==""\n"
R"==(#elif SIZEX == 3 )==""\n"
R"==(#define UPDATE_YY(X, Y, R0, R1, R2, R3) \ )==""\n"
R"==(if (n > (Y)) { \ )==""\n"
R"==(if ((m > 0)) { UPDATE(c[offsetC + 0], R0); } \ )==""\n"
R"==(if ((m > 1)) { UPDATE(c[offsetC + 1], R1); } \ )==""\n"
R"==(if ((m > 2)) { UPDATE(c[offsetC + 2], R2); } \ )==""\n"
R"==(offsetC += ldc; \ )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#define UPDATE_YY(X, Y, R0, R1, R2, R3) \ )==""\n"
R"==(if (n > (Y)) { \ )==""\n"
R"==(if ((m > 0)) { UPDATE(c[offsetC + 0], R0); } \ )==""\n"
R"==(if ((m > 1)) { UPDATE(c[offsetC + 1], R1); } \ )==""\n"
R"==(if ((m > 2)) { UPDATE(c[offsetC + 2], R2); } \ )==""\n"
R"==(if ((m > 3)) { UPDATE(c[offsetC + 3], R3); } \ )==""\n"
R"==(offsetC += ldc; \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SIZEY == 1 )==""\n"
R"==(#define UPDATE_Y(X, R0, R1, R2, R3) \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 0, R0##X, R1##X, R2##X, R3##X); )==""\n"
R"==(#elif SIZEY == 2 )==""\n"
R"==(#define UPDATE_Y(X, R0, R1, R2, R3) \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 0, R0##X.s0, R1##X.s0, R2##X.s0, R3##X.s0); \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 1, R0##X.s1, R1##X.s1, R2##X.s1, R3##X.s1); )==""\n"
R"==(#elif SIZEY == 3 )==""\n"
R"==(#define UPDATE_Y(X, R0, R1, R2, R3) \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 0, R0##X.s0, R1##X.s0, R2##X.s0, R3##X.s0); \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 1, R0##X.s1, R1##X.s1, R2##X.s1, R3##X.s1); \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 2, R0##X.s2, R1##X.s2, R2##X.s2, R3##X.s2); )==""\n"
R"==(#else )==""\n"
R"==(#define UPDATE_Y(X, R0, R1, R2, R3) \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 0, R0##X.s0, R1##X.s0, R2##X.s0, R3##X.s0); \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 1, R0##X.s1, R1##X.s1, R2##X.s1, R3##X.s1); \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 2, R0##X.s2, R1##X.s2, R2##X.s2, R3##X.s2); \ )==""\n"
R"==(UPDATE_YY(X, X *SIZEY + 3, R0##X.s3, R1##X.s3, R2##X.s3, R3##X.s3); )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(GRX))) __kernel void gen9_gemm_compute( )==""\n"
R"==(long m, long n, long k, __global DATA_T *base, int offsetA, int offsetB, )==""\n"
R"==(__global DST_DATA_T *c, long offsetC, long ldc, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale) { )==""\n"
R"==(int idx, idy, lid; )==""\n"
R"==(idx = get_group_id(0); )==""\n"
R"==(idy = get_group_id(1) * get_enqueued_local_size(1) + get_local_id(1); )==""\n"
R"==(lid = get_local_id(0);  )==""\n"
R"==(m -= UNROLL_M * idx; )==""\n"
R"==(if (m > UNROLL_M) m = UNROLL_M; )==""\n"
R"==(n -= UNROLL_N * idy; )==""\n"
R"==(if (n > UNROLL_N) n = UNROLL_N; )==""\n"
R"==(m -= UNROLL_M * lid / GRX; )==""\n"
R"==(offsetA += UNROLL_M * k * idx + UNROLL_M * lid / GRX; )==""\n"
R"==(offsetB += UNROLL_N * k * idy + UNROLL_N * lid / GRX; )==""\n"
R"==(offsetC += UNROLL_M * idx + UNROLL_N * ldc * idy + UNROLL_M * lid / GRX; )==""\n"
R"==(INIT_C(0); )==""\n"
R"==(INIT_C(1); )==""\n"
R"==(INIT_C(2); )==""\n"
R"==(INIT_C(3); )==""\n"
R"==(INIT_C(4); )==""\n"
R"==(INIT_C(5); )==""\n"
R"==(INIT_C(6); )==""\n"
R"==(INIT_C(7); )==""\n"
R"==(FLOATX blockA = AS_FLOATX(base, offsetA); )==""\n"
R"==(offsetA += UNROLL_M; )==""\n"
R"==(FLOATY blockB = AS_FLOATY(base, offsetB); )==""\n"
R"==(offsetB += UNROLL_N; )==""\n"
R"==(for (int l = k; l > 0; l--) { )==""\n"
R"==(FLOATY bb; )==""\n"
R"==(CALC(blockA, blockB, cc0, cc1, cc2, cc3); )==""\n"
R"==(blockB = AS_FLOATY(base, offsetB); )==""\n"
R"==(offsetB += UNROLL_N; )==""\n"
R"==(blockA = AS_FLOATX(base, offsetA); )==""\n"
R"==(offsetA += UNROLL_M; )==""\n"
R"==(} )==""\n"
R"==(UPDATE_Y(0, cc0, cc1, cc2, cc3); )==""\n"
R"==(#if UNROLL_N >= 2 * SIZEY )==""\n"
R"==(UPDATE_Y(1, cc0, cc1, cc2, cc3); )==""\n"
R"==(#endif )==""\n"
R"==(#if UNROLL_N >= 3 * SIZEY )==""\n"
R"==(UPDATE_Y(2, cc0, cc1, cc2, cc3); )==""\n"
R"==(#endif )==""\n"
R"==(#if UNROLL_N >= 4 * SIZEY )==""\n"
R"==(UPDATE_Y(3, cc0, cc1, cc2, cc3); )==""\n"
R"==(#endif )==""\n"
R"==(#if UNROLL_N >= 5 * SIZEY )==""\n"
R"==(UPDATE_Y(4, cc0, cc1, cc2, cc3); )==""\n"
R"==(#endif )==""\n"
R"==(#if UNROLL_N >= 6 * SIZEY )==""\n"
R"==(UPDATE_Y(5, cc0, cc1, cc2, cc3); )==""\n"
R"==(#endif )==""\n"
R"==(#if UNROLL_N >= 7 * SIZEY )==""\n"
R"==(UPDATE_Y(6, cc0, cc1, cc2, cc3); )==""\n"
R"==(#endif )==""\n"
R"==(#if UNROLL_N >= 8 * SIZEY )==""\n"
R"==(UPDATE_Y(7, cc0, cc1, cc2, cc3); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}