namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_gemm_copy_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/gemm/ocl_gemm_attrs.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(__kernel void gen9_gemm_copy(long m, long n, __global SRC_DATA_T *a, )==""\n"
R"==(long offseta, long lda, __global float *alpha, __global DATA_T *b, )==""\n"
R"==(long offsetb) { )==""\n"
R"==(int idx = get_group_id(0); )==""\n"
R"==(int idy = get_group_id(1) * COPY_UNROLL; )==""\n"
R"==(int i; )==""\n"
R"==(#ifdef USE_TRANS )==""\n"
R"==(offseta += (idy + idx * lda);  )==""\n"
R"==(#else )==""\n"
R"==(offseta += (idx + idy * lda);  )==""\n"
R"==(#endif )==""\n"
R"==(offsetb += (idy * m + idx * COPY_UNROLL); )==""\n"
R"==(n -= idy; )==""\n"
R"==(for (i = 0; i < COPY_UNROLL; i++) { )==""\n"
R"==(b[offsetb] )==""\n"
R"==(= (i < n) ? (ATTR_ALPHA * SRC_TO_REF(a[offseta])) : DATA_ZERO; )==""\n"
R"==(#ifdef USE_TRANS )==""\n"
R"==(offseta++; )==""\n"
R"==(#else )==""\n"
R"==(offseta += lda; )==""\n"
R"==(#endif )==""\n"
R"==(offsetb++; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}