namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_gemm_nocopy_f16_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/gemm/ocl_gemm_attrs.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable )==""\n"
R"==(#define VLOAD4_ALIGNED(o, p) *((global half4 *)p + o) )==""\n"
R"==(#if !defined(TRANS_A) )==""\n"
R"==(#if !defined(TRANS_B) )==""\n"
R"==(#define NN )==""\n"
R"==(#define DO_FMA DO_FMA_NN )==""\n"
R"==(#else )==""\n"
R"==(#define NT )==""\n"
R"==(#define DO_FMA DO_FMA_NT )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(#if !defined(TRANS_B) )==""\n"
R"==(#define TN )==""\n"
R"==(#define DO_FMA DO_FMA_TN )==""\n"
R"==(#else )==""\n"
R"==(#define TT )==""\n"
R"==(#define DO_FMA DO_FMA_TT )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#define DO_FMA_NN(h, i, i_mod_2, i_div_2, i_mod_16, i_div_16) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i][0] = mad(sub_group_broadcast(a[h].s##i_mod_2, i_div_2), \ )==""\n"
R"==(b[0].s##h, c[i][0]); \ )==""\n"
R"==(c[i][1] = mad(sub_group_broadcast(a[h].s##i_mod_2, i_div_2), \ )==""\n"
R"==(b[1].s##h, c[i][1]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_NT(h, i, i_mod_2, i_div_2, i_mod_16, i_div_16) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i][0] = mad(sub_group_broadcast(a[h].s##i_mod_2, i_div_2), b[h].s0, \ )==""\n"
R"==(c[i][0]); \ )==""\n"
R"==(c[i][1] = mad(sub_group_broadcast(a[h].s##i_mod_2, i_div_2), b[h].s1, \ )==""\n"
R"==(c[i][1]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_TN(h, i, i_mod_2, i_div_2, i_mod_16, i_div_16) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i][0] = mad(sub_group_broadcast(a[i_div_16].s##h, i_mod_16), \ )==""\n"
R"==(b[0].s##h, c[i][0]); \ )==""\n"
R"==(c[i][1] = mad(sub_group_broadcast(a[i_div_16].s##h, i_mod_16), \ )==""\n"
R"==(b[1].s##h, c[i][1]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_TT(h, i, i_mod_2, i_div_2, i_mod_16, i_div_16) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i][0] = mad(sub_group_broadcast(a[i_div_16].s##h, i_mod_16), \ )==""\n"
R"==(b[h].s0, c[i][0]); \ )==""\n"
R"==(c[i][1] = mad(sub_group_broadcast(a[i_div_16].s##h, i_mod_16), \ )==""\n"
R"==(b[h].s1, c[i][1]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#if WITH_ELTWISE == 1 )==""\n"
R"==(#define POST_OP(val) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (last_k_block && last_k_unroll) \ )==""\n"
R"==(val = fwd_eltwise( \ )==""\n"
R"==(val, eltwise_alpha, eltwise_beta, eltwise_scale); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define POST_OP(val) )==""\n"
R"==(#endif )==""\n"
R"==(#define FMA_I_LOOP(h) \ )==""\n"
R"==(do { \ )==""\n"
R"==(DO_FMA(h, 0, 0, 0, 0, 0); \ )==""\n"
R"==(DO_FMA(h, 1, 1, 0, 1, 0); \ )==""\n"
R"==(DO_FMA(h, 2, 0, 1, 2, 0); \ )==""\n"
R"==(DO_FMA(h, 3, 1, 1, 3, 0); \ )==""\n"
R"==(DO_FMA(h, 4, 0, 2, 4, 0); \ )==""\n"
R"==(DO_FMA(h, 5, 1, 2, 5, 0); \ )==""\n"
R"==(DO_FMA(h, 6, 0, 3, 6, 0); \ )==""\n"
R"==(DO_FMA(h, 7, 1, 3, 7, 0); \ )==""\n"
R"==(DO_FMA(h, 8, 0, 4, 8, 0); \ )==""\n"
R"==(DO_FMA(h, 9, 1, 4, 9, 0); \ )==""\n"
R"==(DO_FMA(h, 10, 0, 5, 10, 0); \ )==""\n"
R"==(DO_FMA(h, 11, 1, 5, 11, 0); \ )==""\n"
R"==(DO_FMA(h, 12, 0, 6, 12, 0); \ )==""\n"
R"==(DO_FMA(h, 13, 1, 6, 13, 0); \ )==""\n"
R"==(DO_FMA(h, 14, 0, 7, 14, 0); \ )==""\n"
R"==(DO_FMA(h, 15, 1, 7, 15, 0); \ )==""\n"
R"==(DO_FMA(h, 16, 0, 8, 0, 1); \ )==""\n"
R"==(DO_FMA(h, 17, 1, 8, 1, 1); \ )==""\n"
R"==(DO_FMA(h, 18, 0, 9, 2, 1); \ )==""\n"
R"==(DO_FMA(h, 19, 1, 9, 3, 1); \ )==""\n"
R"==(DO_FMA(h, 20, 0, 10, 4, 1); \ )==""\n"
R"==(DO_FMA(h, 21, 1, 10, 5, 1); \ )==""\n"
R"==(DO_FMA(h, 22, 0, 11, 6, 1); \ )==""\n"
R"==(DO_FMA(h, 23, 1, 11, 7, 1); \ )==""\n"
R"==(DO_FMA(h, 24, 0, 12, 8, 1); \ )==""\n"
R"==(DO_FMA(h, 25, 1, 12, 9, 1); \ )==""\n"
R"==(DO_FMA(h, 26, 0, 13, 10, 1); \ )==""\n"
R"==(DO_FMA(h, 27, 1, 13, 11, 1); \ )==""\n"
R"==(DO_FMA(h, 28, 0, 14, 12, 1); \ )==""\n"
R"==(DO_FMA(h, 29, 1, 14, 13, 1); \ )==""\n"
R"==(DO_FMA(h, 30, 0, 15, 14, 1); \ )==""\n"
R"==(DO_FMA(h, 31, 1, 15, 15, 1); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C_ROW(i, betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (irem > i) { \ )==""\n"
R"==(if (jrem > 0) { \ )==""\n"
R"==(half val \ )==""\n"
R"==(= ATTR_ALPHA * c[i][0] + ((betaZero) ? 0 : beta * *C); \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*C = val; \ )==""\n"
R"==(} \ )==""\n"
R"==(if (jrem > 16) { \ )==""\n"
R"==(half val = ATTR_ALPHA * c[i][1] \ )==""\n"
R"==(+ ((betaZero) ? 0 : beta * *C2); \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*C2 = val; \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(C++; \ )==""\n"
R"==(C2++; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C(betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(UPDATE_C_ROW(0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(4, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(5, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(6, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(7, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(8, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(9, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(10, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(11, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(12, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(13, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(14, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(15, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(16, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(17, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(18, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(19, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(20, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(21, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(22, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(23, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(24, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(25, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(26, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(27, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(28, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(29, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(30, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(31, betaZero); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#ifdef NN )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_f16(global half *A, global half *B, global half *C, )==""\n"
R"==(long offset_a, long offset_b, long offset_c, int lda, int ldb, int ldc, )==""\n"
R"==(int m, int n, int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(, )==""\n"
R"==(volatile global int *flag, long offset_f) { )==""\n"
R"==(#else )==""\n"
R"==() { )==""\n"
R"==(#endif )==""\n"
R"==(half2 a[4];  )==""\n"
R"==(half4 b[2];  )==""\n"
R"==(half c[32][2];  )==""\n"
R"==(int idM = get_global_id(1); )==""\n"
R"==(int idN = get_global_id(0); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int idK = get_global_id(2); )==""\n"
R"==(int nku = get_global_size(2); )==""\n"
R"==(int i0 = idM * 32; )==""\n"
R"==(int j0 = sub_group_broadcast(idN, 0) * 2 + lid; )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int irem2 = (irem + 1) >> 1; )==""\n"
R"==(int last_k_unroll = (idK == nku - 1); )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(int k0 = idK * UNROLL_K; )==""\n"
R"==(int kt = k - k0; )==""\n"
R"==(if (kt < 0) kt = 0; )==""\n"
R"==(if (kt > UNROLL_K) kt = UNROLL_K; )==""\n"
R"==(A += offset_a + i0 + k0 * lda; )==""\n"
R"==(B += offset_b + j0 * ldb + k0; )==""\n"
R"==(k = kt; )==""\n"
R"==(#else )==""\n"
R"==(A += offset_a + i0; )==""\n"
R"==(B += offset_b + j0 * ldb; )==""\n"
R"==(#endif )==""\n"
R"==(C += offset_c + i0 + j0 * ldc; )==""\n"
R"==(global half *A_ptrs[4] = {A, A + lda, A + 2 * lda, A + 3 * lda}; )==""\n"
R"==(global half *B_ptrs[2] = {B, B + 16 * ldb}; )==""\n"
R"==(for (int y = 0; y < 32; y++) )==""\n"
R"==(for (int z = 0; z < 2; z++) )==""\n"
R"==(c[y][z] = 0; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(flag += offset_f + idM; )==""\n"
R"==(if (idK == 0 && lid == 0) *flag = 0; )==""\n"
R"==(#endif )==""\n"
R"==(int k_align = k & ~3; )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem >= 32 && sub_group_broadcast(jrem, 0) >= 32) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) )==""\n"
R"==(a[hh] = as_half2(intel_sub_group_block_read( )==""\n"
R"==((global uint *)(A_ptrs[hh] + h * lda))); )==""\n"
R"==(for (int j = 0; j < 2; j++) )==""\n"
R"==(b[j] = VLOAD4_ALIGNED(0, (B_ptrs[j] + h)); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(FMA_I_LOOP(1); )==""\n"
R"==(FMA_I_LOOP(2); )==""\n"
R"==(FMA_I_LOOP(3); )==""\n"
R"==(} )==""\n"
R"==(for (int h = k_align; h < k; h++) { )==""\n"
R"==(a[0] = as_half2(intel_sub_group_block_read( )==""\n"
R"==((global uint *)(A_ptrs[0] + h * lda))); )==""\n"
R"==(for (int j = 0; j < 2; j++) )==""\n"
R"==(b[j] = B_ptrs[j][h]; )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(if (irem2 > lid) )==""\n"
R"==(a[hh] = as_half2( )==""\n"
R"==(*((global uint *)(A_ptrs[hh] + h * lda) + lid)); )==""\n"
R"==(} )==""\n"
R"==(for (int j = 0; j < 2; j++) )==""\n"
R"==(if (jrem > j * 16) b[j] = VLOAD4_ALIGNED(0, (B_ptrs[j] + h)); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(FMA_I_LOOP(1); )==""\n"
R"==(FMA_I_LOOP(2); )==""\n"
R"==(FMA_I_LOOP(3); )==""\n"
R"==(} )==""\n"
R"==(for (int h = k_align; h < k; h++) { )==""\n"
R"==(if (irem2 > lid) )==""\n"
R"==(a[0] = as_half2(*((global uint *)(A_ptrs[0] + h * lda) + lid)); )==""\n"
R"==(for (int j = 0; j < 2; j++) )==""\n"
R"==(if (jrem > j * 16) b[j] = B_ptrs[j][h]; )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(global half *C2 = C + 16 * ldc; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(do { )==""\n"
R"==(read_mem_fence(CLK_GLOBAL_MEM_FENCE); )==""\n"
R"==(} while (*flag != idK); )==""\n"
R"==(if (idK == 0) { )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} else { )==""\n"
R"==(beta = 1.0; )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} )==""\n"
R"==(if (lid == 0) *flag = idK + 1; )==""\n"
R"==(#else )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef NT )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_f16(global half *A, global half *B, global half *C, )==""\n"
R"==(long offset_a, long offset_b, long offset_c, int lda, int ldb, int ldc, )==""\n"
R"==(int m, int n, int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(, )==""\n"
R"==(volatile global int *flag, long offset_f) { )==""\n"
R"==(#else )==""\n"
R"==() { )==""\n"
R"==(#endif )==""\n"
R"==(half2 a[4];  )==""\n"
R"==(half2 b[4];  )==""\n"
R"==(half c[32][2];  )==""\n"
R"==(int idM = get_global_id(1); )==""\n"
R"==(int idN = get_global_id(0); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int idK = get_global_id(2); )==""\n"
R"==(int nku = get_global_size(2); )==""\n"
R"==(int i0 = idM * 32; )==""\n"
R"==(int j00 = sub_group_broadcast(idN, 0) * 2; )==""\n"
R"==(int j0 = j00 + lid; )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int irem2 = (irem + 1) >> 1; )==""\n"
R"==(int last_k_unroll = (idK == nku - 1); )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(int k0 = idK * UNROLL_K; )==""\n"
R"==(int kt = k - k0; )==""\n"
R"==(if (kt < 0) kt = 0; )==""\n"
R"==(if (kt > UNROLL_K) kt = UNROLL_K; )==""\n"
R"==(A += offset_a + i0 + k0 * lda; )==""\n"
R"==(B += offset_b + j00 + k0 * ldb; )==""\n"
R"==(k = kt; )==""\n"
R"==(#else )==""\n"
R"==(A += offset_a + i0; )==""\n"
R"==(B += offset_b + j00; )==""\n"
R"==(#endif )==""\n"
R"==(C += offset_c + i0 + j0 * ldc; )==""\n"
R"==(global half *A_ptrs[4] = {A, A + lda, A + 2 * lda, A + 3 * lda}; )==""\n"
R"==(global half *B_ptrs[4] = {B, B + ldb, B + 2 * ldb, B + 3 * ldb}; )==""\n"
R"==(for (int y = 0; y < 32; y++) )==""\n"
R"==(for (int z = 0; z < 2; z++) )==""\n"
R"==(c[y][z] = 0; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(flag += offset_f + idM; )==""\n"
R"==(if (idK == 0 && lid == 0) *flag = 0; )==""\n"
R"==(#endif )==""\n"
R"==(int k_align = k & ~3; )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem >= 32 && sub_group_broadcast(jrem, 0) >= 32) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(a[hh] = as_half2(intel_sub_group_block_read( )==""\n"
R"==((global uint *)(A_ptrs[hh] + h * lda))); )==""\n"
R"==(b[hh] = as_half2(intel_sub_group_block_read_us2( )==""\n"
R"==((global ushort *)(B_ptrs[hh] + h * ldb))); )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(FMA_I_LOOP(1); )==""\n"
R"==(FMA_I_LOOP(2); )==""\n"
R"==(FMA_I_LOOP(3); )==""\n"
R"==(} )==""\n"
R"==(for (int h = k_align; h < k; h++) { )==""\n"
R"==(a[0] = as_half2(intel_sub_group_block_read( )==""\n"
R"==((global uint *)(A_ptrs[0] + h * lda))); )==""\n"
R"==(b[0] = as_half2(intel_sub_group_block_read_us2( )==""\n"
R"==((global ushort *)(B_ptrs[0] + h * ldb))); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(if (irem2 > lid) )==""\n"
R"==(a[hh] = as_half2( )==""\n"
R"==(*((global uint *)(A_ptrs[hh] + h * lda) + lid)); )==""\n"
R"==(if (jrem > 0) b[hh].s0 = B_ptrs[hh][h * ldb + lid]; )==""\n"
R"==(if (jrem > 16) b[hh].s1 = B_ptrs[hh][h * ldb + lid + 16]; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(FMA_I_LOOP(1); )==""\n"
R"==(FMA_I_LOOP(2); )==""\n"
R"==(FMA_I_LOOP(3); )==""\n"
R"==(} )==""\n"
R"==(for (int h = k_align; h < k; h++) { )==""\n"
R"==(if (irem2 > lid) )==""\n"
R"==(a[0] = as_half2(*((global uint *)(A_ptrs[0] + h * lda) + lid)); )==""\n"
R"==(if (jrem > 0) b[0].s0 = B_ptrs[0][h * ldb + lid]; )==""\n"
R"==(if (jrem > 16) b[0].s1 = B_ptrs[0][h * ldb + lid + 16]; )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(global half *C2 = C + 16 * ldc; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(do { )==""\n"
R"==(read_mem_fence(CLK_GLOBAL_MEM_FENCE); )==""\n"
R"==(} while (*flag != idK); )==""\n"
R"==(if (idK == 0) { )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} else { )==""\n"
R"==(beta = 1.0; )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} )==""\n"
R"==(if (lid == 0) *flag = idK + 1; )==""\n"
R"==(#else )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef TN )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_f16(global half *A, global half *B, global half *C, )==""\n"
R"==(long offset_a, long offset_b, long offset_c, int lda, int ldb, int ldc, )==""\n"
R"==(int m, int n, int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(, )==""\n"
R"==(volatile global int *flag, long offset_f) { )==""\n"
R"==(#else )==""\n"
R"==() { )==""\n"
R"==(#endif )==""\n"
R"==(half4 a[2];  )==""\n"
R"==(half4 b[2];  )==""\n"
R"==(half c[32][2];  )==""\n"
R"==(int idM = get_global_id(1); )==""\n"
R"==(int idN = get_global_id(0); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int idK = get_global_id(2); )==""\n"
R"==(int nku = get_global_size(2); )==""\n"
R"==(int i0 = idM * 32; )==""\n"
R"==(int j0 = sub_group_broadcast(idN, 0) * 2 + lid; )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int last_k_unroll = (idK == nku - 1); )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(int k0 = idK * UNROLL_K; )==""\n"
R"==(int kt = k - k0; )==""\n"
R"==(if (kt < 0) kt = 0; )==""\n"
R"==(if (kt > UNROLL_K) kt = UNROLL_K; )==""\n"
R"==(A += offset_a + (i0 + lid) * lda + k0; )==""\n"
R"==(B += offset_b + j0 * ldb + k0; )==""\n"
R"==(k = kt; )==""\n"
R"==(#else )==""\n"
R"==(A += offset_a + (i0 + lid) * lda; )==""\n"
R"==(B += offset_b + j0 * ldb; )==""\n"
R"==(#endif )==""\n"
R"==(C += offset_c + i0 + j0 * ldc; )==""\n"
R"==(global half *A_ptrs[2] = {A, A + 16 * lda}; )==""\n"
R"==(global half *B_ptrs[2] = {B, B + 16 * ldb}; )==""\n"
R"==(for (int y = 0; y < 32; y++) )==""\n"
R"==(for (int z = 0; z < 2; z++) )==""\n"
R"==(c[y][z] = 0; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(flag += offset_f + idM; )==""\n"
R"==(if (idK == 0 && lid == 0) *flag = 0; )==""\n"
R"==(#endif )==""\n"
R"==(int k_align = k & ~3; )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem >= 32 && sub_group_broadcast(jrem, 0) >= 32) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(a[z] = VLOAD4_ALIGNED(0, (A_ptrs[z] + h)); )==""\n"
R"==(b[z] = VLOAD4_ALIGNED(0, (B_ptrs[z] + h)); )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(FMA_I_LOOP(1); )==""\n"
R"==(FMA_I_LOOP(2); )==""\n"
R"==(FMA_I_LOOP(3); )==""\n"
R"==(} )==""\n"
R"==(for (int h = k_align; h < k; h++) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(a[z] = A_ptrs[z][h]; )==""\n"
R"==(b[z] = B_ptrs[z][h]; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(if (irem > (lid + z * 16)) )==""\n"
R"==(a[z] = VLOAD4_ALIGNED(0, (A_ptrs[z] + h)); )==""\n"
R"==(if (jrem > z * 16) b[z] = VLOAD4_ALIGNED(0, (B_ptrs[z] + h)); )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(FMA_I_LOOP(1); )==""\n"
R"==(FMA_I_LOOP(2); )==""\n"
R"==(FMA_I_LOOP(3); )==""\n"
R"==(} )==""\n"
R"==(for (int h = k_align; h < k; h++) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(if (irem > (lid + z * 16)) a[z] = A_ptrs[z][h]; )==""\n"
R"==(if (jrem > z * 16) b[z] = B_ptrs[z][h]; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(global half *C2 = C + 16 * ldc; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(do { )==""\n"
R"==(read_mem_fence(CLK_GLOBAL_MEM_FENCE); )==""\n"
R"==(} while (*flag != idK); )==""\n"
R"==(if (idK == 0) { )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} else { )==""\n"
R"==(beta = 1.0; )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} )==""\n"
R"==(if (lid == 0) *flag = idK + 1; )==""\n"
R"==(#else )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef TT )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_f16(global half *A, global half *B, global half *C, )==""\n"
R"==(long offset_a, long offset_b, long offset_c, int lda, int ldb, int ldc, )==""\n"
R"==(int m, int n, int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(, )==""\n"
R"==(volatile global int *flag, long offset_f) { )==""\n"
R"==(#else )==""\n"
R"==() { )==""\n"
R"==(#endif )==""\n"
R"==(half4 a[2];  )==""\n"
R"==(half2 b[4];  )==""\n"
R"==(half c[32][2];  )==""\n"
R"==(int idM = get_global_id(1); )==""\n"
R"==(int idN = get_global_id(0); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int idK = get_global_id(2); )==""\n"
R"==(int nku = get_global_size(2); )==""\n"
R"==(int i0 = idM * 32; )==""\n"
R"==(int j00 = sub_group_broadcast(idN, 0) * 2; )==""\n"
R"==(int j0 = j00 + lid; )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int last_k_unroll = (idK == nku - 1); )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(int k0 = idK * UNROLL_K; )==""\n"
R"==(int kt = k - k0; )==""\n"
R"==(if (kt < 0) kt = 0; )==""\n"
R"==(if (kt > UNROLL_K) kt = UNROLL_K; )==""\n"
R"==(A += offset_a + (i0 + lid) * lda + k0; )==""\n"
R"==(B += offset_b + j00 + k0 * ldb; )==""\n"
R"==(k = kt; )==""\n"
R"==(#else )==""\n"
R"==(A += offset_a + (i0 + lid) * lda; )==""\n"
R"==(B += offset_b + j00; )==""\n"
R"==(#endif )==""\n"
R"==(C += offset_c + i0 + j0 * ldc; )==""\n"
R"==(global half *A_ptrs[2] = {A, A + 16 * lda}; )==""\n"
R"==(global half *B_ptrs[4] = {B, B + ldb, B + 2 * ldb, B + 3 * ldb}; )==""\n"
R"==(for (int y = 0; y < 32; y++) )==""\n"
R"==(for (int z = 0; z < 2; z++) )==""\n"
R"==(c[y][z] = 0; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(flag += offset_f + idM; )==""\n"
R"==(if (idK == 0 && lid == 0) *flag = 0; )==""\n"
R"==(#endif )==""\n"
R"==(int k_align = k & ~3; )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem >= 32 && sub_group_broadcast(jrem, 0) >= 32) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int z = 0; z < 2; z++) )==""\n"
R"==(a[z] = VLOAD4_ALIGNED(0, (A_ptrs[z] + h)); )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) )==""\n"
R"==(b[hh] = as_half2(intel_sub_group_block_read_us2( )==""\n"
R"==((global ushort *)(B_ptrs[hh] + h * ldb))); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(FMA_I_LOOP(1); )==""\n"
R"==(FMA_I_LOOP(2); )==""\n"
R"==(FMA_I_LOOP(3); )==""\n"
R"==(} )==""\n"
R"==(for (int h = k_align; h < k; h++) { )==""\n"
R"==(for (int z = 0; z < 2; z++) )==""\n"
R"==(a[z] = A_ptrs[z][h]; )==""\n"
R"==(b[0] = as_half2(intel_sub_group_block_read_us2( )==""\n"
R"==((global ushort *)(B_ptrs[0] + h * ldb))); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int z = 0; z < 2; z++) )==""\n"
R"==(if (irem > (lid + z * 16)) )==""\n"
R"==(a[z] = VLOAD4_ALIGNED(0, (A_ptrs[z] + h)); )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(if (jrem > 0) b[hh].s0 = B_ptrs[hh][h * ldb + lid]; )==""\n"
R"==(if (jrem > 16) b[hh].s1 = B_ptrs[hh][h * ldb + lid + 16]; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(FMA_I_LOOP(1); )==""\n"
R"==(FMA_I_LOOP(2); )==""\n"
R"==(FMA_I_LOOP(3); )==""\n"
R"==(} )==""\n"
R"==(for (int h = k_align; h < k; h++) { )==""\n"
R"==(for (int z = 0; z < 2; z++) )==""\n"
R"==(a[z] = A_ptrs[z][h]; )==""\n"
R"==(if (jrem > 0) b[0].s0 = B_ptrs[0][h * ldb + lid]; )==""\n"
R"==(if (jrem > 16) b[0].s1 = B_ptrs[0][h * ldb + lid + 16]; )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(global half *C2 = C + 16 * ldc; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(do { )==""\n"
R"==(read_mem_fence(CLK_GLOBAL_MEM_FENCE); )==""\n"
R"==(} while (*flag != idK); )==""\n"
R"==(if (idK == 0) { )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} else { )==""\n"
R"==(beta = 1.0; )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} )==""\n"
R"==(if (lid == 0) *flag = idK + 1; )==""\n"
R"==(#else )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}