namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_gemm_nocopy_f32_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/gemm/ocl_gemm_attrs.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if DT_F32 != 1 )==""\n"
R"==(#error "Incorrect datatype." )==""\n"
R"==(#endif )==""\n"
R"==(#define DO_FMA_NN(hh, i_mod_16, i_div_16, i_mod_4, i_div_4) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i_div_4].s##i_mod_4 \ )==""\n"
R"==(= mad(sub_group_broadcast(a[hh].s##i_div_16, i_mod_16), \ )==""\n"
R"==(b.s##hh, c[i_div_4].s##i_mod_4); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_NT(hh, i_mod_16, i_div_16, i_mod_4, i_div_4) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i_div_4].s##i_mod_4 \ )==""\n"
R"==(= mad(sub_group_broadcast(a[hh].s##i_div_16, i_mod_16), b[hh], \ )==""\n"
R"==(c[i_div_4].s##i_mod_4); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_TN(hh, i, i_mod_4, i_div_4) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i_div_4][0].s##i_mod_4 = mad(sub_group_broadcast(a.s##hh, i), \ )==""\n"
R"==(b[0].s##hh, c[i_div_4][0].s##i_mod_4); \ )==""\n"
R"==(c[i_div_4][1].s##i_mod_4 = mad(sub_group_broadcast(a.s##hh, i), \ )==""\n"
R"==(b[1].s##hh, c[i_div_4][1].s##i_mod_4); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_TT(hh, i, i_mod_4, i_div_4) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i_div_4][0].s##i_mod_4 = mad(sub_group_broadcast(a.s##hh, i), \ )==""\n"
R"==(b[hh].s0, c[i_div_4][0].s##i_mod_4); \ )==""\n"
R"==(c[i_div_4][1].s##i_mod_4 = mad(sub_group_broadcast(a.s##hh, i), \ )==""\n"
R"==(b[hh].s1, c[i_div_4][1].s##i_mod_4); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#if !defined(TRANS_A) )==""\n"
R"==(#if !defined(TRANS_B) )==""\n"
R"==(#define NN )==""\n"
R"==(#define DO_FMA DO_FMA_NN )==""\n"
R"==(#else )==""\n"
R"==(#define NT )==""\n"
R"==(#define DO_FMA DO_FMA_NT )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(#if !defined(TRANS_B) )==""\n"
R"==(#define TN )==""\n"
R"==(#define DO_FMA DO_FMA_TN )==""\n"
R"==(#else )==""\n"
R"==(#define TT )==""\n"
R"==(#define DO_FMA DO_FMA_TT )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_ELTWISE == 1 )==""\n"
R"==(#define POST_OP(val) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (last_k_block && last_k_unroll) \ )==""\n"
R"==(val = fwd_eltwise( \ )==""\n"
R"==(val, eltwise_alpha, eltwise_beta, eltwise_scale); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define POST_OP(val) )==""\n"
R"==(#endif )==""\n"
R"==(#define FMA_I_LOOP_32_ROW(hh) \ )==""\n"
R"==(do { \ )==""\n"
R"==(DO_FMA(hh, 0, 0, 0, 0); \ )==""\n"
R"==(DO_FMA(hh, 1, 0, 1, 0); \ )==""\n"
R"==(DO_FMA(hh, 2, 0, 2, 0); \ )==""\n"
R"==(DO_FMA(hh, 3, 0, 3, 0); \ )==""\n"
R"==(DO_FMA(hh, 4, 0, 0, 1); \ )==""\n"
R"==(DO_FMA(hh, 5, 0, 1, 1); \ )==""\n"
R"==(DO_FMA(hh, 6, 0, 2, 1); \ )==""\n"
R"==(DO_FMA(hh, 7, 0, 3, 1); \ )==""\n"
R"==(DO_FMA(hh, 8, 0, 0, 2); \ )==""\n"
R"==(DO_FMA(hh, 9, 0, 1, 2); \ )==""\n"
R"==(DO_FMA(hh, 10, 0, 2, 2); \ )==""\n"
R"==(DO_FMA(hh, 11, 0, 3, 2); \ )==""\n"
R"==(DO_FMA(hh, 12, 0, 0, 3); \ )==""\n"
R"==(DO_FMA(hh, 13, 0, 1, 3); \ )==""\n"
R"==(DO_FMA(hh, 14, 0, 2, 3); \ )==""\n"
R"==(DO_FMA(hh, 15, 0, 3, 3); \ )==""\n"
R"==(DO_FMA(hh, 16, 1, 0, 4); \ )==""\n"
R"==(DO_FMA(hh, 17, 1, 1, 4); \ )==""\n"
R"==(DO_FMA(hh, 18, 1, 2, 4); \ )==""\n"
R"==(DO_FMA(hh, 19, 1, 3, 4); \ )==""\n"
R"==(DO_FMA(hh, 20, 1, 0, 5); \ )==""\n"
R"==(DO_FMA(hh, 21, 1, 1, 5); \ )==""\n"
R"==(DO_FMA(hh, 22, 1, 2, 5); \ )==""\n"
R"==(DO_FMA(hh, 23, 1, 3, 5); \ )==""\n"
R"==(DO_FMA(hh, 24, 1, 0, 6); \ )==""\n"
R"==(DO_FMA(hh, 25, 1, 1, 6); \ )==""\n"
R"==(DO_FMA(hh, 26, 1, 2, 6); \ )==""\n"
R"==(DO_FMA(hh, 27, 1, 3, 6); \ )==""\n"
R"==(DO_FMA(hh, 28, 1, 0, 7); \ )==""\n"
R"==(DO_FMA(hh, 29, 1, 1, 7); \ )==""\n"
R"==(DO_FMA(hh, 30, 1, 2, 7); \ )==""\n"
R"==(DO_FMA(hh, 31, 1, 3, 7); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define FMA_I_LOOP_16_ROW(hh) \ )==""\n"
R"==(do { \ )==""\n"
R"==(DO_FMA(hh, 0, 0, 0); \ )==""\n"
R"==(DO_FMA(hh, 1, 1, 0); \ )==""\n"
R"==(DO_FMA(hh, 2, 2, 0); \ )==""\n"
R"==(DO_FMA(hh, 3, 3, 0); \ )==""\n"
R"==(DO_FMA(hh, 4, 0, 1); \ )==""\n"
R"==(DO_FMA(hh, 5, 1, 1); \ )==""\n"
R"==(DO_FMA(hh, 6, 2, 1); \ )==""\n"
R"==(DO_FMA(hh, 7, 3, 1); \ )==""\n"
R"==(DO_FMA(hh, 8, 0, 2); \ )==""\n"
R"==(DO_FMA(hh, 9, 1, 2); \ )==""\n"
R"==(DO_FMA(hh, 10, 2, 2); \ )==""\n"
R"==(DO_FMA(hh, 11, 3, 2); \ )==""\n"
R"==(DO_FMA(hh, 12, 0, 3); \ )==""\n"
R"==(DO_FMA(hh, 13, 1, 3); \ )==""\n"
R"==(DO_FMA(hh, 14, 2, 3); \ )==""\n"
R"==(DO_FMA(hh, 15, 3, 3); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C_ROW(i, ii, betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (jrem > 0) \ )==""\n"
R"==(if (irem > i) { \ )==""\n"
R"==(float val = ATTR_ALPHA * c[i / 4].s##ii \ )==""\n"
R"==(+ ((betaZero) ? 0 : beta * *C); \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*C = val; \ )==""\n"
R"==(} \ )==""\n"
R"==(C++; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C_ROW_2X(i, ii, betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (irem > i) { \ )==""\n"
R"==(if (jrem > 0) { \ )==""\n"
R"==(float val = ATTR_ALPHA * c[i / 4][0].s##ii \ )==""\n"
R"==(+ ((betaZero) ? 0 : beta * *(C_ptrs[0])); \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*(C_ptrs[0]) = val; \ )==""\n"
R"==(} \ )==""\n"
R"==(if (jrem > 16) { \ )==""\n"
R"==(float val = ATTR_ALPHA * c[i / 4][1].s##ii \ )==""\n"
R"==(+ ((betaZero) ? 0 : beta * *(C_ptrs[1])); \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*(C_ptrs[1]) = val; \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(C_ptrs[0]++; \ )==""\n"
R"==(C_ptrs[1]++; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C_32_ROW(betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(UPDATE_C_ROW(0, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(1, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(2, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(3, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(4, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(5, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(6, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(7, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(8, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(9, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(10, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(11, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(12, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(13, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(14, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(15, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(16, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(17, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(18, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(19, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(20, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(21, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(22, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(23, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(24, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(25, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(26, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(27, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(28, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(29, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(30, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(31, 3, betaZero); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C_16_ROW(betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(UPDATE_C_ROW_2X(0, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(1, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(2, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(3, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(4, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(5, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(6, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(7, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(8, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(9, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(10, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(11, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(12, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(13, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(14, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW_2X(15, 3, betaZero); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#ifdef NN )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_f32(global float *A, global float *B, global float *C, )==""\n"
R"==(long offset_a, long offset_b, long offset_c, int lda, int ldb, int ldc, )==""\n"
R"==(int m, int n, int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(, )==""\n"
R"==(volatile global int *flag, long offset_f) { )==""\n"
R"==(#else )==""\n"
R"==() { )==""\n"
R"==(#endif )==""\n"
R"==(float2 a[4];  )==""\n"
R"==(float4 b;  )==""\n"
R"==(float4 c[8];  )==""\n"
R"==(int idM = get_global_id(1); )==""\n"
R"==(int idN = get_global_id(0); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int idK = get_global_id(2); )==""\n"
R"==(int nku = get_global_size(2); )==""\n"
R"==(int i0 = idM * 32; )==""\n"
R"==(int j0 = idN; )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int last_k_unroll = (idK == nku - 1); )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(int k0 = idK * UNROLL_K; )==""\n"
R"==(int kt = k - k0; )==""\n"
R"==(if (kt < 0) kt = 0; )==""\n"
R"==(if (kt > UNROLL_K) kt = UNROLL_K; )==""\n"
R"==(A += offset_a + i0 + k0 * lda; )==""\n"
R"==(B += offset_b + j0 * ldb + k0; )==""\n"
R"==(k = kt; )==""\n"
R"==(#else )==""\n"
R"==(A += offset_a + i0; )==""\n"
R"==(B += offset_b + j0 * ldb; )==""\n"
R"==(#endif )==""\n"
R"==(C += offset_c + i0 + j0 * ldc; )==""\n"
R"==(global float *A_cols[4] = {A, A + lda, A + 2 * lda, A + 3 * lda}; )==""\n"
R"==(int ldax4 = lda << 2; )==""\n"
R"==(int ldbx4 = ldb << 2; )==""\n"
R"==(for (int z = 0; z < 8; z++) )==""\n"
R"==(c[z] = 0.f; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(flag += offset_f + idM; )==""\n"
R"==(if (idK == 0 && lid == 0) *flag = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem >= 32 && sub_group_broadcast(jrem, 0) >= 16) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < (k >> 2); h++) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(a[hh] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)A_cols[hh])); )==""\n"
R"==(A_cols[hh] += ldax4; )==""\n"
R"==(} )==""\n"
R"==(b = vload4(0, B); )==""\n"
R"==(B += 4; )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(FMA_I_LOOP_32_ROW(1); )==""\n"
R"==(FMA_I_LOOP_32_ROW(2); )==""\n"
R"==(FMA_I_LOOP_32_ROW(3); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(for (int h = 0; h < krem; h++) { )==""\n"
R"==(a[0] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)A_cols[0])); )==""\n"
R"==(A_cols[0] += lda; )==""\n"
R"==(b = *B++; )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < (k >> 1); h++) { )==""\n"
R"==(for (int hh = 0; hh < 2; hh++) { )==""\n"
R"==(if (irem > lid) a[hh].s0 = A_cols[hh][lid]; )==""\n"
R"==(if (irem > (lid + 16)) a[hh].s1 = A_cols[hh][lid + 16]; )==""\n"
R"==(A_cols[hh] += (lda << 1); )==""\n"
R"==(} )==""\n"
R"==(if (jrem > 0) b.s01 = vload2(0, B); )==""\n"
R"==(B += 2; )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(FMA_I_LOOP_32_ROW(1); )==""\n"
R"==(} )==""\n"
R"==(if (k & 1) { )==""\n"
R"==(if (irem > lid) a[0].s0 = A_cols[0][lid]; )==""\n"
R"==(if (irem > (lid + 16)) a[0].s1 = A_cols[0][lid + 16]; )==""\n"
R"==(if (jrem > 0) b = *B; )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(do { )==""\n"
R"==(read_mem_fence(CLK_GLOBAL_MEM_FENCE); )==""\n"
R"==(} while (*flag != idK); )==""\n"
R"==(if (idK == 0) { )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_32_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_32_ROW(0); )==""\n"
R"==(} else { )==""\n"
R"==(beta = 1.0; )==""\n"
R"==(UPDATE_C_32_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(if (lid == 0) *flag = idK + 1; )==""\n"
R"==(#else )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_32_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_32_ROW(0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef NT )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_f32(global float *A, global float *B, global float *C, )==""\n"
R"==(long offset_a, long offset_b, long offset_c, int lda, int ldb, int ldc, )==""\n"
R"==(int m, int n, int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(, )==""\n"
R"==(volatile global int *flag, long offset_f) { )==""\n"
R"==(#else )==""\n"
R"==() { )==""\n"
R"==(#endif )==""\n"
R"==(float2 a[2];  )==""\n"
R"==(float b[2];  )==""\n"
R"==(float4 c[8];  )==""\n"
R"==(int idM = get_global_id(1); )==""\n"
R"==(int idN = get_global_id(0); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int idK = get_global_id(2); )==""\n"
R"==(int nku = get_global_size(2); )==""\n"
R"==(int i0 = idM * 32; )==""\n"
R"==(int j0 = idN; )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int last_k_unroll = (idK == nku - 1); )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(int k0 = idK * UNROLL_K; )==""\n"
R"==(int kt = k - k0; )==""\n"
R"==(if (kt < 0) kt = 0; )==""\n"
R"==(if (kt > UNROLL_K) kt = UNROLL_K; )==""\n"
R"==(A += offset_a + i0 + k0 * lda; )==""\n"
R"==(B += offset_b + sub_group_broadcast(j0, 0) + k0 * ldb; )==""\n"
R"==(k = kt; )==""\n"
R"==(#else )==""\n"
R"==(A += offset_a + i0; )==""\n"
R"==(B += offset_b + sub_group_broadcast(j0, 0); )==""\n"
R"==(#endif )==""\n"
R"==(C += offset_c + i0 + j0 * ldc; )==""\n"
R"==(global float *A_cols[2] = {A, A + lda}; )==""\n"
R"==(global float *B_rows[2] = {B, B + ldb}; )==""\n"
R"==(int ldax2 = lda << 1; )==""\n"
R"==(int ldbx2 = ldb << 1; )==""\n"
R"==(for (int z = 0; z < 8; z++) )==""\n"
R"==(c[z] = 0.f; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(flag += offset_f + idM; )==""\n"
R"==(if (idK == 0 && lid == 0) *flag = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem >= 32 && sub_group_broadcast(jrem, 0) >= 16) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < (k >> 1); h++) { )==""\n"
R"==(for (int hh = 0; hh < 2; hh++) { )==""\n"
R"==(a[hh] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)A_cols[hh])); )==""\n"
R"==(A_cols[hh] += ldax2; )==""\n"
R"==(} )==""\n"
R"==(for (int hh = 0; hh < 2; hh++) { )==""\n"
R"==(b[hh] = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)B_rows[hh])); )==""\n"
R"==(B_rows[hh] += ldbx2; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(FMA_I_LOOP_32_ROW(1); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 1; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(a[0] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)A_cols[0])); )==""\n"
R"==(b[0] = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)B_rows[0])); )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < (k >> 1); h++) { )==""\n"
R"==(for (int hh = 0; hh < 2; hh++) { )==""\n"
R"==(if (irem > lid) a[hh].s0 = A_cols[hh][lid]; )==""\n"
R"==(if (irem > (lid + 16)) a[hh].s1 = A_cols[hh][lid + 16]; )==""\n"
R"==(A_cols[hh] += ldax2; )==""\n"
R"==(} )==""\n"
R"==(for (int hh = 0; hh < 2; hh++) { )==""\n"
R"==(if (jrem > 0) b[hh] = B_rows[hh][lid]; )==""\n"
R"==(B_rows[hh] += ldbx2; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(FMA_I_LOOP_32_ROW(1); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 1; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(if (irem > lid) a[0].s0 = A_cols[0][lid]; )==""\n"
R"==(if (irem > (lid + 16)) a[0].s1 = A_cols[0][lid + 16]; )==""\n"
R"==(if (jrem > 0) b[0] = B_rows[0][lid]; )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(do { )==""\n"
R"==(read_mem_fence(CLK_GLOBAL_MEM_FENCE); )==""\n"
R"==(} while (*flag != idK); )==""\n"
R"==(if (idK == 0) { )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_32_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_32_ROW(0); )==""\n"
R"==(} else { )==""\n"
R"==(beta = 1.0; )==""\n"
R"==(UPDATE_C_32_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(if (lid == 0) *flag = idK + 1; )==""\n"
R"==(#else )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_32_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_32_ROW(0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef TN )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_f32(global float *A, global float *B, global float *C, )==""\n"
R"==(long offset_a, long offset_b, long offset_c, int lda, int ldb, int ldc, )==""\n"
R"==(int m, int n, int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(, )==""\n"
R"==(volatile global int *flag, long offset_f) { )==""\n"
R"==(#else )==""\n"
R"==() { )==""\n"
R"==(#endif )==""\n"
R"==(float4 a;  )==""\n"
R"==(float4 b[2];  )==""\n"
R"==(float4 c[4][2];  )==""\n"
R"==(int idM = get_global_id(1); )==""\n"
R"==(int idN = get_global_id(0); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int idK = get_global_id(2); )==""\n"
R"==(int nku = get_global_size(2); )==""\n"
R"==(int i0 = idM * 16; )==""\n"
R"==(int j0 = sub_group_broadcast(idN, 0) * 2 + lid; )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int last_k_unroll = (idK == nku - 1); )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(int k0 = idK * UNROLL_K; )==""\n"
R"==(int kt = k - k0; )==""\n"
R"==(if (kt < 0) kt = 0; )==""\n"
R"==(if (kt > UNROLL_K) kt = UNROLL_K; )==""\n"
R"==(A += offset_a + (i0 + lid) * lda + k0; )==""\n"
R"==(B += offset_b + j0 * ldb + k0; )==""\n"
R"==(k = kt; )==""\n"
R"==(#else )==""\n"
R"==(A += offset_a + (i0 + lid) * lda; )==""\n"
R"==(B += offset_b + j0 * ldb; )==""\n"
R"==(#endif )==""\n"
R"==(C += offset_c + i0 + j0 * ldc; )==""\n"
R"==(global float *B_ptrs[2] = {B, B + 16 * ldb}; )==""\n"
R"==(for (int ii = 0; ii < 4; ii++) )==""\n"
R"==(for (int jj = 0; jj < 2; jj++) )==""\n"
R"==(c[ii][jj] = 0.f; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(flag += offset_f + idM; )==""\n"
R"==(if (idK == 0 && lid == 0) *flag = 0; )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < (k >> 2); h++) { )==""\n"
R"==(if (irem > lid) a = vload4(0, A); )==""\n"
R"==(A += 4; )==""\n"
R"==(for (int hh = 0; hh < 2; hh++) { )==""\n"
R"==(if (jrem > hh * 16) b[hh] = vload4(0, B_ptrs[hh]); )==""\n"
R"==(B_ptrs[hh] += 4; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(FMA_I_LOOP_16_ROW(1); )==""\n"
R"==(FMA_I_LOOP_16_ROW(2); )==""\n"
R"==(FMA_I_LOOP_16_ROW(3); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(for (int h = 0; h < krem; h++) { )==""\n"
R"==(if (irem > lid) a = *A++; )==""\n"
R"==(for (int hh = 0; hh < 2; hh++) { )==""\n"
R"==(if (jrem > hh * 16) b[hh] = *B_ptrs[hh]; )==""\n"
R"==(B_ptrs[hh]++; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(global float *C_ptrs[2] = {C, C + 16 * ldc}; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(do { )==""\n"
R"==(read_mem_fence(CLK_GLOBAL_MEM_FENCE); )==""\n"
R"==(} while (*flag != idK); )==""\n"
R"==(if (idK == 0) { )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_16_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_16_ROW(0); )==""\n"
R"==(} else { )==""\n"
R"==(beta = 1.0; )==""\n"
R"==(UPDATE_C_16_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(if (lid == 0) *flag = idK + 1; )==""\n"
R"==(#else )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_16_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_16_ROW(0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef TT )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_f32(global float *A, global float *B, global float *C, )==""\n"
R"==(long offset_a, long offset_b, long offset_c, int lda, int ldb, int ldc, )==""\n"
R"==(int m, int n, int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(, )==""\n"
R"==(volatile global int *flag, long offset_f) { )==""\n"
R"==(#else )==""\n"
R"==() { )==""\n"
R"==(#endif )==""\n"
R"==(float4 a;  )==""\n"
R"==(float2 b[4];  )==""\n"
R"==(float4 c[4][2];  )==""\n"
R"==(int idM = get_global_id(1); )==""\n"
R"==(int idN = get_global_id(0); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int idK = get_global_id(2); )==""\n"
R"==(int nku = get_global_size(2); )==""\n"
R"==(int i0 = idM * 16; )==""\n"
R"==(int j0 = sub_group_broadcast(idN, 0) * 2 + lid; )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int last_k_unroll = (idK == nku - 1); )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(int k0 = idK * UNROLL_K; )==""\n"
R"==(int kt = k - k0; )==""\n"
R"==(if (kt < 0) kt = 0; )==""\n"
R"==(if (kt > UNROLL_K) kt = UNROLL_K; )==""\n"
R"==(A += offset_a + (i0 + lid) * lda + k0; )==""\n"
R"==(B += offset_b + sub_group_broadcast(j0, 0) + k0 * ldb; )==""\n"
R"==(k = kt; )==""\n"
R"==(#else )==""\n"
R"==(A += offset_a + (i0 + lid) * lda; )==""\n"
R"==(B += offset_b + sub_group_broadcast(j0, 0); )==""\n"
R"==(#endif )==""\n"
R"==(C += offset_c + i0 + j0 * ldc; )==""\n"
R"==(global float *B_rows[4] = {B, B + ldb, B + 2 * ldb, B + 3 * ldb}; )==""\n"
R"==(int ldbx4 = ldb << 2; )==""\n"
R"==(for (int ii = 0; ii < 4; ii++) )==""\n"
R"==(for (int jj = 0; jj < 2; jj++) )==""\n"
R"==(c[ii][jj] = 0.f; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(flag += offset_f + idM; )==""\n"
R"==(if (idK == 0 && lid == 0) *flag = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem >= 16 && sub_group_broadcast(jrem, 0) >= 32) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < (k >> 2); h++) { )==""\n"
R"==(a = vload4(0, A); )==""\n"
R"==(A += 4; )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(b[hh] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)B_rows[hh])); )==""\n"
R"==(B_rows[hh] += ldbx4; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(FMA_I_LOOP_16_ROW(1); )==""\n"
R"==(FMA_I_LOOP_16_ROW(2); )==""\n"
R"==(FMA_I_LOOP_16_ROW(3); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(for (int h = 0; h < krem; h++) { )==""\n"
R"==(a = *A++; )==""\n"
R"==(b[0] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)B_rows[0])); )==""\n"
R"==(B_rows[0] += ldb; )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < (k >> 2); h++) { )==""\n"
R"==(if (irem > lid) a = vload4(0, A); )==""\n"
R"==(A += 4; )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(if (jrem > 0) b[hh].s0 = B_rows[hh][lid]; )==""\n"
R"==(if (jrem > 16) b[hh].s1 = B_rows[hh][lid + 16]; )==""\n"
R"==(B_rows[hh] += ldbx4; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(FMA_I_LOOP_16_ROW(1); )==""\n"
R"==(FMA_I_LOOP_16_ROW(2); )==""\n"
R"==(FMA_I_LOOP_16_ROW(3); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(for (int h = 0; h < krem; h++) { )==""\n"
R"==(if (irem > lid) a = *A++; )==""\n"
R"==(if (jrem > 0) b[0].s0 = B_rows[0][lid]; )==""\n"
R"==(if (jrem > 16) b[0].s1 = B_rows[0][lid + 16]; )==""\n"
R"==(B_rows[0] += ldb; )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(global float *C_ptrs[2] = {C, C + 16 * ldc}; )==""\n"
R"==(#ifdef WITH_K_UNROLL )==""\n"
R"==(do { )==""\n"
R"==(read_mem_fence(CLK_GLOBAL_MEM_FENCE); )==""\n"
R"==(} while (*flag != idK); )==""\n"
R"==(if (idK == 0) { )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_16_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_16_ROW(0); )==""\n"
R"==(} else { )==""\n"
R"==(beta = 1.0; )==""\n"
R"==(UPDATE_C_16_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(if (lid == 0) *flag = idK + 1; )==""\n"
R"==(#else )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_16_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_16_ROW(0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}