namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_gemm_nocopy_superkernel_f32_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/gemm/ocl_gemm_attrs.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if DT_F32 != 1 )==""\n"
R"==(#error "Only f32 implemented." )==""\n"
R"==(#endif )==""\n"
R"==(#define DO_FMA_NN(hh, i_mod_16, i_div_16, i_mod_4, i_div_4) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i_div_4].s##i_mod_4 \ )==""\n"
R"==(= mad(sub_group_broadcast(a[hh].s##i_div_16, i_mod_16), \ )==""\n"
R"==(b.s##hh, c[i_div_4].s##i_mod_4); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_NT(hh, i_mod_16, i_div_16, i_mod_4, i_div_4) \ )==""\n"
R"==(do { \ )==""\n"
R"==(c[i_div_4].s##i_mod_4 \ )==""\n"
R"==(= mad(sub_group_broadcast(a[hh].s##i_div_16, i_mod_16), b[hh], \ )==""\n"
R"==(c[i_div_4].s##i_mod_4); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#if !defined(TRANS_A) )==""\n"
R"==(#if !defined(TRANS_B) )==""\n"
R"==(#define NN )==""\n"
R"==(#define DO_FMA DO_FMA_NN )==""\n"
R"==(#else )==""\n"
R"==(#define NT )==""\n"
R"==(#define DO_FMA DO_FMA_NT )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(#error "No superkernel implementation." )==""\n"
R"==(#endif )==""\n"
R"==(#define FMA_I_LOOP_32_ROW(hh) \ )==""\n"
R"==(do { \ )==""\n"
R"==(DO_FMA(hh, 0, 0, 0, 0); \ )==""\n"
R"==(DO_FMA(hh, 1, 0, 1, 0); \ )==""\n"
R"==(DO_FMA(hh, 2, 0, 2, 0); \ )==""\n"
R"==(DO_FMA(hh, 3, 0, 3, 0); \ )==""\n"
R"==(DO_FMA(hh, 4, 0, 0, 1); \ )==""\n"
R"==(DO_FMA(hh, 5, 0, 1, 1); \ )==""\n"
R"==(DO_FMA(hh, 6, 0, 2, 1); \ )==""\n"
R"==(DO_FMA(hh, 7, 0, 3, 1); \ )==""\n"
R"==(DO_FMA(hh, 8, 0, 0, 2); \ )==""\n"
R"==(DO_FMA(hh, 9, 0, 1, 2); \ )==""\n"
R"==(DO_FMA(hh, 10, 0, 2, 2); \ )==""\n"
R"==(DO_FMA(hh, 11, 0, 3, 2); \ )==""\n"
R"==(DO_FMA(hh, 12, 0, 0, 3); \ )==""\n"
R"==(DO_FMA(hh, 13, 0, 1, 3); \ )==""\n"
R"==(DO_FMA(hh, 14, 0, 2, 3); \ )==""\n"
R"==(DO_FMA(hh, 15, 0, 3, 3); \ )==""\n"
R"==(DO_FMA(hh, 16, 1, 0, 4); \ )==""\n"
R"==(DO_FMA(hh, 17, 1, 1, 4); \ )==""\n"
R"==(DO_FMA(hh, 18, 1, 2, 4); \ )==""\n"
R"==(DO_FMA(hh, 19, 1, 3, 4); \ )==""\n"
R"==(DO_FMA(hh, 20, 1, 0, 5); \ )==""\n"
R"==(DO_FMA(hh, 21, 1, 1, 5); \ )==""\n"
R"==(DO_FMA(hh, 22, 1, 2, 5); \ )==""\n"
R"==(DO_FMA(hh, 23, 1, 3, 5); \ )==""\n"
R"==(DO_FMA(hh, 24, 1, 0, 6); \ )==""\n"
R"==(DO_FMA(hh, 25, 1, 1, 6); \ )==""\n"
R"==(DO_FMA(hh, 26, 1, 2, 6); \ )==""\n"
R"==(DO_FMA(hh, 27, 1, 3, 6); \ )==""\n"
R"==(DO_FMA(hh, 28, 1, 0, 7); \ )==""\n"
R"==(DO_FMA(hh, 29, 1, 1, 7); \ )==""\n"
R"==(DO_FMA(hh, 30, 1, 2, 7); \ )==""\n"
R"==(DO_FMA(hh, 31, 1, 3, 7); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define FMA_I_LOOP_16_ROW(hh) \ )==""\n"
R"==(do { \ )==""\n"
R"==(DO_FMA(hh, 0, 0, 0, 0); \ )==""\n"
R"==(DO_FMA(hh, 1, 0, 1, 0); \ )==""\n"
R"==(DO_FMA(hh, 2, 0, 2, 0); \ )==""\n"
R"==(DO_FMA(hh, 3, 0, 3, 0); \ )==""\n"
R"==(DO_FMA(hh, 4, 0, 0, 1); \ )==""\n"
R"==(DO_FMA(hh, 5, 0, 1, 1); \ )==""\n"
R"==(DO_FMA(hh, 6, 0, 2, 1); \ )==""\n"
R"==(DO_FMA(hh, 7, 0, 3, 1); \ )==""\n"
R"==(DO_FMA(hh, 8, 0, 0, 2); \ )==""\n"
R"==(DO_FMA(hh, 9, 0, 1, 2); \ )==""\n"
R"==(DO_FMA(hh, 10, 0, 2, 2); \ )==""\n"
R"==(DO_FMA(hh, 11, 0, 3, 2); \ )==""\n"
R"==(DO_FMA(hh, 12, 0, 0, 3); \ )==""\n"
R"==(DO_FMA(hh, 13, 0, 1, 3); \ )==""\n"
R"==(DO_FMA(hh, 14, 0, 2, 3); \ )==""\n"
R"==(DO_FMA(hh, 15, 0, 3, 3); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#if WITH_ELTWISE == 1 )==""\n"
R"==(#define POST_OP(val) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (last_k_block) \ )==""\n"
R"==(val = fwd_eltwise( \ )==""\n"
R"==(val, eltwise_alpha, eltwise_beta, eltwise_scale); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define POST_OP(val) )==""\n"
R"==(#endif )==""\n"
R"==(#define UPDATE_C_ROW(i, ii, betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (jrem > 0) \ )==""\n"
R"==(if (irem > i) { \ )==""\n"
R"==(float val = ATTR_ALPHA * c[i / 4].s##ii \ )==""\n"
R"==(+ ((betaZero) ? 0 : beta * *C); \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*C = val; \ )==""\n"
R"==(} \ )==""\n"
R"==(C++; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C_32_ROW(betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(UPDATE_C_ROW(0, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(1, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(2, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(3, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(4, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(5, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(6, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(7, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(8, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(9, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(10, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(11, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(12, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(13, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(14, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(15, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(16, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(17, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(18, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(19, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(20, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(21, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(22, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(23, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(24, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(25, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(26, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(27, 3, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(28, 0, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(29, 1, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(30, 2, betaZero); \ )==""\n"
R"==(UPDATE_C_ROW(31, 3, betaZero); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define SUPERKERNEL_PROLOGUE \ )==""\n"
R"==(global volatile int *p = plan; \ )==""\n"
R"==(int id = get_group_id(0); \ )==""\n"
R"==(\ )==""\n"
R"==(A0 += offsetA; \ )==""\n"
R"==(B0 += offsetB; \ )==""\n"
R"==(C0 += offsetC; \ )==""\n"
R"==(\ )==""\n"
R"==(while (id < threads) { \ )==""\n"
R"==(uint i0, j0; \ )==""\n"
R"==(uint kid0, kid1; \ )==""\n"
R"==(\ )==""\n"
R"==(i0 = plan[2 * id + 2]; \ )==""\n"
R"==(j0 = plan[2 * id + 3]; \ )==""\n"
R"==(kid0 = (i0 >> 31); \ )==""\n"
R"==(kid1 = (j0 >> 31); \ )==""\n"
R"==(i0 &= ~(1 << 31); \ )==""\n"
R"==(j0 &= ~(1 << 31); \ )==""\n"
R"==(j0 += get_local_id(0); )==""\n"
R"==(#define SUPERKERNEL_EPILOGUE \ )==""\n"
R"==(if (get_sub_group_local_id() == 0) id = atomic_inc(plan); \ )==""\n"
R"==(\ )==""\n"
R"==(sub_group_barrier(0); \ )==""\n"
R"==(id = sub_group_broadcast(id, 0); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (get_sub_group_local_id() == 0) { \ )==""\n"
R"==(if (atomic_inc(plan + 1) == (get_num_groups(0) - 1)) { \ )==""\n"
R"==(mem_fence(CLK_GLOBAL_MEM_FENCE); \ )==""\n"
R"==(plan[0] = get_num_groups(0); \ )==""\n"
R"==(plan[1] = 0; \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#ifdef NN )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_superkernel_f32(global int *plan, int threads, )==""\n"
R"==(global float *A0, global float *B0, global float *C0, long offsetA, )==""\n"
R"==(long offsetB, long offsetC, int lda, int ldb, int ldc, int m, int n, )==""\n"
R"==(int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale) { )==""\n"
R"==(SUPERKERNEL_PROLOGUE )==""\n"
R"==(float2 a[4];  )==""\n"
R"==(float4 b;  )==""\n"
R"==(float4 c[8];  )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(global float *A = A0 + i0; )==""\n"
R"==(global float *B = B0 + j0 * ldb; )==""\n"
R"==(global float *C = C0 + i0 + j0 * ldc; )==""\n"
R"==(global float *A_cols[4] = {A, A + lda, A + 2 * lda, A + 3 * lda}; )==""\n"
R"==(int ldax4 = lda << 2; )==""\n"
R"==(int ldbx4 = ldb << 2; )==""\n"
R"==(if (kid0 == 0) { )==""\n"
R"==(for (int z = 0; z < 8; z++) )==""\n"
R"==(c[z] = 0.f; )==""\n"
R"==(for (int h = 0; h < (k >> 2); h++) { )==""\n"
R"==(for (int j = 0; j < 4; j++) { )==""\n"
R"==(a[j] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)A_cols[j])); )==""\n"
R"==(A_cols[j] += ldax4; )==""\n"
R"==(} )==""\n"
R"==(b = vload4(0, B); )==""\n"
R"==(B += 4; )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(FMA_I_LOOP_32_ROW(1); )==""\n"
R"==(FMA_I_LOOP_32_ROW(2); )==""\n"
R"==(FMA_I_LOOP_32_ROW(3); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(for (int j = 0; j < 4; j++) )==""\n"
R"==(a[j] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)A_cols[j])); )==""\n"
R"==(b = vload4(0, B); )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(if (krem > 1) FMA_I_LOOP_32_ROW(1); )==""\n"
R"==(if (krem > 2) FMA_I_LOOP_32_ROW(2); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(if (irem > 16) irem = 16; )==""\n"
R"==(for (int z = 0; z < 4; z++) )==""\n"
R"==(c[z] = 0.f; )==""\n"
R"==(for (int h = 0; h < (k >> 2); h++) { )==""\n"
R"==(for (int j = 0; j < 4; j++) { )==""\n"
R"==(a[j].s0 = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)A_cols[j])); )==""\n"
R"==(A_cols[j] += ldax4; )==""\n"
R"==(} )==""\n"
R"==(b = vload4(0, B); )==""\n"
R"==(B += 4; )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(FMA_I_LOOP_16_ROW(1); )==""\n"
R"==(FMA_I_LOOP_16_ROW(2); )==""\n"
R"==(FMA_I_LOOP_16_ROW(3); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(for (int j = 0; j < 4; j++) )==""\n"
R"==(a[j].s0 = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)A_cols[j])); )==""\n"
R"==(b = vload4(0, B); )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(if (krem > 1) FMA_I_LOOP_16_ROW(1); )==""\n"
R"==(if (krem > 2) FMA_I_LOOP_16_ROW(2); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_32_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_32_ROW(0); )==""\n"
R"==(SUPERKERNEL_EPILOGUE )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef NT )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16)))  )==""\n"
R"==(kernel void )==""\n"
R"==(gen9_gemm_nocopy_superkernel_f32(global int *plan, int threads, )==""\n"
R"==(global float *A0, global float *B0, global float *C0, long offsetA, )==""\n"
R"==(long offsetB, long offsetC, int lda, int ldb, int ldc, int m, int n, )==""\n"
R"==(int k, global float *alpha, float beta, int last_k_block, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale) { )==""\n"
R"==(SUPERKERNEL_PROLOGUE )==""\n"
R"==(float2 a[2];  )==""\n"
R"==(float b[2];  )==""\n"
R"==(float4 c[8];  )==""\n"
R"==(int irem = m - i0; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(global float *A = A0 + i0; )==""\n"
R"==(global float *B = B0 + j0; )==""\n"
R"==(global float *C = C0 + i0 + j0 * ldc; )==""\n"
R"==(global float *A_cols[2] = {A, A + lda}; )==""\n"
R"==(global float *B_rows[2] = {B, B + ldb}; )==""\n"
R"==(int ldax2 = lda << 1; )==""\n"
R"==(int ldbx2 = ldb << 1; )==""\n"
R"==(if (kid0 == 0) { )==""\n"
R"==(for (int z = 0; z < 8; z++) )==""\n"
R"==(c[z] = 0.f; )==""\n"
R"==(for (int h = 0; h < (k >> 1); h++) { )==""\n"
R"==(for (int j = 0; j < 2; j++) { )==""\n"
R"==(a[j] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)A_cols[j])); )==""\n"
R"==(A_cols[j] += ldax2; )==""\n"
R"==(} )==""\n"
R"==(for (int i = 0; i < 2; i++) { )==""\n"
R"==(b[i] = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)B_rows[i])); )==""\n"
R"==(B_rows[i] += ldbx2; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(FMA_I_LOOP_32_ROW(1); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 1; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(a[0] = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((global uint *)A_cols[0])); )==""\n"
R"==(b[0] = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)B_rows[0])); )==""\n"
R"==(FMA_I_LOOP_32_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(if (irem > 16) irem = 16; )==""\n"
R"==(for (int z = 0; z < 4; z++) )==""\n"
R"==(c[z] = 0.f; )==""\n"
R"==(for (int h = 0; h < (k >> 1); h++) { )==""\n"
R"==(for (int j = 0; j < 2; j++) { )==""\n"
R"==(a[j].s0 = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)A_cols[j])); )==""\n"
R"==(A_cols[j] += ldax2; )==""\n"
R"==(} )==""\n"
R"==(for (int i = 0; i < 2; i++) { )==""\n"
R"==(b[i] = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)B_rows[i])); )==""\n"
R"==(B_rows[i] += ldbx2; )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(FMA_I_LOOP_16_ROW(1); )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 1; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(a[0].s0 = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)A_cols[0])); )==""\n"
R"==(b[0] = as_float( )==""\n"
R"==(intel_sub_group_block_read((global uint *)B_rows[0])); )==""\n"
R"==(FMA_I_LOOP_16_ROW(0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C_32_ROW(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C_32_ROW(0); )==""\n"
R"==(SUPERKERNEL_EPILOGUE )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}