namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_gemm_nocopy_x8x8s32_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/gemm/ocl_gemm_attrs.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#undef GRX )==""\n"
R"==(#define GRX 8 )==""\n"
R"==(#if defined(S8S8) )==""\n"
R"==(#define FLOATA char )==""\n"
R"==(#define FLOATA2 char2 )==""\n"
R"==(#define FLOATA4 char4 )==""\n"
R"==(#define FLOATB char )==""\n"
R"==(#define FLOATB4 char4 )==""\n"
R"==(#define SHUFFLE(X, Y) as_char4(intel_sub_group_shuffle(as_int(X), Y)) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(U8S8) )==""\n"
R"==(#define FLOATA uchar )==""\n"
R"==(#define FLOATA2 uchar2 )==""\n"
R"==(#define FLOATA4 uchar4 )==""\n"
R"==(#define FLOATB char )==""\n"
R"==(#define FLOATB4 char4 )==""\n"
R"==(#define SHUFFLE(X, Y) as_char4(intel_sub_group_shuffle(as_int(X), Y)) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(S8U8) )==""\n"
R"==(#define FLOATA char )==""\n"
R"==(#define FLOATA2 char2 )==""\n"
R"==(#define FLOATA4 char4 )==""\n"
R"==(#define FLOATB uchar )==""\n"
R"==(#define FLOATB4 uchar4 )==""\n"
R"==(#define SHUFFLE(X, Y) as_uchar4(intel_sub_group_shuffle(as_int(X), Y)) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(U8U8) )==""\n"
R"==(#define FLOATA uchar )==""\n"
R"==(#define FLOATA2 uchar2 )==""\n"
R"==(#define FLOATA4 uchar4 )==""\n"
R"==(#define FLOATB uchar )==""\n"
R"==(#define FLOATB4 uchar4 )==""\n"
R"==(#define SHUFFLE(X, Y) as_uchar4(intel_sub_group_shuffle(as_int(X), Y)) )==""\n"
R"==(#endif )==""\n"
R"==(#define FLOATC int )==""\n"
R"==(#define FLOATC4 int4 )==""\n"
R"==(#if WITH_ELTWISE == 1 )==""\n"
R"==(#define POST_OP(val) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (apply_eltwise) \ )==""\n"
R"==(val = fwd_eltwise( \ )==""\n"
R"==(val, eltwise_alpha, eltwise_beta, eltwise_scale); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define POST_OP(val) )==""\n"
R"==(#endif )==""\n"
R"==(#define COMPUTE_C(X, Y, CO_IDX) \ )==""\n"
R"==(do { \ )==""\n"
R"==(float val = (!beta ? 0 : (X)) + (Y); \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==((X) = convert_int_sat_rte(val + (apply_co ? co[CO_IDX] : 0)); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#ifdef FF )==""\n"
R"==(#define ADD_EACH(X, OFF) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (n > X + OFF) { \ )==""\n"
R"==(if (m > 0) \ )==""\n"
R"==(COMPUTE_C(c[0], sc[X / 4 + 0].s##OFF + xa[0] + xb[0], 0); \ )==""\n"
R"==(if (m > 1) \ )==""\n"
R"==(COMPUTE_C(c[1], sc[X / 4 + 4].s##OFF + xa[1] + xb[0], 0); \ )==""\n"
R"==(if (m > 2) \ )==""\n"
R"==(COMPUTE_C(c[2], sc[X / 4 + 8].s##OFF + xa[2] + xb[0], 0); \ )==""\n"
R"==(if (m > 3) \ )==""\n"
R"==(COMPUTE_C(c[3], sc[X / 4 + 12].s##OFF + xa[3] + xb[0], 0); \ )==""\n"
R"==(xb++; \ )==""\n"
R"==(c += ldc; \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#elif defined CC )==""\n"
R"==(#define ADD_EACH(X, OFF) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (n > X + OFF) { \ )==""\n"
R"==(if (m > 0) \ )==""\n"
R"==(COMPUTE_C(c[0], sc[X / 4 + 0].s##OFF + xa[0] + xb[0], 0); \ )==""\n"
R"==(if (m > 1) \ )==""\n"
R"==(COMPUTE_C(c[1], sc[X / 4 + 4].s##OFF + xa[1] + xb[0], 0); \ )==""\n"
R"==(if (m > 2) \ )==""\n"
R"==(COMPUTE_C(c[2], sc[X / 4 + 8].s##OFF + xa[2] + xb[0], 0); \ )==""\n"
R"==(if (m > 3) \ )==""\n"
R"==(COMPUTE_C(c[3], sc[X / 4 + 12].s##OFF + xa[3] + xb[0], 0); \ )==""\n"
R"==(xb++; \ )==""\n"
R"==(c += ldc; \ )==""\n"
R"==(co++; \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define ADD_EACH(X, OFF) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (n > X + OFF) { \ )==""\n"
R"==(if (m > 0) \ )==""\n"
R"==(COMPUTE_C(c[0], sc[X / 4 + 0].s##OFF + xa[0] + xb[0], 0); \ )==""\n"
R"==(if (m > 1) \ )==""\n"
R"==(COMPUTE_C(c[1], sc[X / 4 + 4].s##OFF + xa[1] + xb[0], 1); \ )==""\n"
R"==(if (m > 2) \ )==""\n"
R"==(COMPUTE_C(c[2], sc[X / 4 + 8].s##OFF + xa[2] + xb[0], 2); \ )==""\n"
R"==(if (m > 3) \ )==""\n"
R"==(COMPUTE_C(c[3], sc[X / 4 + 12].s##OFF + xa[3] + xb[0], 3); \ )==""\n"
R"==(xb++; \ )==""\n"
R"==(c += ldc; \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#define ADD_SCALE(X) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ADD_EACH(X, 0); \ )==""\n"
R"==(ADD_EACH(X, 1); \ )==""\n"
R"==(ADD_EACH(X, 2); \ )==""\n"
R"==(ADD_EACH(X, 3); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define ACCUMULATE_1(a, b) \ )==""\n"
R"==(((FLOATC)a.s0 * (FLOATC)b.s0) + ((FLOATC)a.s1 * (FLOATC)b.s1) \ )==""\n"
R"==(+ ((FLOATC)a.s2 * (FLOATC)b.s2) + ((FLOATC)a.s3 * (FLOATC)b.s3) )==""\n"
R"==(#define ACCUMULATE(a, b0, b1, b2, b3) \ )==""\n"
R"==((FLOATC4)(ACCUMULATE_1(a, b0), ACCUMULATE_1(a, b1), ACCUMULATE_1(a, b2), \ )==""\n"
R"==(ACCUMULATE_1(a, b3)) )==""\n"
R"==(#define GROUPSIZE_M (6 * UNROLL_M) )==""\n"
R"==(#define GROUPSIZE_N (4 * UNROLL_N) )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(GRX))) kernel void )==""\n"
R"==(gen9_gemm_compute_x8x8s32(global FLOATA *a, global FLOATB *b, global FLOATC *c, )==""\n"
R"==(long offsetA, long offsetB, long offsetC, long lda, long ldb, long ldc, )==""\n"
R"==(long m, long n, long k, int beta, global int *ao, global int *bo, )==""\n"
R"==(global int *co, long offsetCO, int apply_co, local FLOATA *sa, )==""\n"
R"==(local FLOATB *sb, int apply_eltwise, float eltwise_alpha, )==""\n"
R"==(float eltwise_beta, float eltwise_scale) { )==""\n"
R"==(long kk = (k + UNROLL_K - 1) & ~(UNROLL_K - 1); )==""\n"
R"==(long i, j, l, ll; )==""\n"
R"==(global FLOATC *c_ori; )==""\n"
R"==(int lid = get_local_id(0); )==""\n"
R"==(int idx = get_local_id(1); )==""\n"
R"==(int idy = get_local_id(2); )==""\n"
R"==(long gdx = get_group_id(1); )==""\n"
R"==(long gdy = get_group_id(2); )==""\n"
R"==(long szx = get_local_size(1); )==""\n"
R"==(long szy = get_local_size(2); )==""\n"
R"==(a += offsetA; )==""\n"
R"==(b += offsetB; )==""\n"
R"==(c += offsetC + UNROLL_M * idx + GROUPSIZE_M * gdx + UNROLL_M * lid / GRX )==""\n"
R"==(+ (UNROLL_N * idy + GROUPSIZE_N * gdy) * ldc; )==""\n"
R"==(c_ori = c; )==""\n"
R"==(if (apply_co) { )==""\n"
R"==(co += offsetCO; )==""\n"
R"==(#ifdef RR )==""\n"
R"==(co += GROUPSIZE_M * gdx + UNROLL_M * idx + UNROLL_M * lid / GRX; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef CC )==""\n"
R"==(co += GROUPSIZE_N * gdy + UNROLL_N * idy; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(__local FLOATC *xa = (__local FLOATC *)sa; )==""\n"
R"==(sa += UNROLL_M * szx * sizeof(FLOATC); )==""\n"
R"==(__local FLOATC *xb = (__local FLOATC *)sb; )==""\n"
R"==(sb += UNROLL_N * szy * sizeof(FLOATC); )==""\n"
R"==(int cid0 = (idy * szx + idx) * get_local_size(0) + lid; )==""\n"
R"==(int ctotal = get_local_size(0) * szx * szy; )==""\n"
R"==(for (int cid = cid0; cid < szx * UNROLL_M; cid += ctotal) { )==""\n"
R"==(long sa_moffset = (cid & ~(UNROLL_M - 1)) * kk )==""\n"
R"==(+ (cid & (UNROLL_M - 1)) * UNROLL_K; )==""\n"
R"==(long i = cid + GROUPSIZE_M * gdx; )==""\n"
R"==(FLOATC sumA = 0; )==""\n"
R"==(#if defined(NN) || defined(NT) )==""\n"
R"==(long a_offset = i; )==""\n"
R"==(#else )==""\n"
R"==(long a_offset = i * lda; )==""\n"
R"==(#endif )==""\n"
R"==(for (l = 0; l < kk; l += UNROLL_K) { )==""\n"
R"==(for (ll = 0; ll < UNROLL_K; ll++) { )==""\n"
R"==(FLOATA a_val = (((i < m) && (l + ll < k)) ? a[a_offset] : 0); )==""\n"
R"==(sa[sa_moffset + l * UNROLL_M + ll] = a_val; )==""\n"
R"==(sumA -= a_val; )==""\n"
R"==(#if defined(NN) || defined(NT) )==""\n"
R"==(a_offset += lda; )==""\n"
R"==(#else )==""\n"
R"==(a_offset++; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(xa[cid] = (FLOATC)ATTR_B0 * sumA; )==""\n"
R"==(} )==""\n"
R"==(for (int cid = cid0; cid < szy * UNROLL_N; cid += ctotal) { )==""\n"
R"==(long sb_noffset = (cid & ~(UNROLL_N - 1)) * kk )==""\n"
R"==(+ (cid & (UNROLL_N - 1)) * UNROLL_K; )==""\n"
R"==(long j = cid + GROUPSIZE_N * gdy; )==""\n"
R"==(FLOATC sumB = (FLOATC)ATTR_B0 * k; )==""\n"
R"==(#if defined(NN) || defined(TN) )==""\n"
R"==(long b_offset = j * ldb; )==""\n"
R"==(#else )==""\n"
R"==(long b_offset = j; )==""\n"
R"==(#endif )==""\n"
R"==(for (l = 0; l < kk; l += UNROLL_K) { )==""\n"
R"==(for (ll = 0; ll < UNROLL_K; ll++) { )==""\n"
R"==(FLOATB b_val = (((j < n) && (l + ll < k)) ? b[b_offset] : 0); )==""\n"
R"==(sb[sb_noffset + l * UNROLL_N + ll] = b_val; )==""\n"
R"==(sumB -= b_val; )==""\n"
R"==(#if defined(NN) || defined(TN) )==""\n"
R"==(b_offset++; )==""\n"
R"==(#else )==""\n"
R"==(b_offset += ldb; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(xb[cid] = (FLOATC)ATTR_A0 * sumB; )==""\n"
R"==(} )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(m -= GROUPSIZE_M * gdx + UNROLL_M * idx; )==""\n"
R"==(if (m > UNROLL_M) m = UNROLL_M; )==""\n"
R"==(n -= GROUPSIZE_N * gdy + UNROLL_N * idy; )==""\n"
R"==(if (n > UNROLL_N) n = UNROLL_N; )==""\n"
R"==(if ((m <= 0) || (n <= 0)) return; )==""\n"
R"==(m -= UNROLL_M * lid / GRX; )==""\n"
R"==(sa += UNROLL_M * kk * idx + UNROLL_M * UNROLL_K * lid / GRX; )==""\n"
R"==(sb += UNROLL_N * kk * idy + UNROLL_K * lid; )==""\n"
R"==(xa += UNROLL_M * idx + UNROLL_M * lid / GRX; )==""\n"
R"==(xb += UNROLL_N * idy; )==""\n"
R"==(FLOATC4 sc[UNROLL_M * UNROLL_N / GRX / 4] = {0}; )==""\n"
R"==(for (l = 0; l < kk; l += UNROLL_K) { )==""\n"
R"==(FLOATA4 a0, a1, a2, a3; )==""\n"
R"==(FLOATB4 bb, b0, b1, b2, b3; )==""\n"
R"==(a0 = ((__local FLOATA4 *)sa)[0]; )==""\n"
R"==(a1 = ((__local FLOATA4 *)sa)[1]; )==""\n"
R"==(a2 = ((__local FLOATA4 *)sa)[2]; )==""\n"
R"==(a3 = ((__local FLOATA4 *)sa)[3]; )==""\n"
R"==(for (ll = 0; ll < GRX / 4; ll++) { )==""\n"
R"==(bb = ((__local FLOATB4 *)sb)[0]; )==""\n"
R"==(b0 = SHUFFLE(bb, 0); )==""\n"
R"==(b1 = SHUFFLE(bb, 1); )==""\n"
R"==(b2 = SHUFFLE(bb, 2); )==""\n"
R"==(b3 = SHUFFLE(bb, 3); )==""\n"
R"==(sc[ll * 2 + 0] += ACCUMULATE(a0, b0, b1, b2, b3); )==""\n"
R"==(sc[ll * 2 + 4] += ACCUMULATE(a1, b0, b1, b2, b3); )==""\n"
R"==(sc[ll * 2 + 8] += ACCUMULATE(a2, b0, b1, b2, b3); )==""\n"
R"==(sc[ll * 2 + 12] += ACCUMULATE(a3, b0, b1, b2, b3); )==""\n"
R"==(b0 = SHUFFLE(bb, 4); )==""\n"
R"==(b1 = SHUFFLE(bb, 5); )==""\n"
R"==(b2 = SHUFFLE(bb, 6); )==""\n"
R"==(b3 = SHUFFLE(bb, 7); )==""\n"
R"==(sc[ll * 2 + 1] += ACCUMULATE(a0, b0, b1, b2, b3); )==""\n"
R"==(sc[ll * 2 + 5] += ACCUMULATE(a1, b0, b1, b2, b3); )==""\n"
R"==(sc[ll * 2 + 9] += ACCUMULATE(a2, b0, b1, b2, b3); )==""\n"
R"==(sc[ll * 2 + 13] += ACCUMULATE(a3, b0, b1, b2, b3); )==""\n"
R"==(sb += UNROLL_N * GRX / 4; )==""\n"
R"==(} )==""\n"
R"==(sa += UNROLL_M * UNROLL_K; )==""\n"
R"==(} )==""\n"
R"==(ADD_SCALE(0); )==""\n"
R"==(ADD_SCALE(4); )==""\n"
R"==(ADD_SCALE(8); )==""\n"
R"==(ADD_SCALE(12); )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}