namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_reduction_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2021-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if defined(IS_MAX) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MIN) )==""\n"
R"==(#elif defined(IS_MIN) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MAX) )==""\n"
R"==(#elif defined(IS_MUL) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ONE) )==""\n"
R"==(#else )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ZERO) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(IS_MAX) )==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8) )==""\n"
R"==(#define ACCUMULATE(x, y) max(x, y) )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE(x, y) fmax(x, y) )==""\n"
R"==(#endif )==""\n"
R"==(#elif defined(IS_MIN) )==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8) )==""\n"
R"==(#define ACCUMULATE(x, y) min(x, y) )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE(x, y) fmin(x, y) )==""\n"
R"==(#endif )==""\n"
R"==(#elif defined(IS_MEAN) || defined(IS_SUM) )==""\n"
R"==(#define ACCUMULATE(x, y) (x + y) )==""\n"
R"==(#elif defined(IS_MUL) )==""\n"
R"==(#define ACCUMULATE(x, y) (x * y) )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE(x, y) (x + pow(fabs(y), POWER)) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(IS_MAX) || defined(IS_MIN) || defined(IS_MUL) )==""\n"
R"==(#define ACCUMULATE_AGAIN(x, y) ACCUMULATE(x, y) )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE_AGAIN(x, y) (x + y) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(IS_MEAN) )==""\n"
R"==(#define FINALIZE_REDUCTION(x) (x / REDUCTION_SIZE) )==""\n"
R"==(#elif defined(IS_LP_MAX) )==""\n"
R"==(#define FINALIZE_REDUCTION(x) rootn(fmax(x, EPS), POWER) )==""\n"
R"==(#elif defined(IS_LP_SUM) )==""\n"
R"==(#define FINALIZE_REDUCTION(x) rootn(x + EPS, POWER) )==""\n"
R"==(#elif defined(IS_P_MAX) )==""\n"
R"==(#define FINALIZE_REDUCTION(x) fmax(x, EPS) )==""\n"
R"==(#elif defined(IS_P_SUM) )==""\n"
R"==(#define FINALIZE_REDUCTION(x) (x + EPS) )==""\n"
R"==(#else )==""\n"
R"==(#define FINALIZE_REDUCTION(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(#define INIT_SUM(sum_data) DST_TO_REF(sum_data) )==""\n"
R"==(#else )==""\n"
R"==(#define INIT_SUM(sum_data) 0.0f )==""\n"
R"==(#endif  )==""\n"
R"==(#if defined(IS_MAX) )==""\n"
R"==(#define SUB_GROUP_REDUCE(x, c_block) sub_group_reduce_max(x) )==""\n"
R"==(#elif defined(IS_MIN) )==""\n"
R"==(#define SUB_GROUP_REDUCE(x, c_block) sub_group_reduce_min(x) )==""\n"
R"==(#elif defined(IS_MUL) )==""\n"
R"==(#define SUB_GROUP_REDUCE(x, c_block) \ )==""\n"
R"==(({ \ )==""\n"
R"==(int cid_end \ )==""\n"
R"==(= (INITIAL_C % SUB_GROUP_SIZE == 0 ? SUB_GROUP_SIZE \ )==""\n"
R"==(: (INITIAL_C - c_block)); \ )==""\n"
R"==(DEF_ACC_DATA_T sub_group_acc = 1.0; \ )==""\n"
R"==(for (int channel_id = 0; channel_id < cid_end; channel_id++) { \ )==""\n"
R"==(sub_group_acc *= intel_sub_group_shuffle(c_acc, channel_id); \ )==""\n"
R"==(} \ )==""\n"
R"==(sub_group_acc; \ )==""\n"
R"==(}) )==""\n"
R"==(#else )==""\n"
R"==(#define SUB_GROUP_REDUCE(x, c_block) sub_group_reduce_add(x) )==""\n"
R"==(#endif )==""\n"
R"==(#if INITIAL_C_CHUNKS == 1 )==""\n"
R"==(#define C_BLOCK_READ BLOCK_READ )==""\n"
R"==(#define AS_C_BLOCK_DATA_T AS_DATA_T )==""\n"
R"==(#define CONVERT_C_BLOCK_T TO_DEF_ACC_DATA_T )==""\n"
R"==(#define C_BLOCK_T DEF_ACC_DATA_T )==""\n"
R"==(#elif INITIAL_C_CHUNKS == 2 )==""\n"
R"==(#define C_BLOCK_READ BLOCK_READ2 )==""\n"
R"==(#define AS_C_BLOCK_DATA_T AS_DATA2_T )==""\n"
R"==(#define CONVERT_C_BLOCK_T TO_DEF_ACC_DATA2_T )==""\n"
R"==(#define C_BLOCK_T DEF_ACC_DATA2_T )==""\n"
R"==(#elif INITIAL_C_CHUNKS == 4 )==""\n"
R"==(#define C_BLOCK_READ BLOCK_READ4 )==""\n"
R"==(#define AS_C_BLOCK_DATA_T AS_DATA4_T )==""\n"
R"==(#define CONVERT_C_BLOCK_T TO_DEF_ACC_DATA4_T )==""\n"
R"==(#define C_BLOCK_T DEF_ACC_DATA4_T )==""\n"
R"==(#elif INITIAL_C_CHUNKS == 8 )==""\n"
R"==(#define C_BLOCK_READ BLOCK_READ8 )==""\n"
R"==(#define AS_C_BLOCK_DATA_T AS_DATA8_T )==""\n"
R"==(#define CONVERT_C_BLOCK_T TO_DEF_ACC_DATA8_T )==""\n"
R"==(#define C_BLOCK_T DEF_ACC_DATA8_T )==""\n"
R"==(#endif )==""\n"
R"==(#define ROUND_DOWN(a, b) ((a) - ((a) % (b))) )==""\n"
R"==(#undef ROUND_UP )==""\n"
R"==(#define ROUND_UP(a, b) ROUND_DOWN((a + b - 1), (b)) )==""\n"
R"==(#define INITIAL_SRC_OFFSET(n, c, hwd) \ )==""\n"
R"==((((n) / N_BLOCK_SIZE) * INITIAL_HWD_DIM * N_BLOCK_SIZE * ROUND_UP(INITIAL_C, C_BLOCK_SIZE) + \ )==""\n"
R"==(((c) / C_BLOCK_SIZE) * INITIAL_HWD_DIM * N_BLOCK_SIZE * C_BLOCK_SIZE + \ )==""\n"
R"==((hwd) * N_BLOCK_SIZE * C_BLOCK_SIZE + \ )==""\n"
R"==(((n) % N_BLOCK_SIZE) * C_BLOCK_SIZE + \ )==""\n"
R"==(((c) % C_BLOCK_SIZE)) )==""\n"
R"==(#define INITIAL_DST_OFFSET(n, c, hwd) \ )==""\n"
R"==(((n / N_BLOCK_SIZE) * FINAL_HWD_DIM * N_BLOCK_SIZE * ROUND_UP(FINAL_C_DIM, C_BLOCK_SIZE) + \ )==""\n"
R"==(((c) / C_BLOCK_SIZE) * FINAL_HWD_DIM * N_BLOCK_SIZE * C_BLOCK_SIZE + \ )==""\n"
R"==((hwd) * N_BLOCK_SIZE * C_BLOCK_SIZE + \ )==""\n"
R"==(((n) % N_BLOCK_SIZE) * C_BLOCK_SIZE + \ )==""\n"
R"==(((c) % C_BLOCK_SIZE)) )==""\n"
R"==(#define FINAL_SRC_OFFSET(n, c, hwd) INITIAL_DST_OFFSET(n, c, hwd) )==""\n"
R"==(#define FINAL_DST_OFFSET(n, c, hwd) \ )==""\n"
R"==(((n) / N_BLOCK_SIZE) * (FINAL_HWD_DIM / FINAL_HWD_CHUNK_SIZE) * N_BLOCK_SIZE * ROUND_UP(FINAL_C_DIM / FINAL_C_CHUNK_SIZE, C_BLOCK_SIZE) + \ )==""\n"
R"==(((c) / C_BLOCK_SIZE) * (FINAL_HWD_DIM / FINAL_HWD_CHUNK_SIZE) * N_BLOCK_SIZE * C_BLOCK_SIZE + \ )==""\n"
R"==((hwd) * N_BLOCK_SIZE * C_BLOCK_SIZE + \ )==""\n"
R"==(((n) % N_BLOCK_SIZE) * C_BLOCK_SIZE + \ )==""\n"
R"==(((c) % C_BLOCK_SIZE) )==""\n"
R"==(#if WITH_POST_OP )==""\n"
R"==(#define APPLY_POST_OPS(sum_data, data, n_idx, c_idx, hwd_idx) \ )==""\n"
R"==({ \ )==""\n"
R"==(float sum_init_val = INIT_SUM(sum_data); \ )==""\n"
R"==(const int D = hwd_start / (DST_H_DIM * DST_W_DIM); \ )==""\n"
R"==(const int H = (hwd_start % (DST_H_DIM * DST_W_DIM)) / DST_W_DIM; \ )==""\n"
R"==(const int W = hwd_start % DST_W_DIM; \ )==""\n"
R"==(APPLY_POST_OPS_SERIAL(data, float, sum_init_val, float, n_idx, 1, \ )==""\n"
R"==(c_idx, 1, D, 1, H, 1, W, 1, 0, 1); \ )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#define APPLY_POST_OPS(sum_data, data, n_idx, c_idx, hwd_idx) \ )==""\n"
R"==({} )==""\n"
R"==(#endif  )==""\n"
R"==(#define WRITE_FINAL_RESULT(dst_elem, acc, n_start, c_start, hwd_start) \ )==""\n"
R"==({ \ )==""\n"
R"==(float acc_float = FINALIZE_REDUCTION(convert_float(acc)); \ )==""\n"
R"==(APPLY_POST_OPS(dst_elem, acc_float, n_start, c_start, hwd_start); \ )==""\n"
R"==(dst_elem = TO_DST(acc_float); \ )==""\n"
R"==(} )==""\n"
R"==(#if SKIP_FINAL_PHASE )==""\n"
R"==(#define WRITE_INITIAL_RESULT WRITE_FINAL_RESULT )==""\n"
R"==(#define INITIAL_DST_DTYPE DST_DATA_T )==""\n"
R"==(#else )==""\n"
R"==(#define WRITE_INITIAL_RESULT(dst_elem, data, n_start, c_start, hwd_start) \ )==""\n"
R"==({ dst_elem = data; } )==""\n"
R"==(#define INITIAL_DST_DTYPE DEF_ACC_DATA_T )==""\n"
R"==(#endif )==""\n"
R"==(NAMED_KERNEL_ATTR(INITIAL) )==""\n"
R"==(__kernel void gen9_initial_reduce(__global SRC_DATA_T *src, )==""\n"
R"==(__global INITIAL_DST_DTYPE *dst )==""\n"
R"==(#if SKIP_FINAL_PHASE )==""\n"
R"==(POST_OP_ARGS )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(const int n_chunk_idx = GWS_GET_INITIAL_N(); )==""\n"
R"==(const int c = GWS_GET_INITIAL_C(); )==""\n"
R"==(const int c_block_idx = c / C_BLOCK_SIZE; )==""\n"
R"==(const int hwd_chunk_idx = GWS_GET_INITIAL_HWD_CHUNK_ID(); )==""\n"
R"==(const int hwd_start = hwd_chunk_idx * INITIAL_HWD_CHUNK_SIZE; )==""\n"
R"==(const int current_hwd_chunk = min(INITIAL_HWD_CHUNK_SIZE, )==""\n"
R"==(INITIAL_HWD_DIM - hwd_chunk_idx * INITIAL_HWD_CHUNK_SIZE); )==""\n"
R"==(const int aligned_hwd_chunk = ROUND_DOWN(current_hwd_chunk, VECT_DT_N); )==""\n"
R"==(const int n_start = n_chunk_idx * INITIAL_N_CHUNK_SIZE; )==""\n"
R"==(const int n_end = min(n_start + INITIAL_N_CHUNK_SIZE, INITIAL_N); )==""\n"
R"==(#if SKIP_FINAL_PHASE )==""\n"
R"==(for (int n_idx = n_start; n_idx < n_start + INITIAL_N_CHUNK_SIZE; n_idx++) { )==""\n"
R"==(for (int c_idx = c; c_idx < c + INITIAL_C_CHUNKS * SUB_GROUP_SIZE; )==""\n"
R"==(c_idx++) { )==""\n"
R"==(if (n_idx >= DST_N && n_idx < DST_N_PADDED )==""\n"
R"==(|| c_idx >= DST_C && c_idx < DST_C_PADDED) { )==""\n"
R"==(for (int hwd_idx = hwd_start; )==""\n"
R"==(#if IS_HWD_REDUCED )==""\n"
R"==(hwd_idx < hwd_start + FINAL_HWD_CHUNK_SIZE; )==""\n"
R"==(#else )==""\n"
R"==(hwd_idx < hwd_start + INITIAL_HWD_CHUNK_SIZE; )==""\n"
R"==(#endif )==""\n"
R"==(hwd_idx++) { )==""\n"
R"==(int n = (!IS_C_REDUCED && IS_N_REDUCED && NDIMS == 3 )==""\n"
R"==(&& DST_N_PADDED == 1) )==""\n"
R"==(? 0 )==""\n"
R"==(: n_idx; )==""\n"
R"==(const int dst_off = FINAL_DST_OFFSET(n, c_idx, hwd_idx); )==""\n"
R"==(dst[dst_off] = TO_DST(0.0f); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(int channel_id = c + get_sub_group_local_id(); )==""\n"
R"==(if (channel_id >= INITIAL_C || n_start >= INITIAL_N) { return; } )==""\n"
R"==(VECT_DEF_ACC_DATA_T vector_acc = INIT_ACC; )==""\n"
R"==(for (int n = n_start; n < n_end; n++) { )==""\n"
R"==(for (int hwd_id = 0; hwd_id < aligned_hwd_chunk; hwd_id += VECT_DT_N) { )==""\n"
R"==(for (int c_chunk = 0; c_chunk < INITIAL_C_CHUNKS; c_chunk++) { )==""\n"
R"==(const int off = INITIAL_SRC_OFFSET(n, c, )==""\n"
R"==(hwd_start + hwd_id )==""\n"
R"==(+ c_chunk * VECT_DT_N / INITIAL_C_CHUNKS); )==""\n"
R"==(VECT_DEF_ACC_DATA_T data )==""\n"
R"==(= AS_VECT_DEF_ACC_DATA_T(AS_VECT_DATA_T(VECT_BLOCK_READ( )==""\n"
R"==((const __global BLOCK_DATA_T *)&src[off]))); )==""\n"
R"==(vector_acc = ACCUMULATE(vector_acc, data); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(for (int hwd_id = aligned_hwd_chunk; hwd_id < current_hwd_chunk; )==""\n"
R"==(hwd_id++) { )==""\n"
R"==(const int off = INITIAL_SRC_OFFSET(n, c, hwd_start + hwd_id); )==""\n"
R"==(C_BLOCK_T data = CONVERT_C_BLOCK_T(AS_C_BLOCK_DATA_T( )==""\n"
R"==(C_BLOCK_READ((const __global BLOCK_DATA_T *)&src[off]))); )==""\n"
R"==(#if VECT_DT_N == 1 )==""\n"
R"==(vector_acc = ACCUMULATE(vector_acc, data); )==""\n"
R"==(#else  )==""\n"
R"==(#if INITIAL_C_CHUNKS == 1 )==""\n"
R"==(vector_acc[0] = ACCUMULATE(vector_acc[0], data); )==""\n"
R"==(#else )==""\n"
R"==(for (int i = 0; i < INITIAL_C_CHUNKS; i++) { )==""\n"
R"==(vector_acc[i] = ACCUMULATE(vector_acc[i], data[i]); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if VECT_DT_N == 1 )==""\n"
R"==(VECT_DEF_ACC_DATA_T acc = vector_acc; )==""\n"
R"==(#else  )==""\n"
R"==(const int elems_to_accumulate = aligned_hwd_chunk > 0 ? VECT_DT_N : 1; )==""\n"
R"==(#if INITIAL_C_CHUNKS == 1 )==""\n"
R"==(DEF_ACC_DATA_T acc = INIT_ACC; )==""\n"
R"==(for (int i = 0; i < elems_to_accumulate; i++) { )==""\n"
R"==(acc = ACCUMULATE_AGAIN(acc, vector_acc[i]); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(C_BLOCK_T acc = INIT_ACC; )==""\n"
R"==(for (int i = 0; i < elems_to_accumulate; i += INITIAL_C_CHUNKS) { )==""\n"
R"==(unroll_for(int j = 0; j < INITIAL_C_CHUNKS; j++) { )==""\n"
R"==(acc[j] = ACCUMULATE_AGAIN(acc[j], vector_acc[i + j]); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if IS_C_REDUCED )==""\n"
R"==(#if INITIAL_C_CHUNKS == 1 )==""\n"
R"==(DEF_ACC_DATA_T c_acc = acc; )==""\n"
R"==(#else )==""\n"
R"==(DEF_ACC_DATA_T c_acc = acc[0]; )==""\n"
R"==(for (int i = 1; i < INITIAL_C_CHUNKS; i++) { )==""\n"
R"==(c_acc += acc[i]; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(const int dst_off )==""\n"
R"==(= INITIAL_DST_OFFSET(n_chunk_idx, c_block_idx, hwd_chunk_idx); )==""\n"
R"==(c_acc = SUB_GROUP_REDUCE(c_acc, c); )==""\n"
R"==(if (local_id == 0) { )==""\n"
R"==(WRITE_INITIAL_RESULT(dst[dst_off], c_acc, n_start, c, hwd_start); )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(const int dst_c = c + local_id; )==""\n"
R"==(#if INITIAL_C_CHUNKS == 1 )==""\n"
R"==(WRITE_INITIAL_RESULT( )==""\n"
R"==(dst[INITIAL_DST_OFFSET(n_chunk_idx, dst_c, hwd_chunk_idx)], acc, )==""\n"
R"==(n_start, dst_c, hwd_start); )==""\n"
R"==(#else  )==""\n"
R"==(for (int i = 0; i < INITIAL_C_CHUNKS; i++) { )==""\n"
R"==(int c_off = i * SUB_GROUP_SIZE; )==""\n"
R"==(WRITE_INITIAL_RESULT(dst[INITIAL_DST_OFFSET(n_chunk_idx, dst_c + c_off, )==""\n"
R"==(hwd_chunk_idx)], )==""\n"
R"==(acc[i], n_start, c, hwd_start); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(#if !SKIP_FINAL_PHASE )==""\n"
R"==(NAMED_KERNEL_ATTR(FINAL) )==""\n"
R"==(__kernel void gen9_final_reduce( )==""\n"
R"==(__global DEF_ACC_DATA_T *src, __global DST_DATA_T *dst POST_OP_ARGS) { )==""\n"
R"==(const int n_start = GWS_GET_FINAL_N() * FINAL_N_CHUNK_SIZE; )==""\n"
R"==(const int c_start = GWS_GET_FINAL_C() * FINAL_C_CHUNK_SIZE; )==""\n"
R"==(const int hwd_start = GWS_GET_FINAL_HWD() * FINAL_HWD_CHUNK_SIZE; )==""\n"
R"==(DEF_ACC_DATA_T acc = INIT_ACC; )==""\n"
R"==(const int max_n = max(DST_N_PADDED, FINAL_N_DIM); )==""\n"
R"==(const int max_c = max(DST_C_PADDED, FINAL_C_DIM); )==""\n"
R"==(const int n_end = min(max_n, n_start + FINAL_N_CHUNK_SIZE); )==""\n"
R"==(const int c_end = min(max_c, c_start + FINAL_C_CHUNK_SIZE); )==""\n"
R"==(const int hwd_end = min(FINAL_HWD_DIM, hwd_start + FINAL_HWD_CHUNK_SIZE); )==""\n"
R"==(for (int n = n_start; n < n_end; n++) { )==""\n"
R"==(for (int c = c_start; c < c_end; c++) { )==""\n"
R"==(for (int hwd = hwd_start; hwd < hwd_end; hwd++) { )==""\n"
R"==(if ((n >= DST_N && n < DST_N_PADDED) )==""\n"
R"==(|| (c >= DST_C && c < DST_C_PADDED)) { )==""\n"
R"==(#if NDIMS == 2 && DST_N_PADDED == 1  )==""\n"
R"==(const int dst_off = FINAL_DST_OFFSET(0, c, hwd); )==""\n"
R"==(#elif NDIMS >= 3 && DST_N_PADDED == 1 && IS_HWD_REDUCED  )==""\n"
R"==(const int dst_off = FINAL_DST_OFFSET(0, c, 0); )==""\n"
R"==(#elif IS_HWD_REDUCED  )==""\n"
R"==(const int dst_off = FINAL_DST_OFFSET(n, c, 0); )==""\n"
R"==(#else )==""\n"
R"==(const int dst_off = FINAL_DST_OFFSET(n, c, hwd); )==""\n"
R"==(#endif )==""\n"
R"==(dst[dst_off] = TO_DST(0.0f); )==""\n"
R"==(} )==""\n"
R"==(if (n < FINAL_N_DIM && c < FINAL_C_DIM) { )==""\n"
R"==(const int off = FINAL_SRC_OFFSET(n, c, hwd); )==""\n"
R"==(const DEF_ACC_DATA_T data = src[off]; )==""\n"
R"==(acc = ACCUMULATE_AGAIN(acc, data); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(if (n_start < DST_N && c_start < DST_C) { )==""\n"
R"==(const int off = FINAL_DST_OFFSET(n_start, c_start, hwd_start); )==""\n"
R"==(WRITE_FINAL_RESULT(dst[off], acc, n_start, c_start, hwd_start); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==()==";
}
}
}
}