namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *gen9_softmax_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define LOAD_FLOAT8(prefix, ptr) \ )==""\n"
R"==(DATA_TO_FLOAT8(prefix, \ )==""\n"
R"==(BLOCK_TO_DATA8(prefix, \ )==""\n"
R"==(READ_BLOCK8(prefix, \ )==""\n"
R"==((__global BLOCK_T(ALIAS(prefix)) *)(ptr)))) )==""\n"
R"==(#define STORE_FLOAT8(prefix, ptr, val) \ )==""\n"
R"==(WRITE_BLOCK8(prefix, (__global BLOCK_T(ALIAS(prefix)) *)(ptr), \ )==""\n"
R"==(DATA_TO_BLOCK8(prefix, FLOAT_TO_DATA8(prefix, val))) )==""\n"
R"==(#define VECT_SIZE 8 )==""\n"
R"==(#define NUM_BUF (SOFTMAX_AXIS_SIZE / SUB_GROUP_SIZE / VECT_SIZE) )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(__attribute__((reqd_work_group_size(GROUP_SIZE, 1, 1))) )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) __kernel void )==""\n"
R"==(gen9_softmax_fwd(__global SRC_DATA_T *src, __global DST_DATA_T *dst, )==""\n"
R"==(__global float *src_scale, __global float *dst_scale) { )==""\n"
R"==(float scale = 1.0f; )==""\n"
R"==(#if WITH_SRC_SCALES )==""\n"
R"==(scale *= src_scale[0]; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_DST_SCALES )==""\n"
R"==(scale /= dst_scale[0]; )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_NHWC || IS_BLOCKED )==""\n"
R"==(const int group = get_global_id(0) / GROUP_SIZE; )==""\n"
R"==(const int mb = group / OC_PADDED; )==""\n"
R"==(const int local_oc = group % OC_PADDED; )==""\n"
R"==(const int local_id = get_local_id(0); )==""\n"
R"==(const int axis_chunk = (local_id / SUB_GROUP_SIZE) * SOFTMAX_BUF; )==""\n"
R"==(const int subgroup_id = get_sub_group_local_id(); )==""\n"
R"==(const int oc_chunk = OC * VECT_SIZE * subgroup_id; )==""\n"
R"==(#if IS_BLOCKED )==""\n"
R"==(const int oc_block_id = local_oc / OC; )==""\n"
R"==(const int oc_in_block = local_oc % OC; )==""\n"
R"==(int data_off = (MB * oc_block_id + mb) * OC * SOFTMAX_AXIS_SIZE + oc_chunk )==""\n"
R"==(+ oc_in_block; )==""\n"
R"==(#else )==""\n"
R"==(int data_off = mb * OC_PADDED * SOFTMAX_AXIS_SIZE + oc_chunk + local_oc; )==""\n"
R"==(#endif )==""\n"
R"==(float d[VECT_SIZE]; )==""\n"
R"==(float max_ = -FLT_MAX; )==""\n"
R"==(float denom_ = 0.f; )==""\n"
R"==(src += data_off; )==""\n"
R"==(for (int k = 0, axis_channel_id = OC * axis_chunk; k < VECT_SIZE; )==""\n"
R"==(++k, axis_channel_id += OC) { )==""\n"
R"==(d[k] = DATA_TO_FLOAT(SRC, src[axis_channel_id]); )==""\n"
R"==(max_ = max(d[k], max_); )==""\n"
R"==(} )==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE )==""\n"
R"==(max_ = sub_group_reduce_max(max_); )==""\n"
R"==(#else )==""\n"
R"==(max_ = work_group_reduce_max(max_); )==""\n"
R"==(#endif )==""\n"
R"==(for (int k = 0; k < VECT_SIZE; ++k) { )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(denom_ += exp(d[k] - max_); )==""\n"
R"==(#else )==""\n"
R"==(d[k] = exp(d[k] - max_); )==""\n"
R"==(denom_ += d[k]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE )==""\n"
R"==(denom_ = sub_group_reduce_add(denom_); )==""\n"
R"==(#else )==""\n"
R"==(denom_ = work_group_reduce_add(denom_); )==""\n"
R"==(#endif )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(denom_ = log(denom_); )==""\n"
R"==(#else )==""\n"
R"==(denom_ = 1.0 / denom_; )==""\n"
R"==(#endif )==""\n"
R"==(dst += data_off; )==""\n"
R"==(for (int k = 0, axis_channel_id = OC * axis_chunk; k < VECT_SIZE; )==""\n"
R"==(++k, axis_channel_id += OC) { )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(d[k] = d[k] - max_ - denom_; )==""\n"
R"==(#else )==""\n"
R"==(d[k] = d[k] * denom_; )==""\n"
R"==(#endif )==""\n"
R"==(dst[axis_channel_id] = FLOAT_TO_DATA(DST, d[k] * scale); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(const int data_off = (get_global_id(0) / GROUP_SIZE) * SOFTMAX_AXIS_SIZE; )==""\n"
R"==(float8 d[NUM_BUF]; )==""\n"
R"==(float max_ = -FLT_MAX; )==""\n"
R"==(float denom_ = 0.f; )==""\n"
R"==(src += data_off; )==""\n"
R"==(for (int k = 0; k < NUM_BUF; ++k) { )==""\n"
R"==(d[k] = LOAD_FLOAT8(SRC, &src[k * VECT_SIZE * SUB_GROUP_SIZE]); )==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) { )==""\n"
R"==(max_ = max(d[k][i], max_); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(max_ = sub_group_reduce_max(max_); )==""\n"
R"==(for (int k = 0; k < NUM_BUF; ++k) { )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) )==""\n"
R"==(denom_ += exp(d[k][i] - max_); )==""\n"
R"==(#else )==""\n"
R"==(d[k] = exp(d[k] - max_); )==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) )==""\n"
R"==(denom_ += d[k][i]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(denom_ = sub_group_reduce_add(denom_); )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(denom_ = log(denom_); )==""\n"
R"==(#else )==""\n"
R"==(denom_ = 1.0 / denom_; )==""\n"
R"==(#endif )==""\n"
R"==(dst += data_off; )==""\n"
R"==(for (int k = 0; k < NUM_BUF; ++k) { )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(d[k] = d[k] - max_ - denom_; )==""\n"
R"==(#else )==""\n"
R"==(d[k] = d[k] * denom_; )==""\n"
R"==(#endif )==""\n"
R"==(STORE_FLOAT8(DST, &dst[k * VECT_SIZE * SUB_GROUP_SIZE], scale * d[k]); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_BWD )==""\n"
R"==(__attribute__((reqd_work_group_size(GROUP_SIZE, 1, 1))) )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) __kernel void )==""\n"
R"==(gen9_softmax_bwd(__global DST_DATA_T *dst, __global SRC_DATA_T *diff_src, )==""\n"
R"==(__global DST_DATA_T *diff_dst) { )==""\n"
R"==(#if IS_NHWC || IS_16C )==""\n"
R"==(const int groups = get_global_id(0) / GROUP_SIZE; )==""\n"
R"==(const int batch = groups / IC_PADDED; )==""\n"
R"==(const int ic = groups % IC_PADDED; )==""\n"
R"==(const int sub_grp_id = get_sub_group_local_id(); )==""\n"
R"==(const int local_id = get_local_id(0); )==""\n"
R"==(const int slice = local_id / SUB_GROUP_SIZE; )==""\n"
R"==(const int ic_buff = IC * VECT_SIZE; )==""\n"
R"==(#if IS_16C )==""\n"
R"==(const int ic_blk = ic / IC; )==""\n"
R"==(const int ic_in_blk = ic % IC; )==""\n"
R"==(int data_off = BATCH * IC * SOFTMAX_AXIS_SIZE * ic_blk )==""\n"
R"==(+ batch * IC * SOFTMAX_AXIS_SIZE + ic_buff * sub_grp_id + ic_in_blk; )==""\n"
R"==(#else )==""\n"
R"==(int data_off = batch * IC * SOFTMAX_AXIS_SIZE + ic_buff * sub_grp_id + ic; )==""\n"
R"==(#endif )==""\n"
R"==(float sbr = 0.f; )==""\n"
R"==(float diff_d[VECT_SIZE]; )==""\n"
R"==(float dst_[VECT_SIZE]; )==""\n"
R"==(diff_dst += data_off; )==""\n"
R"==(dst += data_off; )==""\n"
R"==(for (int i = 0, idx = IC * slice * SOFTMAX_BUF; i < VECT_SIZE; )==""\n"
R"==(++i, idx += IC) { )==""\n"
R"==(diff_d[i] = DATA_TO_FLOAT(DST, diff_dst[idx]); )==""\n"
R"==(dst_[i] = DATA_TO_FLOAT(DST, dst[idx]); )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(sbr += diff_d[i]; )==""\n"
R"==(#else )==""\n"
R"==(sbr += dst_[i] * diff_d[i]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if GROUP_SIZE == SUB_GROUP_SIZE )==""\n"
R"==(sbr = sub_group_reduce_add(sbr); )==""\n"
R"==(#else )==""\n"
R"==(sbr = work_group_reduce_add(sbr); )==""\n"
R"==(#endif )==""\n"
R"==(diff_src += data_off; )==""\n"
R"==(for (int i = 0, idx = IC * slice * SOFTMAX_BUF; i < VECT_SIZE; )==""\n"
R"==(++i, idx += IC) { )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(diff_d[i] = diff_d[i] - exp(dst_[i]) * sbr; )==""\n"
R"==(#else )==""\n"
R"==(diff_d[i] = (diff_d[i] - sbr) * dst_[i]; )==""\n"
R"==(#endif )==""\n"
R"==(diff_src[idx] = FLOAT_TO_DATA(SRC, diff_d[i]); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(const int data_off = (get_global_id(0) / GROUP_SIZE) * SOFTMAX_AXIS_SIZE; )==""\n"
R"==(float sbr = 0.f; )==""\n"
R"==(float8 diff_d[NUM_BUF]; )==""\n"
R"==(float8 dst_[NUM_BUF]; )==""\n"
R"==(diff_dst += data_off; )==""\n"
R"==(dst += data_off; )==""\n"
R"==(for (int k = 0; k < NUM_BUF; ++k) { )==""\n"
R"==(diff_d[k] = LOAD_FLOAT8(DST, &diff_dst[k * VECT_SIZE * SUB_GROUP_SIZE]); )==""\n"
R"==(dst_[k] = LOAD_FLOAT8(DST, &dst[k * VECT_SIZE * SUB_GROUP_SIZE]); )==""\n"
R"==(for (int i = 0; i < VECT_SIZE; ++i) { )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(sbr += diff_d[k][i]; )==""\n"
R"==(#else )==""\n"
R"==(sbr += dst_[k][i] * diff_d[k][i]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(sbr = sub_group_reduce_add(sbr); )==""\n"
R"==(diff_src += data_off; )==""\n"
R"==(for (int k = 0; k < NUM_BUF; ++k) { )==""\n"
R"==(#if LOGSOFTMAX )==""\n"
R"==(diff_d[k] = diff_d[k] - exp(dst_[k]) * sbr; )==""\n"
R"==(#else )==""\n"
R"==(diff_d[k] = (diff_d[k] - sbr) * dst_[k]; )==""\n"
R"==(#endif )==""\n"
R"==(STORE_FLOAT8(SRC, &diff_src[k * VECT_SIZE * SUB_GROUP_SIZE], diff_d[k]); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}