namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *many_inputs_sum_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define INIT_N_INPUTS(i) \ )==""\n"
R"==(if (i < N_INPUTS) inputs[i] = input##i; )==""\n"
R"==(#define INIT_MAX_N_INPUTS(i) \ )==""\n"
R"==(if (i < MAX_N_INPUTS) inputs[i] = input##i; )==""\n"
R"==(float get_value(__global SRC_DATA_T *src, ptrdiff_t offset) { )==""\n"
R"==(if (offset >= N_ELEMS) return 0; )==""\n"
R"==(return CONVERT_FLOAT_T(src[offset]); )==""\n"
R"==(} )==""\n"
R"==(#define many_inputs_sum_impl(inputs, output, scales, num_inputs, local_val) \ )==""\n"
R"==(const uint group_id = get_group_id(0); \ )==""\n"
R"==(const uint group_size = get_local_size(0); \ )==""\n"
R"==(const uint gid = get_global_id(0); \ )==""\n"
R"==(ptrdiff_t offset = gid / num_inputs; \ )==""\n"
R"==(const int tensor_idx = gid % num_inputs; \ )==""\n"
R"==(const int local_id = get_local_id(0); \ )==""\n"
R"==(local_val[local_id] \ )==""\n"
R"==(= get_value(inputs[tensor_idx], offset) * scales[tensor_idx]; \ )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); \ )==""\n"
R"==(if (tensor_idx == 0 && offset < N_ELEMS) { \ )==""\n"
R"==(float final_val = 0; \ )==""\n"
R"==(for (int i = 0; i < num_inputs; i++) { \ )==""\n"
R"==(final_val += local_val[local_id + i]; \ )==""\n"
R"==(} \ )==""\n"
R"==(output[offset] = TO_DST(final_val + CONVERT_FLOAT_T(output[offset])); \ )==""\n"
R"==(} )==""\n"
R"==(__kernel void many_inputs_sum(__global SRC_DATA_T *input0, )==""\n"
R"==(__global SRC_DATA_T *input1, __global SRC_DATA_T *input2, )==""\n"
R"==(__global SRC_DATA_T *input3, __global SRC_DATA_T *input4, )==""\n"
R"==(__global SRC_DATA_T *input5, __global SRC_DATA_T *input6, )==""\n"
R"==(__global SRC_DATA_T *input7, __global SRC_DATA_T *input8, )==""\n"
R"==(__global SRC_DATA_T *input9, __global SRC_DATA_T *input10, )==""\n"
R"==(__global SRC_DATA_T *input11, __global SRC_DATA_T *input12, )==""\n"
R"==(__global SRC_DATA_T *input13, __global SRC_DATA_T *input14, )==""\n"
R"==(__global SRC_DATA_T *input15, __global SRC_DATA_T *input16, )==""\n"
R"==(__global SRC_DATA_T *input17, __global SRC_DATA_T *input18, )==""\n"
R"==(__global SRC_DATA_T *input19, __global SRC_DATA_T *input20, )==""\n"
R"==(__global SRC_DATA_T *input21, __global SRC_DATA_T *input22, )==""\n"
R"==(__global SRC_DATA_T *input23, __global SRC_DATA_T *input24, )==""\n"
R"==(__global SRC_DATA_T *input25, __global SRC_DATA_T *input26, )==""\n"
R"==(__global SRC_DATA_T *input27, __global SRC_DATA_T *input28, )==""\n"
R"==(__global SRC_DATA_T *input29, __global SRC_DATA_T *input30, )==""\n"
R"==(__global SRC_DATA_T *input31, __global SRC_DATA_T *input32, )==""\n"
R"==(__global SRC_DATA_T *input33, __global SRC_DATA_T *input34, )==""\n"
R"==(__global SRC_DATA_T *input35, __global SRC_DATA_T *input36, )==""\n"
R"==(__global SRC_DATA_T *input37, __global SRC_DATA_T *input38, )==""\n"
R"==(__global SRC_DATA_T *input39, __global SRC_DATA_T *input40, )==""\n"
R"==(__global SRC_DATA_T *input41, __global SRC_DATA_T *input42, )==""\n"
R"==(__global SRC_DATA_T *input43, __global SRC_DATA_T *input44, )==""\n"
R"==(__global SRC_DATA_T *input45, __global SRC_DATA_T *input46, )==""\n"
R"==(__global SRC_DATA_T *input47, __global SRC_DATA_T *input48, )==""\n"
R"==(__global SRC_DATA_T *input49, __global SRC_DATA_T *input50, )==""\n"
R"==(__global SRC_DATA_T *input51, __global SRC_DATA_T *input52, )==""\n"
R"==(__global SRC_DATA_T *input53, __global SRC_DATA_T *input54, )==""\n"
R"==(__global SRC_DATA_T *input55, __global SRC_DATA_T *input56, )==""\n"
R"==(__global SRC_DATA_T *input57, __global SRC_DATA_T *input58, )==""\n"
R"==(__global SRC_DATA_T *input59, __global SRC_DATA_T *input60, )==""\n"
R"==(__global SRC_DATA_T *input61, __global SRC_DATA_T *input62, )==""\n"
R"==(__global SRC_DATA_T *input63, __global SRC_DATA_T *input64, )==""\n"
R"==(__global SRC_DATA_T *input65, __global SRC_DATA_T *input66, )==""\n"
R"==(__global SRC_DATA_T *input67, __global SRC_DATA_T *input68, )==""\n"
R"==(__global SRC_DATA_T *input69, __global SRC_DATA_T *input70, )==""\n"
R"==(__global SRC_DATA_T *input71, __global SRC_DATA_T *input72, )==""\n"
R"==(__global SRC_DATA_T *input73, __global SRC_DATA_T *input74, )==""\n"
R"==(__global SRC_DATA_T *input75, __global SRC_DATA_T *input76, )==""\n"
R"==(__global SRC_DATA_T *input77, __global SRC_DATA_T *input78, )==""\n"
R"==(__global SRC_DATA_T *input79, __global SRC_DATA_T *input80, )==""\n"
R"==(__global SRC_DATA_T *input81, __global SRC_DATA_T *input82, )==""\n"
R"==(__global SRC_DATA_T *input83, __global SRC_DATA_T *input84, )==""\n"
R"==(__global SRC_DATA_T *input85, __global SRC_DATA_T *input86, )==""\n"
R"==(__global SRC_DATA_T *input87, __global SRC_DATA_T *input88, )==""\n"
R"==(__global SRC_DATA_T *input89, __global SRC_DATA_T *input90, )==""\n"
R"==(__global SRC_DATA_T *input91, __global SRC_DATA_T *input92, )==""\n"
R"==(__global SRC_DATA_T *input93, __global DST_DATA_T *output, )==""\n"
R"==(__global float *scales) { )==""\n"
R"==(__local float local_val[256]; )==""\n"
R"==(__global SRC_DATA_T *inputs[94]; )==""\n"
R"==(INIT_N_INPUTS(0); )==""\n"
R"==(INIT_N_INPUTS(1); )==""\n"
R"==(INIT_N_INPUTS(2); )==""\n"
R"==(INIT_N_INPUTS(3); )==""\n"
R"==(INIT_N_INPUTS(4); )==""\n"
R"==(INIT_N_INPUTS(5); )==""\n"
R"==(INIT_N_INPUTS(6); )==""\n"
R"==(INIT_N_INPUTS(7); )==""\n"
R"==(INIT_N_INPUTS(8); )==""\n"
R"==(INIT_N_INPUTS(9); )==""\n"
R"==(INIT_N_INPUTS(10); )==""\n"
R"==(INIT_N_INPUTS(11); )==""\n"
R"==(INIT_N_INPUTS(12); )==""\n"
R"==(INIT_N_INPUTS(13); )==""\n"
R"==(INIT_N_INPUTS(14); )==""\n"
R"==(INIT_N_INPUTS(15); )==""\n"
R"==(INIT_N_INPUTS(16); )==""\n"
R"==(INIT_N_INPUTS(17); )==""\n"
R"==(INIT_N_INPUTS(18); )==""\n"
R"==(INIT_N_INPUTS(19); )==""\n"
R"==(INIT_N_INPUTS(20); )==""\n"
R"==(INIT_N_INPUTS(21); )==""\n"
R"==(INIT_N_INPUTS(22); )==""\n"
R"==(INIT_N_INPUTS(23); )==""\n"
R"==(INIT_N_INPUTS(24); )==""\n"
R"==(INIT_N_INPUTS(25); )==""\n"
R"==(INIT_N_INPUTS(26); )==""\n"
R"==(INIT_N_INPUTS(27); )==""\n"
R"==(INIT_N_INPUTS(28); )==""\n"
R"==(INIT_N_INPUTS(29); )==""\n"
R"==(INIT_N_INPUTS(30); )==""\n"
R"==(INIT_N_INPUTS(31); )==""\n"
R"==(INIT_N_INPUTS(32); )==""\n"
R"==(INIT_N_INPUTS(33); )==""\n"
R"==(INIT_N_INPUTS(34); )==""\n"
R"==(INIT_N_INPUTS(35); )==""\n"
R"==(INIT_N_INPUTS(36); )==""\n"
R"==(INIT_N_INPUTS(37); )==""\n"
R"==(INIT_N_INPUTS(38); )==""\n"
R"==(INIT_N_INPUTS(39); )==""\n"
R"==(INIT_N_INPUTS(40); )==""\n"
R"==(INIT_N_INPUTS(41); )==""\n"
R"==(INIT_N_INPUTS(42); )==""\n"
R"==(INIT_N_INPUTS(43); )==""\n"
R"==(INIT_N_INPUTS(44); )==""\n"
R"==(INIT_N_INPUTS(45); )==""\n"
R"==(INIT_N_INPUTS(46); )==""\n"
R"==(INIT_N_INPUTS(47); )==""\n"
R"==(INIT_N_INPUTS(48); )==""\n"
R"==(INIT_N_INPUTS(49); )==""\n"
R"==(INIT_N_INPUTS(50); )==""\n"
R"==(INIT_N_INPUTS(51); )==""\n"
R"==(INIT_N_INPUTS(52); )==""\n"
R"==(INIT_N_INPUTS(53); )==""\n"
R"==(INIT_N_INPUTS(54); )==""\n"
R"==(INIT_N_INPUTS(55); )==""\n"
R"==(INIT_N_INPUTS(56); )==""\n"
R"==(INIT_N_INPUTS(57); )==""\n"
R"==(INIT_N_INPUTS(58); )==""\n"
R"==(INIT_N_INPUTS(59); )==""\n"
R"==(INIT_N_INPUTS(60); )==""\n"
R"==(INIT_N_INPUTS(61); )==""\n"
R"==(INIT_N_INPUTS(62); )==""\n"
R"==(INIT_N_INPUTS(63); )==""\n"
R"==(INIT_N_INPUTS(64); )==""\n"
R"==(INIT_N_INPUTS(65); )==""\n"
R"==(INIT_N_INPUTS(66); )==""\n"
R"==(INIT_N_INPUTS(67); )==""\n"
R"==(INIT_N_INPUTS(68); )==""\n"
R"==(INIT_N_INPUTS(69); )==""\n"
R"==(INIT_N_INPUTS(70); )==""\n"
R"==(INIT_N_INPUTS(71); )==""\n"
R"==(INIT_N_INPUTS(72); )==""\n"
R"==(INIT_N_INPUTS(73); )==""\n"
R"==(INIT_N_INPUTS(74); )==""\n"
R"==(INIT_N_INPUTS(75); )==""\n"
R"==(INIT_N_INPUTS(76); )==""\n"
R"==(INIT_N_INPUTS(77); )==""\n"
R"==(INIT_N_INPUTS(78); )==""\n"
R"==(INIT_N_INPUTS(79); )==""\n"
R"==(INIT_N_INPUTS(80); )==""\n"
R"==(INIT_N_INPUTS(81); )==""\n"
R"==(INIT_N_INPUTS(82); )==""\n"
R"==(INIT_N_INPUTS(83); )==""\n"
R"==(INIT_N_INPUTS(84); )==""\n"
R"==(INIT_N_INPUTS(85); )==""\n"
R"==(INIT_N_INPUTS(86); )==""\n"
R"==(INIT_N_INPUTS(87); )==""\n"
R"==(INIT_N_INPUTS(88); )==""\n"
R"==(INIT_N_INPUTS(89); )==""\n"
R"==(INIT_N_INPUTS(90); )==""\n"
R"==(INIT_N_INPUTS(91); )==""\n"
R"==(INIT_N_INPUTS(92); )==""\n"
R"==(INIT_N_INPUTS(93); )==""\n"
R"==(many_inputs_sum_impl(inputs, output, scales, N_INPUTS, local_val); )==""\n"
R"==(} )==""\n"
R"==(__kernel void many_inputs_sum_batched(__global SRC_DATA_T *input0, )==""\n"
R"==(__global SRC_DATA_T *input1, __global SRC_DATA_T *input2, )==""\n"
R"==(__global SRC_DATA_T *input3, __global SRC_DATA_T *input4, )==""\n"
R"==(__global SRC_DATA_T *input5, __global SRC_DATA_T *input6, )==""\n"
R"==(__global SRC_DATA_T *input7, __global SRC_DATA_T *input8, )==""\n"
R"==(__global SRC_DATA_T *input9, __global SRC_DATA_T *input10, )==""\n"
R"==(__global SRC_DATA_T *input11, __global SRC_DATA_T *input12, )==""\n"
R"==(__global SRC_DATA_T *input13, __global SRC_DATA_T *input14, )==""\n"
R"==(__global SRC_DATA_T *input15, __global SRC_DATA_T *input16, )==""\n"
R"==(__global SRC_DATA_T *input17, __global SRC_DATA_T *input18, )==""\n"
R"==(__global SRC_DATA_T *input19, __global SRC_DATA_T *input20, )==""\n"
R"==(__global SRC_DATA_T *input21, __global SRC_DATA_T *input22, )==""\n"
R"==(__global SRC_DATA_T *input23, __global SRC_DATA_T *input24, )==""\n"
R"==(__global SRC_DATA_T *input25, __global SRC_DATA_T *input26, )==""\n"
R"==(__global SRC_DATA_T *input27, __global SRC_DATA_T *input28, )==""\n"
R"==(__global SRC_DATA_T *input29, __global SRC_DATA_T *input30, )==""\n"
R"==(__global SRC_DATA_T *input31, __global SRC_DATA_T *input32, )==""\n"
R"==(__global SRC_DATA_T *input33, __global SRC_DATA_T *input34, )==""\n"
R"==(__global SRC_DATA_T *input35, __global SRC_DATA_T *input36, )==""\n"
R"==(__global SRC_DATA_T *input37, __global SRC_DATA_T *input38, )==""\n"
R"==(__global SRC_DATA_T *input39, __global SRC_DATA_T *input40, )==""\n"
R"==(__global SRC_DATA_T *input41, __global SRC_DATA_T *input42, )==""\n"
R"==(__global SRC_DATA_T *input43, __global SRC_DATA_T *input44, )==""\n"
R"==(__global SRC_DATA_T *input45, __global SRC_DATA_T *input46, )==""\n"
R"==(__global SRC_DATA_T *input47, __global SRC_DATA_T *input48, )==""\n"
R"==(__global SRC_DATA_T *input49, __global SRC_DATA_T *input50, )==""\n"
R"==(__global SRC_DATA_T *input51, __global SRC_DATA_T *input52, )==""\n"
R"==(__global SRC_DATA_T *input53, __global SRC_DATA_T *input54, )==""\n"
R"==(__global SRC_DATA_T *input55, __global SRC_DATA_T *input56, )==""\n"
R"==(__global SRC_DATA_T *input57, __global SRC_DATA_T *input58, )==""\n"
R"==(__global SRC_DATA_T *input59, __global SRC_DATA_T *input60, )==""\n"
R"==(__global SRC_DATA_T *input61, __global SRC_DATA_T *input62, )==""\n"
R"==(__global SRC_DATA_T *input63, __global SRC_DATA_T *input64, )==""\n"
R"==(__global SRC_DATA_T *input65, __global SRC_DATA_T *input66, )==""\n"
R"==(__global SRC_DATA_T *input67, __global SRC_DATA_T *input68, )==""\n"
R"==(__global SRC_DATA_T *input69, __global SRC_DATA_T *input70, )==""\n"
R"==(__global SRC_DATA_T *input71, __global SRC_DATA_T *input72, )==""\n"
R"==(__global SRC_DATA_T *input73, __global SRC_DATA_T *input74, )==""\n"
R"==(__global SRC_DATA_T *input75, __global SRC_DATA_T *input76, )==""\n"
R"==(__global SRC_DATA_T *input77, __global SRC_DATA_T *input78, )==""\n"
R"==(__global SRC_DATA_T *input79, __global SRC_DATA_T *input80, )==""\n"
R"==(__global SRC_DATA_T *input81, __global SRC_DATA_T *input82, )==""\n"
R"==(__global SRC_DATA_T *input83, __global SRC_DATA_T *input84, )==""\n"
R"==(__global SRC_DATA_T *input85, __global SRC_DATA_T *input86, )==""\n"
R"==(__global SRC_DATA_T *input87, __global SRC_DATA_T *input88, )==""\n"
R"==(__global SRC_DATA_T *input89, __global SRC_DATA_T *input90, )==""\n"
R"==(__global SRC_DATA_T *input91, __global SRC_DATA_T *input92, )==""\n"
R"==(__global SRC_DATA_T *input93, __global DST_DATA_T *output, )==""\n"
R"==(__global float *scales) { )==""\n"
R"==(__local float local_val[256]; )==""\n"
R"==(__global SRC_DATA_T *inputs[94]; )==""\n"
R"==(INIT_MAX_N_INPUTS(0); )==""\n"
R"==(INIT_MAX_N_INPUTS(1); )==""\n"
R"==(INIT_MAX_N_INPUTS(2); )==""\n"
R"==(INIT_MAX_N_INPUTS(3); )==""\n"
R"==(INIT_MAX_N_INPUTS(4); )==""\n"
R"==(INIT_MAX_N_INPUTS(5); )==""\n"
R"==(INIT_MAX_N_INPUTS(6); )==""\n"
R"==(INIT_MAX_N_INPUTS(7); )==""\n"
R"==(INIT_MAX_N_INPUTS(8); )==""\n"
R"==(INIT_MAX_N_INPUTS(9); )==""\n"
R"==(INIT_MAX_N_INPUTS(10); )==""\n"
R"==(INIT_MAX_N_INPUTS(11); )==""\n"
R"==(INIT_MAX_N_INPUTS(12); )==""\n"
R"==(INIT_MAX_N_INPUTS(13); )==""\n"
R"==(INIT_MAX_N_INPUTS(14); )==""\n"
R"==(INIT_MAX_N_INPUTS(15); )==""\n"
R"==(INIT_MAX_N_INPUTS(16); )==""\n"
R"==(INIT_MAX_N_INPUTS(17); )==""\n"
R"==(INIT_MAX_N_INPUTS(18); )==""\n"
R"==(INIT_MAX_N_INPUTS(19); )==""\n"
R"==(INIT_MAX_N_INPUTS(20); )==""\n"
R"==(INIT_MAX_N_INPUTS(21); )==""\n"
R"==(INIT_MAX_N_INPUTS(22); )==""\n"
R"==(INIT_MAX_N_INPUTS(23); )==""\n"
R"==(INIT_MAX_N_INPUTS(24); )==""\n"
R"==(INIT_MAX_N_INPUTS(25); )==""\n"
R"==(INIT_MAX_N_INPUTS(26); )==""\n"
R"==(INIT_MAX_N_INPUTS(27); )==""\n"
R"==(INIT_MAX_N_INPUTS(28); )==""\n"
R"==(INIT_MAX_N_INPUTS(29); )==""\n"
R"==(INIT_MAX_N_INPUTS(30); )==""\n"
R"==(INIT_MAX_N_INPUTS(31); )==""\n"
R"==(INIT_MAX_N_INPUTS(32); )==""\n"
R"==(INIT_MAX_N_INPUTS(33); )==""\n"
R"==(INIT_MAX_N_INPUTS(34); )==""\n"
R"==(INIT_MAX_N_INPUTS(35); )==""\n"
R"==(INIT_MAX_N_INPUTS(36); )==""\n"
R"==(INIT_MAX_N_INPUTS(37); )==""\n"
R"==(INIT_MAX_N_INPUTS(38); )==""\n"
R"==(INIT_MAX_N_INPUTS(39); )==""\n"
R"==(INIT_MAX_N_INPUTS(40); )==""\n"
R"==(INIT_MAX_N_INPUTS(41); )==""\n"
R"==(INIT_MAX_N_INPUTS(42); )==""\n"
R"==(INIT_MAX_N_INPUTS(43); )==""\n"
R"==(INIT_MAX_N_INPUTS(44); )==""\n"
R"==(INIT_MAX_N_INPUTS(45); )==""\n"
R"==(INIT_MAX_N_INPUTS(46); )==""\n"
R"==(INIT_MAX_N_INPUTS(47); )==""\n"
R"==(INIT_MAX_N_INPUTS(48); )==""\n"
R"==(INIT_MAX_N_INPUTS(49); )==""\n"
R"==(INIT_MAX_N_INPUTS(50); )==""\n"
R"==(INIT_MAX_N_INPUTS(51); )==""\n"
R"==(INIT_MAX_N_INPUTS(52); )==""\n"
R"==(INIT_MAX_N_INPUTS(53); )==""\n"
R"==(INIT_MAX_N_INPUTS(54); )==""\n"
R"==(INIT_MAX_N_INPUTS(55); )==""\n"
R"==(INIT_MAX_N_INPUTS(56); )==""\n"
R"==(INIT_MAX_N_INPUTS(57); )==""\n"
R"==(INIT_MAX_N_INPUTS(58); )==""\n"
R"==(INIT_MAX_N_INPUTS(59); )==""\n"
R"==(INIT_MAX_N_INPUTS(60); )==""\n"
R"==(INIT_MAX_N_INPUTS(61); )==""\n"
R"==(INIT_MAX_N_INPUTS(62); )==""\n"
R"==(INIT_MAX_N_INPUTS(63); )==""\n"
R"==(INIT_MAX_N_INPUTS(64); )==""\n"
R"==(INIT_MAX_N_INPUTS(65); )==""\n"
R"==(INIT_MAX_N_INPUTS(66); )==""\n"
R"==(INIT_MAX_N_INPUTS(67); )==""\n"
R"==(INIT_MAX_N_INPUTS(68); )==""\n"
R"==(INIT_MAX_N_INPUTS(69); )==""\n"
R"==(INIT_MAX_N_INPUTS(70); )==""\n"
R"==(INIT_MAX_N_INPUTS(71); )==""\n"
R"==(INIT_MAX_N_INPUTS(72); )==""\n"
R"==(INIT_MAX_N_INPUTS(73); )==""\n"
R"==(INIT_MAX_N_INPUTS(74); )==""\n"
R"==(INIT_MAX_N_INPUTS(75); )==""\n"
R"==(INIT_MAX_N_INPUTS(76); )==""\n"
R"==(INIT_MAX_N_INPUTS(77); )==""\n"
R"==(INIT_MAX_N_INPUTS(78); )==""\n"
R"==(INIT_MAX_N_INPUTS(79); )==""\n"
R"==(INIT_MAX_N_INPUTS(80); )==""\n"
R"==(INIT_MAX_N_INPUTS(81); )==""\n"
R"==(INIT_MAX_N_INPUTS(82); )==""\n"
R"==(INIT_MAX_N_INPUTS(83); )==""\n"
R"==(INIT_MAX_N_INPUTS(84); )==""\n"
R"==(INIT_MAX_N_INPUTS(85); )==""\n"
R"==(INIT_MAX_N_INPUTS(86); )==""\n"
R"==(INIT_MAX_N_INPUTS(87); )==""\n"
R"==(INIT_MAX_N_INPUTS(88); )==""\n"
R"==(INIT_MAX_N_INPUTS(89); )==""\n"
R"==(INIT_MAX_N_INPUTS(90); )==""\n"
R"==(INIT_MAX_N_INPUTS(91); )==""\n"
R"==(INIT_MAX_N_INPUTS(92); )==""\n"
R"==(INIT_MAX_N_INPUTS(93); )==""\n"
R"==(many_inputs_sum_impl(inputs, output, scales, MAX_N_INPUTS, local_val); )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}