namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *metrics_discovery_api_header = R"==(/*****************************************************************************\ )==""\n"
R"==(Copyright © 2019, Intel Corporation )==""\n"
R"==(Permission is hereby granted, free of charge, to any person obtaining a )==""\n"
R"==(copy of this software and associated documentation files (the "Software"), )==""\n"
R"==(to deal in the Software without restriction, including without limitation )==""\n"
R"==(the rights to use, copy, modify, merge, publish, distribute, sublicense, )==""\n"
R"==(and/or sell copies of the Software, and to permit persons to whom the )==""\n"
R"==(Software is furnished to do so, subject to the following conditions: )==""\n"
R"==(The above copyright notice and this permission notice shall be included )==""\n"
R"==(in all copies or substantial portions of the Software. )==""\n"
R"==(THE SOFTWARE IS PROVIDED "AS IS", WITHOUT WARRANTY OF ANY KIND, EXPRESS OR )==""\n"
R"==(IMPLIED, INCLUDING BUT NOT LIMITED TO THE WARRANTIES OF MERCHANTABILITY, )==""\n"
R"==(FITNESS FOR A PARTICULAR PURPOSE AND NONINFRINGEMENT. IN NO EVENT SHALL )==""\n"
R"==(THE AUTHORS OR COPYRIGHT HOLDERS BE LIABLE FOR ANY CLAIM, DAMAGES OR OTHER )==""\n"
R"==(LIABILITY, WHETHER IN AN ACTION OF CONTRACT, TORT OR OTHERWISE, ARISING )==""\n"
R"==(FROM, OUT OF OR IN CONNECTION WITH THE SOFTWARE OR THE USE OR OTHER DEALINGS )==""\n"
R"==(IN THE SOFTWARE. )==""\n"
R"==(File Name: metrics_discovery_api.h )==""\n"
R"==(Abstract: Interface for metrics discovery DLL )==""\n"
R"==(Notes: )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(#include <stdint.h> )==""\n"
R"==(#ifndef __METRICS_DISCOVERY_H_ )==""\n"
R"==(#define __METRICS_DISCOVERY_H_ )==""\n"
R"==(#ifdef _MSC_VER )==""\n"
R"==(#define MD_STDCALL __stdcall )==""\n"
R"==(#else )==""\n"
R"==(#define MD_STDCALL )==""\n"
R"==(#endif  )==""\n"
R"==(namespace MetricsDiscovery { )==""\n"
R"==(typedef enum EMD_API_MAJOR_VERSION { )==""\n"
R"==(MD_API_MAJOR_NUMBER_1 = 1, )==""\n"
R"==(MD_API_MAJOR_NUMBER_CURRENT = MD_API_MAJOR_NUMBER_1, )==""\n"
R"==(MD_API_MAJOR_NUMBER_CEIL = 0xFFFFFFFF )==""\n"
R"==(} MD_API_MAJOR_VERSION; )==""\n"
R"==(typedef enum EMD_API_MINOR_VERSION { )==""\n"
R"==(MD_API_MINOR_NUMBER_0 = 0, )==""\n"
R"==(MD_API_MINOR_NUMBER_1 = 1,  )==""\n"
R"==(MD_API_MINOR_NUMBER_2 = 2,  )==""\n"
R"==(MD_API_MINOR_NUMBER_3 = 3,  )==""\n"
R"==(MD_API_MINOR_NUMBER_4 = 4,  )==""\n"
R"==(MD_API_MINOR_NUMBER_5 = 5,  )==""\n"
R"==(MD_API_MINOR_NUMBER_CURRENT = MD_API_MINOR_NUMBER_5, )==""\n"
R"==(MD_API_MINOR_NUMBER_CEIL = 0xFFFFFFFF )==""\n"
R"==(} MD_API_MINOR_VERSION; )==""\n"
R"==(#define MD_API_BUILD_NUMBER_CURRENT 115 )==""\n"
R"==(typedef enum ECompletionCode { )==""\n"
R"==(CC_OK = 0, )==""\n"
R"==(CC_READ_PENDING = 1, )==""\n"
R"==(CC_ALREADY_INITIALIZED = 2, )==""\n"
R"==(CC_STILL_INITIALIZED = 3, )==""\n"
R"==(CC_CONCURRENT_GROUP_LOCKED = 4, )==""\n"
R"==(CC_WAIT_TIMEOUT = 5, )==""\n"
R"==(CC_TRY_AGAIN = 6, )==""\n"
R"==(CC_INTERRUPTED = 7, )==""\n"
R"==(CC_ERROR_INVALID_PARAMETER = 40, )==""\n"
R"==(CC_ERROR_NO_MEMORY = 41, )==""\n"
R"==(CC_ERROR_GENERAL = 42, )==""\n"
R"==(CC_ERROR_FILE_NOT_FOUND = 43, )==""\n"
R"==(CC_ERROR_NOT_SUPPORTED = 44, )==""\n"
R"==(CC_LAST_1_0 = 45 )==""\n"
R"==(} TCompletionCode; )==""\n"
R"==(/* Forward declarations */ )==""\n"
R"==(class IMetricsDevice_1_0; )==""\n"
R"==(class IMetricsDevice_1_1; )==""\n"
R"==(class IMetricsDevice_1_2; )==""\n"
R"==(class IMetricsDevice_1_5; )==""\n"
R"==(class IOverride_1_2; )==""\n"
R"==(class IConcurrentGroup_1_0; )==""\n"
R"==(class IConcurrentGroup_1_1; )==""\n"
R"==(class IConcurrentGroup_1_5; )==""\n"
R"==(class IMetricSet_1_0; )==""\n"
R"==(class IMetricSet_1_1; )==""\n"
R"==(class IMetricSet_1_4; )==""\n"
R"==(class IMetricSet_1_5; )==""\n"
R"==(class IMetric_1_0; )==""\n"
R"==(class IInformation_1_0; )==""\n"
R"==(class IEquation_1_0; )==""\n"
R"==(typedef enum EValueType { )==""\n"
R"==(VALUE_TYPE_UINT32, )==""\n"
R"==(VALUE_TYPE_UINT64, )==""\n"
R"==(VALUE_TYPE_FLOAT, )==""\n"
R"==(VALUE_TYPE_BOOL, )==""\n"
R"==(VALUE_TYPE_CSTRING, )==""\n"
R"==(VALUE_TYPE_LAST, )==""\n"
R"==(} TValueType; )==""\n"
R"==(typedef struct STypedValue_1_0 { )==""\n"
R"==(TValueType ValueType; )==""\n"
R"==(union { )==""\n"
R"==(uint32_t ValueUInt32; )==""\n"
R"==(uint64_t ValueUInt64; )==""\n"
R"==(struct { )==""\n"
R"==(uint32_t Low; )==""\n"
R"==(uint32_t High; )==""\n"
R"==(} ValueUInt64Fields; )==""\n"
R"==(float ValueFloat; )==""\n"
R"==(bool ValueBool; )==""\n"
R"==(char *ValueCString; )==""\n"
R"==(}; )==""\n"
R"==(} TTypedValue_1_0; )==""\n"
R"==(typedef struct SGlobalSymbol_1_0 { )==""\n"
R"==(const char *SymbolName; )==""\n"
R"==(TTypedValue_1_0 SymbolTypedValue; )==""\n"
R"==(} TGlobalSymbol_1_0; )==""\n"
R"==(typedef struct SMetricsDeviceParams_1_0 { )==""\n"
R"==(struct SApiVersion { )==""\n"
R"==(uint32_t MajorNumber; )==""\n"
R"==(uint32_t MinorNumber; )==""\n"
R"==(uint32_t BuildNumber; )==""\n"
R"==(} Version; )==""\n"
R"==(uint32_t ConcurrentGroupsCount; )==""\n"
R"==(uint32_t GlobalSymbolsCount; )==""\n"
R"==(uint32_t DeltaFunctionsCount; )==""\n"
R"==(uint32_t EquationElementTypesCount; )==""\n"
R"==(uint32_t EquationOperationsCount; )==""\n"
R"==(const char *DeviceName; )==""\n"
R"==(} TMetricsDeviceParams_1_0; )==""\n"
R"==(typedef struct SMetricsDeviceParams_1_2 : public SMetricsDeviceParams_1_0 { )==""\n"
R"==(uint32_t OverrideCount; )==""\n"
R"==(} TMetricsDeviceParams_1_2; )==""\n"
R"==(typedef enum EMetricApiType { )==""\n"
R"==(API_TYPE_IOSTREAM = 0x00000001,  )==""\n"
R"==(API_TYPE_DX9 = 0x00000002, )==""\n"
R"==(API_TYPE_DX10 = 0x00000004, )==""\n"
R"==(API_TYPE_DX11 = 0x00000008, )==""\n"
R"==(API_TYPE_OGL = 0x00000010, )==""\n"
R"==(API_TYPE_OGL4_X = 0x00000020, )==""\n"
R"==(API_TYPE_OCL = 0x00000040, )==""\n"
R"==(API_TYPE_MEDIA )==""\n"
R"==(= 0x00000080,  )==""\n"
R"==(API_TYPE_DX12 = 0x00000100, )==""\n"
R"==(API_TYPE_BBSTREAM = 0x00000200, )==""\n"
R"==(API_TYPE_VULKAN = 0x00000400, )==""\n"
R"==(API_TYPE_RESERVED = 0x00000800, )==""\n"
R"==(API_TYPE_ALL = 0xffffffff )==""\n"
R"==(} TMetricApiType; )==""\n"
R"==(typedef enum EMeasurementType { )==""\n"
R"==(MEASUREMENT_TYPE_SNAPSHOT_IO = 0x00000001, )==""\n"
R"==(MEASUREMENT_TYPE_SNAPSHOT_QUERY = 0x00000002, )==""\n"
R"==(MEASUREMENT_TYPE_DELTA_QUERY = 0x00000004, )==""\n"
R"==(MEASUREMENT_TYPE_ALL = 0x0000ffff, )==""\n"
R"==(} TMeasurementType; )==""\n"
R"==(typedef enum EMetricUsageFlag { )==""\n"
R"==(USAGE_FLAG_OVERVIEW = 0x00000001,  )==""\n"
R"==(USAGE_FLAG_INDICATE = 0x00000002,  )==""\n"
R"==(USAGE_FLAG_CORRELATE )==""\n"
R"==(= 0x00000004,  )==""\n"
R"==(USAGE_FLAG_SYSTEM = 0x00000020,  )==""\n"
R"==(USAGE_FLAG_FRAME = 0x00000040,  )==""\n"
R"==(USAGE_FLAG_BATCH = 0x00000080,  )==""\n"
R"==(USAGE_FLAG_DRAW = 0x00000100,  )==""\n"
R"==(USAGE_FLAG_TIER_1 = 0x00000400, )==""\n"
R"==(USAGE_FLAG_TIER_2 = 0x00000800, )==""\n"
R"==(USAGE_FLAG_TIER_3 = 0x00001000, )==""\n"
R"==(USAGE_FLAG_TIER_4 = 0x00002000, )==""\n"
R"==(USAGE_FLAG_GLASS_JAW = 0x00004000, )==""\n"
R"==(USAGE_FLAG_ALL = 0x0000ffff, )==""\n"
R"==(} TMetricUsageFlag; )==""\n"
R"==(typedef enum ESamplingType { )==""\n"
R"==(SAMPLING_TYPE_OA_TIMER = 0x00000001, )==""\n"
R"==(SAMPLING_TYPE_OA_EVENT = 0x00000002, )==""\n"
R"==(SAMPLING_TYPE_GPU_QUERY = 0x00000004, )==""\n"
R"==(SAMPLING_TYPE_DMA_BUFFER )==""\n"
R"==(= 0x00000008,  )==""\n"
R"==(SAMPLING_TYPE_ALL = 0x0000ffff, )==""\n"
R"==(} TSamplingType; )==""\n"
R"==(typedef enum EMetricCategory { )==""\n"
R"==(GPU_RENDER = 0x0001, )==""\n"
R"==(GPU_COMPUTE = 0x0002, )==""\n"
R"==(GPU_MEDIA = 0x0004, )==""\n"
R"==(GPU_GENERIC )==""\n"
R"==(= 0x0008,  )==""\n"
R"==(} TMetricCategory; )==""\n"
R"==(typedef enum EIoReadFlag { )==""\n"
R"==(IO_READ_FLAG_DROP_OLD_REPORTS = 0x00000001, )==""\n"
R"==(IO_READ_FLAG_GET_CONTEXT_ID_TAGS = 0x00000002, )==""\n"
R"==(} TIoReadFlag; )==""\n"
R"==(typedef enum EOverrideMode { )==""\n"
R"==(OVERRIDE_MODE_GLOBAL = 0x0001, )==""\n"
R"==(OVERRIDE_MODE_LOCAL = 0x0002, )==""\n"
R"==(} TOverrideMode; )==""\n"
R"==(typedef struct SConcurrentGroupParams_1_0 { )==""\n"
R"==(const char *SymbolName;  )==""\n"
R"==(const char * )==""\n"
R"==(Description;  )==""\n"
R"==(uint32_t MeasurementTypeMask; )==""\n"
R"==(uint32_t MetricSetsCount; )==""\n"
R"==(uint32_t IoMeasurementInformationCount; )==""\n"
R"==(uint32_t IoGpuContextInformationCount; )==""\n"
R"==(} TConcurrentGroupParams_1_0; )==""\n"
R"==(typedef struct SOverrideParams_1_2 { )==""\n"
R"==(const char *SymbolName;  )==""\n"
R"==(const char * )==""\n"
R"==(Description;  )==""\n"
R"==(uint32_t ApiMask; )==""\n"
R"==(uint32_t PlatformMask; )==""\n"
R"==(uint32_t OverrideModeMask; )==""\n"
R"==(} TOverrideParams_1_2; )==""\n"
R"==(typedef struct SSetOverrideParams_1_2 { )==""\n"
R"==(bool Enable; )==""\n"
R"==(} TSetOverrideParams_1_2; )==""\n"
R"==(typedef struct SSetFrequencyOverrideParams_1_2 : SSetOverrideParams_1_2 { )==""\n"
R"==(uint32_t FrequencyMhz; )==""\n"
R"==(uint32_t Pid; )==""\n"
R"==(} TSetFrequencyOverrideParams_1_2; )==""\n"
R"==(typedef struct SSetQueryOverrideParams_1_2 : SSetOverrideParams_1_2 { )==""\n"
R"==(uint32_t Period;  )==""\n"
R"==(} TSetQueryOverrideParams_1_2; )==""\n"
R"==(typedef struct SSetDriverOverrideParams_1_2 : SSetOverrideParams_1_2 { )==""\n"
R"==(uint32_t Value; )==""\n"
R"==(} SSetDriverOverrideParams_1_2; )==""\n"
R"==(typedef struct SApiSpecificId_1_0 { )==""\n"
R"==(uint32_t D3D9QueryId;  )==""\n"
R"==(uint32_t D3D9Fourcc;  )==""\n"
R"==(uint32_t D3D1XQueryId;  )==""\n"
R"==(uint32_t D3D1XDevDependentId;  )==""\n"
R"==(const char *D3D1XDevDependentName;  )==""\n"
R"==(uint32_t OGLQueryIntelId;  )==""\n"
R"==(const char *OGLQueryIntelName;  )==""\n"
R"==(uint32_t OGLQueryARBTargetId;  )==""\n"
R"==(uint32_t OCL;  )==""\n"
R"==(uint32_t HwConfigId;  )==""\n"
R"==(uint32_t placeholder[1]; )==""\n"
R"==(} TApiSpecificId_1_0; )==""\n"
R"==(typedef struct SMetricSetParams_1_0 { )==""\n"
R"==(const char *SymbolName;  )==""\n"
R"==(const char *ShortName;  )==""\n"
R"==(uint32_t ApiMask; )==""\n"
R"==(uint32_t CategoryMask; )==""\n"
R"==(uint32_t RawReportSize;  )==""\n"
R"==(uint32_t QueryReportSize;  )==""\n"
R"==(uint32_t MetricsCount; )==""\n"
R"==(uint32_t InformationCount; )==""\n"
R"==(uint32_t ComplementarySetsCount; )==""\n"
R"==(TApiSpecificId_1_0 ApiSpecificId; )==""\n"
R"==(uint32_t PlatformMask; )==""\n"
R"==(} TMetricSetParams_1_0; )==""\n"
R"==(typedef struct SMetricSetParams_1_4 : SMetricSetParams_1_0 { )==""\n"
R"==(uint32_t GtMask; )==""\n"
R"==(} TMetricSetParams_1_4; )==""\n"
R"==(typedef enum EMetricResultType { )==""\n"
R"==(RESULT_UINT32, )==""\n"
R"==(RESULT_UINT64, )==""\n"
R"==(RESULT_BOOL, )==""\n"
R"==(RESULT_FLOAT, )==""\n"
R"==(RESULT_LAST )==""\n"
R"==(} TMetricResultType; )==""\n"
R"==(typedef enum EMetricType { )==""\n"
R"==(METRIC_TYPE_DURATION, )==""\n"
R"==(METRIC_TYPE_EVENT, )==""\n"
R"==(METRIC_TYPE_EVENT_WITH_RANGE, )==""\n"
R"==(METRIC_TYPE_THROUGHPUT, )==""\n"
R"==(METRIC_TYPE_TIMESTAMP, )==""\n"
R"==(METRIC_TYPE_FLAG, )==""\n"
R"==(METRIC_TYPE_RATIO, )==""\n"
R"==(METRIC_TYPE_RAW, )==""\n"
R"==(METRIC_TYPE_LAST )==""\n"
R"==(} TMetricType; )==""\n"
R"==(typedef enum EInformationType { )==""\n"
R"==(INFORMATION_TYPE_REPORT_REASON, )==""\n"
R"==(INFORMATION_TYPE_VALUE, )==""\n"
R"==(INFORMATION_TYPE_FLAG, )==""\n"
R"==(INFORMATION_TYPE_TIMESTAMP, )==""\n"
R"==(INFORMATION_TYPE_CONTEXT_ID_TAG, )==""\n"
R"==(INFORMATION_TYPE_SAMPLE_PHASE, )==""\n"
R"==(INFORMATION_TYPE_GPU_NODE, )==""\n"
R"==(INFORMATION_TYPE_LAST )==""\n"
R"==(} TInformationType; )==""\n"
R"==(typedef enum EReportReason { )==""\n"
R"==(REPORT_REASON_UNDEFINED = 0x0000, )==""\n"
R"==(REPORT_REASON_INTERNAL_TIMER = 0x0001, )==""\n"
R"==(REPORT_REASON_INTERNAL_TRIGGER1 = 0x0002, )==""\n"
R"==(REPORT_REASON_INTERNAL_TRIGGER2 = 0x0004, )==""\n"
R"==(REPORT_REASON_INTERNAL_CONTEXT_SWITCH = 0x0008, )==""\n"
R"==(REPORT_REASON_INTERNAL_GO = 0x0010, )==""\n"
R"==(REPORT_REASON_INTERNAL_FREQUENCY_CHANGE = 0x0020, )==""\n"
R"==(REPORT_REASON_QUERY_DEFAULT = 0x0100, )==""\n"
R"==(REPORT_REASON_QUERY_INTERNAL_RESOLVE = 0x0200, )==""\n"
R"==(REPORT_REASON_QUERY_INTERNAL_CLEAR = 0x0400, )==""\n"
R"==(} TReportReason; )==""\n"
R"==(typedef enum ESamplePhase { )==""\n"
R"==(SAMPLE_PHASE_END, )==""\n"
R"==(SAMPLE_PHASE_BEGIN, )==""\n"
R"==(SAMPLE_PHASE_LAST )==""\n"
R"==(} TSamplePhase; )==""\n"
R"==(typedef enum EInformationGpuNode { )==""\n"
R"==(INFORMATION_GPUNODE_3D = 0,  )==""\n"
R"==(INFORMATION_GPUNODE_VIDEO = 1,  )==""\n"
R"==(INFORMATION_GPUNODE_BLT = 2,  )==""\n"
R"==(INFORMATION_GPUNODE_VE = 3,  )==""\n"
R"==(INFORMATION_GPUNODE_VCS2 = 4,  )==""\n"
R"==(INFORMATION_GPUNODE_REAL_MAX )==""\n"
R"==(= 5,  )==""\n"
R"==(INFORMATION_GPUNODE_LAST )==""\n"
R"==(} TInformationGpuNode; )==""\n"
R"==(typedef enum EHwUnitType { )==""\n"
R"==(HW_UNIT_GPU, )==""\n"
R"==(HW_UNIT_SLICE, )==""\n"
R"==(HW_UNIT_SUBSLICE, )==""\n"
R"==(HW_UNIT_SUBSLICE_BANK, )==""\n"
R"==(HW_UNIT_EU_UNIT, )==""\n"
R"==(HW_UNIT_UNCORE, )==""\n"
R"==(HW_UNIT_LAST )==""\n"
R"==(} THwUnitType; )==""\n"
R"==(typedef enum EDeltaFunctionType { )==""\n"
R"==(DELTA_FUNCTION_NULL = 0, )==""\n"
R"==(DELTA_N_BITS, )==""\n"
R"==(DELTA_BOOL_OR,  )==""\n"
R"==(DELTA_BOOL_XOR,  )==""\n"
R"==(DELTA_GET_PREVIOUS,  )==""\n"
R"==(DELTA_GET_LAST,  )==""\n"
R"==(DELTA_NS_TIME,  )==""\n"
R"==(DELTA_FUNCTION_LAST_1_0 )==""\n"
R"==(} TDeltaFunctionType; )==""\n"
R"==(typedef struct SDeltaFunction_1_0 { )==""\n"
R"==(TDeltaFunctionType FunctionType; )==""\n"
R"==(union { )==""\n"
R"==(uint32_t BitsCount;  )==""\n"
R"==(}; )==""\n"
R"==(} TDeltaFunction_1_0; )==""\n"
R"==(typedef enum EEquationElementType { )==""\n"
R"==(EQUATION_ELEM_OPERATION,  )==""\n"
R"==(EQUATION_ELEM_RD_BITFIELD, )==""\n"
R"==(EQUATION_ELEM_RD_UINT8, )==""\n"
R"==(EQUATION_ELEM_RD_UINT16, )==""\n"
R"==(EQUATION_ELEM_RD_UINT32, )==""\n"
R"==(EQUATION_ELEM_RD_UINT64, )==""\n"
R"==(EQUATION_ELEM_RD_FLOAT, )==""\n"
R"==(EQUATION_ELEM_RD_40BIT_CNTR,  )==""\n"
R"==(EQUATION_ELEM_IMM_UINT64, )==""\n"
R"==(EQUATION_ELEM_IMM_FLOAT, )==""\n"
R"==(EQUATION_ELEM_SELF_COUNTER_VALUE,  )==""\n"
R"==(EQUATION_ELEM_GLOBAL_SYMBOL,  )==""\n"
R"==(EQUATION_ELEM_LOCAL_COUNTER_SYMBOL,  )==""\n"
R"==(EQUATION_ELEM_OTHER_SET_COUNTER_SYMBOL,  )==""\n"
R"==(EQUATION_ELEM_LOCAL_METRIC_SYMBOL,  )==""\n"
R"==(EQUATION_ELEM_OTHER_SET_METRIC_SYMBOL,  )==""\n"
R"==(EQUATION_ELEM_INFORMATION_SYMBOL,  )==""\n"
R"==(EQUATION_ELEM_STD_NORM_GPU_DURATION,  )==""\n"
R"==(EQUATION_ELEM_STD_NORM_EU_AGGR_DURATION,  )==""\n"
R"==(EQUATION_ELEM_LAST_1_0 )==""\n"
R"==(} TEquationElementType; )==""\n"
R"==(typedef enum EEquationOperation { )==""\n"
R"==(EQUATION_OPER_RSHIFT,  )==""\n"
R"==(EQUATION_OPER_LSHIFT,  )==""\n"
R"==(EQUATION_OPER_AND,  )==""\n"
R"==(EQUATION_OPER_OR,  )==""\n"
R"==(EQUATION_OPER_XOR,  )==""\n"
R"==(EQUATION_OPER_XNOR,  )==""\n"
R"==(EQUATION_OPER_AND_L,  )==""\n"
R"==(EQUATION_OPER_EQUALS,  )==""\n"
R"==(EQUATION_OPER_UADD,  )==""\n"
R"==(EQUATION_OPER_USUB,  )==""\n"
R"==(EQUATION_OPER_UMUL,  )==""\n"
R"==(EQUATION_OPER_UDIV,  )==""\n"
R"==(EQUATION_OPER_FADD,  )==""\n"
R"==(EQUATION_OPER_FSUB,  )==""\n"
R"==(EQUATION_OPER_FMUL,  )==""\n"
R"==(EQUATION_OPER_FDIV,  )==""\n"
R"==(EQUATION_OPER_UGT,  )==""\n"
R"==(EQUATION_OPER_ULT,  )==""\n"
R"==(EQUATION_OPER_UGTE,  )==""\n"
R"==(EQUATION_OPER_ULTE,  )==""\n"
R"==(EQUATION_OPER_FGT,  )==""\n"
R"==(EQUATION_OPER_FLT,  )==""\n"
R"==(EQUATION_OPER_FGTE,  )==""\n"
R"==(EQUATION_OPER_FLTE,  )==""\n"
R"==(EQUATION_OPER_UMIN,  )==""\n"
R"==(EQUATION_OPER_UMAX,  )==""\n"
R"==(EQUATION_OPER_FMIN,  )==""\n"
R"==(EQUATION_OPER_FMAX,  )==""\n"
R"==(EQUATION_OPER_LAST_1_0 )==""\n"
R"==(} TEquationOperation; )==""\n"
R"==(typedef struct SReadParams_1_0 { )==""\n"
R"==(uint32_t ByteOffset; )==""\n"
R"==(uint32_t BitOffset; )==""\n"
R"==(uint32_t BitsCount; )==""\n"
R"==(uint32_t ByteOffsetExt; )==""\n"
R"==(} TReadParams_1_0; )==""\n"
R"==(typedef struct SEquationElement_1_0 { )==""\n"
R"==(TEquationElementType Type; )==""\n"
R"==(union { )==""\n"
R"==(uint64_t ImmediateUInt64; )==""\n"
R"==(float ImmediateFloat; )==""\n"
R"==(TEquationOperation Operation; )==""\n"
R"==(TReadParams_1_0 ReadParams; )==""\n"
R"==(}; )==""\n"
R"==(char *SymbolName; )==""\n"
R"==(} TEquationElement_1_0; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IEquation_1_0 )==""\n"
R"==(Description: )==""\n"
R"==(Abstract interface for the equation object. )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IEquation_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IEquation_1_0(); )==""\n"
R"==(virtual uint32_t GetEquationElementsCount(void); )==""\n"
R"==(virtual TEquationElement_1_0 *GetEquationElement(uint32_t index); )==""\n"
R"==(}; )==""\n"
R"==(typedef struct SMetricParams_1_0 { )==""\n"
R"==(uint32_t IdInSet;  )==""\n"
R"==(uint32_t GroupId;  )==""\n"
R"==(const char *SymbolName;  )==""\n"
R"==(const char * )==""\n"
R"==(ShortName;  )==""\n"
R"==(const char *GroupName;  )==""\n"
R"==(const char *LongName;  )==""\n"
R"==(const char *DxToOglAlias;  )==""\n"
R"==(uint32_t UsageFlagsMask; )==""\n"
R"==(uint32_t ApiMask; )==""\n"
R"==(TMetricResultType ResultType; )==""\n"
R"==(const char *MetricResultUnits; )==""\n"
R"==(TMetricType MetricType; )==""\n"
R"==(uint64_t )==""\n"
R"==(LowWatermark;  )==""\n"
R"==(uint64_t )==""\n"
R"==(HighWatermark;  )==""\n"
R"==(THwUnitType HwUnitType; )==""\n"
R"==(IEquation_1_0 *IoReadEquation; )==""\n"
R"==(IEquation_1_0 *QueryReadEquation; )==""\n"
R"==(TDeltaFunction_1_0 DeltaFunction; )==""\n"
R"==(IEquation_1_0 *NormEquation; )==""\n"
R"==(IEquation_1_0 *MaxValueEquation; )==""\n"
R"==(} TMetricParams_1_0; )==""\n"
R"==(typedef struct SInformationParams_1_0 { )==""\n"
R"==(uint32_t IdInSet;  )==""\n"
R"==(const char *SymbolName;  )==""\n"
R"==(const char *ShortName;  )==""\n"
R"==(const char *GroupName;  )==""\n"
R"==(const char *LongName;  )==""\n"
R"==(uint32_t ApiMask; )==""\n"
R"==(TInformationType InfoType; )==""\n"
R"==(const char *InfoUnits; )==""\n"
R"==(IEquation_1_0 *IoReadEquation; )==""\n"
R"==(IEquation_1_0 *QueryReadEquation; )==""\n"
R"==(TDeltaFunction_1_0 OverflowFunction; )==""\n"
R"==(} TInformationParams_1_0; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IInformation_1_0 )==""\n"
R"==(Description: )==""\n"
R"==(Abstract interface for the measurement information parameter. )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IInformation_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IInformation_1_0(); )==""\n"
R"==(virtual TInformationParams_1_0 *GetParams(); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetric_1_0 )==""\n"
R"==(Description: )==""\n"
R"==(Abstract interface for the metric that is sampled. )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetric_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IMetric_1_0(); )==""\n"
R"==(virtual TMetricParams_1_0 *GetParams(); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetricSet_1_0 )==""\n"
R"==(Description: )==""\n"
R"==(Abstract interface for the metric sets mapping to different HW configuration that should be used )==""\n"
R"==(exclusively to each other metric set in the concurrent group. )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetricSet_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IMetricSet_1_0(); )==""\n"
R"==(virtual TMetricSetParams_1_0 *GetParams(void); )==""\n"
R"==(virtual IMetric_1_0 *GetMetric(uint32_t index); )==""\n"
R"==(virtual IInformation_1_0 *GetInformation(uint32_t index); )==""\n"
R"==(virtual IMetricSet_1_0 *GetComplementaryMetricSet(uint32_t index); )==""\n"
R"==(virtual TCompletionCode Activate(void); )==""\n"
R"==(virtual TCompletionCode Deactivate(void); )==""\n"
R"==(virtual IMetric_1_0 *AddCustomMetric(const char *symbolName, )==""\n"
R"==(const char *shortName, const char *groupName, const char *longName, )==""\n"
R"==(const char *dxToOglAlias, uint32_t usageFlagsMask, uint32_t apiMask, )==""\n"
R"==(TMetricResultType resultType, const char *resultUnits, )==""\n"
R"==(TMetricType metricType, int64_t loWatermark, int64_t hiWatermark, )==""\n"
R"==(THwUnitType hwType, const char *ioReadEquation, )==""\n"
R"==(const char *deltaFunction, const char *queryReadEquation, )==""\n"
R"==(const char *normalizationEquation, const char *maxValueEquation, )==""\n"
R"==(const char *signalName); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetricSet_1_1 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.0 version to use with 1.1 interface version. )==""\n"
R"==(Introduces an ability to calculate metrics from raw data. )==""\n"
R"==(New: )==""\n"
R"==(- SetApiFiltering )==""\n"
R"==(- CalculateMetrics )==""\n"
R"==(- CalculateIoMeasurementInformation )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetricSet_1_1 : public IMetricSet_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IMetricSet_1_1(); )==""\n"
R"==(virtual TCompletionCode SetApiFiltering(uint32_t apiMask); )==""\n"
R"==(virtual TCompletionCode CalculateMetrics(const unsigned char *rawData, )==""\n"
R"==(uint32_t rawDataSize, TTypedValue_1_0 *out, uint32_t outSize, )==""\n"
R"==(uint32_t *outReportCount, bool enableContextFiltering); )==""\n"
R"==(virtual TCompletionCode CalculateIoMeasurementInformation( )==""\n"
R"==(TTypedValue_1_0 *out, uint32_t outSize); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetricSet_1_4 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.1 version to use with 1.4 interface version. )==""\n"
R"==(Extends set params with gtType information. )==""\n"
R"==(Updates: )==""\n"
R"==(- GetParams )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetricSet_1_4 : public IMetricSet_1_1 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IMetricSet_1_4(); )==""\n"
R"==(virtual TMetricSetParams_1_4 *GetParams(void); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetricSet_1_5 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.4 version to use with 1.5 interface version. )==""\n"
R"==(Adds an ability to calculate MaxValueEquations (maximal value) for each metric. )==""\n"
R"==(Param 'enableContextFiltering' becomes deprecated. )==""\n"
R"==(Updates: )==""\n"
R"==(- GetComplementaryMetricSet )==""\n"
R"==(- CalculateMetrics )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetricSet_1_5 : public IMetricSet_1_4 { )==""\n"
R"==(public: )==""\n"
R"==(using IMetricSet_1_1::CalculateMetrics; )==""\n"
R"==(virtual IMetricSet_1_5 *GetComplementaryMetricSet(uint32_t index); )==""\n"
R"==(virtual TCompletionCode CalculateMetrics(const unsigned char *rawData, )==""\n"
R"==(uint32_t rawDataSize, TTypedValue_1_0 *out, uint32_t outSize, )==""\n"
R"==(uint32_t *outReportCount, TTypedValue_1_0 *outMaxValues, )==""\n"
R"==(uint32_t outMaxValuesSize); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IConcurrentGroup_1_0 )==""\n"
R"==(Description: )==""\n"
R"==(Abstract interface for the metrics groups that can be collected concurrently to another group. )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IConcurrentGroup_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IConcurrentGroup_1_0(); )==""\n"
R"==(virtual TConcurrentGroupParams_1_0 *GetParams(void); )==""\n"
R"==(virtual IMetricSet_1_0 *GetMetricSet(uint32_t index); )==""\n"
R"==(virtual TCompletionCode OpenIoStream(IMetricSet_1_0 *metricSet, )==""\n"
R"==(uint32_t processId, uint32_t *nsTimerPeriod, )==""\n"
R"==(uint32_t *oaBufferSize); )==""\n"
R"==(virtual TCompletionCode ReadIoStream( )==""\n"
R"==(uint32_t *reportsCount, char *reportData, uint32_t readFlags); )==""\n"
R"==(virtual TCompletionCode CloseIoStream(void); )==""\n"
R"==(virtual TCompletionCode WaitForReports(uint32_t milliseconds); )==""\n"
R"==(virtual IInformation_1_0 *GetIoMeasurementInformation(uint32_t index); )==""\n"
R"==(virtual IInformation_1_0 *GetIoGpuContextInformation(uint32_t index); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IConcurrentGroup_1_1 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.0 version to use with 1.1 interface version. )==""\n"
R"==(Updates: )==""\n"
R"==(- GetMetricSet )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IConcurrentGroup_1_1 : public IConcurrentGroup_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual IMetricSet_1_1 *GetMetricSet(uint32_t index); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IConcurrentGroup_1_3 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.1 version to use with 1.3 interface version. )==""\n"
R"==(Introduces setting Stream Sampling Type. )==""\n"
R"==(New: )==""\n"
R"==(- SetIoStreamSamplingType )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IConcurrentGroup_1_3 : public IConcurrentGroup_1_1 { )==""\n"
R"==(public: )==""\n"
R"==(virtual TCompletionCode SetIoStreamSamplingType(TSamplingType type); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IConcurrentGroup_1_5 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.3 version to use with 1.5 interface version. )==""\n"
R"==(Updates: )==""\n"
R"==(- GetMetricSet )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IConcurrentGroup_1_5 : public IConcurrentGroup_1_3 { )==""\n"
R"==(public: )==""\n"
R"==(virtual IMetricSet_1_5 *GetMetricSet(uint32_t index); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IOverride_1_2 )==""\n"
R"==(Description: )==""\n"
R"==(Abstract interface for Metrics Device overrides. )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IOverride_1_2 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IOverride_1_2(); )==""\n"
R"==(virtual TOverrideParams_1_2 *GetParams(void); )==""\n"
R"==(virtual TCompletionCode SetOverride( )==""\n"
R"==(TSetOverrideParams_1_2 *params, uint32_t paramsSize); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetricsDevice_1_0 )==""\n"
R"==(Description: )==""\n"
R"==(Abstract interface for the GPU metrics root object. )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetricsDevice_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual ~IMetricsDevice_1_0(); )==""\n"
R"==(virtual TMetricsDeviceParams_1_0 *GetParams(void); )==""\n"
R"==(virtual IConcurrentGroup_1_0 *GetConcurrentGroup(uint32_t index); )==""\n"
R"==(virtual TGlobalSymbol_1_0 *GetGlobalSymbol(uint32_t index); )==""\n"
R"==(virtual TTypedValue_1_0 *GetGlobalSymbolValueByName(const char *name); )==""\n"
R"==(virtual TCompletionCode GetLastError(void); )==""\n"
R"==(virtual TCompletionCode GetGpuCpuTimestamps(uint64_t *gpuTimestampNs, )==""\n"
R"==(uint64_t *cpuTimestampNs, uint32_t *cpuId); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetricsDevice_1_1 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.0 version to use with 1.1 interface version. )==""\n"
R"==(Updates: )==""\n"
R"==(- GetConcurrentGroup )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetricsDevice_1_1 : public IMetricsDevice_1_0 { )==""\n"
R"==(public: )==""\n"
R"==(virtual IConcurrentGroup_1_1 *GetConcurrentGroup(uint32_t index); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetricsDevice_1_2 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.1 version to use with 1.2 interface version. )==""\n"
R"==(Introduces an interface for getting overrides. )==""\n"
R"==(Updates: )==""\n"
R"==(- GetParams )==""\n"
R"==(New: )==""\n"
R"==(- GetOverride )==""\n"
R"==(- GetOverrideByName )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetricsDevice_1_2 : public IMetricsDevice_1_1 { )==""\n"
R"==(public: )==""\n"
R"==(virtual TMetricsDeviceParams_1_2 *GetParams(void); )==""\n"
R"==(virtual IOverride_1_2 *GetOverride(uint32_t index); )==""\n"
R"==(virtual IOverride_1_2 *GetOverrideByName(const char *symbolName); )==""\n"
R"==(}; )==""\n"
R"==(/*****************************************************************************\ )==""\n"
R"==(Class: )==""\n"
R"==(IMetricsDevice_1_5 )==""\n"
R"==(Description: )==""\n"
R"==(Updated 1.2 version to use with 1.5 interface version. )==""\n"
R"==(Updates: )==""\n"
R"==(- GetConcurrentGroup )==""\n"
R"==(\*****************************************************************************/ )==""\n"
R"==(class IMetricsDevice_1_5 : public IMetricsDevice_1_2 { )==""\n"
R"==(public: )==""\n"
R"==(virtual IConcurrentGroup_1_5 *GetConcurrentGroup(uint32_t index); )==""\n"
R"==(}; )==""\n"
R"==(#ifdef __cplusplus )==""\n"
R"==(extern "C" { )==""\n"
R"==(#endif )==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *OpenMetricsDevice_fn)( )==""\n"
R"==(IMetricsDevice_1_5 **device); )==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *OpenMetricsDeviceFromFile_fn)( )==""\n"
R"==(const char *fileName, void *openParams, IMetricsDevice_1_5 **device); )==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *CloseMetricsDevice_fn)( )==""\n"
R"==(IMetricsDevice_1_5 *device); )==""\n"
R"==(typedef TCompletionCode(MD_STDCALL *SaveMetricsDeviceToFile_fn)( )==""\n"
R"==(const char *fileName, void *saveParams, IMetricsDevice_1_5 *device); )==""\n"
R"==(#ifdef __cplusplus )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(};  )==""\n"
R"==(#endif  )==""\n"
R"==()==";
}
}
}
}