namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ocl_eltwise_header = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#ifndef GPU_OCL_OCL_ELTWISE_H )==""\n"
R"==(#define GPU_OCL_OCL_ELTWISE_H )==""\n"
R"==(#if WITH_ELTWISE )==""\n"
R"==(#if DT_F16 == 1 )==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable )==""\n"
R"==(#endif )==""\n"
R"==(#ifndef DATA_MAX )==""\n"
R"==(#if DT_F16 == 1 )==""\n"
R"==(#define DATA_MAX HALF_MAX )==""\n"
R"==(#elif DT_S8 == 1 )==""\n"
R"==(#define DATA_MAX CHAR_MAX )==""\n"
R"==(#elif DT_U8 == 1 )==""\n"
R"==(#define DATA_MAX UCHAR_MAX )==""\n"
R"==(#else )==""\n"
R"==(#define DATA_MAX FLT_MAX )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(float relu_fwd(float s, float alpha) { )==""\n"
R"==(return s > 0 ? s : ((alpha == 0) ? 0 : s * alpha); )==""\n"
R"==(} )==""\n"
R"==(float relu_bwd(float dd, float s, float alpha) { )==""\n"
R"==(return s > 0 ? dd : dd * alpha; )==""\n"
R"==(} )==""\n"
R"==(float relu_bwd_use_dst(float dd, float d, float alpha) { )==""\n"
R"==(return d > 0 ? dd : dd * alpha; )==""\n"
R"==(} )==""\n"
R"==(float linear_fwd(float s, float alpha, float beta) { )==""\n"
R"==(return alpha * s + beta; )==""\n"
R"==(} )==""\n"
R"==(float linear_bwd(float dd, float alpha) { )==""\n"
R"==(return dd * alpha; )==""\n"
R"==(} )==""\n"
R"==(float soft_relu_fwd(float s, float alpha) { )==""\n"
R"==(s = alpha * s; )==""\n"
R"==(float v = (s < log((float)DATA_MAX) ? log1p(exp(s)) : s); )==""\n"
R"==(return v / alpha; )==""\n"
R"==(} )==""\n"
R"==(float soft_relu_bwd(float dd, float s, float alpha) { )==""\n"
R"==(s = alpha * s; )==""\n"
R"==(return dd / (1 + exp(-s)); )==""\n"
R"==(} )==""\n"
R"==(float logistic_fwd(float s) { )==""\n"
R"==(return 1.0f / (1.0f + exp(-s)); )==""\n"
R"==(} )==""\n"
R"==(float logistic_bwd(float dd, float s) { )==""\n"
R"==(float v = logistic_fwd(s); )==""\n"
R"==(return dd * v * (1 - v); )==""\n"
R"==(} )==""\n"
R"==(float logistic_bwd_use_dst(float dd, float d) { )==""\n"
R"==(return dd * d * (1 - d); )==""\n"
R"==(} )==""\n"
R"==(float square_fwd(float s) { )==""\n"
R"==(return s * s; )==""\n"
R"==(} )==""\n"
R"==(float square_bwd(float dd, float s) { )==""\n"
R"==(return dd * 2 * s; )==""\n"
R"==(} )==""\n"
R"==(float sqrt_fwd(float s) { )==""\n"
R"==(return sqrt(s); )==""\n"
R"==(} )==""\n"
R"==(float sqrt_bwd(float dd, float s) { )==""\n"
R"==(return dd / (2 * sqrt(s)); )==""\n"
R"==(} )==""\n"
R"==(float sqrt_bwd_use_dst(float dd, float d) { )==""\n"
R"==(return dd / (2 * d); )==""\n"
R"==(} )==""\n"
R"==(float abs_fwd(float s) { )==""\n"
R"==(return s > 0 ? s : -s; )==""\n"
R"==(} )==""\n"
R"==(float abs_bwd(float dd, float s) { )==""\n"
R"==(return s > 0 ? dd : s < 0 ? -dd : 0; )==""\n"
R"==(} )==""\n"
R"==(float tanh_fwd(float s) { )==""\n"
R"==(return tanh(s); )==""\n"
R"==(} )==""\n"
R"==(float tanh_bwd(float dd, float s) { )==""\n"
R"==(float e = tanh_fwd(s); )==""\n"
R"==(return dd * (1 - e) * (1 + e); )==""\n"
R"==(} )==""\n"
R"==(float tanh_bwd_use_dst(float dd, float d) { )==""\n"
R"==(return dd * (1 - d) * (1 + d); )==""\n"
R"==(} )==""\n"
R"==(float mish_fwd(float s) { )==""\n"
R"==(return s * tanh_fwd(soft_relu_fwd(s, 1.f)); )==""\n"
R"==(} )==""\n"
R"==(float mish_bwd(float dd, float s) { )==""\n"
R"==(const float tanh = tanh_fwd(soft_relu_fwd(s, 1.f)); )==""\n"
R"==(const float srelu_bwd = soft_relu_bwd(1.f, s, 1.f); )==""\n"
R"==(const float derivative = tanh + s * srelu_bwd * (1 - pow(tanh, 2.0f)); )==""\n"
R"==(return dd * derivative; )==""\n"
R"==(} )==""\n"
R"==(float elu_fwd(float s, float alpha) { )==""\n"
R"==(return s > 0 ? s : alpha * expm1(s); )==""\n"
R"==(} )==""\n"
R"==(float elu_bwd(float dd, float s, float alpha) { )==""\n"
R"==(return dd * (s > 0 ? 1 : alpha * exp(s)); )==""\n"
R"==(} )==""\n"
R"==(float elu_bwd_use_dst(float dd, float d, float alpha) { )==""\n"
R"==(return dd * (d > 0 ? 1 : d + alpha); )==""\n"
R"==(} )==""\n"
R"==(float exp_fwd(float s) { )==""\n"
R"==(return exp(s); )==""\n"
R"==(} )==""\n"
R"==(float exp_bwd(float dd, float s) { )==""\n"
R"==(return dd * exp_fwd(s); )==""\n"
R"==(} )==""\n"
R"==(float exp_bwd_use_dst(float dd, float d) { )==""\n"
R"==(return dd * d; )==""\n"
R"==(} )==""\n"
R"==(float gelu_tanh_fwd(float s) { )==""\n"
R"==(const float sqrt_2_over_pi = 0.79788458347320556640625f; )==""\n"
R"==(const float fitting_const = 0.044715f; )==""\n"
R"==(const float g = sqrt_2_over_pi * s * (1.f + fitting_const * s * s); )==""\n"
R"==(return (0.5f * s * (1.f + tanh_fwd(g))); )==""\n"
R"==(} )==""\n"
R"==(float gelu_tanh_bwd(float dd, float s) { )==""\n"
R"==(const float sqrt_2_over_pi = 0.79788458347320556640625f; )==""\n"
R"==(const float fitting_const = 0.044715f; )==""\n"
R"==(const float g = sqrt_2_over_pi * s * (1.f + fitting_const * s * s); )==""\n"
R"==(const float dg = sqrt_2_over_pi * (1.f + 3.f * fitting_const * s * s); )==""\n"
R"==(const float v = tanh_fwd(g); )==""\n"
R"==(return dd * 0.5f * (1.f + v) * (1.f + s * (1.f - v) * dg); )==""\n"
R"==(} )==""\n"
R"==(float swish_fwd(float s, float alpha) { )==""\n"
R"==(float w = -alpha * s; )==""\n"
R"==(return s / (1.0f + exp(w)); )==""\n"
R"==(} )==""\n"
R"==(float swish_bwd(float dd, float s, float alpha) { )==""\n"
R"==(float v = logistic_fwd(alpha * s); )==""\n"
R"==(return dd * (v + s * alpha * v * (1.0f - v)); )==""\n"
R"==(} )==""\n"
R"==(float log_fwd(float s) { )==""\n"
R"==(return log(s); )==""\n"
R"==(} )==""\n"
R"==(float log_bwd(float dd, float s) { )==""\n"
R"==(return dd / s; )==""\n"
R"==(} )==""\n"
R"==(float clip_fwd(float s, float alpha, float beta) { )==""\n"
R"==(s = s > alpha ? s : alpha; )==""\n"
R"==(return s > beta ? beta : s; )==""\n"
R"==(} )==""\n"
R"==(float clip_bwd(float dd, float s, float alpha, float beta) { )==""\n"
R"==(return dd * (alpha < s && s <= beta ? 1 : 0); )==""\n"
R"==(} )==""\n"
R"==(float clip_v2_fwd(float s, float alpha, float beta) { )==""\n"
R"==(s = s > alpha ? s : alpha; )==""\n"
R"==(return s < beta ? s : beta; )==""\n"
R"==(} )==""\n"
R"==(float clip_v2_bwd(float dd, float s, float alpha, float beta) { )==""\n"
R"==(return dd * (alpha < s && s < beta ? 1 : 0); )==""\n"
R"==(} )==""\n"
R"==(float clip_v2_bwd_use_dst(float dd, float d, float alpha, float beta) { )==""\n"
R"==(return dd * (alpha < d && d < beta ? 1 : 0); )==""\n"
R"==(} )==""\n"
R"==(float pow_fwd(float s, float alpha, float beta) { )==""\n"
R"==(return alpha * pow(s, beta); )==""\n"
R"==(} )==""\n"
R"==(float pow_bwd(float dd, float s, float alpha, float beta) { )==""\n"
R"==(if (beta == 0) return 0; )==""\n"
R"==(float v = pow_fwd(s, alpha * beta, beta - 1); )==""\n"
R"==(return dd * v; )==""\n"
R"==(} )==""\n"
R"==(float gelu_erf_fwd(float s) { )==""\n"
R"==(const float sqrt_2_over_2 = 0.707106769084930419921875f; )==""\n"
R"==(float v = s * sqrt_2_over_2; )==""\n"
R"==(return 0.5f * s * (1.f + erf(v)); )==""\n"
R"==(} )==""\n"
R"==(float gelu_erf_bwd(float dd, float s) { )==""\n"
R"==(const float two_over_sqrt_pi = 1.12837922573089599609375f; )==""\n"
R"==(const float sqrt_2_over_2 = 0.707106769084930419921875f; )==""\n"
R"==(float v = s * sqrt_2_over_2; )==""\n"
R"==(return dd * 0.5f * (1.f + erf(v) + v * two_over_sqrt_pi * exp(-v * v)); )==""\n"
R"==(} )==""\n"
R"==(float round_fwd(float s) { )==""\n"
R"==(return (float)rint((float)s); )==""\n"
R"==(} )==""\n"
R"==(float hardsigmoid_fwd(float s, float alpha, float beta) { )==""\n"
R"==(float v = alpha * s + beta; )==""\n"
R"==(return v <= 0.f ? 0.f : v >= 1.f ? 1.f : v; )==""\n"
R"==(} )==""\n"
R"==(float hardsigmoid_bwd(float dd, float s, float alpha, float beta) { )==""\n"
R"==(float v = alpha * s + beta; )==""\n"
R"==(return v <= 0.f ? 0.f : v >= 1.f ? 0.f : dd * alpha; )==""\n"
R"==(} )==""\n"
R"==(float hardswish_fwd(float s, float alpha, float beta) { )==""\n"
R"==(return s * hardsigmoid_fwd(s, alpha, beta); )==""\n"
R"==(} )==""\n"
R"==(float hardswish_bwd(float dd, float s, float alpha, float beta) { )==""\n"
R"==(float v = alpha * s + beta; )==""\n"
R"==(float w = 2.f * alpha * s + beta; )==""\n"
R"==(return (v <= 0.f ? 0.f : v >= 1.f ? dd : dd * w); )==""\n"
R"==(} )==""\n"
R"==(float fwd_eltwise_common( )==""\n"
R"==(int eltwise_alg, float x, float alpha_, float beta_, float scale_) { )==""\n"
R"==(switch (eltwise_alg) { )==""\n"
R"==(case RELU: return scale_ * relu_fwd(x, alpha_); break; )==""\n"
R"==(case LINEAR: return scale_ * linear_fwd(x, alpha_, beta_); break; )==""\n"
R"==(case SOFT_RELU: return scale_ * soft_relu_fwd(x, alpha_); break; )==""\n"
R"==(case MISH: return scale_ * mish_fwd(x); break; )==""\n"
R"==(case LOGISTIC: return scale_ * logistic_fwd(x); break; )==""\n"
R"==(case TANH: return scale_ * tanh_fwd(x); break; )==""\n"
R"==(case ELU: return scale_ * elu_fwd(x, alpha_); break; )==""\n"
R"==(case SQUARE: return scale_ * square_fwd(x); break; )==""\n"
R"==(case SQRT: return scale_ * sqrt_fwd(x); break; )==""\n"
R"==(case ABS: return scale_ * abs_fwd(x); break; )==""\n"
R"==(case EXP: return scale_ * exp_fwd(x); break; )==""\n"
R"==(case GELU_TANH: return scale_ * gelu_tanh_fwd(x); break; )==""\n"
R"==(case SWISH: return scale_ * swish_fwd(x, alpha_); break; )==""\n"
R"==(case LOG: return scale_ * log_fwd(x); break; )==""\n"
R"==(case CLIP: return scale_ * clip_fwd(x, alpha_, beta_); break; )==""\n"
R"==(case CLIP_V2: return scale_ * clip_v2_fwd(x, alpha_, beta_); break; )==""\n"
R"==(case POW: return scale_ * pow_fwd(x, alpha_, beta_); break; )==""\n"
R"==(case GELU_ERF: return scale_ * gelu_erf_fwd(x); break; )==""\n"
R"==(case ROUND: return scale_ * round_fwd(x); break; )==""\n"
R"==(case HARDSWISH: return scale_ * hardswish_fwd(x, alpha_, beta_); break; )==""\n"
R"==(case HARDSIGMOID: )==""\n"
R"==(return scale_ * hardsigmoid_fwd(x, alpha_, beta_); )==""\n"
R"==(break; )==""\n"
R"==(case RELU_DST: return scale_ * relu_fwd(x, alpha_); break; )==""\n"
R"==(case LOGISTIC_DST: return scale_ * logistic_fwd(x); break; )==""\n"
R"==(case TANH_DST: return scale_ * tanh_fwd(x); break; )==""\n"
R"==(case ELU_DST: return scale_ * elu_fwd(x, alpha_); break; )==""\n"
R"==(case SQRT_DST: return scale_ * sqrt_fwd(x); break; )==""\n"
R"==(case EXP_DST: return scale_ * exp_fwd(x); break; )==""\n"
R"==(case CLIP_V2_DST: return scale_ * clip_v2_fwd(x, alpha_, beta_); break; )==""\n"
R"==(default: return x; break; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(float fwd_eltwise(float x, float alpha_, float beta_, float scale_) { )==""\n"
R"==(#ifdef ELTWISE_ALG )==""\n"
R"==(return fwd_eltwise_common(ELTWISE_ALG, x, alpha_, beta_, scale_); )==""\n"
R"==(#else )==""\n"
R"==(return x; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(float bwd_eltwise(float x, float y, float alpha_, float beta_) { )==""\n"
R"==(#ifdef ELTWISE_ALG )==""\n"
R"==(switch (ELTWISE_ALG) { )==""\n"
R"==(case RELU: return relu_bwd(x, y, alpha_); break; )==""\n"
R"==(case LINEAR: return linear_bwd(x, alpha_); break; )==""\n"
R"==(case SOFT_RELU: return soft_relu_bwd(x, y, alpha_); break; )==""\n"
R"==(case MISH: return mish_bwd(x, y); break; )==""\n"
R"==(case LOGISTIC: return logistic_bwd(x, y); break; )==""\n"
R"==(case TANH: return tanh_bwd(x, y); break; )==""\n"
R"==(case ELU: return elu_bwd(x, y, alpha_); break; )==""\n"
R"==(case SQUARE: return square_bwd(x, y); break; )==""\n"
R"==(case SQRT: return sqrt_bwd(x, y); break; )==""\n"
R"==(case ABS: return abs_bwd(x, y); break; )==""\n"
R"==(case EXP: return exp_bwd(x, y); break; )==""\n"
R"==(case GELU_TANH: return gelu_tanh_bwd(x, y); break; )==""\n"
R"==(case SWISH: return swish_bwd(x, y, alpha_); break; )==""\n"
R"==(case LOG: return log_bwd(x, y); break; )==""\n"
R"==(case CLIP: return clip_bwd(x, y, alpha_, beta_); break; )==""\n"
R"==(case CLIP_V2: return clip_v2_bwd(x, y, alpha_, beta_); break; )==""\n"
R"==(case POW: return pow_bwd(x, y, alpha_, beta_); break; )==""\n"
R"==(case GELU_ERF: return gelu_erf_bwd(x, y); break; )==""\n"
R"==(case HARDSWISH: return hardswish_bwd(x, y, alpha_, beta_); break; )==""\n"
R"==(case HARDSIGMOID: return hardsigmoid_bwd(x, y, alpha_, beta_); break; )==""\n"
R"==(case RELU_DST: return relu_bwd_use_dst(x, y, alpha_); break; )==""\n"
R"==(case LOGISTIC_DST: return logistic_bwd_use_dst(x, y); break; )==""\n"
R"==(case TANH_DST: return tanh_bwd_use_dst(x, y); break; )==""\n"
R"==(case ELU_DST: return elu_bwd_use_dst(x, y, alpha_); break; )==""\n"
R"==(case SQRT_DST: return sqrt_bwd_use_dst(x, y); break; )==""\n"
R"==(case EXP_DST: return exp_bwd_use_dst(x, y); break; )==""\n"
R"==(case CLIP_V2_DST: )==""\n"
R"==(return clip_v2_bwd_use_dst(x, y, alpha_, beta_); )==""\n"
R"==(break; )==""\n"
R"==(default: return x; break; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(return x; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==()==";
}
}
}
}