namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ocl_math_utils_header = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#ifndef GPU_OCL_OCL_MATH_UTILS_H )==""\n"
R"==(#define GPU_OCL_OCL_MATH_UTILS_H )==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable )==""\n"
R"==(#if DT_BF16 || SRC_DT_BF16 || WEI_DT_BF16 || DST_DT_BF16 || BIA_DT_BF16 \ )==""\n"
R"==(|| A_DT_BF16 || B_DT_BF16 || C_DT_BF16 || SUM_DT_BF16 \ )==""\n"
R"==(|| POST_OP_USING_BF16 )==""\n"
R"==(#define MATH_UTILS_DECLARE_BF16 1 )==""\n"
R"==(#endif )==""\n"
R"==(ulong8 __builtin_IB_simd_block_read_8_global_l(const __global ulong *); )==""\n"
R"==(ushort16 __builtin_IB_simd_block_read_16_global_h(const __global ushort *); )==""\n"
R"==(void __builtin_IB_simd_block_write_8_global_l(__global ulong *, ulong8); )==""\n"
R"==(void __builtin_IB_simd_block_write_16_global_h(__global ushort *, ushort16); )==""\n"
R"==(#if MATH_UTILS_DECLARE_BF16 )==""\n"
R"==(#ifdef cl_future_bf16_cvt )==""\n"
R"==(short __builtin_IB_ftobf_1(float a) __attribute__((const)); )==""\n"
R"==(short2 __builtin_IB_ftobf_2(float2 a) __attribute__((const)); )==""\n"
R"==(short4 __builtin_IB_ftobf_4(float4 a) __attribute__((const)); )==""\n"
R"==(short8 __builtin_IB_ftobf_8(float8 a) __attribute__((const)); )==""\n"
R"==(short16 __builtin_IB_ftobf_16(float16 a) __attribute__((const)); )==""\n"
R"==(float __builtin_IB_bftof_1(short a) __attribute__((const)); )==""\n"
R"==(float2 __builtin_IB_bftof_2(short2 a) __attribute__((const)); )==""\n"
R"==(float4 __builtin_IB_bftof_4(short4 a) __attribute__((const)); )==""\n"
R"==(float8 __builtin_IB_bftof_8(short8 a) __attribute__((const)); )==""\n"
R"==(float16 __builtin_IB_bftof_16(short16 a) __attribute__((const)); )==""\n"
R"==(ushort __attribute__((overloadable)) cvt_f32_to_bf16(float a) { return as_ushort (__builtin_IB_ftobf_1 (a)); } )==""\n"
R"==(ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 a) { return as_ushort2 (__builtin_IB_ftobf_2 (a)); } )==""\n"
R"==(ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 a) { return as_ushort4 (__builtin_IB_ftobf_4 (a)); } )==""\n"
R"==(ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 a) { return as_ushort8 (__builtin_IB_ftobf_8 (a)); } )==""\n"
R"==(ushort16 __attribute__((overloadable)) cvt_f32_to_bf16(float16 a) { return as_ushort16(__builtin_IB_ftobf_16(a)); } )==""\n"
R"==(float __attribute__((overloadable)) cvt_bf16_to_f32(ushort a) { return __builtin_IB_bftof_1 (as_short (a)); } )==""\n"
R"==(float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 a) { return __builtin_IB_bftof_2 (as_short2 (a)); } )==""\n"
R"==(float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 a) { return __builtin_IB_bftof_4 (as_short4 (a)); } )==""\n"
R"==(float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 a) { return __builtin_IB_bftof_8 (as_short8 (a)); } )==""\n"
R"==(float16 __attribute__((overloadable)) cvt_bf16_to_f32(ushort16 a) { return __builtin_IB_bftof_16(as_short16(a)); } )==""\n"
R"==(#else )==""\n"
R"==(ushort __attribute__((overloadable)) cvt_f32_to_bf16(float f) { )==""\n"
R"==(uint i = as_uint(f); )==""\n"
R"==(i += 0x00007FFF + ((i & 0x10000) >> 16); )==""\n"
R"==(ushort2 r = as_ushort2(i); )==""\n"
R"==(return r[1]; )==""\n"
R"==(} )==""\n"
R"==(ushort2 __attribute__((overloadable)) cvt_f32_to_bf16(float2 f) { )==""\n"
R"==(ushort2 r; )==""\n"
R"==(for (int i = 0; i < 2; i++) { )==""\n"
R"==(r[i] = cvt_f32_to_bf16(f[i]); )==""\n"
R"==(} )==""\n"
R"==(return r; )==""\n"
R"==(} )==""\n"
R"==(ushort4 __attribute__((overloadable)) cvt_f32_to_bf16(float4 f) { )==""\n"
R"==(ushort4 r; )==""\n"
R"==(for (int i = 0; i < 4; i++) { )==""\n"
R"==(r[i] = cvt_f32_to_bf16(f[i]); )==""\n"
R"==(} )==""\n"
R"==(return r; )==""\n"
R"==(} )==""\n"
R"==(ushort8 __attribute__((overloadable)) cvt_f32_to_bf16(float8 f) { )==""\n"
R"==(ushort8 r; )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(r[i] = cvt_f32_to_bf16(f[i]); )==""\n"
R"==(} )==""\n"
R"==(return r; )==""\n"
R"==(} )==""\n"
R"==(ushort16 __attribute__((overloadable)) cvt_f32_to_bf16(float16 f) { )==""\n"
R"==(ushort16 r; )==""\n"
R"==(for (int i = 0; i < 16; i++) { )==""\n"
R"==(r[i] = cvt_f32_to_bf16(f[i]); )==""\n"
R"==(} )==""\n"
R"==(return r; )==""\n"
R"==(} )==""\n"
R"==(float __attribute__((overloadable)) cvt_bf16_to_f32(ushort b) { )==""\n"
R"==(ushort2 r = {0, b}; )==""\n"
R"==(float f = as_float(r); )==""\n"
R"==(return f; )==""\n"
R"==(} )==""\n"
R"==(float2 __attribute__((overloadable)) cvt_bf16_to_f32(ushort2 b) { )==""\n"
R"==(float2 f; )==""\n"
R"==(for (int i = 0; i < 2; i++) { )==""\n"
R"==(f[i] = cvt_bf16_to_f32(b[i]); )==""\n"
R"==(} )==""\n"
R"==(return f; )==""\n"
R"==(} )==""\n"
R"==(float4 __attribute__((overloadable)) cvt_bf16_to_f32(ushort4 b) { )==""\n"
R"==(float4 f; )==""\n"
R"==(for (int i = 0; i < 4; i++) { )==""\n"
R"==(f[i] = cvt_bf16_to_f32(b[i]); )==""\n"
R"==(} )==""\n"
R"==(return f; )==""\n"
R"==(} )==""\n"
R"==(float8 __attribute__((overloadable)) cvt_bf16_to_f32(ushort8 b) { )==""\n"
R"==(float8 f; )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(f[i] = cvt_bf16_to_f32(b[i]); )==""\n"
R"==(} )==""\n"
R"==(return f; )==""\n"
R"==(} )==""\n"
R"==(float16 __attribute__((overloadable)) cvt_bf16_to_f32(ushort16 b) { )==""\n"
R"==(float16 f; )==""\n"
R"==(for (int i = 0; i < 16; i++) { )==""\n"
R"==(f[i] = cvt_bf16_to_f32(b[i]); )==""\n"
R"==(} )==""\n"
R"==(return f; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(int __attribute__((overloadable)) idot4(char4 a, char4 b, int c) { )==""\n"
R"==(c += a[0] * b[0]; )==""\n"
R"==(c += a[1] * b[1]; )==""\n"
R"==(c += a[2] * b[2]; )==""\n"
R"==(c += a[3] * b[3]; )==""\n"
R"==(return c; )==""\n"
R"==(} )==""\n"
R"==(int __attribute__((overloadable)) idot4(uchar4 a, uchar4 b, int c) { )==""\n"
R"==(c += a[0] * b[0]; )==""\n"
R"==(c += a[1] * b[1]; )==""\n"
R"==(c += a[2] * b[2]; )==""\n"
R"==(c += a[3] * b[3]; )==""\n"
R"==(return c; )==""\n"
R"==(} )==""\n"
R"==(int __attribute__((overloadable)) idot4(char4 a, uchar4 b, int c) { )==""\n"
R"==(c += a[0] * b[0]; )==""\n"
R"==(c += a[1] * b[1]; )==""\n"
R"==(c += a[2] * b[2]; )==""\n"
R"==(c += a[3] * b[3]; )==""\n"
R"==(return c; )==""\n"
R"==(} )==""\n"
R"==(int __attribute__((overloadable)) idot4(uchar4 a, char4 b, int c) { )==""\n"
R"==(c += a[0] * b[0]; )==""\n"
R"==(c += a[1] * b[1]; )==""\n"
R"==(c += a[2] * b[2]; )==""\n"
R"==(c += a[3] * b[3]; )==""\n"
R"==(return c; )==""\n"
R"==(} )==""\n"
R"==(int __attribute__((overloadable)) idot4(int a, int b, int c) { )==""\n"
R"==(return idot4(as_char4(a), as_char4(b), c); )==""\n"
R"==(} )==""\n"
R"==(int __attribute__((overloadable)) idot4(uint a, int b, int c) { )==""\n"
R"==(return idot4(as_uchar4(a), as_char4(b), c); )==""\n"
R"==(} )==""\n"
R"==(float __attribute__((overloadable)) f16_dot2(int a, int b, float c) { )==""\n"
R"==(half2 _a = as_half2(a); )==""\n"
R"==(half2 _b = as_half2(b); )==""\n"
R"==(return c + _a[0] * _b[0] + _a[1] * _b[1]; )==""\n"
R"==(} )==""\n"
R"==(#if MATH_UTILS_DECLARE_BF16 )==""\n"
R"==(float __attribute__((overloadable)) bf16_dot2(int a, int b, float c) { )==""\n"
R"==(ushort2 _a = as_ushort2(a); )==""\n"
R"==(ushort2 _b = as_ushort2(b); )==""\n"
R"==(c += cvt_bf16_to_f32(_a[0]) * cvt_bf16_to_f32(_b[0]); )==""\n"
R"==(c += cvt_bf16_to_f32(_a[1]) * cvt_bf16_to_f32(_b[1]); )==""\n"
R"==(return c; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#define DECLARE_BLOCK_READ(suffix, func, data_type, addr_space, p_type) \ )==""\n"
R"==(data_type __attribute__((overloadable)) \ )==""\n"
R"==(block_read##suffix(const addr_space p_type *p) { \ )==""\n"
R"==(return func(p); \ )==""\n"
R"==(} )==""\n"
R"==(#define DECLARE_BLOCK_READ_EMU(suffix, data_type, addr_space, p_type) \ )==""\n"
R"==(data_type __attribute__((overloadable)) \ )==""\n"
R"==(block_read##suffix##_emu(const addr_space p_type *p) { \ )==""\n"
R"==(data_type ret; \ )==""\n"
R"==(uint idx = get_sub_group_local_id(); \ )==""\n"
R"==(for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \ )==""\n"
R"==(((p_type *)&ret)[i] = p[idx]; \ )==""\n"
R"==(idx += get_max_sub_group_size(); \ )==""\n"
R"==(} \ )==""\n"
R"==(return ret; \ )==""\n"
R"==(} )==""\n"
R"==(#define DECLARE_BLOCK_WRITE(suffix, func, data_type, addr_space, p_type) \ )==""\n"
R"==(void __attribute__((overloadable)) \ )==""\n"
R"==(block_write##suffix(addr_space p_type *p, data_type data) { \ )==""\n"
R"==(func(p, data); \ )==""\n"
R"==(} )==""\n"
R"==(#define DECLARE_BLOCK_WRITE_EMU(suffix, data_type, addr_space, p_type) \ )==""\n"
R"==(void __attribute__((overloadable)) \ )==""\n"
R"==(block_write##suffix##_emu(addr_space p_type *p, data_type data) { \ )==""\n"
R"==(uint idx = get_sub_group_local_id(); \ )==""\n"
R"==(for (int i = 0; i < sizeof(data_type) / sizeof(p_type); i++) { \ )==""\n"
R"==(p[idx] = ((p_type *)&data)[i]; \ )==""\n"
R"==(p += get_max_sub_group_size(); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __global, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __global, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __global, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __global, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __global, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __global, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __global, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __global, uint) )==""\n"
R"==(#ifdef cl_intel_subgroups_char )==""\n"
R"==(void __attribute__((overloadable)) )==""\n"
R"==(intel_sub_group_block_write_uc16(__global uchar *p, uchar16 data); )==""\n"
R"==(uchar16 __attribute__((overloadable)) )==""\n"
R"==(intel_sub_group_block_read_uc16(const __global uchar *p); )==""\n"
R"==(#endif )==""\n"
R"==(DECLARE_BLOCK_READ_EMU(, uint, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ_EMU(2, uint2, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ_EMU(4, uint4, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ_EMU(8, uint8, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(, uint, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(2, uint2, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(4, uint4, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(8, uint8, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(_us, ushort, __local, ushort) )==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(_us2, ushort2, __local, ushort) )==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(_us4, ushort4, __local, ushort) )==""\n"
R"==(DECLARE_BLOCK_WRITE_EMU(_us8, ushort8, __local, ushort) )==""\n"
R"==(#ifdef cl_intel_subgroup_local_block_io )==""\n"
R"==(DECLARE_BLOCK_READ(, intel_sub_group_block_read, uint, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(2, intel_sub_group_block_read2, uint2, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(4, intel_sub_group_block_read4, uint4, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(8, intel_sub_group_block_read8, uint8, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(, intel_sub_group_block_write, uint, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(2, intel_sub_group_block_write2, uint2, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(4, intel_sub_group_block_write4, uint4, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(8, intel_sub_group_block_write8, uint8, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE( )==""\n"
R"==(_us, intel_sub_group_block_write_us, ushort, __local, ushort) )==""\n"
R"==(#else )==""\n"
R"==(DECLARE_BLOCK_READ(, block_read_emu, uint, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(2, block_read2_emu, uint2, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(4, block_read4_emu, uint4, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_READ(8, block_read8_emu, uint8, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(, block_write_emu, uint, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(2, block_write2_emu, uint2, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(4, block_write4_emu, uint4, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(8, block_write8_emu, uint8, __local, uint) )==""\n"
R"==(DECLARE_BLOCK_WRITE(_us, block_write_us_emu, ushort, __local, ushort) )==""\n"
R"==(#endif )==""\n"
R"==(#define DECLARE_MMAD_EMU(name, dot, K, m, a_type, b_type, acc_type) \ )==""\n"
R"==(acc_type __attribute__((overloadable)) \ )==""\n"
R"==(name(a_type A_vectors, b_type B_vectors, acc_type acc) { \ )==""\n"
R"==(for (uint i = 0; i < (m); ++i) { \ )==""\n"
R"==(for (uint j = 0; j < (K); ++j) \ )==""\n"
R"==(acc[i] = dot(sub_group_broadcast(A_vectors[i], j), \ )==""\n"
R"==(B_vectors[j], acc[i]); \ )==""\n"
R"==(} \ )==""\n"
R"==(return acc; \ )==""\n"
R"==(} )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4, idot4, 8, 4, uint4, int8, int4) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4, idot4, 8, 4, int4, int8, int4) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8, idot4, 8, 8, uint8, int8, int8) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8, idot4, 8, 8, int8, int8, int8) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8, idot4, 8, 8, ushort8, int8, int8) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8, idot4, 8, 8, short8, int8, int8) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4_f16, f16_dot2, 8, 4, uint4, int8, float4) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4_f16, f16_dot2, 8, 4, short4, int8, float4) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_f16, f16_dot2, 8, 8, uint8, int8, float8) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_f16, f16_dot2, 8, 8, short8, int8, float8) )==""\n"
R"==(#if MATH_UTILS_DECLARE_BF16 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4_bf16, bf16_dot2, 8, 4, uint4, int8, float4) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_bf16, bf16_dot2, 8, 8, uint8, int8, float8) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x4_bf16, bf16_dot2, 8, 4, ushort4, int8, float4) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_bf16, bf16_dot2, 8, 8, ushort8, int8, float8) )==""\n"
R"==(DECLARE_MMAD_EMU(mmad8x8_bf16, bf16_dot2, 8, 8, short8, int8, float8) )==""\n"
R"==(#endif )==""\n"
R"==(#if __OPENCL_C_VERSION__ >= 200 )==""\n"
R"==(#ifdef cl_intel_global_float_atomics )==""\n"
R"==(inline void atomic_add_global( )==""\n"
R"==(volatile global atomic_float *source, float operand) { )==""\n"
R"==(atomic_fetch_add_explicit(source, operand, memory_order_relaxed); )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(inline void atomic_add_global( )==""\n"
R"==(volatile __global atomic_float *source, float operand) { )==""\n"
R"==(float old_val = atomic_load_explicit( )==""\n"
R"==(source, memory_order_relaxed, memory_scope_device); )==""\n"
R"==(bool success = false; )==""\n"
R"==(do { )==""\n"
R"==(float new_val = old_val + operand; )==""\n"
R"==(success = atomic_compare_exchange_strong_explicit(source, &old_val, )==""\n"
R"==(new_val, memory_order_acq_rel, memory_order_relaxed, )==""\n"
R"==(memory_scope_device); )==""\n"
R"==(} while (!success); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}