namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ocl_post_ops_header = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2023 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#ifndef GPU_OCL_OCL_POST_OPS_H )==""\n"
R"==(#define GPU_OCL_OCL_POST_OPS_H )==""\n"
R"==(#ifndef SUB_GROUP_SIZE )==""\n"
R"==(#define SUB_GROUP_SIZE get_sub_group_size() )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_POST_OP )==""\n"
R"==(#if !WITH_ELTWISE )==""\n"
R"==(#undef WITH_ELTWISE )==""\n"
R"==(#define WITH_ELTWISE 1 )==""\n"
R"==(#endif )==""\n"
R"==(#include "gpu/ocl/ocl_eltwise.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(float fwd_Xnary(unsigned kind, unsigned algorithm, float x, float y, )==""\n"
R"==(float alpha, float beta, float scale) { )==""\n"
R"==(if (kind == PO_BINARY) { )==""\n"
R"==(switch (algorithm) { )==""\n"
R"==(case BINARY_ADD: return x + y; break; )==""\n"
R"==(case BINARY_MUL: return x * y; break; )==""\n"
R"==(case BINARY_MIN: return x < y ? x : y; break; )==""\n"
R"==(case BINARY_MAX: return x > y ? x : y; break; )==""\n"
R"==(case BINARY_DIV: return x / y; break; )==""\n"
R"==(case BINARY_SUB: return x - y; break; )==""\n"
R"==(case BINARY_GE: return x >= y; break; )==""\n"
R"==(case BINARY_GT: return x > y; break; )==""\n"
R"==(case BINARY_LE: return x <= y; break; )==""\n"
R"==(case BINARY_LT: return x < y; break; )==""\n"
R"==(case BINARY_EQ: return x == y; break; )==""\n"
R"==(case BINARY_NE: return x != y; break; )==""\n"
R"==(case RELU:  )==""\n"
R"==(return fwd_eltwise_common(RELU, x, y, beta, scale); )==""\n"
R"==(break; )==""\n"
R"==(default: return 0.f; )==""\n"
R"==(} )==""\n"
R"==(} else {  )==""\n"
R"==(return fwd_eltwise_common(algorithm, x, alpha, beta, scale); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#define CONV_BIN_ARG_TO_FLOAT(idx, bin_arg_val) \ )==""\n"
R"==(({ \ )==""\n"
R"==(float ret_val; \ )==""\n"
R"==(if (CONCAT3(PO_, idx, _BIN_ARG_DT_IS_BF16)) \ )==""\n"
R"==(ret_val = cvt_bf16_to_f32(bin_arg_val); \ )==""\n"
R"==(else \ )==""\n"
R"==(ret_val = convert_float(bin_arg_val); \ )==""\n"
R"==(\ )==""\n"
R"==(ret_val; \ )==""\n"
R"==(}) )==""\n"
R"==(#define FWD_XNARY_GENERIC_DT(po_kind, algorithm, result, result_elem_dt, \ )==""\n"
R"==(arg0_ptr, arg0_len, arg1_ptr, arg1_len, alpha, beta, scale) \ )==""\n"
R"==({ \ )==""\n"
R"==(const unsigned out_len = max((unsigned)arg0_len, (unsigned)arg1_len); \ )==""\n"
R"==(result_elem_dt *res_ptr = (result_elem_dt *)(&result); \ )==""\n"
R"==(unroll_for(unsigned idx = 0; idx < out_len; ++idx) { \ )==""\n"
R"==(if (arg0_len == 1 && arg1_len == 1) { \ )==""\n"
R"==(*res_ptr = fwd_Xnary(po_kind, algorithm, \ )==""\n"
R"==(convert_float(*arg0_ptr), convert_float(*arg1_ptr), \ )==""\n"
R"==(alpha, beta, scale); \ )==""\n"
R"==(} else if (arg0_len == 1) { \ )==""\n"
R"==(res_ptr[idx] = fwd_Xnary(po_kind, algorithm, \ )==""\n"
R"==(convert_float(*arg0_ptr), \ )==""\n"
R"==(convert_float(arg1_ptr[idx]), alpha, beta, scale); \ )==""\n"
R"==(} else if (arg1_len == 1) { \ )==""\n"
R"==(res_ptr[idx] = fwd_Xnary(po_kind, algorithm, \ )==""\n"
R"==(convert_float(arg0_ptr[idx]), \ )==""\n"
R"==(convert_float(*arg1_ptr), alpha, beta, scale); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(res_ptr[idx] = fwd_Xnary(po_kind, algorithm, \ )==""\n"
R"==(convert_float(arg0_ptr[idx]), \ )==""\n"
R"==(convert_float(arg1_ptr[idx]), alpha, beta, scale); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define FMA_BLOCK( \ )==""\n"
R"==(block_size, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b) \ )==""\n"
R"==(unroll_for(; nof_elems >= block_size; acc_ptr += block_size, \ )==""\n"
R"==(a_ptr += block_size, nof_elems -= block_size) { \ )==""\n"
R"==(CONCAT2(acc_elem_dt, block_size) \ )==""\n"
R"==(a_conv = CONCAT3(convert_, acc_elem_dt, block_size)( \ )==""\n"
R"==(*((CONCAT2(a_elem_dt, block_size) *)a_ptr)); \ )==""\n"
R"==(*((CONCAT2(acc_elem_dt, block_size) *)acc_ptr) = fma( \ )==""\n"
R"==(a_conv, b, *((CONCAT2(acc_elem_dt, block_size) *)acc_ptr)); \ )==""\n"
R"==(} )==""\n"
R"==(#define FMA_MIXED(acc_nof_elems, a, a_elem_dt, b, acc, acc_elem_dt) \ )==""\n"
R"==({ \ )==""\n"
R"==(unsigned nof_elems = acc_nof_elems; \ )==""\n"
R"==(a_elem_dt *a_ptr = (a_elem_dt *)(&a); \ )==""\n"
R"==(acc_elem_dt *acc_ptr = (acc_elem_dt *)(&acc); \ )==""\n"
R"==(FMA_BLOCK(8, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \ )==""\n"
R"==(FMA_BLOCK(4, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \ )==""\n"
R"==(FMA_BLOCK(2, nof_elems, acc_ptr, acc_elem_dt, a_ptr, a_elem_dt, b); \ )==""\n"
R"==(if (nof_elems == 1) { *acc_ptr += (*a_ptr) * b; } \ )==""\n"
R"==(} )==""\n"
R"==(#define FILL_BIN_ARG_SERIAL(idx, dest_ptr, x0, x0_s, x1, x1_s, x1_incr, x2, \ )==""\n"
R"==(x2_s, x3, x3_s, x4, x4_s, x5, x5_s) \ )==""\n"
R"==(unroll_for(unsigned x0_idx = x0, bin_arg_offset = 0; x0_idx < x0 + x0_s; \ )==""\n"
R"==(++x0_idx) { \ )==""\n"
R"==(unroll_for(unsigned x1_idx = x1; x1_idx < x1 + x1_s; \ )==""\n"
R"==(x1_idx += x1_incr) { \ )==""\n"
R"==(unroll_for(unsigned x2_idx = x2; x2_idx < x2 + x2_s; ++x2_idx) { \ )==""\n"
R"==(unroll_for(unsigned x3_idx = x3; x3_idx < x3 + x3_s; \ )==""\n"
R"==(++x3_idx) { \ )==""\n"
R"==(unroll_for(unsigned x4_idx = x4; x4_idx < x4 + x4_s; \ )==""\n"
R"==(++x4_idx) { \ )==""\n"
R"==(unroll_for(unsigned x5_idx = x5; x5_idx < x5 + x5_s; \ )==""\n"
R"==(++x5_idx, ++bin_arg_offset) { \ )==""\n"
R"==(const unsigned bin_arg_glob_off = OFF_MD( \ )==""\n"
R"==(CONCAT3(PO_, idx, _BIN_ARG), \ )==""\n"
R"==(x0_idx % CONCAT3(PO_, idx, _BIN_ARG_D0), \ )==""\n"
R"==(x1_idx % CONCAT3(PO_, idx, _BIN_ARG_D1), \ )==""\n"
R"==(x2_idx % CONCAT3(PO_, idx, _BIN_ARG_D2), \ )==""\n"
R"==(x3_idx % CONCAT3(PO_, idx, _BIN_ARG_D3), \ )==""\n"
R"==(x4_idx % CONCAT3(PO_, idx, _BIN_ARG_D4), \ )==""\n"
R"==(x5_idx % CONCAT3(PO_, idx, _BIN_ARG_D5)); \ )==""\n"
R"==(dest_ptr[bin_arg_offset] = CONV_BIN_ARG_TO_FLOAT( \ )==""\n"
R"==(idx, \ )==""\n"
R"==(CONCAT3(po_, idx, \ )==""\n"
R"==(_binary_arg)[bin_arg_glob_off]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define intel_sub_group_block_read_uc1 intel_sub_group_block_read_uc )==""\n"
R"==(#define intel_sub_group_block_read_us1 intel_sub_group_block_read_us )==""\n"
R"==(#define intel_sub_group_block_read1 intel_sub_group_block_read )==""\n"
R"==(#define uchar1 uchar )==""\n"
R"==(#define ushort1 ushort )==""\n"
R"==(#define uint1 uint )==""\n"
R"==(#define FILL_WITH_BLOCK_READ(idx, src_ptr, dst_ptr, nelem, data_type) \ )==""\n"
R"==({ \ )==""\n"
R"==(data_type tmp_storage[nelem]; \ )==""\n"
R"==(if (sizeof(data_type) == 1) { \ )==""\n"
R"==(*((CONCAT2(uchar, nelem) *)(&tmp_storage)) \ )==""\n"
R"==(= (CONCAT2(intel_sub_group_block_read_uc, nelem)( \ )==""\n"
R"==((__global uchar *)(src_ptr))); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (sizeof(data_type) == 2) { \ )==""\n"
R"==(*((CONCAT2(ushort, nelem) *)(&tmp_storage)) \ )==""\n"
R"==(= CONCAT2(intel_sub_group_block_read_us, nelem)( \ )==""\n"
R"==((__global ushort *)(src_ptr)); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (sizeof(data_type) == 4) { \ )==""\n"
R"==(*((CONCAT2(uint, nelem) *)(&tmp_storage)) \ )==""\n"
R"==(= CONCAT2(intel_sub_group_block_read, nelem)( \ )==""\n"
R"==((__global uint *)(src_ptr)); \ )==""\n"
R"==(} \ )==""\n"
R"==(unroll_for(unsigned s_index = 0; s_index < nelem; ++s_index) { \ )==""\n"
R"==(dst_ptr[s_index] \ )==""\n"
R"==(= CONV_BIN_ARG_TO_FLOAT(idx, tmp_storage[s_index]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define X_NELEMS(x) ({ x / SUB_GROUP_SIZE; }) )==""\n"
R"==(#define CONDITIONAL_FILL( \ )==""\n"
R"==(idx, blocked_coord, nelem, src_ptr, dst_ptr, data_type) \ )==""\n"
R"==(if (blocked_coord / SUB_GROUP_SIZE == nelem) \ )==""\n"
R"==(FILL_WITH_BLOCK_READ(idx, src_ptr, dst_ptr, nelem, data_type); )==""\n"
R"==(#define FILL_BIN_ARG_TRY_BLOCK(idx, dest_ptr, dest_size, x0, x0_s, x1, x1_s, \ )==""\n"
R"==(x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s) \ )==""\n"
R"==({ \ )==""\n"
R"==(unroll_for(unsigned x0_idx = x0, arg_off = 0; x0_idx < x0 + x0_s; \ )==""\n"
R"==(++x0_idx, arg_off += X_NELEMS(x1_s)) { \ )==""\n"
R"==(const unsigned bin_arg_glob_off \ )==""\n"
R"==(= OFF_MD(CONCAT3(PO_, idx, _BIN_ARG), \ )==""\n"
R"==(x0_idx % CONCAT3(PO_, idx, _BIN_ARG_D0), \ )==""\n"
R"==(x1 % CONCAT3(PO_, idx, _BIN_ARG_D1), \ )==""\n"
R"==(x2 % CONCAT3(PO_, idx, _BIN_ARG_D2), \ )==""\n"
R"==(x3 % CONCAT3(PO_, idx, _BIN_ARG_D3), \ )==""\n"
R"==(x4 % CONCAT3(PO_, idx, _BIN_ARG_D4), \ )==""\n"
R"==(x5 % CONCAT3(PO_, idx, _BIN_ARG_D5)); \ )==""\n"
R"==(\ )==""\n"
R"==(CONDITIONAL_FILL(idx, x1_s, 1, \ )==""\n"
R"==((CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \ )==""\n"
R"==((dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \ )==""\n"
R"==(CONDITIONAL_FILL(idx, x1_s, 2, \ )==""\n"
R"==((CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \ )==""\n"
R"==((dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \ )==""\n"
R"==(CONDITIONAL_FILL(idx, x1_s, 4, \ )==""\n"
R"==((CONCAT3(po_, idx, _binary_arg) + bin_arg_glob_off), \ )==""\n"
R"==((dest_ptr + arg_off), CONCAT3(PO_, idx, _BIN_ARG_DATA_T)); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define REPLICATE_DATA( \ )==""\n"
R"==(dest_ptr, dest_size, x0_s, x1_s, x2_s, x3_s, x4_s, x5_s) \ )==""\n"
R"==({ \ )==""\n"
R"==(const unsigned copy_size \ )==""\n"
R"==(= x0_s * X_NELEMS(x1_s) * x2_s * x3_s * x4_s * x5_s; \ )==""\n"
R"==(unroll_for(unsigned fid = copy_size; fid < dest_size; ++fid) { \ )==""\n"
R"==(*(dest_ptr + fid) = *(dest_ptr + (fid % copy_size)); \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(#define IS_BURSTABLE(idx, x0, x0_s, x1, x1_s, x2, x2_s, x3, x3_s, x4, x4_s, \ )==""\n"
R"==(x5, x5_s, is_burst) \ )==""\n"
R"==(({ \ )==""\n"
R"==(bool is_burstable = is_burst; \ )==""\n"
R"==(if (x0_s > CONCAT3(PO_, idx, _BIN_ARG_D0) && x0_s > 1) \ )==""\n"
R"==(is_burstable = false; \ )==""\n"
R"==(if (x1_s > CONCAT3(PO_, idx, _BIN_ARG_D1) && x1_s > 1) \ )==""\n"
R"==(is_burstable = false; \ )==""\n"
R"==(if (x2_s > CONCAT3(PO_, idx, _BIN_ARG_D2) && x2_s > 1) \ )==""\n"
R"==(is_burstable = false; \ )==""\n"
R"==(if (x3_s > CONCAT3(PO_, idx, _BIN_ARG_D3) && x3_s > 1) \ )==""\n"
R"==(is_burstable = false; \ )==""\n"
R"==(if (x4_s > CONCAT3(PO_, idx, _BIN_ARG_D4) && x4_s > 1) \ )==""\n"
R"==(is_burstable = false; \ )==""\n"
R"==(if (x5_s > CONCAT3(PO_, idx, _BIN_ARG_D5) && x5_s > 1) \ )==""\n"
R"==(is_burstable = false; \ )==""\n"
R"==(if (CONCAT3(PO_, idx, _BIN_ARG_D0) * CONCAT3(PO_, idx, _BIN_ARG_D1) \ )==""\n"
R"==(* CONCAT3(PO_, idx, _BIN_ARG_D2) \ )==""\n"
R"==(* CONCAT3(PO_, idx, _BIN_ARG_D2) \ )==""\n"
R"==(* CONCAT3(PO_, idx, _BIN_ARG_D3) \ )==""\n"
R"==(* CONCAT3(PO_, idx, _BIN_ARG_D4) \ )==""\n"
R"==(* CONCAT3(PO_, idx, _BIN_ARG_D5) \ )==""\n"
R"==(== 1) \ )==""\n"
R"==(is_burstable = false; \ )==""\n"
R"==(\ )==""\n"
R"==(is_burstable; \ )==""\n"
R"==(}) )==""\n"
R"==(#define APPLY_PO_BINARY(idx, accumulator, acc_elem_dt, x0, x0_s, x1, x1_s, \ )==""\n"
R"==(x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(const unsigned bin_arg_size \ )==""\n"
R"==(= sizeof(accumulator) / sizeof(acc_elem_dt); \ )==""\n"
R"==(float bin_arg[sizeof(accumulator) / sizeof(acc_elem_dt)]; \ )==""\n"
R"==(float *bin_arg_ptr = &bin_arg[0]; \ )==""\n"
R"==(const bool use_burst_read = IS_BURSTABLE(idx, x0, x0_s, x1, x1_s, x2, \ )==""\n"
R"==(x2_s, x3, x3_s, x4, x4_s, x5, x5_s, is_burst); \ )==""\n"
R"==(const unsigned x1_jump = is_burst ? SUB_GROUP_SIZE : 1; \ )==""\n"
R"==(if (use_burst_read) { \ )==""\n"
R"==(FILL_BIN_ARG_TRY_BLOCK(idx, bin_arg_ptr, bin_arg_size, x0, x0_s, \ )==""\n"
R"==(x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(FILL_BIN_ARG_SERIAL(idx, bin_arg_ptr, x0, x0_s, (x1 + x1_incr), \ )==""\n"
R"==(x1_s, x1_jump, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s); \ )==""\n"
R"==(} \ )==""\n"
R"==(REPLICATE_DATA(bin_arg_ptr, bin_arg_size, x0_s, x1_s, x2_s, x3_s, \ )==""\n"
R"==(x4_s, x5_s); \ )==""\n"
R"==(FWD_XNARY_GENERIC_DT(PO_BINARY, CONCAT3(PO_, idx, _ALG), accumulator, \ )==""\n"
R"==(acc_elem_dt, ((acc_elem_dt *)(&accumulator)), \ )==""\n"
R"==((sizeof(accumulator) / sizeof(acc_elem_dt)), bin_arg_ptr, \ )==""\n"
R"==(bin_arg_size, 0.0f, 0.0f, 1.0f); \ )==""\n"
R"==(} )==""\n"
R"==(#define APPLY_PO_SUM(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt) \ )==""\n"
R"==({ \ )==""\n"
R"==(unsigned acc_size = sizeof(accumulator) / sizeof(acc_elem_dt); \ )==""\n"
R"==(FMA_MIXED(acc_size, sum_src, sum_elem_dt, \ )==""\n"
R"==(CONCAT3(PO_, idx, _SUM_SCALE), accumulator, acc_elem_dt); \ )==""\n"
R"==(} )==""\n"
R"==(#define APPLY_PO_ELTWISE(idx, accumulator, acc_elem_dt) \ )==""\n"
R"==({ \ )==""\n"
R"==(FWD_XNARY_GENERIC_DT(PO_ELTWISE, CONCAT3(PO_, idx, _ALG), accumulator, \ )==""\n"
R"==(acc_elem_dt, ((acc_elem_dt *)(&accumulator)), \ )==""\n"
R"==((sizeof(accumulator) / sizeof(acc_elem_dt)), \ )==""\n"
R"==(((acc_elem_dt *)(&accumulator)), \ )==""\n"
R"==((sizeof(accumulator) / sizeof(acc_elem_dt)), \ )==""\n"
R"==(CONCAT3(PO_, idx, _ELTWISE_ALPHA), \ )==""\n"
R"==(CONCAT3(PO_, idx, _ELTWISE_BETA), \ )==""\n"
R"==(CONCAT3(PO_, idx, _ELTWISE_SCALE)); \ )==""\n"
R"==(} )==""\n"
R"==(#define APPLY_PO_STAGE(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt, \ )==""\n"
R"==(x0, x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==(switch (CONCAT3(PO_, idx, _KIND)) { \ )==""\n"
R"==(case PO_BINARY: \ )==""\n"
R"==(APPLY_PO_BINARY(idx, accumulator, acc_elem_dt, x0, x0_s, x1, x1_s, \ )==""\n"
R"==(x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst); \ )==""\n"
R"==(break; \ )==""\n"
R"==(case PO_ELTWISE: APPLY_PO_ELTWISE(idx, accumulator, acc_elem_dt); \ )==""\n"
R"==(break; \ )==""\n"
R"==(case PO_SUM: \ )==""\n"
R"==(APPLY_PO_SUM(idx, accumulator, acc_elem_dt, sum_src, sum_elem_dt); \ )==""\n"
R"==(break; \ )==""\n"
R"==(} )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH == 0 )==""\n"
R"==(#define EMPTY_POST_OPS(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 0 )==""\n"
R"==(#define APPLY_1_PO_STAGE(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_PO_STAGE(0, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 1 )==""\n"
R"==(#define APPLY_2_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_1_PO_STAGE(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(1, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 2 )==""\n"
R"==(#define APPLY_3_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_2_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(2, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 3 )==""\n"
R"==(#define APPLY_4_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_3_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(3, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 4 )==""\n"
R"==(#define APPLY_5_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_4_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(4, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 5 )==""\n"
R"==(#define APPLY_6_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_5_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(5, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 6 )==""\n"
R"==(#define APPLY_7_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_6_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(6, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 7 )==""\n"
R"==(#define APPLY_8_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_7_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(7, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 8 )==""\n"
R"==(#define APPLY_9_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_8_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(8, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 9 )==""\n"
R"==(#define APPLY_10_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_9_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(9, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 10 )==""\n"
R"==(#define APPLY_11_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_10_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(10, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 11 )==""\n"
R"==(#define APPLY_12_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_11_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(11, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 12 )==""\n"
R"==(#define APPLY_13_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_12_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(12, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 13 )==""\n"
R"==(#define APPLY_14_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_13_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(13, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 14 )==""\n"
R"==(#define APPLY_15_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_14_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(14, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 15 )==""\n"
R"==(#define APPLY_16_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_15_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(15, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 16 )==""\n"
R"==(#define APPLY_17_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_16_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(16, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 17 )==""\n"
R"==(#define APPLY_18_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_17_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(17, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 18 )==""\n"
R"==(#define APPLY_19_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_18_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(18, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 19 )==""\n"
R"==(#define APPLY_20_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_19_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(19, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 20 )==""\n"
R"==(#define APPLY_21_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_20_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(20, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 21 )==""\n"
R"==(#define APPLY_22_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_21_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(21, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 22 )==""\n"
R"==(#define APPLY_23_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_22_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(22, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 23 )==""\n"
R"==(#define APPLY_24_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_23_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(23, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 24 )==""\n"
R"==(#define APPLY_25_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_24_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(24, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 25 )==""\n"
R"==(#define APPLY_26_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_25_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(25, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 26 )==""\n"
R"==(#define APPLY_27_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_26_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(26, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 27 )==""\n"
R"==(#define APPLY_28_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_27_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(27, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 28 )==""\n"
R"==(#define APPLY_29_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_28_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(28, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 29 )==""\n"
R"==(#define APPLY_30_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_29_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(29, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 30 )==""\n"
R"==(#define APPLY_31_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_30_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(30, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH > 31 )==""\n"
R"==(#define APPLY_32_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_31_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(31, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if POST_OP_CHAIN_LENGTH == 0 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES EMPTY_POST_OPS )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 1 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_1_PO_STAGE )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 2 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_2_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 3 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_3_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 4 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_4_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 5 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_5_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 6 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_6_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 7 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_7_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 8 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_8_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 9 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_9_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 10 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_10_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 11 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_11_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 12 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_12_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 13 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_13_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 14 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_14_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 15 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_15_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 16 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_16_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 17 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_17_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 18 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_18_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 19 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_19_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 20 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_20_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 21 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_21_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 22 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_22_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 23 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_23_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 24 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_24_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 25 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_25_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 26 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_26_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 27 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_27_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 28 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_28_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 29 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_29_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 30 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_30_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 31 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_31_PO_STAGES )==""\n"
R"==(#elif POST_OP_CHAIN_LENGTH == 32 )==""\n"
R"==(#define APPLY_ALL_PO_STAGES APPLY_32_PO_STAGES )==""\n"
R"==(#endif )==""\n"
R"==(#define APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, x5_s, \ )==""\n"
R"==(is_burst) \ )==""\n"
R"==({ \ )==""\n"
R"==(APPLY_ALL_PO_STAGES(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \ )==""\n"
R"==(x0, x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(/*APPLY_PO_STAGE(0, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(1, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(2, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(3, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(4, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(5, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(6, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(7, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(8, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(9, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(10, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(11, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(12, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(13, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(14, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(15, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(16, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(17, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(18, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(19, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(20, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(21, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(22, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(23, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(24, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(25, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(26, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(27, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(28, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(29, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(30, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); \ )==""\n"
R"==(APPLY_PO_STAGE(31, accumulator, acc_elem_dt, sum_src, sum_elem_dt, x0, \ )==""\n"
R"==(x0_s, x1, x1_s, x1_incr, x2, x2_s, x3, x3_s, x4, x4_s, x5, \ )==""\n"
R"==(x5_s, is_burst); */ \ )==""\n"
R"==(} )==""\n"
R"==(#define APPLY_POST_OPS_TRY_BURST(accumulator, acc_elem_dt, sum_src, \ )==""\n"
R"==(sum_elem_dt, mb_start, mb_size, oc_start, oc_size, oc_serial_incr) \ )==""\n"
R"==(APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \ )==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, oc_serial_incr, 0, 1, 0, 1, \ )==""\n"
R"==(0, 1, 0, 1, true) )==""\n"
R"==(#define APPLY_POST_OPS_SERIAL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \ )==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, d2_start, d2_size, d3_start, \ )==""\n"
R"==(d3_size, d4_start, d4_size, d5_start, d5_size) \ )==""\n"
R"==(APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \ )==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, 0, d2_start, d2_size, \ )==""\n"
R"==(d3_start, d3_size, d4_start, d4_size, d5_start, d5_size, false) )==""\n"
R"==(#define APPLY_POST_OPS_SERIAL_BINARY_2D(accumulator, acc_elem_dt, sum_src, \ )==""\n"
R"==(sum_elem_dt, mb_start, mb_size, oc_start, oc_size) \ )==""\n"
R"==(APPLY_POST_OPS_BL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \ )==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, 0, 0, 1, 0, 1, 0, 1, 0, 1, \ )==""\n"
R"==(false) )==""\n"
R"==(#else )==""\n"
R"==(#define APPLY_POST_OPS_SERIAL(accumulator, acc_elem_dt, sum_src, sum_elem_dt, \ )==""\n"
R"==(mb_start, mb_size, oc_start, oc_size, d2_start, d2_size, d3_start, \ )==""\n"
R"==(d3_size, d4_start, d4_size, d5_start, d5_size) \ )==""\n"
R"==({} )==""\n"
R"==(#define APPLY_POST_OPS_SERIAL_BINARY_2D(accumulator, acc_elem_dt, sum_src, \ )==""\n"
R"==(sum_elem_dt, mb_start, mb_size, oc_start, oc_size) \ )==""\n"
R"==({} )==""\n"
R"==(#define APPLY_POST_OPS_TRY_BURST(accumulator, acc_elem_dt, sum_src, \ )==""\n"
R"==(sum_elem_dt, mb_start, mb_size, oc_start, oc_size, oc_serial_incr) \ )==""\n"
R"==({} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}