namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ocl_types_header = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#ifndef GPU_OCL_OCL_TYPES_H )==""\n"
R"==(#define GPU_OCL_OCL_TYPES_H )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#define unroll_for __attribute__((opencl_unroll_hint)) for )==""\n"
R"==(#define for_ for )==""\n"
R"==(#define CONCAt2(a, b) a##b )==""\n"
R"==(#define CONCAT2(a, b) CONCAt2(a, b) )==""\n"
R"==(#define CONCAT3(a, b, c) CONCAT2(CONCAT2(a, b), c) )==""\n"
R"==(#if defined(DT_F16) || defined(SRC_DT_F16) || defined(SRC0_DT_F16) \ )==""\n"
R"==(|| defined(SRC1_DT_F16) || defined(DST_DT_F16) || defined(WEI_DT_F16) \ )==""\n"
R"==(|| defined(BIA_DT_F16) || defined(ACC_DT_F16) )==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp16 : enable )==""\n"
R"==(#endif )==""\n"
R"==(#if DT_F64 )==""\n"
R"==(#pragma OPENCL EXTENSION cl_khr_fp64 : enable )==""\n"
R"==(#endif )==""\n"
R"==(#if DT_F32 == 1 )==""\n"
R"==(#define DATA_T float )==""\n"
R"==(#define DATA2_T float2 )==""\n"
R"==(#define DATA4_T float4 )==""\n"
R"==(#define DATA8_T float8 )==""\n"
R"==(#define DATA16_T float16 )==""\n"
R"==(#define DATA_MAX FLT_MAX )==""\n"
R"==(#define DATA_MIN -DATA_MAX )==""\n"
R"==(#define DATA_ZERO 0.0f )==""\n"
R"==(#define DATA_ONE 1.0f )==""\n"
R"==(#define DEF_ACC_DATA_T float )==""\n"
R"==(#define DEF_ACC_DATA2_T float2 )==""\n"
R"==(#define DEF_ACC_DATA4_T float4 )==""\n"
R"==(#define DEF_ACC_DATA8_T float8 )==""\n"
R"==(#define POST_OP_DATA_T float )==""\n"
R"==(#define TO_DATA_T(v) (float)(v) )==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_float )==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_float2 )==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_float4 )==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_float8 )==""\n"
R"==(#define DATA_TO_REF convert_float )==""\n"
R"==(#define CONVERT_DATA_T convert_float )==""\n"
R"==(#define CONVERT_DATA2_T convert_float2 )==""\n"
R"==(#define CONVERT_DATA4_T convert_float4 )==""\n"
R"==(#define CONVERT_DATA8_T convert_float8 )==""\n"
R"==(#define CONVERT_FLOAT_T convert_float )==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2 )==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4 )==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8 )==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read )==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write )==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read2 )==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read4 )==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read8 )==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write2 )==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write4 )==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write8 )==""\n"
R"==(#define AS_DATA_T as_float )==""\n"
R"==(#define AS_DATA2_T as_float2 )==""\n"
R"==(#define AS_DATA4_T as_float4 )==""\n"
R"==(#define AS_DATA8_T as_float8 )==""\n"
R"==(#define AS_UINT_T as_uint )==""\n"
R"==(#define AS_UINT2_T as_uint2 )==""\n"
R"==(#define AS_UINT4_T as_uint4 )==""\n"
R"==(#define AS_UINT8_T as_uint8 )==""\n"
R"==(#define BLOCK_DATA_T uint )==""\n"
R"==(#define BLOCK_DATA2_T uint2 )==""\n"
R"==(#define BLOCK_DATA4_T uint4 )==""\n"
R"==(#define BLOCK_DATA8_T uint8 )==""\n"
R"==(#define AS_BLOCK_DATA_T as_uint )==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uint2 )==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uint4 )==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uint8 )==""\n"
R"==(#define MMAD_DATA_T uint )==""\n"
R"==(#define MMAD_DATA4_T uint4 )==""\n"
R"==(#define MMAD_DATA8_T uint8 )==""\n"
R"==(#define MMAD_ACC_DATA4_T float4 )==""\n"
R"==(#define MMAD_ACC_DATA8_T float8 )==""\n"
R"==(#elif DT_F64 == 1 )==""\n"
R"==(#define DATA_T double )==""\n"
R"==(#define DATA2_T double2 )==""\n"
R"==(#define DATA4_T double4 )==""\n"
R"==(#define DATA8_T double8 )==""\n"
R"==(#define DATA16_T double16 )==""\n"
R"==(#define DATA_MAX DBL_MAX )==""\n"
R"==(#define DATA_MIN -DATA_MAX )==""\n"
R"==(#define DATA_ZERO 0.0d )==""\n"
R"==(#define DATA_ONE 1.0d )==""\n"
R"==(#define DEF_ACC_DATA_T double )==""\n"
R"==(#define DEF_ACC_DATA2_T double2 )==""\n"
R"==(#define DEF_ACC_DATA4_T double4 )==""\n"
R"==(#define DEF_ACC_DATA8_T double8 )==""\n"
R"==(#define POST_OP_DATA_T double )==""\n"
R"==(#define TO_DATA_T(v) (double)(v) )==""\n"
R"==(#define TO_DEF_ACC_DATA_T(v) (double)(v) )==""\n"
R"==(#define DATA_TO_REF convert_float )==""\n"
R"==(#define CONVERT_DATA_T convert_double )==""\n"
R"==(#define CONVERT_DATA2_T convert_double2 )==""\n"
R"==(#define CONVERT_DATA4_T convert_double4 )==""\n"
R"==(#define CONVERT_DATA8_T convert_double8 )==""\n"
R"==(#define CONVERT_FLOAT_T convert_float )==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2 )==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4 )==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8 )==""\n"
R"==(#define AS_DATA_T as_double )==""\n"
R"==(#define AS_DATA2_T as_double2 )==""\n"
R"==(#define AS_DATA4_T as_double4 )==""\n"
R"==(#define AS_DATA8_T as_double8 )==""\n"
R"==(#elif DT_F16 == 1 )==""\n"
R"==(#define DATA_T half )==""\n"
R"==(#define DATA2_T half2 )==""\n"
R"==(#define DATA4_T half4 )==""\n"
R"==(#define DATA8_T half8 )==""\n"
R"==(#define DATA16_T half16 )==""\n"
R"==(#define AS_DATA2_T as_half2 )==""\n"
R"==(#define DATA_MAX HALF_MAX )==""\n"
R"==(#define DATA_MIN -DATA_MAX )==""\n"
R"==(#define DATA_ZERO 0.0h )==""\n"
R"==(#define DATA_ONE 1.0h )==""\n"
R"==(#define DEF_ACC_DATA_T float )==""\n"
R"==(#define DEF_ACC_DATA2_T float2 )==""\n"
R"==(#define DEF_ACC_DATA4_T float4 )==""\n"
R"==(#define DEF_ACC_DATA8_T float8 )==""\n"
R"==(#define POST_OP_DATA_T float )==""\n"
R"==(#define TO_DATA_T convert_half )==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_float )==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_float2 )==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_float4 )==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_float8 )==""\n"
R"==(#define DATA_TO_REF convert_half )==""\n"
R"==(#define CONVERT_DATA_T convert_half )==""\n"
R"==(#define CONVERT_DATA2_T convert_half2 )==""\n"
R"==(#define CONVERT_DATA4_T convert_half4 )==""\n"
R"==(#define CONVERT_DATA8_T convert_half8 )==""\n"
R"==(#define CONVERT_FLOAT_T convert_float )==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2 )==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4 )==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8 )==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_us )==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_us )==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_us2 )==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_us4 )==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_us8 )==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_us2 )==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_us4 )==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_us8 )==""\n"
R"==(#define AS_DATA_T as_half )==""\n"
R"==(#define AS_DATA2_T as_half2 )==""\n"
R"==(#define AS_DATA4_T as_half4 )==""\n"
R"==(#define AS_DATA8_T as_half8 )==""\n"
R"==(#define AS_UINT_T as_ushort )==""\n"
R"==(#define AS_UINT2_T as_ushort2 )==""\n"
R"==(#define AS_UINT4_T as_ushort4 )==""\n"
R"==(#define AS_UINT8_T as_ushort8 )==""\n"
R"==(#define BLOCK_DATA_T ushort )==""\n"
R"==(#define BLOCK_DATA2_T ushort2 )==""\n"
R"==(#define BLOCK_DATA4_T ushort4 )==""\n"
R"==(#define BLOCK_DATA8_T ushort8 )==""\n"
R"==(#define AS_BLOCK_DATA_T as_ushort )==""\n"
R"==(#define AS_BLOCK_DATA2_T as_ushort2 )==""\n"
R"==(#define AS_BLOCK_DATA4_T as_ushort4 )==""\n"
R"==(#define AS_BLOCK_DATA8_T as_ushort8 )==""\n"
R"==(#define MMAD_DATA_T uint )==""\n"
R"==(#define MMAD_DATA4_T uint4 )==""\n"
R"==(#define MMAD_DATA8_T uint8 )==""\n"
R"==(#define MMAD_ACC_DATA4_T float4 )==""\n"
R"==(#define MMAD_ACC_DATA8_T float8 )==""\n"
R"==(#elif DT_BF16 == 1 )==""\n"
R"==(#define DATA_T ushort )==""\n"
R"==(#define DATA2_T ushort2 )==""\n"
R"==(#define POST_OP_DATA_T float )==""\n"
R"==(#define DATA2_T ushort2 )==""\n"
R"==(#define DATA4_T ushort4 )==""\n"
R"==(#define DATA8_T ushort8 )==""\n"
R"==(#define DATA16_T ushort16 )==""\n"
R"==(#define DATA_MAX (ushort)0x7F7F )==""\n"
R"==(#define DATA_MIN (ushort)0xFF7F )==""\n"
R"==(#define DATA_ZERO (ushort)0x0000 )==""\n"
R"==(#define DATA_ONE (ushort)0x3F80 )==""\n"
R"==(#define DEF_ACC_DATA_T float )==""\n"
R"==(#define DEF_ACC_DATA2_T float2 )==""\n"
R"==(#define DEF_ACC_DATA4_T float4 )==""\n"
R"==(#define DEF_ACC_DATA8_T float8 )==""\n"
R"==(#define TO_DATA_T cvt_f32_to_bf16 )==""\n"
R"==(#define TO_DEF_ACC_DATA_T cvt_bf16_to_f32 )==""\n"
R"==(#define TO_DEF_ACC_DATA2_T cvt_bf16_to_f32 )==""\n"
R"==(#define TO_DEF_ACC_DATA4_T cvt_bf16_to_f32 )==""\n"
R"==(#define TO_DEF_ACC_DATA8_T cvt_bf16_to_f32 )==""\n"
R"==(#define DATA_TO_REF cvt_bf16_to_f32 )==""\n"
R"==(#define CONVERT_DATA_T(v) cvt_f32_to_bf16(convert_float(v)) )==""\n"
R"==(#define CONVERT_DATA2_T(v) cvt_f32_to_bf16(convert_float2(v)) )==""\n"
R"==(#define CONVERT_DATA4_T(v) cvt_f32_to_bf16(convert_float4(v)) )==""\n"
R"==(#define CONVERT_DATA8_T(v) cvt_f32_to_bf16(convert_float8(v)) )==""\n"
R"==(#define CONVERT_FLOAT_T cvt_bf16_to_f32 )==""\n"
R"==(#define CONVERT_FLOAT2_T cvt_bf16_to_f32 )==""\n"
R"==(#define CONVERT_FLOAT4_T cvt_bf16_to_f32 )==""\n"
R"==(#define CONVERT_FLOAT8_T cvt_bf16_to_f32 )==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_us )==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_us )==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_us2 )==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_us4 )==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_us8 )==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_us2 )==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_us4 )==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_us8 )==""\n"
R"==(#define AS_DATA_T as_ushort )==""\n"
R"==(#define AS_DATA2_T as_ushort2 )==""\n"
R"==(#define AS_DATA4_T as_ushort4 )==""\n"
R"==(#define AS_DATA8_T as_ushort8 )==""\n"
R"==(#define AS_UINT_T as_ushort )==""\n"
R"==(#define AS_UINT2_T as_ushort2 )==""\n"
R"==(#define AS_UINT4_T as_ushort4 )==""\n"
R"==(#define AS_UINT8_T as_ushort8 )==""\n"
R"==(#define BLOCK_DATA_T ushort )==""\n"
R"==(#define BLOCK_DATA2_T ushort2 )==""\n"
R"==(#define BLOCK_DATA4_T ushort4 )==""\n"
R"==(#define BLOCK_DATA8_T ushort8 )==""\n"
R"==(#define AS_BLOCK_DATA_T as_ushort )==""\n"
R"==(#define AS_BLOCK_DATA2_T as_ushort2 )==""\n"
R"==(#define AS_BLOCK_DATA4_T as_ushort4 )==""\n"
R"==(#define AS_BLOCK_DATA8_T as_ushort8 )==""\n"
R"==(#define MMAD_DATA_T uint )==""\n"
R"==(#define MMAD_DATA4_T uint4 )==""\n"
R"==(#define MMAD_DATA8_T uint8 )==""\n"
R"==(#define MMAD_ACC_DATA4_T float4 )==""\n"
R"==(#define MMAD_ACC_DATA8_T float8 )==""\n"
R"==(#elif DT_S8 == 1 )==""\n"
R"==(#define DATA_T char )==""\n"
R"==(#define DATA2_T char2 )==""\n"
R"==(#define DATA4_T char4 )==""\n"
R"==(#define DATA8_T char8 )==""\n"
R"==(#define DATA16_T char16 )==""\n"
R"==(#define DATA_MAX CHAR_MAX )==""\n"
R"==(#define DATA_MIN CHAR_MIN )==""\n"
R"==(#define DATA_ZERO 0 )==""\n"
R"==(#define DATA_ONE 1 )==""\n"
R"==(#define INT8_T int8 )==""\n"
R"==(#define DEF_ACC_DATA_T int )==""\n"
R"==(#define DEF_ACC_DATA2_T int2 )==""\n"
R"==(#define DEF_ACC_DATA4_T int4 )==""\n"
R"==(#define DEF_ACC_DATA8_T int8 )==""\n"
R"==(#define POST_OP_DATA_T float )==""\n"
R"==(#define TO_DATA_T(v) convert_char_sat_rte(v) )==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_int_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_int2_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_int4_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_int8_sat_rte )==""\n"
R"==(#define DATA_TO_REF convert_float )==""\n"
R"==(#define CONVERT_DATA_T convert_char_sat_rte )==""\n"
R"==(#define CONVERT_DATA2_T convert_char2_sat_rte )==""\n"
R"==(#define CONVERT_DATA4_T convert_char4_sat_rte )==""\n"
R"==(#define CONVERT_DATA8_T convert_char8_sat_rte )==""\n"
R"==(#define CONVERT_FLOAT_T convert_float )==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2 )==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4 )==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8 )==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_uc )==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_uc )==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_uc2 )==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_uc4 )==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_uc8 )==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_uc2 )==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_uc4 )==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_uc8 )==""\n"
R"==(#define AS_DATA_T as_char )==""\n"
R"==(#define AS_DATA2_T as_char2 )==""\n"
R"==(#define AS_DATA4_T as_char4 )==""\n"
R"==(#define AS_DATA8_T as_char8 )==""\n"
R"==(#define AS_DATA16_T as_char16 )==""\n"
R"==(#define AS_UINT_T as_uchar )==""\n"
R"==(#define AS_UINT2_T as_uchar2 )==""\n"
R"==(#define AS_UINT4_T as_uchar4 )==""\n"
R"==(#define AS_UINT8_T as_uchar8 )==""\n"
R"==(#define AS_INT8_T as_int8 )==""\n"
R"==(#define BLOCK_DATA_T uchar )==""\n"
R"==(#define BLOCK_DATA2_T uchar2 )==""\n"
R"==(#define BLOCK_DATA4_T uchar4 )==""\n"
R"==(#define BLOCK_DATA8_T uchar8 )==""\n"
R"==(#define AS_BLOCK_DATA_T as_uchar )==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uchar2 )==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uchar4 )==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uchar8 )==""\n"
R"==(#define MMAD_DATA_T int )==""\n"
R"==(#define MMAD_DATA4_T int4 )==""\n"
R"==(#define MMAD_DATA8_T int8 )==""\n"
R"==(#define MMAD_ACC_DATA4_T int4 )==""\n"
R"==(#define MMAD_ACC_DATA8_T int8 )==""\n"
R"==(#elif DT_U8 == 1 )==""\n"
R"==(#define DATA_T uchar )==""\n"
R"==(#define DATA2_T uchar2 )==""\n"
R"==(#define DATA4_T uchar4 )==""\n"
R"==(#define DATA8_T uchar8 )==""\n"
R"==(#define DATA16_T uchar16 )==""\n"
R"==(#define DATA_MAX UCHAR_MAX )==""\n"
R"==(#define DATA_MIN 0 )==""\n"
R"==(#define DATA_ZERO 0 )==""\n"
R"==(#define DATA_ONE 1 )==""\n"
R"==(#define INT8_T uint8 )==""\n"
R"==(#define DEF_ACC_DATA_T int )==""\n"
R"==(#define DEF_ACC_DATA2_T int2 )==""\n"
R"==(#define DEF_ACC_DATA4_T int4 )==""\n"
R"==(#define DEF_ACC_DATA8_T int8 )==""\n"
R"==(#define POST_OP_DATA_T float )==""\n"
R"==(#define TO_DATA_T(v) convert_uchar_sat_rte(v) )==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_int_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_int2_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_int4_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_int8_sat_rte )==""\n"
R"==(#define DATA_TO_REF convert_float )==""\n"
R"==(#define CONVERT_DATA_T convert_uchar_sat_rte )==""\n"
R"==(#define CONVERT_DATA2_T convert_uchar2_sat_rte )==""\n"
R"==(#define CONVERT_DATA4_T convert_uchar4_sat_rte )==""\n"
R"==(#define CONVERT_DATA8_T convert_uchar8_sat_rte )==""\n"
R"==(#define CONVERT_FLOAT_T convert_float )==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2 )==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4 )==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8 )==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read_uc )==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write_uc )==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read_uc2 )==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read_uc4 )==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read_uc8 )==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write_uc2 )==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write_uc4 )==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write_uc8 )==""\n"
R"==(#define AS_DATA_T as_uchar )==""\n"
R"==(#define AS_DATA2_T as_uchar2 )==""\n"
R"==(#define AS_DATA4_T as_uchar4 )==""\n"
R"==(#define AS_DATA8_T as_uchar8 )==""\n"
R"==(#define AS_DATA16_T as_uchar16 )==""\n"
R"==(#define AS_UINT_T as_uchar )==""\n"
R"==(#define AS_UINT2_T as_uchar2 )==""\n"
R"==(#define AS_UINT4_T as_uchar4 )==""\n"
R"==(#define AS_UINT8_T as_uchar8 )==""\n"
R"==(#define AS_INT8_T as_uint8 )==""\n"
R"==(#define BLOCK_DATA_T uchar )==""\n"
R"==(#define BLOCK_DATA2_T uchar2 )==""\n"
R"==(#define BLOCK_DATA4_T uchar4 )==""\n"
R"==(#define BLOCK_DATA8_T uchar8 )==""\n"
R"==(#define AS_BLOCK_DATA_T as_uchar )==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uchar2 )==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uchar4 )==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uchar8 )==""\n"
R"==(#define MMAD_DATA_T uint )==""\n"
R"==(#define MMAD_DATA4_T uint4 )==""\n"
R"==(#define MMAD_DATA8_T uint8 )==""\n"
R"==(#define MMAD_ACC_DATA4_T int4 )==""\n"
R"==(#define MMAD_ACC_DATA8_T int8 )==""\n"
R"==(#elif DT_S32 == 1 )==""\n"
R"==(#define MMAD_DATA_T uint )==""\n"
R"==(#define MMAD_DATA4_T uint4 )==""\n"
R"==(#define MMAD_DATA8_T uint8 )==""\n"
R"==(#define DATA_T int )==""\n"
R"==(#define DATA2_T int2 )==""\n"
R"==(#define DATA4_T int4 )==""\n"
R"==(#define DATA8_T int8 )==""\n"
R"==(#define DATA16_T int16 )==""\n"
R"==(#define DATA_MAX INT_MAX )==""\n"
R"==(#define DATA_MIN INT_MIN )==""\n"
R"==(#define DATA_ZERO 0 )==""\n"
R"==(#define DATA_ONE 1 )==""\n"
R"==(#define DATA_TO_REF convert_float )==""\n"
R"==(#define TO_DATA_T(v) convert_int_sat_rte )==""\n"
R"==(#define TO_DATA8_T(v) convert_int8_sat_rte )==""\n"
R"==(#define CONVERT_DATA_T convert_int_sat_rte )==""\n"
R"==(#define CONVERT_DATA2_T convert_int2_sat_rte )==""\n"
R"==(#define CONVERT_DATA4_T convert_int4_sat_rte )==""\n"
R"==(#define CONVERT_DATA8_T convert_int8_sat_rte )==""\n"
R"==(#define CONVERT_FLOAT_T convert_float )==""\n"
R"==(#define CONVERT_FLOAT2_T convert_float2 )==""\n"
R"==(#define CONVERT_FLOAT4_T convert_float4 )==""\n"
R"==(#define CONVERT_FLOAT8_T convert_float8 )==""\n"
R"==(#define DEF_ACC_DATA_T int )==""\n"
R"==(#define DEF_ACC_DATA2_T int2 )==""\n"
R"==(#define DEF_ACC_DATA4_T int4 )==""\n"
R"==(#define DEF_ACC_DATA8_T int8 )==""\n"
R"==(#define TO_DATA_T(v) convert_int_sat_rte(v) )==""\n"
R"==(#define TO_DEF_ACC_DATA_T convert_int_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA2_T convert_int2_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA4_T convert_int4_sat_rte )==""\n"
R"==(#define TO_DEF_ACC_DATA8_T convert_int8_sat_rte )==""\n"
R"==(#define POST_OP_DATA_T float )==""\n"
R"==(#define DATA_MIN INT_MIN )==""\n"
R"==(#define DATA_MAX INT_MAX )==""\n"
R"==(#define DATA_ZERO 0 )==""\n"
R"==(#define ROUND )==""\n"
R"==(#define BLOCK_READ intel_sub_group_block_read )==""\n"
R"==(#define BLOCK_WRITE intel_sub_group_block_write )==""\n"
R"==(#define BLOCK_READ2 intel_sub_group_block_read2 )==""\n"
R"==(#define BLOCK_READ4 intel_sub_group_block_read4 )==""\n"
R"==(#define BLOCK_READ8 intel_sub_group_block_read8 )==""\n"
R"==(#define BLOCK_WRITE2 intel_sub_group_block_write2 )==""\n"
R"==(#define BLOCK_WRITE4 intel_sub_group_block_write4 )==""\n"
R"==(#define BLOCK_WRITE8 intel_sub_group_block_write8 )==""\n"
R"==(#define AS_DATA_T as_int )==""\n"
R"==(#define AS_DATA2_T as_int2 )==""\n"
R"==(#define AS_DATA4_T as_int4 )==""\n"
R"==(#define AS_DATA8_T as_int8 )==""\n"
R"==(#define AS_UINT_T as_uint )==""\n"
R"==(#define AS_UINT2_T as_uint2 )==""\n"
R"==(#define AS_UINT4_T as_uint4 )==""\n"
R"==(#define AS_UINT8_T as_uint8 )==""\n"
R"==(#define BLOCK_DATA_T uint )==""\n"
R"==(#define BLOCK_DATA2_T uint2 )==""\n"
R"==(#define BLOCK_DATA4_T uint4 )==""\n"
R"==(#define BLOCK_DATA8_T uint8 )==""\n"
R"==(#define AS_BLOCK_DATA_T as_uint )==""\n"
R"==(#define AS_BLOCK_DATA2_T as_uint2 )==""\n"
R"==(#define AS_BLOCK_DATA4_T as_uint4 )==""\n"
R"==(#define AS_BLOCK_DATA8_T as_uint8 )==""\n"
R"==(#elif !defined(DT_UNDEF) )==""\n"
R"==(#error "Unexpected data type" )==""\n"
R"==(#endif )==""\n"
R"==(#if VECT_DT_N == 1 )==""\n"
R"==(#define VECT_DATA_T DATA_T )==""\n"
R"==(#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA_T )==""\n"
R"==(#define AS_VECT_DEF_ACC_DATA_T TO_DEF_ACC_DATA_T )==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA_T )==""\n"
R"==(#define VECT_BLOCK_READ BLOCK_READ )==""\n"
R"==(#define VECT_BLOCK_WRITE BLOCK_WRITE )==""\n"
R"==(#define VECT_UINT_READ intel_sub_group_block_read )==""\n"
R"==(#define VECT_UINT_WRITE intel_sub_group_block_write )==""\n"
R"==(#define VECT_UCHAR_READ intel_sub_group_block_read_uc )==""\n"
R"==(#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc )==""\n"
R"==(#define VECT_BLOCK_DATA_T BLOCK_DATA_T )==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA_T )==""\n"
R"==(#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT_T )==""\n"
R"==(#define CONVERT_VECTOR_DATA_T CONVERT_DATA_T )==""\n"
R"==(#define CONVERT_VECT_CHAR_T convert_char )==""\n"
R"==(#define CONVERT_VECT_INT_T convert_int )==""\n"
R"==(#define VECT_INT_T int )==""\n"
R"==(#define VECT_UINT_T uint )==""\n"
R"==(#define VECT_FLOAT_T float )==""\n"
R"==(#define VECT_CHAR_T char )==""\n"
R"==(#define AS_VECT_INT_T as_int )==""\n"
R"==(#define AS_VECT_UINT_T as_uint )==""\n"
R"==(#define AS_VECT_FLOAT_T as_float )==""\n"
R"==(#define AS_VECT_CHAR_T as_char )==""\n"
R"==(#define AS_VECT_UCHAR_T as_uchar )==""\n"
R"==(#elif VECT_DT_N == 2 )==""\n"
R"==(#define VECT_DATA_T DATA2_T )==""\n"
R"==(#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA2_T )==""\n"
R"==(#define AS_VECT_DEF_ACC_DATA_T TO_DEF_ACC_DATA2_T )==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA2_T )==""\n"
R"==(#define VECT_BLOCK_READ BLOCK_READ2 )==""\n"
R"==(#define VECT_BLOCK_WRITE BLOCK_WRITE2 )==""\n"
R"==(#define VECT_UINT_READ intel_sub_group_block_read2 )==""\n"
R"==(#define VECT_UINT_WRITE intel_sub_group_block_write2 )==""\n"
R"==(#define VECT_UCHAR_READ intel_sub_group_block_read_uc2 )==""\n"
R"==(#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc2 )==""\n"
R"==(#define VECT_BLOCK_DATA_T BLOCK_DATA2_T )==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA2_T )==""\n"
R"==(#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT2_T )==""\n"
R"==(#define CONVERT_VECTOR_DATA_T CONVERT_DATA2_T )==""\n"
R"==(#define CONVERT_VECT_CHAR_T convert_char2 )==""\n"
R"==(#define CONVERT_VECT_INT_T convert_int2 )==""\n"
R"==(#define VECT_INT_T int2 )==""\n"
R"==(#define VECT_UINT_T uint2 )==""\n"
R"==(#define VECT_FLOAT_T float2 )==""\n"
R"==(#define VECT_CHAR_T char2 )==""\n"
R"==(#define AS_VECT_INT_T as_int2 )==""\n"
R"==(#define AS_VECT_UINT_T as_uint2 )==""\n"
R"==(#define AS_VECT_FLOAT_T as_float2 )==""\n"
R"==(#define AS_VECT_CHAR_T as_char2 )==""\n"
R"==(#define AS_VECT_UCHAR_T as_uchar2 )==""\n"
R"==(#elif VECT_DT_N == 4 )==""\n"
R"==(#define VECT_DATA_T DATA4_T )==""\n"
R"==(#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA4_T )==""\n"
R"==(#define AS_VECT_DEF_ACC_DATA_T TO_DEF_ACC_DATA4_T )==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA4_T )==""\n"
R"==(#define VECT_BLOCK_READ BLOCK_READ4 )==""\n"
R"==(#define VECT_BLOCK_WRITE BLOCK_WRITE4 )==""\n"
R"==(#define VECT_UINT_READ intel_sub_group_block_read4 )==""\n"
R"==(#define VECT_UINT_WRITE intel_sub_group_block_write4 )==""\n"
R"==(#define VECT_UCHAR_READ intel_sub_group_block_read_uc4 )==""\n"
R"==(#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc4 )==""\n"
R"==(#define VECT_BLOCK_DATA_T BLOCK_DATA4_T )==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA4_T )==""\n"
R"==(#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT4_T )==""\n"
R"==(#define CONVERT_VECTOR_DATA_T CONVERT_DATA4_T )==""\n"
R"==(#define CONVERT_VECT_CHAR_T convert_char4 )==""\n"
R"==(#define CONVERT_VECT_INT_T convert_int4 )==""\n"
R"==(#define VECT_INT_T int4 )==""\n"
R"==(#define VECT_UINT_T uint4 )==""\n"
R"==(#define VECT_FLOAT_T float4 )==""\n"
R"==(#define VECT_CHAR_T char4 )==""\n"
R"==(#define AS_VECT_INT_T as_int4 )==""\n"
R"==(#define AS_VECT_UINT_T as_uint4 )==""\n"
R"==(#define AS_VECT_FLOAT_T as_float4 )==""\n"
R"==(#define AS_VECT_CHAR_T as_char4 )==""\n"
R"==(#define AS_VECT_UCHAR_T as_uchar4 )==""\n"
R"==(#elif VECT_DT_N == 8 )==""\n"
R"==(#define VECT_DATA_T DATA8_T )==""\n"
R"==(#define VECT_DEF_ACC_DATA_T DEF_ACC_DATA8_T )==""\n"
R"==(#define AS_VECT_DEF_ACC_DATA_T TO_DEF_ACC_DATA8_T )==""\n"
R"==(#define AS_VECT_DATA_T AS_DATA8_T )==""\n"
R"==(#define VECT_BLOCK_READ BLOCK_READ8 )==""\n"
R"==(#define VECT_BLOCK_WRITE BLOCK_WRITE8 )==""\n"
R"==(#define VECT_UINT_READ intel_sub_group_block_read8 )==""\n"
R"==(#define VECT_UINT_WRITE intel_sub_group_block_write8 )==""\n"
R"==(#define VECT_UCHAR_READ intel_sub_group_block_read_uc8 )==""\n"
R"==(#define VECT_UCHAR_WRITE intel_sub_group_block_write_uc8 )==""\n"
R"==(#define VECT_BLOCK_DATA_T BLOCK_DATA8_T )==""\n"
R"==(#define AS_VECT_BLOCK_DATA_T AS_BLOCK_DATA8_T )==""\n"
R"==(#define CONVERT_VECT_FLOAT_T CONVERT_FLOAT8_T )==""\n"
R"==(#define CONVERT_VECTOR_DATA_T CONVERT_DATA8_T )==""\n"
R"==(#define CONVERT_VECT_CHAR_T convert_char8 )==""\n"
R"==(#define CONVERT_VECT_INT_T convert_int8 )==""\n"
R"==(#define VECT_INT_T int8 )==""\n"
R"==(#define VECT_UINT_T uint8 )==""\n"
R"==(#define VECT_FLOAT_T float8 )==""\n"
R"==(#define VECT_CHAR_T char8 )==""\n"
R"==(#define AS_VECT_INT_T as_int8 )==""\n"
R"==(#define AS_VECT_UINT_T as_uint8 )==""\n"
R"==(#define AS_VECT_FLOAT_T as_float8 )==""\n"
R"==(#define AS_VECT_CHAR_T as_char8 )==""\n"
R"==(#define AS_VECT_UCHAR_T as_uchar8 )==""\n"
R"==(#endif )==""\n"
R"==(#define AS_MMAD_DATA_T CONCAT2(as_, MMAD_DATA_T) )==""\n"
R"==(#define AS_MMAD_DATA4_T CONCAT2(as_, MMAD_DATA4_T) )==""\n"
R"==(#define AS_MMAD_DATA8_T CONCAT2(as_, MMAD_DATA8_T) )==""\n"
R"==(#ifdef SRC_DATA_T )==""\n"
R"==(#define SRC_DATA2_T CONCAT2(SRC_DATA_T, 2) )==""\n"
R"==(#define SRC_DATA4_T CONCAT2(SRC_DATA_T, 4) )==""\n"
R"==(#define SRC_DATA8_T CONCAT2(SRC_DATA_T, 8) )==""\n"
R"==(#define SRC_DATA16_T CONCAT2(SRC_DATA_T, 16) )==""\n"
R"==(#ifdef SRC_DT_U8 )==""\n"
R"==(#define SRC_MMAD_DATA_T uint )==""\n"
R"==(#define SRC_MMAD_DATA4_T uint4 )==""\n"
R"==(#define SRC_MMAD_DATA8_T uint8 )==""\n"
R"==(#elif SRC_DT_S8 )==""\n"
R"==(#define SRC_MMAD_DATA_T int )==""\n"
R"==(#define SRC_MMAD_DATA4_T int4 )==""\n"
R"==(#define SRC_MMAD_DATA8_T int8 )==""\n"
R"==(#elif SRC_DT_F16 || SRC_DT_BF16 )==""\n"
R"==(#define SRC_MMAD_DATA_T uint )==""\n"
R"==(#define SRC_MMAD_DATA4_T uint4 )==""\n"
R"==(#define SRC_MMAD_DATA8_T uint8 )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(SRC_DT_U8) || defined(SRC_DT_S8) )==""\n"
R"==(#define SRC_MMAD_ACC_DATA4_T int4 )==""\n"
R"==(#define SRC_MMAD_ACC_DATA8_T int8 )==""\n"
R"==(#else )==""\n"
R"==(#define SRC_MMAD_ACC_DATA4_T float4 )==""\n"
R"==(#define SRC_MMAD_ACC_DATA8_T float8 )==""\n"
R"==(#endif )==""\n"
R"==(#define AS_SRC_DATA2_T CONCAT2(as_, SRC_DATA2_T) )==""\n"
R"==(#define AS_SRC_DATA4_T CONCAT2(as_, SRC_DATA4_T) )==""\n"
R"==(#define AS_SRC_DATA8_T CONCAT2(as_, SRC_DATA8_T) )==""\n"
R"==(#define AS_SRC_DATA16_T CONCAT2(as_, SRC_DATA16_T) )==""\n"
R"==(#define AS_SRC_MMAD_DATA_T CONCAT2(as_, SRC_MMAD_DATA_T) )==""\n"
R"==(#define AS_SRC_MMAD_DATA4_T CONCAT2(as_, SRC_MMAD_DATA4_T) )==""\n"
R"==(#define AS_SRC_MMAD_DATA8_T CONCAT2(as_, SRC_MMAD_DATA8_T) )==""\n"
R"==(#if SRC_DT_BF16 )==""\n"
R"==(#define SRC_TO_REF(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define SRC_TO_REF8(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define REF_TO_SRC(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#else )==""\n"
R"==(#define SRC_TO_REF(x) (x) )==""\n"
R"==(#define SRC_TO_REF8(x) (x) )==""\n"
R"==(#define REF_TO_SRC(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if SRC_DT_BF16 )==""\n"
R"==(#define TO_SRC(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#elif SRC_DT_U8 )==""\n"
R"==(#define TO_SRC(x) convert_uchar_sat_rte(x) )==""\n"
R"==(#elif SRC_DT_S8 )==""\n"
R"==(#define TO_SRC(x) convert_char_sat_rte(x) )==""\n"
R"==(#elif SRC_DT_S32 )==""\n"
R"==(#define TO_SRC(x) convert_int_sat_rte(x) )==""\n"
R"==(#else )==""\n"
R"==(#define TO_SRC(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef A_DATA_T )==""\n"
R"==(#define A_DATA8_T CONCAT2(A_DATA_T, 8) )==""\n"
R"==(#if A_DT_BF16 )==""\n"
R"==(#define A_TO_REF(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define A_TO_REF8(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define REF_TO_A(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#else )==""\n"
R"==(#define A_TO_REF(x) (x) )==""\n"
R"==(#define A_TO_REF8(x) (x) )==""\n"
R"==(#define REF_TO_A(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if A_DT_BF16 )==""\n"
R"==(#define TO_A(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#elif A_DT_U8 )==""\n"
R"==(#define TO_A(x) convert_uchar_sat_rte(x) )==""\n"
R"==(#elif A_DT_S8 )==""\n"
R"==(#define TO_A(x) convert_char_sat_rte(x) )==""\n"
R"==(#elif A_DT_S32 )==""\n"
R"==(#define TO_A(x) convert_int_sat_rte(x) )==""\n"
R"==(#else )==""\n"
R"==(#define TO_A(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef WEI_DATA_T )==""\n"
R"==(#if WEI_DT_BF16 )==""\n"
R"==(#define WEI_TO_REF(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define REF_TO_WEI(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#else )==""\n"
R"==(#define WEI_TO_REF(x) (x) )==""\n"
R"==(#define REF_TO_WEI(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if WEI_DT_BF16 )==""\n"
R"==(#define TO_WEI(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#elif WEI_DT_U8 )==""\n"
R"==(#define TO_WEI(x) convert_uchar_sat_rte(x) )==""\n"
R"==(#elif WEI_DT_S8 )==""\n"
R"==(#define TO_WEI(x) convert_char_sat_rte(x) )==""\n"
R"==(#elif WEI_DT_S32 )==""\n"
R"==(#define TO_WEI(x) convert_int_sat_rte(x) )==""\n"
R"==(#else )==""\n"
R"==(#define TO_WEI(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef DIFF_WEI_DATA_T )==""\n"
R"==(#if DIFF_WEI_DT_BF16 )==""\n"
R"==(#define DIFF_WEI_TO_REF(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define REF_TO_DIFF_WEI(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#else )==""\n"
R"==(#define DIFF_WEI_TO_REF(x) (x) )==""\n"
R"==(#define REF_TO_DIFF_WEI(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if DIFF_WEI_DT_BF16 )==""\n"
R"==(#define TO_DIFF_WEI(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#elif DIFF_WEI_DT_U8 )==""\n"
R"==(#define TO_DIFF_WEI(x) convert_uchar_sat_rte(x) )==""\n"
R"==(#elif DIFF_WEI_DT_S8 )==""\n"
R"==(#define TO_DIFF_WEI(x) convert_char_sat_rte(x) )==""\n"
R"==(#elif DIFF_WEI_DT_S32 )==""\n"
R"==(#define TO_DIFF_WEI(x) convert_int_sat_rte(x) )==""\n"
R"==(#else )==""\n"
R"==(#define TO_DIFF_WEI(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef B_DATA_T )==""\n"
R"==(#if B_DT_BF16 )==""\n"
R"==(#define B_TO_REF(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define REF_TO_B(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#else )==""\n"
R"==(#define B_TO_REF(x) (x) )==""\n"
R"==(#define REF_TO_B(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if B_DT_BF16 )==""\n"
R"==(#define TO_B(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#elif B_DT_U8 )==""\n"
R"==(#define TO_B(x) convert_uchar_sat_rte(x) )==""\n"
R"==(#elif B_DT_S8 )==""\n"
R"==(#define TO_B(x) convert_char_sat_rte(x) )==""\n"
R"==(#elif B_DT_S32 )==""\n"
R"==(#define TO_B(x) convert_int_sat_rte(x) )==""\n"
R"==(#else )==""\n"
R"==(#define TO_B(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef BIA_DATA_T )==""\n"
R"==(#define BIA_DATA2_T CONCAT2(BIA_DATA_T, 2) )==""\n"
R"==(#if BIA_DT_BF16 )==""\n"
R"==(#define BIA_TO_REF(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define REF_TO_BIA(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#else )==""\n"
R"==(#define BIA_TO_REF(x) (x) )==""\n"
R"==(#define REF_TO_BIA(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if BIA_DT_BF16 )==""\n"
R"==(#define TO_BIA(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#elif BIA_DT_U8 )==""\n"
R"==(#define TO_BIA(x) convert_uchar_sat_rte(x) )==""\n"
R"==(#elif BIA_DT_S8 )==""\n"
R"==(#define TO_BIA(x) convert_char_sat_rte(x) )==""\n"
R"==(#elif BIA_DT_S32 )==""\n"
R"==(#define TO_BIA(x) convert_int_sat_rte(x) )==""\n"
R"==(#else )==""\n"
R"==(#define TO_BIA(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef DST_DATA_T )==""\n"
R"==(#define DST_DATA2_T CONCAT2(DST_DATA_T, 2) )==""\n"
R"==(#define DST_DATA4_T CONCAT2(DST_DATA_T, 4) )==""\n"
R"==(#define DST_DATA8_T CONCAT2(DST_DATA_T, 8) )==""\n"
R"==(#define DST_DATA16_T CONCAT2(DST_DATA_T, 16) )==""\n"
R"==(#define AS_DST_DATA_T CONCAT2(as_, DST_DATA_T) )==""\n"
R"==(#define AS_DST_DATA2_T CONCAT2(as_, DST_DATA2_T) )==""\n"
R"==(#define AS_DST_DATA4_T CONCAT2(as_, DST_DATA4_T) )==""\n"
R"==(#define AS_DST_DATA8_T CONCAT2(as_, DST_DATA8_T) )==""\n"
R"==(#define AS_DST_DATA16_T CONCAT2(as_, DST_DATA16_T) )==""\n"
R"==(#if DST_DT_F32 || DST_DT_F16 )==""\n"
R"==(#define CONVERT_DST_DATA_T CONCAT2(convert_, DST_DATA_T) )==""\n"
R"==(#define CONVERT_DST_DATA2_T CONCAT2(convert_, DST_DATA2_T) )==""\n"
R"==(#define CONVERT_DST_DATA4_T CONCAT2(convert_, DST_DATA4_T) )==""\n"
R"==(#define CONVERT_DST_DATA8_T CONCAT2(convert_, DST_DATA8_T) )==""\n"
R"==(#define CONVERT_DST_DATA16_T CONCAT2(convert_, DST_DATA16_T) )==""\n"
R"==(#else )==""\n"
R"==(#define CONVERT_DST_DATA_T CONCAT3(convert_, DST_DATA_T, _sat_rte) )==""\n"
R"==(#define CONVERT_DST_DATA2_T CONCAT3(convert_, DST_DATA2_T, _sat_rte) )==""\n"
R"==(#define CONVERT_DST_DATA4_T CONCAT3(convert_, DST_DATA4_T, _sat_rte) )==""\n"
R"==(#define CONVERT_DST_DATA8_T CONCAT3(convert_, DST_DATA8_T, _sat_rte) )==""\n"
R"==(#define CONVERT_DST_DATA16_T CONCAT3(convert_, DST_DATA16_T, _sat_rte) )==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_U8 )==""\n"
R"==(#define MMAD_DATA_T uint )==""\n"
R"==(#define MMAD_DATA4_T uint4 )==""\n"
R"==(#define MMAD_DATA8_T uint8 )==""\n"
R"==(#elif DST_DT_S8 )==""\n"
R"==(#define MMAD_DATA_T int )==""\n"
R"==(#define MMAD_DATA4_T int4 )==""\n"
R"==(#define MMAD_DATA8_T int8 )==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_U8 || DST_DT_S8 )==""\n"
R"==(#define BLOCK_READ_DST2(ptr) \ )==""\n"
R"==(AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v)) )==""\n"
R"==(#define BLOCK_READ_DST(ptr) \ )==""\n"
R"==(AS_DST_DATA_T(intel_sub_group_block_read_uc((__global uchar *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_uc((__global uchar *)ptr, as_uchar(v)) )==""\n"
R"==(#define BLOCK_READ_DST2(ptr) \ )==""\n"
R"==(AS_DST_DATA2_T(intel_sub_group_block_read_uc2((__global uchar *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_uc2((__global uchar *)ptr, as_uchar2(v)) )==""\n"
R"==(#define BLOCK_READ_DST4(ptr) \ )==""\n"
R"==(AS_DST_DATA4_T(intel_sub_group_block_read_uc4((__global uchar *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST4(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_uc4((__global uchar *)ptr, as_uchar4(v)) )==""\n"
R"==(#define BLOCK_READ_DST8(ptr) \ )==""\n"
R"==(AS_DST_DATA8_T(intel_sub_group_block_read_uc8((__global uchar *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST8(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_uc8((__global uchar *)ptr, as_uchar8(v)) )==""\n"
R"==(#define BLOCK_READ_DST16(ptr) \ )==""\n"
R"==(AS_DST_DATA16_T(intel_sub_group_block_read_uc16((__global uchar *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST16(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_uc16((__global uchar *)ptr, as_uchar16(v)) )==""\n"
R"==(#elif DST_DT_F16 || DST_DT_BF16 )==""\n"
R"==(#define BLOCK_READ_DST(ptr) \ )==""\n"
R"==(AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v)) )==""\n"
R"==(#define BLOCK_READ_DST2(ptr) \ )==""\n"
R"==(AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_us2((__global ushort *)ptr, as_ushort2(v)) )==""\n"
R"==(#define BLOCK_READ_DST4(ptr) \ )==""\n"
R"==(AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST4(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v)) )==""\n"
R"==(#define BLOCK_READ_DST8(ptr) \ )==""\n"
R"==(AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST8(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v)) )==""\n"
R"==(#define BLOCK_READ_DST16(ptr) \ )==""\n"
R"==((DST_DATA16_T)( \ )==""\n"
R"==(BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE)) )==""\n"
R"==(#define BLOCK_WRITE_DST16(ptr, v) \ )==""\n"
R"==(do { \ )==""\n"
R"==(BLOCK_WRITE_DST8(ptr, (v).s01234567); \ )==""\n"
R"==(BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#elif DST_DT_S32 || DST_DT_F32 )==""\n"
R"==(#define BLOCK_READ_DST(ptr) \ )==""\n"
R"==(AS_DST_DATA_T(intel_sub_group_block_read((__global uint *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write((__global uint *)ptr, as_uint(v)) )==""\n"
R"==(#define BLOCK_READ_DST2(ptr) \ )==""\n"
R"==(AS_DST_DATA2_T(intel_sub_group_block_read2((__global uint *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write2((__global uint *)ptr, as_uint2(v)) )==""\n"
R"==(#define BLOCK_READ_DST4(ptr) \ )==""\n"
R"==(AS_DST_DATA4_T(intel_sub_group_block_read4((__global uint *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST4(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write4((__global uint *)ptr, as_uint4(v)) )==""\n"
R"==(#define BLOCK_READ_DST8(ptr) \ )==""\n"
R"==(AS_DST_DATA8_T(intel_sub_group_block_read8((__global uint *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST8(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write8((__global uint *)ptr, as_uint8(v)) )==""\n"
R"==(#define BLOCK_READ_DST16(ptr) \ )==""\n"
R"==((DST_DATA16_T)( \ )==""\n"
R"==(BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE)) )==""\n"
R"==(#define BLOCK_WRITE_DST16(ptr, v) \ )==""\n"
R"==(do { \ )==""\n"
R"==(BLOCK_WRITE_DST8(ptr, (v).s01234567); \ )==""\n"
R"==(BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#elif DST_DT_F16 || DST_DT_BF16 )==""\n"
R"==(#define BLOCK_READ_DST(ptr) \ )==""\n"
R"==(AS_DST_DATA_T(intel_sub_group_block_read_us((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_us((__global ushort *)ptr, as_ushort(v)) )==""\n"
R"==(#define BLOCK_READ_DST2(ptr) \ )==""\n"
R"==(AS_DST_DATA2_T(intel_sub_group_block_read_us2((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST2(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_us2((__global ushort *)ptr, as_short2(v)) )==""\n"
R"==(#define BLOCK_READ_DST4(ptr) \ )==""\n"
R"==(AS_DST_DATA4_T(intel_sub_group_block_read_us4((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST4(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_us4((__global ushort *)ptr, as_ushort4(v)) )==""\n"
R"==(#define BLOCK_READ_DST8(ptr) \ )==""\n"
R"==(AS_DST_DATA8_T(intel_sub_group_block_read_us8((__global ushort *)ptr)) )==""\n"
R"==(#define BLOCK_WRITE_DST8(ptr, v) \ )==""\n"
R"==(intel_sub_group_block_write_us8((__global ushort *)ptr, as_ushort8(v)) )==""\n"
R"==(#define BLOCK_READ_DST16(ptr) \ )==""\n"
R"==((DST_DATA16_T)( \ )==""\n"
R"==(BLOCK_READ_DST8(ptr), BLOCK_READ_DST8(ptr + 8 * SUB_GROUP_SIZE)) )==""\n"
R"==(#define BLOCK_WRITE_DST16(ptr, v) \ )==""\n"
R"==(do { \ )==""\n"
R"==(BLOCK_WRITE_DST8(ptr, (v).s01234567); \ )==""\n"
R"==(BLOCK_WRITE_DST8(ptr + 8 * SUB_GROUP_SIZE, (v).s89abcdef); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_BF16 )==""\n"
R"==(#define DST_TO_REF(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define DST_TO_REF2(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define DST_TO_REF8(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define REF_TO_DST(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#define REF_TO_DST8(x) cvt_f32_to_bf16(convert_float8(x)) )==""\n"
R"==(#elif DST_DT_F16 )==""\n"
R"==(#define REF_TO_DST(x) convert_half(x) )==""\n"
R"==(#define DST_TO_REF(x) convert_float(x) )==""\n"
R"==(#define DST_TO_REF2(x) convert_float2(x) )==""\n"
R"==(#define DST_TO_REF8(x) convert_float8(x) )==""\n"
R"==(#elif DST_DT_U8 )==""\n"
R"==(#define DST_TO_REF(x) (x) )==""\n"
R"==(#define DST_TO_REF2(x) (x) )==""\n"
R"==(#define DST_TO_REF8(x) (x) )==""\n"
R"==(#define REF_TO_DST(x) convert_uchar(x) )==""\n"
R"==(#define REF_TO_DST8(x) convert_uchar8(x) )==""\n"
R"==(#elif DST_DT_S8 )==""\n"
R"==(#define DST_TO_REF(x) (x) )==""\n"
R"==(#define DST_TO_REF2(x) (x) )==""\n"
R"==(#define DST_TO_REF8(x) (x) )==""\n"
R"==(#define REF_TO_DST(x) convert_char(x) )==""\n"
R"==(#define REF_TO_DST8(x) convert_char8(x) )==""\n"
R"==(#else )==""\n"
R"==(#define DST_TO_REF(x) (x) )==""\n"
R"==(#define DST_TO_REF2(x) (x) )==""\n"
R"==(#define DST_TO_REF8(x) (x) )==""\n"
R"==(#define REF_TO_DST(x) (x) )==""\n"
R"==(#define REF_TO_DST8(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_BF16 )==""\n"
R"==(#define TO_DST(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#define TO_DST2(x) cvt_f32_to_bf16(convert_float2(x)) )==""\n"
R"==(#define TO_DST4(x) cvt_f32_to_bf16(convert_float4(x)) )==""\n"
R"==(#define TO_DST8(x) cvt_f32_to_bf16(convert_float8(x)) )==""\n"
R"==(#elif DST_DT_F16 )==""\n"
R"==(#define TO_DST(x) convert_half(x) )==""\n"
R"==(#define TO_DST2(x) convert_half2(x) )==""\n"
R"==(#define TO_DST4(x) convert_half4(x) )==""\n"
R"==(#define TO_DST8(x) convert_half8(x) )==""\n"
R"==(#elif DST_DT_U8 )==""\n"
R"==(#define TO_DST(x) convert_uchar_sat_rte(x) )==""\n"
R"==(#define TO_DST2(x) convert_uchar2_sat_rte(x) )==""\n"
R"==(#define TO_DST4(x) convert_uchar4_sat_rte(x) )==""\n"
R"==(#define TO_DST8(x) convert_uchar8_sat_rte(x) )==""\n"
R"==(#define TO_DST16(x) convert_uchar16_sat_rte(x) )==""\n"
R"==(#elif DST_DT_S8 )==""\n"
R"==(#define TO_DST(x) convert_char_sat_rte(x) )==""\n"
R"==(#define TO_DST2(x) convert_char2_sat_rte(x) )==""\n"
R"==(#define TO_DST4(x) convert_char4_sat_rte(x) )==""\n"
R"==(#define TO_DST8(x) convert_char8_sat_rte(x) )==""\n"
R"==(#define TO_DST16(x) convert_char16_sat_rte(x) )==""\n"
R"==(#elif DST_DT_S32 )==""\n"
R"==(#define TO_DST(x) convert_int_sat_rte(x) )==""\n"
R"==(#define TO_DST2(x) convert_int2_sat_rte(x) )==""\n"
R"==(#define TO_DST4(x) convert_int4_sat_rte(x) )==""\n"
R"==(#define TO_DST8(x) convert_int8_sat_rte(x) )==""\n"
R"==(#elif DST_DT_F32 )==""\n"
R"==(#define TO_DST(x) convert_float(x) )==""\n"
R"==(#define TO_DST2(x) convert_float2(x) )==""\n"
R"==(#define TO_DST4(x) convert_float4(x) )==""\n"
R"==(#define TO_DST8(x) convert_float8(x) )==""\n"
R"==(#elif DST_DT_F64 )==""\n"
R"==(#define TO_DST(x) convert_double(x) )==""\n"
R"==(#define TO_DST2(x) convert_double2(x) )==""\n"
R"==(#define TO_DST4(x) convert_double4(x) )==""\n"
R"==(#define TO_DST8(x) convert_double8(x) )==""\n"
R"==(#else )==""\n"
R"==(#error "Not expected" )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef C_DATA_T )==""\n"
R"==(#define C_DATA8_T CONCAT2(C_DATA_T, 8) )==""\n"
R"==(#if C_DT_BF16 )==""\n"
R"==(#define C_TO_REF(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define C_TO_REF8(x) cvt_bf16_to_f32(x) )==""\n"
R"==(#define REF_TO_C(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#define REF_TO_C8(x) cvt_f32_to_bf16(convert_float8(x)) )==""\n"
R"==(#else )==""\n"
R"==(#define C_TO_REF(x) (x) )==""\n"
R"==(#define C_TO_REF8(x) (x) )==""\n"
R"==(#define REF_TO_C(x) (x) )==""\n"
R"==(#define REF_TO_C8(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if C_DT_BF16 )==""\n"
R"==(#define TO_C(x) cvt_f32_to_bf16(x) )==""\n"
R"==(#define TO_C8(x) cvt_f32_to_bf16(convert_float8(x)) )==""\n"
R"==(#elif C_DT_F16 )==""\n"
R"==(#define TO_C(x) convert_half(x) )==""\n"
R"==(#define TO_C8(x) convert_half8(x) )==""\n"
R"==(#elif C_DT_U8 )==""\n"
R"==(#define TO_C(x) convert_uchar_sat_rte(x) )==""\n"
R"==(#define TO_C8(x) convert_uchar8_sat_rte(x) )==""\n"
R"==(#elif C_DT_S8 )==""\n"
R"==(#define TO_C(x) convert_char_sat_rte(x) )==""\n"
R"==(#define TO_C8(x) convert_char8_sat_rte(x) )==""\n"
R"==(#elif C_DT_S32 )==""\n"
R"==(#define TO_C(x) convert_int_sat_rte(x) )==""\n"
R"==(#define TO_C8(x) convert_int8_sat_rte(x) )==""\n"
R"==(#elif C_DT_F32 )==""\n"
R"==(#define TO_C(x) convert_float(x) )==""\n"
R"==(#define TO_C8(x) convert_float8(x) )==""\n"
R"==(#elif C_DT_F64 )==""\n"
R"==(#define TO_C(x) convert_double(x) )==""\n"
R"==(#define TO_C8(x) convert_double8(x) )==""\n"
R"==(#else )==""\n"
R"==(#error "Not expected" )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef ACC_DATA_T )==""\n"
R"==(#if ACC_DT_F16 )==""\n"
R"==(#define TO_ACC(x) convert_half(x) )==""\n"
R"==(#elif ACC_DT_F32 )==""\n"
R"==(#define TO_ACC(x) convert_float(x) )==""\n"
R"==(#elif ACC_DT_F64 )==""\n"
R"==(#define TO_ACC(x) convert_double(x) )==""\n"
R"==(#elif ACC_DT_S32 )==""\n"
R"==(#define TO_ACC(x) convert_int(x) )==""\n"
R"==(#else )==""\n"
R"==(#error "Unexpected accumulation data type" )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef SUM_DATA_T )==""\n"
R"==(#define SUM_DATA2_T CONCAT2(SUM_DATA_T, 2) )==""\n"
R"==(#define SUM_DATA4_T CONCAT2(SUM_DATA_T, 4) )==""\n"
R"==(#define SUM_DATA8_T CONCAT2(SUM_DATA_T, 8) )==""\n"
R"==(#define SUM_DATA16_T CONCAT2(SUM_DATA_T, 16) )==""\n"
R"==(#define AS_SUM_DATA_T CONCAT2(as_, SUM_DATA_T) )==""\n"
R"==(#define AS_SUM_DATA2_T CONCAT2(as_, SUM_DATA2_T) )==""\n"
R"==(#define AS_SUM_DATA4_T CONCAT2(as_, SUM_DATA4_T) )==""\n"
R"==(#define AS_SUM_DATA8_T CONCAT2(as_, SUM_DATA8_T) )==""\n"
R"==(#define AS_SUM_DATA16_T CONCAT2(as_, SUM_DATA16_T) )==""\n"
R"==(#if SUM_DT_BF16 )==""\n"
R"==(#define SUM_TO_REF cvt_bf16_to_f32 )==""\n"
R"==(#else )==""\n"
R"==(#define SUM_TO_REF )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#define OFF_MD_2(prefix, x0, x1, x2, x3, x4, x5) \ )==""\n"
R"==(((((x0) / CONCAT2(prefix, _B0_2)) / CONCAT2(prefix, _B0_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S0_0)) \ )==""\n"
R"==(+ (((x0) / CONCAT2(prefix, _B0_2)) % CONCAT2(prefix, _B0_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S0_1)) \ )==""\n"
R"==(+ (((x0) % CONCAT2(prefix, _B0_2)) * CONCAT2(prefix, _S0_2)) \ )==""\n"
R"==(+ (((x1) / CONCAT2(prefix, _B1_2)) / CONCAT2(prefix, _B1_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S1_0)) \ )==""\n"
R"==(+ (((x1) / CONCAT2(prefix, _B1_2)) % CONCAT2(prefix, _B1_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S1_1)) \ )==""\n"
R"==(+ (((x1) % CONCAT2(prefix, _B1_2)) * CONCAT2(prefix, _S1_2)) \ )==""\n"
R"==(+ (((x2) / CONCAT2(prefix, _B2_2)) / CONCAT2(prefix, _B2_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S2_0)) \ )==""\n"
R"==(+ (((x2) / CONCAT2(prefix, _B2_2)) % CONCAT2(prefix, _B2_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S2_1)) \ )==""\n"
R"==(+ (((x2) % CONCAT2(prefix, _B2_2)) * CONCAT2(prefix, _S2_2)) \ )==""\n"
R"==(+ (((x3) / CONCAT2(prefix, _B3_2)) / CONCAT2(prefix, _B3_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S3_0)) \ )==""\n"
R"==(+ (((x3) / CONCAT2(prefix, _B3_2)) % CONCAT2(prefix, _B3_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S3_1)) \ )==""\n"
R"==(+ (((x3) % CONCAT2(prefix, _B3_2)) * CONCAT2(prefix, _S3_2)) \ )==""\n"
R"==(+ (((x4) / CONCAT2(prefix, _B4_2)) / CONCAT2(prefix, _B4_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S4_0)) \ )==""\n"
R"==(+ (((x4) / CONCAT2(prefix, _B4_2)) % CONCAT2(prefix, _B4_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S4_1)) \ )==""\n"
R"==(+ (((x4) % CONCAT2(prefix, _B4_2)) * CONCAT2(prefix, _S4_2)) \ )==""\n"
R"==(+ (((x5) / CONCAT2(prefix, _B5_2)) / CONCAT2(prefix, _B5_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S5_0)) \ )==""\n"
R"==(+ (((x5) / CONCAT2(prefix, _B5_2)) % CONCAT2(prefix, _B5_1) \ )==""\n"
R"==(* CONCAT2(prefix, _S5_1)) \ )==""\n"
R"==(+ (((x5) % CONCAT2(prefix, _B5_2)) * CONCAT2(prefix, _S5_2))) )==""\n"
R"==(#define OFF_MD_3(prefix, x0, x1, x2, x3, x4, x5) \ )==""\n"
R"==(((((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \ )==""\n"
R"==(/ CONCAT2(prefix, _B0_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S0_0)) \ )==""\n"
R"==(+ (((((x0) / CONCAT2(prefix, _B0_3)) / CONCAT2(prefix, _B0_2)) \ )==""\n"
R"==(% CONCAT2(prefix, _B0_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S0_1)) \ )==""\n"
R"==(+ ((((x0) / CONCAT2(prefix, _B0_3)) % CONCAT2(prefix, _B0_2)) \ )==""\n"
R"==(* CONCAT2(prefix, _S0_2)) \ )==""\n"
R"==(+ (((x0) % CONCAT2(prefix, _B0_3)) * CONCAT2(prefix, _S0_3)) \ )==""\n"
R"==(+ (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \ )==""\n"
R"==(/ CONCAT2(prefix, _B1_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S1_0)) \ )==""\n"
R"==(+ (((((x1) / CONCAT2(prefix, _B1_3)) / CONCAT2(prefix, _B1_2)) \ )==""\n"
R"==(% CONCAT2(prefix, _B1_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S1_1)) \ )==""\n"
R"==(+ ((((x1) / CONCAT2(prefix, _B1_3)) % CONCAT2(prefix, _B1_2)) \ )==""\n"
R"==(* CONCAT2(prefix, _S1_2)) \ )==""\n"
R"==(+ (((x1) % CONCAT2(prefix, _B1_3)) * CONCAT2(prefix, _S1_3)) \ )==""\n"
R"==(+ (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \ )==""\n"
R"==(/ CONCAT2(prefix, _B2_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S2_0)) \ )==""\n"
R"==(+ (((((x2) / CONCAT2(prefix, _B2_3)) / CONCAT2(prefix, _B2_2)) \ )==""\n"
R"==(% CONCAT2(prefix, _B2_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S2_1)) \ )==""\n"
R"==(+ ((((x2) / CONCAT2(prefix, _B2_3)) % CONCAT2(prefix, _B2_2)) \ )==""\n"
R"==(* CONCAT2(prefix, _S2_2)) \ )==""\n"
R"==(+ (((x2) % CONCAT2(prefix, _B2_3)) * CONCAT2(prefix, _S2_3)) \ )==""\n"
R"==(+ (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \ )==""\n"
R"==(/ CONCAT2(prefix, _B3_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S3_0)) \ )==""\n"
R"==(+ (((((x3) / CONCAT2(prefix, _B3_3)) / CONCAT2(prefix, _B3_2)) \ )==""\n"
R"==(% CONCAT2(prefix, _B3_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S3_1)) \ )==""\n"
R"==(+ ((((x3) / CONCAT2(prefix, _B3_3)) % CONCAT2(prefix, _B3_2)) \ )==""\n"
R"==(* CONCAT2(prefix, _S3_2)) \ )==""\n"
R"==(+ (((x3) % CONCAT2(prefix, _B3_3)) * CONCAT2(prefix, _S3_3)) \ )==""\n"
R"==(+ (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \ )==""\n"
R"==(/ CONCAT2(prefix, _B4_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S4_0)) \ )==""\n"
R"==(+ (((((x4) / CONCAT2(prefix, _B4_3)) / CONCAT2(prefix, _B4_2)) \ )==""\n"
R"==(% CONCAT2(prefix, _B4_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S4_1)) \ )==""\n"
R"==(+ ((((x4) / CONCAT2(prefix, _B4_3)) % CONCAT2(prefix, _B4_2)) \ )==""\n"
R"==(* CONCAT2(prefix, _S4_2)) \ )==""\n"
R"==(+ (((x4) % CONCAT2(prefix, _B4_3)) * CONCAT2(prefix, _S4_3)) \ )==""\n"
R"==(+ (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \ )==""\n"
R"==(/ CONCAT2(prefix, _B5_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S5_0)) \ )==""\n"
R"==(+ (((((x5) / CONCAT2(prefix, _B5_3)) / CONCAT2(prefix, _B5_2)) \ )==""\n"
R"==(% CONCAT2(prefix, _B5_1)) \ )==""\n"
R"==(* CONCAT2(prefix, _S5_1)) \ )==""\n"
R"==(+ ((((x5) / CONCAT2(prefix, _B5_3)) % CONCAT2(prefix, _B5_2)) \ )==""\n"
R"==(* CONCAT2(prefix, _S5_2)) \ )==""\n"
R"==(+ (((x5) % CONCAT2(prefix, _B5_3)) * CONCAT2(prefix, _S5_3))) )==""\n"
R"==(#define OFF_MD(prefix, x0, x1, x2, x3, x4, x5) \ )==""\n"
R"==(CONCAT2(OFF_MD_, CONCAT2(prefix, _NLEVELS))(prefix, x0, x1, x2, x3, x4, x5) )==""\n"
R"==(#if SRC_NDIMS == 3 )==""\n"
R"==(#define CONV_SRC_OFF(n, c, d, h, w) OFF_MD(SRC, n, c, w, 0, 0, 0) )==""\n"
R"==(#elif SRC_NDIMS == 4 )==""\n"
R"==(#define CONV_SRC_OFF(n, c, d, h, w) OFF_MD(SRC, n, c, h, w, 0, 0) )==""\n"
R"==(#elif SRC_NDIMS == 5 )==""\n"
R"==(#define CONV_SRC_OFF(n, c, d, h, w) OFF_MD(SRC, n, c, d, h, w, 0) )==""\n"
R"==(#endif )==""\n"
R"==(#if WEI_NDIMS == 3 )==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, o, i, w, 0, 0, 0) )==""\n"
R"==(#elif WEI_NDIMS == 4 )==""\n"
R"==(#if WITH_GROUPS == 0 )==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, o, i, h, w, 0, 0) )==""\n"
R"==(#else )==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, g, o, i, w, 0, 0) )==""\n"
R"==(#endif )==""\n"
R"==(#elif WEI_NDIMS == 5 )==""\n"
R"==(#if WITH_GROUPS == 0 )==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, o, i, d, h, w, 0) )==""\n"
R"==(#else )==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, g, o, i, h, w, 0) )==""\n"
R"==(#endif )==""\n"
R"==(#elif WEI_NDIMS == 6 )==""\n"
R"==(#define CONV_WEI_OFF(g, o, i, d, h, w) OFF_MD(WEI, g, o, i, d, h, w) )==""\n"
R"==(#endif )==""\n"
R"==(#if DST_NDIMS == 3 )==""\n"
R"==(#define CONV_DST_OFF(n, c, d, h, w) OFF_MD(DST, n, c, w, 0, 0, 0) )==""\n"
R"==(#elif DST_NDIMS == 4 )==""\n"
R"==(#define CONV_DST_OFF(n, c, d, h, w) OFF_MD(DST, n, c, h, w, 0, 0) )==""\n"
R"==(#elif DST_NDIMS == 5 )==""\n"
R"==(#define CONV_DST_OFF(n, c, d, h, w) OFF_MD(DST, n, c, d, h, w, 0) )==""\n"
R"==(#endif )==""\n"
R"==(#if NDIMS == 2 )==""\n"
R"==(#define SRC_OFF(x0, x1, d, h, w) \ )==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \ )==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1) )==""\n"
R"==(#if WITH_GROUPS == 1 )==""\n"
R"==(#define WEI_OFF(x0, x1, x2, d, h, w) \ )==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \ )==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \ )==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2) )==""\n"
R"==(#else )==""\n"
R"==(#define WEI_OFF(g, x0, x1, d, h, w) \ )==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \ )==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1) )==""\n"
R"==(#endif )==""\n"
R"==(#define DST_OFF(x0, x1, d, h, w) \ )==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \ )==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1) )==""\n"
R"==(#elif NDIMS == 3 )==""\n"
R"==(#define SRC_OFF(x0, x1, d, h, x2) \ )==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \ )==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \ )==""\n"
R"==(+ ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2) )==""\n"
R"==(#if WITH_GROUPS == 1 )==""\n"
R"==(#define WEI_OFF(x0, x1, x2, d, h, x3) \ )==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \ )==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \ )==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \ )==""\n"
R"==(+ ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3) )==""\n"
R"==(#else )==""\n"
R"==(#define WEI_OFF(g, x0, x1, d, h, x2) \ )==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \ )==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \ )==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2) )==""\n"
R"==(#endif )==""\n"
R"==(#define DST_OFF(x0, x1, d, h, x2) \ )==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \ )==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \ )==""\n"
R"==(+ ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2) )==""\n"
R"==(#elif NDIMS == 4 )==""\n"
R"==(#define SRC_OFF(x0, x1, d, x2, x3) \ )==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \ )==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \ )==""\n"
R"==(+ ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \ )==""\n"
R"==(+ ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3) )==""\n"
R"==(#if WITH_GROUPS == 1 )==""\n"
R"==(#define WEI_OFF(x0, x1, x2, d, x3, x4) \ )==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \ )==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \ )==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \ )==""\n"
R"==(+ ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \ )==""\n"
R"==(+ ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4) )==""\n"
R"==(#else )==""\n"
R"==(#define WEI_OFF(g, x1, x2, d, x3, x4) \ )==""\n"
R"==((((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \ )==""\n"
R"==(+ ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \ )==""\n"
R"==(+ ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \ )==""\n"
R"==(+ ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3) )==""\n"
R"==(#endif )==""\n"
R"==(#define DST_OFF(x0, x1, d, x2, x3) \ )==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \ )==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \ )==""\n"
R"==(+ ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \ )==""\n"
R"==(+ ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3) )==""\n"
R"==(#elif NDIMS == 5 )==""\n"
R"==(#define SRC_OFF(x0, x1, x2, x3, x4) \ )==""\n"
R"==((((x0) % SRC_B0) * SRC_SB0 + ((x0) / SRC_B0) * SRC_S0 \ )==""\n"
R"==(+ ((x1) % SRC_B1) * SRC_SB1 + ((x1) / SRC_B1) * SRC_S1 \ )==""\n"
R"==(+ ((x2) % SRC_B2) * SRC_SB2 + ((x2) / SRC_B2) * SRC_S2 \ )==""\n"
R"==(+ ((x3) % SRC_B3) * SRC_SB3 + ((x3) / SRC_B3) * SRC_S3 \ )==""\n"
R"==(+ ((x4) % SRC_B4) * SRC_SB4 + ((x4) / SRC_B4) * SRC_S4) )==""\n"
R"==(#if WITH_GROUPS == 1 )==""\n"
R"==(#define WEI_OFF(x0, x1, x2, x3, x4, x5) \ )==""\n"
R"==((((x0) % WEI_B0) * WEI_SB0 + ((x0) / WEI_B0) * WEI_S0 \ )==""\n"
R"==(+ ((x1) % WEI_B1) * WEI_SB1 + ((x1) / WEI_B1) * WEI_S1 \ )==""\n"
R"==(+ ((x2) % WEI_B2) * WEI_SB2 + ((x2) / WEI_B2) * WEI_S2 \ )==""\n"
R"==(+ ((x3) % WEI_B3) * WEI_SB3 + ((x3) / WEI_B3) * WEI_S3 \ )==""\n"
R"==(+ ((x4) % WEI_B4) * WEI_SB4 + ((x4) / WEI_B4) * WEI_S4 \ )==""\n"
R"==(+ ((x5) % WEI_B5) * WEI_SB5 + ((x5) / WEI_B5) * WEI_S5) )==""\n"
R"==(#else )==""\n"
R"==(#define WEI_OFF(g, x1, x2, x3, x4, x5) \ )==""\n"
R"==((((x1) % WEI_B0) * WEI_SB0 + ((x1) / WEI_B0) * WEI_S0 \ )==""\n"
R"==(+ ((x2) % WEI_B1) * WEI_SB1 + ((x2) / WEI_B1) * WEI_S1 \ )==""\n"
R"==(+ ((x3) % WEI_B2) * WEI_SB2 + ((x3) / WEI_B2) * WEI_S2 \ )==""\n"
R"==(+ ((x4) % WEI_B3) * WEI_SB3 + ((x4) / WEI_B3) * WEI_S3 \ )==""\n"
R"==(+ ((x5) % WEI_B4) * WEI_SB4 + ((x5) / WEI_B4) * WEI_S4) )==""\n"
R"==(#endif )==""\n"
R"==(#define DST_OFF(x0, x1, x2, x3, x4) \ )==""\n"
R"==((((x0) % DST_B0) * DST_SB0 + ((x0) / DST_B0) * DST_S0 \ )==""\n"
R"==(+ ((x1) % DST_B1) * DST_SB1 + ((x1) / DST_B1) * DST_S1 \ )==""\n"
R"==(+ ((x2) % DST_B2) * DST_SB2 + ((x2) / DST_B2) * DST_S2 \ )==""\n"
R"==(+ ((x3) % DST_B3) * DST_SB3 + ((x3) / DST_B3) * DST_S3 \ )==""\n"
R"==(+ ((x4) % DST_B4) * DST_SB4 + ((x4) / DST_B4) * DST_S4) )==""\n"
R"==(#endif )==""\n"
R"==(#define GWS_OP_ZERO(x, y) 0 )==""\n"
R"==(#define GWS_OP_FIRST(x, y) (x) )==""\n"
R"==(#define GWS_OP_MOD(x, y) ((x) % (y)) )==""\n"
R"==(#define ROUND_UP(a,b) (((a) + (b) - 1) / (b)) )==""\n"
R"==(#define GWS0_GET_ID0() GWS0_OP0((get_global_id(GWS0_IDX0) / GWS0_STRIDE0), ROUND_UP(GWS0_DIM0, GWS0_BLOCK0)) / GWS0_VEC_SIZE0 * GWS0_VEC_SIZE0 * GWS0_BLOCK0 )==""\n"
R"==(#define GWS0_GET_ID1() GWS0_OP1((get_global_id(GWS0_IDX1) / GWS0_STRIDE1), ROUND_UP(GWS0_DIM1, GWS0_BLOCK1)) / GWS0_VEC_SIZE1 * GWS0_VEC_SIZE1 * GWS0_BLOCK1 )==""\n"
R"==(#define GWS0_GET_ID2() GWS0_OP2((get_global_id(GWS0_IDX2) / GWS0_STRIDE2), ROUND_UP(GWS0_DIM2, GWS0_BLOCK2)) / GWS0_VEC_SIZE2 * GWS0_VEC_SIZE2 * GWS0_BLOCK2 )==""\n"
R"==(#define GWS0_GET_ID3() GWS0_OP3((get_global_id(GWS0_IDX3) / GWS0_STRIDE3), ROUND_UP(GWS0_DIM3, GWS0_BLOCK3)) / GWS0_VEC_SIZE3 * GWS0_VEC_SIZE3 * GWS0_BLOCK3 )==""\n"
R"==(#define GWS0_GET_ID4() GWS0_OP4((get_global_id(GWS0_IDX4) / GWS0_STRIDE4), ROUND_UP(GWS0_DIM4, GWS0_BLOCK4)) / GWS0_VEC_SIZE4 * GWS0_VEC_SIZE4 * GWS0_BLOCK4 )==""\n"
R"==(#define GWS0_GET_ID5() GWS0_OP5((get_global_id(GWS0_IDX5) / GWS0_STRIDE5), ROUND_UP(GWS0_DIM5, GWS0_BLOCK5)) / GWS0_VEC_SIZE5 * GWS0_VEC_SIZE5 * GWS0_BLOCK5 )==""\n"
R"==(#define GWS0_GET_BLOCK0() GWS0_BLOCK0 )==""\n"
R"==(#define GWS0_GET_BLOCK1() GWS0_BLOCK1 )==""\n"
R"==(#define GWS0_GET_BLOCK2() GWS0_BLOCK2 )==""\n"
R"==(#define GWS0_GET_BLOCK3() GWS0_BLOCK3 )==""\n"
R"==(#define GWS0_GET_BLOCK4() GWS0_BLOCK4 )==""\n"
R"==(#define GWS0_GET_BLOCK5() GWS0_BLOCK5 )==""\n"
R"==(#define GWS1_GET_ID0() GWS1_OP0((get_global_id(GWS1_IDX0) / GWS1_STRIDE0), ROUND_UP(GWS1_DIM0, GWS1_BLOCK0)) / GWS1_VEC_SIZE0 * GWS1_VEC_SIZE0 * GWS1_BLOCK0 )==""\n"
R"==(#define GWS1_GET_ID1() GWS1_OP1((get_global_id(GWS1_IDX1) / GWS1_STRIDE1), ROUND_UP(GWS1_DIM1, GWS1_BLOCK1)) / GWS1_VEC_SIZE1 * GWS1_VEC_SIZE1 * GWS1_BLOCK1 )==""\n"
R"==(#define GWS1_GET_ID2() GWS1_OP2((get_global_id(GWS1_IDX2) / GWS1_STRIDE2), ROUND_UP(GWS1_DIM2, GWS1_BLOCK2)) / GWS1_VEC_SIZE2 * GWS1_VEC_SIZE2 * GWS1_BLOCK2 )==""\n"
R"==(#define GWS1_GET_ID3() GWS1_OP3((get_global_id(GWS1_IDX3) / GWS1_STRIDE3), ROUND_UP(GWS1_DIM3, GWS1_BLOCK3)) / GWS1_VEC_SIZE3 * GWS1_VEC_SIZE3 * GWS1_BLOCK3 )==""\n"
R"==(#define GWS1_GET_ID4() GWS1_OP4((get_global_id(GWS1_IDX4) / GWS1_STRIDE4), ROUND_UP(GWS1_DIM4, GWS1_BLOCK4)) / GWS1_VEC_SIZE4 * GWS1_VEC_SIZE4 * GWS1_BLOCK4 )==""\n"
R"==(#define GWS1_GET_ID5() GWS1_OP5((get_global_id(GWS1_IDX5) / GWS1_STRIDE5), ROUND_UP(GWS1_DIM5, GWS1_BLOCK5)) / GWS1_VEC_SIZE5 * GWS1_VEC_SIZE5 * GWS1_BLOCK5 )==""\n"
R"==(#define GWS1_GET_BLOCK0() GWS1_BLOCK0 )==""\n"
R"==(#define GWS1_GET_BLOCK1() GWS1_BLOCK1 )==""\n"
R"==(#define GWS1_GET_BLOCK2() GWS1_BLOCK2 )==""\n"
R"==(#define GWS1_GET_BLOCK3() GWS1_BLOCK3 )==""\n"
R"==(#define GWS1_GET_BLOCK4() GWS1_BLOCK4 )==""\n"
R"==(#define GWS1_GET_BLOCK5() GWS1_BLOCK5 )==""\n"
R"==(#define GWS2_GET_ID0() GWS2_OP0((get_global_id(GWS2_IDX0) / GWS2_STRIDE0), ROUND_UP(GWS2_DIM0, GWS2_BLOCK0)) / GWS2_VEC_SIZE0 * GWS2_VEC_SIZE0 * GWS2_BLOCK0 )==""\n"
R"==(#define GWS2_GET_ID1() GWS2_OP1((get_global_id(GWS2_IDX1) / GWS2_STRIDE1), ROUND_UP(GWS2_DIM1, GWS2_BLOCK1)) / GWS2_VEC_SIZE1 * GWS2_VEC_SIZE1 * GWS2_BLOCK1 )==""\n"
R"==(#define GWS2_GET_ID2() GWS2_OP2((get_global_id(GWS2_IDX2) / GWS2_STRIDE2), ROUND_UP(GWS2_DIM2, GWS2_BLOCK2)) / GWS2_VEC_SIZE2 * GWS2_VEC_SIZE2 * GWS2_BLOCK2 )==""\n"
R"==(#define GWS2_GET_ID3() GWS2_OP3((get_global_id(GWS2_IDX3) / GWS2_STRIDE3), ROUND_UP(GWS2_DIM3, GWS2_BLOCK3)) / GWS2_VEC_SIZE3 * GWS2_VEC_SIZE3 * GWS2_BLOCK3 )==""\n"
R"==(#define GWS2_GET_ID4() GWS2_OP4((get_global_id(GWS2_IDX4) / GWS2_STRIDE4), ROUND_UP(GWS2_DIM4, GWS2_BLOCK4)) / GWS2_VEC_SIZE4 * GWS2_VEC_SIZE4 * GWS2_BLOCK4 )==""\n"
R"==(#define GWS2_GET_ID5() GWS2_OP5((get_global_id(GWS2_IDX5) / GWS2_STRIDE5), ROUND_UP(GWS2_DIM5, GWS2_BLOCK5)) / GWS2_VEC_SIZE5 * GWS2_VEC_SIZE5 * GWS2_BLOCK5 )==""\n"
R"==(#define GWS2_GET_BLOCK0() GWS2_BLOCK0 )==""\n"
R"==(#define GWS2_GET_BLOCK1() GWS2_BLOCK1 )==""\n"
R"==(#define GWS2_GET_BLOCK2() GWS2_BLOCK2 )==""\n"
R"==(#define GWS2_GET_BLOCK3() GWS2_BLOCK3 )==""\n"
R"==(#define GWS2_GET_BLOCK4() GWS2_BLOCK4 )==""\n"
R"==(#define GWS2_GET_BLOCK5() GWS2_BLOCK5 )==""\n"
R"==(#define GWS3_GET_ID0() GWS3_OP0((get_global_id(GWS3_IDX0) / GWS3_STRIDE0), ROUND_UP(GWS3_DIM0, GWS3_BLOCK0)) / GWS3_VEC_SIZE0 * GWS3_VEC_SIZE0 * GWS3_BLOCK0 )==""\n"
R"==(#define GWS3_GET_ID1() GWS3_OP1((get_global_id(GWS3_IDX1) / GWS3_STRIDE1), ROUND_UP(GWS3_DIM1, GWS3_BLOCK1)) / GWS3_VEC_SIZE1 * GWS3_VEC_SIZE1 * GWS3_BLOCK1 )==""\n"
R"==(#define GWS3_GET_ID2() GWS3_OP2((get_global_id(GWS3_IDX2) / GWS3_STRIDE2), ROUND_UP(GWS3_DIM2, GWS3_BLOCK2)) / GWS3_VEC_SIZE2 * GWS3_VEC_SIZE2 * GWS3_BLOCK2 )==""\n"
R"==(#define GWS3_GET_ID3() GWS3_OP3((get_global_id(GWS3_IDX3) / GWS3_STRIDE3), ROUND_UP(GWS3_DIM3, GWS3_BLOCK3)) / GWS3_VEC_SIZE3 * GWS3_VEC_SIZE3 * GWS3_BLOCK3 )==""\n"
R"==(#define GWS3_GET_ID4() GWS3_OP4((get_global_id(GWS3_IDX4) / GWS3_STRIDE4), ROUND_UP(GWS3_DIM4, GWS3_BLOCK4)) / GWS3_VEC_SIZE4 * GWS3_VEC_SIZE4 * GWS3_BLOCK4 )==""\n"
R"==(#define GWS3_GET_ID5() GWS3_OP5((get_global_id(GWS3_IDX5) / GWS3_STRIDE5), ROUND_UP(GWS3_DIM5, GWS3_BLOCK5)) / GWS3_VEC_SIZE5 * GWS3_VEC_SIZE5 * GWS3_BLOCK5 )==""\n"
R"==(#define GWS3_GET_BLOCK0() GWS3_BLOCK0 )==""\n"
R"==(#define GWS3_GET_BLOCK1() GWS3_BLOCK1 )==""\n"
R"==(#define GWS3_GET_BLOCK2() GWS3_BLOCK2 )==""\n"
R"==(#define GWS3_GET_BLOCK3() GWS3_BLOCK3 )==""\n"
R"==(#define GWS3_GET_BLOCK4() GWS3_BLOCK4 )==""\n"
R"==(#define GWS3_GET_BLOCK5() GWS3_BLOCK5 )==""\n"
R"==(#define KERNEL_ATTR_SG0 \ )==""\n"
R"==(__attribute__((reqd_work_group_size( \ )==""\n"
R"==(GWS_LWS0_DEFAULT, GWS_LWS1_DEFAULT, GWS_LWS2_DEFAULT))) )==""\n"
R"==(#define KERNEL_ATTR_SG1 \ )==""\n"
R"==(KERNEL_ATTR_SG0 \ )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(GWS_SGS_DEFAULT))) )==""\n"
R"==(#define KERNEL_ATTR CONCAT2(KERNEL_ATTR_SG, GWS_WITH_SG_DEFAULT) )==""\n"
R"==(#define NAMED_KERNEL_ATTR_SG0(name) \ )==""\n"
R"==(__attribute__((reqd_work_group_size(CONCAT2(GWS_LWS0_, name), \ )==""\n"
R"==(CONCAT2(GWS_LWS1_, name), CONCAT2(GWS_LWS2_, name)))) )==""\n"
R"==(#define NAMED_KERNEL_ATTR_SG1(name) \ )==""\n"
R"==(NAMED_KERNEL_ATTR_SG0(name) \ )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(CONCAT2(GWS_SGS_, name)))) )==""\n"
R"==(#define NAMED_KERNEL_ATTR(name) \ )==""\n"
R"==(CONCAT2(NAMED_KERNEL_ATTR_SG, CONCAT2(GWS_WITH_SG_, name))(name) )==""\n"
R"==(#define MAYBE_SKIP_NON_UNIFORM_WG() \ )==""\n"
R"==(do { \ )==""\n"
R"==(if ((GWS_0 != GWS_ORIG_0) && (GWS_ORIG_0 % LWS_0 != 0) \ )==""\n"
R"==(&& (get_global_id(0) >= GWS_ORIG_0)) \ )==""\n"
R"==(return; \ )==""\n"
R"==(if ((GWS_1 != GWS_ORIG_1) && (GWS_ORIG_1 % LWS_1 != 0) \ )==""\n"
R"==(&& (get_global_id(1) >= GWS_ORIG_1)) \ )==""\n"
R"==(return; \ )==""\n"
R"==(if ((GWS_2 != GWS_ORIG_2) && (GWS_ORIG_2 % LWS_2 != 0) \ )==""\n"
R"==(&& (get_global_id(2) >= GWS_ORIG_2)) \ )==""\n"
R"==(return; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#if SRC_DT_U8 == 1 )==""\n"
R"==(#define SRC_DT_ALIAS UCHAR )==""\n"
R"==(#elif SRC_DT_S8 == 1 )==""\n"
R"==(#define SRC_DT_ALIAS CHAR )==""\n"
R"==(#elif SRC_DT_F16 == 1 )==""\n"
R"==(#define SRC_DT_ALIAS HALF )==""\n"
R"==(#elif SRC_DT_BF16 == 1 )==""\n"
R"==(#define SRC_DT_ALIAS BFLOAT )==""\n"
R"==(#elif SRC_DT_F32 == 1 )==""\n"
R"==(#define SRC_DT_ALIAS FLOAT )==""\n"
R"==(#endif )==""\n"
R"==(#if DST_DT_U8 == 1 )==""\n"
R"==(#define DST_DT_ALIAS UCHAR )==""\n"
R"==(#elif DST_DT_S8 == 1 )==""\n"
R"==(#define DST_DT_ALIAS CHAR )==""\n"
R"==(#elif DST_DT_F16 == 1 )==""\n"
R"==(#define DST_DT_ALIAS HALF )==""\n"
R"==(#elif DST_DT_BF16 == 1 )==""\n"
R"==(#define DST_DT_ALIAS BFLOAT )==""\n"
R"==(#elif DST_DT_F32 == 1 )==""\n"
R"==(#define DST_DT_ALIAS FLOAT )==""\n"
R"==(#endif )==""\n"
R"==(#define ALIAS(prefix) CONCAT2(prefix, _DT_ALIAS) )==""\n"
R"==(#define BLOCK1_T uchar )==""\n"
R"==(#define BLOCK2_T ushort )==""\n"
R"==(#define BLOCK4_T uint )==""\n"
R"==(#define BLOCK8_T ulong )==""\n"
R"==(#define BLOCK_T(alias) CONCAT3(BLOCK, SIZEOF(alias), _T) )==""\n"
R"==(#define BLOCK1_ALIAS UCHAR )==""\n"
R"==(#define BLOCK2_ALIAS USHORT )==""\n"
R"==(#define BLOCK4_ALIAS UINT )==""\n"
R"==(#define BLOCK_ALIAS(prefix) CONCAT3(BLOCK, SIZEOF(ALIAS(prefix)), _ALIAS) )==""\n"
R"==(#define SIZEOF_UCHAR 1 )==""\n"
R"==(#define SIZEOF_CHAR 1 )==""\n"
R"==(#define SIZEOF_BFLOAT 2 )==""\n"
R"==(#define SIZEOF_HALF 2 )==""\n"
R"==(#define SIZEOF_FLOAT 4 )==""\n"
R"==(#define SIZEOF(alias) CONCAT2(SIZEOF_, alias) )==""\n"
R"==(#define READ_UCHAR8 intel_sub_group_block_read_uc8 )==""\n"
R"==(#define READ_USHORT8 intel_sub_group_block_read_us8 )==""\n"
R"==(#define READ_UINT8 intel_sub_group_block_read8 )==""\n"
R"==(#define READ_BLOCK8(prefix, ptr) READ_BLOCK_N(prefix, 8)(ptr) )==""\n"
R"==(#define READ_BLOCK_N(prefix, n) CONCAT3(READ_, BLOCK_ALIAS(prefix), n) )==""\n"
R"==(#define WRITE_UCHAR8 intel_sub_group_block_write_uc8 )==""\n"
R"==(#define WRITE_USHORT8 intel_sub_group_block_write_us8 )==""\n"
R"==(#define WRITE_UINT8 intel_sub_group_block_write8 )==""\n"
R"==(#define WRITE_BLOCK8(prefix, ptr, val) WRITE_BLOCK_N(prefix, 8)(ptr, val) )==""\n"
R"==(#define WRITE_BLOCK_N(prefix, n) CONCAT3(WRITE_, BLOCK_ALIAS(prefix), n) )==""\n"
R"==(#define AS_UCHAR8 as_uchar8 )==""\n"
R"==(#define AS_CHAR8 as_char8 )==""\n"
R"==(#define AS_HALF8 as_half8 )==""\n"
R"==(#define AS_USHORT8 as_ushort8 )==""\n"
R"==(#define AS_BFLOAT8 as_ushort8 )==""\n"
R"==(#define AS_FLOAT8 as_float8 )==""\n"
R"==(#define AS_INT8 as_int8 )==""\n"
R"==(#define AS_UINT8 as_uint8 )==""\n"
R"==(#define BLOCK_TO_DATA8(prefix, val) BLOCK_TO_DATA_N(prefix, 8)(val) )==""\n"
R"==(#define BLOCK_TO_DATA_N(prefix, n) CONCAT3(AS_, ALIAS(prefix), n) )==""\n"
R"==(#define DATA_TO_BLOCK8(prefix, val) DATA_TO_BLOCK_N(prefix, 8)(val) )==""\n"
R"==(#define DATA_TO_BLOCK_N(prefix, n) CONCAT3(AS_, BLOCK_ALIAS(prefix), n) )==""\n"
R"==(#define UCHAR_TO_FLOAT1 convert_float )==""\n"
R"==(#define UCHAR_TO_FLOAT8 convert_float8 )==""\n"
R"==(#define FLOAT_TO_UCHAR1 convert_uchar_sat_rte )==""\n"
R"==(#define FLOAT_TO_UCHAR8 convert_uchar8_sat_rte )==""\n"
R"==(#define CHAR_TO_FLOAT1 convert_float )==""\n"
R"==(#define CHAR_TO_FLOAT8 convert_float8 )==""\n"
R"==(#define FLOAT_TO_CHAR1 convert_char_sat_rte )==""\n"
R"==(#define FLOAT_TO_CHAR8 convert_char8_sat_rte )==""\n"
R"==(#define HALF_TO_FLOAT1 convert_float )==""\n"
R"==(#define HALF_TO_FLOAT8 convert_float8 )==""\n"
R"==(#define FLOAT_TO_HALF1 convert_half )==""\n"
R"==(#define FLOAT_TO_HALF8 convert_half8 )==""\n"
R"==(#define BFLOAT_TO_FLOAT1 cvt_bf16_to_f32 )==""\n"
R"==(#define BFLOAT_TO_FLOAT8 cvt_bf16_to_f32 )==""\n"
R"==(#define FLOAT_TO_BFLOAT1 cvt_f32_to_bf16 )==""\n"
R"==(#define FLOAT_TO_BFLOAT8 cvt_f32_to_bf16 )==""\n"
R"==(#define FLOAT_TO_FLOAT1 convert_float )==""\n"
R"==(#define FLOAT_TO_FLOAT8 convert_float8 )==""\n"
R"==(#define DATA_TO_FLOAT(prefix, val) DATA_TO_FLOAT_N(prefix, 1)(val) )==""\n"
R"==(#define DATA_TO_FLOAT8(prefix, val) DATA_TO_FLOAT_N(prefix, 8)(val) )==""\n"
R"==(#define DATA_TO_FLOAT_N(prefix, n) CONCAT3(ALIAS(prefix), _TO_FLOAT, n) )==""\n"
R"==(#define FLOAT_TO_DATA(prefix, val) FLOAT_TO_DATA_N(prefix, 1)(val) )==""\n"
R"==(#define FLOAT_TO_DATA8(prefix, val) FLOAT_TO_DATA_N(prefix, 8)(val) )==""\n"
R"==(#define FLOAT_TO_DATA_N(prefix, n) CONCAT3(FLOAT_TO_, ALIAS(prefix), n) )==""\n"
R"==()==";
}
}
}
}