namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ocl_zero_points_header = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#ifndef GPU_OCL_OCL_ZERO_POINTS_H )==""\n"
R"==(#define GPU_OCL_OCL_ZERO_POINTS_H )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(int4 read_src_zero_points_32c(const __global int *ptr, const int ic) { )==""\n"
R"==(int4 z; )==""\n"
R"==(ptr += ic; )==""\n"
R"==(#if IC % 32 != 0 )==""\n"
R"==(if (ic + 32 > IC) { )==""\n"
R"==(const int max_local_id = IC % 8; )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(if (ic + 8 > IC) { )==""\n"
R"==(z.s0 = local_id < max_local_id ? ptr[0 + local_id] : 0; )==""\n"
R"==(z.s1 = 0; )==""\n"
R"==(z.s2 = 0; )==""\n"
R"==(z.s3 = 0; )==""\n"
R"==(} else if (ic + 16 > IC) { )==""\n"
R"==(z.s0 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 0))); )==""\n"
R"==(z.s1 = local_id < max_local_id ? ptr[8 + local_id] : 0; )==""\n"
R"==(z.s2 = 0; )==""\n"
R"==(z.s3 = 0; )==""\n"
R"==(} else if (ic + 24 > IC) { )==""\n"
R"==(z.s0 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 0))); )==""\n"
R"==(z.s1 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 8))); )==""\n"
R"==(z.s2 = local_id < max_local_id ? ptr[16 + local_id] : 0; )==""\n"
R"==(z.s3 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(z.s0 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 0))); )==""\n"
R"==(z.s1 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 8))); )==""\n"
R"==(z.s2 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 16))); )==""\n"
R"==(z.s3 = local_id < max_local_id ? ptr[24 + local_id] : 0; )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(z = as_int4(intel_sub_group_block_read4((const __global uint *)ptr)); )==""\n"
R"==(} )==""\n"
R"==(return z; )==""\n"
R"==(} )==""\n"
R"==(int2 read_src_zero_points_32g(const __global int *ptr, const int g) { )==""\n"
R"==(int2 z; )==""\n"
R"==(ptr += g; )==""\n"
R"==(#if G % 32 != 0 )==""\n"
R"==(if (g + 32 > G) { )==""\n"
R"==(const int max_local_id = G % 16; )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(if (g + 16 > G) { )==""\n"
R"==(z.s0 = local_id < max_local_id ? ptr[0 + local_id] : 0; )==""\n"
R"==(z.s1 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(z.s0 = as_int( )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)ptr)); )==""\n"
R"==(z.s1 = local_id < max_local_id ? ptr[16 + local_id] : 0; )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(z = as_int2(intel_sub_group_block_read2((const __global uint *)ptr)); )==""\n"
R"==(} )==""\n"
R"==(return z; )==""\n"
R"==(} )==""\n"
R"==(int calc_src_compensation_x32(int4 z, int8 wei) { )==""\n"
R"==(int sum = 0; )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (uint i = 0; i < 8; ++i) { )==""\n"
R"==(char4 w = as_char4(wei[i]); )==""\n"
R"==(sum += sub_group_broadcast(z[i >> 1], (i & 1) * 4 + 0) * w[0]; )==""\n"
R"==(sum += sub_group_broadcast(z[i >> 1], (i & 1) * 4 + 1) * w[1]; )==""\n"
R"==(sum += sub_group_broadcast(z[i >> 1], (i & 1) * 4 + 2) * w[2]; )==""\n"
R"==(sum += sub_group_broadcast(z[i >> 1], (i & 1) * 4 + 3) * w[3]; )==""\n"
R"==(} )==""\n"
R"==(return sum; )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(int read_src_zero_point(const __global int *ptr) { )==""\n"
R"==(const int z = ptr[0]; )==""\n"
R"==(return z; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(int calc_src_compensation_x4(int4 z, int wei) { )==""\n"
R"==(int sum = 0; )==""\n"
R"==({ )==""\n"
R"==(char4 w = as_char4(wei); )==""\n"
R"==(sum += z.s0 * w.s0; )==""\n"
R"==(sum += z.s1 * w.s1; )==""\n"
R"==(sum += z.s2 * w.s2; )==""\n"
R"==(sum += z.s3 * w.s3; )==""\n"
R"==(} )==""\n"
R"==(return sum; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_DST_ZPOINTS )==""\n"
R"==(int4 read_dst_zero_points_32c(const __global int *ptr, const int oc) { )==""\n"
R"==(#if WITH_DST_ZPOINTS_PER_OC )==""\n"
R"==(int4 z; )==""\n"
R"==(ptr += oc; )==""\n"
R"==(#if OC % 32 != 0 )==""\n"
R"==(if (oc + 32 > OC) { )==""\n"
R"==(const int max_local_id = OC % 8; )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(if (oc + 8 > OC) { )==""\n"
R"==(z.s0 = local_id < max_local_id ? ptr[0 + local_id] : 0; )==""\n"
R"==(z.s1 = 0; )==""\n"
R"==(z.s2 = 0; )==""\n"
R"==(z.s3 = 0; )==""\n"
R"==(} else if (oc + 16 > OC) { )==""\n"
R"==(z.s0 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 0))); )==""\n"
R"==(z.s1 = local_id < max_local_id ? ptr[8 + local_id] : 0; )==""\n"
R"==(z.s2 = 0; )==""\n"
R"==(z.s3 = 0; )==""\n"
R"==(} else if (oc + 24 > OC) { )==""\n"
R"==(z.s0 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 0))); )==""\n"
R"==(z.s1 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 8))); )==""\n"
R"==(z.s2 = local_id < max_local_id ? ptr[16 + local_id] : 0; )==""\n"
R"==(z.s3 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(z.s0 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 0))); )==""\n"
R"==(z.s1 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 8))); )==""\n"
R"==(z.s2 = as_int(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(ptr + 16))); )==""\n"
R"==(z.s3 = local_id < max_local_id ? ptr[24 + local_id] : 0; )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(z = as_int4(intel_sub_group_block_read4((const __global uint *)ptr)); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(const int4 z = ptr[0]; )==""\n"
R"==(#endif  )==""\n"
R"==(return z; )==""\n"
R"==(} )==""\n"
R"==(int2 read_dst_zero_points_32g(const __global int *ptr, const int g) { )==""\n"
R"==(#if WITH_DST_ZPOINTS_PER_OC )==""\n"
R"==(int2 z; )==""\n"
R"==(ptr += g; )==""\n"
R"==(#if G % 32 != 0 )==""\n"
R"==(if (g + 32 > G) { )==""\n"
R"==(const int max_local_id = G % 16; )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(if (g + 16 > G) { )==""\n"
R"==(z.s0 = local_id < max_local_id ? ptr[0 + local_id] : 0; )==""\n"
R"==(z.s1 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(z.s0 = as_int( )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)ptr)); )==""\n"
R"==(z.s1 = local_id < max_local_id ? ptr[16 + local_id] : 0; )==""\n"
R"==(} )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(z = as_int2(intel_sub_group_block_read2((const __global uint *)ptr)); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(const int2 z = (int2)(ptr[0]); )==""\n"
R"==(#endif  )==""\n"
R"==(return z; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_SRC_ZPOINTS || WITH_DST_ZPOINTS )==""\n"
R"==(float4 zero_pad_dst_32c(float4 dst, const int oc) { )==""\n"
R"==(#if OC % 32 != 0 )==""\n"
R"==(if (oc + 32 > OC) { )==""\n"
R"==(const int max_local_id = OC % 8; )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(if (oc + 8 > OC) { )==""\n"
R"==(dst.s0 = local_id < max_local_id ? dst.s0 : 0; )==""\n"
R"==(dst.s1 = 0; )==""\n"
R"==(dst.s2 = 0; )==""\n"
R"==(dst.s3 = 0; )==""\n"
R"==(} else if (oc + 16 > OC) { )==""\n"
R"==(dst.s1 = local_id < max_local_id ? dst.s1 : 0; )==""\n"
R"==(dst.s2 = 0; )==""\n"
R"==(dst.s3 = 0; )==""\n"
R"==(} else if (oc + 24 > OC) { )==""\n"
R"==(dst.s2 = local_id < max_local_id ? dst.s2 : 0; )==""\n"
R"==(dst.s3 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(dst.s3 = local_id < max_local_id ? dst.s3 : 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(return dst; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==()==";
}
}
}
}