namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ref_bnorm_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#if MB_BLOCK == 16 )==""\n"
R"==(#define MB16 )==""\n"
R"==(#define VECT_DT_N 8 )==""\n"
R"==(#elif VECTORIZE_CALC_STATS == 1 )==""\n"
R"==(#define VECT_DT_N VECT_SIZE )==""\n"
R"==(#else )==""\n"
R"==(#define VECT_DT_N 1 )==""\n"
R"==(#endif )==""\n"
R"==(#if VECT_DT_N == 1 )==""\n"
R"==(#define VECT_CHAR_TO_INT convert_int )==""\n"
R"==(#else )==""\n"
R"==(#define VECT_CHAR_TO_INT CONCAT2(convert_int, VECT_DT_N) )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_16MB_UNROLL == 0 && (CALCULATE_STATS == 1 || IS_BWD == 1) )==""\n"
R"==(int reduce_index(int x[5]) { )==""\n"
R"==(int dim[5] = {MB, IC, ID, IH, IW}; )==""\n"
R"==(dim[REDUCE_DIM_IDX] = 1; )==""\n"
R"==(return x[0] * (dim[2] * dim[3] * dim[4]) + x[2] * (dim[3] * dim[4]) )==""\n"
R"==(+ x[3] * dim[4] + x[4]; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if IS_FWD == 1 )==""\n"
R"==(#if USE_16MB_UNROLL == 0 && CALCULATE_STATS == 1 )==""\n"
R"==(#if VECTORIZE_CALC_STATS == 1 )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void calculate_mean(__global DATA_T *src, __global float *mean) { )==""\n"
R"==(int x[5]; )==""\n"
R"==(x[0] = GWS_GET_STAT_MB(); )==""\n"
R"==(x[1] = GWS_GET_STAT_IC(); )==""\n"
R"==(x[2] = GWS_GET_STAT_ID(); )==""\n"
R"==(x[3] = GWS_GET_STAT_IH(); )==""\n"
R"==(x[4] = GWS_GET_STAT_IW(); )==""\n"
R"==(VECT_FLOAT_T vect_sum = 0; )==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i += SUB_GROUP_SIZE * VECT_DT_N) { )==""\n"
R"==(x[REDUCE_DIM_IDX] = i; )==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4]); )==""\n"
R"==(vect_sum += CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off]))); )==""\n"
R"==(} )==""\n"
R"==(#if VECT_DT_N == 1 )==""\n"
R"==(float sum = vect_sum; )==""\n"
R"==(#else  )==""\n"
R"==(float sum = 0; )==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) { )==""\n"
R"==(sum += vect_sum[i]; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(x[REDUCE_DIM_IDX] = 0; )==""\n"
R"==(int reduce_idx = reduce_index(x); )==""\n"
R"==(float total_sum = sub_group_reduce_add(sum); )==""\n"
R"==(int local_id = get_sub_group_local_id(); )==""\n"
R"==(if (local_id == 0) { mean[reduce_idx * IC + x[1]] = total_sum; } )==""\n"
R"==(} )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void calculate_variance( )==""\n"
R"==(__global DATA_T *src, __global float *mean, __global float *variance) { )==""\n"
R"==(int x[5]; )==""\n"
R"==(x[0] = GWS_GET_STAT_MB(); )==""\n"
R"==(x[1] = GWS_GET_STAT_IC(); )==""\n"
R"==(x[2] = GWS_GET_STAT_ID(); )==""\n"
R"==(x[3] = GWS_GET_STAT_IH(); )==""\n"
R"==(x[4] = GWS_GET_STAT_IW(); )==""\n"
R"==(VECT_FLOAT_T mean_tmp = mean[x[1]]; )==""\n"
R"==(VECT_FLOAT_T vect_sum = 0; )==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i += SUB_GROUP_SIZE * VECT_DT_N) { )==""\n"
R"==(x[REDUCE_DIM_IDX] = i; )==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4]); )==""\n"
R"==(VECT_FLOAT_T v0 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off]))); )==""\n"
R"==(v0 -= mean_tmp; )==""\n"
R"==(vect_sum += v0 * v0; )==""\n"
R"==(} )==""\n"
R"==(#if VECT_DT_N == 1 )==""\n"
R"==(float sum = vect_sum; )==""\n"
R"==(#else  )==""\n"
R"==(float sum = 0; )==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) { )==""\n"
R"==(sum += vect_sum[i]; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(x[REDUCE_DIM_IDX] = 0; )==""\n"
R"==(int reduce_idx = reduce_index(x); )==""\n"
R"==(float total_sum = sub_group_reduce_add(sum); )==""\n"
R"==(int local_id = get_sub_group_local_id(); )==""\n"
R"==(if (local_id == 0) { )==""\n"
R"==(variance += MB * ID * IH * IW * IC / REDUCE_DIM; )==""\n"
R"==(variance[reduce_idx * IC + x[1]] = total_sum; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void calculate_mean_variance( )==""\n"
R"==(__global DATA_T *src, __global float *mean, __global float *variance) { )==""\n"
R"==(#if SKIP_REDUCE_STATS == 1 )==""\n"
R"==(int x[5]; )==""\n"
R"==(x[0] = GWS_GET_STAT_MB(); )==""\n"
R"==(x[1] = GWS_GET_STAT_IC(); )==""\n"
R"==(x[2] = GWS_GET_STAT_ID(); )==""\n"
R"==(x[3] = GWS_GET_STAT_IH(); )==""\n"
R"==(x[4] = GWS_GET_STAT_IW(); )==""\n"
R"==(VECT_FLOAT_T src_sum = 0; )==""\n"
R"==(VECT_FLOAT_T src_pow_sum = 0; )==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i += SUB_GROUP_SIZE * VECT_DT_N) { )==""\n"
R"==(x[REDUCE_DIM_IDX] = i; )==""\n"
R"==(int src_off = SRC_OFF(x[0], x[1], x[2], x[3], x[4]); )==""\n"
R"==(VECT_FLOAT_T src_vect = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[src_off]))); )==""\n"
R"==(src_sum += src_vect; )==""\n"
R"==(src_pow_sum += src_vect * src_vect; )==""\n"
R"==(} )==""\n"
R"==(#if VECT_DT_N == 1 )==""\n"
R"==(float sum = src_sum; )==""\n"
R"==(float pow_sum = src_pow_sum; )==""\n"
R"==(#else  )==""\n"
R"==(float sum = 0; )==""\n"
R"==(float pow_sum = 0; )==""\n"
R"==(for (int i = 0; i < VECT_DT_N; ++i) { )==""\n"
R"==(sum += src_sum[i]; )==""\n"
R"==(pow_sum += src_pow_sum[i]; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(x[REDUCE_DIM_IDX] = 0; )==""\n"
R"==(int reduce_idx = reduce_index(x); )==""\n"
R"==(float total_sum = sub_group_reduce_add(sum); )==""\n"
R"==(float total_pow_sum = sub_group_reduce_add(pow_sum); )==""\n"
R"==(int local_id = get_sub_group_local_id(); )==""\n"
R"==(if (local_id == 0) { )==""\n"
R"==(float calc_mean = total_sum / (MB * ID * IH * IW); )==""\n"
R"==(float calc_variance )==""\n"
R"==(= total_pow_sum / (MB * ID * IH * IW) - calc_mean * calc_mean; )==""\n"
R"==(mean[x[1]] = calc_mean; )==""\n"
R"==(variance[x[1]] = calc_variance < 0 ? 0 : calc_variance; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void calculate_mean(__global DATA_T *src, __global float *mean) { )==""\n"
R"==(int x[5]; )==""\n"
R"==(x[0] = GWS_GET_STAT_MB(); )==""\n"
R"==(x[1] = GWS_GET_STAT_IC(); )==""\n"
R"==(x[2] = GWS_GET_STAT_ID(); )==""\n"
R"==(x[3] = GWS_GET_STAT_IH(); )==""\n"
R"==(x[4] = GWS_GET_STAT_IW(); )==""\n"
R"==(float sum = 0; )==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i++) { )==""\n"
R"==(x[REDUCE_DIM_IDX] = i; )==""\n"
R"==(sum += TO_DEF_ACC_DATA_T(src[SRC_OFF(x[0], x[1], x[2], x[3], x[4])]); )==""\n"
R"==(} )==""\n"
R"==(x[REDUCE_DIM_IDX] = 0; )==""\n"
R"==(int reduce_idx = reduce_index(x); )==""\n"
R"==(mean[reduce_idx * IC + x[1]] = sum; )==""\n"
R"==(} )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void calculate_variance( )==""\n"
R"==(__global DATA_T *src, __global float *mean, __global float *variance) { )==""\n"
R"==(int x[5]; )==""\n"
R"==(x[0] = GWS_GET_STAT_MB(); )==""\n"
R"==(x[1] = GWS_GET_STAT_IC(); )==""\n"
R"==(x[2] = GWS_GET_STAT_ID(); )==""\n"
R"==(x[3] = GWS_GET_STAT_IH(); )==""\n"
R"==(x[4] = GWS_GET_STAT_IW(); )==""\n"
R"==(float sum = 0; )==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i++) { )==""\n"
R"==(x[REDUCE_DIM_IDX] = i; )==""\n"
R"==(DEF_ACC_DATA_T v0 )==""\n"
R"==(= TO_DEF_ACC_DATA_T(src[SRC_OFF(x[0], x[1], x[2], x[3], x[4])]) )==""\n"
R"==(- mean[x[1]]; )==""\n"
R"==(sum += v0 * v0; )==""\n"
R"==(} )==""\n"
R"==(variance += MB * ID * IH * IW * IC / REDUCE_DIM; )==""\n"
R"==(x[REDUCE_DIM_IDX] = 0; )==""\n"
R"==(int reduce_idx = reduce_index(x); )==""\n"
R"==(variance[reduce_idx * IC + x[1]] = sum; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE) )==""\n"
R"==(__kernel void reduce_mean(__global float *reduce_temp, __global float *mean) { )==""\n"
R"==(const int c = GWS_GET_REDUCE_STAT_IC(); )==""\n"
R"==(reduce_temp += c; )==""\n"
R"==(float sum = 0.0f; )==""\n"
R"==(int reduce_size = MB * ID * IH * IW / REDUCE_DIM; )==""\n"
R"==(for (int i = 0; i < reduce_size; i++) { )==""\n"
R"==(sum += reduce_temp[i * IC]; )==""\n"
R"==(} )==""\n"
R"==(mean[c] = sum / (MB * ID * IH * IW); )==""\n"
R"==(} )==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE) )==""\n"
R"==(__kernel void reduce_variance( )==""\n"
R"==(__global float *reduce_temp, __global float *variance) { )==""\n"
R"==(const int c = GWS_GET_REDUCE_STAT_IC(); )==""\n"
R"==(#if SAVE_STATS == 0 )==""\n"
R"==(variance += IC; )==""\n"
R"==(#endif )==""\n"
R"==(float sum = 0.0f; )==""\n"
R"==(int reduce_size = MB * ID * IH * IW / REDUCE_DIM; )==""\n"
R"==(reduce_temp += reduce_size * IC + c; )==""\n"
R"==(for (int i = 0; i < reduce_size; i++) )==""\n"
R"==(sum += reduce_temp[i * IC]; )==""\n"
R"==(variance[c] = sum / (MB * ID * IH * IW); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(KERNEL_ATTR )==""\n"
R"==(__kernel void ref_bnorm_fwd(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global float *variance, __global DATA_T *dst, __global float *scale, )==""\n"
R"==(__global float *shift, __global char *ws, float eps, )==""\n"
R"==(__global DATA_T *src_add) { )==""\n"
R"==(const int n = GWS_GET_MB(); )==""\n"
R"==(const int c = GWS_GET_IC(); )==""\n"
R"==(const int d = GWS_GET_ID(); )==""\n"
R"==(const int h = GWS_GET_IH(); )==""\n"
R"==(const int w = GWS_GET_IW(); )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(float sm = scale[c]; )==""\n"
R"==(#else )==""\n"
R"==(float sm = 1; )==""\n"
R"==(#endif )==""\n"
R"==(#if USE_SHIFT == 1 )==""\n"
R"==(float sv = shift[c]; )==""\n"
R"==(#else )==""\n"
R"==(float sv = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#if SAVE_STATS == 0 && CALCULATE_STATS == 1 )==""\n"
R"==(variance += IC; )==""\n"
R"==(#endif )==""\n"
R"==(float v_mean = mean[c]; )==""\n"
R"==(float v_variance = variance[c]; )==""\n"
R"==(const int off = SRC_OFF(n, c, d, h, w); )==""\n"
R"==(float v0 = TO_DEF_ACC_DATA_T(src[off]); )==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(v_variance + eps); )==""\n"
R"==(float bn_res = sm * (v0 - v_mean) * sqrt_variance + sv; )==""\n"
R"==(#if FUSE_BN_ADD_RELU == 1 )==""\n"
R"==(bn_res += TO_DEF_ACC_DATA_T(src_add[off]); )==""\n"
R"==(#endif )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(if (bn_res <= 0) { )==""\n"
R"==(bn_res = 0; )==""\n"
R"==(#if IS_TRAINING == 1 )==""\n"
R"==(ws[off] = 0; )==""\n"
R"==(} else { )==""\n"
R"==(ws[off] = -1; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_RELU )==""\n"
R"==(bn_res = max(bn_res, 0.0f); )==""\n"
R"==(#endif )==""\n"
R"==(dst[off] = TO_DATA_T(bn_res); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_BWD == 1 )==""\n"
R"==(#if USE_16MB_UNROLL == 1 )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void calculate_stats(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global DATA_T *diff_dst, __global char *ws, )==""\n"
R"==(__global float *reduce_temp) { )==""\n"
R"==(const int mb = GWS_GET_STAT_MB(); )==""\n"
R"==(const int stat_mb_block_idx = mb / MB_BLOCK; )==""\n"
R"==(const int c = GWS_GET_STAT_IC(); )==""\n"
R"==(const int sp_beg = GWS_GET_STAT_SP(); )==""\n"
R"==(const int stat_sp_block = GWS_GET_STAT_SP_BLOCK(); )==""\n"
R"==(const int stat_sp_nblocks = ID * IH * IW / stat_sp_block; )==""\n"
R"==(const int stat_sp_block_idx = sp_beg / stat_sp_block; )==""\n"
R"==(const int mb_sp_idx )==""\n"
R"==(= stat_mb_block_idx * stat_sp_nblocks + stat_sp_block_idx; )==""\n"
R"==(const int s_off = c * ID * IH * IW * MB_BLOCK + mb * IC * ID * IH * IW )==""\n"
R"==(+ sp_beg * MB_BLOCK * IC_BLOCK; )==""\n"
R"==(src += s_off; )==""\n"
R"==(diff_dst += s_off; )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(ws += s_off; )==""\n"
R"==(#endif )==""\n"
R"==(VECT_FLOAT_T diff_gamma0 = 0.0f, diff_beta0 = 0.0f; )==""\n"
R"==(VECT_FLOAT_T diff_gamma1 = 0.0f, diff_beta1 = 0.0f; )==""\n"
R"==(float v_mean = as_float( )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)&mean[c])); )==""\n"
R"==(for (int sp = sp_beg; sp < sp_beg + stat_sp_block; sp++) { )==""\n"
R"==(VECT_FLOAT_T dd0 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&diff_dst[0]))); )==""\n"
R"==(VECT_FLOAT_T ss0 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[0]))); )==""\n"
R"==(#ifdef MB16 )==""\n"
R"==(VECT_FLOAT_T dd1 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ( )==""\n"
R"==((const __global BLOCK_DATA_T *)&diff_dst[8 * 16]))); )==""\n"
R"==(VECT_FLOAT_T ss1 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[8 * 16]))); )==""\n"
R"==(#endif )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(VECT_INT_T ws0 = VECT_CHAR_TO_INT(AS_VECT_CHAR_T( )==""\n"
R"==(VECT_UCHAR_READ((const __global uchar *)&ws[0]))); )==""\n"
R"==(dd0 = select((VECT_FLOAT_T)0.0f, dd0, ws0); )==""\n"
R"==(#ifdef MB16 )==""\n"
R"==(VECT_INT_T ws1 = VECT_CHAR_TO_INT(AS_VECT_CHAR_T( )==""\n"
R"==(VECT_UCHAR_READ((const __global uchar *)&ws[8 * 16]))); )==""\n"
R"==(dd1 = select((VECT_FLOAT_T)0.0f, dd1, ws1); )==""\n"
R"==(#endif )==""\n"
R"==(ws += MB_BLOCK * IC_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(diff_gamma0 = fma((ss0 - (VECT_FLOAT_T)v_mean), dd0, diff_gamma0); )==""\n"
R"==(diff_beta0 += dd0; )==""\n"
R"==(#ifdef MB16 )==""\n"
R"==(diff_gamma1 = fma((ss1 - (VECT_FLOAT_T)v_mean), dd1, diff_gamma1); )==""\n"
R"==(diff_beta1 += dd1; )==""\n"
R"==(#endif )==""\n"
R"==(src += MB_BLOCK * IC_BLOCK; )==""\n"
R"==(diff_dst += MB_BLOCK * IC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(#ifdef MB16 )==""\n"
R"==(float v_diff_gamma = 0.0f, v_diff_beta = 0.0; )==""\n"
R"==(for (int i = 0; i < 8; i++) { )==""\n"
R"==(v_diff_gamma += diff_gamma0[i] + diff_gamma1[i]; )==""\n"
R"==(v_diff_beta += diff_beta0[i] + diff_beta1[i]; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(float v_diff_gamma = diff_gamma0, v_diff_beta = diff_beta0; )==""\n"
R"==(#endif )==""\n"
R"==(intel_sub_group_block_write( )==""\n"
R"==((__global uint *)&reduce_temp[mb_sp_idx * IC + c], )==""\n"
R"==(as_uint(v_diff_gamma)); )==""\n"
R"==(intel_sub_group_block_write( )==""\n"
R"==((__global uint *)&reduce_temp[REDUCE_STAT_NBLOCKS * IC )==""\n"
R"==(+ mb_sp_idx * IC + c], )==""\n"
R"==(as_uint(v_diff_beta)); )==""\n"
R"==(} )==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE) )==""\n"
R"==(__kernel void reduce_stats(__global float *reduce_temp, )==""\n"
R"==(__global float *diff_scale, __global float *diff_shift, )==""\n"
R"==(__global float *variance, float eps) { )==""\n"
R"==(const int c = GWS_GET_REDUCE_STAT_IC(); )==""\n"
R"==(reduce_temp += c; )==""\n"
R"==(float diff_gamma = 0.0f, diff_beta = 0.0f; )==""\n"
R"==(for (int i = 0; i < REDUCE_STAT_NBLOCKS; i++) { )==""\n"
R"==(diff_gamma += reduce_temp[i * IC]; )==""\n"
R"==(diff_beta += reduce_temp[REDUCE_STAT_NBLOCKS * IC + i * IC]; )==""\n"
R"==(} )==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(variance[c] + eps); )==""\n"
R"==(diff_scale[c] = diff_gamma * sqrt_variance; )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(diff_shift[c] = diff_beta; )==""\n"
R"==(#else )==""\n"
R"==(diff_shift[REDUCE_STAT_NBLOCKS * IC + c] = diff_beta; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(NAMED_KERNEL_ATTR(CALC) )==""\n"
R"==(__kernel void calculate_stats(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global DATA_T *diff_dst, __global char *ws, )==""\n"
R"==(__global float *reduce_temp) { )==""\n"
R"==(float diff_gamma = 0; )==""\n"
R"==(float diff_beta = 0; )==""\n"
R"==(int x[5]; )==""\n"
R"==(x[0] = GWS_GET_STAT_MB(); )==""\n"
R"==(x[1] = GWS_GET_STAT_IC(); )==""\n"
R"==(x[2] = GWS_GET_STAT_ID(); )==""\n"
R"==(x[3] = GWS_GET_STAT_IH(); )==""\n"
R"==(x[4] = GWS_GET_STAT_IW(); )==""\n"
R"==(for (int i = 0; i < REDUCE_DIM; i++) { )==""\n"
R"==(x[REDUCE_DIM_IDX] = i; )==""\n"
R"==(int off = SRC_OFF(x[0], x[1], x[2], x[3], x[4]); )==""\n"
R"==(float dd = CONVERT_FLOAT_T(diff_dst[off]); )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(if (!ws[off]) dd = 0; )==""\n"
R"==(#endif )==""\n"
R"==(diff_gamma += (CONVERT_FLOAT_T(src[off]) - mean[x[1]]) * dd; )==""\n"
R"==(diff_beta += dd; )==""\n"
R"==(} )==""\n"
R"==(int ss_off = MB * ID * IH * IW * IC / REDUCE_DIM; )==""\n"
R"==(x[REDUCE_DIM_IDX] = 0; )==""\n"
R"==(int reduce_idx = reduce_index(x); )==""\n"
R"==(reduce_temp[reduce_idx * IC + x[1]] = diff_gamma; )==""\n"
R"==(reduce_temp[ss_off + reduce_idx * IC + x[1]] = diff_beta; )==""\n"
R"==(} )==""\n"
R"==(NAMED_KERNEL_ATTR(REDUCE) )==""\n"
R"==(__kernel void reduce_stats(__global float *reduce_temp, )==""\n"
R"==(__global float *diff_scale, __global float *diff_shift, )==""\n"
R"==(__global float *variance, float eps) { )==""\n"
R"==(const int c = GWS_GET_REDUCE_STAT_IC(); )==""\n"
R"==(float diff_gamma = 0.0f; )==""\n"
R"==(float diff_beta = 0.0f; )==""\n"
R"==(int reduce_size = MB * ID * IH * IW / REDUCE_DIM; )==""\n"
R"==(for (int i = 0; i < reduce_size; i++) { )==""\n"
R"==(diff_gamma += reduce_temp[c + i * IC]; )==""\n"
R"==(diff_beta += reduce_temp[IC * reduce_size + c + i * IC]; )==""\n"
R"==(} )==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(variance[c] + eps); )==""\n"
R"==(diff_scale[c] = diff_gamma * sqrt_variance; )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(diff_shift[c] = diff_beta; )==""\n"
R"==(#else )==""\n"
R"==(diff_shift[IC * reduce_size + c] = diff_beta; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(KERNEL_ATTR )==""\n"
R"==(__kernel void ref_bnorm_bwd(__global DATA_T *src, __global float *mean, )==""\n"
R"==(__global float *variance, __global DATA_T *diff_dst, )==""\n"
R"==(__global float *scale, __global char *ws, __global DATA_T *diff_src, )==""\n"
R"==(__global float *diff_scale, __global float *diff_shift, float eps, )==""\n"
R"==(__global DATA_T *diff_src_add) { )==""\n"
R"==(#if USE_16MB_UNROLL == 1 )==""\n"
R"==(const int n = GWS_GET_MB(); )==""\n"
R"==(const int c = GWS_GET_IC(); )==""\n"
R"==(const int d = GWS_GET_ID(); )==""\n"
R"==(const int h = GWS_GET_IH(); )==""\n"
R"==(const int w = GWS_GET_IW(); )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(float gamma = as_float( )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)&scale[c])); )==""\n"
R"==(#else )==""\n"
R"==(float gamma = 1.0f; )==""\n"
R"==(#endif )==""\n"
R"==(float v_variance = as_float( )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)&variance[c])); )==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(v_variance + eps); )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(float v_mean = as_float( )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)&mean[c])); )==""\n"
R"==(float diff_gamma = as_float( )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)&diff_scale[c])); )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(float diff_beta = as_float( )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)&diff_shift[c])); )==""\n"
R"==(#else )==""\n"
R"==(float diff_beta = as_float(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)&diff_shift[REDUCE_STAT_NBLOCKS * IC + c])); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif )==""\n"
R"==(const uint d_off = SRC_OFF(n, c, d, h, w); )==""\n"
R"==(diff_src += d_off; )==""\n"
R"==(#if FUSE_BN_ADD_RELU == 1 )==""\n"
R"==(diff_src_add += d_off; )==""\n"
R"==(#endif )==""\n"
R"==(diff_dst += d_off; )==""\n"
R"==(src += d_off; )==""\n"
R"==(VECT_FLOAT_T blockD0 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&diff_dst[0]))); )==""\n"
R"==(#ifdef MB16 )==""\n"
R"==(VECT_FLOAT_T blockD1 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ( )==""\n"
R"==((const __global BLOCK_DATA_T *)&diff_dst[8 * IC_BLOCK]))); )==""\n"
R"==(#endif )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(ws += d_off; )==""\n"
R"==(VECT_INT_T blockWS0 = VECT_CHAR_TO_INT( )==""\n"
R"==(AS_VECT_CHAR_T(VECT_UCHAR_READ((const __global uchar *)&ws[0]))); )==""\n"
R"==(blockD0 = select((VECT_FLOAT_T)0.0f, blockD0, blockWS0); )==""\n"
R"==(#if FUSE_BN_ADD_RELU == 1 )==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)&diff_src_add[0], )==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(blockD0))); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef MB16 )==""\n"
R"==(VECT_INT_T blockWS1 = VECT_CHAR_TO_INT(AS_VECT_CHAR_T( )==""\n"
R"==(VECT_UCHAR_READ((const __global uchar *)&ws[8 * IC_BLOCK]))); )==""\n"
R"==(blockD1 = select((VECT_FLOAT_T)0.0f, blockD1, blockWS1); )==""\n"
R"==(#if FUSE_BN_ADD_RELU == 1 )==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)&diff_src_add[8 * 16], )==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(blockD1))); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(gamma *= sqrt_variance; )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(diff_gamma *= sqrt_variance; )==""\n"
R"==(diff_gamma /= (MB * ID * IH * IW); )==""\n"
R"==(diff_beta /= (MB * ID * IH * IW); )==""\n"
R"==(VECT_FLOAT_T blockS0 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T( )==""\n"
R"==(VECT_BLOCK_READ((const __global BLOCK_DATA_T *)&src[0]))); )==""\n"
R"==(blockD0 -= fma((VECT_FLOAT_T)diff_gamma, (blockS0 - (VECT_FLOAT_T)v_mean), )==""\n"
R"==((VECT_FLOAT_T)diff_beta); )==""\n"
R"==(#ifdef MB16 )==""\n"
R"==(VECT_FLOAT_T blockS1 = CONVERT_VECT_FLOAT_T(AS_VECT_DATA_T(VECT_BLOCK_READ( )==""\n"
R"==((const __global BLOCK_DATA_T *)&src[8 * IC_BLOCK]))); )==""\n"
R"==(blockD1 -= fma((VECT_FLOAT_T)diff_gamma, (blockS1 - (VECT_FLOAT_T)v_mean), )==""\n"
R"==((VECT_FLOAT_T)diff_beta); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(blockD0 *= gamma; )==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)&diff_src[0], )==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(blockD0))); )==""\n"
R"==(#ifdef MB16 )==""\n"
R"==(blockD1 *= gamma; )==""\n"
R"==(VECT_BLOCK_WRITE((__global BLOCK_DATA_T *)&diff_src[8 * 16], )==""\n"
R"==(AS_VECT_BLOCK_DATA_T(CONVERT_VECTOR_DATA_T(blockD1))); )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(const int n = GWS_GET_MB(); )==""\n"
R"==(const int c = GWS_GET_IC(); )==""\n"
R"==(const int d = GWS_GET_ID(); )==""\n"
R"==(const int h = GWS_GET_IH(); )==""\n"
R"==(const int w = GWS_GET_IW(); )==""\n"
R"==(float v_variance = variance[c]; )==""\n"
R"==(float sqrt_variance = 1.0f / sqrt(v_variance + eps); )==""\n"
R"==(#if USE_SCALE == 1 )==""\n"
R"==(float gamma = scale[c]; )==""\n"
R"==(#else )==""\n"
R"==(float gamma = 1; )==""\n"
R"==(#endif )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(float v_mean = mean[c]; )==""\n"
R"==(float diff_gamma = diff_scale[c]; )==""\n"
R"==(#if DIFF_SHIFT == 1 )==""\n"
R"==(float diff_beta = diff_shift[c]; )==""\n"
R"==(#else )==""\n"
R"==(int reduce_size = MB * ID * IH * IW / REDUCE_DIM; )==""\n"
R"==(float diff_beta = diff_shift[reduce_size * IC + c]; )==""\n"
R"==(#endif  )==""\n"
R"==(#endif )==""\n"
R"==(const int off = SRC_OFF(n, c, d, h, w); )==""\n"
R"==(float dd = TO_DEF_ACC_DATA_T(diff_dst[off]); )==""\n"
R"==(#if FUSE_BN_RELU == 1 )==""\n"
R"==(if (!ws[off]) dd = 0; )==""\n"
R"==(#if FUSE_BN_ADD_RELU == 1 )==""\n"
R"==(diff_src_add[off] = TO_DATA_T(dd); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(float v_diff_src = dd; )==""\n"
R"==(#if CALCULATE_DIFF_STATS == 1 )==""\n"
R"==(v_diff_src -= diff_beta / (MB * ID * IH * IW) )==""\n"
R"==(+ (CONVERT_FLOAT_T(src[off]) - v_mean) * diff_gamma * sqrt_variance )==""\n"
R"==(/ (MB * ID * IH * IW); )==""\n"
R"==(#endif )==""\n"
R"==(v_diff_src *= gamma * sqrt_variance; )==""\n"
R"==(diff_src[off] = TO_DATA_T(v_diff_src); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==()==";
}
}
}
}