namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ref_matmul_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define offset6D(d0, d1, d2, d3, d4, d5, s0, s1, s2, s3, s4, s5) \ )==""\n"
R"==(((d0) * (s0) + (d1) * (s1) + (d2) * (s2) + (d3) * (s3) + (d4) * (s4) \ )==""\n"
R"==(+ (d5) * (s5)) )==""\n"
R"==(__kernel void ref_matmul(__global SRC_DATA_T *A, __global WEI_DATA_T *B, )==""\n"
R"==(__global DST_DATA_T *C, __global BIA_DATA_T *bia, __global int *a0, )==""\n"
R"==(__global int *b0, __global int *c0, __global float *src_scales, )==""\n"
R"==(__global float *wei_scales, long wei_scale_stride, )==""\n"
R"==(__global float *dst_scales, long K, long N, long M, long D0, long D1, )==""\n"
R"==(long D2, long bia_stride_d3, long bia_stride_d2, long bia_stride_d1, )==""\n"
R"==(long bia_stride_d0, long bia_stride_m, long bia_stride_n, )==""\n"
R"==(long a_stride_d3, long a_stride_d2, long a_stride_d1, long a_stride_d0, )==""\n"
R"==(long a_stride_m, long a_stride_k, long b_stride_d3, long b_stride_d2, )==""\n"
R"==(long b_stride_d1, long b_stride_d0, long b_stride_k, long b_stride_n, )==""\n"
R"==(long c_stride_d3, long c_stride_d2, long c_stride_d1, long c_stride_d0, )==""\n"
R"==(long c_stride_m, long c_stride_n POST_OP_ARGS) { )==""\n"
R"==(int n = get_global_id(1); )==""\n"
R"==(int mb = get_global_id(2); )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(int src_zp = a0[0]; )==""\n"
R"==(#else )==""\n"
R"==(int src_zp = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_WEI_ZPOINTS )==""\n"
R"==(int wei_zp = b0[0]; )==""\n"
R"==(#else )==""\n"
R"==(int wei_zp = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_DST_ZPOINTS )==""\n"
R"==(int dst_zp = c0[0]; )==""\n"
R"==(#else )==""\n"
R"==(int dst_zp = 0; )==""\n"
R"==(#endif )==""\n"
R"==(long d3 = mb / D0 / D1 / D2; )==""\n"
R"==(long d2 = (mb / D0 / D1) % D2; )==""\n"
R"==(long d1 = (mb / D0) % D1; )==""\n"
R"==(long d0 = mb % D0; )==""\n"
R"==(for (long m = 0; m < M; ++m) { )==""\n"
R"==(ACC_DATA_T acc = 0; )==""\n"
R"==(for (long k = 0; k < K; ++k) { )==""\n"
R"==(long src_off )==""\n"
R"==(= offset6D(m, k, d0, d1, d2, d3, a_stride_m, a_stride_k, )==""\n"
R"==(a_stride_d0, a_stride_d1, a_stride_d2, a_stride_d3); )==""\n"
R"==(long wei_off )==""\n"
R"==(= offset6D(k, n, d0, d1, d2, d3, b_stride_k, b_stride_n, )==""\n"
R"==(b_stride_d0, b_stride_d1, b_stride_d2, b_stride_d3); )==""\n"
R"==(acc += TO_ACC(SRC_TO_REF(A[src_off]) - src_zp) )==""\n"
R"==(* TO_ACC(WEI_TO_REF(B[wei_off]) - wei_zp); )==""\n"
R"==(} )==""\n"
R"==(long dst_off = offset6D(m, n, d0, d1, d2, d3, c_stride_m, c_stride_n, )==""\n"
R"==(c_stride_d0, c_stride_d1, c_stride_d2, c_stride_d3); )==""\n"
R"==(#if WITH_BIAS || NON_DEFAULT_ATTRS )==""\n"
R"==(POST_OP_DATA_T temp = (POST_OP_DATA_T)acc; )==""\n"
R"==(#if WITH_SRC_SCALES )==""\n"
R"==(temp *= src_scales[0]; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_WEI_SCALES )==""\n"
R"==(temp *= wei_scales[wei_scale_stride * n]; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(long bia_off = offset6D(m, n, d0, d1, d2, d3, bia_stride_m, )==""\n"
R"==(bia_stride_n, bia_stride_d0, bia_stride_d1, bia_stride_d2, )==""\n"
R"==(bia_stride_d3); )==""\n"
R"==(temp += bia[bia_off]; )==""\n"
R"==(#endif  )==""\n"
R"==(float dst_data; )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(dst_data = convert_float(DATA_TO_REF(C[dst_off])); )==""\n"
R"==(#endif  )==""\n"
R"==(float po_acc = convert_float(temp); )==""\n"
R"==(if (DST_NDIMS == 2) )==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, m, 1, n, 1, 0, )==""\n"
R"==(1, 0, 1, 0, 1, 0, 1); )==""\n"
R"==(if (DST_NDIMS == 3) )==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, d0, 1, m, 1, )==""\n"
R"==(n, 1, 0, 1, 0, 1, 0, 1); )==""\n"
R"==(if (DST_NDIMS == 4) )==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, d1, 1, d0, 1, )==""\n"
R"==(m, 1, n, 1, 0, 1, 0, 1); )==""\n"
R"==(if (DST_NDIMS == 5) )==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, d2, 1, d1, 1, )==""\n"
R"==(d0, 1, m, 1, n, 1, 0, 1); )==""\n"
R"==(if (DST_NDIMS == 6) )==""\n"
R"==(APPLY_POST_OPS_SERIAL(po_acc, float, dst_data, float, d3, 1, d2, 1, )==""\n"
R"==(d1, 1, d0, 1, m, 1, n, 1); )==""\n"
R"==(#if WITH_DST_SCALES )==""\n"
R"==(po_acc /= dst_scales[0]; )==""\n"
R"==(#endif )==""\n"
R"==(po_acc += dst_zp; )==""\n"
R"==(C[dst_off] = TO_DST(po_acc); )==""\n"
R"==(#else  )==""\n"
R"==(C[dst_off] = TO_DST(acc); )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}