namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ref_reduction_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if defined(IS_MAX) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MIN) )==""\n"
R"==(#elif defined(IS_MIN) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_MAX) )==""\n"
R"==(#elif defined(IS_MUL) )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ONE) )==""\n"
R"==(#else )==""\n"
R"==(#define INIT_ACC TO_DEF_ACC_DATA_T(DATA_ZERO) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(IS_MAX) )==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8) )==""\n"
R"==(#define ACCUMULATE(x, y) max(x, y) )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE(x, y) fmax(x, y) )==""\n"
R"==(#endif )==""\n"
R"==(#elif defined(IS_MIN) )==""\n"
R"==(#if defined(SRC_DT_S8) || defined(SRC_DT_U8) )==""\n"
R"==(#define ACCUMULATE(x, y) min(x, y) )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE(x, y) fmin(x, y) )==""\n"
R"==(#endif )==""\n"
R"==(#elif defined(IS_MEAN) || defined(IS_SUM) )==""\n"
R"==(#define ACCUMULATE(x, y) (x + y) )==""\n"
R"==(#elif defined(IS_MUL) )==""\n"
R"==(#define ACCUMULATE(x, y) (x * y) )==""\n"
R"==(#else )==""\n"
R"==(#define ACCUMULATE(x, y) (x + pow(fabs(y), POWER)) )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(IS_MEAN) )==""\n"
R"==(#define FINALIZE(x) (x / DIV) )==""\n"
R"==(#elif defined(IS_LP_MAX) )==""\n"
R"==(#define FINALIZE(x) rootn(fmax(x, EPS), POWER) )==""\n"
R"==(#elif defined(IS_LP_SUM) )==""\n"
R"==(#define FINALIZE(x) rootn(x + EPS, POWER) )==""\n"
R"==(#elif defined(IS_P_MAX) )==""\n"
R"==(#define FINALIZE(x) fmax(x, EPS) )==""\n"
R"==(#elif defined(IS_P_SUM) )==""\n"
R"==(#define FINALIZE(x) (x + EPS) )==""\n"
R"==(#else )==""\n"
R"==(#define FINALIZE(x) (x) )==""\n"
R"==(#endif )==""\n"
R"==(#if NDIMS == 6 )==""\n"
R"==(#define _SRC_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(SRC, x0, x1, x2, x3, x4, x5) )==""\n"
R"==(#define _DST_OFF(x0, x1, x2, x3, x4, x5) OFF_MD(DST, x0, x1, x2, x3, x4, x5) )==""\n"
R"==(#elif NDIMS == 1 )==""\n"
R"==(#define _SRC_OFF(x0, x1, x2, x3, x4, x5) (x0) )==""\n"
R"==(#define _DST_OFF(x0, x1, x2, x3, x4, x5) (x0) )==""\n"
R"==(#else )==""\n"
R"==(#define _SRC_OFF(x0, x1, ignore, x3, x4, x5) SRC_OFF(x0, x1, x3, x4, x5) )==""\n"
R"==(#define _DST_OFF(x0, x1, ignore, x3, x4, x5) DST_OFF(x0, x1, x3, x4, x5) )==""\n"
R"==(#endif )==""\n"
R"==(#if NDIMS == 6 )==""\n"
R"==(#define ITERATE_OVER_REDUCTION_D2 \ )==""\n"
R"==(for_(int d2_off = 0; d2_off < REDUCTION_D2; d2_off++) )==""\n"
R"==(#define D2_OFF d2_off )==""\n"
R"==(#else )==""\n"
R"==(#define ITERATE_OVER_REDUCTION_D2 )==""\n"
R"==(#define D2_OFF 0 )==""\n"
R"==(#endif )==""\n"
R"==(#define _DST_OFF_MODULO_DIM(x0, x1, x2, x3, x4, x5) \ )==""\n"
R"==(({ \ )==""\n"
R"==(int ret_val; \ )==""\n"
R"==(if (NDIMS == 1) \ )==""\n"
R"==(ret_val = _DST_OFF(x0 % DST_D0, 0, 0, 0, 0, 0); \ )==""\n"
R"==(else if (NDIMS == 2) \ )==""\n"
R"==(ret_val = _DST_OFF(x0 % DST_D0, x1 % DST_D1, 0, 0, 0, 0); \ )==""\n"
R"==(else if (NDIMS == 3) \ )==""\n"
R"==(ret_val = _DST_OFF( \ )==""\n"
R"==(x0 % DST_D0, x1 % DST_D1, 0, 0, 0, x5 % DST_D2); \ )==""\n"
R"==(else if (NDIMS == 4) \ )==""\n"
R"==(ret_val = _DST_OFF( \ )==""\n"
R"==(x0 % DST_D0, x1 % DST_D1, 0, 0, x4 % DST_D2, x5 % DST_D3); \ )==""\n"
R"==(else if (NDIMS == 5) \ )==""\n"
R"==(ret_val = _DST_OFF(x0 % DST_D0, x1 % DST_D1, 0, x3 % DST_D2, \ )==""\n"
R"==(x4 % DST_D3, x5 % DST_D4); \ )==""\n"
R"==(else \ )==""\n"
R"==(ret_val = _DST_OFF(x0 % DST_D0, x1 % DST_D1, x2 % DST_D2, \ )==""\n"
R"==(x3 % DST_D3, x4 % DST_D4, x5 % DST_D5); \ )==""\n"
R"==(ret_val; \ )==""\n"
R"==(}) )==""\n"
R"==(__kernel void ref_reduce( )==""\n"
R"==(__global SRC_DATA_T *src, __global DST_DATA_T *dst POST_OP_ARGS) { )==""\n"
R"==(int d0 = GWS_GET_D0(); )==""\n"
R"==(int d1 = GWS_GET_D1(); )==""\n"
R"==(int d2 = GWS_GET_D2(); )==""\n"
R"==(int d3 = GWS_GET_D3(); )==""\n"
R"==(int d4 = GWS_GET_D4(); )==""\n"
R"==(int d5 = GWS_GET_D5(); )==""\n"
R"==(DEF_ACC_DATA_T acc = INIT_ACC; )==""\n"
R"==(for_(int d0_off = 0; d0_off < REDUCTION_D0; d0_off++) )==""\n"
R"==(for_(int d1_off = 0; d1_off < REDUCTION_D1; d1_off++) )==""\n"
R"==(ITERATE_OVER_REDUCTION_D2 )==""\n"
R"==(for_(int d3_off = 0; d3_off < REDUCTION_D3; d3_off++) )==""\n"
R"==(for_(int d4_off = 0; d4_off < REDUCTION_D4; d4_off++) )==""\n"
R"==(for_(int d5_off = 0; d5_off < REDUCTION_D5; d5_off++) )==""\n"
R"==({ )==""\n"
R"==(const int src_off = _SRC_OFF(d0 + d0_off, d1 + d1_off, d2 + D2_OFF, )==""\n"
R"==(d3 + d3_off, d4 + d4_off, d5 + d5_off); )==""\n"
R"==(acc = ACCUMULATE(acc, TO_DEF_ACC_DATA_T(src[src_off])); )==""\n"
R"==(} )==""\n"
R"==(float res = convert_float(acc); )==""\n"
R"==(res = FINALIZE(res); )==""\n"
R"==(const int dst_off = _DST_OFF_MODULO_DIM(d0, d1, d2, d3, d4, d5); )==""\n"
R"==(const int dst_off_pd = _DST_OFF(d0, d1, d2, d3, d4, d5); )==""\n"
R"==(float dst_val; )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(dst_val = DST_TO_REF(dst[dst_off]); )==""\n"
R"==(#endif )==""\n"
R"==(#if NDIMS == 4 )==""\n"
R"==(#if REDUCTION_D1 != 1 )==""\n"
R"==(d1 = 0; )==""\n"
R"==(d2 = d4; )==""\n"
R"==(d3 = d5; )==""\n"
R"==(#elif REDUCTION_D4 != 1 )==""\n"
R"==(d2 = 0; )==""\n"
R"==(d3 = d5; )==""\n"
R"==(#elif REDUCTION_D5 != 1 )==""\n"
R"==(d2 = d4; )==""\n"
R"==(d3 = 0; )==""\n"
R"==(#endif )==""\n"
R"==(APPLY_POST_OPS_SERIAL( )==""\n"
R"==(res, float, dst_val, float, d0, 1, d1, 1, d2, 1, d3, 1, 0, 1, 0, 1); )==""\n"
R"==(#elif NDIMS == 5 )==""\n"
R"==(#if REDUCTION_D1 != 1 )==""\n"
R"==(d1 = 0; )==""\n"
R"==(#elif REDUCTION_D5 != 1 )==""\n"
R"==(d5 = 0; )==""\n"
R"==(#endif )==""\n"
R"==(APPLY_POST_OPS_SERIAL(res, float, dst_val, float, d0, 1, d1, 1, d3, 1, d4, )==""\n"
R"==(1, d5, 1, 0, 1); )==""\n"
R"==(#else )==""\n"
R"==(APPLY_POST_OPS_SERIAL(res, float, dst_val, float, d0, 1, d1, 1, d2, 1, d3, )==""\n"
R"==(1, d4, 1, d5, 1); )==""\n"
R"==(#endif )==""\n"
R"==(if (dst_off_pd != dst_off) res = 0.f; )==""\n"
R"==(dst[dst_off_pd] = TO_DST(res); )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}