namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *ref_rnn_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/rnn/rnn_types.h" )==""\n"
R"==(float one_m_square(float a) { )==""\n"
R"==(return 1.0f - a * a; )==""\n"
R"==(} )==""\n"
R"==(float x_m_square(float a) { )==""\n"
R"==(return (1.0f - a) * a; )==""\n"
R"==(} )==""\n"
R"==(float relu_fwd(float s, float alpha) { )==""\n"
R"==(return s > 0 ? s : s * alpha; )==""\n"
R"==(} )==""\n"
R"==(float tanh_fwd(float s) { )==""\n"
R"==(return tanh(s); )==""\n"
R"==(} )==""\n"
R"==(float logistic_fwd(float s) { )==""\n"
R"==(return 1 / (1 + exp((float)-s)); )==""\n"
R"==(} )==""\n"
R"==(float logistic_bwd(float s) { )==""\n"
R"==(return x_m_square(s); )==""\n"
R"==(} )==""\n"
R"==(float relu_bwd(float s, float alpha) { )==""\n"
R"==(return s > 0 ? 1.f : alpha; )==""\n"
R"==(} )==""\n"
R"==(float tanh_bwd(float s) { )==""\n"
R"==(return (1 - s) * (1 + s); )==""\n"
R"==(} )==""\n"
R"==(float linear(float s, float alpha) { )==""\n"
R"==(return alpha * s; )==""\n"
R"==(} )==""\n"
R"==(float relu_fwd_tm(float s, float alpha) { )==""\n"
R"==(#if !IS_TESTMODE )==""\n"
R"==(return relu_fwd(s, alpha); )==""\n"
R"==(#else )==""\n"
R"==(return linear(s, alpha); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(float tanh_fwd_tm(float s, float alpha) { )==""\n"
R"==(#if !IS_TESTMODE )==""\n"
R"==(return tanh(s); )==""\n"
R"==(#else )==""\n"
R"==(return linear(s, alpha); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(float logistic_fwd_tm(float s, float alpha) { )==""\n"
R"==(#if !IS_TESTMODE )==""\n"
R"==(return logistic_fwd(s); )==""\n"
R"==(#else )==""\n"
R"==(return linear(s, alpha); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(float relu_bwd_tm(float s, float alpha) { )==""\n"
R"==(#if !IS_TESTMODE )==""\n"
R"==(return relu_bwd(s, alpha); )==""\n"
R"==(#else )==""\n"
R"==(return linear(s, alpha); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(float tanh_bwd_tm(float s, float alpha) { )==""\n"
R"==(#if !IS_TESTMODE )==""\n"
R"==(return tanh_bwd(s); )==""\n"
R"==(#else )==""\n"
R"==(return linear(s, alpha); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(float logistic_bwd_tm(float s, float alpha) { )==""\n"
R"==(#if !IS_TESTMODE )==""\n"
R"==(return logistic_bwd(s); )==""\n"
R"==(#else )==""\n"
R"==(return linear(s, alpha); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(float activation_fwd(float s, float alpha, float cliping) { )==""\n"
R"==(#if CELL_KIND == VANILLA_RNN )==""\n"
R"==(#if ACTIVATION_KIND == ELTWISE_RELU )==""\n"
R"==(return relu_fwd_tm(s, alpha); )==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_TANH )==""\n"
R"==(return tanh_fwd_tm(s, alpha); )==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_LOGISTIC )==""\n"
R"==(return logistic_fwd_tm(s, alpha); )==""\n"
R"==(#else )==""\n"
R"==(#error "Unsupported activation_kind" )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(return 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(float activation_bwd(float s, float alpha, float cliping) { )==""\n"
R"==(#if CELL_KIND == VANILLA_RNN )==""\n"
R"==(#if ACTIVATION_KIND == ELTWISE_RELU )==""\n"
R"==(return relu_bwd_tm(s, alpha); )==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_TANH )==""\n"
R"==(return tanh_bwd_tm(s, alpha); )==""\n"
R"==(#elif ACTIVATION_KIND == ELTWISE_LOGISTIC )==""\n"
R"==(return logistic_bwd_tm(s, alpha); )==""\n"
R"==(#else )==""\n"
R"==(#error "Unsupported activation_kind" )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(return 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void )==""\n"
R"==(ref_rnn_copy_init_layer(__global char *ws, __global char *src_base, )==""\n"
R"==(__global char *scratch_diff_states, int lr, int rl) { )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(const int it = get_global_id(2); )==""\n"
R"==(const int b = get_global_id(1); )==""\n"
R"==(const int c = get_global_id(0); )==""\n"
R"==(if (c >= SLC || b >= BATCH || it >= N_ITER) return; )==""\n"
R"==(__global WS_STATE_DATA_T *dst; )==""\n"
R"==(__global WS_STATE_DATA_T *dst_base )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET); )==""\n"
R"==(__global WS_STATE_DATA_T *src = (__global WS_STATE_DATA_T *)src_base )==""\n"
R"==(+ SRC_L_OFF(it, 0, 0) + b * SLC + c; )==""\n"
R"==(if (lr) { )==""\n"
R"==(dst = dst_base + OFF_WS_STATE(0, 0, it + 1, b, c); )==""\n"
R"==(dst[0] = src[0]; )==""\n"
R"==(} )==""\n"
R"==(if (rl) { )==""\n"
R"==(dst = dst_base + OFF_WS_STATE(0, N_DIR - 1, N_ITER - it, b, c); )==""\n"
R"==(dst[0] = src[0]; )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(const int it = get_global_id(1); )==""\n"
R"==(const int b = get_global_id(0); )==""\n"
R"==(if (b >= BATCH || it >= N_ITER) return; )==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)scratch_diff_states; )==""\n"
R"==(#if DIRECTION_KIND == CONCAT )==""\n"
R"==(__global DIFF_DATA_T *src )==""\n"
R"==(= (__global DIFF_DATA_T *)src_base + DIFF_DST_L_OFF(it, b, 0); )==""\n"
R"==(for (int s = 0; s < DHC; s++) { )==""\n"
R"==(dst[OFF_SCRATCH_DIFF_STATES(N_LAYER, 0, N_STATES, it, b, s)] = src[s]; )==""\n"
R"==(dst[OFF_SCRATCH_DIFF_STATES( )==""\n"
R"==(N_LAYER, 1, N_STATES, N_ITER - it - 1, b, s)] )==""\n"
R"==(= src[DHC + s]; )==""\n"
R"==(} )==""\n"
R"==(#elif DIRECTION_KIND == SUM )==""\n"
R"==(__global DIFF_DATA_T *src )==""\n"
R"==(= (__global DIFF_DATA_T *)src_base + DIFF_DST_L_OFF(it, b, 0); )==""\n"
R"==(for (int s = 0; s < DHC; s++) { )==""\n"
R"==(dst[OFF_SCRATCH_DIFF_STATES(N_LAYER, 0, N_STATES, it, b, s)] = src[s]; )==""\n"
R"==(dst[OFF_SCRATCH_DIFF_STATES( )==""\n"
R"==(N_LAYER, 1, N_STATES, N_ITER - it - 1, b, s)] )==""\n"
R"==(= src[s]; )==""\n"
R"==(} )==""\n"
R"==(#elif DIRECTION_KIND == L2R )==""\n"
R"==(__global DIFF_DATA_T *src )==""\n"
R"==(= (__global DIFF_DATA_T *)src_base + DIFF_DST_L_OFF(it, b, 0); )==""\n"
R"==(for (int s = 0; s < DHC; s++) { )==""\n"
R"==(dst[OFF_SCRATCH_DIFF_STATES(N_LAYER, 0, N_STATES, it, b, s)] = src[s]; )==""\n"
R"==(} )==""\n"
R"==(#elif DIRECTION_KIND == R2L )==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)src_base )==""\n"
R"==(+ DIFF_DST_L_OFF(N_ITER - it - 1, b, 0); )==""\n"
R"==(for (int s = 0; s < DHC; s++) { )==""\n"
R"==(dst[OFF_SCRATCH_DIFF_STATES(N_LAYER, 0, N_STATES, it, b, s)] = src[s]; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#error "Unsupported direction_kind" )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(__kernel void ref_rnn_copy_init_iter(__global char *ws, __global char *src_base, )==""\n"
R"==(__global char *src_c_base, __global char *scratch_diff_states )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(, )==""\n"
R"==(const float shift, const float scale, const int quantize )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(const int s = get_global_id(0); )==""\n"
R"==(const int b = get_global_id(1); )==""\n"
R"==(const int lay = get_global_id(2) / N_DIR; )==""\n"
R"==(const int dir = get_global_id(2) % N_DIR; )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(__global INPUT_DATA_T *src = (__global INPUT_DATA_T *)(src_base); )==""\n"
R"==(__global WS_STATE_DATA_T *dst )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET); )==""\n"
R"==(if (s < SIC) )==""\n"
R"==(dst[OFF_WS_STATE(lay + 1, dir, 0, b, s)] = src_base )==""\n"
R"==(? (quantize ? TO_WS_STATE( )==""\n"
R"==(src[SRC_I_OFF(lay, dir, b, s)] * scale + shift) )==""\n"
R"==(: src[SRC_I_OFF(lay, dir, b, s)]) )==""\n"
R"==(: TO_WS_STATE(0.0f); )==""\n"
R"==(#if WITH_SRC_ITER_C )==""\n"
R"==(__global AUX_DATA_T *src_c = (__global AUX_DATA_T *)(src_c_base); )==""\n"
R"==(__global AUX_DATA_T *dst_c )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET); )==""\n"
R"==(if (s < DHC) )==""\n"
R"==(dst_c[OFF_WS_STATE(lay + 1, dir, 0, b, s)] = src_c_base )==""\n"
R"==(? src_c[SRC_I_C_OFF(lay, dir, b, s)] )==""\n"
R"==(: TO_WS_STATE(0.0f); )==""\n"
R"==(#endif )==""\n"
R"==(#else  )==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)(src_base); )==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)scratch_diff_states; )==""\n"
R"==(if (s < DHC) )==""\n"
R"==(dst[OFF_SCRATCH_DIFF_STATES(lay, dir, 0, N_ITER, b, s)] )==""\n"
R"==(= src_base ? src[DIFF_DST_I_OFF(lay, dir, b, s)] : 0.0f; )==""\n"
R"==(#if WITH_DST_ITER_C )==""\n"
R"==(__global DIFF_DATA_T *src_c = (__global DIFF_DATA_T *)(src_c_base); )==""\n"
R"==(if (s < DHC) )==""\n"
R"==(dst[OFF_SCRATCH_DIFF_STATES(lay, dir, 1, N_ITER, b, s)] )==""\n"
R"==(= src_c_base ? src_c[DIFF_DST_I_C_OFF(lay, dir, b, s)] : 0.0f; )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void )==""\n"
R"==(ref_rnn_copy_res_layer(__global char *ws, __global char *dst_base, )==""\n"
R"==(__global char *scratch_diff_states, int lr, int rl )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(, )==""\n"
R"==(const float shift, const float scale, const int dequantize )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(const int it = get_global_id(2); )==""\n"
R"==(const int b = get_global_id(1); )==""\n"
R"==(const int s = get_global_id(0); )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(if (s >= DHC || b >= BATCH || it >= N_ITER) return; )==""\n"
R"==(__global WS_STATE_DATA_T *src )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET); )==""\n"
R"==(__global DST_DATA_T *dst = (__global DST_DATA_T *)(dst_base); )==""\n"
R"==(int dir = 0; )==""\n"
R"==(if (lr) { )==""\n"
R"==(bool dequantize_at_copy = dequantize && DIRECTION_KIND != SUM; )==""\n"
R"==(dst[DST_L_OFF(it, b, dir * DHC + s)] = dequantize_at_copy )==""\n"
R"==(? TO_DST(((float)src[OFF_WS_STATE(N_LAYER, dir, it + 1, b, s)] )==""\n"
R"==(- shift) )==""\n"
R"==(/ scale) )==""\n"
R"==(: src[OFF_WS_STATE(N_LAYER, dir, it + 1, b, s)]; )==""\n"
R"==(dir = 1; )==""\n"
R"==(} )==""\n"
R"==(if (rl) { )==""\n"
R"==(#if DIRECTION_KIND == SUM )==""\n"
R"==(if (dequantize) { )==""\n"
R"==(float val )==""\n"
R"==(= (float)src[OFF_WS_STATE(N_LAYER, dir, N_ITER - it, b, s)] )==""\n"
R"==(+ dst[DST_L_OFF(it, b, s)]; )==""\n"
R"==(val = min(max(val, 0.f), 255.f); )==""\n"
R"==(dst[DST_L_OFF(it, b, s)] = TO_DST((val - 2 * shift) / scale); )==""\n"
R"==(} else { )==""\n"
R"==(#if defined(SRC_DT_U8) && defined(DST_DT_U8) )==""\n"
R"==(dst[DST_L_OFF(it, b, s)] = convert_uchar_sat( )==""\n"
R"==(convert_short( )==""\n"
R"==(src[OFF_WS_STATE(N_LAYER, dir, N_ITER - it, b, s)]) )==""\n"
R"==(+ convert_short(dst[DST_L_OFF(it, b, s)])); )==""\n"
R"==(#else )==""\n"
R"==(ACC_DATA_T temp_src = DST_TO_REF(dst[DST_L_OFF(it, b, s)]); )==""\n"
R"==(temp_src += DST_TO_REF( )==""\n"
R"==(src[OFF_WS_STATE(N_LAYER, dir, N_ITER - it, b, s)]); )==""\n"
R"==(dst[DST_L_OFF(it, b, s)] = REF_TO_DST(temp_src); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(dst[DST_L_OFF(it, b, dir * DHC + s)] = dequantize )==""\n"
R"==(? TO_DST(((float)src[OFF_WS_STATE( )==""\n"
R"==(N_LAYER, dir, N_ITER - it, b, s)] )==""\n"
R"==(- shift) )==""\n"
R"==(/ scale) )==""\n"
R"==(: src[OFF_WS_STATE(N_LAYER, dir, N_ITER - it, b, s)]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else  )==""\n"
R"==(if (s >= SLC || b >= BATCH || it >= N_ITER) return; )==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)(scratch_diff_states); )==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(dst_base); )==""\n"
R"==(int dir = 0; )==""\n"
R"==(#if DIRECTION_KIND == R2L )==""\n"
R"==(const int iter = N_ITER - 1 - it; )==""\n"
R"==(#else )==""\n"
R"==(const int iter = it; )==""\n"
R"==(#endif )==""\n"
R"==(DIFF_DATA_T res = src[OFF_SCRATCH_DIFF_STATES(0, 0, N_STATES, it, b, s)]; )==""\n"
R"==(#if N_DIR > 1 )==""\n"
R"==(res += src[OFF_SCRATCH_DIFF_STATES(0, 1, N_STATES, N_ITER - 1 - it, b, s)]; )==""\n"
R"==(#endif )==""\n"
R"==(dst[DIFF_SRC_L_OFF(iter, b, dir * SLC + s)] = res; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(__kernel void ref_rnn_copy_res_iter(__global char *ws, __global char *dst_base, )==""\n"
R"==(__global char *dst_c_base, __global char *scratch_diff_states )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(, )==""\n"
R"==(const float shift, const float scale, const int dequantize )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(const int s = get_global_id(0); )==""\n"
R"==(const int b = get_global_id(1); )==""\n"
R"==(const int lay = get_global_id(2) / N_DIR; )==""\n"
R"==(const int dir = get_global_id(2) % N_DIR; )==""\n"
R"==(#if IS_FWD )==""\n"
R"==(__global WS_STATE_DATA_T *src )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET); )==""\n"
R"==(__global OUTPUT_DATA_T *dst = (__global OUTPUT_DATA_T *)(dst_base); )==""\n"
R"==(if (dst_base && s < DHC) { )==""\n"
R"==(dst[DST_I_OFF(lay, dir, b, s)] = dequantize )==""\n"
R"==(? TO_OUTPUT( )==""\n"
R"==(((float)src[OFF_WS_STATE(lay + 1, dir, N_ITER, b, s)] )==""\n"
R"==(- shift) )==""\n"
R"==(/ scale) )==""\n"
R"==(: TO_OUTPUT(src[OFF_WS_STATE(lay + 1, dir, N_ITER, b, s)]); )==""\n"
R"==(} )==""\n"
R"==(#if WITH_DST_ITER_C )==""\n"
R"==(__global AUX_DATA_T *src_c )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET); )==""\n"
R"==(__global AUX_DATA_T *dst_c = (__global AUX_DATA_T *)(dst_c_base); )==""\n"
R"==(if (dst_c_base && s < DHC) { )==""\n"
R"==(dst_c[DST_I_C_OFF(lay, dir, b, s)] )==""\n"
R"==(= src_c[OFF_WS_STATE(lay + 1, dir, N_ITER, b, s)]; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#else  )==""\n"
R"==(__global DIFF_DATA_T *src = (__global DIFF_DATA_T *)(scratch_diff_states); )==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(dst_base); )==""\n"
R"==(__global DIFF_DATA_T *dst_c = (__global DIFF_DATA_T *)(dst_c_base); )==""\n"
R"==(if (dst_base && s < SIC) { )==""\n"
R"==(dst[DIFF_SRC_I_OFF(lay, dir, b, s)] )==""\n"
R"==(= src[OFF_SCRATCH_DIFF_STATES(lay, dir, 0, 0, b, s)]; )==""\n"
R"==(} )==""\n"
R"==(#if WITH_SRC_ITER_C )==""\n"
R"==(if (dst_base && s < DHC) { )==""\n"
R"==(dst_c[DIFF_SRC_I_C_OFF(lay, dir, b, s)] )==""\n"
R"==(= src[OFF_SCRATCH_DIFF_STATES(lay, dir, 1, 0, b, s)]; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(__kernel void ref_rnn_ws_set( )==""\n"
R"==(__global char *ws, OFFTYPE ws_offset, float val, int ws_part) { )==""\n"
R"==(if (ws_part == WS_C_STATES || ws_part == WS_BIAS) { )==""\n"
R"==(__global DIFF_DATA_T *dst = (__global DIFF_DATA_T *)(ws + ws_offset); )==""\n"
R"==(dst[get_global_id(0)] = CONVERT_DATA_T(val); )==""\n"
R"==(} else if (ws_part == WS_GATES) { )==""\n"
R"==(__global ACC_DATA_T *dst = (__global ACC_DATA_T *)(ws + ws_offset); )==""\n"
R"==(dst[get_global_id(0)] = TO_ACC(val); )==""\n"
R"==(} else {  )==""\n"
R"==(__global WS_STATE_DATA_T *dst )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + ws_offset); )==""\n"
R"==(dst[get_global_id(0)] = TO_WS_STATE(val); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if DEBUGPRINT )==""\n"
R"==(__kernel void ref_rnn_ws_print(const __global char *ws) { )==""\n"
R"==({ )==""\n"
R"==(__global ACC_DATA_T *wt = (__global ACC_DATA_T *)(ws + WS_GATES_OFFSET); )==""\n"
R"==(printf("ws_gates: off %d\n", WS_GATES_OFFSET); )==""\n"
R"==(printf("[lay,dir,iter,batch]\n"); )==""\n"
R"==(for_(int j = 0; j < N_LAYER; j++) )==""\n"
R"==(for_(int dir = 0; dir < N_DIR; dir++) )==""\n"
R"==(for_(int i = 0; i < N_ITER; i++) )==""\n"
R"==(for (int b = 0; b < BATCH; b++) { )==""\n"
R"==(printf("[%d,%d,%d,%d]: ", j, dir, i, b); )==""\n"
R"==(for_(int g = 0; g < N_GATES; g++) )==""\n"
R"==(for (int s = 0; s < DHC; s++) { )==""\n"
R"==(printf(" %f", )==""\n"
R"==(SRC_TO_REF(*(wt + OFF_WS_GATES(j, dir, i, b, g, s)))); )==""\n"
R"==(} )==""\n"
R"==(printf("\n"); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==({ )==""\n"
R"==(__global WS_STATE_DATA_T *wt )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET); )==""\n"
R"==(printf("ws_states (H): off %d\n", WS_STATES_OFFSET); )==""\n"
R"==(printf("[lay,dir,iter]\n"); )==""\n"
R"==(for_(int j = 0; j < N_LAYER + 1; j++) )==""\n"
R"==(for_(int dir = 0; dir < N_DIR; dir++) )==""\n"
R"==(for (int i = 1; i < N_ITER + 1; i++) { )==""\n"
R"==(printf("[%d,%d,%d] : ", j, dir, i); )==""\n"
R"==(for_(int b = 0; b < BATCH; b++) )==""\n"
R"==(for (int s = 0; s < WIC; s++) { )==""\n"
R"==(printf(" %f", )==""\n"
R"==(SRC_TO_REF(*(wt + OFF_WS_STATE(j, dir, i, b, s)))); )==""\n"
R"==(} )==""\n"
R"==(printf("\n"); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if IS_TRAINING && CELL_KIND == LBR_GRU )==""\n"
R"==({ )==""\n"
R"==(__global ACC_DATA_T *wt )==""\n"
R"==(= (__global ACC_DATA_T *)(ws + WS_GRID_COMP_OFFSET); )==""\n"
R"==(printf("ws_grid: off %d\n", WS_GRID_COMP_OFFSET); )==""\n"
R"==(printf("[lay,dir,iter,batch]\n"); )==""\n"
R"==(for_(int j = 0; j < N_LAYER; j++) )==""\n"
R"==(for_(int dir = 0; dir < N_DIR; dir++) )==""\n"
R"==(for_(int i = 0; i < N_ITER; i++) )==""\n"
R"==(for (int b = 0; b < BATCH; b++) { )==""\n"
R"==(printf("[%d,%d,%d,%d]: ", j, dir, i, b); )==""\n"
R"==(for (int s = 0; s < DHC; s++) { )==""\n"
R"==(printf(" %f", *(wt + OFF_WS_GRID_OFFSET(j, dir, i, b, s))); )==""\n"
R"==(} )==""\n"
R"==(printf("\n"); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_FWD && CELL_KIND == VANILLA_LSTM )==""\n"
R"==({ )==""\n"
R"==(__global AUX_DATA_T *wt )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET); )==""\n"
R"==(printf("ws_states (C): off %d\n", WS_C_STATE_OFFSET); )==""\n"
R"==(printf("[lay,dir,iter]\n"); )==""\n"
R"==(for_(int j = 0; j < N_LAYER; j++) )==""\n"
R"==(for_(int dir = 0; dir < N_DIR; dir++) )==""\n"
R"==(for (int i = 0; i < N_ITER + 1; i++) { )==""\n"
R"==(printf("[%d,%d,%d] : ", j, dir, i); )==""\n"
R"==(for_(int b = 0; b < BATCH; b++) )==""\n"
R"==(for (int s = 0; s < WIC; s++) { )==""\n"
R"==(printf(" %f", *(wt + OFF_WS_STATE(j, dir, i, b, s))); )==""\n"
R"==(} )==""\n"
R"==(printf("\n"); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if COPY_BIAS )==""\n"
R"==({ )==""\n"
R"==(__global AUX_DATA_T *wt = (__global AUX_DATA_T *)(ws + WS_BIAS_OFFSET); )==""\n"
R"==(printf("ws_bias: off %d\n", WS_BIAS_OFFSET); )==""\n"
R"==(printf("[lay,dir]\n"); )==""\n"
R"==(for_(int j = 0; j < N_LAYER; j++) )==""\n"
R"==(for_(int dir = 0; dir < N_DIR; dir++) )==""\n"
R"==({ )==""\n"
R"==(printf("[%d,%d] : ", j, dir); )==""\n"
R"==(for_(int nb = 0; nb < N_BIAS; nb++) )==""\n"
R"==(for (int dhc = 0; dhc < DHC; dhc++) { )==""\n"
R"==(printf(" %f", *(wt + OFF_WS_BIAS(j, dir, nb, dhc))); )==""\n"
R"==(} )==""\n"
R"==(printf("\n"); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(__kernel void ref_rnn_bias_prepare(__global char *ws, __global float *scales, )==""\n"
R"==(__global char *wei_layer, __global char *wei_iter, __global float *bias, )==""\n"
R"==(float data_shift, float data_scale) { )==""\n"
R"==(#if COPY_BIAS )==""\n"
R"==(const int dhc = get_global_id(0); )==""\n"
R"==(const int nbias = get_global_id(1); )==""\n"
R"==(const int layer = get_global_id(2) / N_DIR; )==""\n"
R"==(const int dir = get_global_id(2) % N_DIR; )==""\n"
R"==(__global float *ws_bias = (__global float *)(ws + WS_BIAS_OFFSET); )==""\n"
R"==(const float wei_scale )==""\n"
R"==(#if WEI_QPARAM_MASK )==""\n"
R"==(= scales[nbias * DHC + dhc]; )==""\n"
R"==(#else )==""\n"
R"==(= scales[0]; )==""\n"
R"==(#endif )==""\n"
R"==(#define COMP_OFF(i0, i1, i2, i3) \ )==""\n"
R"==(((((i0) * (N_DIR) + (i1)) * (N_BIAS) + (i2)) * (DHC) + (i3)) )==""\n"
R"==(#define COMP_WEI_LAYER_OFF (WEI_L_D0 * WEI_L_S0) )==""\n"
R"==(#define COMP_WEI_ITER_OFF (WEI_I_D0 * WEI_I_S0) )==""\n"
R"==(__global char *temp = (__global char *)(wei_iter + COMP_WEI_ITER_OFF); )==""\n"
R"==(__global float *wei_iter_comp )==""\n"
R"==(= (__global float *)(((unsigned long)temp + (sizeof(float) - 1)) )==""\n"
R"==(& -sizeof(float)); )==""\n"
R"==(temp = (__global char *)(wei_layer + COMP_WEI_LAYER_OFF); )==""\n"
R"==(__global float *wei_layer_comp )==""\n"
R"==(= (__global float *)(((unsigned long)temp + (sizeof(float) - 1)) )==""\n"
R"==(& -sizeof(float)); )==""\n"
R"==(const int off = COMP_OFF(layer, dir, nbias, dhc); )==""\n"
R"==(const float comp = wei_layer_comp[off] + wei_iter_comp[off]; )==""\n"
R"==(ws_bias[OFF_WS_BIAS(layer, dir, nbias, dhc)] )==""\n"
R"==(= bias[BIAS_OFF(layer, dir, nbias, dhc)] )==""\n"
R"==(- comp * data_shift / (wei_scale * data_scale); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if IS_INT8 && CELL_KIND == VANILLA_LSTM )==""\n"
R"==(WS_STATE_DATA_T q_d(float f, float data_scale, float data_shift) { )==""\n"
R"==(float qf = f * data_scale + data_shift; )==""\n"
R"==(return TO_WS_STATE(qf); )==""\n"
R"==(} )==""\n"
R"==(float deq_w(ACC_DATA_T s, int gate, int j, __global float *scales, )==""\n"
R"==(float data_scale) { )==""\n"
R"==(#if WEI_QPARAM_MASK )==""\n"
R"==(float wei_scale = scales[gate * DHC + j]; )==""\n"
R"==(#else )==""\n"
R"==(float wei_scale = scales[0]; )==""\n"
R"==(#endif )==""\n"
R"==(return (float)(s) / (wei_scale * data_scale); )==""\n"
R"==(} )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void )==""\n"
R"==(ref_rnn_elemwise_fwd(int dir, int lay, int iter, __global char *ws, )==""\n"
R"==(__global char *scr_gates, __global float *scales, )==""\n"
R"==(__global float *bias_base, float alpha, float data_shift, )==""\n"
R"==(float data_scale, __global float *tm_scales, float tm_cscale) { )==""\n"
R"==(const int i = get_global_id(1);  )==""\n"
R"==(const int j = get_global_id(0);  )==""\n"
R"==(if (j >= DHC || i >= BATCH) return; )==""\n"
R"==(const __global float *c_states_tm1_l )==""\n"
R"==(= (__global float *)(ws + WS_C_STATE_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter, 0, 0); )==""\n"
R"==(__global float *ws_bias = (__global float *)(ws + WS_BIAS_OFFSET); )==""\n"
R"==(__global ACC_DATA_T *ws_gates )==""\n"
R"==(= (__global ACC_DATA_T *)(ws + WS_GATES_OFFSET) )==""\n"
R"==(+ OFF_WS_GATES(lay, dir, iter, 0, 0, 0); )==""\n"
R"==(__global ACC_DATA_T *scratch_gates = (__global ACC_DATA_T *)(scr_gates) )==""\n"
R"==(+ OFF_SCRATCH_MEM(iter, 0, 0, 0); )==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0); )==""\n"
R"==(__global float *c_states_t_l = (__global float *)(ws + WS_C_STATE_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0); )==""\n"
R"==(float G0 = logistic_fwd_tm(deq_w(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)], )==""\n"
R"==(0, j, scales, data_scale) )==""\n"
R"==(+ ws_bias[OFF_WS_BIAS(lay, dir, 0, j)], )==""\n"
R"==(tm_scales[0]); )==""\n"
R"==(float G1 = logistic_fwd_tm(deq_w(scratch_gates[CELL_SCRATCH_MEM(i, 1, j)], )==""\n"
R"==(1, j, scales, data_scale) )==""\n"
R"==(+ ws_bias[OFF_WS_BIAS(lay, dir, 1, j)], )==""\n"
R"==(tm_scales[1]); )==""\n"
R"==(float G2 = tanh_fwd_tm(deq_w(scratch_gates[CELL_SCRATCH_MEM(i, 2, j)], 2, j, )==""\n"
R"==(scales, data_scale) )==""\n"
R"==(+ ws_bias[OFF_WS_BIAS(lay, dir, 2, j)], )==""\n"
R"==(tm_scales[2]); )==""\n"
R"==(float G3 = logistic_fwd_tm(deq_w(scratch_gates[CELL_SCRATCH_MEM(i, 3, j)], )==""\n"
R"==(3, j, scales, data_scale) )==""\n"
R"==(+ ws_bias[OFF_WS_BIAS(lay, dir, 3, j)], )==""\n"
R"==(tm_scales[3]); )==""\n"
R"==(float tmp = G1 * c_states_tm1_l[CELL_WS_STATE(i, j)] + G0 * G2; )==""\n"
R"==(h_states_t_l[CELL_WS_STATE(i, j)] )==""\n"
R"==(= q_d(G3 * tanh_fwd_tm(tmp, tm_cscale), data_scale, data_shift); )==""\n"
R"==(c_states_t_l[CELL_WS_STATE(i, j)] = tmp; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void )==""\n"
R"==(ref_rnn_elemwise_fwd( )==""\n"
R"==(int dir, int lay, int iter, __global char *ws, __global char *scr_gates, )==""\n"
R"==(__global AUX_DATA_T *bias_base, float alpha, __global float *tm_scales, )==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM || CELL_KIND == VANILLA_RNN )==""\n"
R"==(float tm_cscale )==""\n"
R"==(#elif CELL_KIND == LBR_GRU )==""\n"
R"==(__global char *scr_cell )==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU )==""\n"
R"==(int n_part )==""\n"
R"==(#endif )==""\n"
R"==() { )==""\n"
R"==(const int i = get_global_id(1);  )==""\n"
R"==(const int j = get_global_id(0);  )==""\n"
R"==(if (j >= DHC || i >= BATCH) return; )==""\n"
R"==(const __global AUX_DATA_T *c_states_tm1_l )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter, 0, 0); )==""\n"
R"==(const __global AUX_DATA_T *bias = bias_base + BIAS_OFF(lay, dir, 0, 0); )==""\n"
R"==(__global AUX_DATA_T *ws_gates )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET) )==""\n"
R"==(+ OFF_WS_GATES(lay, dir, iter, 0, 0, 0); )==""\n"
R"==(__global AUX_DATA_T *scratch_gates = (__global AUX_DATA_T *)(scr_gates) )==""\n"
R"==(+ OFF_SCRATCH_MEM(iter, 0, 0, 0); )==""\n"
R"==(__global WS_STATE_DATA_T *h_states_t_l )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0); )==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM )==""\n"
R"==(__global AUX_DATA_T *c_states_t_l )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0); )==""\n"
R"==(float g_i = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(0, j)], )==""\n"
R"==(tm_scales[0]); )==""\n"
R"==(float g_f = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(1, j)], )==""\n"
R"==(tm_scales[1]); )==""\n"
R"==(float g_z = tanh_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(2, j)], )==""\n"
R"==(tm_scales[2]); )==""\n"
R"==(float g_o = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 3, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(3, j)], )==""\n"
R"==(tm_scales[3]); )==""\n"
R"==(#if IS_TRAINING )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 0, j)] = g_i; )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 1, j)] = g_f; )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 2, j)] = g_z; )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 3, j)] = g_o; )==""\n"
R"==(#endif )==""\n"
R"==(float Ct = g_f * c_states_tm1_l[CELL_WS_STATE(i, j)] + g_i * g_z; )==""\n"
R"==(float Ht = g_o * tanh_fwd_tm(Ct, tm_cscale); )==""\n"
R"==(h_states_t_l[CELL_WS_STATE(i, j)] = TO_INPUT(Ht); )==""\n"
R"==(c_states_t_l[CELL_WS_STATE(i, j)] = Ct; )==""\n"
R"==(#elif CELL_KIND == VANILLA_RNN )==""\n"
R"==(float g = activation_fwd((float)scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(0, j)], )==""\n"
R"==(#if IS_TESTMODE )==""\n"
R"==(tm_scales[0], 0); )==""\n"
R"==(#else )==""\n"
R"==(alpha, 0); )==""\n"
R"==(#endif )==""\n"
R"==(#if IS_TRAINING )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 0, j)] = g; )==""\n"
R"==(#endif )==""\n"
R"==(h_states_t_l[CELL_WS_STATE(i, j)] = TO_INPUT(g); )==""\n"
R"==(#elif CELL_KIND == LBR_GRU )==""\n"
R"==(__global AUX_DATA_T *scratch_cell = (__global AUX_DATA_T *)(scr_cell); )==""\n"
R"==(__global WS_STATE_DATA_T *src_iter )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter, 0, 0); )==""\n"
R"==(__global AUX_DATA_T *ws_grid )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_GRID_COMP_OFFSET) )==""\n"
R"==(+ OFF_WS_GRID_OFFSET(lay, dir, iter, 0, 0); )==""\n"
R"==(float Wh_b = (float)scratch_cell[CELL_SCRATCH_MEM(i, 2, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(3, j)]; )==""\n"
R"==(float G0 = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] )==""\n"
R"==(+ (float)scratch_cell[CELL_SCRATCH_MEM(i, 0, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(0, j)], )==""\n"
R"==(tm_scales[0]); )==""\n"
R"==(float G1 = logistic_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] )==""\n"
R"==(+ (float)scratch_cell[CELL_SCRATCH_MEM(i, 1, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(1, j)], )==""\n"
R"==(tm_scales[1]); )==""\n"
R"==(float G2 = tanh_fwd_tm((float)scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] )==""\n"
R"==(+ G1 * Wh_b + bias[OFF_KER_BIAS(2, j)], )==""\n"
R"==(tm_scales[2]); )==""\n"
R"==(float Ht = G0 * TO_REF(src_iter[CELL_WS_STATE(i, j)]) + (1 - G0) * G2; )==""\n"
R"==(h_states_t_l[CELL_WS_STATE(i, j)] = TO_INPUT(Ht); )==""\n"
R"==(#if IS_TRAINING )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 0, j)] = G0; )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 1, j)] = G1; )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 2, j)] = G2; )==""\n"
R"==(ws_grid[CELL_WS_GRID_COMP(i, j)] = Wh_b; )==""\n"
R"==(#endif )==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU )==""\n"
R"==(__global WS_STATE_DATA_T *src_iter )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter, 0, 0); )==""\n"
R"==(if (n_part == 1) { )==""\n"
R"==(float G0 = logistic_fwd_tm(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(0, j)], )==""\n"
R"==(tm_scales[0]); )==""\n"
R"==(float G1 = logistic_fwd_tm(scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(1, j)], )==""\n"
R"==(tm_scales[1]); )==""\n"
R"==(/* TODO from CPU: Can be optimized for fwd_training by using )==""\n"
R"==(ws_gates instead of scratch_gates in p2 */ )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(G0); )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] = TO_INPUT(G1); )==""\n"
R"==(float tmp = TO_REF(src_iter[CELL_WS_STATE(i, j)]); )==""\n"
R"==(h_states_t_l[CELL_WS_STATE(i, j)] = TO_INPUT(tmp * G1); )==""\n"
R"==(#if IS_TRAINING )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 0, j)] = G0; )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 1, j)] = G1; )==""\n"
R"==(#endif )==""\n"
R"==(} else if (n_part == 2) { )==""\n"
R"==(float G0 = TO_REF(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)]); )==""\n"
R"==(float G2 = tanh_fwd_tm(scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] )==""\n"
R"==(+ bias[OFF_KER_BIAS(2, j)], )==""\n"
R"==(tm_scales[2]); )==""\n"
R"==(float tmp = TO_REF(src_iter[CELL_WS_STATE(i, j)]); )==""\n"
R"==(h_states_t_l[CELL_WS_STATE(i, j)] )==""\n"
R"==(= TO_INPUT(tmp * G0 + (1.0f - G0) * G2); )==""\n"
R"==(#if IS_TRAINING )==""\n"
R"==(ws_gates[CELL_WS_GATES(i, 2, j)] = G2; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#error "Wrong Cell Kind" )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void )==""\n"
R"==(ref_rnn_elemwise_bwd(int dir, int lay, int iter, __global char *ws, )==""\n"
R"==(__global char *scr_gates, __global AUX_DATA_T *bias_base, float alpha, )==""\n"
R"==(__global float *tm_scales, )==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM || CELL_KIND == VANILLA_RNN )==""\n"
R"==(float tm_cscale, )==""\n"
R"==(#elif CELL_KIND == LBR_GRU )==""\n"
R"==(__global char *scr_gate_r, )==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU )==""\n"
R"==(int n_part, __global char *scr_cell, __global char *scratch_dhG1, )==""\n"
R"==(#endif )==""\n"
R"==(__global char *diff_states) { )==""\n"
R"==(const int i = get_global_id(1);  )==""\n"
R"==(const int j = get_global_id(0);  )==""\n"
R"==(if (j >= DHC || i >= BATCH) return; )==""\n"
R"==(#if CELL_KIND == VANILLA_LSTM )==""\n"
R"==(__global AUX_DATA_T *ws_gates )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET) )==""\n"
R"==(+ OFF_WS_GATES(lay, dir, iter, 0, 0, 0); )==""\n"
R"==(__global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates) )==""\n"
R"==(+ OFF_SCRATCH_MEM(iter, 0, 0, 0); )==""\n"
R"==(__global AUX_DATA_T *c_states_t_l )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter + 1, 0, 0); )==""\n"
R"==(__global AUX_DATA_T *c_states_tm1_l )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_C_STATE_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_l = (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay, dir, 0, iter, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_states_tp1_l )==""\n"
R"==(= (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay, dir, 0, iter + 1, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_lp1 )==""\n"
R"==(= (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay + 1, dir, 0, iter, 0, 0); )==""\n"
R"==(float Ct = c_states_t_l[CELL_WS_STATE(i, j)]; )==""\n"
R"==(float tanhCt = tanh_fwd_tm(Ct, tm_cscale); )==""\n"
R"==(float dHt = (float)diff_states_tp1_l[CELL_SCRATCH_DIFF_STATES(0, i, j)] )==""\n"
R"==(+ diff_states_t_lp1[CELL_SCRATCH_DIFF_STATES(N_STATES, i, j)]; )==""\n"
R"==(float dCt = (float)diff_states_tp1_l[CELL_SCRATCH_DIFF_STATES(1, i, j)] )==""\n"
R"==(+ one_m_square(tanhCt) * ws_gates[CELL_WS_GATES(i, 3, j)] * dHt; )==""\n"
R"==(float dG1 = (float)c_states_tm1_l[CELL_WS_STATE(i, j)] * dCt )==""\n"
R"==(* x_m_square(ws_gates[CELL_WS_GATES(i, 1, j)]); )==""\n"
R"==(float dG0 = ws_gates[CELL_WS_GATES(i, 2, j)] * dCt )==""\n"
R"==(* x_m_square(ws_gates[CELL_WS_GATES(i, 0, j)]); )==""\n"
R"==(float dG3 = tanhCt * dHt * x_m_square(ws_gates[CELL_WS_GATES(i, 3, j)]); )==""\n"
R"==(float dG2 = ws_gates[CELL_WS_GATES(i, 0, j)] * dCt )==""\n"
R"==(* one_m_square(ws_gates[CELL_WS_GATES(i, 2, j)]); )==""\n"
R"==(diff_states_t_l[CELL_SCRATCH_DIFF_STATES(1, i, j)] )==""\n"
R"==(= dCt * ws_gates[CELL_WS_GATES(i, 1, j)]; )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(dG0); )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] = TO_INPUT(dG1); )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] = TO_INPUT(dG2); )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 3, j)] = TO_INPUT(dG3); )==""\n"
R"==(#elif CELL_KIND == LBR_GRU )==""\n"
R"==(__global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates) )==""\n"
R"==(+ OFF_SCRATCH_MEM(iter, 0, 0, 0); )==""\n"
R"==(__global SRC_DATA_T *scratch_gate_r = (__global SRC_DATA_T *)(scr_gate_r); )==""\n"
R"==(__global AUX_DATA_T *ws_gates )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET) )==""\n"
R"==(+ OFF_WS_GATES(lay, dir, iter, 0, 0, 0); )==""\n"
R"==(__global AUX_DATA_T *ws_grid )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_GRID_COMP_OFFSET) )==""\n"
R"==(+ OFF_WS_GRID_OFFSET(lay, dir, iter, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_src_iter = (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay, dir, 0, iter, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_dst_iter = (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay, dir, 0, iter + 1, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_dst_layer = (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay + 1, dir, 0, iter, 0, 0); )==""\n"
R"==(__global WS_STATE_DATA_T *src_iter  )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter, 0, 0); )==""\n"
R"==(float h = TO_REF(src_iter[CELL_WS_STATE(i, j)]); )==""\n"
R"==(float Wh_b = ws_grid[CELL_WS_GRID_COMP(i, j)]; )==""\n"
R"==(float dHt = diff_dst_iter[CELL_SCRATCH_DIFF_STATES(0, i, j)] )==""\n"
R"==(+ diff_dst_layer[CELL_SCRATCH_DIFF_STATES(N_STATES, i, j)]; )==""\n"
R"==(float dG0 = (h - ws_gates[CELL_WS_GATES(i, 2, j)]) * dHt )==""\n"
R"==(* x_m_square(ws_gates[CELL_WS_GATES(i, 0, j)]); )==""\n"
R"==(float dG2 = (1.0f - ws_gates[CELL_WS_GATES(i, 0, j)]) )==""\n"
R"==(* one_m_square(ws_gates[CELL_WS_GATES(i, 2, j)]) * dHt; )==""\n"
R"==(float dG1 = Wh_b * dG2 * x_m_square(ws_gates[CELL_WS_GATES(i, 1, j)]); )==""\n"
R"==(diff_src_iter[CELL_SCRATCH_DIFF_STATES(0, i, j)] )==""\n"
R"==(= dHt * ws_gates[CELL_WS_GATES(i, 0, j)]; )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(dG0); )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] = TO_INPUT(dG1); )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] = TO_INPUT(dG2); )==""\n"
R"==(scratch_gate_r[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(dG0); )==""\n"
R"==(scratch_gate_r[CELL_SCRATCH_MEM(i, 1, j)] = TO_INPUT(dG1); )==""\n"
R"==(scratch_gate_r[CELL_SCRATCH_MEM(i, 2, j)] )==""\n"
R"==(= TO_INPUT(dG2 * ws_gates[CELL_WS_GATES(i, 1, j)]); )==""\n"
R"==(#elif CELL_KIND == VANILLA_RNN )==""\n"
R"==(__global AUX_DATA_T *ws_gates )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET) )==""\n"
R"==(+ OFF_WS_GATES(lay, dir, iter, i, 0, j); )==""\n"
R"==(__global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates) )==""\n"
R"==(+ OFF_SCRATCH_MEM(iter, i, 0, j); )==""\n"
R"==(__global DIFF_DATA_T *diff_states_t_lp1 )==""\n"
R"==(= (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay + 1, dir, N_STATES, iter, i, j); )==""\n"
R"==(__global DIFF_DATA_T *diff_states_tp1_l )==""\n"
R"==(= (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay, dir, 0, iter + 1, i, j); )==""\n"
R"==(const float dH = (float)diff_states_t_lp1[0] + diff_states_tp1_l[0]; )==""\n"
R"==(float g = ws_gates[0]; )==""\n"
R"==(#if IS_TESTMODE )==""\n"
R"==(scratch_gates[0] = TO_INPUT(dH * activation_bwd(g, tm_scales[0], 0.)); )==""\n"
R"==(#else )==""\n"
R"==(scratch_gates[0] = TO_INPUT(dH * activation_bwd(g, alpha, 0.)); )==""\n"
R"==(#endif )==""\n"
R"==(#elif CELL_KIND == VANILLA_GRU )==""\n"
R"==(__global SRC_DATA_T *scratch_gates = (__global SRC_DATA_T *)(scr_gates) )==""\n"
R"==(+ OFF_SCRATCH_MEM(iter, 0, 0, 0); )==""\n"
R"==(__global AUX_DATA_T *ws_gates )==""\n"
R"==(= (__global AUX_DATA_T *)(ws + WS_GATES_OFFSET) )==""\n"
R"==(+ OFF_WS_GATES(lay, dir, iter, 0, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_src_iter = (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay, dir, 0, iter, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_dst_iter = (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay, dir, 0, iter + 1, 0, 0); )==""\n"
R"==(__global DIFF_DATA_T *diff_dst_layer = (__global DIFF_DATA_T *)diff_states )==""\n"
R"==(+ OFF_SCRATCH_DIFF_STATES(lay + 1, dir, 0, iter, 0, 0); )==""\n"
R"==(__global WS_STATE_DATA_T *src_iter  )==""\n"
R"==(= (__global WS_STATE_DATA_T *)(ws + WS_STATES_OFFSET) )==""\n"
R"==(+ OFF_WS_STATE(lay + 1, dir, iter, 0, 0); )==""\n"
R"==(float h = TO_REF(src_iter[CELL_WS_STATE(i, j)]); )==""\n"
R"==(if (n_part == 1) { )==""\n"
R"==(float dHt = diff_dst_iter[CELL_SCRATCH_DIFF_STATES(0, i, j)] )==""\n"
R"==(+ diff_dst_layer[CELL_SCRATCH_DIFF_STATES(N_STATES, i, j)]; )==""\n"
R"==(float dG2 = (1.0f - ws_gates[CELL_WS_GATES(i, 0, j)]) * dHt )==""\n"
R"==(* one_m_square(ws_gates[CELL_WS_GATES(i, 2, j)]); )==""\n"
R"==(float dG0 = (h - ws_gates[CELL_WS_GATES(i, 2, j)]) * dHt )==""\n"
R"==(* x_m_square(ws_gates[CELL_WS_GATES(i, 0, j)]); )==""\n"
R"==(diff_src_iter[CELL_SCRATCH_DIFF_STATES(0, i, j)] )==""\n"
R"==(= dHt * ws_gates[CELL_WS_GATES(i, 0, j)]; )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 0, j)] = TO_INPUT(dG0); )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 2, j)] = TO_INPUT(dG2); )==""\n"
R"==(} else if (n_part == 2) { )==""\n"
R"==(__global SRC_DATA_T *scratch_cell = (__global SRC_DATA_T *)(scr_cell); )==""\n"
R"==(__global DIFF_DATA_T *dhG1 = (__global DIFF_DATA_T *)scratch_dhG1; )==""\n"
R"==(float dG1 = ws_gates[CELL_WS_GATES(i, 1, j)]; )==""\n"
R"==(diff_src_iter[CELL_SCRATCH_DIFF_STATES(0, i, j)] )==""\n"
R"==(+= dhG1[OFF_SCRATCH_DHG1(i, j)] * dG1; )==""\n"
R"==(scratch_gates[CELL_SCRATCH_MEM(i, 1, j)] )==""\n"
R"==(= TO_INPUT(dhG1[OFF_SCRATCH_DHG1(i, j)] * h * x_m_square(dG1)); )==""\n"
R"==(scratch_cell[OFF_SCRATCH_CELL(i, j)] = TO_INPUT(dG1 * h); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#error "Wrong Cell Kind" )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUBGROUP_SIZE))) __kernel void )==""\n"
R"==(ref_rnn_gates_reduction(int dir, int lay, int iter, )==""\n"
R"==(__global DIFF_DATA_T *diff_bias_base, __global char *scratch_gates, )==""\n"
R"==(__global char *scratch_cell) { )==""\n"
R"==(#if !IS_FWD )==""\n"
R"==(#if USE_SUBGROUP_REDUCTION )==""\n"
R"==(const int k = get_global_id(1);  )==""\n"
R"==(const int i = get_global_id(2);  )==""\n"
R"==(#else )==""\n"
R"==(const int k = get_global_id(0);  )==""\n"
R"==(const int i = get_global_id(1);  )==""\n"
R"==(#endif  )==""\n"
R"==(const int n_bias_max = (CELL_KIND == LBR_GRU) ? 4 : N_GATES; )==""\n"
R"==(if (k >= DHC || i >= n_bias_max) return; )==""\n"
R"==(__global DIFF_DATA_T *diff_bias )==""\n"
R"==(= diff_bias_base + DIFF_BIAS_OFF(lay, dir, 0, 0); )==""\n"
R"==(__global SRC_DATA_T *gates; )==""\n"
R"==(int i_ = i; )==""\n"
R"==(if (CELL_KIND == LBR_GRU && i == 3) { )==""\n"
R"==(gates = (__global SRC_DATA_T *)(scratch_cell); )==""\n"
R"==(i_ = 2; )==""\n"
R"==(} else )==""\n"
R"==(gates = (__global SRC_DATA_T *)(scratch_gates) )==""\n"
R"==(+ OFF_SCRATCH_MEM(iter, 0, 0, 0); )==""\n"
R"==(#if USE_SUBGROUP_REDUCTION )==""\n"
R"==(DIFF_DATA_T result = 0; )==""\n"
R"==(for (int j = get_local_id(0); j < BATCH; j += SUBGROUP_SIZE) { )==""\n"
R"==(result += SRC_TO_REF(gates[CELL_SCRATCH_MEM(j, i_, k)]); )==""\n"
R"==(} )==""\n"
R"==(diff_bias[i * DHC + k] += sub_group_reduce_add(result); )==""\n"
R"==(#else )==""\n"
R"==(for (int j = 0; j < BATCH; j++) { )==""\n"
R"==(diff_bias[i * DHC + k] += SRC_TO_REF(gates[CELL_SCRATCH_MEM(j, i_, k)]); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}