namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_bwd_data_mb_block_x8s8x8_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define BLOCK_READ_DST(data, idx) \ )==""\n"
R"==(data = AS_INT8_T( \ )==""\n"
R"==(intel_sub_group_block_read8((__global uint *)&current_dst[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT(data, idx) \ )==""\n"
R"==(data = as_int8(intel_sub_group_block_read8((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4((__global uint *)&bias[idx])); )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) __kernel void )==""\n"
R"==(conv_bwd_data_mb_block_x8s8x8(const __global uchar *src, )==""\n"
R"==(const __global char *wei, const __global float *bias, )==""\n"
R"==(__global DATA_T *dst) { )==""\n"
R"==(const int mb_blocks = 2; )==""\n"
R"==(const int group_ic = get_group_id(0) * IC_GROUP; )==""\n"
R"==(const int group_mb = get_group_id(2) * MB_GROUP / mb_blocks; )==""\n"
R"==(const int group_sp = get_group_id(1) * SP_GROUP; )==""\n"
R"==(const int sub_group_id = get_sub_group_id(); )==""\n"
R"==(const int mb = get_group_id(2) % mb_blocks; )==""\n"
R"==(const int ic = (sub_group_id % IC_GROUP); )==""\n"
R"==(const int sp = (sub_group_id / IC_GROUP); )==""\n"
R"==(const int g = (group_ic + ic) / IC_NCHUNK; )==""\n"
R"==(const int group_oc = OC_NCHUNK * g; )==""\n"
R"==(const int gid = group_sp / (IW_PADDED * IH); )==""\n"
R"==(const int gihw = group_sp % (IW_PADDED * IH); )==""\n"
R"==(const int gih = gihw / IW_PADDED; )==""\n"
R"==(const int giw = gihw % IW_PADDED; )==""\n"
R"==(const int local_ih = sp / IW_PADDED; )==""\n"
R"==(const int local_iw = sp % IW_PADDED; )==""\n"
R"==(const int id = gid; )==""\n"
R"==(const int iw = giw + local_iw; )==""\n"
R"==(const int ih = gih + local_ih; )==""\n"
R"==(if (iw >= IW) return; )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * MB_BLOCK * (group_ic + ic); )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * IC_NCHUNK * G * MB_BLOCK * group_mb; )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK / 2 * mb; )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (IW * IH * id + IW * ih + iw); )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * MB_BLOCK * group_oc; )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * OC_NCHUNK * G * MB_BLOCK * group_mb; )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK / 2 * mb; )==""\n"
R"==(wei += OC_BLOCK * KD * KH * KW * IC_BLOCK * (group_ic + ic) * OC_NCHUNK; )==""\n"
R"==(int8 C00 = 0, C01 = 0, C02 = 0, C03 = 0; )==""\n"
R"==(int8 C10 = 0, C11 = 0, C12 = 0, C13 = 0; )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int oc_chunk = 0; )==""\n"
R"==(oc_chunk < OC_NCHUNK; oc_chunk++) { )==""\n"
R"==(if (MB % MB_BLOCK != 0 )==""\n"
R"==(&& (group_mb * MB_BLOCK + mb * MB_BLOCK / mb_blocks) >= MB) { )==""\n"
R"==(break; )==""\n"
R"==(} )==""\n"
R"==(INT8_T D0, D1; )==""\n"
R"==(int8 W0, W1, W2, W3; )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(if ((id + PD - kd * (1 + DD)) % SD != 0) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KH * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(const int od = (id + PD - kd * (1 + DD)) / SD; )==""\n"
R"==(if (od < 0 || od >= OD) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KH * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(if ((ih + PH - kh * (1 + DH)) % SH != 0) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(const int oh = (ih + PH - kh * (1 + DH)) / SH; )==""\n"
R"==(if (oh < 0 || oh >= OH) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int kw = 0; kw < KW; )==""\n"
R"==(kw++) { )==""\n"
R"==(if ((iw + PW - kw * (1 + DW)) % SW == 0) { )==""\n"
R"==(const int ow = (iw + PW - kw * (1 + DW)) / SW; )==""\n"
R"==(if (ow >= 0 && ow < OW) { )==""\n"
R"==(__global DATA_T *current_dst = dst )==""\n"
R"==(+ OC_BLOCK * MB_BLOCK )==""\n"
R"==(* (OW * OH * od + OW * oh + ow); )==""\n"
R"==(BLOCK_READ_DST(D0, 0); )==""\n"
R"==(#if MB > 8 )==""\n"
R"==(BLOCK_READ_DST(D1, 8 * IC_BLOCK); )==""\n"
R"==(#endif  )==""\n"
R"==(BLOCK_READ_WHT(W0, 0); )==""\n"
R"==(BLOCK_READ_WHT(W1, 8 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_WHT(W2, 16 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_WHT(W3, 24 * IC_BLOCK); )==""\n"
R"==(C00 = mmad8x8(D0, W0, C00); )==""\n"
R"==(C01 = mmad8x8(D0, W1, C01); )==""\n"
R"==(C02 = mmad8x8(D0, W2, C02); )==""\n"
R"==(C03 = mmad8x8(D0, W3, C03); )==""\n"
R"==(#if MB > 8 )==""\n"
R"==(C10 = mmad8x8(D1, W0, C10); )==""\n"
R"==(C11 = mmad8x8(D1, W1, C11); )==""\n"
R"==(C12 = mmad8x8(D1, W2, C12); )==""\n"
R"==(C13 = mmad8x8(D1, W3, C13); )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK * OD * OH * OW; )==""\n"
R"==(} )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(#define BIAS_SUM_RELU(RES, TMP, ACC, BIA, DST) \ )==""\n"
R"==(TMP = (float)ACC + BIA; \ )==""\n"
R"==(RES = TO_SRC(TMP); )==""\n"
R"==(#else  )==""\n"
R"==(#define BIAS_SUM_RELU(RES, TMP, ACC, BIA, DST) RES = TO_SRC((float)ACC); )==""\n"
R"==(#endif  )==""\n"
R"==(#define PACK(idx) \ )==""\n"
R"==(BIAS_SUM_RELU(D00[0], T00, C00[idx], b0, S00[0]); \ )==""\n"
R"==(BIAS_SUM_RELU(D00[1], T01, C01[idx], b1, S00[1]); \ )==""\n"
R"==(BIAS_SUM_RELU(D00[2], T02, C02[idx], b2, S00[2]); \ )==""\n"
R"==(BIAS_SUM_RELU(D00[3], T03, C03[idx], b3, S00[3]); \ )==""\n"
R"==(T0[idx] = as_uint(D00); \ )==""\n"
R"==(BIAS_SUM_RELU(D01[0], T10, C10[idx], b0, S01[0]); \ )==""\n"
R"==(BIAS_SUM_RELU(D01[1], T11, C11[idx], b1, S01[1]); \ )==""\n"
R"==(BIAS_SUM_RELU(D01[2], T12, C12[idx], b2, S01[2]); \ )==""\n"
R"==(BIAS_SUM_RELU(D01[3], T13, C13[idx], b3, S01[3]); \ )==""\n"
R"==(T1[idx] = as_uint(D01); )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float4 bia; )==""\n"
R"==(BLOCK_READ_BIA(bia, (group_ic + ic) * IC_BLOCK); )==""\n"
R"==(float b0 = bia[0]; )==""\n"
R"==(float b1 = bia[1]; )==""\n"
R"==(float b2 = bia[2]; )==""\n"
R"==(float b3 = bia[3]; )==""\n"
R"==(#endif  )==""\n"
R"==(uchar4 D00, D01; )==""\n"
R"==(uint8 T0, T1; )==""\n"
R"==(float T00, T01, T02, T03; )==""\n"
R"==(float T10, T11, T12, T13; )==""\n"
R"==(PACK(0); )==""\n"
R"==(PACK(1); )==""\n"
R"==(PACK(2); )==""\n"
R"==(PACK(3); )==""\n"
R"==(PACK(4); )==""\n"
R"==(PACK(5); )==""\n"
R"==(PACK(6); )==""\n"
R"==(PACK(7); )==""\n"
R"==(intel_sub_group_block_write_uc16( )==""\n"
R"==((__global uchar *)&src[0 * IC_BLOCK], as_uchar16(T0.s0123)); )==""\n"
R"==(intel_sub_group_block_write_uc16( )==""\n"
R"==((__global uchar *)&src[4 * IC_BLOCK], as_uchar16(T0.s4567)); )==""\n"
R"==(intel_sub_group_block_write_uc16( )==""\n"
R"==((__global uchar *)&src[8 * IC_BLOCK], as_uchar16(T1.s0123)); )==""\n"
R"==(intel_sub_group_block_write_uc16( )==""\n"
R"==((__global uchar *)&src[12 * IC_BLOCK], as_uchar16(T1.s4567)); )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}