namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_bwd_data_x8s8x8_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if OC % OC_BLOCK != 0 )==""\n"
R"==(#define OC_NBLOCKS_TAIL ((OC - (OC & ~(OC_BLOCK - 1)) + 3) / 4) )==""\n"
R"==(#else )==""\n"
R"==(#define OC_NBLOCKS_TAIL 8 )==""\n"
R"==(#endif )==""\n"
R"==(#if IW_BLOCK == 4 )==""\n"
R"==(#define BLOCK 4 )==""\n"
R"==(#define ACC_DATA_BLOCK int4 )==""\n"
R"==(#define A_DATA_BLOCK_T MMAD_DATA4_T )==""\n"
R"==(#define WRITE_LOCAL block_write4 )==""\n"
R"==(#define READ_BLOCK intel_sub_group_block_read4 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail, idot4, OC_NBLOCKS_TAIL, 4, A_DATA_BLOCK_T, int8, )==""\n"
R"==(ACC_DATA_BLOCK) )==""\n"
R"==(#define MMAD_FULL mmad8x4 )==""\n"
R"==(#define MMAD_TAIL mmad_tail )==""\n"
R"==(#elif IW_BLOCK == 8 )==""\n"
R"==(#define BLOCK 8 )==""\n"
R"==(#define ACC_DATA_BLOCK int8 )==""\n"
R"==(#define A_DATA_BLOCK_T MMAD_DATA8_T )==""\n"
R"==(#define WRITE_LOCAL block_write8 )==""\n"
R"==(#define READ_BLOCK intel_sub_group_block_read8 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail, idot4, OC_NBLOCKS_TAIL, 8, A_DATA_BLOCK_T, int8, )==""\n"
R"==(ACC_DATA_BLOCK) )==""\n"
R"==(#define MMAD_FULL mmad8x8 )==""\n"
R"==(#define MMAD_TAIL mmad_tail )==""\n"
R"==(#else )==""\n"
R"==(#error "Wrong IW_BLOCK" )==""\n"
R"==(#endif )==""\n"
R"==(#define BLOCK_READ_WHT_1x32(data, idx) \ )==""\n"
R"==(data = as_int(intel_sub_group_block_read((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT_8x32(data, idx) \ )==""\n"
R"==(data = as_int8(intel_sub_group_block_read8((__global uint *)&wei[idx])); )==""\n"
R"==(#if IC % IC_BLOCK == 0 )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4((__global uint *)&bias[idx])); )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = (float4)0; \ )==""\n"
R"==(int i; \ )==""\n"
R"==(for (i = idx; i < idx + IC_BLOCK && i < IC - (IC % SUB_GROUP_SIZE); \ )==""\n"
R"==(i += SUB_GROUP_SIZE) { \ )==""\n"
R"==(data[(i - idx) / SUB_GROUP_SIZE] = as_float( \ )==""\n"
R"==(intel_sub_group_block_read((__global uint *)&bias[i])); \ )==""\n"
R"==(} \ )==""\n"
R"==(if ((get_sub_group_local_id() < IC % SUB_GROUP_SIZE) \ )==""\n"
R"==(&& (i == IC - IC % SUB_GROUP_SIZE)) { \ )==""\n"
R"==(data[(i - idx) / SUB_GROUP_SIZE] \ )==""\n"
R"==(= as_float(bias[i + get_sub_group_local_id()]); \ )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#define HAS_PAD_W (PW > 0 || OW * SW - PW + (KW - 1) * (1 + DW) >= IW) )==""\n"
R"==(#if IS_NHWC )==""\n"
R"==(inline void write_ic_block4(__global SRC_DATA_T *src, int off, uchar4 value) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if IC % IC_BLOCK != 0 )==""\n"
R"==(int tail = IC - off; )==""\n"
R"==(if (tail < IC_BLOCK) { )==""\n"
R"==(if (local_id < tail) src[8 * 0 + local_id] = value.s0; )==""\n"
R"==(if (local_id < tail - 8 * 1) src[1 * 8 + local_id] = value.s1; )==""\n"
R"==(if (local_id < tail - 8 * 2) src[2 * 8 + local_id] = value.s2; )==""\n"
R"==(if (local_id < tail - 8 * 3) src[3 * 8 + local_id] = value.s3; )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if IC % 4 != 0 )==""\n"
R"==(src[0 * 8 + local_id] = value.s0; )==""\n"
R"==(src[1 * 8 + local_id] = value.s1; )==""\n"
R"==(src[2 * 8 + local_id] = value.s2; )==""\n"
R"==(src[3 * 8 + local_id] = value.s3; )==""\n"
R"==(return; )==""\n"
R"==(#else )==""\n"
R"==(intel_sub_group_block_write_uc4((__global uchar *)src, value); )==""\n"
R"==(return; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(inline void write_local(__local uint *dst_iw_slm_copy, int oc_nchunk, )==""\n"
R"==(__global DATA_T *dst_copy) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if OC % OC_BLOCK != 0 )==""\n"
R"==(int oc_block_tail = OC % OC_BLOCK; )==""\n"
R"==(int oc_bound_tail = oc_block_tail % 4; )==""\n"
R"==(int max_i = (local_id * 4 < (oc_block_tail - oc_bound_tail) )==""\n"
R"==(|| oc_nchunk < (OC_NCHUNK - 1)) )==""\n"
R"==(? 4 )==""\n"
R"==(: (local_id * 4 == (oc_block_tail - oc_bound_tail) ? oc_bound_tail )==""\n"
R"==(: 0); )==""\n"
R"==(uchar4 tmp = 0; )==""\n"
R"==(for (int i = 0; i < max_i; ++i) { )==""\n"
R"==(tmp[i] = dst_copy[local_id * 4 + i]; )==""\n"
R"==(} )==""\n"
R"==(dst_iw_slm_copy[local_id] = as_uint(tmp); )==""\n"
R"==(return; )==""\n"
R"==(#endif )==""\n"
R"==(block_write(dst_iw_slm_copy, )==""\n"
R"==(intel_sub_group_block_read((const __global uint *)(dst_copy))); )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE)))  )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))  )==""\n"
R"==(__kernel void )==""\n"
R"==(conv_bwd_data_x8s8x8(const __global SRC_DATA_T *src, const __global char *wei, )==""\n"
R"==(const __global float *bias, __global DATA_T *dst) { )==""\n"
R"==(const int group_ic = get_group_id(0) * IC_GROUP; )==""\n"
R"==(const int group_sp = get_group_id(1) * SP_GROUP; )==""\n"
R"==(const int group_mb = get_group_id(2) * MB_GROUP; )==""\n"
R"==(const int sub_group_id = get_sub_group_id(); )==""\n"
R"==(const int sub_group_lid = get_sub_group_local_id(); )==""\n"
R"==(const int ic = (sub_group_id % IC_GROUP); )==""\n"
R"==(const int sp = (sub_group_id / IC_GROUP); )==""\n"
R"==(const int g = (group_ic + ic) / IC_NCHUNK; )==""\n"
R"==(const int group_oc = OC_NCHUNK * g; )==""\n"
R"==(const int gid = group_sp / (IW_NCHUNK * IH); )==""\n"
R"==(const int gihw = group_sp % (IW_NCHUNK * IH); )==""\n"
R"==(const int gih = gihw / IW_NCHUNK; )==""\n"
R"==(const int giw = IW_BLOCK * (gihw % IW_NCHUNK); )==""\n"
R"==(const int id = gid; )==""\n"
R"==(const int iw = giw + IW_BLOCK * sp;  )==""\n"
R"==(const int ih = gih; )==""\n"
R"==(#if IS_NHWC )==""\n"
R"==(dst += group_mb * MB_BLOCK * OD * OH * OW * G * OC; )==""\n"
R"==(dst += OC_BLOCK * group_oc; )==""\n"
R"==(src += group_mb * MB_BLOCK * ID * IH * IW * G * IC; )==""\n"
R"==(src += (IW * IH * id + IW * ih + iw) * G * IC; )==""\n"
R"==(src += (group_ic + ic) * IC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * IC_NCHUNK * G * MB_BLOCK * group_mb; )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * MB_BLOCK * (group_ic + ic); )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (IW * IH * id + IW * ih + iw); )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * OC_NCHUNK * G * MB_BLOCK * group_mb; )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * MB_BLOCK * group_oc; )==""\n"
R"==(#endif )==""\n"
R"==(wei += OC_BLOCK * KD * KH * KW * IC_BLOCK * (group_ic + ic) * OC_NCHUNK; )==""\n"
R"==(ACC_DATA_BLOCK C00 = 0, C01 = 0, C02 = 0, C03 = 0; )==""\n"
R"==(__local uint dst_slm[DST_SLM_SIZE]; )==""\n"
R"==(__local uint *dst_iw_slm = dst_slm + (OC_BLOCK / 4) * sp * IW_BLOCK; )==""\n"
R"==(__global DATA_T *dst_tmp = dst; )==""\n"
R"==(for (int oc_chunk = 0; oc_chunk < OC_NCHUNK; oc_chunk++) { )==""\n"
R"==(A_DATA_BLOCK_T D0; )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(int od = id - kd * (1 + DD) + PD; )==""\n"
R"==(if (od < 0 || od % SD != 0) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KH * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(od /= SD; )==""\n"
R"==(if (od >= OD) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KH * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(int oh = (ih - kh * (1 + DH) + PH); )==""\n"
R"==(if (oh < 0 || oh % SH != 0) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(oh /= SH; )==""\n"
R"==(if (oh >= OH) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#if IS_NHWC )==""\n"
R"==(__global DATA_T *dst_cur )==""\n"
R"==(= dst + (G * OC * (OW * OH * od + OW * oh)); )==""\n"
R"==(#else )==""\n"
R"==(__global DATA_T *dst_cur = dst )==""\n"
R"==(+ (OC_BLOCK * MB_BLOCK * (OW * OH * od + OW * oh)); )==""\n"
R"==(#endif )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(#if !HAS_PAD_W && SW == 1 && KW == 1 && !IS_NHWC && IW % IW_BLOCK == 0 )==""\n"
R"==(int ow_min = (iw - (KW - 1) * (1 + DW)); )==""\n"
R"==(int ow_max = (iw + IW_BLOCK - 1); )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int i = ow_min; )==""\n"
R"==(i <= ow_max; )==""\n"
R"==(i += IW_BLOCK) { )==""\n"
R"==(if (i < 0 || i >= OW) { )==""\n"
R"==(block_write(dst_iw_slm + (i - ow_min) * 8, 0); )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(WRITE_LOCAL(dst_iw_slm + (i - ow_min) * 8, )==""\n"
R"==(READ_BLOCK((const __global uint )==""\n"
R"==(*)(&dst_cur[i * OC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(int ow_min = (iw - (KW - 1) * (1 + DW) + PW); )==""\n"
R"==(int ow_max = (iw + IW_BLOCK - 1 + PW); )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int i = ow_min; )==""\n"
R"==(i <= ow_max; i++) { )==""\n"
R"==(if (i < 0 || i % SW != 0) { )==""\n"
R"==(block_write(dst_iw_slm + (i - ow_min) * 8, 0); )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(int index = i / SW; )==""\n"
R"==(if (index >= OW) { )==""\n"
R"==(block_write(dst_iw_slm + (i - ow_min) * 8, 0); )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#if IS_NHWC )==""\n"
R"==(write_local(dst_iw_slm + (i - ow_min) * 8, oc_chunk, )==""\n"
R"==(dst_cur + (index * G * OC)); )==""\n"
R"==(#else )==""\n"
R"==(block_write(dst_iw_slm + (i - ow_min) * 8, )==""\n"
R"==(block_read((const __global uint )==""\n"
R"==(*)(&dst_cur[index * OC_BLOCK]))); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { )==""\n"
R"==(unroll_for(int i = 0; i < IW_BLOCK; i++) { )==""\n"
R"==(int ow_index = (iw + i - kw * (1 + DW) + PW) - ow_min; )==""\n"
R"==(D0[i] = block_read(dst_iw_slm + (ow_index * 8)); )==""\n"
R"==(} )==""\n"
R"==(int8 W0 = 0, W1 = 0, W2 = 0, W3 = 0; )==""\n"
R"==(#if OC % OC_BLOCK != 0 )==""\n"
R"==(if (oc_chunk == OC_NCHUNK - 1) { )==""\n"
R"==(unroll_for(int i = 0; i < OC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32(W0[i], (i + 0) * OC_BLOCK); )==""\n"
R"==(if (IC > 8) )==""\n"
R"==(unroll_for(int i = 0; i < OC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W1[i], (i + 8) * OC_BLOCK); )==""\n"
R"==(if (IC > 16) )==""\n"
R"==(unroll_for(int i = 0; i < OC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W2[i], (i + 16) * OC_BLOCK); )==""\n"
R"==(if (IC > 24) )==""\n"
R"==(unroll_for(int i = 0; i < OC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W3[i], (i + 24) * OC_BLOCK); )==""\n"
R"==(C00 = MMAD_TAIL(D0, W0, C00); )==""\n"
R"==(if (IC > 8) C01 = MMAD_TAIL(D0, W1, C01); )==""\n"
R"==(if (IC > 16) C02 = MMAD_TAIL(D0, W2, C02); )==""\n"
R"==(if (IC > 24) C03 = MMAD_TAIL(D0, W3, C03); )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(BLOCK_READ_WHT_8x32(W0, 0); )==""\n"
R"==(if (IC > 8) BLOCK_READ_WHT_8x32(W1, 8 * OC_BLOCK); )==""\n"
R"==(if (IC > 16) BLOCK_READ_WHT_8x32(W2, 16 * OC_BLOCK); )==""\n"
R"==(if (IC > 24) BLOCK_READ_WHT_8x32(W3, 24 * OC_BLOCK); )==""\n"
R"==(C00 = MMAD_FULL(D0, W0, C00); )==""\n"
R"==(if (IC > 8) C01 = MMAD_FULL(D0, W1, C01); )==""\n"
R"==(if (IC > 16) C02 = MMAD_FULL(D0, W2, C02); )==""\n"
R"==(if (IC > 24) C03 = MMAD_FULL(D0, W3, C03); )==""\n"
R"==(} )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK; )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(#if IS_NHWC )==""\n"
R"==(dst += OC_BLOCK; )==""\n"
R"==(#else )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK * OH * OW * OD; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#define PACK(idx) \ )==""\n"
R"==(BIAS_SUM_RELU(D00[0], tmp[0], C00[idx], bia[0]); \ )==""\n"
R"==(BIAS_SUM_RELU(D00[1], tmp[1], C01[idx], bia[1]); \ )==""\n"
R"==(BIAS_SUM_RELU(D00[2], tmp[2], C02[idx], bia[2]); \ )==""\n"
R"==(BIAS_SUM_RELU(D00[3], tmp[3], C03[idx], bia[3]); \ )==""\n"
R"==(src_pack[idx] = as_uint(D00); )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(#define BIAS_SUM_RELU(RES, TMP, ACC, BIA) \ )==""\n"
R"==(TMP = (float)ACC + BIA; \ )==""\n"
R"==(RES = TO_SRC(TMP); )==""\n"
R"==(#else )==""\n"
R"==(#define BIAS_SUM_RELU(RES, TMP, ACC, BIA) RES = TO_SRC((float)ACC); )==""\n"
R"==(#endif  )==""\n"
R"==(uchar4 D00; )==""\n"
R"==(uint8 src_pack; )==""\n"
R"==(float4 bia, tmp; )==""\n"
R"==(BLOCK_READ_BIA(bia, (group_ic + ic) * IC_BLOCK); )==""\n"
R"==(#if IS_NHWC )==""\n"
R"==(#if IW_TAIL )==""\n"
R"==(if (iw + IW_BLOCK > IW) { )==""\n"
R"==(for (int i = 0; i < IW_TAIL; ++i) { )==""\n"
R"==(PACK(i); )==""\n"
R"==(} )==""\n"
R"==(__attribute__((opencl_unroll_hint(IW_TAIL))) for (int i = 0; )==""\n"
R"==(i < IW_TAIL; i++) { )==""\n"
R"==(write_ic_block4(src + i * G * IC, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[i])); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(#endif  )==""\n"
R"==(#if IW_BLOCK == 4 || IW_BLOCK == 8 )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; ++i) { )==""\n"
R"==(PACK(i); )==""\n"
R"==(} )==""\n"
R"==(write_ic_block4(src + G * IC * 0, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[0])); )==""\n"
R"==(write_ic_block4(src + G * IC * 1, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[1])); )==""\n"
R"==(write_ic_block4(src + G * IC * 2, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[2])); )==""\n"
R"==(write_ic_block4(src + G * IC * 3, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[3])); )==""\n"
R"==(#endif  )==""\n"
R"==(#if IW_BLOCK == 8 )==""\n"
R"==(write_ic_block4(src + G * IC * 4, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[4])); )==""\n"
R"==(write_ic_block4(src + G * IC * 5, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[5])); )==""\n"
R"==(write_ic_block4(src + G * IC * 6, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[6])); )==""\n"
R"==(write_ic_block4(src + G * IC * 7, (group_ic + ic) * IC_BLOCK, )==""\n"
R"==(as_uchar4(src_pack[7])); )==""\n"
R"==(#endif  )==""\n"
R"==(#if IW_TAIL )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#else  )==""\n"
R"==(#if IW_TAIL )==""\n"
R"==(if (iw + IW_BLOCK > IW) { )==""\n"
R"==(for (int i = 0; i < IW_TAIL; ++i) { )==""\n"
R"==(PACK(i); )==""\n"
R"==(} )==""\n"
R"==(__attribute__((opencl_unroll_hint(IW_TAIL))) for (int i = 0; )==""\n"
R"==(i < IW_TAIL; i++) { )==""\n"
R"==(intel_sub_group_block_write_uc4( )==""\n"
R"==((__global uchar *)&src[i * IC_BLOCK], )==""\n"
R"==(as_uchar4(src_pack[i])); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(#endif  )==""\n"
R"==(#if IW_BLOCK == 4 || IW_BLOCK == 8 )==""\n"
R"==(for (int i = 0; i < IW_BLOCK; ++i) { )==""\n"
R"==(PACK(i); )==""\n"
R"==(} )==""\n"
R"==(intel_sub_group_block_write_uc16((__global uchar *)&src[0 * IC_BLOCK], )==""\n"
R"==(as_uchar16(src_pack.s0123)); )==""\n"
R"==(#endif  )==""\n"
R"==(#if IW_BLOCK == 8 )==""\n"
R"==(intel_sub_group_block_write_uc16((__global uchar *)&src[4 * IC_BLOCK], )==""\n"
R"==(as_uchar16(src_pack.s4567)); )==""\n"
R"==(#endif  )==""\n"
R"==(#if IW_TAIL )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}