namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_fwd_data_first_x8s8x_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#undef cl_intel_subgroup_matrix_multiply_accumulate )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#include "gpu/ocl/ocl_zero_points.h" )==""\n"
R"==(#define KDHW_SIZE (KH * KW * KD) )==""\n"
R"==(#if (PW % 4 == 0) && (SRC_SLM_SIZE % 4 == 0) )==""\n"
R"==(#define WRITE_SLM_BLOCK(p, data) block_write(p, data) )==""\n"
R"==(#define WRITE_SLM_BLOCK_SHORT(p, data) block_write_us(p, data) )==""\n"
R"==(#else )==""\n"
R"==(#define WRITE_SLM_BLOCK(p, data) block_write_emu(p, data) )==""\n"
R"==(#define WRITE_SLM_BLOCK_SHORT(p, data) block_write_us_emu(p, data) )==""\n"
R"==(#endif )==""\n"
R"==(#define GET_INT_BLOCK(SRC_SLM, SLM_INDEX, SRC_GLOBAL, GLOBAL_INDEX) \ )==""\n"
R"==(uchar4 res = 0; \ )==""\n"
R"==(for (int j = 0; j < IC; j++) { \ )==""\n"
R"==(res[j] = SRC_GLOBAL[GLOBAL_INDEX + j * IH * IW * ID]; \ )==""\n"
R"==(} \ )==""\n"
R"==(SRC_SLM[SLM_INDEX] = as_int(res); )==""\n"
R"==(#define BLOCK_READ_SRC(data, idx) \ )==""\n"
R"==(data = intel_sub_group_block_read8((__global uint *)&src[idx]); )==""\n"
R"==(#define BLOCK_READ_WHT(data, idx) \ )==""\n"
R"==(data = as_int(intel_sub_group_block_read((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT8(data, idx) \ )==""\n"
R"==(data = as_int8(intel_sub_group_block_read8((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4((__global uint *)&bias[idx])); )==""\n"
R"==(#define BLOCK_READ_SCALES(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4( \ )==""\n"
R"==((__global uint *)&runtime_scales[idx])); )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(#define SCALE_VEC4 scales.s01230123 )==""\n"
R"==(#define SCALE scales )==""\n"
R"==(#elif SCALES_COMMON )==""\n"
R"==(#define SCALE_VEC4 runtime_scales[0] )==""\n"
R"==(#define SCALE runtime_scales[0] )==""\n"
R"==(#else )==""\n"
R"==(#define SCALE_VEC4 1 )==""\n"
R"==(#define SCALE 1 )==""\n"
R"==(#endif )==""\n"
R"==(#define OC_PADD8 ((OC % 8) ? (OC / 8 + 1) * 8 : OC) )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) __kernel void )==""\n"
R"==(conv_fwd_first_x8s8x(const __global uchar *src, const __global char *wei, )==""\n"
R"==(const __global float *bias, __global DST_DATA_T *dst POST_OP_ARGS, )==""\n"
R"==(const __global float *runtime_scales, )==""\n"
R"==(const __global int *src_compensation, const __global int *src_zpoints, )==""\n"
R"==(const __global int *dst_compensation) { )==""\n"
R"==(const int group_oc = get_group_id(0) * OC_GROUP; )==""\n"
R"==(const int group_sp = get_group_id(1) * SP_GROUP; )==""\n"
R"==(const int group_mb = get_group_id(2) * MB_GROUP; )==""\n"
R"==(const int is_mb_padding = MB % MB_BLOCK != 0 && group_mb >= MB; )==""\n"
R"==(const int sub_group_id = get_sub_group_id(); )==""\n"
R"==(const int sub_local_id = get_sub_group_local_id(); )==""\n"
R"==(const int oc = (sub_group_id % OC_GROUP); )==""\n"
R"==(const int sp = (sub_group_id / OC_GROUP); )==""\n"
R"==(const int g = (group_oc + oc) / OC_NCHUNK; )==""\n"
R"==(const int group_ic = IC_NCHUNK * g; )==""\n"
R"==(const int god = group_sp / (OW_PADDED * OH); )==""\n"
R"==(const int gohw = group_sp % (OW_PADDED * OH); )==""\n"
R"==(const int goh = gohw / OW_PADDED; )==""\n"
R"==(const int gow = OW_BLOCK * (gohw % OW_PADDED); )==""\n"
R"==(const int gid = god * SD; )==""\n"
R"==(const int gih = goh * SH; )==""\n"
R"==(const int giw = gow * SW; )==""\n"
R"==(const int local_ow = OW_BLOCK * sp; )==""\n"
R"==(const int local_iw = local_ow * SW; )==""\n"
R"==(const int od = god; )==""\n"
R"==(const int ow = gow + local_ow; )==""\n"
R"==(const int oh = goh; )==""\n"
R"==(const int id = gid - PD; )==""\n"
R"==(const int iw = giw + local_iw - PW; )==""\n"
R"==(const int ih = gih - PH; )==""\n"
R"==(__local uint S_slice[SRC_SLM_SIZE * KH * KD]; )==""\n"
R"==(__local uint *S_part = S_slice + (sp * SW * OW_BLOCK + PW); )==""\n"
R"==(__local SRC_MMAD_DATA_T *S_work = S_slice + (sp * SW * OW_BLOCK); )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * MB_BLOCK * (group_oc + oc); )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * OC_NCHUNK * G * MB_BLOCK )==""\n"
R"==(* (group_mb / MB_BLOCK); )==""\n"
R"==(dst += OC_BLOCK * (group_mb % MB_BLOCK); )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK * (OW * OH * od + OW * oh + ow); )==""\n"
R"==(#if NCHW == 1 )==""\n"
R"==(src += IC * ID * IH * IW * G * group_mb; )==""\n"
R"==(src += (IW * IH * id + IW * ih + iw + PW); )==""\n"
R"==(#else )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * G * group_mb; )==""\n"
R"==(src += IC_BLOCK * (IW * IH * id + IW * ih + iw + PW); )==""\n"
R"==(#endif )==""\n"
R"==(wei += 4 * KDHW_SIZE * OC_BLOCK * (group_oc + oc); )==""\n"
R"==(/* WORK WITH SLM */ )==""\n"
R"==(const bool left_tail = iw < 0 || iw >= IW; )==""\n"
R"==(const bool left_nozero_tail = sub_group_id == 0 && iw >= 0; )==""\n"
R"==(const bool right_tail = (iw + PW + SLM_TAIL >= IW) && (iw + PW < IW); )==""\n"
R"==(const bool empty = (iw + PW >= IW); )==""\n"
R"==(const bool right_nozero_tail )==""\n"
R"==(= sp == (LWS_1 - 1) && (iw + PW + SLM_TAIL < IW); )==""\n"
R"==(/* KD */ )==""\n"
R"==(#if KD > 1 )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(if (kd * (1 + DD) + id < 0 || kd * (1 + DD) + id >= ID) { )==""\n"
R"==(S_part += SRC_SLM_SIZE * KH; )==""\n"
R"==(src += IC_BLOCK * IW * IH * (1 + DD); )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(/* KH */ )==""\n"
R"==(#if KH > 1 )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(if (kh * (1 + DH) + ih < 0 || kh * (1 + DH) + ih >= IH) { )==""\n"
R"==(S_part += SRC_SLM_SIZE; )==""\n"
R"==(src += IC_BLOCK * IW * (1 + DH); )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(/* KW */ )==""\n"
R"==(/* left tail */ )==""\n"
R"==(if (is_mb_padding) { goto end_conv_calculate; } )==""\n"
R"==(#if PW > 0 || OW != OWX )==""\n"
R"==(if (left_tail) { )==""\n"
R"==(for (int i = -PW; i < 0; i += 8) { )==""\n"
R"==(if (i + sub_local_id < 0) S_part[i + sub_local_id] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(/* right tail */ )==""\n"
R"==(#if ZERO_TAIL > 0 )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(for (int i = SLM_TAIL; i < SW * OW_BLOCK + (KW - 1) * (1 + DW); )==""\n"
R"==(i++) { )==""\n"
R"==(S_part[i] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(if (empty) { )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK + (KW - 1) * (1 + DW); i++) { )==""\n"
R"==(S_part[i] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK || OW != OWX )==""\n"
R"==(if (iw + PW < IW) { )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_NCHUNK > LWS_1 )==""\n"
R"==(/* Copy tails in case of multigroups */ )==""\n"
R"==(if (ow < OW) { )==""\n"
R"==(#if PW > 0 )==""\n"
R"==(if (left_nozero_tail) { )==""\n"
R"==(for (int i = -PW; i < 0; i += 8) { )==""\n"
R"==(if (i + sub_local_id < 0) { )==""\n"
R"==(#if NCHW == 1 )==""\n"
R"==(GET_INT_BLOCK(S_part, i + sub_local_id, src, )==""\n"
R"==(i + sub_local_id); )==""\n"
R"==(#else )==""\n"
R"==(S_part[i + sub_local_id] = (( )==""\n"
R"==(__global uint *)src)[i + sub_local_id]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(if (right_nozero_tail) { )==""\n"
R"==(for (int i = SW * OW_BLOCK; )==""\n"
R"==(i < SW * OW_BLOCK + (KW - 1) * (1 + DW) - PW; )==""\n"
R"==(i += 8) { )==""\n"
R"==(if (i + sub_local_id < SW * OW_BLOCK )==""\n"
R"==(+ (KW - 1) * (1 + DW) - PW) { )==""\n"
R"==(#if NCHW == 1 )==""\n"
R"==(GET_INT_BLOCK(S_part, i + sub_local_id, src, )==""\n"
R"==(i + sub_local_id); )==""\n"
R"==(#else )==""\n"
R"==(S_part[i + sub_local_id] = (( )==""\n"
R"==(__global uint *)src)[i + sub_local_id]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_TAIL != OW_BLOCK * SW )==""\n"
R"==(/* Copy last block to SLM */ )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int i = 0; )==""\n"
R"==(i < SLM_TAIL; )==""\n"
R"==(i += 8) { )==""\n"
R"==(if (i + sub_local_id < SLM_TAIL) { )==""\n"
R"==(#if NCHW == 1 )==""\n"
R"==(GET_INT_BLOCK(S_part, i + sub_local_id, src, )==""\n"
R"==(i + sub_local_id); )==""\n"
R"==(#else )==""\n"
R"==(S_part[i + sub_local_id] = (( )==""\n"
R"==(__global uint *)src)[i + sub_local_id]; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(#endif )==""\n"
R"==(#if (SW * OW_BLOCK) % 8 == 0 )==""\n"
R"==(/* Copy block to SLM */ )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint)) for (int i = 0; )==""\n"
R"==(i < SW * OW_BLOCK; )==""\n"
R"==(i += 8) { )==""\n"
R"==(#if NCHW == 1 )==""\n"
R"==(uchar4 res = 0; )==""\n"
R"==(for (int j = 0; j < IC; j++) { )==""\n"
R"==(if ((ulong)&src[(i + j * IH * IW * ID)] % 4 )==""\n"
R"==(== 0) )==""\n"
R"==(res[j] = intel_sub_group_block_read_uc( )==""\n"
R"==(src + i + j * IH * IW * ID); )==""\n"
R"==(else )==""\n"
R"==(res[j] = src[i + j * IH * IW * ID )==""\n"
R"==(+ get_sub_group_local_id()]; )==""\n"
R"==(} )==""\n"
R"==(WRITE_SLM_BLOCK(S_part + i, as_int(res)); )==""\n"
R"==(#else )==""\n"
R"==(WRITE_SLM_BLOCK(S_part + i, )==""\n"
R"==(intel_sub_group_block_read(( )==""\n"
R"==(const __global uint )==""\n"
R"==(*)(&src[i * IC_BLOCK]))); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#elif (SW * OW_BLOCK) % 4 == 0 && NCHW == 0 )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int i = 0; i < SW * OW_BLOCK; )==""\n"
R"==(i += 4) { )==""\n"
R"==(WRITE_SLM_BLOCK_SHORT(S_part + i, )==""\n"
R"==(intel_sub_group_block_read_us( )==""\n"
R"==((const __global ushort *)(&src[i * IC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int i = 0; i < SW * OW_BLOCK; )==""\n"
R"==(i++) { )==""\n"
R"==(GET_INT_BLOCK(S_part, i, src, i); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_TAIL != OW_BLOCK * SW )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_NCHUNK > LWS_1 )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK || OW != OWX )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(/* right tail */ )==""\n"
R"==(#if ZERO_TAIL > 0 )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(for (int i = SLM_TAIL; i < SW * OW_BLOCK + (KW - 1) * (1 + DW); )==""\n"
R"==(i += 8) { )==""\n"
R"==(if (i + sub_local_id < SW * OW_BLOCK + (KW - 1) * (1 + DW)) )==""\n"
R"==(S_part[i + sub_local_id] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK || OW != OWX )==""\n"
R"==(if (empty) { )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK + (KW - 1) * (1 + DW); )==""\n"
R"==(i += 8) { )==""\n"
R"==(if (i + sub_local_id < SW * OW_BLOCK + (KW - 1) * (1 + DW)) )==""\n"
R"==(S_part[i + sub_local_id] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if KH > 1 )==""\n"
R"==(S_part += SRC_SLM_SIZE; )==""\n"
R"==(src += IC_BLOCK * IW * (1 + DH); )==""\n"
R"==(} )==""\n"
R"==(S_part -= SRC_SLM_SIZE * KH; )==""\n"
R"==(src -= IC_BLOCK * KH * IW * (1 + DH); )==""\n"
R"==(#endif )==""\n"
R"==(#if KD > 1 )==""\n"
R"==(S_part += SRC_SLM_SIZE * KH; )==""\n"
R"==(src += IC_BLOCK * IW * IH * (1 + DD); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(end_conv_calculate: )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(SRC_MMAD_DATA8_T S; )==""\n"
R"==(int8 W0 = 0, W1 = 0, W2 = 0, W3 = 0; )==""\n"
R"==(int W00 = 0, W10 = 0, W20 = 0, W30 = 0; )==""\n"
R"==(int8 C00 = 0; )==""\n"
R"==(int8 C10 = 0; )==""\n"
R"==(int8 C20 = 0; )==""\n"
R"==(int8 C30 = 0; )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(SRC_MMAD_DATA4_T SS; )==""\n"
R"==(int4 C01 = 0; )==""\n"
R"==(int4 C11 = 0; )==""\n"
R"==(int4 C21 = 0; )==""\n"
R"==(int4 C31 = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 16 )==""\n"
R"==(int8 C01 = 0; )==""\n"
R"==(int8 C11 = 0; )==""\n"
R"==(int8 C21 = 0; )==""\n"
R"==(int8 C31 = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(int4 z = 0; )==""\n"
R"==(if (IC > 0) z.s0 = src_zpoints[0]; )==""\n"
R"==(if (IC > 1) z.s1 = src_zpoints[1]; )==""\n"
R"==(if (IC > 2) z.s2 = src_zpoints[2]; )==""\n"
R"==(if (IC > 3) z.s3 = src_zpoints[3]; )==""\n"
R"==(#else )==""\n"
R"==(int4 z = read_src_zero_point(src_zpoints); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if !WITH_SRC_ZPOINTS )==""\n"
R"==(for (int i = 0; i < KDHW_SIZE - KDHW_SIZE % 8; i += 8) { )==""\n"
R"==(const int ihw = (i + sub_local_id) % (KW * KH); )==""\n"
R"==(const int filter_iw = (ihw % KW) * (1 + DW); )==""\n"
R"==(const int filter_ih = ihw / KW; )==""\n"
R"==(const int filter_id = (i + sub_local_id) / (KH * KW); )==""\n"
R"==(const int filter = (filter_ih * (1 + DH) + ih >= 0) )==""\n"
R"==(&& (filter_ih * (1 + DH) + ih < IH) )==""\n"
R"==(&& (filter_id * (1 + DD) + id >= 0 )==""\n"
R"==(&& filter_id * (1 + DD) + id < ID); )==""\n"
R"==(BLOCK_READ_WHT8(W0, 0); )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK )==""\n"
R"==(BLOCK_READ_WHT8(W1, KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK * 2 )==""\n"
R"==(BLOCK_READ_WHT8(W2, 2 * KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK * 3 )==""\n"
R"==(BLOCK_READ_WHT8(W3, 3 * KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(if (filter) { )==""\n"
R"==(S.s0 = S_work[SW * 0 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s1 = S_work[SW * 1 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s2 = S_work[SW * 2 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s3 = S_work[SW * 3 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s4 = S_work[SW * 4 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s5 = S_work[SW * 5 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s6 = S_work[SW * 6 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s7 = S_work[SW * 7 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(SS.s0 = S_work[SW * 8 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s1 = S_work[SW * 9 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s2 = S_work[SW * 10 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s3 = S_work[SW * 11 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(#endif  )==""\n"
R"==(} else { )==""\n"
R"==(S = 0; )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(SS = 0; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(C00 = mmad8x8(S, W0, C00); )==""\n"
R"==(C10 = mmad8x8(S, W1, C10); )==""\n"
R"==(C20 = mmad8x8(S, W2, C20); )==""\n"
R"==(C30 = mmad8x8(S, W3, C30); )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(C01 = mmad8x4(SS, W0, C01); )==""\n"
R"==(C11 = mmad8x4(SS, W1, C11); )==""\n"
R"==(C21 = mmad8x4(SS, W2, C21); )==""\n"
R"==(C31 = mmad8x4(SS, W3, C31); )==""\n"
R"==(#endif  )==""\n"
R"==(#if OW_BLOCK == 16 )==""\n"
R"==(if (filter) { )==""\n"
R"==(S.s0 = S_work[SW * 8 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s1 = S_work[SW * 9 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s2 = S_work[SW * 10 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s3 = S_work[SW * 11 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s4 = S_work[SW * 12 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s5 = S_work[SW * 13 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s6 = S_work[SW * 14 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s7 = S_work[SW * 15 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(} else { )==""\n"
R"==(S = 0; )==""\n"
R"==(} )==""\n"
R"==(C01 = mmad8x8(S, W0, C01); )==""\n"
R"==(C11 = mmad8x8(S, W1, C11); )==""\n"
R"==(C21 = mmad8x8(S, W2, C21); )==""\n"
R"==(C31 = mmad8x8(S, W3, C31); )==""\n"
R"==(#endif  )==""\n"
R"==(wei += OC_BLOCK * 8; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(for (int i = 0; i < KDHW_SIZE; i++) )==""\n"
R"==(#else )==""\n"
R"==(for (int i = KDHW_SIZE - KDHW_SIZE % 8; i < KDHW_SIZE; i++) )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(const int ihw = (i) % (KW * KH); )==""\n"
R"==(const int filter_iw = (ihw % KW) * (1 + DW); )==""\n"
R"==(const int filter_ih = ihw / KW; )==""\n"
R"==(const int filter_id = (i) / (KH * KW); )==""\n"
R"==(const int filter = (filter_ih * (1 + DH) + ih >= 0) )==""\n"
R"==(&& (filter_ih * (1 + DH) + ih < IH) )==""\n"
R"==(&& (filter_id * (1 + DD) + id >= 0 )==""\n"
R"==(&& filter_id * (1 + DD) + id < ID); )==""\n"
R"==(if (filter) { )==""\n"
R"==(BLOCK_READ_WHT(W00, 0); )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK )==""\n"
R"==(BLOCK_READ_WHT(W10, KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK * 2 )==""\n"
R"==(BLOCK_READ_WHT(W20, 2 * KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK * 3 )==""\n"
R"==(BLOCK_READ_WHT(W30, 3 * KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(int4 src_comp; )==""\n"
R"==(src_comp.s0 = calc_src_compensation_x4(z, W00); )==""\n"
R"==(src_comp.s1 = calc_src_compensation_x4(z, W10); )==""\n"
R"==(src_comp.s2 = calc_src_compensation_x4(z, W20); )==""\n"
R"==(src_comp.s3 = calc_src_compensation_x4(z, W30); )==""\n"
R"==(unroll_for(uint j = 0; j < 8; ++j) { )==""\n"
R"==(if (filter_iw + iw + j * SW >= 0 )==""\n"
R"==(&& filter_iw + iw + j * SW < IW) { )==""\n"
R"==(C00[j] -= src_comp.s0; )==""\n"
R"==(C10[j] -= src_comp.s1; )==""\n"
R"==(C20[j] -= src_comp.s2; )==""\n"
R"==(C30[j] -= src_comp.s3; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if (OW_BLOCK == 12) || (OW_BLOCK == 16) )==""\n"
R"==(unroll_for(uint j = 8; j < OW_BLOCK; ++j) { )==""\n"
R"==(if (filter_iw + iw + j * SW >= 0 )==""\n"
R"==(&& filter_iw + iw + j * SW < IW) { )==""\n"
R"==(C01[j - 8] -= src_comp.s0; )==""\n"
R"==(C11[j - 8] -= src_comp.s1; )==""\n"
R"==(C21[j - 8] -= src_comp.s2; )==""\n"
R"==(C31[j - 8] -= src_comp.s3; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(S.s0 = S_work[SW * 0 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s1 = S_work[SW * 1 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s2 = S_work[SW * 2 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s3 = S_work[SW * 3 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s4 = S_work[SW * 4 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s5 = S_work[SW * 5 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s6 = S_work[SW * 6 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s7 = S_work[SW * 7 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(SS.s0 = S_work[SW * 8 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s1 = S_work[SW * 9 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s2 = S_work[SW * 10 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s3 = S_work[SW * 11 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(#endif  )==""\n"
R"==(C00.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W00), C00.s0); )==""\n"
R"==(C00.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W00), C00.s1); )==""\n"
R"==(C00.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W00), C00.s2); )==""\n"
R"==(C00.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W00), C00.s3); )==""\n"
R"==(C00.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W00), C00.s4); )==""\n"
R"==(C00.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W00), C00.s5); )==""\n"
R"==(C00.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W00), C00.s6); )==""\n"
R"==(C00.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W00), C00.s7); )==""\n"
R"==(C10.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W10), C10.s0); )==""\n"
R"==(C10.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W10), C10.s1); )==""\n"
R"==(C10.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W10), C10.s2); )==""\n"
R"==(C10.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W10), C10.s3); )==""\n"
R"==(C10.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W10), C10.s4); )==""\n"
R"==(C10.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W10), C10.s5); )==""\n"
R"==(C10.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W10), C10.s6); )==""\n"
R"==(C10.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W10), C10.s7); )==""\n"
R"==(C20.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W20), C20.s0); )==""\n"
R"==(C20.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W20), C20.s1); )==""\n"
R"==(C20.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W20), C20.s2); )==""\n"
R"==(C20.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W20), C20.s3); )==""\n"
R"==(C20.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W20), C20.s4); )==""\n"
R"==(C20.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W20), C20.s5); )==""\n"
R"==(C20.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W20), C20.s6); )==""\n"
R"==(C20.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W20), C20.s7); )==""\n"
R"==(C30.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W30), C30.s0); )==""\n"
R"==(C30.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W30), C30.s1); )==""\n"
R"==(C30.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W30), C30.s2); )==""\n"
R"==(C30.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W30), C30.s3); )==""\n"
R"==(C30.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W30), C30.s4); )==""\n"
R"==(C30.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W30), C30.s5); )==""\n"
R"==(C30.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W30), C30.s6); )==""\n"
R"==(C30.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W30), C30.s7); )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(C01.s0 = idot4(AS_SRC_DATA4_T(SS.s0), as_char4(W00), C01.s0); )==""\n"
R"==(C01.s1 = idot4(AS_SRC_DATA4_T(SS.s1), as_char4(W00), C01.s1); )==""\n"
R"==(C01.s2 = idot4(AS_SRC_DATA4_T(SS.s2), as_char4(W00), C01.s2); )==""\n"
R"==(C01.s3 = idot4(AS_SRC_DATA4_T(SS.s3), as_char4(W00), C01.s3); )==""\n"
R"==(C11.s0 = idot4(AS_SRC_DATA4_T(SS.s0), as_char4(W10), C11.s0); )==""\n"
R"==(C11.s1 = idot4(AS_SRC_DATA4_T(SS.s1), as_char4(W10), C11.s1); )==""\n"
R"==(C11.s2 = idot4(AS_SRC_DATA4_T(SS.s2), as_char4(W10), C11.s2); )==""\n"
R"==(C11.s3 = idot4(AS_SRC_DATA4_T(SS.s3), as_char4(W10), C11.s3); )==""\n"
R"==(C21.s0 = idot4(AS_SRC_DATA4_T(SS.s0), as_char4(W20), C21.s0); )==""\n"
R"==(C21.s1 = idot4(AS_SRC_DATA4_T(SS.s1), as_char4(W20), C21.s1); )==""\n"
R"==(C21.s2 = idot4(AS_SRC_DATA4_T(SS.s2), as_char4(W20), C21.s2); )==""\n"
R"==(C21.s3 = idot4(AS_SRC_DATA4_T(SS.s3), as_char4(W20), C21.s3); )==""\n"
R"==(C31.s0 = idot4(AS_SRC_DATA4_T(SS.s0), as_char4(W30), C31.s0); )==""\n"
R"==(C31.s1 = idot4(AS_SRC_DATA4_T(SS.s1), as_char4(W30), C31.s1); )==""\n"
R"==(C31.s2 = idot4(AS_SRC_DATA4_T(SS.s2), as_char4(W30), C31.s2); )==""\n"
R"==(C31.s3 = idot4(AS_SRC_DATA4_T(SS.s3), as_char4(W30), C31.s3); )==""\n"
R"==(#endif  )==""\n"
R"==(#if OW_BLOCK == 16 )==""\n"
R"==(S.s0 = S_work[SW * 8 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s1 = S_work[SW * 9 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s2 = S_work[SW * 10 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s3 = S_work[SW * 11 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s4 = S_work[SW * 12 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s5 = S_work[SW * 13 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s6 = S_work[SW * 14 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s7 = S_work[SW * 15 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(C01.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W00), C01.s0); )==""\n"
R"==(C01.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W00), C01.s1); )==""\n"
R"==(C01.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W00), C01.s2); )==""\n"
R"==(C01.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W00), C01.s3); )==""\n"
R"==(C01.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W00), C01.s4); )==""\n"
R"==(C01.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W00), C01.s5); )==""\n"
R"==(C01.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W00), C01.s6); )==""\n"
R"==(C01.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W00), C01.s7); )==""\n"
R"==(C11.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W10), C11.s0); )==""\n"
R"==(C11.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W10), C11.s1); )==""\n"
R"==(C11.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W10), C11.s2); )==""\n"
R"==(C11.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W10), C11.s3); )==""\n"
R"==(C11.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W10), C11.s4); )==""\n"
R"==(C11.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W10), C11.s5); )==""\n"
R"==(C11.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W10), C11.s6); )==""\n"
R"==(C11.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W10), C11.s7); )==""\n"
R"==(C21.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W20), C21.s0); )==""\n"
R"==(C21.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W20), C21.s1); )==""\n"
R"==(C21.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W20), C21.s2); )==""\n"
R"==(C21.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W20), C21.s3); )==""\n"
R"==(C21.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W20), C21.s4); )==""\n"
R"==(C21.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W20), C21.s5); )==""\n"
R"==(C21.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W20), C21.s6); )==""\n"
R"==(C21.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W20), C21.s7); )==""\n"
R"==(C31.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W30), C31.s0); )==""\n"
R"==(C31.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W30), C31.s1); )==""\n"
R"==(C31.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W30), C31.s2); )==""\n"
R"==(C31.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W30), C31.s3); )==""\n"
R"==(C31.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W30), C31.s4); )==""\n"
R"==(C31.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W30), C31.s5); )==""\n"
R"==(C31.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W30), C31.s6); )==""\n"
R"==(C31.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W30), C31.s7); )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(wei += OC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(DST_DATA16_T R1, R2, R3, R4; )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(float4 scales; )==""\n"
R"==(BLOCK_READ_SCALES(scales, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float4 bia; )==""\n"
R"==(BLOCK_READ_BIA(bia, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp = SCALE * fma(tmp, (float4)1, bia); )==""\n"
R"==(#define QUANTIZE_ADD_BIAS_4() \ )==""\n"
R"==(tmp0 = ((float8)SCALE_VEC4) * fma(tmp0, (float8)1, bia.s01230123); \ )==""\n"
R"==(tmp1 = ((float8)SCALE_VEC4) * fma(tmp1, (float8)1, bia.s01230123); )==""\n"
R"==(#else )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp *= SCALE; )==""\n"
R"==(#define QUANTIZE_ADD_BIAS_4() \ )==""\n"
R"==(tmp0 *= SCALE_VEC4; \ )==""\n"
R"==(tmp1 *= SCALE_VEC4; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_DST_ZPOINTS )==""\n"
R"==(int4 dst_zp = read_dst_zero_points_32c( )==""\n"
R"==(dst_compensation, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#define ADD_DST_COMPENSATION() tmp += convert_float4(dst_zp); )==""\n"
R"==(#define ADD_DST_COMPENSATION_4() \ )==""\n"
R"==(tmp0 += convert_float8(dst_zp.s01230123); \ )==""\n"
R"==(tmp1 += convert_float8(dst_zp.s01230123); )==""\n"
R"==(#else )==""\n"
R"==(#define ADD_DST_COMPENSATION() )==""\n"
R"==(#define ADD_DST_COMPENSATION_4() )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(#define ZERO_PAD_DST() tmp = zero_pad_dst_32c(tmp, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#define ZERO_PAD_DST_4() \ )==""\n"
R"==(const int4 zp_mask = as_int4(zero_pad_dst_32c( \ )==""\n"
R"==(as_float4((int4)(~0u)), (group_oc + oc) * OC_BLOCK)); \ )==""\n"
R"==(tmp0 = as_float8(as_int8(tmp0) & zp_mask.s01230123); \ )==""\n"
R"==(tmp1 = as_float8(as_int8(tmp1) & zp_mask.s01230123); )==""\n"
R"==(#else )==""\n"
R"==(#define ZERO_PAD_DST() )==""\n"
R"==(#define ZERO_PAD_DST_4() )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_POST_OP )==""\n"
R"==(#define POST_OP_COMMON(accumulator, dest_data, dest_data_type, oc_block, i) \ )==""\n"
R"==(const int po_mb = group_mb % MB; \ )==""\n"
R"==(const int po_oc = (oc * OC_BLOCK) % (OC * G); \ )==""\n"
R"==(APPLY_POST_OPS_TRY_BURST(accumulator, float, dest_data, dest_data_type, \ )==""\n"
R"==(po_mb, 1, po_oc, oc_block *SUB_GROUP_SIZE, sub_local_id); )==""\n"
R"==(#define DO_POST_OP(i) \ )==""\n"
R"==({ \ )==""\n"
R"==(SUM_DATA4_T d; \ )==""\n"
R"==(if (WITH_SUM) d = AS_SUM_DATA4_T(BLOCK_READ_DST4(dst)); \ )==""\n"
R"==(POST_OP_COMMON(tmp, d, SUM_DATA_T, 4, i); \ )==""\n"
R"==(} )==""\n"
R"==(#define DO_POST_OP_4(i) \ )==""\n"
R"==({ \ )==""\n"
R"==(SUM_DATA16_T d; \ )==""\n"
R"==(if (WITH_SUM) d = AS_SUM_DATA16_T(BLOCK_READ_DST16(dst)); \ )==""\n"
R"==(float16 tmp_x16 = (float16)(tmp0, tmp1); \ )==""\n"
R"==(POST_OP_COMMON(tmp_x16, d, SUM_DATA_T, 4, i); \ )==""\n"
R"==(tmp0 = tmp_x16.s01234567; \ )==""\n"
R"==(tmp1 = tmp_x16.s89abcdef; \ )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#define DO_POST_OP(i) ; )==""\n"
R"==(#define DO_POST_OP_4(i) ; )==""\n"
R"==(#endif  )==""\n"
R"==(#define PACK(C0, C1, C2, C3, idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp[0] = C0[idx]; \ )==""\n"
R"==(tmp[1] = C1[idx]; \ )==""\n"
R"==(tmp[2] = C2[idx]; \ )==""\n"
R"==(tmp[3] = C3[idx]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define PACK_4(C0, C1, C2, C3, idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp0.s0 = C0[idx]; \ )==""\n"
R"==(tmp0.s1 = C1[idx]; \ )==""\n"
R"==(tmp0.s2 = C2[idx]; \ )==""\n"
R"==(tmp0.s3 = C3[idx]; \ )==""\n"
R"==(\ )==""\n"
R"==(tmp0.s4 = C0[idx + 1]; \ )==""\n"
R"==(tmp0.s5 = C1[idx + 1]; \ )==""\n"
R"==(tmp0.s6 = C2[idx + 1]; \ )==""\n"
R"==(tmp0.s7 = C3[idx + 1]; \ )==""\n"
R"==(\ )==""\n"
R"==(tmp1.s0 = C0[idx + 2]; \ )==""\n"
R"==(tmp1.s1 = C1[idx + 2]; \ )==""\n"
R"==(tmp1.s2 = C2[idx + 2]; \ )==""\n"
R"==(tmp1.s3 = C3[idx + 2]; \ )==""\n"
R"==(\ )==""\n"
R"==(tmp1.s4 = C0[idx + 3]; \ )==""\n"
R"==(tmp1.s5 = C1[idx + 3]; \ )==""\n"
R"==(tmp1.s6 = C2[idx + 3]; \ )==""\n"
R"==(tmp1.s7 = C3[idx + 3]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define CONVERT_PACK() \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp_cvt = CONVERT_DST_DATA4_T(tmp); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define CONVERT_PACK_4() \ )==""\n"
R"==(do { \ )==""\n"
R"==(R.s01234567 = CONVERT_DST_DATA8_T(tmp0); \ )==""\n"
R"==(R.s89abcdef = CONVERT_DST_DATA8_T(tmp1); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define STORE_DST(C0, C1, C2, C3, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(PACK(C0, C1, C2, C3, i); \ )==""\n"
R"==(if (!is_mb_padding) { \ )==""\n"
R"==(QUANTIZE_ADD_BIAS(); \ )==""\n"
R"==(DO_POST_OP(i); \ )==""\n"
R"==(ADD_DST_COMPENSATION(); \ )==""\n"
R"==(ZERO_PAD_DST(); \ )==""\n"
R"==(CONVERT_PACK(); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(tmp_cvt = 0; \ )==""\n"
R"==(} \ )==""\n"
R"==(BLOCK_WRITE_DST4(dst, tmp_cvt); \ )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define STORE_DST_4(C0, C1, C2, C3, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(PACK_4(C0, C1, C2, C3, i); \ )==""\n"
R"==(QUANTIZE_ADD_BIAS_4(); \ )==""\n"
R"==(DO_POST_OP_4(i); \ )==""\n"
R"==(ADD_DST_COMPENSATION_4(); \ )==""\n"
R"==(ZERO_PAD_DST_4(); \ )==""\n"
R"==(CONVERT_PACK_4(); \ )==""\n"
R"==(BLOCK_WRITE_DST16(dst, R); \ )==""\n"
R"==(dst += 4 * OC_BLOCK; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(if (ow < OW) { )==""\n"
R"==(float4 tmp; )==""\n"
R"==(DST_DATA4_T tmp_cvt; )==""\n"
R"==(float8 tmp0, tmp1; )==""\n"
R"==(DST_DATA16_T R; )==""\n"
R"==(#if OW_TAIL )==""\n"
R"==(if (ow + OW_BLOCK < OW) { )==""\n"
R"==(#endif )==""\n"
R"==(#if MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 0); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 1); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 2); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 3); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 4); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 5); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 6); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 7); )==""\n"
R"==(#if OW_BLOCK >= 12 )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 0); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 1); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 2); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 3); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 16 )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 4); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 5); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 6); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 7); )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C00, C10, C20, C30, 0); )==""\n"
R"==(STORE_DST_4(C00, C10, C20, C30, 4); )==""\n"
R"==(#if OW_BLOCK >= 12 )==""\n"
R"==(STORE_DST_4(C01, C11, C21, C31, 0); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 16 )==""\n"
R"==(STORE_DST_4(C01, C11, C21, C31, 4); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL )==""\n"
R"==(} else { )==""\n"
R"==(#if OW_TAIL < 4 )==""\n"
R"==(for (int i = 0; i < OW_TAIL; i++) { )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, i); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 0); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 1); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 2); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 3); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C00, C10, C20, C30, 0); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL > 4 )==""\n"
R"==(#if OW_TAIL < 8 )==""\n"
R"==(for (int i = 4; i < OW_TAIL; i++) { )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, i); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 4); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 5); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 6); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 7); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C00, C10, C20, C30, 4); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL > 8 )==""\n"
R"==(#if OW_TAIL < 12 )==""\n"
R"==(for (int i = 8; i < OW_TAIL; i++) { )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, i - 8); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 0); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 1); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 2); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 3); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C01, C11, C21, C31, 0); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL > 12 )==""\n"
R"==(#if OW_TAIL < 16 )==""\n"
R"==(for (int i = 12; i < OW_TAIL; i++) { )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, i - 8); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 4); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 5); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 6); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 7); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C01, C11, C21, C31, 4); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}