namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_fwd_data_mb_block_x8s8x_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#include "gpu/ocl/ocl_zero_points.h" )==""\n"
R"==(#define SRC_DATA_BLOCK_T SRC_MMAD_DATA8_T )==""\n"
R"==(#define AS_SRC_DATA_BLOCK_T AS_SRC_MMAD_DATA8_T )==""\n"
R"==(#define BLOCK_READ_SRC(data, idx) \ )==""\n"
R"==(data = AS_SRC_DATA_BLOCK_T( \ )==""\n"
R"==(intel_sub_group_block_read8((__global uint *)&src[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT(data, idx) \ )==""\n"
R"==(data = as_int8(intel_sub_group_block_read8((__global uint *)&wei[idx])); )==""\n"
R"==(#if OC % OC_BLOCK == 0 )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4((__global uint *)&bias[idx])); )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = (float4)0; \ )==""\n"
R"==(int i; \ )==""\n"
R"==(for (i = idx; i < idx + OC_BLOCK && i < OC - (OC % SUB_GROUP_SIZE); \ )==""\n"
R"==(i += SUB_GROUP_SIZE) { \ )==""\n"
R"==(data[(i - idx) / SUB_GROUP_SIZE] = as_float( \ )==""\n"
R"==(intel_sub_group_block_read((__global uint *)&bias[i])); \ )==""\n"
R"==(} \ )==""\n"
R"==(if ((get_sub_group_local_id() < OC % SUB_GROUP_SIZE) && i < OC \ )==""\n"
R"==(&& (i - idx) / SUB_GROUP_SIZE < 4) { \ )==""\n"
R"==(data[(i - idx) / SUB_GROUP_SIZE] \ )==""\n"
R"==(= as_float(bias[i + get_sub_group_local_id()]); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#define BLOCK_READ_SCALES(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4( \ )==""\n"
R"==((__global uint *)&runtime_scales[idx])); )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(#define SCALE scales )==""\n"
R"==(#elif SCALES_COMMON )==""\n"
R"==(#define SCALE runtime_scales[0] )==""\n"
R"==(#else )==""\n"
R"==(#define SCALE 1 )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) __kernel void )==""\n"
R"==(conv_fwd_mb_block_x8s8x(const __global uchar *src, const __global char *wei, )==""\n"
R"==(const __global float *bias, __global DST_DATA_T *dst POST_OP_ARGS, )==""\n"
R"==(const __global float *runtime_scales, )==""\n"
R"==(const __global int *src_compensation, const __global int *src_zpoints, )==""\n"
R"==(const __global int *dst_compensation) { )==""\n"
R"==(#ifdef MB_FULL_BLOCK )==""\n"
R"==(const int mb_blocks = 1; )==""\n"
R"==(#else  )==""\n"
R"==(const int mb_blocks = 2; )==""\n"
R"==(#endif  )==""\n"
R"==(const int group_oc = get_group_id(0) * OC_GROUP; )==""\n"
R"==(const int group_mb = get_group_id(2) * MB_GROUP / mb_blocks; )==""\n"
R"==(const int group_sp = get_group_id(1) * SP_GROUP; )==""\n"
R"==(const int mb = get_group_id(2) % mb_blocks; )==""\n"
R"==(const int sub_group_id = get_sub_group_id(); )==""\n"
R"==(const int ocl_local_id = get_local_id(0); )==""\n"
R"==(const int oc = (sub_group_id % OC_GROUP); )==""\n"
R"==(const int sp = (sub_group_id / OC_GROUP); )==""\n"
R"==(const int g = (group_oc + oc) / OC_NCHUNK; )==""\n"
R"==(const int group_ic = IC_NCHUNK * g; )==""\n"
R"==(const int god = group_sp / (OW_PADDED * OH); )==""\n"
R"==(const int gohw = group_sp % (OW_PADDED * OH); )==""\n"
R"==(const int goh = gohw / OW_PADDED; )==""\n"
R"==(const int gow = gohw % OW_PADDED; )==""\n"
R"==(const int gid = god * SD; )==""\n"
R"==(const int gih = goh * SH; )==""\n"
R"==(const int giw = gow * SW; )==""\n"
R"==(const int local_oh = sp / OW_PADDED; )==""\n"
R"==(const int local_ow = sp % OW_PADDED; )==""\n"
R"==(const int local_ih = local_oh * SH; )==""\n"
R"==(const int local_iw = local_ow * SW; )==""\n"
R"==(const int od = god; )==""\n"
R"==(const int ow = gow + local_ow; )==""\n"
R"==(const int oh = goh + local_oh; )==""\n"
R"==(const int id = gid - PD; )==""\n"
R"==(const int iw = giw + local_iw - PW; )==""\n"
R"==(const int ih = gih + local_ih - PH; )==""\n"
R"==(if (ow >= OW) return; )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * MB_BLOCK * (group_oc + oc); )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * OC_NCHUNK * G * MB_BLOCK * group_mb; )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK / mb_blocks * mb;  )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK * (OW * OH * od + OW * oh + ow); )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * MB_BLOCK * group_ic; )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * IC_NCHUNK * G * MB_BLOCK * group_mb; )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK / mb_blocks * mb; )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (IW * IH * id + IW * ih + iw); )==""\n"
R"==(wei += IC_BLOCK * KD * KH * KW * OC_BLOCK * (group_oc + oc) * IC_NCHUNK; )==""\n"
R"==(int8 C00 = 0, C01 = 0, C02 = 0, C03 = 0; )==""\n"
R"==(int8 C10 = 0, C11 = 0, C12 = 0, C13 = 0; )==""\n"
R"==(int8 C20 = 0, C21 = 0, C22 = 0, C23 = 0; )==""\n"
R"==(int8 C30 = 0, C31 = 0, C32 = 0, C33 = 0; )==""\n"
R"==(for (int ic_chunk = 0; ic_chunk < IC_NCHUNK; ic_chunk++) { )==""\n"
R"==(if (MB % MB_BLOCK != 0 )==""\n"
R"==(&& (group_mb * MB_BLOCK + mb * MB_BLOCK / mb_blocks) >= MB) { )==""\n"
R"==(break; )==""\n"
R"==(} )==""\n"
R"==(SRC_DATA_BLOCK_T S0, S1, S2, S3; )==""\n"
R"==(int8 W0, W1, W2, W3; )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(const int is_pad_d )==""\n"
R"==(= kd * (1 + DD) + id < 0 || kd * (1 + DD) + id >= ID; )==""\n"
R"==(#else )==""\n"
R"==(if (kd * (1 + DD) + id < 0 || kd * (1 + DD) + id >= ID) { )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * IH * IW * (1 + DD); )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KH * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(const int is_pad_h )==""\n"
R"==(= kh * (1 + DH) + ih < 0 || kh * (1 + DH) + ih >= IH; )==""\n"
R"==(#else )==""\n"
R"==(if (kh * (1 + DH) + ih < 0 || kh * (1 + DH) + ih >= IH) { )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * IW * (1 + DH); )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(const int is_pad_w = kw * (1 + DW) + iw < 0 )==""\n"
R"==(|| kw * (1 + DW) + iw >= IW; )==""\n"
R"==(if (is_pad_w || is_pad_h || is_pad_d) { )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(const int4 z = read_src_zero_points_32c( )==""\n"
R"==(src_zpoints, (group_ic + ic_chunk) * IC_BLOCK); )==""\n"
R"==(#else )==""\n"
R"==(const int z = read_src_zero_point(src_zpoints); )==""\n"
R"==(#endif  )==""\n"
R"==(BLOCK_READ_WHT(W0, 0); )==""\n"
R"==(BLOCK_READ_WHT(W1, 8 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_WHT(W2, 16 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_WHT(W3, 24 * IC_BLOCK); )==""\n"
R"==(int4 acc = 0; )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(acc.s0 += calc_src_compensation_x32(z, W0); )==""\n"
R"==(acc.s1 += calc_src_compensation_x32(z, W1); )==""\n"
R"==(acc.s2 += calc_src_compensation_x32(z, W2); )==""\n"
R"==(acc.s3 += calc_src_compensation_x32(z, W3); )==""\n"
R"==(#else )==""\n"
R"==(unroll_for(uint i = 0; i < 8; ++i) { )==""\n"
R"==(acc.s0 = idot4(0x01010101, W0[i], acc.s0); )==""\n"
R"==(acc.s1 = idot4(0x01010101, W1[i], acc.s1); )==""\n"
R"==(acc.s2 = idot4(0x01010101, W2[i], acc.s2); )==""\n"
R"==(acc.s3 = idot4(0x01010101, W3[i], acc.s3); )==""\n"
R"==(} )==""\n"
R"==(acc = z * acc; )==""\n"
R"==(#endif  )==""\n"
R"==(C00 += acc.s0; )==""\n"
R"==(C01 += acc.s1; )==""\n"
R"==(C02 += acc.s2; )==""\n"
R"==(C03 += acc.s3; )==""\n"
R"==(#if MB > 8 )==""\n"
R"==(C10 += acc.s0; )==""\n"
R"==(C11 += acc.s1; )==""\n"
R"==(C12 += acc.s2; )==""\n"
R"==(C13 += acc.s3; )==""\n"
R"==(#ifdef MB_FULL_BLOCK )==""\n"
R"==(C20 += acc.s0; )==""\n"
R"==(C21 += acc.s1; )==""\n"
R"==(C22 += acc.s2; )==""\n"
R"==(C23 += acc.s3; )==""\n"
R"==(C30 += acc.s0; )==""\n"
R"==(C31 += acc.s1; )==""\n"
R"==(C32 += acc.s2; )==""\n"
R"==(C33 += acc.s3; )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(} else )==""\n"
R"==(#else )==""\n"
R"==(if (kw * (1 + DW) + iw >= 0 && kw * (1 + DW) + iw < IW) )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(BLOCK_READ_SRC(S0, 0); )==""\n"
R"==(#if MB > 8 )==""\n"
R"==(BLOCK_READ_SRC(S1, 8 * IC_BLOCK); )==""\n"
R"==(#ifdef MB_FULL_BLOCK )==""\n"
R"==(BLOCK_READ_SRC(S2, 16 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_SRC(S3, 24 * IC_BLOCK); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(BLOCK_READ_WHT(W0, 0); )==""\n"
R"==(BLOCK_READ_WHT(W1, 8 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_WHT(W2, 16 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_WHT(W3, 24 * IC_BLOCK); )==""\n"
R"==(C00 = mmad8x8(S0, W0, C00); )==""\n"
R"==(C01 = mmad8x8(S0, W1, C01); )==""\n"
R"==(C02 = mmad8x8(S0, W2, C02); )==""\n"
R"==(C03 = mmad8x8(S0, W3, C03); )==""\n"
R"==(#if MB > 8 )==""\n"
R"==(C10 = mmad8x8(S1, W0, C10); )==""\n"
R"==(C11 = mmad8x8(S1, W1, C11); )==""\n"
R"==(C12 = mmad8x8(S1, W2, C12); )==""\n"
R"==(C13 = mmad8x8(S1, W3, C13); )==""\n"
R"==(#ifdef MB_FULL_BLOCK )==""\n"
R"==(C20 = mmad8x8(S2, W0, C20); )==""\n"
R"==(C21 = mmad8x8(S2, W1, C21); )==""\n"
R"==(C22 = mmad8x8(S2, W2, C22); )==""\n"
R"==(C23 = mmad8x8(S2, W3, C23); )==""\n"
R"==(C30 = mmad8x8(S3, W0, C30); )==""\n"
R"==(C31 = mmad8x8(S3, W1, C31); )==""\n"
R"==(C32 = mmad8x8(S3, W2, C32); )==""\n"
R"==(C33 = mmad8x8(S3, W3, C33); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (1 + DW); )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK; )==""\n"
R"==(}  )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (IW * (1 + DH) - KW * (1 + DW)); )==""\n"
R"==(}  )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (IH * (1 + DD) - KH * (1 + DH)) * IW; )==""\n"
R"==(}  )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (ID - KD * (1 + DD)) * IH * IW; )==""\n"
R"==(}  )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(int4 src_comp = as_int4(intel_sub_group_block_read4( )==""\n"
R"==((__global uint *)(&src_compensation[(group_oc + oc) * OC_BLOCK]))); )==""\n"
R"==(C00 -= src_comp.s0; )==""\n"
R"==(C01 -= src_comp.s1; )==""\n"
R"==(C02 -= src_comp.s2; )==""\n"
R"==(C03 -= src_comp.s3; )==""\n"
R"==(#if MB > 8 )==""\n"
R"==(C10 -= src_comp.s0; )==""\n"
R"==(C11 -= src_comp.s1; )==""\n"
R"==(C12 -= src_comp.s2; )==""\n"
R"==(C13 -= src_comp.s3; )==""\n"
R"==(#ifdef MB_FULL_BLOCK )==""\n"
R"==(C20 -= src_comp.s0; )==""\n"
R"==(C21 -= src_comp.s1; )==""\n"
R"==(C22 -= src_comp.s2; )==""\n"
R"==(C23 -= src_comp.s3; )==""\n"
R"==(C30 -= src_comp.s0; )==""\n"
R"==(C31 -= src_comp.s1; )==""\n"
R"==(C32 -= src_comp.s2; )==""\n"
R"==(C33 -= src_comp.s3; )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(float4 tmp; )==""\n"
R"==(DST_DATA4_T dst_pack[8]; )==""\n"
R"==(DST_DATA4_T D0[8]; )==""\n"
R"==(DST_DATA4_T D1[8]; )==""\n"
R"==(DST_DATA4_T D2[8]; )==""\n"
R"==(DST_DATA4_T D3[8]; )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(float4 scales; )==""\n"
R"==(BLOCK_READ_SCALES(scales, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float4 bia; )==""\n"
R"==(BLOCK_READ_BIA(bia, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp = SCALE * fma(tmp, (float4)1, bia); )==""\n"
R"==(#else )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp *= SCALE; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(*(DST_DATA16_T *)(D0 + 0) = BLOCK_READ_DST16(dst); )==""\n"
R"==(*(DST_DATA16_T *)(D0 + 4) = BLOCK_READ_DST16(dst + 4 * OC_BLOCK); )==""\n"
R"==(#if MB > 8 )==""\n"
R"==(*(DST_DATA16_T *)(D1 + 0) = BLOCK_READ_DST16(dst + 8 * OC_BLOCK); )==""\n"
R"==(*(DST_DATA16_T *)(D1 + 4) = BLOCK_READ_DST16(dst + 12 * OC_BLOCK); )==""\n"
R"==(#ifdef MB_FULL_BLOCK )==""\n"
R"==(*(DST_DATA16_T *)(D2 + 0) = BLOCK_READ_DST16(dst + 16 * OC_BLOCK); )==""\n"
R"==(*(DST_DATA16_T *)(D2 + 4) = BLOCK_READ_DST16(dst + 20 * OC_BLOCK); )==""\n"
R"==(*(DST_DATA16_T *)(D3 + 0) = BLOCK_READ_DST16(dst + 24 * OC_BLOCK); )==""\n"
R"==(*(DST_DATA16_T *)(D3 + 4) = BLOCK_READ_DST16(dst + 28 * OC_BLOCK); )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_DST_ZPOINTS )==""\n"
R"==(int4 dst_zp = read_dst_zero_points_32c( )==""\n"
R"==(dst_compensation, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#define ADD_DST_COMPENSATION() tmp += convert_float4(dst_zp); )==""\n"
R"==(#else )==""\n"
R"==(#define ADD_DST_COMPENSATION() )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(#define ZERO_PAD_DST() tmp = zero_pad_dst_32c(tmp, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#else )==""\n"
R"==(#define ZERO_PAD_DST() )==""\n"
R"==(#endif  )==""\n"
R"==(#define PACK(C0, C1, C2, C3, idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp[0] = C0[idx]; \ )==""\n"
R"==(tmp[1] = C1[idx]; \ )==""\n"
R"==(tmp[2] = C2[idx]; \ )==""\n"
R"==(tmp[3] = C3[idx]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define CONVERT_PACK(idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(dst_pack[idx] = CONVERT_DST_DATA4_T(tmp); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define STORE_DST(C0, C1, C2, C3, D, mb_stride) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int n_i = 0; n_i < 8; n_i++) { \ )==""\n"
R"==(PACK(C0, C1, C2, C3, n_i); \ )==""\n"
R"==(const int po_mb = (group_mb * MB_BLOCK + mb * MB_BLOCK / mb_blocks \ )==""\n"
R"==(+ mb_stride + n_i); \ )==""\n"
R"==(if (MB % MB_BLOCK == 0 || po_mb < MB) { \ )==""\n"
R"==(QUANTIZE_ADD_BIAS(); \ )==""\n"
R"==(const int po_oc = (group_oc + oc) * OC_BLOCK; \ )==""\n"
R"==(float4 dni \ )==""\n"
R"==(= convert_float4(SUM_TO_REF(AS_SUM_DATA4_T(D[n_i]))); \ )==""\n"
R"==(APPLY_POST_OPS_TRY_BURST(tmp, float, dni, float, po_mb, 1, \ )==""\n"
R"==(po_oc, 4 * SUB_GROUP_SIZE, ocl_local_id); \ )==""\n"
R"==(ADD_DST_COMPENSATION(); \ )==""\n"
R"==(ZERO_PAD_DST(); \ )==""\n"
R"==(} \ )==""\n"
R"==(CONVERT_PACK(n_i); \ )==""\n"
R"==(} \ )==""\n"
R"==(BLOCK_WRITE_DST16( \ )==""\n"
R"==(&dst[mb_stride * OC_BLOCK], *(DST_DATA16_T *)dst_pack); \ )==""\n"
R"==(BLOCK_WRITE_DST16(&dst[mb_stride * OC_BLOCK + 16 * 8], \ )==""\n"
R"==(*(DST_DATA16_T *)(dst_pack + 4)); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(STORE_DST(C00, C01, C02, C03, D0, 0); )==""\n"
R"==(STORE_DST(C10, C11, C12, C13, D1, 8); )==""\n"
R"==(#ifdef MB_FULL_BLOCK )==""\n"
R"==(STORE_DST(C20, C21, C22, C23, D2, 16); )==""\n"
R"==(STORE_DST(C30, C31, C32, C33, D3, 24); )==""\n"
R"==(#endif  )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}