namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_fwd_data_ow_block_x8s8x_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#include "gpu/ocl/ocl_zero_points.h" )==""\n"
R"==(#if IC % IC_BLOCK != 0 )==""\n"
R"==(#define IC_NBLOCKS_TAIL ((IC - (IC & ~(IC_BLOCK - 1)) + 3) / 4) )==""\n"
R"==(#else )==""\n"
R"==(#define IC_NBLOCKS_TAIL 8 )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 4 )==""\n"
R"==(#define BLOCK 4 )==""\n"
R"==(#define ACC_DATA_BLOCK int4 )==""\n"
R"==(#define SRC_DATA_BLOCK_T SRC_MMAD_DATA4_T )==""\n"
R"==(#define READ_BLOCK intel_sub_group_block_read4 )==""\n"
R"==(#define WRITE_LOCAL block_write4 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail, idot4, IC_NBLOCKS_TAIL, 4, SRC_DATA_BLOCK_T, int8, )==""\n"
R"==(ACC_DATA_BLOCK) )==""\n"
R"==(#define MMAD_FULL mmad8x4 )==""\n"
R"==(#define MMAD_TAIL mmad_tail )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK 8 )==""\n"
R"==(#define ACC_DATA_BLOCK int8 )==""\n"
R"==(#define SRC_DATA_BLOCK_T SRC_MMAD_DATA8_T )==""\n"
R"==(#define READ_BLOCK intel_sub_group_block_read8 )==""\n"
R"==(#define WRITE_LOCAL block_write8 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail, idot4, IC_NBLOCKS_TAIL, 8, SRC_DATA_BLOCK_T, int8, )==""\n"
R"==(ACC_DATA_BLOCK) )==""\n"
R"==(#define MMAD_FULL mmad8x8 )==""\n"
R"==(#define MMAD_TAIL mmad_tail )==""\n"
R"==(#endif )==""\n"
R"==(#define BLOCK_READ_SRC(data, idx) \ )==""\n"
R"==(data = intel_sub_group_block_read8((__global uint *)&src[idx]); )==""\n"
R"==(#define BLOCK_READ_WHT_1x32(data, idx) \ )==""\n"
R"==(data = as_int(intel_sub_group_block_read((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT_8x32(data, idx) \ )==""\n"
R"==(data = as_int8(intel_sub_group_block_read8((__global uint *)&wei[idx])); )==""\n"
R"==(#if OC % OC_BLOCK == 0 )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4((__global uint *)&bias[idx])); )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = (float4)0; \ )==""\n"
R"==(int i; \ )==""\n"
R"==(for (i = idx; i < idx + OC_BLOCK && i < OC - (OC % SUB_GROUP_SIZE); \ )==""\n"
R"==(i += SUB_GROUP_SIZE) { \ )==""\n"
R"==(data[(i - idx) / SUB_GROUP_SIZE] = as_float( \ )==""\n"
R"==(intel_sub_group_block_read((__global uint *)&bias[i])); \ )==""\n"
R"==(} \ )==""\n"
R"==(if ((get_sub_group_local_id() < OC % SUB_GROUP_SIZE) && i < OC \ )==""\n"
R"==(&& (i - idx) / SUB_GROUP_SIZE < 4) { \ )==""\n"
R"==(data[(i - idx) / SUB_GROUP_SIZE] \ )==""\n"
R"==(= as_float(bias[i + get_sub_group_local_id()]); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#define BLOCK_READ_SCALES(data, idx) \ )==""\n"
R"==(if (OC >= idx + (SUB_GROUP_SIZE * 4)) { \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4( \ )==""\n"
R"==((__global uint *)&runtime_scales[idx])); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(float local_dat[4] = {}; \ )==""\n"
R"==(for (int i = 0; i < 4; ++i) \ )==""\n"
R"==(if (idx + ((i + 1) * SUB_GROUP_SIZE) <= OC) { \ )==""\n"
R"==(local_dat[i] = as_float(intel_sub_group_block_read( \ )==""\n"
R"==((__global uint *)&runtime_scales[idx \ )==""\n"
R"==(+ (SUB_GROUP_SIZE * i)])); \ )==""\n"
R"==(} else if (idx + (i * SUB_GROUP_SIZE) + subg_local_id < OC) { \ )==""\n"
R"==(local_dat[i] = runtime_scales[idx + (SUB_GROUP_SIZE * i) \ )==""\n"
R"==(+ subg_local_id]; \ )==""\n"
R"==(} \ )==""\n"
R"==(data.s0 = local_dat[0]; \ )==""\n"
R"==(data.s1 = local_dat[1]; \ )==""\n"
R"==(data.s2 = local_dat[2]; \ )==""\n"
R"==(data.s3 = local_dat[3]; \ )==""\n"
R"==(} )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(#define SCALE scales )==""\n"
R"==(#elif SCALES_COMMON )==""\n"
R"==(#define SCALE runtime_scales[0] )==""\n"
R"==(#else )==""\n"
R"==(#define SCALE 1 )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) __kernel void )==""\n"
R"==(conv_fwd_ow_block_x8s8x(const __global SRC_DATA_T *src, )==""\n"
R"==(const __global char *wei, const __global float *bias, )==""\n"
R"==(__global DATA_T *dst POST_OP_ARGS, const __global float *runtime_scales, )==""\n"
R"==(const __global int *src_compensation, const __global int *src_zpoints, )==""\n"
R"==(const __global int *dst_compensation) { )==""\n"
R"==(const int group_oc = get_group_id(0) * OC_GROUP; )==""\n"
R"==(const int group_mb = get_group_id(2) * MB_GROUP; )==""\n"
R"==(const int group_sp = get_group_id(1) * SP_GROUP; )==""\n"
R"==(const int sub_group_id = get_sub_group_id(); )==""\n"
R"==(const int subg_local_id = get_sub_group_local_id(); )==""\n"
R"==(const int oc = (sub_group_id % OC_GROUP); )==""\n"
R"==(const int sp = (sub_group_id / OC_GROUP); )==""\n"
R"==(const int g = (group_oc + oc) / OC_NCHUNK; )==""\n"
R"==(const int group_ic = IC_NCHUNK * g; )==""\n"
R"==(const int god = group_sp / (OW_PADDED * OH); )==""\n"
R"==(const int gohw = group_sp % (OW_PADDED * OH); )==""\n"
R"==(const int goh = gohw / OW_PADDED; )==""\n"
R"==(const int gow = OW_BLOCK * (gohw % OW_PADDED); )==""\n"
R"==(const int gid = god * SD; )==""\n"
R"==(const int gih = goh * SH; )==""\n"
R"==(const int giw = gow * SW; )==""\n"
R"==(const int local_ow = OW_BLOCK * sp; )==""\n"
R"==(const int local_iw = local_ow * SW; )==""\n"
R"==(const int od = god; )==""\n"
R"==(const int ow = gow + local_ow; )==""\n"
R"==(const int oh = goh; )==""\n"
R"==(const int id = gid - PD; )==""\n"
R"==(const int iw = giw + local_iw - PW; )==""\n"
R"==(const int ih = gih - PH; )==""\n"
R"==(__local uint S_slice[SRC_SLM_SIZE]; )==""\n"
R"==(__local uint *S_part = S_slice + IC_BLOCK / 4 * (sp * SW * OW_BLOCK + PW); )==""\n"
R"==(__local uint *S_work = S_slice + IC_BLOCK / 4 * (sp * SW * OW_BLOCK); )==""\n"
R"==(const bool left_tail = iw < 0; )==""\n"
R"==(const bool left_nozero_tail = sub_group_id == 0 && iw > -PW; )==""\n"
R"==(const bool right_tail = (iw + PW + SLM_TAIL >= IW) && (iw + PW < IW); )==""\n"
R"==(const bool right_nozero_tail )==""\n"
R"==(= sp == (LWS_1 - 1) && (iw + PW + SLM_TAIL < IW); )==""\n"
R"==(const bool empty = (iw + PW >= IW); )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * MB_BLOCK * (group_oc + oc); )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * OC_NCHUNK * G * MB_BLOCK * group_mb; )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK * (OW * OH * od + OW * oh + ow); )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * MB_BLOCK * group_ic; )==""\n"
R"==(src += IC_BLOCK * ID * IH * IW * IC_NCHUNK * G * MB_BLOCK * group_mb; )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (IW * IH * id + IW * ih + iw + PW); )==""\n"
R"==(wei += IC_BLOCK * KD * KH * KW * OC_BLOCK * (group_oc + oc) * IC_NCHUNK; )==""\n"
R"==(/* Prepare S_slice tails */ )==""\n"
R"==(#if PW > 0 )==""\n"
R"==(if (left_tail) { )==""\n"
R"==(for (int i = 0; i < PW; i++) { )==""\n"
R"==(block_write(S_slice + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if ZERO_TAIL > 0 )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(for (int i = SLM_TAIL; i < SW * OW_BLOCK + (KW - 1) * (1 + DW) - PW; )==""\n"
R"==(i++) { )==""\n"
R"==(block_write(S_part + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(if (empty) { )==""\n"
R"==(for (int i = -PW; i < SW * OW_BLOCK + (KW - 1) * (1 + DW) - PW; i++) { )==""\n"
R"==(block_write(S_part + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(ACC_DATA_BLOCK C00 = 0, C01 = 0, C02 = 0, C03 = 0; )==""\n"
R"==(for (int ic_chunk = 0; ic_chunk < IC_NCHUNK; ic_chunk++) { )==""\n"
R"==(SRC_DATA_BLOCK_T S0; )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(if (kd * (1 + DD) + id < 0 || kd * (1 + DD) + id >= ID) { )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * IH * IW * (1 + DD); )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KH * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(if (kh * (1 + DH) + ih < 0 || kh * (1 + DH) + ih >= IH) { )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * IW * (1 + DH); )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(if (iw + PW < IW) { )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_NCHUNK > LWS_1 )==""\n"
R"==(/* Copy tails in case of multigroups */ )==""\n"
R"==(if (ow < OW) { )==""\n"
R"==(#if PW > 0 )==""\n"
R"==(if (left_nozero_tail) { )==""\n"
R"==(for (int i = -PW - min(iw, 0); i < 0; i++) { )==""\n"
R"==(block_write(S_part + i * 8, )==""\n"
R"==(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(&src[i )==""\n"
R"==(* IC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(if (right_nozero_tail) { )==""\n"
R"==(int buffer_last = (KW - 1) * (1 + DW) - PW; )==""\n"
R"==(int src_last = IW - iw - SW * OW_BLOCK - PW; )==""\n"
R"==(for (int i = SW * OW_BLOCK; i < SW * OW_BLOCK )==""\n"
R"==(+ min(buffer_last, src_last); )==""\n"
R"==(i++) { )==""\n"
R"==(block_write(S_part + i * 8, )==""\n"
R"==(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(&src[i )==""\n"
R"==(* IC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(for (int i = SW * OW_BLOCK )==""\n"
R"==(+ min(buffer_last, src_last); )==""\n"
R"==(i < SW * OW_BLOCK + buffer_last; i++) { )==""\n"
R"==(block_write(S_part + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_TAIL != OW_BLOCK * SW )==""\n"
R"==(/* Copy last block to SLM */ )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int i = 0; )==""\n"
R"==(i )==""\n"
R"==(< SLM_TAIL; )==""\n"
R"==(i++) { )==""\n"
R"==(block_write(S_part + i * 8, )==""\n"
R"==(intel_sub_group_block_read( )==""\n"
R"==((const __global uint *)(&src[i )==""\n"
R"==(* IC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(#endif )==""\n"
R"==(/* Copy block to SLM */ )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint)) for (int i = 0; )==""\n"
R"==(i < SW * OW_BLOCK; )==""\n"
R"==(i += OW_BLOCK) { )==""\n"
R"==(WRITE_LOCAL(S_part + i * 8, )==""\n"
R"==(READ_BLOCK( )==""\n"
R"==((const __global uint *)(&src[i )==""\n"
R"==(* IC_BLOCK]))); )==""\n"
R"==(} )==""\n"
R"==(#if SLM_TAIL != OW_BLOCK * SW )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_NCHUNK > LWS_1 )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { )==""\n"
R"==(unroll_for(int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(S0[i] = block_read( )==""\n"
R"==(S_work + (kw * (1 + DW) + SW * i) * 8); )==""\n"
R"==(} )==""\n"
R"==(int8 W0 = 0, W1 = 0, W2 = 0, W3 = 0; )==""\n"
R"==(#if IC % IC_BLOCK != 0 )==""\n"
R"==(if (ic_chunk == IC_NCHUNK - 1) { )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32(W0[i], (i + 0) * IC_BLOCK); )==""\n"
R"==(if (OC > 8) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W1[i], (i + 8) * IC_BLOCK); )==""\n"
R"==(if (OC > 16) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W2[i], (i + 16) * IC_BLOCK); )==""\n"
R"==(if (OC > 24) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W3[i], (i + 24) * IC_BLOCK); )==""\n"
R"==(C00 = MMAD_TAIL(S0, W0, C00); )==""\n"
R"==(if (OC > 8) C01 = MMAD_TAIL(S0, W1, C01); )==""\n"
R"==(if (OC > 16) C02 = MMAD_TAIL(S0, W2, C02); )==""\n"
R"==(if (OC > 24) C03 = MMAD_TAIL(S0, W3, C03); )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(BLOCK_READ_WHT_8x32(W0, 0); )==""\n"
R"==(if (OC > 8) BLOCK_READ_WHT_8x32(W1, 8 * IC_BLOCK); )==""\n"
R"==(if (OC > 16) BLOCK_READ_WHT_8x32(W2, 16 * IC_BLOCK); )==""\n"
R"==(if (OC > 24) BLOCK_READ_WHT_8x32(W3, 24 * IC_BLOCK); )==""\n"
R"==(C00 = MMAD_FULL(S0, W0, C00); )==""\n"
R"==(if (OC > 8) C01 = MMAD_FULL(S0, W1, C01); )==""\n"
R"==(if (OC > 16) C02 = MMAD_FULL(S0, W2, C02); )==""\n"
R"==(if (OC > 24) C03 = MMAD_FULL(S0, W3, C03); )==""\n"
R"==(} )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * IW * (1 + DH); )==""\n"
R"==(} )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (IH * (1 + DD) - KH * (1 + DH)) * IW; )==""\n"
R"==(} )==""\n"
R"==(src += IC_BLOCK * MB_BLOCK * (ID - KD * (1 + DD)) * IH * IW; )==""\n"
R"==(} )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(const int has_pad_d = id < 0 || id + KD * (1 + DD) >= ID; )==""\n"
R"==(const int has_pad_h = ih < 0 || ih + KH * (1 + DH) >= IH; )==""\n"
R"==(const int has_pad_w = iw < 0 || iw + KW * (1 + DW) + OW_BLOCK * SW >= IW; )==""\n"
R"==(if (has_pad_d || has_pad_h || has_pad_w) { )==""\n"
R"==(wei -= IC_NCHUNK * KD * KH * KW * IC_BLOCK * OC_BLOCK; )==""\n"
R"==(for (int ic_chunk = 0; ic_chunk < IC_NCHUNK; ic_chunk++) { )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(const int4 z = read_src_zero_points_32c( )==""\n"
R"==(src_zpoints, (group_ic + ic_chunk) * IC_BLOCK); )==""\n"
R"==(#else )==""\n"
R"==(const int z = read_src_zero_point(src_zpoints); )==""\n"
R"==(#endif  )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { )==""\n"
R"==(int8 w0, w1, w2, w3; )==""\n"
R"==(BLOCK_READ_WHT_8x32(w0, 0); )==""\n"
R"==(BLOCK_READ_WHT_8x32(w1, 8 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_WHT_8x32(w2, 16 * IC_BLOCK); )==""\n"
R"==(BLOCK_READ_WHT_8x32(w3, 24 * IC_BLOCK); )==""\n"
R"==(int4 acc = 0; )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(acc.s0 += calc_src_compensation_x32(z, w0); )==""\n"
R"==(acc.s1 += calc_src_compensation_x32(z, w1); )==""\n"
R"==(acc.s2 += calc_src_compensation_x32(z, w2); )==""\n"
R"==(acc.s3 += calc_src_compensation_x32(z, w3); )==""\n"
R"==(#else )==""\n"
R"==(unroll_for(uint j = 0; j < 8; ++j) { )==""\n"
R"==(acc.s0 = idot4(0x01010101, w0[j], acc.s0); )==""\n"
R"==(acc.s1 = idot4(0x01010101, w1[j], acc.s1); )==""\n"
R"==(acc.s2 = idot4(0x01010101, w2[j], acc.s2); )==""\n"
R"==(acc.s3 = idot4(0x01010101, w3[j], acc.s3); )==""\n"
R"==(} )==""\n"
R"==(acc = z * acc; )==""\n"
R"==(#endif  )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; ++i) { )==""\n"
R"==(const int id0 = kd * (1 + DD) + id; )==""\n"
R"==(const int ih0 = kh * (1 + DH) + ih; )==""\n"
R"==(const int iw0 = kw * (1 + DW) + iw + i * SW; )==""\n"
R"==(const int is_pad_d = id0 < 0 || id0 >= ID; )==""\n"
R"==(const int is_pad_h = ih0 < 0 || ih0 >= IH; )==""\n"
R"==(const int is_pad_w = iw0 < 0 || iw0 >= IW; )==""\n"
R"==(if (is_pad_d || is_pad_h || is_pad_w) { )==""\n"
R"==(C00[i] += acc.s0; )==""\n"
R"==(C01[i] += acc.s1; )==""\n"
R"==(C02[i] += acc.s2; )==""\n"
R"==(C03[i] += acc.s3; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK; )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(int4 src_comp = as_int4(intel_sub_group_block_read4( )==""\n"
R"==((__global uint *)(&src_compensation[(group_oc + oc) * OC_BLOCK]))); )==""\n"
R"==(C00 -= src_comp.s0; )==""\n"
R"==(C01 -= src_comp.s1; )==""\n"
R"==(C02 -= src_comp.s2; )==""\n"
R"==(C03 -= src_comp.s3; )==""\n"
R"==(#endif  )==""\n"
R"==(if (ow < OW) { )==""\n"
R"==(float4 tmp; )==""\n"
R"==(DST_DATA4_T dst_pack[BLOCK]; )==""\n"
R"==(DST_DATA4_T D0[BLOCK]; )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(float4 scales = 1; )==""\n"
R"==(BLOCK_READ_SCALES(scales, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float4 bia; )==""\n"
R"==(BLOCK_READ_BIA(bia, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp = SCALE * fma(tmp, (float4)1, bia); )==""\n"
R"==(#else )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp *= SCALE; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(#if OW_BLOCK == 4 )==""\n"
R"==(*(DST_DATA16_T *)D0 = BLOCK_READ_DST16(dst); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 8 )==""\n"
R"==(*(DST_DATA16_T *)(D0 + 0) = BLOCK_READ_DST16(dst); )==""\n"
R"==(*(DST_DATA16_T *)(D0 + 4) = BLOCK_READ_DST16(dst + 16 * 8); )==""\n"
R"==(#endif )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_DST_ZPOINTS )==""\n"
R"==(int4 dst_zp = read_dst_zero_points_32c( )==""\n"
R"==(dst_compensation, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#if !WITH_DST_ZPOINTS_PER_OC && OC % 32 != 0 )==""\n"
R"==(dst_zp = convert_int4(zero_pad_dst_32c( )==""\n"
R"==(convert_float4(dst_zp), (group_oc + oc) * OC_BLOCK)); )==""\n"
R"==(#endif )==""\n"
R"==(#define ADD_DST_COMPENSATION() tmp += convert_float4(dst_zp); )==""\n"
R"==(#else )==""\n"
R"==(#define ADD_DST_COMPENSATION() )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(#define ZERO_PAD_DST() tmp = zero_pad_dst_32c(tmp, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#else )==""\n"
R"==(#define ZERO_PAD_DST() )==""\n"
R"==(#endif  )==""\n"
R"==(#define PACK(C0, C1, C2, C3, idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp[0] = convert_float(C0[idx]); \ )==""\n"
R"==(tmp[1] = convert_float(C1[idx]); \ )==""\n"
R"==(tmp[2] = convert_float(C2[idx]); \ )==""\n"
R"==(tmp[3] = convert_float(C3[idx]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define CONVERT_PACK(idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(dst_pack[idx] = CONVERT_DST_DATA4_T(tmp); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define PACK_DST(C0, C1, C2, C3, D) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int n_i = 0; n_i < OW_BLOCK; ++n_i) { \ )==""\n"
R"==(PACK(C0, C1, C2, C3, n_i); \ )==""\n"
R"==(QUANTIZE_ADD_BIAS(); \ )==""\n"
R"==(const int po_mb = group_mb * MB_BLOCK; \ )==""\n"
R"==(const int po_oc \ )==""\n"
R"==(= (group_oc * OC_BLOCK + oc * OC_BLOCK) % (OC * G); \ )==""\n"
R"==(float4 dni = convert_float4(SUM_TO_REF(AS_SUM_DATA4_T(D[n_i]))); \ )==""\n"
R"==(APPLY_POST_OPS_TRY_BURST(tmp, float, dni, float, po_mb, 1, po_oc, \ )==""\n"
R"==(4 * SUB_GROUP_SIZE, subg_local_id); \ )==""\n"
R"==(ADD_DST_COMPENSATION(); \ )==""\n"
R"==(ZERO_PAD_DST(); \ )==""\n"
R"==(CONVERT_PACK(n_i); \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(PACK_DST(C00, C01, C02, C03, D0); )==""\n"
R"==(#if OW_TAIL )==""\n"
R"==(if (ow + OW_BLOCK > OW) { )==""\n"
R"==(__attribute__((opencl_unroll_hint(OW_TAIL))) for (int i = 0; )==""\n"
R"==(i < OW_TAIL; )==""\n"
R"==(i++) { )==""\n"
R"==(BLOCK_WRITE_DST4(&dst[i * 32], dst_pack[i]); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 4 )==""\n"
R"==(BLOCK_WRITE_DST16(dst, *(DST_DATA16_T *)dst_pack); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 8 )==""\n"
R"==(BLOCK_WRITE_DST16(dst, *(DST_DATA16_T *)dst_pack); )==""\n"
R"==(BLOCK_WRITE_DST16(dst + 16 * 8, *(DST_DATA16_T *)(dst_pack + 4)); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}