namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_nhwc_fwd_dw_mb_block_x8s8x_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define KDHW_SIZE KD *KH *KW )==""\n"
R"==(#define MB_BLOCK_PER_THREAD (MB_BLOCK / 4) )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(#define SCALE scales )==""\n"
R"==(#define SCALE_VEC8 scales.s01010101 )==""\n"
R"==(#elif SCALES_COMMON )==""\n"
R"==(#define SCALE runtime_scales[0] )==""\n"
R"==(#define SCALE_VEC8 runtime_scales[0] )==""\n"
R"==(#else )==""\n"
R"==(#define SCALE 1 )==""\n"
R"==(#define SCALE_VEC8 1 )==""\n"
R"==(#endif )==""\n"
R"==(void block_read_src( )==""\n"
R"==(uchar *s, __global uchar *src, const int g, const int cur_mb_blk) { )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(int mb_tail = (MB - cur_mb_blk) % MB_BLOCK_PER_THREAD; )==""\n"
R"==(int po_mb = (cur_mb_blk + mb_tail < MB) ? MB_BLOCK_PER_THREAD : mb_tail; )==""\n"
R"==(for (int i = 0; i < SUB_GROUP_SIZE; i++) { )==""\n"
R"==(if ((i % 2) * SUB_GROUP_SIZE + sglid )==""\n"
R"==(< (g + IC_BLOCK > G ? G % IC_BLOCK : IC_BLOCK) )==""\n"
R"==(&& (i / 2) < po_mb) )==""\n"
R"==(s[i] = src[(i / 2) * (ID * IH * IW * G) + (i % 2) * SUB_GROUP_SIZE )==""\n"
R"==(+ sglid]; )==""\n"
R"==(else )==""\n"
R"==(s[i] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(void block_write_dst(const DST_DATA_T *d, __global DST_DATA_T *dst, const int g, )==""\n"
R"==(const int cur_mb_blk) { )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(int mb_tail = (MB - cur_mb_blk) % MB_BLOCK_PER_THREAD; )==""\n"
R"==(int po_mb = (cur_mb_blk + mb_tail < MB) ? MB_BLOCK_PER_THREAD : mb_tail; )==""\n"
R"==(for (int i = 0; i < SUB_GROUP_SIZE; i++) { )==""\n"
R"==(if ((i % 2) * SUB_GROUP_SIZE + sglid )==""\n"
R"==(< (g + OC_BLOCK > G ? G % OC_BLOCK : OC_BLOCK) )==""\n"
R"==(&& (i / 2) < po_mb) )==""\n"
R"==(dst[(i / 2) * (OD * OH * OW * G) + (i % 2) * SUB_GROUP_SIZE + sglid] )==""\n"
R"==(= d[i]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(void block_read_dst_as_sum(SUM_DATA_T *d, __global DST_DATA_T *dst, const int g, )==""\n"
R"==(const int cur_mb_blk) { )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(int mb_tail = (MB - cur_mb_blk) % MB_BLOCK_PER_THREAD; )==""\n"
R"==(int po_mb = (cur_mb_blk + mb_tail < MB) ? MB_BLOCK_PER_THREAD : mb_tail; )==""\n"
R"==(for (int i = 0; i < SUB_GROUP_SIZE; i++) { )==""\n"
R"==(if ((i % 2) * SUB_GROUP_SIZE + sglid )==""\n"
R"==(< (g + IC_BLOCK > G ? G % IC_BLOCK : IC_BLOCK) )==""\n"
R"==(&& (i / 2) < po_mb) )==""\n"
R"==(d[i] = AS_SUM_DATA_T(dst[(i / 2) * (OD * OH * OW * G) )==""\n"
R"==(+ (i % 2) * SUB_GROUP_SIZE + sglid]); )==""\n"
R"==(else )==""\n"
R"==(d[i] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) __kernel void )==""\n"
R"==(conv_nhwc_fwd_dw_mb_block_x8s8x(const __global uchar *src, )==""\n"
R"==(const __global char *wei, const __global float *bias, )==""\n"
R"==(__global DST_DATA_T *dst POST_OP_ARGS, )==""\n"
R"==(const __global float *runtime_scales, )==""\n"
R"==(const __global int *src_compensation, const __global int *src_zpoints, )==""\n"
R"==(const __global int *dst_compensation) { )==""\n"
R"==(const int osp = get_global_id(1); )==""\n"
R"==(const int od = osp / (OW * OH); )==""\n"
R"==(const int ohw = osp % (OW * OH); )==""\n"
R"==(const int ow = (ohw % OW); )==""\n"
R"==(const int oh = ohw / OW; )==""\n"
R"==(const int g = get_group_id(0) * OC_BLOCK; )==""\n"
R"==(const int cur_mb_blk = (get_global_id(2) % 4) * MB_BLOCK_PER_THREAD; )==""\n"
R"==(const int id = od * SD - PD; )==""\n"
R"==(const int ih = oh * SH - PH; )==""\n"
R"==(const int iw = ow * SW - PW; )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(src += cur_mb_blk * ID * IH * IW * G + (id * IH * IW + ih * IW + iw) * G )==""\n"
R"==(+ g; )==""\n"
R"==(dst += cur_mb_blk * OD * OH * OW * G + (od * OH * OW + oh * OW + ow) * G )==""\n"
R"==(+ g; )==""\n"
R"==(wei += g * KDHW_SIZE; )==""\n"
R"==(int8 S00 = 0; )==""\n"
R"==(int8 S01 = 0; )==""\n"
R"==(uchar16 A00, A10, A20, A30; )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int sp = 0; )==""\n"
R"==(sp < KDHW_SIZE - KDHW_SIZE % 4; )==""\n"
R"==(sp += 4) { )==""\n"
R"==(const int4 s = {sp, sp + 1, sp + 2, sp + 3}; )==""\n"
R"==(const int4 kd = s / (KH * KW); )==""\n"
R"==(const int4 kh = (s % (KH * KW)) / KW; )==""\n"
R"==(const int4 kw = (s % (KH * KW)) % KW; )==""\n"
R"==(const int4 src_index )==""\n"
R"==(= (kd * (1 + DD) * IH * IW + kh * (1 + DH) * IW + kw * (1 + DW)) )==""\n"
R"==(* G; )==""\n"
R"==(const int4 index = id + kd * (1 + DD) < 0 || id + kd * (1 + DD) >= ID )==""\n"
R"==(|| ih + kh * (1 + DH) < 0 || ih + kh * (1 + DH) >= IH )==""\n"
R"==(|| iw + kw * (1 + DW) < 0 || iw + kw * (1 + DW) >= IW; )==""\n"
R"==(if (index.s0) { )==""\n"
R"==(A00 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(block_read_src((uchar *)&A00, src + src_index.s0, g, cur_mb_blk); )==""\n"
R"==(} )==""\n"
R"==(if (index.s1) { )==""\n"
R"==(A10 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(block_read_src((uchar *)&A10, src + src_index.s1, g, cur_mb_blk); )==""\n"
R"==(} )==""\n"
R"==(if (index.s2) { )==""\n"
R"==(A20 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(block_read_src((uchar *)&A20, src + src_index.s2, g, cur_mb_blk); )==""\n"
R"==(} )==""\n"
R"==(if (index.s3) { )==""\n"
R"==(A30 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(block_read_src((uchar *)&A30, src + src_index.s3, g, cur_mb_blk); )==""\n"
R"==(} )==""\n"
R"==(char8 W = as_char8( )==""\n"
R"==(intel_sub_group_block_read_uc8((const __global uchar *)(wei))); )==""\n"
R"==(char4 W1 = W.s0246; )==""\n"
R"==(char4 W2 = W.s1357; )==""\n"
R"==(S00.s0 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s0, A10.s0, A20.s0, A30.s0), W1, S00.s0); )==""\n"
R"==(S00.s1 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s1, A10.s1, A20.s1, A30.s1), W2, S00.s1); )==""\n"
R"==(S00.s2 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s2, A10.s2, A20.s2, A30.s2), W1, S00.s2); )==""\n"
R"==(S00.s3 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s3, A10.s3, A20.s3, A30.s3), W2, S00.s3); )==""\n"
R"==(S00.s4 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s4, A10.s4, A20.s4, A30.s4), W1, S00.s4); )==""\n"
R"==(S00.s5 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s5, A10.s5, A20.s5, A30.s5), W2, S00.s5); )==""\n"
R"==(S00.s6 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s6, A10.s6, A20.s6, A30.s6), W1, S00.s6); )==""\n"
R"==(S00.s7 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s7, A10.s7, A20.s7, A30.s7), W2, S00.s7); )==""\n"
R"==(S01.s0 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s8, A10.s8, A20.s8, A30.s8), W1, S01.s0); )==""\n"
R"==(S01.s1 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.s9, A10.s9, A20.s9, A30.s9), W2, S01.s1); )==""\n"
R"==(S01.s2 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.sa, A10.sa, A20.sa, A30.sa), W1, S01.s2); )==""\n"
R"==(S01.s3 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.sb, A10.sb, A20.sb, A30.sb), W2, S01.s3); )==""\n"
R"==(S01.s4 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.sc, A10.sc, A20.sc, A30.sc), W1, S01.s4); )==""\n"
R"==(S01.s5 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.sd, A10.sd, A20.sd, A30.sd), W2, S01.s5); )==""\n"
R"==(S01.s6 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.se, A10.se, A20.se, A30.se), W1, S01.s6); )==""\n"
R"==(S01.s7 = idot4( )==""\n"
R"==((SRC_DATA4_T)(A00.sf, A10.sf, A20.sf, A30.sf), W2, S01.s7); )==""\n"
R"==(wei += 4 * OC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int sp = KDHW_SIZE - KDHW_SIZE % 4; )==""\n"
R"==(sp < KDHW_SIZE; sp++) { )==""\n"
R"==(const int kd = sp / (KH * KW); )==""\n"
R"==(const int kh = (sp % (KH * KW)) / KW; )==""\n"
R"==(const int kw = (sp % (KH * KW)) % KW; )==""\n"
R"==(const int src_index )==""\n"
R"==(= (kd * (1 + DD) * IH * IW + kh * (1 + DH) * IW + kw * (1 + DW)) )==""\n"
R"==(* G; )==""\n"
R"==(const int index = id + kd * (1 + DD) < 0 || id + kd * (1 + DD) >= ID )==""\n"
R"==(|| ih + kh * (1 + DH) < 0 || ih + kh * (1 + DH) >= IH )==""\n"
R"==(|| iw + kw * (1 + DW) < 0 || iw + kw * (1 + DW) >= IW; )==""\n"
R"==(if (index) { )==""\n"
R"==(A00 = 0; )==""\n"
R"==(} else { )==""\n"
R"==(block_read_src((uchar *)&A00, src + src_index, g, cur_mb_blk); )==""\n"
R"==(} )==""\n"
R"==(const char2 W = as_char2( )==""\n"
R"==(intel_sub_group_block_read_uc2((const __global uchar *)(wei))); )==""\n"
R"==(const char W1 = W.s0; )==""\n"
R"==(const char W2 = W.s1; )==""\n"
R"==(S00.s0 += ((SRC_DATA_T)A00.s0) * W1; )==""\n"
R"==(S00.s1 += ((SRC_DATA_T)A00.s1) * W2; )==""\n"
R"==(S00.s2 += ((SRC_DATA_T)A00.s2) * W1; )==""\n"
R"==(S00.s3 += ((SRC_DATA_T)A00.s3) * W2; )==""\n"
R"==(S00.s4 += ((SRC_DATA_T)A00.s4) * W1; )==""\n"
R"==(S00.s5 += ((SRC_DATA_T)A00.s5) * W2; )==""\n"
R"==(S00.s6 += ((SRC_DATA_T)A00.s6) * W1; )==""\n"
R"==(S00.s7 += ((SRC_DATA_T)A00.s7) * W2; )==""\n"
R"==(S01.s0 += ((SRC_DATA_T)A00.s8) * W1; )==""\n"
R"==(S01.s1 += ((SRC_DATA_T)A00.s9) * W2; )==""\n"
R"==(S01.s2 += ((SRC_DATA_T)A00.sa) * W1; )==""\n"
R"==(S01.s3 += ((SRC_DATA_T)A00.sb) * W2; )==""\n"
R"==(S01.s4 += ((SRC_DATA_T)A00.sc) * W1; )==""\n"
R"==(S01.s5 += ((SRC_DATA_T)A00.sd) * W2; )==""\n"
R"==(S01.s6 += ((SRC_DATA_T)A00.se) * W1; )==""\n"
R"==(S01.s7 += ((SRC_DATA_T)A00.sf) * W2; )==""\n"
R"==(wei += OC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(float8 tmp00 = convert_float8(S00); )==""\n"
R"==(float8 tmp01 = convert_float8(S01); )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(float2 scales = as_float2(intel_sub_group_block_read2( )==""\n"
R"==((const __global uint *)&runtime_scales[g])); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float2 B = as_float2( )==""\n"
R"==(intel_sub_group_block_read2((const __global uint *)&bias[g])); )==""\n"
R"==(tmp00 = SCALE_VEC8 * fma(tmp00, (float8)1, B.s01010101); )==""\n"
R"==(tmp01 = SCALE_VEC8 * fma(tmp01, (float8)1, B.s01010101); )==""\n"
R"==(#else )==""\n"
R"==(tmp00 *= SCALE_VEC8; )==""\n"
R"==(tmp01 *= SCALE_VEC8; )==""\n"
R"==(#endif )==""\n"
R"==(SUM_DATA16_T D00; )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(block_read_dst_as_sum(&D00, dst, g, cur_mb_blk); )==""\n"
R"==(#endif )==""\n"
R"==(float16 tmp_x16 = (float16)(tmp00, tmp01); )==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D( )==""\n"
R"==(tmp_x16, float, D00, SUM_DATA_T, 0, 1, 0, 1); )==""\n"
R"==(DST_DATA16_T R0 = CONVERT_DST_DATA16_T(tmp_x16); )==""\n"
R"==(block_write_dst((DST_DATA16_T *)&R0, dst, g, cur_mb_blk); )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}