namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_nhwc_fwd_dw_ow_block_x8s8x_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define PWX (PW > 1 ? PW : 1) )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(#define SCALE scales.s0101010101010101 )==""\n"
R"==(#elif SCALES_COMMON )==""\n"
R"==(#define SCALE runtime_scales[0] )==""\n"
R"==(#else )==""\n"
R"==(#define SCALE 1 )==""\n"
R"==(#endif )==""\n"
R"==(void block_read_dst( )==""\n"
R"==(int n, DST_DATA_T *d, const __global DST_DATA_T *dst, const int g); )==""\n"
R"==(void block_write_dst( )==""\n"
R"==(int n, const DST_DATA_T *d, __global DST_DATA_T *dst, const int g); )==""\n"
R"==(void block_read_src(int n, ushort *s, const __global ushort *src, const int g); )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) __kernel void )==""\n"
R"==(conv_nhwc_fwd_dw_ow_block_x8s8x(const __global uchar *src, )==""\n"
R"==(const __global char *wei, const __global float *bias, )==""\n"
R"==(__global DST_DATA_T *dst POST_OP_ARGS, )==""\n"
R"==(const __global float *runtime_scales, )==""\n"
R"==(const __global int *src_compensation, const __global int *src_zpoints, )==""\n"
R"==(const __global int *dst_compensation) { )==""\n"
R"==(const int osp = get_global_id(1); )==""\n"
R"==(const int od = osp / (OWB * OH); )==""\n"
R"==(const int ohw = osp % (OWB * OH); )==""\n"
R"==(const int ow = (ohw % OWB) * OW_BLOCK; )==""\n"
R"==(const int oh = ohw / OWB; )==""\n"
R"==(const int g = get_group_id(0) * OC_BLOCK; )==""\n"
R"==(const int mb = get_global_id(2) * MB_BLOCK; )==""\n"
R"==(const int id = od * SD - PD; )==""\n"
R"==(const int ih = oh * SH - PH; )==""\n"
R"==(const int iw = ow * SW - PW; )==""\n"
R"==(const int sglid = get_sub_group_local_id(); )==""\n"
R"==(int dst_off, src_off; )==""\n"
R"==(dst_off = mb * OD * OH * OW * G + (od * OH * OW + oh * OW + ow) * G + g; )==""\n"
R"==(src_off = mb * ID * IH * IW * G + (id * IH * IW + ih * IW + iw) * G + g; )==""\n"
R"==(dst += dst_off; )==""\n"
R"==(src += src_off; )==""\n"
R"==(wei += g * KD * KH * KW; )==""\n"
R"==(int16 S0 = 0; )==""\n"
R"==(int16 S1 = 0; )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(float2 scales; )==""\n"
R"==(scales.s0 = runtime_scales[g + 2 * sglid]; )==""\n"
R"==(scales.s1 = runtime_scales[g + 2 * sglid + 1]; )==""\n"
R"==(#endif )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(if (kd * (1 + DD) + id < 0 || kd * (1 + DD) + id >= ID) { )==""\n"
R"==(src += G * IH * IW * (1 + DD); )==""\n"
R"==(wei += OC_BLOCK * KH * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(__attribute__((opencl_unroll_hint)) for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(if (kh * (1 + DH) + ih < 0 || kh * (1 + DH) + ih >= IH) { )==""\n"
R"==(src += G * MB_BLOCK * IW * (1 + DH); )==""\n"
R"==(wei += OC_BLOCK * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#if SW == 2 )==""\n"
R"==(ushort16 AAA = 0; )==""\n"
R"==(#else )==""\n"
R"==(ushort AAA; )==""\n"
R"==(#endif )==""\n"
R"==(ushort16 AA = 0; )==""\n"
R"==(#if OW % (SW * OW_BLOCK) + KW - 1 \ )==""\n"
R"==(>= SW - 1 + PW  )==""\n"
R"==(/* get main block */ )==""\n"
R"==(if (iw + SW * (OW_BLOCK) + KW - 1 > IW) { )==""\n"
R"==(if (iw >= 0) { )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 0, )==""\n"
R"==((const __global ushort *)(&src[0 * G]), g); )==""\n"
R"==(#if PW >= 2 )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 1, )==""\n"
R"==((const __global ushort *)(&src[1 * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if PW >= 3 )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 2, )==""\n"
R"==((const __global ushort *)(&src[2 * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if IW_TAIL > 16 )==""\n"
R"==(#if PW == 2 )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + 2, )==""\n"
R"==((const __global ushort *)(&src[(PWX)*G]), g); )==""\n"
R"==(block_read_src(4, ((ushort *)&AA) + 10, )==""\n"
R"==((const __global ushort *)(&src[(PWX + 8) * G]), g); )==""\n"
R"==(block_read_src(2, ((ushort *)&AA) + 14, )==""\n"
R"==((const __global ushort *)(&src[(PWX + 12) * G]), g); )==""\n"
R"==(#elif PW == 3 )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + 3, )==""\n"
R"==((const __global ushort *)(&src[(PWX)*G]), g); )==""\n"
R"==(block_read_src(4, ((ushort *)&AA) + 11, )==""\n"
R"==((const __global ushort *)(&src[(PWX + 8) * G]), g); )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 15, )==""\n"
R"==((const __global ushort *)(&src[(PWX + 12) * G]), g); )==""\n"
R"==(#else )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + 1, )==""\n"
R"==((const __global ushort *)(&src[(PWX)*G]), g); )==""\n"
R"==(block_read_src(4, ((ushort *)&AA) + 9, )==""\n"
R"==((const __global ushort *)(&src[(PWX + 8) * G]), g); )==""\n"
R"==(block_read_src(2, ((ushort *)&AA) + 13, )==""\n"
R"==((const __global ushort *)(&src[(PWX + 12) * G]), g); )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 15, )==""\n"
R"==((const __global ushort *)(&src[(PWX + 14) * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((IW_TAIL - 16) & 0b1000) == 0b1000 )==""\n"
R"==(block_read_src(8, ((ushort *)&AAA), )==""\n"
R"==((const __global ushort *)(&src[(16) * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((IW_TAIL - 16) & 0b100) == 0b100 )==""\n"
R"==(block_read_src(4, ((ushort *)&AAA) + ((IW_TAIL - 16) & 0b1000), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(16 + ((IW_TAIL - 16) & 0b1000)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((IW_TAIL - 16) & 0b10) == 0b10 )==""\n"
R"==(block_read_src(2, ((ushort *)&AAA) + ((IW_TAIL - 16) & 0b1100), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(16 + ((IW_TAIL - 16) & 0b1100)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((IW_TAIL - 16) & 0b1) == 0b1 )==""\n"
R"==(block_read_src(1, ((ushort *)&AAA) + ((IW_TAIL - 16) & 0b1110), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(16 + ((IW_TAIL - 16) & 0b1110)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(#if ((IW_TAIL - PWX) & 0b1000) == 0b1000 )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + PWX, )==""\n"
R"==((const __global ushort *)(&src[(PWX)*G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((IW_TAIL - PWX) & 0b100) == 0b100 )==""\n"
R"==(block_read_src(4, )==""\n"
R"==(((ushort *)&AA) + PWX + ((IW_TAIL - PWX) & 0b1000), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX )==""\n"
R"==(+ ((IW_TAIL - PWX) )==""\n"
R"==(& 0b1000)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((IW_TAIL - PWX) & 0b10) == 0b10 )==""\n"
R"==(block_read_src(2, )==""\n"
R"==(((ushort *)&AA) + PWX + ((IW_TAIL - PWX) & 0b1100), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX )==""\n"
R"==(+ ((IW_TAIL - PWX) )==""\n"
R"==(& 0b1100)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((IW_TAIL - PWX) & 0b1) == 0b1 )==""\n"
R"==(block_read_src(1, )==""\n"
R"==(((ushort *)&AA) + PWX + ((IW_TAIL - PWX) & 0b1110), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX )==""\n"
R"==(+ ((IW_TAIL - PWX) )==""\n"
R"==(& 0b1110)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} else { )==""\n"
R"==(#endif )==""\n"
R"==(#if SW == 1 )==""\n"
R"==(#define READ_BLOCK (OW_BLOCK + KW - 1 - PWX) )==""\n"
R"==(if (iw >= 0) { )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 0, )==""\n"
R"==((const __global ushort *)(&src[0 * G]), g); )==""\n"
R"==(#if PW >= 2 )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 1, )==""\n"
R"==((const __global ushort *)(&src[1 * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if PW >= 3 )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 2, )==""\n"
R"==((const __global ushort *)(&src[2 * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if (READ_BLOCK & 0b1000) == 0b1000 )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + PWX, )==""\n"
R"==((const __global ushort *)(&src[(PWX)*G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if (READ_BLOCK & 0b100) == 0b100 )==""\n"
R"==(block_read_src(4, ((ushort *)&AA) + PWX + (READ_BLOCK & 0b1000), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX + (READ_BLOCK & 0b1000)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if (READ_BLOCK & 0b10) == 0b10 )==""\n"
R"==(block_read_src(2, ((ushort *)&AA) + PWX + (READ_BLOCK & 0b1100), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX + (READ_BLOCK & 0b1100)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if (READ_BLOCK & 0b1) == 0b1 )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + PWX + (READ_BLOCK & 0b1110), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX + (READ_BLOCK & 0b1110)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#elif SW == 2 )==""\n"
R"==(#if OW_BLOCK + KW - 1 >= 8 )==""\n"
R"==(#define READ_BLOCK (2 * (OW_BLOCK) + KW - 1) )==""\n"
R"==(if (iw >= 0) { )==""\n"
R"==(block_read_src(16, (ushort *)&AA, )==""\n"
R"==((const __global ushort *)(&src[0 * G]), g); )==""\n"
R"==(} else { )==""\n"
R"==(#if PW == 0 )==""\n"
R"==(block_read_src(16, (ushort *)&AA, )==""\n"
R"==((const __global ushort *)(&src[0 * G]), g); )==""\n"
R"==(#elif PW == 2 )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + 2, )==""\n"
R"==((const __global ushort *)(&src[(PW)*G]), g); )==""\n"
R"==(block_read_src(4, ((ushort *)&AA) + 10, )==""\n"
R"==((const __global ushort *)(&src[(PW + 8) * G]), g); )==""\n"
R"==(block_read_src(2, ((ushort *)&AA) + 14, )==""\n"
R"==((const __global ushort *)(&src[(PW + 12) * G]), g); )==""\n"
R"==(#elif PW == 3 )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + 3, )==""\n"
R"==((const __global ushort *)(&src[(PW)*G]), g); )==""\n"
R"==(block_read_src(4, ((ushort *)&AA) + 11, )==""\n"
R"==((const __global ushort *)(&src[(PW + 8) * G]), g); )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 15, )==""\n"
R"==((const __global ushort *)(&src[(PW + 12) * G]), g); )==""\n"
R"==(#else )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + 1, )==""\n"
R"==((const __global ushort *)(&src[(PW)*G]), g); )==""\n"
R"==(block_read_src(4, ((ushort *)&AA) + 9, )==""\n"
R"==((const __global ushort *)(&src[(PW + 8) * G]), g); )==""\n"
R"==(block_read_src(2, ((ushort *)&AA) + 13, )==""\n"
R"==((const __global ushort *)(&src[(PW + 12) * G]), g); )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 15, )==""\n"
R"==((const __global ushort *)(&src[(PW + 14) * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if ((READ_BLOCK - 16) & 0b1000) == 0b1000 )==""\n"
R"==(block_read_src(8, ((ushort *)&AAA), )==""\n"
R"==((const __global ushort *)(&src[(16) * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((READ_BLOCK - 16) & 0b100) == 0b100 )==""\n"
R"==(block_read_src(4, ((ushort *)&AAA) + ((READ_BLOCK - 16) & 0b1000), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(16 + ((READ_BLOCK - 16) & 0b1000)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((READ_BLOCK - 16) & 0b10) == 0b10 )==""\n"
R"==(block_read_src(2, ((ushort *)&AAA) + ((READ_BLOCK - 16) & 0b1100), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(16 + ((READ_BLOCK - 16) & 0b1100)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if ((READ_BLOCK - 16) & 0b1) == 0b1 )==""\n"
R"==(block_read_src(1, ((ushort *)&AAA) + ((READ_BLOCK - 16) & 0b1110), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(16 + ((READ_BLOCK - 16) & 0b1110)) )==""\n"
R"==(* G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#else  )==""\n"
R"==(#define READ_BLOCK (2 * (OW_BLOCK) + KW - 1 - PWX) )==""\n"
R"==(if (iw >= 0) { )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 0, )==""\n"
R"==((const __global ushort *)(&src[0 * G]), g); )==""\n"
R"==(#if PW >= 2 )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 1, )==""\n"
R"==((const __global ushort *)(&src[1 * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if PW >= 3 )==""\n"
R"==(block_read_src(1, ((ushort *)&AA) + 2, )==""\n"
R"==((const __global ushort *)(&src[2 * G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#if (READ_BLOCK & 0b1000) == 0b1000 )==""\n"
R"==(block_read_src(8, ((ushort *)&AA) + PWX, )==""\n"
R"==((const __global ushort *)(&src[(PWX)*G]), g); )==""\n"
R"==(#endif )==""\n"
R"==(#if (READ_BLOCK & 0b100) == 0b100 )==""\n"
R"==(block_read_src(4, ((ushort *)&AA) + PWX + (READ_BLOCK & 0b1000), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX + (READ_BLOCK & 0b1000)) * G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if (READ_BLOCK & 0b10) == 0b10 )==""\n"
R"==(block_read_src(2, ((ushort *)&AA) + PWX + (READ_BLOCK & 0b1100), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX + (READ_BLOCK & 0b1100)) * G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#if (READ_BLOCK & 0b1) == 0b1 )==""\n"
R"==(block_read_src(2, ((ushort *)&AA) + PWX + (READ_BLOCK & 0b1110), )==""\n"
R"==((const __global ushort )==""\n"
R"==(*)(&src[(PWX + (READ_BLOCK & 0b1110)) * G]), )==""\n"
R"==(g); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if OW % (SW * OW_BLOCK) + KW - 1 >= SW - 1 + PW )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OW > OWX )==""\n"
R"==(if (iw + READ_BLOCK > IW) { )==""\n"
R"==(if (iw < IW) { )==""\n"
R"==(for (int i = IW - iw; i < READ_BLOCK; i++) { )==""\n"
R"==(if (i < 16) { )==""\n"
R"==(((ushort *)&AA)[i] = 0; )==""\n"
R"==(} )==""\n"
R"==(#if SW == 2 )==""\n"
R"==(else { )==""\n"
R"==(((ushort *)&AAA)[i - 16] = 0; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(AA = 0; )==""\n"
R"==(#if SW == 2 )==""\n"
R"==(AAA = 0; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(ushort4 WW = 0; )==""\n"
R"==(#if KW > 4 )==""\n"
R"==(#error "Wrong KW" )==""\n"
R"==(#endif )==""\n"
R"==(#if KW == 4 )==""\n"
R"==(WW = intel_sub_group_block_read_us4((const __global ushort *)wei); )==""\n"
R"==(#endif )==""\n"
R"==(#if KW == 3 )==""\n"
R"==(WW.s01 = intel_sub_group_block_read_us2( )==""\n"
R"==((const __global ushort *)wei); )==""\n"
R"==(WW.s2 = intel_sub_group_block_read_us( )==""\n"
R"==((const __global ushort *)wei + OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if KW == 2 )==""\n"
R"==(WW.s01 = intel_sub_group_block_read_us2( )==""\n"
R"==((const __global ushort *)wei); )==""\n"
R"==(#endif )==""\n"
R"==(#if KW == 1 )==""\n"
R"==(WW.s0 = intel_sub_group_block_read_us((const __global ushort *)wei); )==""\n"
R"==(#endif )==""\n"
R"==(SRC_DATA16_T A0 = 0, A1 = 0; )==""\n"
R"==(A0.s01234567 = AS_SRC_DATA16_T(AA.s01234567).s02468ace; )==""\n"
R"==(A0.s89abcdef = AS_SRC_DATA16_T(AA.s89abcdef).s02468ace; )==""\n"
R"==(A1.s01234567 = AS_SRC_DATA16_T(AA.s01234567).s13579bdf; )==""\n"
R"==(A1.s89abcdef = AS_SRC_DATA16_T(AA.s89abcdef).s13579bdf; )==""\n"
R"==(#if SW == 2 )==""\n"
R"==(SRC_DATA16_T right0, right1; )==""\n"
R"==(right0.s01234567 = AS_SRC_DATA16_T(AAA.s01234567).s02468ace; )==""\n"
R"==(right0.s89abcdef = AS_SRC_DATA16_T(AAA.s89abcdef).s02468ace; )==""\n"
R"==(right1.s01234567 = AS_SRC_DATA16_T(AAA.s01234567).s13579bdf; )==""\n"
R"==(right1.s89abcdef = AS_SRC_DATA16_T(AAA.s89abcdef).s13579bdf; )==""\n"
R"==(#else )==""\n"
R"==(#if OW_BLOCK >= 14 )==""\n"
R"==(SRC_DATA_T right0, right1; )==""\n"
R"==(right0 = AS_SRC_DATA2_T(AAA).s0; )==""\n"
R"==(right1 = AS_SRC_DATA2_T(AAA).s1; )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(char8 W = as_char8(WW); )==""\n"
R"==(#if SW == 1 )==""\n"
R"==(S0.s0 = idot4(A0.s0123, W.s0246, S0.s0); )==""\n"
R"==(#if OW_BLOCK >= 2 )==""\n"
R"==(S0.s2 = idot4(A0.s1234, W.s0246, S0.s2); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 3 )==""\n"
R"==(S0.s4 = idot4(A0.s2345, W.s0246, S0.s4); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 4 )==""\n"
R"==(S0.s6 = idot4(A0.s3456, W.s0246, S0.s6); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 5 )==""\n"
R"==(S0.s8 = idot4(A0.s4567, W.s0246, S0.s8); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_BLOCK >= 6 )==""\n"
R"==(S0.sa = idot4(A0.s5678, W.s0246, S0.sa); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 7 )==""\n"
R"==(S0.sc = idot4(A0.s6789, W.s0246, S0.sc); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 8 )==""\n"
R"==(S0.se = idot4(A0.s789a, W.s0246, S0.se); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 9 )==""\n"
R"==(S1.s0 = idot4(A0.s89ab, W.s0246, S1.s0); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 10 )==""\n"
R"==(S1.s2 = idot4(A0.s9abc, W.s0246, S1.s2); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 11 )==""\n"
R"==(S1.s4 = idot4(A0.sabcd, W.s0246, S1.s4); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 12 )==""\n"
R"==(S1.s6 = idot4(A0.sbcde, W.s0246, S1.s6); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 13 )==""\n"
R"==(S1.s8 = idot4(A0.scdef, W.s0246, S1.s8); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 14 )==""\n"
R"==(S1.sa = idot4((SRC_DATA4_T)(A0.sde, A0.sf, right0), W.s0246, S1.sa); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 15 )==""\n"
R"==(S1.sc = idot4( )==""\n"
R"==((SRC_DATA4_T)(A0.sef, right0, right1), W.s0246, S1.sc); )==""\n"
R"==(#endif )==""\n"
R"==(S0.s1 = idot4(A1.s0123, W.s1357, S0.s1); )==""\n"
R"==(#if OW_BLOCK >= 2 )==""\n"
R"==(S0.s3 = idot4(A1.s1234, W.s1357, S0.s3); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 3 )==""\n"
R"==(S0.s5 = idot4(A1.s2345, W.s1357, S0.s5); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 4 )==""\n"
R"==(S0.s7 = idot4(A1.s3456, W.s1357, S0.s7); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 5 )==""\n"
R"==(S0.s9 = idot4(A1.s4567, W.s1357, S0.s9); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 6 )==""\n"
R"==(S0.sb = idot4(A1.s5678, W.s1357, S0.sb); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 7 )==""\n"
R"==(S0.sd = idot4(A1.s6789, W.s1357, S0.sd); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 8 )==""\n"
R"==(S0.sf = idot4(A1.s789a, W.s1357, S0.sf); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 9 )==""\n"
R"==(S1.s1 = idot4(A1.s89ab, W.s1357, S1.s1); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 10 )==""\n"
R"==(S1.s3 = idot4(A1.s9abc, W.s1357, S1.s3); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 11 )==""\n"
R"==(S1.s5 = idot4(A1.sabcd, W.s1357, S1.s5); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 12 )==""\n"
R"==(S1.s7 = idot4(A1.sbcde, W.s1357, S1.s7); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 13 )==""\n"
R"==(S1.s9 = idot4(A1.scdef, W.s1357, S1.s9); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 14 )==""\n"
R"==(S1.sb = idot4((SRC_DATA4_T)(A1.sde, A1.sf, 0), W.s1357, S1.sb); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 15 )==""\n"
R"==(S1.sd = idot4((SRC_DATA4_T)(A1.sef, right1, 0), W.s1357, S1.sd); )==""\n"
R"==(#endif )==""\n"
R"==(#elif SW == 2 )==""\n"
R"==(S0.s0 = idot4(A0.s0123, W.s0246, S0.s0); )==""\n"
R"==(#if OW_BLOCK >= 2 )==""\n"
R"==(S0.s2 = idot4(A0.s2345, W.s0246, S0.s2); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 3 )==""\n"
R"==(S0.s4 = idot4(A0.s4567, W.s0246, S0.s4); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 4 )==""\n"
R"==(S0.s6 = idot4(A0.s6789, W.s0246, S0.s6); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 5 )==""\n"
R"==(S0.s8 = idot4(A0.s89ab, W.s0246, S0.s8); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 6 )==""\n"
R"==(S0.sa = idot4(A0.sabcd, W.s0246, S0.sa); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 7 )==""\n"
R"==(S0.sc = idot4(A0.scdef, W.s0246, S0.sc); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 8 )==""\n"
R"==(S0.se = idot4((SRC_DATA4_T)(A0.sef, right0.s0, right0.s1), W.s0246, )==""\n"
R"==(S0.se); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 9 )==""\n"
R"==(S1.s0 = idot4(right0.s0123, W.s0246, S1.s0); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 10 )==""\n"
R"==(S1.s2 = idot4(right0.s2345, W.s0246, S1.s2); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 11 )==""\n"
R"==(S1.s4 = idot4(right0.s4567, W.s0246, S1.s4); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 12 )==""\n"
R"==(S1.s6 = idot4(right0.s6789, W.s0246, S1.s6); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 13 )==""\n"
R"==(S1.s8 = idot4(right0.s89ab, W.s0246, S1.s8); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 14 )==""\n"
R"==(S1.sa = idot4(right0.sabcd, W.s0246, S1.sa); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 15 )==""\n"
R"==(S1.sc = idot4(right0.scdef, W.s0246, S1.sc); )==""\n"
R"==(#endif )==""\n"
R"==(S0.s1 = idot4(A1.s0123, W.s1357, S0.s1); )==""\n"
R"==(#if OW_BLOCK >= 2 )==""\n"
R"==(S0.s3 = idot4(A1.s2345, W.s1357, S0.s3); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 3 )==""\n"
R"==(S0.s5 = idot4(A1.s4567, W.s1357, S0.s5); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 4 )==""\n"
R"==(S0.s7 = idot4(A1.s6789, W.s1357, S0.s7); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 5 )==""\n"
R"==(S0.s9 = idot4(A1.s89ab, W.s1357, S0.s9); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 6 )==""\n"
R"==(S0.sb = idot4(A1.sabcd, W.s1357, S0.sb); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 7 )==""\n"
R"==(S0.sd = idot4(A1.scdef, W.s1357, S0.sd); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 8 )==""\n"
R"==(S0.sf = idot4((SRC_DATA4_T)(A1.sef, right1.s0, right1.s1), W.s1357, )==""\n"
R"==(S0.sf); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 9 )==""\n"
R"==(S1.s1 = idot4(right1.s0123, W.s1357, S1.s1); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 10 )==""\n"
R"==(S1.s3 = idot4(right1.s2345, W.s1357, S1.s3); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 11 )==""\n"
R"==(S1.s5 = idot4(right1.s4567, W.s1357, S1.s5); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 12 )==""\n"
R"==(S1.s7 = idot4(right1.s6789, W.s1357, S1.s7); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 13 )==""\n"
R"==(S1.s9 = idot4(right1.s89ab, W.s1357, S1.s9); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 14 )==""\n"
R"==(S1.sb = idot4(right1.sabcd, W.s1357, S1.sb); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 15 )==""\n"
R"==(S1.sd = idot4(right1.scdef, W.s1357, S1.sd); )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(#error  )==""\n"
R"==(#endif )==""\n"
R"==(src += G * IW * (1 + DH); )==""\n"
R"==(wei += OC_BLOCK * KW; )==""\n"
R"==(} )==""\n"
R"==(src += G * IW * (IH * (1 + DD) - KH * (1 + DH)); )==""\n"
R"==(} )==""\n"
R"==(#if WITH_BIAS || (WITH_POST_OP && !SUM_SCALE1 || SCALES_PER_OC || SCALES_COMMON) )==""\n"
R"==(float16 tmp00 = convert_float16(S0); )==""\n"
R"==(float16 tmp01 = convert_float16(S1); )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float2 B; )==""\n"
R"==(B.s0 = bias[g + 2 * sglid]; )==""\n"
R"==(B.s1 = bias[g + 2 * sglid + 1]; )==""\n"
R"==(tmp00 += convert_float16(B.s0101010101010101); )==""\n"
R"==(tmp01 += convert_float16(B.s0101010101010101); )==""\n"
R"==(#endif )==""\n"
R"==(tmp00 *= SCALE; )==""\n"
R"==(tmp01 *= SCALE; )==""\n"
R"==(#define ACC_DATA_TYPE float )==""\n"
R"==(#define ACC0 tmp00 )==""\n"
R"==(#define ACC1 tmp01 )==""\n"
R"==(#else )==""\n"
R"==(#define ACC_DATA_TYPE int )==""\n"
R"==(#define ACC0 S0 )==""\n"
R"==(#define ACC1 S1 )==""\n"
R"==(#endif )==""\n"
R"==(DST_DATA16_T D0 = 0; )==""\n"
R"==(DST_DATA16_T D1 = 0; )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(if (OW_TAIL != 0 && ow + OW_BLOCK >= OW) { )==""\n"
R"==(block_read_dst(min(8, OW_TAIL), &D0, dst, g); )==""\n"
R"==(block_read_dst(OW_TAIL - 8, &D1, dst + 8 * G, g); )==""\n"
R"==(} else { )==""\n"
R"==(block_read_dst(min(8, OW_BLOCK), &D0, dst, g); )==""\n"
R"==(block_read_dst(OW_BLOCK - 8, &D1, dst + 8 * G, g); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(SUM_DATA16_T D0_sdt = AS_SUM_DATA16_T(D0); )==""\n"
R"==(SUM_DATA16_T D1_sdt = AS_SUM_DATA16_T(D1); )==""\n"
R"==(#define APPLY_POST_OPS_COMMON(accumulator, sum, offset) \ )==""\n"
R"==({ \ )==""\n"
R"==(for (int didx = 0; didx < 16; ++didx) { \ )==""\n"
R"==(int po_mb = mb; \ )==""\n"
R"==(int po_oc = g * OC + 2 * get_sub_group_local_id() + (didx % 2); \ )==""\n"
R"==(ACC_DATA_TYPE accum = accumulator[didx]; \ )==""\n"
R"==(SUM_DATA_T sum_di = sum[didx]; \ )==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D(accum, ACC_DATA_TYPE, sum_di, \ )==""\n"
R"==(SUM_DATA_T, po_mb, 1, po_oc, 1); \ )==""\n"
R"==(accumulator[didx] = accum; \ )==""\n"
R"==(} \ )==""\n"
R"==(} )==""\n"
R"==(APPLY_POST_OPS_COMMON(ACC0, D0_sdt, 0); )==""\n"
R"==(APPLY_POST_OPS_COMMON(ACC1, D1_sdt, 8); )==""\n"
R"==(DST_DATA16_T R0 = CONVERT_DST_DATA16_T(ACC0); )==""\n"
R"==(DST_DATA16_T R1 = CONVERT_DST_DATA16_T(ACC1); )==""\n"
R"==(if (OW_TAIL != 0 && ow + OW_BLOCK > OW) { )==""\n"
R"==(block_write_dst(min(8, OW_TAIL), &R0, dst, g); )==""\n"
R"==(block_write_dst(OW_TAIL - 8, &R1, dst + 8 * G, g); )==""\n"
R"==(} else { )==""\n"
R"==(block_write_dst(min(8, OW_BLOCK), &R0, dst, g); )==""\n"
R"==(block_write_dst(OW_BLOCK - 8, &R1, dst + 8 * G, g); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(void block_read_dst( )==""\n"
R"==(int n, DST_DATA_T *d, const __global DST_DATA_T *dst, const int g) { )==""\n"
R"==(int sglid = get_sub_group_local_id(); )==""\n"
R"==(#if DST_DT_S8 || DST_DT_U8 )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < n; i++) { )==""\n"
R"==(const int gtail = (g + OC_BLOCK) <= G ? G : G % OC_BLOCK; )==""\n"
R"==(if (2 * sglid < gtail) { d[i * 2] = dst[i * G + 2 * sglid]; } )==""\n"
R"==(if (1 + 2 * sglid < gtail) { )==""\n"
R"==(d[i * 2 + 1] = dst[i * G + 1 + 2 * sglid]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(return; )==""\n"
R"==(#elif DST_DT_S32 || DST_DT_F32 )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < n; i++) { )==""\n"
R"==(uint block0 = 0, block1 = 0; )==""\n"
R"==(if ((g + OC_BLOCK) <= G || sglid < (G % OC_BLOCK)) { )==""\n"
R"==(block0 = ((const __global uint *)(dst + i * G))[sglid]; )==""\n"
R"==(} )==""\n"
R"==(if ((g + OC_BLOCK) <= G || sglid < (G % OC_BLOCK) - SUB_GROUP_SIZE) { )==""\n"
R"==(block1 = ((const __global uint *)(dst + i * G )==""\n"
R"==(+ SUB_GROUP_SIZE))[sglid]; )==""\n"
R"==(} )==""\n"
R"==(int from00 = min(2 * sglid, SUB_GROUP_SIZE - 1); )==""\n"
R"==(int from01 = max(2 * sglid - 16, 0); )==""\n"
R"==(int from10 = min(2 * sglid + 1, SUB_GROUP_SIZE - 1); )==""\n"
R"==(int from11 = max(2 * sglid + 1 - 16, 0); )==""\n"
R"==(uint block00 = intel_sub_group_shuffle(block0, from00); )==""\n"
R"==(uint block01 = intel_sub_group_shuffle(block1, from01); )==""\n"
R"==(uint block10 = intel_sub_group_shuffle(block0, from10); )==""\n"
R"==(uint block11 = intel_sub_group_shuffle(block1, from11); )==""\n"
R"==(block0 = (2 * sglid < SUB_GROUP_SIZE) ? block00 : block01; )==""\n"
R"==(block1 = (2 * sglid + 1 < SUB_GROUP_SIZE) ? block10 : block11; )==""\n"
R"==(*(DST_DATA2_T *)(&d[i * 2]) = AS_DST_DATA2_T((uint2)(block0, block1)); )==""\n"
R"==(} )==""\n"
R"==(return; )==""\n"
R"==(#else )==""\n"
R"==(#error "Not expected" )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(void block_write_dst( )==""\n"
R"==(int n, const DST_DATA_T *d, __global DST_DATA_T *dst, const int g) { )==""\n"
R"==(int sglid = get_sub_group_local_id(); )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < n; i++) { )==""\n"
R"==(DST_DATA2_T block = AS_DST_DATA2_T(*(DST_DATA2_T *)(&d[i * 2])); )==""\n"
R"==(const int gtail = (g + OC_BLOCK) <= G ? G : G % OC_BLOCK; )==""\n"
R"==(if (2 * sglid < gtail) { dst[i * G + 2 * sglid] = block.S0; } )==""\n"
R"==(if (1 + 2 * sglid < gtail) { dst[i * G + 1 + 2 * sglid] = block.S1; } )==""\n"
R"==(} )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(void block_read_src(int n, ushort *s, const __global ushort *src, const int g) { )==""\n"
R"==(int sglid = get_sub_group_local_id(); )==""\n"
R"==(#if G % 2 == 0 )==""\n"
R"==(for (int i = 0; i < n; i++) { )==""\n"
R"==(if (sglid < ((g + IC_BLOCK) <= G ? 16 : (G % IC_BLOCK) / 2)) { )==""\n"
R"==(s[i] = src[i * G / 2 + sglid]; )==""\n"
R"==(} else )==""\n"
R"==(s[i] = 0; )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(uchar *sc = (uchar *)s; )==""\n"
R"==(const __global uchar *src_c = (const __global uchar *)src; )==""\n"
R"==(if ((g + IC_BLOCK) <= G || (g + IC_BLOCK > G && sglid < G % IC_BLOCK - 1)) { )==""\n"
R"==(for (int i = 0; i < n; i++) { )==""\n"
R"==(sc[i * 2] = src_c[i * G + sglid * 2]; )==""\n"
R"==(sc[i * 2 + 1] = src_c[i * G + sglid * 2 + 1]; )==""\n"
R"==(} )==""\n"
R"==(} else if (sglid == G % IC_BLOCK - 1) { )==""\n"
R"==(for (int i = 0; i < n; i++) { )==""\n"
R"==(sc[i * 2] = src_c[i * G + sglid * 2]; )==""\n"
R"==(sc[i * 2 + 1] = 0; )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(for (int i = 0; i < n; i++) { )==""\n"
R"==(sc[i * 2] = 0; )==""\n"
R"==(sc[i * 2 + 1] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}