namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_nhwc_fwd_first_x8s8x_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#define KDHW_SIZE (KH * KW * KD) )==""\n"
R"==(#define CX1_OFFSET (sizeof(C00) / sizeof(int)) )==""\n"
R"==(#if (PW % 4 == 0) && (SRC_SLM_SIZE % 4 == 0) )==""\n"
R"==(#define WRITE_SLM_BLOCK(p, data) block_write(p, data) )==""\n"
R"==(#define WRITE_SLM_BLOCK_SHORT(p, data) block_write_us(p, data) )==""\n"
R"==(#else )==""\n"
R"==(#define WRITE_SLM_BLOCK(p, data) block_write_emu(p, data) )==""\n"
R"==(#define WRITE_SLM_BLOCK_SHORT(p, data) block_write_us_emu(p, data) )==""\n"
R"==(#endif )==""\n"
R"==(#define GET_INT_BLOCK(src_slm, slm_index, src_global) \ )==""\n"
R"==(uchar4 res = 0; \ )==""\n"
R"==(for (int j = 0; j < IC; j++) { \ )==""\n"
R"==(((uchar *)&res)[j] = src_global[j]; \ )==""\n"
R"==(} \ )==""\n"
R"==(src_slm[slm_index] = as_int(res); \ )==""\n"
R"==(src_global += IC; )==""\n"
R"==(#define BLOCK_READ_SRC(data, idx) \ )==""\n"
R"==(data = intel_sub_group_block_read8((__global uint *)&src[idx]); )==""\n"
R"==(#define BLOCK_READ_WHT(data, idx) \ )==""\n"
R"==(data = as_int(intel_sub_group_block_read((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT8(data, idx) \ )==""\n"
R"==(data = as_int8(intel_sub_group_block_read8((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4((__global uint *)&bias[idx])); )==""\n"
R"==(#define BLOCK_READ_SCALES(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4( \ )==""\n"
R"==((__global uint *)&runtime_scales[idx])); )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(#define SCALE_VEC4 scales.s01230123 )==""\n"
R"==(#define SCALE scales )==""\n"
R"==(#elif SCALES_COMMON )==""\n"
R"==(#define SCALE_VEC4 runtime_scales[0] )==""\n"
R"==(#define SCALE runtime_scales[0] )==""\n"
R"==(#else )==""\n"
R"==(#define SCALE_VEC4 1 )==""\n"
R"==(#define SCALE 1 )==""\n"
R"==(#endif )==""\n"
R"==(#define OC_PADD8 ((OC % 8) ? (OC / 8 + 1) * 8 : OC) )==""\n"
R"==(#if DST_DT_S8 || DST_DT_U8 )==""\n"
R"==(#define OC_BLOCK_READ_BOUND 4 )==""\n"
R"==(#define OC_BLOCK_WRITE_BOUND 16 )==""\n"
R"==(#else )==""\n"
R"==(#define OC_BLOCK_READ_BOUND 1 )==""\n"
R"==(#define OC_BLOCK_WRITE_BOUND 4 )==""\n"
R"==(#endif )==""\n"
R"==(inline DST_DATA4_T read_oc_block4(const __global DST_DATA_T *dst, int off) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if OC % OC_BLOCK != 0 )==""\n"
R"==(int tail = OC - off; )==""\n"
R"==(if (tail < OC_BLOCK) { )==""\n"
R"==(return (DST_DATA4_T)( )==""\n"
R"==(local_id < tail - 8 * 0 ? dst[0 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 1 ? dst[1 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 2 ? dst[2 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 3 ? dst[3 * 8 + local_id] : 0); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OC % OC_BLOCK_READ_BOUND != 0 )==""\n"
R"==(return (DST_DATA4_T)(dst[0 * 8 + local_id], dst[1 * 8 + local_id], )==""\n"
R"==(dst[2 * 8 + local_id], dst[3 * 8 + local_id]); )==""\n"
R"==(#else )==""\n"
R"==(return BLOCK_READ_DST4(dst); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(inline void write_oc_block4( )==""\n"
R"==(__global DST_DATA_T *dst, int off, DST_DATA4_T value) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if OC % OC_BLOCK != 0 )==""\n"
R"==(int tail = OC - off; )==""\n"
R"==(if (tail < OC_BLOCK) { )==""\n"
R"==(if (local_id < tail) dst[0 * 8 + local_id] = value.s0; )==""\n"
R"==(if (local_id < tail - 8 * 1) dst[1 * 8 + local_id] = value.s1; )==""\n"
R"==(if (local_id < tail - 8 * 2) dst[2 * 8 + local_id] = value.s2; )==""\n"
R"==(if (local_id < tail - 8 * 3) dst[3 * 8 + local_id] = value.s3; )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OC % OC_BLOCK_WRITE_BOUND != 0 )==""\n"
R"==(dst[0 * 8 + local_id] = value.s0; )==""\n"
R"==(dst[1 * 8 + local_id] = value.s1; )==""\n"
R"==(dst[2 * 8 + local_id] = value.s2; )==""\n"
R"==(dst[3 * 8 + local_id] = value.s3; )==""\n"
R"==(return; )==""\n"
R"==(#else )==""\n"
R"==(BLOCK_WRITE_DST4(dst, value); )==""\n"
R"==(return; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) __kernel void )==""\n"
R"==(conv_nhwc_fwd_first_x8s8x(const __global uchar *src, const __global char *wei, )==""\n"
R"==(const __global float *bias, __global DST_DATA_T *dst POST_OP_ARGS, )==""\n"
R"==(const __global float *runtime_scales, )==""\n"
R"==(const __global int *src_compensation, const __global int *src_zpoints, )==""\n"
R"==(const __global int *dst_compensation) { )==""\n"
R"==(const int group_oc = get_group_id(0) * OC_GROUP; )==""\n"
R"==(const int group_mb = get_group_id(2) * MB_GROUP; )==""\n"
R"==(const int group_sp = get_group_id(1) * SP_GROUP; )==""\n"
R"==(const int sub_group_id = get_sub_group_id(); )==""\n"
R"==(const int sub_local_id = get_sub_group_local_id(); )==""\n"
R"==(const int oc = (sub_group_id % OC_GROUP); )==""\n"
R"==(const int sp = (sub_group_id / OC_GROUP); )==""\n"
R"==(const int g = (group_oc + oc) / OC_NCHUNK; )==""\n"
R"==(const int group_ic = IC_NCHUNK * g; )==""\n"
R"==(const int god = group_sp / (OW_PADDED * OH); )==""\n"
R"==(const int gohw = group_sp % (OW_PADDED * OH); )==""\n"
R"==(const int goh = gohw / OW_PADDED; )==""\n"
R"==(const int gow = OW_BLOCK * (gohw % OW_PADDED); )==""\n"
R"==(const int gid = god * SD; )==""\n"
R"==(const int gih = goh * SH; )==""\n"
R"==(const int giw = gow * SW; )==""\n"
R"==(const int local_ow = OW_BLOCK * sp; )==""\n"
R"==(const int local_iw = local_ow * SW; )==""\n"
R"==(const int od = god; )==""\n"
R"==(const int ow = gow + local_ow; )==""\n"
R"==(const int oh = goh; )==""\n"
R"==(const int id = gid - PD; )==""\n"
R"==(const int iw = giw + local_iw - PW; )==""\n"
R"==(const int ih = gih - PH; )==""\n"
R"==(__local uint S_slice[SRC_SLM_SIZE * KH * KD]; )==""\n"
R"==(__local uint *S_part = S_slice + (sp * SW * OW_BLOCK + PW); )==""\n"
R"==(__local SRC_MMAD_DATA_T *S_work = S_slice + (sp * SW * OW_BLOCK); )==""\n"
R"==(#if DST_NHWC )==""\n"
R"==(dst += group_mb * OD * OH * OW * G * OC; )==""\n"
R"==(dst += (OW * OH * od + OW * oh + ow) * G * OC; )==""\n"
R"==(dst += OC_BLOCK * (group_oc + oc); )==""\n"
R"==(#else )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * MB_BLOCK * (group_oc + oc); )==""\n"
R"==(dst += OC_BLOCK * OD * OH * OW * OC_NCHUNK * G * MB_BLOCK )==""\n"
R"==(* (group_mb / MB_BLOCK); )==""\n"
R"==(dst += OC_BLOCK * (group_mb % MB_BLOCK); )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK * (OW * OH * od + OW * oh + ow); )==""\n"
R"==(#endif )==""\n"
R"==(src += (group_mb >= MB ? MB - 1 : group_mb) * ID * IH * IW * G * IC; )==""\n"
R"==(src += (IW * IH * id + IW * ih + iw + PW) * G * IC; )==""\n"
R"==(wei += 4 * KDHW_SIZE * OC_BLOCK * (group_oc + oc); )==""\n"
R"==(/* WORK WITH SLM */ )==""\n"
R"==(const bool left_tail = iw < 0; )==""\n"
R"==(const bool left_nozero_tail = sub_group_id == 0 && iw >= 0; )==""\n"
R"==(const bool right_tail = (iw + PW + SLM_TAIL >= IW) && (iw + PW < IW); )==""\n"
R"==(const bool empty = (iw + PW >= IW); )==""\n"
R"==(const bool right_nozero_tail )==""\n"
R"==(= sp == (LWS_1 - 1) && (iw + PW + SLM_TAIL < IW); )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(/* KD */ )==""\n"
R"==(#if KD > 1 )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(if (kd * (1 + DD) + id < 0 || kd * (1 + DD) + id >= ID) { )==""\n"
R"==(S_part += SRC_SLM_SIZE * KH; )==""\n"
R"==(src += IC * IW * IH * (1 + DD); )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(/* KH */ )==""\n"
R"==(#if KH > 1 )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(if (kh * (1 + DH) + ih < 0 || kh * (1 + DH) + ih >= IH) { )==""\n"
R"==(S_part += SRC_SLM_SIZE; )==""\n"
R"==(src += IC * IW * (1 + DH); )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(/* KW */ )==""\n"
R"==(/* left tail */ )==""\n"
R"==(#if PW > 0 )==""\n"
R"==(if (left_tail) { )==""\n"
R"==(for (int i = -PW; i < 0; i++) { )==""\n"
R"==(S_part[i] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(/* right tail */ )==""\n"
R"==(#if ZERO_TAIL > 0 )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(for (int i = SLM_TAIL; )==""\n"
R"==(i < SW * OW_BLOCK + (KW - 1) * (1 + DW) - PW; i++) { )==""\n"
R"==(S_part[i] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(if (empty) { )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK + (KW - 1) * (1 + DW) - PW; )==""\n"
R"==(i++) { )==""\n"
R"==(WRITE_SLM_BLOCK(S_part + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(if (iw + PW < IW) { )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_NCHUNK > LWS_1 )==""\n"
R"==(/* Copy tails in case of multigroups */ )==""\n"
R"==(if (ow < OW) { )==""\n"
R"==(#if PW > 0 )==""\n"
R"==(if (left_nozero_tail) { )==""\n"
R"==(__global uchar *s = (__global uchar *)src; )==""\n"
R"==(for (int i = -PW; i < 0; i++) { )==""\n"
R"==(GET_INT_BLOCK(S_part, i, s); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(if (right_nozero_tail) { )==""\n"
R"==(__global uchar *s = (__global uchar *)src; )==""\n"
R"==(for (int i = SW * OW_BLOCK; )==""\n"
R"==(i < SW * OW_BLOCK + (KW - 1) * (1 + DW) - PW; )==""\n"
R"==(i++) { )==""\n"
R"==(GET_INT_BLOCK(S_part, i, s); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_TAIL != OW_BLOCK * SW )==""\n"
R"==(/* Copy last block to SLM */ )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(__global uchar *s = (__global uchar *)src; )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < SLM_TAIL; i++) { )==""\n"
R"==(GET_INT_BLOCK(S_part, i, s); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(#endif )==""\n"
R"==(#if (SW * OW_BLOCK) % 8 == 0 )==""\n"
R"==(/* Copy block to SLM */ )==""\n"
R"==(#if IC == 4 )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK; i += 8) { )==""\n"
R"==(WRITE_SLM_BLOCK(S_part + i, )==""\n"
R"==(intel_sub_group_block_read((const __global )==""\n"
R"==(uint *)(&src[i * IC]))); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(__global uchar *s = (__global uchar *)src; )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK; i += 8) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(uchar4 res = 0; )==""\n"
R"==(for (int j = 0; j < IC; j++) { )==""\n"
R"==(res[j] = s[local_id * IC + j]; )==""\n"
R"==(} )==""\n"
R"==(s += IC * 8; )==""\n"
R"==(WRITE_SLM_BLOCK(S_part + i, as_uint(res)); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#else  )==""\n"
R"==(#if IC == 4 )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK; i += 4) { )==""\n"
R"==(WRITE_SLM_BLOCK_SHORT(S_part + i, )==""\n"
R"==(intel_sub_group_block_read_us( )==""\n"
R"==((const __global ushort *)(&src[i * IC]))); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(__global uchar *s = (__global uchar *)src; )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK; i += 4) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(uchar2 res = 0; )==""\n"
R"==(#if IC == 3 )==""\n"
R"==(res[0] = local_id % 2 ? s[local_id * IC / 2 + 1] )==""\n"
R"==(: s[0 + local_id * IC / 2]; )==""\n"
R"==(res[1] = local_id % 2 ?: s[1 + local_id * IC / 2]; )==""\n"
R"==(#elif IC == 2 )==""\n"
R"==(res[0] = local_id % 2 ?: s[0 + local_id * IC / 2]; )==""\n"
R"==(res[1] = local_id % 2 ?: s[1 + local_id * IC / 2]; )==""\n"
R"==(#else )==""\n"
R"==(res[0] = local_id % 2 ?: s[0 + local_id * IC / 2]; )==""\n"
R"==(#endif )==""\n"
R"==(s += IC * 4; )==""\n"
R"==(WRITE_SLM_BLOCK_SHORT(S_part + i, as_ushort(res)); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_TAIL != OW_BLOCK * SW )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_NCHUNK > LWS_1 )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if KH > 1 )==""\n"
R"==(S_part += SRC_SLM_SIZE; )==""\n"
R"==(src += IC * IW * (1 + DH); )==""\n"
R"==(} )==""\n"
R"==(S_part -= SRC_SLM_SIZE * KH; )==""\n"
R"==(src -= IC * KH * IW * (1 + DH); )==""\n"
R"==(#endif )==""\n"
R"==(#if KD > 1 )==""\n"
R"==(S_part += SRC_SLM_SIZE * KH; )==""\n"
R"==(src += IC * IW * IH * (1 + DD); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(SRC_MMAD_DATA8_T S; )==""\n"
R"==(int8 W0 = 0, W1 = 0, W2 = 0, W3 = 0; )==""\n"
R"==(int W00 = 0, W10 = 0, W20 = 0, W30 = 0; )==""\n"
R"==(int8 C00 = 0; )==""\n"
R"==(int8 C10 = 0; )==""\n"
R"==(int8 C20 = 0; )==""\n"
R"==(int8 C30 = 0; )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(SRC_MMAD_DATA4_T SS; )==""\n"
R"==(int4 C01 = 0; )==""\n"
R"==(int4 C11 = 0; )==""\n"
R"==(int4 C21 = 0; )==""\n"
R"==(int4 C31 = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 16 )==""\n"
R"==(int8 C01 = 0; )==""\n"
R"==(int8 C11 = 0; )==""\n"
R"==(int8 C21 = 0; )==""\n"
R"==(int8 C31 = 0; )==""\n"
R"==(#endif )==""\n"
R"==(for (int i = 0; i < KDHW_SIZE - KDHW_SIZE % 8; i += 8) { )==""\n"
R"==(const int ihw = (i + sub_local_id) % (KW * KH); )==""\n"
R"==(const int filter_iw = (ihw % KW) * (1 + DW); )==""\n"
R"==(const int filter_ih = ihw / KW; )==""\n"
R"==(const int filter_id = (i + sub_local_id) / (KH * KW); )==""\n"
R"==(const int filter = (filter_ih * (1 + DH) + ih >= 0) )==""\n"
R"==(&& (filter_ih * (1 + DH) + ih < IH) )==""\n"
R"==(&& (filter_id * (1 + DD) + id >= 0 )==""\n"
R"==(&& filter_id * (1 + DD) + id < ID); )==""\n"
R"==(BLOCK_READ_WHT8(W0, 0); )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK )==""\n"
R"==(BLOCK_READ_WHT8(W1, KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK * 2 )==""\n"
R"==(BLOCK_READ_WHT8(W2, 2 * KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK * 3 )==""\n"
R"==(BLOCK_READ_WHT8(W3, 3 * KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(if (filter) { )==""\n"
R"==(S.s0 = S_work[SW * 0 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s1 = S_work[SW * 1 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s2 = S_work[SW * 2 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s3 = S_work[SW * 3 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s4 = S_work[SW * 4 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s5 = S_work[SW * 5 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s6 = S_work[SW * 6 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s7 = S_work[SW * 7 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(SS.s0 = S_work[SW * 8 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s1 = S_work[SW * 9 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s2 = S_work[SW * 10 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s3 = S_work[SW * 11 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(#endif )==""\n"
R"==(} else { )==""\n"
R"==(S = 0; )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(SS = 0; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(C00 = mmad8x8(S, W0, C00); )==""\n"
R"==(C10 = mmad8x8(S, W1, C10); )==""\n"
R"==(C20 = mmad8x8(S, W2, C20); )==""\n"
R"==(C30 = mmad8x8(S, W3, C30); )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(C01 = mmad8x4(SS, W0, C01); )==""\n"
R"==(C11 = mmad8x4(SS, W1, C11); )==""\n"
R"==(C21 = mmad8x4(SS, W2, C21); )==""\n"
R"==(C31 = mmad8x4(SS, W3, C31); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 16 )==""\n"
R"==(if (filter) { )==""\n"
R"==(S.s0 = S_work[SW * 8 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s1 = S_work[SW * 9 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s2 = S_work[SW * 10 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s3 = S_work[SW * 11 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s4 = S_work[SW * 12 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s5 = S_work[SW * 13 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s6 = S_work[SW * 14 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s7 = S_work[SW * 15 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(} else { )==""\n"
R"==(S = 0; )==""\n"
R"==(} )==""\n"
R"==(C01 = mmad8x8(S, W0, C01); )==""\n"
R"==(C11 = mmad8x8(S, W1, C11); )==""\n"
R"==(C21 = mmad8x8(S, W2, C21); )==""\n"
R"==(C31 = mmad8x8(S, W3, C31); )==""\n"
R"==(#endif )==""\n"
R"==(wei += OC_BLOCK * 8; )==""\n"
R"==(} )==""\n"
R"==(for (int i = KDHW_SIZE - KDHW_SIZE % 8; i < KDHW_SIZE; i++) { )==""\n"
R"==(const int ihw = (i) % (KW * KH); )==""\n"
R"==(const int filter_iw = (ihw % KW) * (1 + DW); )==""\n"
R"==(const int filter_ih = ihw / KW; )==""\n"
R"==(const int filter_id = (i) / (KH * KW); )==""\n"
R"==(const int filter = (filter_ih * (1 + DH) + ih >= 0) )==""\n"
R"==(&& (filter_ih * (1 + DH) + ih < IH) )==""\n"
R"==(&& (filter_id * (1 + DD) + id >= 0 )==""\n"
R"==(&& filter_id * (1 + DD) + id < ID); )==""\n"
R"==(if (filter) { )==""\n"
R"==(BLOCK_READ_WHT(W00, 0); )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK )==""\n"
R"==(BLOCK_READ_WHT(W10, KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK * 2 )==""\n"
R"==(BLOCK_READ_WHT(W20, 2 * KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC_PADD8 * 4 > OC_BLOCK * 3 )==""\n"
R"==(BLOCK_READ_WHT(W30, 3 * KDHW_SIZE * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(S.s0 = S_work[SW * 0 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s1 = S_work[SW * 1 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s2 = S_work[SW * 2 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s3 = S_work[SW * 3 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s4 = S_work[SW * 4 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s5 = S_work[SW * 5 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s6 = S_work[SW * 6 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s7 = S_work[SW * 7 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(SS.s0 = S_work[SW * 8 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s1 = S_work[SW * 9 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s2 = S_work[SW * 10 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(SS.s3 = S_work[SW * 11 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(#endif )==""\n"
R"==(C00.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W00), C00.s0); )==""\n"
R"==(C00.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W00), C00.s1); )==""\n"
R"==(C00.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W00), C00.s2); )==""\n"
R"==(C00.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W00), C00.s3); )==""\n"
R"==(C00.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W00), C00.s4); )==""\n"
R"==(C00.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W00), C00.s5); )==""\n"
R"==(C00.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W00), C00.s6); )==""\n"
R"==(C00.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W00), C00.s7); )==""\n"
R"==(C10.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W10), C10.s0); )==""\n"
R"==(C10.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W10), C10.s1); )==""\n"
R"==(C10.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W10), C10.s2); )==""\n"
R"==(C10.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W10), C10.s3); )==""\n"
R"==(C10.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W10), C10.s4); )==""\n"
R"==(C10.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W10), C10.s5); )==""\n"
R"==(C10.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W10), C10.s6); )==""\n"
R"==(C10.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W10), C10.s7); )==""\n"
R"==(C20.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W20), C20.s0); )==""\n"
R"==(C20.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W20), C20.s1); )==""\n"
R"==(C20.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W20), C20.s2); )==""\n"
R"==(C20.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W20), C20.s3); )==""\n"
R"==(C20.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W20), C20.s4); )==""\n"
R"==(C20.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W20), C20.s5); )==""\n"
R"==(C20.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W20), C20.s6); )==""\n"
R"==(C20.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W20), C20.s7); )==""\n"
R"==(C30.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W30), C30.s0); )==""\n"
R"==(C30.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W30), C30.s1); )==""\n"
R"==(C30.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W30), C30.s2); )==""\n"
R"==(C30.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W30), C30.s3); )==""\n"
R"==(C30.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W30), C30.s4); )==""\n"
R"==(C30.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W30), C30.s5); )==""\n"
R"==(C30.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W30), C30.s6); )==""\n"
R"==(C30.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W30), C30.s7); )==""\n"
R"==(#if OW_BLOCK == 12 )==""\n"
R"==(C01.s0 = idot4(AS_SRC_DATA4_T(SS.s0), as_char4(W00), C01.s0); )==""\n"
R"==(C01.s1 = idot4(AS_SRC_DATA4_T(SS.s1), as_char4(W00), C01.s1); )==""\n"
R"==(C01.s2 = idot4(AS_SRC_DATA4_T(SS.s2), as_char4(W00), C01.s2); )==""\n"
R"==(C01.s3 = idot4(AS_SRC_DATA4_T(SS.s3), as_char4(W00), C01.s3); )==""\n"
R"==(C11.s0 = idot4(AS_SRC_DATA4_T(SS.s0), as_char4(W10), C11.s0); )==""\n"
R"==(C11.s1 = idot4(AS_SRC_DATA4_T(SS.s1), as_char4(W10), C11.s1); )==""\n"
R"==(C11.s2 = idot4(AS_SRC_DATA4_T(SS.s2), as_char4(W10), C11.s2); )==""\n"
R"==(C11.s3 = idot4(AS_SRC_DATA4_T(SS.s3), as_char4(W10), C11.s3); )==""\n"
R"==(C21.s0 = idot4(AS_SRC_DATA4_T(SS.s0), as_char4(W20), C21.s0); )==""\n"
R"==(C21.s1 = idot4(AS_SRC_DATA4_T(SS.s1), as_char4(W20), C21.s1); )==""\n"
R"==(C21.s2 = idot4(AS_SRC_DATA4_T(SS.s2), as_char4(W20), C21.s2); )==""\n"
R"==(C21.s3 = idot4(AS_SRC_DATA4_T(SS.s3), as_char4(W20), C21.s3); )==""\n"
R"==(C31.s0 = idot4(AS_SRC_DATA4_T(SS.s0), as_char4(W30), C31.s0); )==""\n"
R"==(C31.s1 = idot4(AS_SRC_DATA4_T(SS.s1), as_char4(W30), C31.s1); )==""\n"
R"==(C31.s2 = idot4(AS_SRC_DATA4_T(SS.s2), as_char4(W30), C31.s2); )==""\n"
R"==(C31.s3 = idot4(AS_SRC_DATA4_T(SS.s3), as_char4(W30), C31.s3); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 16 )==""\n"
R"==(S.s0 = S_work[SW * 8 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s1 = S_work[SW * 9 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s2 = S_work[SW * 10 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s3 = S_work[SW * 11 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s4 = S_work[SW * 12 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s5 = S_work[SW * 13 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s6 = S_work[SW * 14 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(S.s7 = S_work[SW * 15 + SRC_SLM_SIZE * KH * filter_id )==""\n"
R"==(+ SRC_SLM_SIZE * filter_ih + filter_iw]; )==""\n"
R"==(C01.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W00), C01.s0); )==""\n"
R"==(C01.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W00), C01.s1); )==""\n"
R"==(C01.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W00), C01.s2); )==""\n"
R"==(C01.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W00), C01.s3); )==""\n"
R"==(C01.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W00), C01.s4); )==""\n"
R"==(C01.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W00), C01.s5); )==""\n"
R"==(C01.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W00), C01.s6); )==""\n"
R"==(C01.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W00), C01.s7); )==""\n"
R"==(C11.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W10), C11.s0); )==""\n"
R"==(C11.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W10), C11.s1); )==""\n"
R"==(C11.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W10), C11.s2); )==""\n"
R"==(C11.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W10), C11.s3); )==""\n"
R"==(C11.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W10), C11.s4); )==""\n"
R"==(C11.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W10), C11.s5); )==""\n"
R"==(C11.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W10), C11.s6); )==""\n"
R"==(C11.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W10), C11.s7); )==""\n"
R"==(C21.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W20), C21.s0); )==""\n"
R"==(C21.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W20), C21.s1); )==""\n"
R"==(C21.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W20), C21.s2); )==""\n"
R"==(C21.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W20), C21.s3); )==""\n"
R"==(C21.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W20), C21.s4); )==""\n"
R"==(C21.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W20), C21.s5); )==""\n"
R"==(C21.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W20), C21.s6); )==""\n"
R"==(C21.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W20), C21.s7); )==""\n"
R"==(C31.s0 = idot4(AS_SRC_DATA4_T(S.s0), as_char4(W30), C31.s0); )==""\n"
R"==(C31.s1 = idot4(AS_SRC_DATA4_T(S.s1), as_char4(W30), C31.s1); )==""\n"
R"==(C31.s2 = idot4(AS_SRC_DATA4_T(S.s2), as_char4(W30), C31.s2); )==""\n"
R"==(C31.s3 = idot4(AS_SRC_DATA4_T(S.s3), as_char4(W30), C31.s3); )==""\n"
R"==(C31.s4 = idot4(AS_SRC_DATA4_T(S.s4), as_char4(W30), C31.s4); )==""\n"
R"==(C31.s5 = idot4(AS_SRC_DATA4_T(S.s5), as_char4(W30), C31.s5); )==""\n"
R"==(C31.s6 = idot4(AS_SRC_DATA4_T(S.s6), as_char4(W30), C31.s6); )==""\n"
R"==(C31.s7 = idot4(AS_SRC_DATA4_T(S.s7), as_char4(W30), C31.s7); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(wei += OC_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(DST_DATA16_T R1, R2, R3, R4; )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(float4 scales; )==""\n"
R"==(BLOCK_READ_SCALES(scales, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float4 bia; )==""\n"
R"==(BLOCK_READ_BIA(bia, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp = SCALE * fma(tmp, (float4)1, bia); )==""\n"
R"==(#define QUANTIZE_ADD_BIAS_4() \ )==""\n"
R"==(tmp0 = ((float8)SCALE_VEC4) * fma(tmp0, (float8)1, bia.s01230123); \ )==""\n"
R"==(tmp1 = ((float8)SCALE_VEC4) * fma(tmp1, (float8)1, bia.s01230123); )==""\n"
R"==(#else )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp *= SCALE; )==""\n"
R"==(#define QUANTIZE_ADD_BIAS_4() \ )==""\n"
R"==(tmp0 *= SCALE_VEC4; \ )==""\n"
R"==(tmp1 *= SCALE_VEC4; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_POST_OP )==""\n"
R"==(#define APPLY_POST_OPS_COMMON(nelems, accum, sum) \ )==""\n"
R"==(for (int didx = 0; didx < nelems; ++didx) { \ )==""\n"
R"==(float tmp_i = accum[didx]; \ )==""\n"
R"==(SUM_DATA_T d_i = sum[didx]; \ )==""\n"
R"==(const int po_mb = group_mb % MB; \ )==""\n"
R"==(const int po_oc \ )==""\n"
R"==(= (oc * OC_BLOCK + ((didx * SUB_GROUP_SIZE) % OC_BLOCK) \ )==""\n"
R"==(+ sub_local_id) \ )==""\n"
R"==(% (OC * G); \ )==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D( \ )==""\n"
R"==(tmp_i, float, d_i, SUM_DATA_T, po_mb, 1, po_oc, 1); \ )==""\n"
R"==(accum[didx] = tmp_i; \ )==""\n"
R"==(} )==""\n"
R"==(#if DST_NHWC )==""\n"
R"==(#define DO_POST_OP() \ )==""\n"
R"==(do { \ )==""\n"
R"==(SUM_DATA4_T d; \ )==""\n"
R"==(if (WITH_SUM) \ )==""\n"
R"==(d = AS_SUM_DATA4_T( \ )==""\n"
R"==(read_oc_block4(dst, (group_oc + oc) * OC_BLOCK)); \ )==""\n"
R"==(APPLY_POST_OPS_COMMON(4, tmp, d); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_POST_OP_4() \ )==""\n"
R"==({ \ )==""\n"
R"==(SUM_DATA16_T d; \ )==""\n"
R"==(if (WITH_SUM) \ )==""\n"
R"==(d = AS_SUM_DATA16_T( \ )==""\n"
R"==((DST_DATA16_T)(read_oc_block4(dst + G * OC * 0, \ )==""\n"
R"==((group_oc + oc) * OC_BLOCK), \ )==""\n"
R"==(read_oc_block4(dst + G * OC * 1, \ )==""\n"
R"==((group_oc + oc) * OC_BLOCK), \ )==""\n"
R"==(read_oc_block4(dst + G * OC * 2, \ )==""\n"
R"==((group_oc + oc) * OC_BLOCK), \ )==""\n"
R"==(read_oc_block4(dst + G * OC * 3, \ )==""\n"
R"==((group_oc + oc) * OC_BLOCK))); \ )==""\n"
R"==(float16 tmp_x16 = (float16)(tmp0, tmp1); \ )==""\n"
R"==(APPLY_POST_OPS_COMMON(16, tmp_x16, d); \ )==""\n"
R"==(tmp0 = tmp_x16.s01234567; \ )==""\n"
R"==(tmp1 = tmp_x16.s89abcdef; \ )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#define DO_POST_OP() \ )==""\n"
R"==({ \ )==""\n"
R"==(SUM_DATA4_T d; \ )==""\n"
R"==(if (WITH_SUM) d = AS_SUM_DATA4_T(BLOCK_READ_DST4(dst)); \ )==""\n"
R"==(APPLY_POST_OPS_COMMON(4, tmp, d); \ )==""\n"
R"==(} )==""\n"
R"==(#define DO_POST_OP_4() \ )==""\n"
R"==({ \ )==""\n"
R"==(SUM_DATA16_T d; \ )==""\n"
R"==(if (WITH_SUM) d = AS_SUM_DATA16_T(BLOCK_READ_DST16(dst)); \ )==""\n"
R"==(float16 tmp_x16 = (float16)(tmp0, tmp1); \ )==""\n"
R"==(APPLY_POST_OPS_COMMON(16, tmp_x16, d); \ )==""\n"
R"==(tmp0 = tmp_x16.s01234567; \ )==""\n"
R"==(tmp1 = tmp_x16.s89abcdef; \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#else )==""\n"
R"==(#define DO_POST_OP() ; )==""\n"
R"==(#define DO_POST_OP_4() ; )==""\n"
R"==(#endif  )==""\n"
R"==(#define PACK(C0, C1, C2, C3, idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp.s0 = ((int *)&C0)[idx]; \ )==""\n"
R"==(tmp.s1 = ((int *)&C1)[idx]; \ )==""\n"
R"==(tmp.s2 = ((int *)&C2)[idx]; \ )==""\n"
R"==(tmp.s3 = ((int *)&C3)[idx]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define PACK_4(C0, C1, C2, C3, idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp0.s0 = ((int *)&C0)[idx]; \ )==""\n"
R"==(tmp0.s1 = ((int *)&C1)[idx]; \ )==""\n"
R"==(tmp0.s2 = ((int *)&C2)[idx]; \ )==""\n"
R"==(tmp0.s3 = ((int *)&C3)[idx]; \ )==""\n"
R"==(\ )==""\n"
R"==(tmp0.s4 = ((int *)&C0)[idx + 1]; \ )==""\n"
R"==(tmp0.s5 = ((int *)&C1)[idx + 1]; \ )==""\n"
R"==(tmp0.s6 = ((int *)&C2)[idx + 1]; \ )==""\n"
R"==(tmp0.s7 = ((int *)&C3)[idx + 1]; \ )==""\n"
R"==(\ )==""\n"
R"==(tmp1.s0 = ((int *)&C0)[idx + 2]; \ )==""\n"
R"==(tmp1.s1 = ((int *)&C1)[idx + 2]; \ )==""\n"
R"==(tmp1.s2 = ((int *)&C2)[idx + 2]; \ )==""\n"
R"==(tmp1.s3 = ((int *)&C3)[idx + 2]; \ )==""\n"
R"==(\ )==""\n"
R"==(tmp1.s4 = ((int *)&C0)[idx + 3]; \ )==""\n"
R"==(tmp1.s5 = ((int *)&C1)[idx + 3]; \ )==""\n"
R"==(tmp1.s6 = ((int *)&C2)[idx + 3]; \ )==""\n"
R"==(tmp1.s7 = ((int *)&C3)[idx + 3]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define CONVERT_PACK() \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp_cvt = CONVERT_DST_DATA4_T(tmp); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define CONVERT_PACK_4() \ )==""\n"
R"==(do { \ )==""\n"
R"==(R.s01234567 = CONVERT_DST_DATA8_T(tmp0); \ )==""\n"
R"==(R.s89abcdef = CONVERT_DST_DATA8_T(tmp1); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#if DST_NHWC )==""\n"
R"==(#define STORE_DST(C0, C1, C2, C3, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(PACK(C0, C1, C2, C3, i); \ )==""\n"
R"==(QUANTIZE_ADD_BIAS(); \ )==""\n"
R"==(DO_POST_OP(); \ )==""\n"
R"==(CONVERT_PACK(); \ )==""\n"
R"==(write_oc_block4(dst, (group_oc + oc) * OC_BLOCK, tmp_cvt); \ )==""\n"
R"==(dst += OC; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define STORE_DST_4(C0, C1, C2, C3, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(PACK_4(C0, C1, C2, C3, i); \ )==""\n"
R"==(QUANTIZE_ADD_BIAS_4(); \ )==""\n"
R"==(DO_POST_OP_4(); \ )==""\n"
R"==(CONVERT_PACK_4(); \ )==""\n"
R"==(write_oc_block4(dst, (group_oc + oc) * OC_BLOCK, R.s0123); \ )==""\n"
R"==(write_oc_block4(dst + OC * 1, (group_oc + oc) * OC_BLOCK, R.s4567); \ )==""\n"
R"==(write_oc_block4(dst + OC * 2, (group_oc + oc) * OC_BLOCK, R.s89ab); \ )==""\n"
R"==(write_oc_block4(dst + OC * 3, (group_oc + oc) * OC_BLOCK, R.scdef); \ )==""\n"
R"==(dst += 4 * OC; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define STORE_DST(C0, C1, C2, C3, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(PACK(C0, C1, C2, C3, i); \ )==""\n"
R"==(if (MB % MB_BLOCK == 0 || group_mb < MB) { \ )==""\n"
R"==(QUANTIZE_ADD_BIAS(); \ )==""\n"
R"==(DO_POST_OP(); \ )==""\n"
R"==(CONVERT_PACK(); \ )==""\n"
R"==(} else { \ )==""\n"
R"==(tmp_cvt = 0; \ )==""\n"
R"==(} \ )==""\n"
R"==(BLOCK_WRITE_DST4(dst, tmp_cvt); \ )==""\n"
R"==(dst += OC_BLOCK * MB_BLOCK; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define STORE_DST_4(C0, C1, C2, C3, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(PACK_4(C0, C1, C2, C3, i); \ )==""\n"
R"==(QUANTIZE_ADD_BIAS_4(); \ )==""\n"
R"==(DO_POST_OP_4(); \ )==""\n"
R"==(CONVERT_PACK_4(); \ )==""\n"
R"==(BLOCK_WRITE_DST16(dst, R); \ )==""\n"
R"==(dst += 4 * OC_BLOCK; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(if (ow < OW) { )==""\n"
R"==(float4 tmp; )==""\n"
R"==(DST_DATA4_T tmp_cvt; )==""\n"
R"==(float8 tmp0, tmp1; )==""\n"
R"==(DST_DATA16_T R; )==""\n"
R"==(#if OW_TAIL )==""\n"
R"==(if (ow + OW_BLOCK < OW) { )==""\n"
R"==(#endif )==""\n"
R"==(#if !DST_NHWC && MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 0); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 1); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 2); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 3); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 4); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 5); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 6); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 7); )==""\n"
R"==(#if OW_BLOCK >= 12 )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 0); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 1); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 2); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 3); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 16 )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 4); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 5); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 6); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 7); )==""\n"
R"==(#endif )==""\n"
R"==(#else  )==""\n"
R"==(STORE_DST_4(C00, C10, C20, C30, 0); )==""\n"
R"==(STORE_DST_4(C00, C10, C20, C30, 4); )==""\n"
R"==(#if OW_BLOCK >= 12 )==""\n"
R"==(STORE_DST_4(C01, C11, C21, C31, 0); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 16 )==""\n"
R"==(STORE_DST_4(C01, C11, C21, C31, 4); )==""\n"
R"==(#endif )==""\n"
R"==(#endif  )==""\n"
R"==(#if OW_TAIL )==""\n"
R"==(} else { )==""\n"
R"==(#if OW_TAIL < 4 )==""\n"
R"==(for (int i = 0; i < OW_TAIL; i++) { )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, i); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if !DST_NHWC && MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 0); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 1); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 2); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 3); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C00, C10, C20, C30, 0); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL > 4 )==""\n"
R"==(#if OW_TAIL < 8 )==""\n"
R"==(for (int i = 4; i < OW_TAIL; i++) { )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, i); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if !DST_NHWC && MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 4); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 5); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 6); )==""\n"
R"==(STORE_DST(C00, C10, C20, C30, 7); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C00, C10, C20, C30, 4); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL > 8 )==""\n"
R"==(#if OW_TAIL < 12 )==""\n"
R"==(for (int i = 8; i < OW_TAIL; i++) { )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, i - CX1_OFFSET); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if !DST_NHWC && MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 0); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 1); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 2); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 3); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C01, C11, C21, C31, 0); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL > 12 )==""\n"
R"==(#if OW_TAIL < 16 )==""\n"
R"==(for (int i = 12; i < OW_TAIL; i++) { )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, i - CX1_OFFSET); )==""\n"
R"==(} )==""\n"
R"==(#else )==""\n"
R"==(#if !DST_NHWC && MB_BLOCK == 32 )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 4); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 5); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 6); )==""\n"
R"==(STORE_DST(C01, C11, C21, C31, 7); )==""\n"
R"==(#else )==""\n"
R"==(STORE_DST_4(C01, C11, C21, C31, 4); )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}