namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_conv_nhwc_fwd_x8s8x_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if IC % IC_BLOCK != 0 )==""\n"
R"==(#define IC_NBLOCKS_TAIL ((IC % IC_BLOCK + 3) / 4) )==""\n"
R"==(#else )==""\n"
R"==(#define IC_NBLOCKS_TAIL 8 )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 4 )==""\n"
R"==(#define BLOCK 4 )==""\n"
R"==(#define ACC_DATA_BLOCK int4 )==""\n"
R"==(#define SRC_DATA_BLOCK_T SRC_MMAD_DATA4_T )==""\n"
R"==(#define READ_BLOCK intel_sub_group_block_read4 )==""\n"
R"==(#define WRITE_LOCAL block_write4 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail, idot4, IC_NBLOCKS_TAIL, 4, SRC_DATA_BLOCK_T, int8, )==""\n"
R"==(ACC_DATA_BLOCK) )==""\n"
R"==(#define MMAD_FULL mmad8x4 )==""\n"
R"==(#define MMAD_TAIL mmad_tail )==""\n"
R"==(#elif OW_BLOCK == 8 )==""\n"
R"==(#define BLOCK 8 )==""\n"
R"==(#define ACC_DATA_BLOCK int8 )==""\n"
R"==(#define SRC_DATA_BLOCK_T SRC_MMAD_DATA8_T )==""\n"
R"==(#define READ_BLOCK intel_sub_group_block_read8 )==""\n"
R"==(#define WRITE_LOCAL block_write8 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail, idot4, IC_NBLOCKS_TAIL, 8, SRC_DATA_BLOCK_T, int8, )==""\n"
R"==(ACC_DATA_BLOCK) )==""\n"
R"==(#define MMAD_FULL mmad8x8 )==""\n"
R"==(#define MMAD_TAIL mmad_tail )==""\n"
R"==(#else )==""\n"
R"==(#error "Wrong OW_BLOCK" )==""\n"
R"==(#endif )==""\n"
R"==(#define BLOCK_READ_SRC(data, idx) \ )==""\n"
R"==(data = intel_sub_group_block_read8((__global uint *)&src[idx]); )==""\n"
R"==(#define BLOCK_READ_WHT_1x32(data, idx) \ )==""\n"
R"==(data = as_int(intel_sub_group_block_read((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT_8x32(data, idx) \ )==""\n"
R"==(data = as_int8(intel_sub_group_block_read8((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4((__global uint *)&bias[idx])); )==""\n"
R"==(#define BLOCK_READ_SCALES(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4( \ )==""\n"
R"==((__global uint *)&runtime_scales[idx])); )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(#define SCALE scales )==""\n"
R"==(#elif SCALES_COMMON )==""\n"
R"==(#define SCALE runtime_scales[0] )==""\n"
R"==(#else )==""\n"
R"==(#define SCALE 1 )==""\n"
R"==(#endif )==""\n"
R"==(#define BLOCK_READ_BOUND 1 )==""\n"
R"==(#define BLOCK_WRITE_BOUND 4 )==""\n"
R"==(inline float4 read_bias_scale_block4(const __global float *dst, int off) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if OC % OC_BLOCK != 0 )==""\n"
R"==(int tail = OC - off; )==""\n"
R"==(if (tail < OC_BLOCK) { )==""\n"
R"==(return (float4)(local_id < tail - 8 * 0 ? dst[0 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 1 ? dst[1 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 2 ? dst[2 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 3 ? dst[3 * 8 + local_id] : 0); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OC % BLOCK_READ_BOUND != 0 )==""\n"
R"==(return (float4)(dst[0 * 8 + local_id], dst[1 * 8 + local_id], )==""\n"
R"==(dst[2 * 8 + local_id], dst[3 * 8 + local_id]); )==""\n"
R"==(#else )==""\n"
R"==(return as_float4(intel_sub_group_block_read4((__global uint *)dst)); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(inline DST_DATA4_T read_oc_block4(const __global DATA_T *dst, int off) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if OC % OC_BLOCK != 0 )==""\n"
R"==(int tail = OC - off; )==""\n"
R"==(if (tail < OC_BLOCK) { )==""\n"
R"==(return (DST_DATA4_T)( )==""\n"
R"==(local_id < tail - 8 * 0 ? dst[0 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 1 ? dst[1 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 2 ? dst[2 * 8 + local_id] : 0, )==""\n"
R"==(local_id < tail - 8 * 3 ? dst[3 * 8 + local_id] : 0); )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OC % BLOCK_READ_BOUND != 0 )==""\n"
R"==(return (DST_DATA4_T)(dst[0 * 8 + local_id], dst[1 * 8 + local_id], )==""\n"
R"==(dst[2 * 8 + local_id], dst[3 * 8 + local_id]); )==""\n"
R"==(#else )==""\n"
R"==(return BLOCK_READ_DST4(dst); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(inline void write_oc_block4(__global DATA_T *dst, int off, DATA4_T value) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if OC % OC_BLOCK != 0 )==""\n"
R"==(int tail = OC - off; )==""\n"
R"==(if (tail < OC_BLOCK) { )==""\n"
R"==(if (local_id < tail) dst[0 * 8 + local_id] = value.s0; )==""\n"
R"==(if (local_id < tail - 8 * 1) dst[1 * 8 + local_id] = value.s1; )==""\n"
R"==(if (local_id < tail - 8 * 2) dst[2 * 8 + local_id] = value.s2; )==""\n"
R"==(if (local_id < tail - 8 * 3) dst[3 * 8 + local_id] = value.s3; )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OC % BLOCK_WRITE_BOUND != 0 )==""\n"
R"==(dst[0 * 8 + local_id] = value.s0; )==""\n"
R"==(dst[1 * 8 + local_id] = value.s1; )==""\n"
R"==(dst[2 * 8 + local_id] = value.s2; )==""\n"
R"==(dst[3 * 8 + local_id] = value.s3; )==""\n"
R"==(return; )==""\n"
R"==(#else )==""\n"
R"==(BLOCK_WRITE_DST4(dst, value); )==""\n"
R"==(return; )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(inline void write_local_1(__local uint *S, __global SRC_DATA_T *src1) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(#if IC % 4 != 0 )==""\n"
R"==(__local SRC_DATA_T *S1 = S + local_id; )==""\n"
R"==(__global SRC_DATA_T *src2 = (const __global uint *)(src1) + local_id; )==""\n"
R"==(S1[0] = src2[0]; )==""\n"
R"==(S1[1] = src2[1]; )==""\n"
R"==(S1[2] = src2[2]; )==""\n"
R"==(S1[3] = src2[3]; )==""\n"
R"==(#else )==""\n"
R"==(block_write(S, intel_sub_group_block_read((const __global uint *)(src1))); )==""\n"
R"==(#endif )==""\n"
R"==(return; )==""\n"
R"==(} )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE)))  )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2)))  )==""\n"
R"==(__kernel void )==""\n"
R"==(conv_nhwc_fwd_x8s8x(const __global SRC_DATA_T *src, const __global char *wei, )==""\n"
R"==(const __global float *bias, __global DATA_T *dst POST_OP_ARGS, )==""\n"
R"==(const __global float *runtime_scales, )==""\n"
R"==(const __global int *src_compensation, const __global int *src_zpoints, )==""\n"
R"==(const __global int *dst_compensation) { )==""\n"
R"==(const int group_oc = get_group_id(0) * OC_GROUP; )==""\n"
R"==(const int group_mb = get_group_id(2) * MB_GROUP; )==""\n"
R"==(const int group_sp = get_group_id(1) * SP_GROUP; )==""\n"
R"==(const int sub_group_id = get_sub_group_id(); )==""\n"
R"==(const int oc = (sub_group_id % OC_GROUP); )==""\n"
R"==(const int sp = (sub_group_id / OC_GROUP); )==""\n"
R"==(const int g = (group_oc + oc) / OC_NCHUNK; )==""\n"
R"==(const int group_ic = IC_NCHUNK * g; )==""\n"
R"==(const int god = group_sp / (OW_PADDED * OH); )==""\n"
R"==(const int gohw = group_sp % (OW_PADDED * OH); )==""\n"
R"==(const int goh = gohw / OW_PADDED; )==""\n"
R"==(const int gow = OW_BLOCK * (gohw % OW_PADDED); )==""\n"
R"==(const int gid = god * SD; )==""\n"
R"==(const int gih = goh * SH; )==""\n"
R"==(const int giw = gow * SW; )==""\n"
R"==(const int local_ow = OW_BLOCK * sp; )==""\n"
R"==(const int local_iw = local_ow * SW; )==""\n"
R"==(const int od = god; )==""\n"
R"==(const int ow = gow + local_ow; )==""\n"
R"==(const int oh = goh; )==""\n"
R"==(const int id = gid - PD; )==""\n"
R"==(const int iw = giw + local_iw - PW; )==""\n"
R"==(const int ih = gih - PH; )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(__local uint S_slice[SRC_SLM_SIZE]; )==""\n"
R"==(__local uint *S_part = S_slice + IC_BLOCK / 4 * (sp * SW * OW_BLOCK + PW); )==""\n"
R"==(__local uint *S_work = S_slice + IC_BLOCK / 4 * (sp * SW * OW_BLOCK); )==""\n"
R"==(const bool left_tail = iw < 0; )==""\n"
R"==(const bool left_nozero_tail = sub_group_id == 0 && iw > -PW; )==""\n"
R"==(const bool right_tail = (iw + PW + SLM_TAIL >= IW) && (iw + PW < IW); )==""\n"
R"==(const bool right_nozero_tail )==""\n"
R"==(= sp == (LWS_1 - 1) && (iw + PW + SLM_TAIL < IW); )==""\n"
R"==(const bool empty = (iw + PW >= IW); )==""\n"
R"==(dst += group_mb * MB_BLOCK * OD * OH * OW * G * OC; )==""\n"
R"==(dst += (OW * OH * od + OW * oh + ow) * G * OC; )==""\n"
R"==(dst += OC_BLOCK * (group_oc + oc); )==""\n"
R"==(src += group_mb * MB_BLOCK * ID * IH * IW * G * IC; )==""\n"
R"==(src += (IW * IH * id + IW * ih + iw + PW) * G * IC; )==""\n"
R"==(src += group_ic * IC_BLOCK; )==""\n"
R"==(wei += IC_BLOCK * KD * KH * KW * OC_BLOCK * (group_oc + oc) * IC_NCHUNK; )==""\n"
R"==(/* Prepare S_slice tails */ )==""\n"
R"==(#if PW > 0 )==""\n"
R"==(if (left_tail) { )==""\n"
R"==(for (int i = 0; i < PW; i++) { )==""\n"
R"==(block_write(S_slice + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if ZERO_TAIL > 0 )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(for (int i = SLM_TAIL; i < SW * OW_BLOCK + (KW - 1) * (1 + DW) - PW; )==""\n"
R"==(i++) { )==""\n"
R"==(block_write(S_part + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(if (empty) { )==""\n"
R"==(for (int i = -PW; i < SW * OW_BLOCK + (KW - 1) * (1 + DW) - PW; i++) { )==""\n"
R"==(block_write(S_part + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#endif )==""\n"
R"==(ACC_DATA_BLOCK C00 = 0, C01 = 0, C02 = 0, C03 = 0; )==""\n"
R"==(__attribute__((opencl_unroll_hint(1)))  )==""\n"
R"==(for (int ic_chunk = 0; ic_chunk < IC_NCHUNK; ic_chunk++) { )==""\n"
R"==(SRC_DATA_BLOCK_T S0; )==""\n"
R"==(__attribute__((opencl_unroll_hint(1)))  )==""\n"
R"==(for (int kd = 0; kd < KD; kd++) { )==""\n"
R"==(if (kd * (1 + DD) + id < 0 || kd * (1 + DD) + id >= ID) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KH * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(__attribute__((opencl_unroll_hint(1)))  )==""\n"
R"==(for (int kh = 0; kh < KH; kh++) { )==""\n"
R"==(if (kh * (1 + DH) + ih < 0 || kh * (1 + DH) + ih >= IH) { )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK * KW; )==""\n"
R"==(continue; )==""\n"
R"==(} )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(const __global SRC_DATA_T *src1 = src )==""\n"
R"==(+ kd * (1 + DD) * IH * IW * G * IC )==""\n"
R"==(+ kh * (1 + DH) * IW * G * IC; )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(if (iw + PW < IW) { )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_NCHUNK > LWS_1 )==""\n"
R"==(/* Copy tails in case of multigroups */ )==""\n"
R"==(if (ow < OW) { )==""\n"
R"==(#if PW > 0 )==""\n"
R"==(if (left_nozero_tail) { )==""\n"
R"==(for (int i = -PW - min(iw, 0); i < 0; i++) { )==""\n"
R"==(write_local_1( )==""\n"
R"==(S_part + i * 8, src1 + i * G * IC); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(if (right_nozero_tail) { )==""\n"
R"==(int buffer_last = (KW - 1) * (1 + DW) - PW; )==""\n"
R"==(int src_last = IW - iw - SW * OW_BLOCK - PW; )==""\n"
R"==(for (int i = SW * OW_BLOCK; i < SW * OW_BLOCK )==""\n"
R"==(+ min(buffer_last, src_last); )==""\n"
R"==(i++) { )==""\n"
R"==(write_local_1( )==""\n"
R"==(S_part + i * 8, src1 + i * G * IC); )==""\n"
R"==(} )==""\n"
R"==(for (int i = SW * OW_BLOCK )==""\n"
R"==(+ min(buffer_last, src_last); )==""\n"
R"==(i < SW * OW_BLOCK + buffer_last; i++) { )==""\n"
R"==(block_write(S_part + i * 8, 0); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_TAIL != OW_BLOCK * SW )==""\n"
R"==(/* Copy last block to SLM */ )==""\n"
R"==(if (right_tail) { )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < SLM_TAIL; i++) { )==""\n"
R"==(write_local_1( )==""\n"
R"==(S_part + i * 8, src1 + i * G * IC); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(#endif )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < SW * OW_BLOCK; i++) { )==""\n"
R"==(write_local_1( )==""\n"
R"==(S_part + i * 8, src1 + i * G * IC); )==""\n"
R"==(} )==""\n"
R"==(#if SLM_TAIL != OW_BLOCK * SW )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_NCHUNK > LWS_1 )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#if SLM_NCHUNK < OW_NCHUNK )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int kw = 0; kw < KW; kw++) { )==""\n"
R"==(__attribute__(( )==""\n"
R"==(opencl_unroll_hint(OW_BLOCK)))  )==""\n"
R"==(for (int i = 0; i < OW_BLOCK; i++) { )==""\n"
R"==(S0[i] = block_read( )==""\n"
R"==(S_work + (kw * (1 + DW) + SW * i) * 8); )==""\n"
R"==(} )==""\n"
R"==(int8 W0 = 0, W1 = 0, W2 = 0, W3 = 0; )==""\n"
R"==(#if IC % IC_BLOCK != 0 )==""\n"
R"==(if (ic_chunk == IC_NCHUNK - 1) { )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32(W0[i], (i + 0) * IC_BLOCK); )==""\n"
R"==(if (OC > 8) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W1[i], (i + 8) * IC_BLOCK); )==""\n"
R"==(if (OC > 16) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W2[i], (i + 16) * IC_BLOCK); )==""\n"
R"==(if (OC > 24) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32( )==""\n"
R"==(W3[i], (i + 24) * IC_BLOCK); )==""\n"
R"==(C00 = MMAD_TAIL(S0, W0, C00); )==""\n"
R"==(if (OC > 8) C01 = MMAD_TAIL(S0, W1, C01); )==""\n"
R"==(if (OC > 16) C02 = MMAD_TAIL(S0, W2, C02); )==""\n"
R"==(if (OC > 24) C03 = MMAD_TAIL(S0, W3, C03); )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(BLOCK_READ_WHT_8x32(W0, 0); )==""\n"
R"==(if (OC > 8) BLOCK_READ_WHT_8x32(W1, 8 * IC_BLOCK); )==""\n"
R"==(if (OC > 16) BLOCK_READ_WHT_8x32(W2, 16 * IC_BLOCK); )==""\n"
R"==(if (OC > 24) BLOCK_READ_WHT_8x32(W3, 24 * IC_BLOCK); )==""\n"
R"==(C00 = MMAD_FULL(S0, W0, C00); )==""\n"
R"==(if (OC > 8) C01 = MMAD_FULL(S0, W1, C01); )==""\n"
R"==(if (OC > 16) C02 = MMAD_FULL(S0, W2, C02); )==""\n"
R"==(if (OC > 24) C03 = MMAD_FULL(S0, W3, C03); )==""\n"
R"==(} )==""\n"
R"==(wei += IC_BLOCK * OC_BLOCK; )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(}  )==""\n"
R"==(src += IC_BLOCK; )==""\n"
R"==(}  )==""\n"
R"==(if (ow < OW) { )==""\n"
R"==(float4 tmp = {0, 0, 0, 0}; )==""\n"
R"==(DST_DATA4_T dst_pack[BLOCK] = {0}; )==""\n"
R"==(DST_DATA4_T D0[BLOCK] = {0}; )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(float4 scales = {0, 0, 0, 0}; )==""\n"
R"==(scales = read_bias_scale_block4( )==""\n"
R"==(runtime_scales + (group_oc + oc) * OC_BLOCK, )==""\n"
R"==((group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float4 bia = {0, 0, 0, 0}; )==""\n"
R"==(bia = read_bias_scale_block4( )==""\n"
R"==(bias + (group_oc + oc) * OC_BLOCK, (group_oc + oc) * OC_BLOCK); )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp = SCALE * fma(tmp, (float4)1, bia); )==""\n"
R"==(#else )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp *= SCALE; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(#if OW_BLOCK >= 4 )==""\n"
R"==(*(DST_DATA16_T *)D0 = (DST_DATA16_T)( )==""\n"
R"==(read_oc_block4(dst + G * OC * 0, (group_oc + oc) * OC_BLOCK), )==""\n"
R"==(read_oc_block4(dst + G * OC * 1, (group_oc + oc) * OC_BLOCK), )==""\n"
R"==(read_oc_block4(dst + G * OC * 2, (group_oc + oc) * OC_BLOCK), )==""\n"
R"==(read_oc_block4(dst + G * OC * 3, (group_oc + oc) * OC_BLOCK)); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 8 )==""\n"
R"==(*(DST_DATA16_T *)(D0 + 4) = (DST_DATA16_T)( )==""\n"
R"==(read_oc_block4(dst + G * OC * 4, (group_oc + oc) * OC_BLOCK), )==""\n"
R"==(read_oc_block4(dst + G * OC * 5, (group_oc + oc) * OC_BLOCK), )==""\n"
R"==(read_oc_block4(dst + G * OC * 6, (group_oc + oc) * OC_BLOCK), )==""\n"
R"==(read_oc_block4(dst + G * OC * 7, (group_oc + oc) * OC_BLOCK)); )==""\n"
R"==(#endif )==""\n"
R"==(#endif  )==""\n"
R"==(#define PACK(C0, C1, C2, C3, idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp[0] = C0[idx]; \ )==""\n"
R"==(tmp[1] = C1[idx]; \ )==""\n"
R"==(tmp[2] = C2[idx]; \ )==""\n"
R"==(tmp[3] = C3[idx]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define CONVERT_PACK(idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(dst_pack[idx] = CONVERT_DST_DATA4_T(tmp); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define PACK_DST(C0, C1, C2, C3, D) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int n_i = 0; n_i < OW_BLOCK; n_i++) { \ )==""\n"
R"==(PACK(C0, C1, C2, C3, n_i); \ )==""\n"
R"==(QUANTIZE_ADD_BIAS(); \ )==""\n"
R"==(for (int didx = 0; didx < 4; ++didx) { \ )==""\n"
R"==(float tmp_i = tmp[didx]; \ )==""\n"
R"==(float dni_i = convert_float(AS_SUM_DATA_T(D[n_i][didx])); \ )==""\n"
R"==(int po_mb; \ )==""\n"
R"==(po_mb = group_mb % MB; \ )==""\n"
R"==(const int po_oc = ((group_oc + oc) * OC_BLOCK + local_id \ )==""\n"
R"==(+ didx * SUB_GROUP_SIZE) \ )==""\n"
R"==(% (OC * G); \ )==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D( \ )==""\n"
R"==(tmp_i, float, dni_i, float, po_mb, 1, po_oc, 1); \ )==""\n"
R"==(tmp[didx] = tmp_i; \ )==""\n"
R"==(} \ )==""\n"
R"==(CONVERT_PACK(n_i); \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0) )==""\n"
R"==(PACK_DST(C00, C01, C02, C03, D0); )==""\n"
R"==(#if OW_TAIL )==""\n"
R"==(if (ow + OW_BLOCK > OW) { )==""\n"
R"==(__attribute__((opencl_unroll_hint(OW_TAIL)))  )==""\n"
R"==(for (int i = 0; i < OW_TAIL; i++) { )==""\n"
R"==(write_oc_block4(dst + i * G * OC, (group_oc + oc) * OC_BLOCK, )==""\n"
R"==(dst_pack[i]); )==""\n"
R"==(} )==""\n"
R"==(} else { )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK >= 4 )==""\n"
R"==(write_oc_block4( )==""\n"
R"==(dst + G * OC * 0, (group_oc + oc) * OC_BLOCK, dst_pack[0]); )==""\n"
R"==(write_oc_block4( )==""\n"
R"==(dst + G * OC * 1, (group_oc + oc) * OC_BLOCK, dst_pack[1]); )==""\n"
R"==(write_oc_block4( )==""\n"
R"==(dst + G * OC * 2, (group_oc + oc) * OC_BLOCK, dst_pack[2]); )==""\n"
R"==(write_oc_block4( )==""\n"
R"==(dst + G * OC * 3, (group_oc + oc) * OC_BLOCK, dst_pack[3]); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_BLOCK == 8 )==""\n"
R"==(write_oc_block4( )==""\n"
R"==(dst + G * OC * 4, (group_oc + oc) * OC_BLOCK, dst_pack[4]); )==""\n"
R"==(write_oc_block4( )==""\n"
R"==(dst + G * OC * 5, (group_oc + oc) * OC_BLOCK, dst_pack[5]); )==""\n"
R"==(write_oc_block4( )==""\n"
R"==(dst + G * OC * 6, (group_oc + oc) * OC_BLOCK, dst_pack[6]); )==""\n"
R"==(write_oc_block4( )==""\n"
R"==(dst + G * OC * 7, (group_oc + oc) * OC_BLOCK, dst_pack[7]); )==""\n"
R"==(#endif )==""\n"
R"==(#if OW_TAIL )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}