namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_gemm_nocopy_scale_x8x8s32_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/gemm/ocl_gemm_attrs.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if WITH_ELTWISE == 1 )==""\n"
R"==(#define POST_OP(val) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (apply_eltwise) \ )==""\n"
R"==(val = fwd_eltwise( \ )==""\n"
R"==(val, eltwise_alpha, eltwise_beta, eltwise_scale); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define POST_OP(val) )==""\n"
R"==(#endif )==""\n"
R"==(kernel void xe_lp_gemm_scale_x8x8s32(global int *cc, global int *c, char trc, )==""\n"
R"==(int offset_c, int m, int n, int ldc, global float *alpha, float beta, )==""\n"
R"==(global int *co, int offset_co, int alpha_is_zero, int apply_eltwise, )==""\n"
R"==(float eltwise_alpha, float eltwise_beta, float eltwise_scale) { )==""\n"
R"==(int idx = get_group_id(0); )==""\n"
R"==(int idy = get_group_id(1); )==""\n"
R"==(int lid = get_local_id(0); )==""\n"
R"==(int j; )==""\n"
R"==(int offset_cc = 0; )==""\n"
R"==(int offset_x = 0; )==""\n"
R"==(int ldcc = m; )==""\n"
R"==(m -= 32 * idx; )==""\n"
R"==(if (m > 32) m = 32; )==""\n"
R"==(n -= 16 * idy; )==""\n"
R"==(if (n > 16) n = 16; )==""\n"
R"==(m -= 32 * lid / 16; )==""\n"
R"==(if ((m <= 0) || (n <= 0)) return; )==""\n"
R"==(offset_cc = 32 * idx + 32 * lid / 16 + 16 * idy * ldcc; )==""\n"
R"==(offset_c += 32 * idx + 32 * lid / 16 + 16 * idy * ldc; )==""\n"
R"==(if (trc == 'C') offset_co += 32 * idx + 32 * lid / 16; )==""\n"
R"==(if (trc == 'R') offset_co += 16 * idy; )==""\n"
R"==(for (j = 0; j < n; j++) { )==""\n"
R"==(if (m > 0) { )==""\n"
R"==(float val = (alpha_is_zero ? 0 : ATTR_ALPHA) * cc[offset_cc + 0] )==""\n"
R"==(+ beta * c[offset_c + 0]; )==""\n"
R"==(POST_OP(val); )==""\n"
R"==(c[offset_c] = convert_int_sat_rte( )==""\n"
R"==(val + (co ? co[offset_co + offset_x] : 0)); )==""\n"
R"==(if (trc == 'C') { offset_x++; } )==""\n"
R"==(} )==""\n"
R"==(if (m > 1) { )==""\n"
R"==(float val = (alpha_is_zero ? 0 : ATTR_ALPHA) * cc[offset_cc + 1] )==""\n"
R"==(+ beta * c[offset_c + 1]; )==""\n"
R"==(POST_OP(val); )==""\n"
R"==(c[offset_c + 1] = convert_int_sat_rte( )==""\n"
R"==(val + (co ? co[offset_co + offset_x] : 0)); )==""\n"
R"==(} )==""\n"
R"==(offset_cc += ldcc; )==""\n"
R"==(offset_c += ldc; )==""\n"
R"==(if (trc == 'C') offset_x = 0; )==""\n"
R"==(if (trc == 'R') offset_x++; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}