namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_gemm_nocopy_x8x8s32_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/gemm/ocl_gemm_attrs.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#if defined(S8S8) )==""\n"
R"==(#define A_TYPE char )==""\n"
R"==(#define A_TYPE2 char2 )==""\n"
R"==(#define A_TYPE4 char4 )==""\n"
R"==(#define B_TYPE char )==""\n"
R"==(#define B_TYPE4 char4 )==""\n"
R"==(#define AS_A_TYPE as_char )==""\n"
R"==(#define AS_A_TYPE2 as_char2 )==""\n"
R"==(#define AS_A_TYPE4 as_char4 )==""\n"
R"==(#define AS_B_TYPE as_char )==""\n"
R"==(#define AS_B_TYPE2 as_char2 )==""\n"
R"==(#define AS_B_TYPE4 as_char4 )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(U8S8) )==""\n"
R"==(#define A_TYPE uchar )==""\n"
R"==(#define A_TYPE2 uchar2 )==""\n"
R"==(#define A_TYPE4 uchar4 )==""\n"
R"==(#define B_TYPE char )==""\n"
R"==(#define B_TYPE4 char4 )==""\n"
R"==(#define AS_A_TYPE as_uchar )==""\n"
R"==(#define AS_A_TYPE2 as_uchar2 )==""\n"
R"==(#define AS_A_TYPE4 as_uchar4 )==""\n"
R"==(#define AS_B_TYPE as_char )==""\n"
R"==(#define AS_B_TYPE2 as_char2 )==""\n"
R"==(#define AS_B_TYPE4 as_char4 )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(S8U8) )==""\n"
R"==(#define A_TYPE char )==""\n"
R"==(#define A_TYPE2 char2 )==""\n"
R"==(#define A_TYPE4 char4 )==""\n"
R"==(#define B_TYPE uchar )==""\n"
R"==(#define B_TYPE4 uchar4 )==""\n"
R"==(#define AS_A_TYPE as_char )==""\n"
R"==(#define AS_A_TYPE2 as_char2 )==""\n"
R"==(#define AS_A_TYPE4 as_char4 )==""\n"
R"==(#define AS_B_TYPE as_uchar )==""\n"
R"==(#define AS_B_TYPE2 as_uchar2 )==""\n"
R"==(#define AS_B_TYPE4 as_uchar4 )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(U8U8) )==""\n"
R"==(#define A_TYPE uchar )==""\n"
R"==(#define A_TYPE2 uchar2 )==""\n"
R"==(#define A_TYPE4 uchar4 )==""\n"
R"==(#define B_TYPE uchar )==""\n"
R"==(#define B_TYPE4 uchar4 )==""\n"
R"==(#define AS_A_TYPE as_uchar )==""\n"
R"==(#define AS_A_TYPE2 as_uchar2 )==""\n"
R"==(#define AS_A_TYPE4 as_uchar4 )==""\n"
R"==(#define AS_B_TYPE as_uchar )==""\n"
R"==(#define AS_B_TYPE2 as_uchar2 )==""\n"
R"==(#define AS_B_TYPE4 as_uchar4 )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(TN) )==""\n"
R"==(#define DO_FMA DO_FMA_TN )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(NN) )==""\n"
R"==(#define DO_FMA DO_FMA_NN )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(NT) )==""\n"
R"==(#define DO_FMA DO_FMA_NT )==""\n"
R"==(#endif )==""\n"
R"==(#if defined(TT) )==""\n"
R"==(#define DO_FMA DO_FMA_TT )==""\n"
R"==(#endif )==""\n"
R"==(#define ADD_ROW_A(z) \ )==""\n"
R"==(do { \ )==""\n"
R"==(sumRowA[z] = ai[z].s0 + ai[z].s1 + ai[z].s2 + ai[z].s3; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define ADD_ROW_AT() \ )==""\n"
R"==(do { \ )==""\n"
R"==(sumRowA[0] = ai[0].s0 + ai[1].s0 + ai[2].s0 + ai[3].s0; \ )==""\n"
R"==(sumRowA[1] = ai[0].s1 + ai[1].s1 + ai[2].s1 + ai[3].s1; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define ADD_COL_B() \ )==""\n"
R"==(do { \ )==""\n"
R"==(sumColB = bi.s0 + bi.s1 + bi.s2 + bi.s3; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define ADD_COL_BT() \ )==""\n"
R"==(do { \ )==""\n"
R"==(sumColB = bi[0] + bi[1] + bi[2] + bi[3]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(#define VLOAD4_A(z, p) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ai[z] = *((global A_TYPE4 *)p); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define VLOAD4_A(z, p) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ai[z].s0 = *(p + 0); \ )==""\n"
R"==(ai[z].s1 = *(p + 1); \ )==""\n"
R"==(ai[z].s2 = *(p + 2); \ )==""\n"
R"==(ai[z].s3 = *(p + 3); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(#define BLOCK_READ_A(h, hh) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ai[hh] = AS_A_TYPE2(intel_sub_group_block_read_uc2( \ )==""\n"
R"==((global uchar *)(a_ptrs[hh] + h * lda))); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK_READ_A(h, hh) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + h * lda) + 0); \ )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + h * lda) + 16); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(#define BLOCK_READ_B(h, hh) \ )==""\n"
R"==(do { \ )==""\n"
R"==(bi[hh] = AS_B_TYPE(intel_sub_group_block_read_uc( \ )==""\n"
R"==((global uchar *)(b_ptrs[hh] + h * ldb))); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK_READ_B(h, hh) \ )==""\n"
R"==(do { \ )==""\n"
R"==(bi[hh] = *(b_ptrs[hh] + h * ldb); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(#define VLOAD4_B(p) \ )==""\n"
R"==(do { \ )==""\n"
R"==(bi = *((global B_TYPE4 *)p); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define VLOAD4_B(p) \ )==""\n"
R"==(do { \ )==""\n"
R"==(bi.s0 = *(p + 0); \ )==""\n"
R"==(bi.s1 = *(p + 1); \ )==""\n"
R"==(bi.s2 = *(p + 2); \ )==""\n"
R"==(bi.s3 = *(p + 3); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#endif )==""\n"
R"==(#define LOADA_REM(z, p) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (krem == 3) { \ )==""\n"
R"==(ai[z].s0 = *(p + 0); \ )==""\n"
R"==(ai[z].s1 = *(p + 1); \ )==""\n"
R"==(ai[z].s2 = *(p + 2); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (krem == 2) { \ )==""\n"
R"==(ai[z].s0 = *(p + 0); \ )==""\n"
R"==(ai[z].s1 = *(p + 1); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (krem == 1) { ai[z].s0 = *(p + 0); } \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define LOADB_REM(p) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (krem == 3) { \ )==""\n"
R"==(bi.s0 = *(p + 0); \ )==""\n"
R"==(bi.s1 = *(p + 1); \ )==""\n"
R"==(bi.s2 = *(p + 2); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (krem == 2) { \ )==""\n"
R"==(bi.s0 = *(p + 0); \ )==""\n"
R"==(bi.s1 = *(p + 1); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (krem == 1) { bi.s0 = *(p + 0); } \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define COPYA() \ )==""\n"
R"==(do { \ )==""\n"
R"==(ait[0].s0 = ai[0].s0; \ )==""\n"
R"==(ait[0].s1 = ai[1].s0; \ )==""\n"
R"==(ait[0].s2 = ai[2].s0; \ )==""\n"
R"==(ait[0].s3 = ai[3].s0; \ )==""\n"
R"==(ait[1].s0 = ai[0].s1; \ )==""\n"
R"==(ait[1].s1 = ai[1].s1; \ )==""\n"
R"==(ait[1].s2 = ai[2].s1; \ )==""\n"
R"==(ait[1].s3 = ai[3].s1; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define COPYB() \ )==""\n"
R"==(do { \ )==""\n"
R"==(biit.s0 = bi[0]; \ )==""\n"
R"==(biit.s1 = bi[1]; \ )==""\n"
R"==(biit.s2 = bi[2]; \ )==""\n"
R"==(biit.s3 = bi[3]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_TN(h, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ci[0][i] = idot4(AS_B_TYPE4(sub_group_broadcast(as_int(bi), i)), \ )==""\n"
R"==(AS_A_TYPE4(ai[0]), ci[0][i]); \ )==""\n"
R"==(ci[1][i] = idot4(AS_B_TYPE4(sub_group_broadcast(as_int(bi), i)), \ )==""\n"
R"==(AS_A_TYPE4(ai[1]), ci[1][i]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_NN(h, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ci[0][i] = idot4(AS_B_TYPE4(sub_group_broadcast(as_int(bi), i)), \ )==""\n"
R"==(AS_A_TYPE4(ait[0]), ci[0][i]); \ )==""\n"
R"==(ci[1][i] = idot4(AS_B_TYPE4(sub_group_broadcast(as_int(bi), i)), \ )==""\n"
R"==(AS_A_TYPE4(ait[1]), ci[1][i]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_NT(h, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ci[0][i] = idot4(AS_B_TYPE4(sub_group_broadcast(as_int(biit), i)), \ )==""\n"
R"==(AS_A_TYPE4(ait[0]), ci[0][i]); \ )==""\n"
R"==(ci[1][i] = idot4(AS_B_TYPE4(sub_group_broadcast(as_int(biit), i)), \ )==""\n"
R"==(AS_A_TYPE4(ait[1]), ci[1][i]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define DO_FMA_TT(h, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ci[0][i] = idot4(AS_B_TYPE4(sub_group_broadcast(as_int(biit), i)), \ )==""\n"
R"==(AS_A_TYPE4(ai[0]), ci[0][i]); \ )==""\n"
R"==(ci[1][i] = idot4(AS_B_TYPE4(sub_group_broadcast(as_int(biit), i)), \ )==""\n"
R"==(AS_A_TYPE4(ai[1]), ci[1][i]); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#if WITH_ELTWISE == 1 )==""\n"
R"==(#define POST_OP(val) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (apply_eltwise) \ )==""\n"
R"==(val = fwd_eltwise( \ )==""\n"
R"==(val, eltwise_alpha, eltwise_beta, eltwise_scale); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#else )==""\n"
R"==(#define POST_OP(val) )==""\n"
R"==(#endif )==""\n"
R"==(#define FMA_I_LOOP(h) \ )==""\n"
R"==(do { \ )==""\n"
R"==(DO_FMA(h, 0); \ )==""\n"
R"==(DO_FMA(h, 1); \ )==""\n"
R"==(DO_FMA(h, 2); \ )==""\n"
R"==(DO_FMA(h, 3); \ )==""\n"
R"==(DO_FMA(h, 4); \ )==""\n"
R"==(DO_FMA(h, 5); \ )==""\n"
R"==(DO_FMA(h, 6); \ )==""\n"
R"==(DO_FMA(h, 7); \ )==""\n"
R"==(DO_FMA(h, 8); \ )==""\n"
R"==(DO_FMA(h, 9); \ )==""\n"
R"==(DO_FMA(h, 10); \ )==""\n"
R"==(DO_FMA(h, 11); \ )==""\n"
R"==(DO_FMA(h, 12); \ )==""\n"
R"==(DO_FMA(h, 13); \ )==""\n"
R"==(DO_FMA(h, 14); \ )==""\n"
R"==(DO_FMA(h, 15); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define ADD_BOFF(i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ci[0][i] -= ATTR_B0 * sumRowA[0]; \ )==""\n"
R"==(ci[1][i] -= ATTR_B0 * sumRowA[1]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define ADD_BOFF_LOOP() \ )==""\n"
R"==(do { \ )==""\n"
R"==(ADD_BOFF(0); \ )==""\n"
R"==(ADD_BOFF(1); \ )==""\n"
R"==(ADD_BOFF(2); \ )==""\n"
R"==(ADD_BOFF(3); \ )==""\n"
R"==(ADD_BOFF(4); \ )==""\n"
R"==(ADD_BOFF(5); \ )==""\n"
R"==(ADD_BOFF(6); \ )==""\n"
R"==(ADD_BOFF(7); \ )==""\n"
R"==(ADD_BOFF(8); \ )==""\n"
R"==(ADD_BOFF(9); \ )==""\n"
R"==(ADD_BOFF(10); \ )==""\n"
R"==(ADD_BOFF(11); \ )==""\n"
R"==(ADD_BOFF(12); \ )==""\n"
R"==(ADD_BOFF(13); \ )==""\n"
R"==(ADD_BOFF(14); \ )==""\n"
R"==(ADD_BOFF(15); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define ADD_AOFF(h, i) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ci[0][i] -= (ATTR_A0 * sub_group_broadcast(as_int(sumColB), i)) \ )==""\n"
R"==(- (h * ATTR_A0 * ATTR_B0); \ )==""\n"
R"==(ci[1][i] -= (ATTR_A0 * sub_group_broadcast(as_int(sumColB), i)) \ )==""\n"
R"==(- (h * ATTR_A0 * ATTR_B0); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define ADD_AOFF_LOOP(h) \ )==""\n"
R"==(do { \ )==""\n"
R"==(ADD_AOFF(h, 0); \ )==""\n"
R"==(ADD_AOFF(h, 1); \ )==""\n"
R"==(ADD_AOFF(h, 2); \ )==""\n"
R"==(ADD_AOFF(h, 3); \ )==""\n"
R"==(ADD_AOFF(h, 4); \ )==""\n"
R"==(ADD_AOFF(h, 5); \ )==""\n"
R"==(ADD_AOFF(h, 6); \ )==""\n"
R"==(ADD_AOFF(h, 7); \ )==""\n"
R"==(ADD_AOFF(h, 8); \ )==""\n"
R"==(ADD_AOFF(h, 9); \ )==""\n"
R"==(ADD_AOFF(h, 10); \ )==""\n"
R"==(ADD_AOFF(h, 11); \ )==""\n"
R"==(ADD_AOFF(h, 12); \ )==""\n"
R"==(ADD_AOFF(h, 13); \ )==""\n"
R"==(ADD_AOFF(h, 14); \ )==""\n"
R"==(ADD_AOFF(h, 15); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C_COL(i, betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(if (jrem > i) { \ )==""\n"
R"==(if (irem > 0) { \ )==""\n"
R"==(if (c_offset_type == 0) { \ )==""\n"
R"==(float val = ((betaZero) ? 0 : *c) + ci[0][i]; \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*c = convert_int_sat_rte(val + ((!apply_co) ? 0 : co[0])); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (c_offset_type == 1) { \ )==""\n"
R"==(float val = ((betaZero) ? 0 : *c) + ci[0][i]; \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*c = convert_int_sat_rte(val + ((!apply_co) ? 0 : co[0])); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (c_offset_type == 2) { \ )==""\n"
R"==(float val = ((betaZero) ? 0 : *c) + ci[0][i]; \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*c = convert_int_sat_rte(val + ((!apply_co) ? 0 : co[i])); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(if (irem > 16) { \ )==""\n"
R"==(if (c_offset_type == 0) { \ )==""\n"
R"==(float val = ((betaZero) ? 0 : *c2) + ci[1][i]; \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*c2 = convert_int_sat_rte( \ )==""\n"
R"==(val + ((!apply_co) ? 0 : co[0])); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (c_offset_type == 1) { \ )==""\n"
R"==(float val = ((betaZero) ? 0 : *c2) + ci[1][i]; \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*c2 = convert_int_sat_rte( \ )==""\n"
R"==(val + ((!apply_co) ? 0 : co[16])); \ )==""\n"
R"==(} \ )==""\n"
R"==(if (c_offset_type == 2) { \ )==""\n"
R"==(float val = ((betaZero) ? 0 : *c2) + ci[1][i]; \ )==""\n"
R"==(POST_OP(val); \ )==""\n"
R"==(*c2 = convert_int_sat_rte( \ )==""\n"
R"==(val + ((!apply_co) ? 0 : co[i])); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(c = c + ldc; \ )==""\n"
R"==(c2 = c2 + ldc; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define UPDATE_C(betaZero) \ )==""\n"
R"==(do { \ )==""\n"
R"==(UPDATE_C_COL(0, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(1, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(2, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(3, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(4, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(5, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(6, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(7, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(8, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(9, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(10, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(11, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(12, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(13, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(14, betaZero); \ )==""\n"
R"==(UPDATE_C_COL(15, betaZero); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#ifdef TN )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void )==""\n"
R"==(xe_lp_gemm_compute_x8x8s32(global A_TYPE *a, global B_TYPE *b, global int *c, )==""\n"
R"==(int offsetA, int offsetB, int offsetC, int lda, int ldb, int ldc, int m, )==""\n"
R"==(int n, int k, int beta, global int *ao, global int *bo, global int *co, )==""\n"
R"==(int offsetCO, int apply_co, local A_TYPE *sa, local B_TYPE *sb, )==""\n"
R"==(int apply_eltwise, float eltwise_alpha, float eltwise_beta, )==""\n"
R"==(float eltwise_scale) { )==""\n"
R"==(A_TYPE4 ai[2];  )==""\n"
R"==(B_TYPE4 bi;  )==""\n"
R"==(int ci[2][16];  )==""\n"
R"==(int sumRowA[2] = {0, 0}; )==""\n"
R"==(int sumColB = 0; )==""\n"
R"==(int idM = get_group_id(0); )==""\n"
R"==(int idN = get_group_id(1); )==""\n"
R"==(int idlM = get_local_id(0); )==""\n"
R"==(int idlN = get_local_id(1); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int lsm = get_enqueued_local_size(0); )==""\n"
R"==(int lsn = 8; )==""\n"
R"==(int i0 = (idM * lsm / 16) * 32 + (get_local_id(0) / 16) * 32; )==""\n"
R"==(int j0 = idlN * 16 + (idN * lsn * 16); )==""\n"
R"==(int irem = m - i0 - lid; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(int irem2 = m - i0; )==""\n"
R"==(int jrem2 = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(a += offsetA + (i0 * lda) + (lid * lda); )==""\n"
R"==(b += offsetB + (j0 * ldb) + (lid * ldb); )==""\n"
R"==(c += offsetC + (i0) + (j0 * ldc) + lid; )==""\n"
R"==(int c_offset_type = 0; )==""\n"
R"==(#ifdef FF )==""\n"
R"==(co += offsetCO; )==""\n"
R"==(c_offset_type = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef RR )==""\n"
R"==(co += offsetCO + i0 + lid; )==""\n"
R"==(c_offset_type = 1; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef CC )==""\n"
R"==(co += offsetCO + (j0); )==""\n"
R"==(c_offset_type = 2; )==""\n"
R"==(#endif )==""\n"
R"==(global A_TYPE *a_ptrs[2] = {a, a + 16 * lda}; )==""\n"
R"==(global B_TYPE *b_ptrs = {b}; )==""\n"
R"==(for (int y = 0; y < 16; y++) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(ci[z][y] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(int k_align = k & ~3; )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem2 >= 32 && jrem2 >= 16) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(VLOAD4_A(z, (a_ptrs[z] + h)); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_A(z); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(VLOAD4_B((b_ptrs + h)); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_B(); )==""\n"
R"==(#endif )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(4); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(ai[0] = 0; )==""\n"
R"==(ai[1] = 0; )==""\n"
R"==(bi = 0; )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(LOADA_REM(z, (a_ptrs[z] + k_align)); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_A(z); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(LOADB_REM((b_ptrs + k_align)); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_B(); )==""\n"
R"==(#endif )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(krem); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(if (irem > z * 16) { )==""\n"
R"==(VLOAD4_A(z, (a_ptrs[z] + h)); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_A(z); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(if (jrem > lid) { )==""\n"
R"==(VLOAD4_B((b_ptrs + h)); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_B(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(4); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(ai[0] = 0; )==""\n"
R"==(ai[1] = 0; )==""\n"
R"==(bi = 0; )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(if (irem > z * 16) { )==""\n"
R"==(LOADA_REM(z, (a_ptrs[z] + k_align)); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_A(z); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(if (jrem > lid) { )==""\n"
R"==(LOADB_REM((b_ptrs + k_align)); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_B(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(krem); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif /* ALLOW_READ_OVERHEAD */ )==""\n"
R"==(global int *c2 = c + 16; )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#ifdef NN )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void )==""\n"
R"==(xe_lp_gemm_compute_x8x8s32(global A_TYPE *a, global B_TYPE *b, global int *c, )==""\n"
R"==(int offsetA, int offsetB, int offsetC, int lda, int ldb, int ldc, int m, )==""\n"
R"==(int n, int k, int beta, global int *ao, global int *bo, global int *co, )==""\n"
R"==(int offsetCO, int apply_co, local A_TYPE *sa, local B_TYPE *sb, )==""\n"
R"==(int apply_eltwise, float eltwise_alpha, float eltwise_beta, )==""\n"
R"==(float eltwise_scale) { )==""\n"
R"==(A_TYPE2 ai[4];  )==""\n"
R"==(B_TYPE4 bi;  )==""\n"
R"==(int ci[2][16];  )==""\n"
R"==(int sumRowA[2] = {0, 0}; )==""\n"
R"==(int sumColB = 0; )==""\n"
R"==(A_TYPE4 ait[2]; )==""\n"
R"==(int idM = get_group_id(0); )==""\n"
R"==(int idN = get_group_id(1); )==""\n"
R"==(int idlM = get_local_id(0); )==""\n"
R"==(int idlN = get_local_id(1); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int lsm = get_enqueued_local_size(0); )==""\n"
R"==(int lsn = 8; )==""\n"
R"==(int i0 = (idM * lsm / 16) * 32 + (get_local_id(0) / 16) * 32; )==""\n"
R"==(int j0 = idlN * 16 + (idN * lsn * 16); )==""\n"
R"==(int irem = m - i0 - lid; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(int irem2 = m - i0; )==""\n"
R"==(int jrem2 = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(a += offsetA + i0; )==""\n"
R"==(#else )==""\n"
R"==(a += offsetA + i0 + lid; )==""\n"
R"==(#endif )==""\n"
R"==(b += offsetB + (j0 * ldb) + (lid * ldb); )==""\n"
R"==(c += offsetC + (i0) + (j0 * ldc) + lid; )==""\n"
R"==(int c_offset_type = 0; )==""\n"
R"==(#ifdef FF )==""\n"
R"==(co += offsetCO; )==""\n"
R"==(c_offset_type = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef RR )==""\n"
R"==(co += offsetCO + i0 + lid; )==""\n"
R"==(c_offset_type = 1; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef CC )==""\n"
R"==(co += offsetCO + (j0); )==""\n"
R"==(c_offset_type = 2; )==""\n"
R"==(#endif )==""\n"
R"==(global A_TYPE *a_ptrs[4] = {a, a + 1 * lda, a + 2 * lda, a + 3 * lda}; )==""\n"
R"==(global B_TYPE *b_ptrs = {b}; )==""\n"
R"==(for (int y = 0; y < 16; y++) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(ci[z][y] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(int k_align = k & ~3; )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem2 >= 32 && jrem2 >= 16) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(BLOCK_READ_A(h, hh); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_AT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(COPYA(); )==""\n"
R"==(VLOAD4_B((b_ptrs + h)); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_B(); )==""\n"
R"==(#endif )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(4); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(ai[0] = 0; )==""\n"
R"==(ai[1] = 0; )==""\n"
R"==(ai[2] = 0; )==""\n"
R"==(ai[3] = 0; )==""\n"
R"==(bi = 0; )==""\n"
R"==(for (int hh = 0; hh < krem; hh++) { )==""\n"
R"==(BLOCK_READ_A(k_align, hh); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_AT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(COPYA(); )==""\n"
R"==(LOADB_REM((b_ptrs + k_align)); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_B(); )==""\n"
R"==(#endif )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(krem); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(if (irem2 > lid) { )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + h * lda) + 0 + lid); )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + h * lda) + 16 + lid); )==""\n"
R"==(#else )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + h * lda) + 0); )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + h * lda) + 16); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_AT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(COPYA(); )==""\n"
R"==(if (jrem > lid) { )==""\n"
R"==(VLOAD4_B((b_ptrs + h)); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_B(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(4); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(ai[0] = 0; )==""\n"
R"==(ai[1] = 0; )==""\n"
R"==(ai[2] = 0; )==""\n"
R"==(ai[3] = 0; )==""\n"
R"==(bi = 0; )==""\n"
R"==(for (int hh = 0; hh < krem; hh++) { )==""\n"
R"==(if (irem2 > lid) { )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + k_align * lda) + 0 + lid); )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + k_align * lda) + 16 + lid); )==""\n"
R"==(#else )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + k_align * lda) + 0); )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + k_align * lda) + 16); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_AT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(COPYA(); )==""\n"
R"==(if (jrem > lid) { )==""\n"
R"==(LOADB_REM((b_ptrs + k_align)); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_B(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(krem); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif /* ALLOW_READ_OVERHEAD */ )==""\n"
R"==(global int *c2 = c + 16; )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#ifdef NT )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void )==""\n"
R"==(xe_lp_gemm_compute_x8x8s32(global A_TYPE *a, global B_TYPE *b, global int *c, )==""\n"
R"==(int offsetA, int offsetB, int offsetC, int lda, int ldb, int ldc, int m, )==""\n"
R"==(int n, int k, int beta, global int *ao, global int *bo, global int *co, )==""\n"
R"==(int offsetCO, int apply_co, local A_TYPE *sa, local B_TYPE *sb, )==""\n"
R"==(int apply_eltwise, float eltwise_alpha, float eltwise_beta, )==""\n"
R"==(float eltwise_scale) { )==""\n"
R"==(A_TYPE2 ai[4];  )==""\n"
R"==(B_TYPE bi[4];  )==""\n"
R"==(int ci[2][16];  )==""\n"
R"==(int sumRowA[2] = {0, 0}; )==""\n"
R"==(int sumColB = 0; )==""\n"
R"==(A_TYPE4 ait[2]; )==""\n"
R"==(A_TYPE4 biit; )==""\n"
R"==(int idM = get_group_id(0); )==""\n"
R"==(int idN = get_group_id(1); )==""\n"
R"==(int idlM = get_local_id(0); )==""\n"
R"==(int idlN = get_local_id(1); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int lsm = get_enqueued_local_size(0); )==""\n"
R"==(int lsn = 8; )==""\n"
R"==(int i0 = (idM * lsm / 16) * 32 + (get_local_id(0) / 16) * 32; )==""\n"
R"==(int j0 = idlN * 16 + (idN * lsn * 16); )==""\n"
R"==(int irem = m - i0 - lid; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(int irem2 = m - i0; )==""\n"
R"==(int jrem2 = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(a += offsetA + i0; )==""\n"
R"==(#else )==""\n"
R"==(a += offsetA + i0 + lid; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(b += offsetB + j0; )==""\n"
R"==(#else )==""\n"
R"==(b += offsetB + j0 + lid; )==""\n"
R"==(#endif )==""\n"
R"==(c += offsetC + (i0) + (j0 * ldc) + lid; )==""\n"
R"==(int c_offset_type = 0; )==""\n"
R"==(#ifdef FF )==""\n"
R"==(co += offsetCO; )==""\n"
R"==(c_offset_type = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef RR )==""\n"
R"==(co += offsetCO + i0 + lid; )==""\n"
R"==(c_offset_type = 1; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef CC )==""\n"
R"==(co += offsetCO + (j0); )==""\n"
R"==(c_offset_type = 2; )==""\n"
R"==(#endif )==""\n"
R"==(global A_TYPE *a_ptrs[4] = {a, a + 1 * lda, a + 2 * lda, a + 3 * lda}; )==""\n"
R"==(global B_TYPE *b_ptrs[4] = {b, b + 1 * ldb, b + 2 * ldb, b + 3 * ldb}; )==""\n"
R"==(for (int y = 0; y < 16; y++) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(ci[z][y] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(int insidea1 = 5; )==""\n"
R"==(int insidea2 = 5; )==""\n"
R"==(int insideb = 5; )==""\n"
R"==(int k_align = k & ~3; )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem2 >= 32 && jrem2 >= 16) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(BLOCK_READ_A(h, hh); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_AT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(COPYA(); )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(BLOCK_READ_B(h, hh); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_BT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(COPYB(); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(4); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(ai[0] = 0; )==""\n"
R"==(ai[1] = 0; )==""\n"
R"==(ai[2] = 0; )==""\n"
R"==(ai[3] = 0; )==""\n"
R"==(bi[0] = 0; )==""\n"
R"==(bi[1] = 0; )==""\n"
R"==(bi[2] = 0; )==""\n"
R"==(bi[3] = 0; )==""\n"
R"==(for (int hh = 0; hh < krem; hh++) { )==""\n"
R"==(BLOCK_READ_A(k_align, hh); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_AT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(COPYA(); )==""\n"
R"==(for (int hh = 0; hh < krem; hh++) { )==""\n"
R"==(BLOCK_READ_B(k_align, hh); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_BT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(COPYB(); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(krem); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(if (irem2 > lid) { )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + h * lda) + 0 + lid); )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + h * lda) + 16 + lid); )==""\n"
R"==(#else )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + h * lda) + 0); )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + h * lda) + 16); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_AT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(COPYA(); )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(if (jrem > lid) { )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(bi[hh] = *((b_ptrs[hh] + h * ldb) + lid); )==""\n"
R"==(#else )==""\n"
R"==(bi[hh] = *(b_ptrs[hh] + h * ldb); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_BT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(COPYB(); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(4); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(ai[0] = 0; )==""\n"
R"==(ai[1] = 0; )==""\n"
R"==(ai[2] = 0; )==""\n"
R"==(ai[3] = 0; )==""\n"
R"==(bi[0] = 0; )==""\n"
R"==(bi[1] = 0; )==""\n"
R"==(bi[2] = 0; )==""\n"
R"==(bi[3] = 0; )==""\n"
R"==(for (int hh = 0; hh < krem; hh++) { )==""\n"
R"==(if (irem2 > lid) { )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + k_align * lda) + 0 + lid); )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + k_align * lda) + 16 + lid); )==""\n"
R"==(#else )==""\n"
R"==(ai[hh].s0 = *((a_ptrs[hh] + k_align * lda) + 0); )==""\n"
R"==(ai[hh].s1 = *((a_ptrs[hh] + k_align * lda) + 16); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_AT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(COPYA(); )==""\n"
R"==(for (int hh = 0; hh < krem; hh++) { )==""\n"
R"==(if (jrem > lid) { )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(bi[hh] = *((b_ptrs[hh] + k_align * ldb) + lid); )==""\n"
R"==(#else )==""\n"
R"==(bi[hh] = *(b_ptrs[hh] + k_align * ldb); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_BT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(COPYB(); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(krem); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif /* ALLOW_READ_OVERHEAD */ )==""\n"
R"==(global int *c2 = c + 16; )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#ifdef TT )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) kernel void )==""\n"
R"==(xe_lp_gemm_compute_x8x8s32(global A_TYPE *a, global B_TYPE *b, global int *c, )==""\n"
R"==(int offsetA, int offsetB, int offsetC, int lda, int ldb, int ldc, int m, )==""\n"
R"==(int n, int k, int beta, global int *ao, global int *bo, global int *co, )==""\n"
R"==(int offsetCO, int apply_co, local A_TYPE *sa, local B_TYPE *sb, )==""\n"
R"==(int apply_eltwise, float eltwise_alpha, float eltwise_beta, )==""\n"
R"==(float eltwise_scale) { )==""\n"
R"==(A_TYPE4 ai[2];  )==""\n"
R"==(B_TYPE bi[4];  )==""\n"
R"==(int ci[2][16];  )==""\n"
R"==(int sumRowA[2] = {0, 0}; )==""\n"
R"==(int sumColB = 0; )==""\n"
R"==(A_TYPE4 biit; )==""\n"
R"==(int idM = get_group_id(0); )==""\n"
R"==(int idN = get_group_id(1); )==""\n"
R"==(int idlM = get_local_id(0); )==""\n"
R"==(int idlN = get_local_id(1); )==""\n"
R"==(int lid = get_sub_group_local_id(); )==""\n"
R"==(int lsm = get_enqueued_local_size(0); )==""\n"
R"==(int lsn = 8; )==""\n"
R"==(int i0 = (idM * lsm / 16) * 32 + (get_local_id(0) / 16) * 32; )==""\n"
R"==(int j0 = idlN * 16 + (idN * lsn * 16); )==""\n"
R"==(int irem = m - i0 - lid; )==""\n"
R"==(int jrem = n - j0; )==""\n"
R"==(if (irem < 0) irem = 0; )==""\n"
R"==(if (jrem < 0) jrem = 0; )==""\n"
R"==(int irem2 = m - i0; )==""\n"
R"==(int jrem2 = n - j0; )==""\n"
R"==(a += offsetA + (i0 * lda) + (lid * lda); )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(b += offsetB + j0; )==""\n"
R"==(#else )==""\n"
R"==(b += offsetB + j0 + lid; )==""\n"
R"==(#endif )==""\n"
R"==(c += offsetC + (i0) + (j0 * ldc) + lid; )==""\n"
R"==(int c_offset_type = 0;  )==""\n"
R"==(#ifdef FF )==""\n"
R"==(co += offsetCO; )==""\n"
R"==(c_offset_type = 0; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef RR )==""\n"
R"==(co += offsetCO + i0 + lid; )==""\n"
R"==(c_offset_type = 1; )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef CC )==""\n"
R"==(co += offsetCO + (j0); )==""\n"
R"==(c_offset_type = 2; )==""\n"
R"==(#endif )==""\n"
R"==(global A_TYPE *a_ptrs[2] = {a, a + 16 * lda}; )==""\n"
R"==(global B_TYPE *b_ptrs[4] = {b, b + 1 * ldb, b + 2 * ldb, b + 3 * ldb}; )==""\n"
R"==(for (int y = 0; y < 16; y++) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(ci[z][y] = 0; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(int k_align = k & ~3; )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(if (irem2 >= 32 && jrem2 >= 16) { )==""\n"
R"==(#endif )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(VLOAD4_A(z, ((a_ptrs[z]) + h)); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_A(z); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(BLOCK_READ_B(h, hh); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_BT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(COPYB(); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(4); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(ai[0] = 0; )==""\n"
R"==(ai[1] = 0; )==""\n"
R"==(bi[0] = 0; )==""\n"
R"==(bi[1] = 0; )==""\n"
R"==(bi[2] = 0; )==""\n"
R"==(bi[3] = 0; )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(LOADA_REM(z, ((a_ptrs[z]) + k_align)); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_A(z); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(for (int hh = 0; hh < krem; hh++) { )==""\n"
R"==(BLOCK_READ_B(k_align, hh); )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_BT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(COPYB(); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(krem); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(#ifndef ALLOW_READ_OVERRUNS )==""\n"
R"==(} else { )==""\n"
R"==(for (int h = 0; h < k_align; h += 4) { )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(if (irem > z * 16) { )==""\n"
R"==(VLOAD4_A(z, (a_ptrs[z] + h)); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_A(z); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(for (int hh = 0; hh < 4; hh++) { )==""\n"
R"==(if (jrem > lid) { )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(bi[hh] = *((b_ptrs[hh] + h * ldb) + lid); )==""\n"
R"==(#else )==""\n"
R"==(bi[hh] = *(b_ptrs[hh] + h * ldb); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_BT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(COPYB(); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(4); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int krem = k & 3; )==""\n"
R"==(if (krem > 0) { )==""\n"
R"==(ai[0] = 0; )==""\n"
R"==(ai[1] = 0; )==""\n"
R"==(bi[0] = 0; )==""\n"
R"==(bi[1] = 0; )==""\n"
R"==(bi[2] = 0; )==""\n"
R"==(bi[3] = 0; )==""\n"
R"==(for (int z = 0; z < 2; z++) { )==""\n"
R"==(if (irem > z * 16) { )==""\n"
R"==(LOADA_REM(z, (a_ptrs[z] + k_align)); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_ROW_A(z); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(for (int hh = 0; hh < krem; hh++) { )==""\n"
R"==(if (jrem > lid) { )==""\n"
R"==(#ifdef ALIGNED )==""\n"
R"==(bi[hh] = *((b_ptrs[hh] + k_align * ldb) + lid); )==""\n"
R"==(#else )==""\n"
R"==(bi[hh] = *(b_ptrs[hh] + k_align * ldb); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_COL_BT(); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(COPYB(); )==""\n"
R"==(FMA_I_LOOP(0); )==""\n"
R"==(#ifdef BOFFNONZERO )==""\n"
R"==(ADD_BOFF_LOOP(); )==""\n"
R"==(#endif )==""\n"
R"==(#ifdef AOFFNONZERO )==""\n"
R"==(ADD_AOFF_LOOP(krem); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif /* ALLOW_READ_OVERHEAD */ )==""\n"
R"==(global int *c2 = c + 16; )==""\n"
R"==(if (beta == 0) )==""\n"
R"==(UPDATE_C(1); )==""\n"
R"==(else )==""\n"
R"==(UPDATE_C(0); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==()==";
}
}
}
}