namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_nhwc_1x1_conv_fwd_x8s8x_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2020-2022 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* licensed under the apache license, version 2.0 (the "license"); )==""\n"
R"==(* you may not use this file except in compliance with the license. )==""\n"
R"==(* you may obtain a copy of the license at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the license is distributed on an "as is" basis, )==""\n"
R"==(* without warranties or conditions of any kind, either express or implied. )==""\n"
R"==(* see the license for the specific language governing permissions and )==""\n"
R"==(* limitations under the license. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_math_utils.h" )==""\n"
R"==(#include "gpu/ocl/ocl_post_ops.h" )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#include "gpu/ocl/ocl_zero_points.h" )==""\n"
R"==(#if IC % IC_BLOCK != 0 )==""\n"
R"==(#define IC_NBLOCKS_TAIL ((IC % IC_BLOCK + 3) / 4) )==""\n"
R"==(#else )==""\n"
R"==(#define IC_NBLOCKS_TAIL 8 )==""\n"
R"==(#endif )==""\n"
R"==(#define IC_TAIL (IC % IC_BLOCK) )==""\n"
R"==(#define HAS_PADDING (PW > 0 || PH > 0 || PD > 0) )==""\n"
R"==(#define USE_SP_BLOCK ((SW == 1 && SH == 1 && SW == 1) || HAS_PADDING) )==""\n"
R"==(#define SRC_SP (IW * IH * ID) )==""\n"
R"==(#define SRC_SP_STRIDE (G * IC) )==""\n"
R"==(#define SRC_ICB_STRIDE IC_BLOCK )==""\n"
R"==(#define DST_SP (OW * OH * OD) )==""\n"
R"==(#define DST_SP_STRIDE (G * OC) )==""\n"
R"==(#define DST_OCB_STRIDE OC_BLOCK )==""\n"
R"==(#define WEI_BLOCK_STRIDE (4 * 8 * 8 * 4) )==""\n"
R"==(#if DST_DT_S8 || DST_DT_U8 )==""\n"
R"==(#define OC_BLOCK_READ_BOUND 4 )==""\n"
R"==(#define OC_BLOCK_WRITE_BOUND 16 )==""\n"
R"==(#else )==""\n"
R"==(#define OC_BLOCK_READ_BOUND 1 )==""\n"
R"==(#define OC_BLOCK_WRITE_BOUND 4 )==""\n"
R"==(#endif )==""\n"
R"==(#define IC_BLOCK_READ_BOUND 4 )==""\n"
R"==(#if IC % IC_BLOCK == 0 )==""\n"
R"==(#define BLOCK_READ_SRC_Xx32(start, end, d_idx, data, idx, sp_off) \ )==""\n"
R"==(do { \ )==""\n"
R"==(uint *d = (uint *)&data; \ )==""\n"
R"==(unroll_for(uint _i = (start); _i < (end); ++_i) { \ )==""\n"
R"==(if (HAS_PADDING) { \ )==""\n"
R"==(PAD_BLOCK_READ(d[_i + d_idx], src, sp, _i + sp_off, 0, 0) \ )==""\n"
R"==(} else { \ )==""\n"
R"==(d[_i + d_idx] = AS_SRC_MMAD_DATA_T(intel_sub_group_block_read( \ )==""\n"
R"==((__global uint *)&src[idx + _i * SW * G * IC])); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0); )==""\n"
R"==(#elif IC % 4 == 0 )==""\n"
R"==(#define BLOCK_READ_SRC_Xx32(start, end, d_idx, data, idx, sp_off) \ )==""\n"
R"==(do { \ )==""\n"
R"==(uint *d = (uint *)&data; \ )==""\n"
R"==(unroll_for(uint _i = (start); _i < (end); ++_i) { \ )==""\n"
R"==(__global uchar *s = &src[idx + _i * SW * G * IC]; \ )==""\n"
R"==(if (ic_block_id < IC_NCHUNK - 1 \ )==""\n"
R"==(|| sg_local_id * 4 < IC_TAIL - IC_TAIL % 4) { \ )==""\n"
R"==(if (HAS_PADDING) { \ )==""\n"
R"==(PAD_BLOCK_READ(d[_i + d_idx], src, sp, _i + sp_off, 1, 0) \ )==""\n"
R"==(} else { \ )==""\n"
R"==(d[_i + d_idx] = *((__global uint *)&s[sg_local_id * 4]); \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0); )==""\n"
R"==(#else  )==""\n"
R"==(#define BLOCK_READ_SRC_Xx32(start, end, d_idx, data, idx, sp_off) \ )==""\n"
R"==(do { \ )==""\n"
R"==(uint *d = (uint *)&data; \ )==""\n"
R"==(unroll_for(uint _i = (start); _i < (end); ++_i) { \ )==""\n"
R"==(__global uchar *s = &src[idx + _i * SW * G * IC]; \ )==""\n"
R"==(uint _j_max = (sg_local_id * 4 < IC_TAIL - IC_TAIL % 4) \ )==""\n"
R"==(|| (ic_block_id < IC_NCHUNK - 1) \ )==""\n"
R"==(? 4 \ )==""\n"
R"==(: (sg_local_id * 4 == IC_TAIL - IC_TAIL % 4 ? IC_TAIL % 4 \ )==""\n"
R"==(: 0); \ )==""\n"
R"==(unroll_for(uint _j = 0; _j < _j_max; ++_j) { \ )==""\n"
R"==(if (HAS_PADDING) { \ )==""\n"
R"==(PAD_BLOCK_READ(d[_i + d_idx], src, sp, _i + sp_off, 2, _j) \ )==""\n"
R"==(} else { \ )==""\n"
R"==(*((uchar *)&d[_i + d_idx] + _j) = s[sg_local_id * 4 + _j]; \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0); )==""\n"
R"==(#endif )==""\n"
R"==(#if SP_BLOCK == 4 )==""\n"
R"==(#define BLOCK0 4 )==""\n"
R"==(#define ACC_DATA_BLOCK int4 )==""\n"
R"==(#define SRC_DATA_BLOCK_T SRC_MMAD_DATA4_T )==""\n"
R"==(#define BLOCK_READ_SRC BLOCK_READ_SRC_4x32 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail0, idot4, IC_NBLOCKS_TAIL, 4, SRC_DATA_BLOCK_T, int8, )==""\n"
R"==(ACC_DATA_BLOCK) )==""\n"
R"==(#define MMAD_FULL0 mmad8x4 )==""\n"
R"==(#define MMAD_TAIL0 mmad_tail0 )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK0 8 )==""\n"
R"==(#define ACC_DATA_BLOCK int8 )==""\n"
R"==(#define SRC_DATA_BLOCK_T SRC_MMAD_DATA8_T )==""\n"
R"==(#define BLOCK_READ_SRC BLOCK_READ_SRC_8x32 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail0, idot4, IC_NBLOCKS_TAIL, 8, SRC_DATA_BLOCK_T, int8, )==""\n"
R"==(ACC_DATA_BLOCK) )==""\n"
R"==(#define MMAD_FULL0 mmad8x8 )==""\n"
R"==(#define MMAD_TAIL0 mmad_tail0 )==""\n"
R"==(#endif )==""\n"
R"==(#if SP_BLOCK == 12 )==""\n"
R"==(#define BLOCK1 4 )==""\n"
R"==(#define ACC_DATA_BLOCK1 int4 )==""\n"
R"==(#define SRC_DATA_BLOCK_T1 SRC_MMAD_DATA4_T )==""\n"
R"==(#define DST_DATA_BLOCK_T1 uint4 )==""\n"
R"==(#define BLOCK_READ_SRC1 BLOCK_READ_SRC_4x32 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail1, idot4, IC_NBLOCKS_TAIL, 4, SRC_DATA_BLOCK_T1, int8, )==""\n"
R"==(ACC_DATA_BLOCK1) )==""\n"
R"==(#define MMAD_FULL1 mmad8x4 )==""\n"
R"==(#define MMAD_TAIL1 mmad_tail1 )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK1 8 )==""\n"
R"==(#define ACC_DATA_BLOCK1 int8 )==""\n"
R"==(#define SRC_DATA_BLOCK_T1 SRC_MMAD_DATA8_T )==""\n"
R"==(#define DST_DATA_BLOCK_T1 uint8 )==""\n"
R"==(#define BLOCK_READ_SRC1 BLOCK_READ_SRC_8x32 )==""\n"
R"==(DECLARE_MMAD_EMU(mmad_tail1, idot4, IC_NBLOCKS_TAIL, 8, SRC_DATA_BLOCK_T1, int8, )==""\n"
R"==(ACC_DATA_BLOCK1) )==""\n"
R"==(#define MMAD_FULL1 mmad8x8 )==""\n"
R"==(#define MMAD_TAIL1 mmad_tail1 )==""\n"
R"==(#endif )==""\n"
R"==(#if INT8_WEI_SLM )==""\n"
R"==(#define BLOCK_READ_WHT_1x32(data, idx) \ )==""\n"
R"==(data = as_int(block_read((__local uint *)&wei_tmp[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT_8x32(data, idx) \ )==""\n"
R"==(data = as_int8(block_read8((__local uint *)&wei_tmp[idx])); )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK_READ_WHT_1x32(data, idx) \ )==""\n"
R"==(data = as_int(intel_sub_group_block_read((__global uint *)&wei[idx])); )==""\n"
R"==(#define BLOCK_READ_WHT_8x32(data, idx) \ )==""\n"
R"==(data = as_int8(intel_sub_group_block_read8((__global uint *)&wei[idx])); )==""\n"
R"==(#endif )==""\n"
R"==(#if OC % OC_BLOCK == 0 )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4((__global uint *)&bias[idx])); )==""\n"
R"==(#else )==""\n"
R"==(#define BLOCK_READ_BIA(data, idx) \ )==""\n"
R"==(data = (float4)0; \ )==""\n"
R"==(int i; \ )==""\n"
R"==(for (i = idx; i < idx + OC_BLOCK && i < OC - (OC % SUB_GROUP_SIZE); \ )==""\n"
R"==(i += SUB_GROUP_SIZE) { \ )==""\n"
R"==(data[(i - idx) / SUB_GROUP_SIZE] = as_float( \ )==""\n"
R"==(intel_sub_group_block_read((__global uint *)&bias[i])); \ )==""\n"
R"==(} \ )==""\n"
R"==(if ((get_sub_group_local_id() < OC % SUB_GROUP_SIZE) && i < OC \ )==""\n"
R"==(&& (i - idx) / SUB_GROUP_SIZE < 4) { \ )==""\n"
R"==(data[(i - idx) / SUB_GROUP_SIZE] \ )==""\n"
R"==(= as_float(bias[i + get_sub_group_local_id()]); \ )==""\n"
R"==(} )==""\n"
R"==(#endif )==""\n"
R"==(#define BLOCK_READ_SCALES(data, idx) \ )==""\n"
R"==(data = as_float4(intel_sub_group_block_read4( \ )==""\n"
R"==((__global uint *)&runtime_scales[idx])); )==""\n"
R"==(#define PAD_BLOCK_READ(data, src, sp, i, read_kind, l_off) \ )==""\n"
R"==(do { \ )==""\n"
R"==(const int od = (sp + i) / (OW * OH); \ )==""\n"
R"==(const int ohw = (sp + i) % (OW * OH); \ )==""\n"
R"==(const int oh = ohw / OW; \ )==""\n"
R"==(const int ow = (ohw % OW); \ )==""\n"
R"==(const int id = SD * od - PD; \ )==""\n"
R"==(const int ih = SH * oh - PH; \ )==""\n"
R"==(const int iw = SW * ow - PW; \ )==""\n"
R"==(bool pad = ((PW > 0 || PH > 0 || PD > 0) \ )==""\n"
R"==(&& (iw < 0 || ih < 0 || id < 0 || iw >= IW || ih >= IH \ )==""\n"
R"==(|| id >= ID)); \ )==""\n"
R"==(int off = id * IH * IW + ih * IW + iw; \ )==""\n"
R"==(if (read_kind == 0) { \ )==""\n"
R"==(data = pad ? 0 \ )==""\n"
R"==(: AS_SRC_MMAD_DATA_T(intel_sub_group_block_read( \ )==""\n"
R"==((global uint *)&src[off * SRC_SP_STRIDE])); \ )==""\n"
R"==(} else if (read_kind == 1) { \ )==""\n"
R"==(data = pad ? 0 \ )==""\n"
R"==(: *((__global uint *)&src[off * SRC_SP_STRIDE \ )==""\n"
R"==(+ sg_local_id * 4]); \ )==""\n"
R"==(} else if (read_kind == 2) { \ )==""\n"
R"==(*((uchar *)&data + l_off) = pad \ )==""\n"
R"==(? 0 \ )==""\n"
R"==(: src[off * SRC_SP_STRIDE + sg_local_id * 4 + l_off]; \ )==""\n"
R"==(} \ )==""\n"
R"==(} while (0); )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(#define SCALE scales )==""\n"
R"==(#elif SCALES_COMMON )==""\n"
R"==(#define SCALE runtime_scales[0] )==""\n"
R"==(#else )==""\n"
R"==(#define SCALE 1 )==""\n"
R"==(#endif )==""\n"
R"==(void block_read_dst( )==""\n"
R"==(int n, DST_DATA_T *d, const __global DST_DATA_T *dst, int oc_tail); )==""\n"
R"==(void block_write_dst( )==""\n"
R"==(int n, const DST_DATA_T *d, __global DST_DATA_T *dst, int oc_tail); )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(SUB_GROUP_SIZE))) )==""\n"
R"==(__attribute__((reqd_work_group_size(LWS_0, LWS_1, LWS_2))) __kernel void )==""\n"
R"==(xe_lp_nhwc_1x1_conv_fwd_x8s8x(const __global SRC_DATA_T *src, )==""\n"
R"==(const __global char *wei, const __global float *bias, )==""\n"
R"==(__global DST_DATA_T *dst POST_OP_ARGS, )==""\n"
R"==(const __global float *runtime_scales, )==""\n"
R"==(const __global int *src_compensation, )==""\n"
R"==(const __global int *dst_compensation) { )==""\n"
R"==(const uint oc_group_id = get_group_id(0); )==""\n"
R"==(const uint sp_group_id = get_group_id(1); )==""\n"
R"==(const uint mb_group_id = get_group_id(2); )==""\n"
R"==(const uint ic_group_id = oc_group_id / OC_NCHUNK * IC_NCHUNK; )==""\n"
R"==(const uint sg_local_id = get_sub_group_local_id(); )==""\n"
R"==(const uint sg_id = get_sub_group_id(); )==""\n"
R"==(#define OWB ((OW + SP_BLOCK - 1) / SP_BLOCK) )==""\n"
R"==(#if USE_SP_BLOCK )==""\n"
R"==(const uint sp = get_global_id(1) * SP_BLOCK; )==""\n"
R"==(const int sp_local_id = get_local_id(1); )==""\n"
R"==(const uint od = sp / (OH * OW); )==""\n"
R"==(const uint ohw = sp % (OH * OW); )==""\n"
R"==(const uint oh = ohw / OW; )==""\n"
R"==(const uint ow = (ohw % OW); )==""\n"
R"==(#else )==""\n"
R"==(const uint sp = get_global_id(1); )==""\n"
R"==(const int sp_local_id = get_local_id(1); )==""\n"
R"==(const uint od = sp / (OWB * OH); )==""\n"
R"==(const uint ohw = sp % (OWB * OH); )==""\n"
R"==(const uint oh = ohw / OWB; )==""\n"
R"==(const uint ow = (ohw % OWB) * SP_BLOCK; )==""\n"
R"==(#endif )==""\n"
R"==(const uint id = SD * od; )==""\n"
R"==(const uint ih = SH * oh; )==""\n"
R"==(const uint iw = SW * ow; )==""\n"
R"==(src += mb_group_id * SRC_SP * SRC_SP_STRIDE;  )==""\n"
R"==(#if !HAS_PADDING )==""\n"
R"==(src += (id * IH * IW + ih * IW + iw) * SRC_SP_STRIDE;  )==""\n"
R"==(#endif )==""\n"
R"==(src += ic_group_id * SRC_ICB_STRIDE;  )==""\n"
R"==(dst += mb_group_id * DST_SP * DST_SP_STRIDE;  )==""\n"
R"==(dst += (od * OH * OW + oh * OW + ow) * DST_SP_STRIDE;  )==""\n"
R"==(dst += oc_group_id * DST_OCB_STRIDE;  )==""\n"
R"==(wei += oc_group_id * WEI_BLOCK_STRIDE * IC_NCHUNK; )==""\n"
R"==(ACC_DATA_BLOCK C00 = 0, C01 = 0, C02 = 0, C03 = 0; )==""\n"
R"==(ACC_DATA_BLOCK1 C10 = 0, C11 = 0, C12 = 0, C13 = 0; )==""\n"
R"==(const int oc_tail )==""\n"
R"==(= (oc_group_id + 1) * OC_BLOCK > G * OC ? OC % OC_BLOCK : OC_BLOCK; )==""\n"
R"==(#if INT8_WEI_SLM )==""\n"
R"==(#define READ_SLM() \ )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); \ )==""\n"
R"==(const __global char *wei_copy_from \ )==""\n"
R"==(= wei + sp_local_id * WEI_BLOCK_STRIDE / LWS_1; \ )==""\n"
R"==(__local char *wei_copy_to \ )==""\n"
R"==(= wei_slm + sp_local_id * WEI_BLOCK_STRIDE / LWS_1; \ )==""\n"
R"==(block_write4((__local uint *)wei_copy_to, \ )==""\n"
R"==(intel_sub_group_block_read4((__global uint *)wei_copy_from)); \ )==""\n"
R"==(__local char *wei_tmp = wei_slm; \ )==""\n"
R"==(barrier(CLK_LOCAL_MEM_FENCE); )==""\n"
R"==(__local char wei_slm[WEI_BLOCK_STRIDE]; )==""\n"
R"==(#endif  )==""\n"
R"==(for (uint ic_block_id = 0; ic_block_id < IC_NCHUNK; ++ic_block_id) { )==""\n"
R"==(#if INT8_WEI_SLM )==""\n"
R"==(READ_SLM() )==""\n"
R"==(#if SP_TAIL )==""\n"
R"==(if (ow < OW) )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(SRC_DATA_BLOCK_T S0; )==""\n"
R"==(SRC_DATA_BLOCK_T1 S1; )==""\n"
R"==(#if OUT_SP_TAIL )==""\n"
R"==(#if USE_SP_BLOCK )==""\n"
R"==(if (od * OH * OW + oh * OW + ow + SP_BLOCK > DST_SP) { )==""\n"
R"==(#else )==""\n"
R"==(if (ow + SP_BLOCK > OW) { )==""\n"
R"==(#endif )==""\n"
R"==(#if OUT_SP_TAIL < 8 )==""\n"
R"==(S0 = 0; )==""\n"
R"==(BLOCK_READ_SRC_Xx32(0, OUT_SP_TAIL, 0, S0, 0 * IC, 0); )==""\n"
R"==(#else )==""\n"
R"==(BLOCK_READ_SRC_Xx32(0, BLOCK0, 0, S0, 0, 0); )==""\n"
R"==(S1 = 0; )==""\n"
R"==(BLOCK_READ_SRC_Xx32(8, OUT_SP_TAIL, -8, S1, 0, BLOCK0); )==""\n"
R"==(#endif )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(BLOCK_READ_SRC_Xx32(0, BLOCK0, 0, S0, 0 * IC, 0); )==""\n"
R"==(#if SP_BLOCK > 8 )==""\n"
R"==(BLOCK_READ_SRC_Xx32(0, BLOCK1, 0, S1, 8 * SW * G * IC, BLOCK0); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(int8 W0 = 0, W1 = 0, W2 = 0, W3 = 0; )==""\n"
R"==(#if IC % IC_BLOCK != 0 )==""\n"
R"==(if (ic_block_id == IC_NCHUNK - 1) { )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32(W0[i], (i + 0) * IC_BLOCK); )==""\n"
R"==(if (OC > 8) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32(W1[i], (i + 8) * IC_BLOCK); )==""\n"
R"==(if (OC > 16) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32(W2[i], (i + 16) * IC_BLOCK); )==""\n"
R"==(if (OC > 24) )==""\n"
R"==(unroll_for(int i = 0; i < IC_NBLOCKS_TAIL; ++i) )==""\n"
R"==(BLOCK_READ_WHT_1x32(W3[i], (i + 24) * IC_BLOCK); )==""\n"
R"==(C00 = MMAD_TAIL0(S0, W0, C00); )==""\n"
R"==(if (OC > 8) C01 = MMAD_TAIL0(S0, W1, C01); )==""\n"
R"==(if (OC > 16) C02 = MMAD_TAIL0(S0, W2, C02); )==""\n"
R"==(if (OC > 24) C03 = MMAD_TAIL0(S0, W3, C03); )==""\n"
R"==(#if SP_BLOCK > 8 )==""\n"
R"==(C10 = MMAD_TAIL1(S1, W0, C10); )==""\n"
R"==(if (OC > 8) C11 = MMAD_TAIL1(S1, W1, C11); )==""\n"
R"==(if (OC > 16) C12 = MMAD_TAIL1(S1, W2, C12); )==""\n"
R"==(if (OC > 24) C13 = MMAD_TAIL1(S1, W3, C13); )==""\n"
R"==(#endif  )==""\n"
R"==(} else )==""\n"
R"==(#endif  )==""\n"
R"==({ )==""\n"
R"==(BLOCK_READ_WHT_8x32(W0, 0); )==""\n"
R"==(if (OC > 8) BLOCK_READ_WHT_8x32(W1, 8 * IC_BLOCK); )==""\n"
R"==(if (OC > 16) BLOCK_READ_WHT_8x32(W2, 16 * IC_BLOCK); )==""\n"
R"==(if (OC > 24) BLOCK_READ_WHT_8x32(W3, 24 * IC_BLOCK); )==""\n"
R"==(C00 = MMAD_FULL0(S0, W0, C00); )==""\n"
R"==(if (OC > 8) C01 = MMAD_FULL0(S0, W1, C01); )==""\n"
R"==(if (OC > 16) C02 = MMAD_FULL0(S0, W2, C02); )==""\n"
R"==(if (OC > 24) C03 = MMAD_FULL0(S0, W3, C03); )==""\n"
R"==(#if SP_BLOCK > 8 )==""\n"
R"==(C10 = MMAD_FULL1(S1, W0, C10); )==""\n"
R"==(if (OC > 8) C11 = MMAD_FULL1(S1, W1, C11); )==""\n"
R"==(if (OC > 16) C12 = MMAD_FULL1(S1, W2, C12); )==""\n"
R"==(if (OC > 24) C13 = MMAD_FULL1(S1, W3, C13); )==""\n"
R"==(#endif )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(src += SRC_ICB_STRIDE; )==""\n"
R"==(wei += WEI_BLOCK_STRIDE; )==""\n"
R"==(} )==""\n"
R"==(#if WITH_SRC_ZPOINTS )==""\n"
R"==(int4 src_comp = as_int4(intel_sub_group_block_read4( )==""\n"
R"==((__global uint *)(&src_compensation[oc_group_id * OC_BLOCK]))); )==""\n"
R"==(C00 -= src_comp.s0; )==""\n"
R"==(C01 -= src_comp.s1; )==""\n"
R"==(C02 -= src_comp.s2; )==""\n"
R"==(C03 -= src_comp.s3; )==""\n"
R"==(#if SP_BLOCK > 8 )==""\n"
R"==(C10 -= src_comp.s0; )==""\n"
R"==(C11 -= src_comp.s1; )==""\n"
R"==(C12 -= src_comp.s2; )==""\n"
R"==(C13 -= src_comp.s3; )==""\n"
R"==(#endif  )==""\n"
R"==(#endif  )==""\n"
R"==(float4 tmp; )==""\n"
R"==(DST_DATA4_T dst_pack[8]; )==""\n"
R"==(DST_DATA4_T D0[BLOCK0] = {0}; )==""\n"
R"==(DST_DATA4_T D1[BLOCK1] = {0}; )==""\n"
R"==(#if SCALES_PER_OC )==""\n"
R"==(float4 scales; )==""\n"
R"==(BLOCK_READ_SCALES(scales, oc_group_id * OC_BLOCK); )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_BIAS )==""\n"
R"==(float4 bia; )==""\n"
R"==(BLOCK_READ_BIA(bia, oc_group_id * OC_BLOCK); )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp = SCALE * fma(tmp, (float4)1, bia); )==""\n"
R"==(#else )==""\n"
R"==(#define QUANTIZE_ADD_BIAS() tmp *= SCALE; )==""\n"
R"==(#endif )==""\n"
R"==(#if WITH_SUM )==""\n"
R"==(#if USE_SP_BLOCK )==""\n"
R"==(if (OUT_SP_TAIL && od * OH * OW + oh * OW + ow + SP_BLOCK > DST_SP) { )==""\n"
R"==(#else )==""\n"
R"==(if (OUT_SP_TAIL && ow + SP_BLOCK > OW) { )==""\n"
R"==(#endif )==""\n"
R"==(#if OUT_SP_TAIL < 8 )==""\n"
R"==(block_read_dst(OUT_SP_TAIL, D0, dst, oc_tail); )==""\n"
R"==(#else )==""\n"
R"==(block_read_dst(BLOCK0, D0, dst, oc_tail); )==""\n"
R"==(block_read_dst(OUT_SP_TAIL - 8, D1, dst + 8 * G * OC, oc_tail); )==""\n"
R"==(#endif )==""\n"
R"==(} else { )==""\n"
R"==(block_read_dst(BLOCK0, D0, dst, oc_tail); )==""\n"
R"==(if (SP_BLOCK > 8) { )==""\n"
R"==(block_read_dst(BLOCK1, D1, dst + 8 * G * OC, oc_tail); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#if WITH_DST_ZPOINTS )==""\n"
R"==(int4 dst_comp = read_dst_zero_points_32c( )==""\n"
R"==(dst_compensation, oc_group_id * OC_BLOCK); )==""\n"
R"==(#define ADD_DST_COMPENSATION() tmp += convert_float4(dst_comp); )==""\n"
R"==(#else )==""\n"
R"==(#define ADD_DST_COMPENSATION() )==""\n"
R"==(#endif  )==""\n"
R"==(#define PACK(C0, C1, C2, C3, idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(tmp[0] = C0[idx]; \ )==""\n"
R"==(tmp[1] = C1[idx]; \ )==""\n"
R"==(tmp[2] = C2[idx]; \ )==""\n"
R"==(tmp[3] = C3[idx]; \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define CONVERT_PACK(idx) \ )==""\n"
R"==(do { \ )==""\n"
R"==(dst_pack[idx] = CONVERT_DST_DATA4_T(tmp); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#define STORE_DST(n, C0, C1, C2, C3, D, dst_ptr, mb_stride) \ )==""\n"
R"==(do { \ )==""\n"
R"==(for (int n_i = 0; n_i < n; n_i++) { \ )==""\n"
R"==(PACK(C0, C1, C2, C3, n_i); \ )==""\n"
R"==(QUANTIZE_ADD_BIAS(); \ )==""\n"
R"==(for (int didx = 0; didx < 4; ++didx) { \ )==""\n"
R"==(float tmp_i = tmp[didx]; \ )==""\n"
R"==(float dni_i = convert_float(AS_SUM_DATA_T(D[n_i][didx])); \ )==""\n"
R"==(int po_mb; \ )==""\n"
R"==(if (MB_BLOCK == 32) \ )==""\n"
R"==(po_mb = (mb_group_id * MB_BLOCK / 2 + mb_stride * 8 + n_i) \ )==""\n"
R"==(% MB; \ )==""\n"
R"==(else \ )==""\n"
R"==(po_mb = mb_group_id % MB; \ )==""\n"
R"==(const int po_oc = (oc_group_id * OC_BLOCK + sg_local_id \ )==""\n"
R"==(+ didx * SUB_GROUP_SIZE) \ )==""\n"
R"==(% (OC * G); \ )==""\n"
R"==(APPLY_POST_OPS_SERIAL_BINARY_2D( \ )==""\n"
R"==(tmp_i, float, dni_i, float, po_mb, 1, po_oc, 1); \ )==""\n"
R"==(tmp[didx] = tmp_i; \ )==""\n"
R"==(} \ )==""\n"
R"==(ADD_DST_COMPENSATION(); \ )==""\n"
R"==(CONVERT_PACK(n_i); \ )==""\n"
R"==(} \ )==""\n"
R"==(block_write_dst(n, dst_pack, dst_ptr, oc_tail); \ )==""\n"
R"==(} while (0) )==""\n"
R"==(#if INT8_WEI_SLM && SP_TAIL )==""\n"
R"==(if (ow < OW) )==""\n"
R"==(#endif )==""\n"
R"==({ )==""\n"
R"==(#if USE_SP_BLOCK )==""\n"
R"==(if (OUT_SP_TAIL && od * OH * OW + oh * OW + ow + SP_BLOCK > DST_SP) { )==""\n"
R"==(#else )==""\n"
R"==(if (OUT_SP_TAIL && ow + SP_BLOCK > OW) { )==""\n"
R"==(#endif )==""\n"
R"==(STORE_DST(min(BLOCK0, OUT_SP_TAIL), C00, C01, C02, C03, D0, dst, 0); )==""\n"
R"==(STORE_DST(OUT_SP_TAIL - 8, C10, C11, C12, C13, D1, dst + 8 * G * OC, )==""\n"
R"==(1); )==""\n"
R"==(} else { )==""\n"
R"==(STORE_DST(BLOCK0, C00, C01, C02, C03, D0, dst, 0); )==""\n"
R"==(if (SP_BLOCK > 8) { )==""\n"
R"==(STORE_DST(BLOCK1, C10, C11, C12, C13, D1, dst + 8 * G * OC, 1); )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(void block_read_dst( )==""\n"
R"==(int n, DST_DATA_T *d, const __global DST_DATA_T *dst, int oc_tail) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(int nelems = n * 4; )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < nelems; i += 4) { )==""\n"
R"==(if (OC % OC_BLOCK_WRITE_BOUND == 0 && oc_tail == OC_BLOCK) { )==""\n"
R"==(*((DST_DATA4_T *)&d[i]) = BLOCK_READ_DST4(dst + (i / 4) * G * OC); )==""\n"
R"==(} else { )==""\n"
R"==(unroll_for(int idx = 0; idx < 4; idx++) { )==""\n"
R"==(if (local_id + 8 * idx < oc_tail) { )==""\n"
R"==(d[i + idx] = dst[(i / 4) * G * OC + idx * 8 + local_id]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(void block_write_dst( )==""\n"
R"==(int n, const DST_DATA_T *d, __global DST_DATA_T *dst, int oc_tail) { )==""\n"
R"==(const int local_id = get_sub_group_local_id(); )==""\n"
R"==(int nelems = n * 4; )==""\n"
R"==(__attribute__((opencl_unroll_hint))  )==""\n"
R"==(for (int i = 0; i < nelems; i += 4) { )==""\n"
R"==(if (OC % OC_BLOCK_WRITE_BOUND == 0 && oc_tail == OC_BLOCK) { )==""\n"
R"==(BLOCK_WRITE_DST4(dst + (i / 4) * G * OC, *((DST_DATA4_T *)&d[i])); )==""\n"
R"==(} else { )==""\n"
R"==(unroll_for(int idx = 0; idx < 4; idx++) { )==""\n"
R"==(if (local_id + 8 * idx < oc_tail) { )==""\n"
R"==(dst[(i / 4) * G * OC + idx * 8 + local_id] = d[i + idx]; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==()==";
}
}
}
}