namespace dnnl {
namespace impl {
namespace gpu {
namespace ocl {
const char *xe_lp_x8s8x_compensation_kernel = R"==(/******************************************************************************* )==""\n"
R"==(* Copyright 2019-2021 Intel Corporation )==""\n"
R"==(* )==""\n"
R"==(* Licensed under the Apache License, Version 2.0 (the "License"); )==""\n"
R"==(* you may not use this file except in compliance with the License. )==""\n"
R"==(* You may obtain a copy of the License at )==""\n"
R"==(* )==""\n"
R"==(* http: )==""\n"
R"==(* )==""\n"
R"==(* Unless required by applicable law or agreed to in writing, software )==""\n"
R"==(* distributed under the License is distributed on an "AS IS" BASIS, )==""\n"
R"==(* WITHOUT WARRANTIES OR CONDITIONS OF ANY KIND, either express or implied. )==""\n"
R"==(* See the License for the specific language governing permissions and )==""\n"
R"==(* limitations under the License. )==""\n"
R"==(*******************************************************************************/ )==""\n"
R"==(#include "gpu/ocl/ocl_types.h" )==""\n"
R"==(#include "gpu/ocl/ocl_zero_points.h" )==""\n"
R"==(#if WEI_4O8I8O4I )==""\n"
R"==(#define OCB ((OC + 31) / 32) )==""\n"
R"==(#define ICB ((IC + 31) / 32) )==""\n"
R"==(#define KDHW (KD * KH * KW) )==""\n"
R"==(#define WEI_BLOCK (32 * 32) )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(8))) )==""\n"
R"==(__attribute__((reqd_work_group_size(8, 1, 1))) __kernel void )==""\n"
R"==(xe_lp_x8s8x_compensation(const __global int *src_zpoints, )==""\n"
R"==(const __global char *wei, __global int *dst) { )==""\n"
R"==(const int oc_block_idx = get_global_id(1); )==""\n"
R"==(const int g = get_global_id(2); )==""\n"
R"==(wei += g * OCB * ICB * KDHW * WEI_BLOCK; )==""\n"
R"==(wei += oc_block_idx * ICB * KDHW * WEI_BLOCK; )==""\n"
R"==(dst += g * OCB * 32; )==""\n"
R"==(dst += oc_block_idx * 32; )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(src_zpoints += g * IC; )==""\n"
R"==(#else )==""\n"
R"==(const int z = read_src_zero_point(src_zpoints); )==""\n"
R"==(#endif  )==""\n"
R"==(int4 acc = 0; )==""\n"
R"==(for (uint icb = 0; icb < ICB; ++icb) { )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(const int4 z = read_src_zero_points_32c(src_zpoints, icb * IC_BLOCK); )==""\n"
R"==(#endif  )==""\n"
R"==(for (uint k = 0; k < KDHW; ++k) { )==""\n"
R"==(const int8 w0 = as_int8(intel_sub_group_block_read8( )==""\n"
R"==((__global uint *)(wei + 0 * IC_BLOCK))); )==""\n"
R"==(const int8 w1 = as_int8(intel_sub_group_block_read8( )==""\n"
R"==((__global uint *)(wei + 8 * IC_BLOCK))); )==""\n"
R"==(const int8 w2 = as_int8(intel_sub_group_block_read8( )==""\n"
R"==((__global uint *)(wei + 16 * IC_BLOCK))); )==""\n"
R"==(const int8 w3 = as_int8(intel_sub_group_block_read8( )==""\n"
R"==((__global uint *)(wei + 24 * IC_BLOCK))); )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(acc.s0 += calc_src_compensation_x32(z, w0); )==""\n"
R"==(acc.s1 += calc_src_compensation_x32(z, w1); )==""\n"
R"==(acc.s2 += calc_src_compensation_x32(z, w2); )==""\n"
R"==(acc.s3 += calc_src_compensation_x32(z, w3); )==""\n"
R"==(#else )==""\n"
R"==(unroll_for(uint i = 0; i < 8; ++i) { )==""\n"
R"==(acc.s0 = idot4(0x01010101, w0[i], acc.s0); )==""\n"
R"==(acc.s1 = idot4(0x01010101, w1[i], acc.s1); )==""\n"
R"==(acc.s2 = idot4(0x01010101, w2[i], acc.s2); )==""\n"
R"==(acc.s3 = idot4(0x01010101, w3[i], acc.s3); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(wei += WEI_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(} )==""\n"
R"==(#if !WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(acc = z * acc; )==""\n"
R"==(#endif  )==""\n"
R"==(intel_sub_group_block_write4((__global uint *)(dst), as_uint4(acc)); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==(#if WEI_32G )==""\n"
R"==(#define KDHW (KD * KH * KW) )==""\n"
R"==(#define WEI_BLOCK 32 )==""\n"
R"==(__attribute__((intel_reqd_sub_group_size(16))) )==""\n"
R"==(__attribute__((reqd_work_group_size(16, 1, 1))) __kernel void )==""\n"
R"==(xe_lp_x8s8x_compensation(const __global int *src_zpoints, )==""\n"
R"==(const __global char *wei, __global int *dst) { )==""\n"
R"==(const int g_block_idx = get_global_id(1); )==""\n"
R"==(wei += g_block_idx * KDHW * WEI_BLOCK; )==""\n"
R"==(dst += g_block_idx * WEI_BLOCK; )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(const int2 z )==""\n"
R"==(= read_src_zero_points_32g(src_zpoints, g_block_idx * WEI_BLOCK); )==""\n"
R"==(#else )==""\n"
R"==(const int z = read_src_zero_point(src_zpoints); )==""\n"
R"==(#endif  )==""\n"
R"==(int2 acc = 0; )==""\n"
R"==(#if WITH_SRC_ZPOINTS_PER_IC )==""\n"
R"==(#endif  )==""\n"
R"==(for (uint k = 0; k < KDHW; ++k) { )==""\n"
R"==(const int2 w0 = convert_int2(as_char2( )==""\n"
R"==(intel_sub_group_block_read_uc2((const __global uchar *)(wei)))); )==""\n"
R"==(acc += w0; )==""\n"
R"==(wei += WEI_BLOCK; )==""\n"
R"==(} )==""\n"
R"==(acc = z * acc; )==""\n"
R"==(intel_sub_group_block_write2((__global uint *)(dst), as_uint2(acc)); )==""\n"
R"==(} )==""\n"
R"==(#endif  )==""\n"
R"==()==";
}
}
}
}